<?php
/**
 *UTF8
 * Roman.Szablatura RON Software 25.5.2018
 */


namespace Ron\RonPortal\Benefity;

use Ron\Controls\ComboBox;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\RonPortal\ComboBoxOsoba;
use Ron\RonPortal\PravaNaOsoby;
use Ron\StringUtils;


$model = Model::getInstance();

$pp = $model->getData('pp');
$jeMoznoEditovat = $model->getData('jeMoznoEditovat');
$osobabenefitu = $model->getData('osobabenefitu');

$nadpis = $model->getData('nadpis');
/** upřesňující nadpis */
$popisStavuBenefitu = $model->getData('popisStavuBenefitu');
$sekce = $model->getData('sekceBenefitu');
$url = $model->getData('url');
$jumpMenu = $model->getData('jumpMenu');
$druhPohybuBenefitu = $model->getData('druhPohybuBenefitu');
/** @var ComboBox $comboVyberuBenefitu */
$comboVyberuBenefitu = $model->getData('comboVyberuBenefitu');

/** @var PohybBenefitu $pohybBenefitu */
$pohybBenefitu = $model->getData('pohybBenefitu');

/** @var ComboBoxOsoba $comboOsobBenefitu */
$comboOsobBenefitu = $model->getData('comboOsobBenefitu');

/** @var DokumentyBenefituBrowser $dokumentBenefitu */
$dokumentBenefitu = $model->getData('dokumentBenefitu');

/** @var Benefit $objektBenefitu */
$objektBenefitu = $model->getData('objektBenefitu');

/** @var BenefityOsoby $bodyOsoby */
$bodyOsoby = $model->getData('bodyOsoby');

//Práva
/** @var PravaNaOsoby $pravo_rezervace */
$pravo_rezervace = $model->getData('pravo_rezervace');
/** @var PravaNaOsoby $pravo_schvalit */
$pravo_schvalit = $model->getData('pravo_schvaleni');
/** @var PravaNaOsoby $pravo_vydani */
$pravo_vydani = $model->getData('pravo_vydani');
/** @var PravaNaOsoby $pravo_vznik_bodu */
$pravo_vznik_bodu = $model->getData('pravo_vznik_bodu');

$schvaleno = $pohybBenefitu->datumSchvaleni != "" ? true : false;
$cerpano = $pohybBenefitu->datumCerpani != "" ? true : false;
$novyVznik = $schvaleno == "" && in_array($druhPohybuBenefitu, ["11"]);
$rezervaceZBodu = $cerpano == "" && in_array($druhPohybuBenefitu, ["21", "41"]);

if ($pohybBenefitu->datumRezervaceDo != "" && $pohybBenefitu->datumRezervaceDo < time()){
    $rezervaceVyprsela = "(" . \Ron\ronText('platnost_vyprsela') . ") ";
} else {
    $rezervaceVyprsela = "";
}

?>


<h1><?= $nadpis ?></h1>
<?php MessageManager::getInstance() ->showMessages(); ?>

<?php if ($osobabenefitu == '') { ?>
    <div class='form middle-form form-25-75 osoba_benefitu'>
        <form enctype="multipart/form-data" method="post" name="prirazenibenefituosobe" action="<?= $url ?>">


                <div class="row form-section">
                    <?= \Ron\ronText("vyber_osoby") ?>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('osoba') ?></div>
                    <div  class="col col-12 col-md-9">
                        <?php
                            $comboOsobBenefitu->selectedOption = '';
                            $comboOsobBenefitu->render();
                        ?>
                    </div>
                </div>
        </form>
    </div>
<?php }?>


<?php if ($osobabenefitu != "") { ?>
    <form enctype="multipart/form-data" method="post" name="prirazenibenefituosobe" action="<?=$url?>">
        <input type="hidden" name="osoba" value="<?=$osobabenefitu?>">
        <input type="hidden" name="druhPohybu" value="<?= $druhPohybuBenefitu ?>">
        <input type="hidden" name="idPohybu" value="<?= $pohybBenefitu->idPohybu ?>">
        <input type="hidden" name="benefit" value="<?= isset($_GET['benefit']) ? $_GET['benefit'] : $pohybBenefitu->id_benefitu ?>">
        <input type="hidden" name="schvalil" value="<?= $pohybBenefitu->schvalil ?>">
        <input type="hidden" name="automatickeSchvaleni" value="<?= $objektBenefitu->automatickeSchvaleni ?>">
        <input type="hidden" name="cerpaniUsername" value="<?= $pohybBenefitu->vydal ?>">
        <input type="hidden" name="hodnotaVBodechProVypocet" value="<?= $objektBenefitu->hodnotaVBodech ?>">
        <input type="hidden" name="doplatekCastkaProVypocet" value="<?= $objektBenefitu->doplatekCastka ?>">
        <input type="hidden" name="maxPocetNaOsobuProVypocet" value="<?= $objektBenefitu->neomezovatNaOsobu == 1 ? "" : $objektBenefitu->maximalniPocetJedenZamestnanec ?>">
        <input type="hidden" name="typDoplatku" value="<?= ($pohybBenefitu->typDoplatku == "" ? 0 : $pohybBenefitu->typDoplatku)  ?>">

        <div class='form middle-form form-25-75'>
            <div class="form-content">
            <?php if (!$pravo_rezervace->prava == 1) { ?>
                <?php if ($comboOsobBenefitu != "") { ?>
                    <div class="row form-section">
                            <?= \Ron\ronText("osoba_benefitu") ?>
                    </div>

                    <div class="row">
                        <div class="col col-12 col-md-3 caption"><?= \Ron\ronText("vyber_osoby") ?></div>
                        <div class="col col-12 col-md-9">
                            <?php $comboOsobBenefitu->render(); ?>
                        </div>
                    </div>

                    <div><div>&nbsp;</div></div>
                <?php }?>
            <?php }?>


            <?php if ($pohybBenefitu->idPohybu != "") { ?>
                <div class="row form-section" id="stav_benefitu_popis">
                    <strong><?= \Ron\ronText('stav_benefitu') ?></strong>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-7 caption">
                        <h3><strong><?= $rezervaceVyprsela . $popisStavuBenefitu ?></strong></h3>
                    </div>
                    <div class="col col-12 col-md-5">
                        <?php if ($jumpMenu != "") echo $jumpMenu ?>
                    </div>
                </div>
            <?php } ?>

            <div class="row form-section">
                <?= \Ron\ronText("vybrana_osoba") ?>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption"></div>
                <div class="col col-12 col-md-9 jmeno "><strong><?= $pp->jmenoPrijmeniKratke ?></strong></div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('osobni_cislo') ?></div>
                <div class="col col-12 col-md-9 osobni_cislo"><strong><?= $pp->osobniCislo ?></strong></div>
            </div>

            <div class="row form-section">
                <div ><?= \Ron\ronText('aktualni_stav_bodu') ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-3 caption">
                    <?= \Ron\ronText('vznik_bodu') . " : " ?>
                </div>
                <div class="col col-12 col-md-9">
                    <strong><?= $bodyOsoby->vznikBoduCelkem ?></strong>
                </div>
            </div>

             <div class="row">
                <div class="col col-12 col-md-3 caption">
                    <?= \Ron\ronText('rezervovano_bodu') . " : "?>
                </div>
                <div class="col col-12 col-md-9">
                    <strong>
                        <?= $bodyOsoby->rezervovanoBodu ?>
                    </strong>
                </div>
            </div>


            <div class="row">
                <div class="col col-12 col-md-3 caption">
                    <?= \Ron\ronText('vycerpano_bodu') . " : " ?>
                </div>


                <div class="col col-12 col-md-9 ">
                    <strong><?= $bodyOsoby->cerpanoBodu ?></strong>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-3 caption">
                    <?= \Ron\ronText('zanik_rezervace') . " : "?>
                </div>
                <div class="col col-12 col-md-9">
                    <strong><?= $bodyOsoby->zanikRezervaceBodu ?></strong>
                </div>
            </div>


            <div class="row">
                <div class="col col-12 col-md-3 caption">
                    <?= \Ron\ronText('zanik_bodu') . " : "?>
                </div>

                <div class="col col-12 col-md-9">
                    <strong><?= $bodyOsoby->zanikBodu ?></strong>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-3 caption font-weight-bold">
                    <?= \Ron\ronText('zustatek_bodu') . " : "?>
                </div>
                <div class="col col-12 col-md-9 font-weight-bold">
                    <?= $bodyOsoby->zustatekBodu ?>
                </div>
            </div>

            <div><div>&nbsp;</div></div>

            <?php
                //Nezobrazovat pro vznik a zánik
                if ((!in_array($pohybBenefitu->druhPohybu, ["11", "31"]) && $comboVyberuBenefitu != "")) { ?>
                    <div class="row form-section">
                        <?= \Ron\ronText("vyber_benefitu") ?>
                    </div>

                    <div class="row">
                        <div class="col col-12 col-md-3 caption"><?= \Ron\ronText("benefit") ?></div>
                        <div class="col col-12 col-md-9" >
                            <?php $comboVyberuBenefitu->render(); ?>
                        </div>
                    </div>
                     <div class='mezera'><div></div></div>
            <?php } ?>
                <?= //Sekce vznik bodů / detail rezervace
                    $sekce
                ?>
            </div>

            <div class='buttons'>
                <button type="button" class="button" id="back_url" value=""><?= \Ron\ronText('Zpet')?></button>
                <?php if ($novyVznik || ($rezervaceZBodu && $_GET['benefit'] != "") || ($rezervaceZBodu && $_GET['idpohybubenefitu'] != "")) { ?>
                    <?php
                        //Nezpřístupnit pro: 21-čerpání bodů, 31-zánik bodů, pro schválené
                        if (!in_array($pohybBenefitu->druhPohybu, ["21", "31"])) {
                            if ($jeMoznoEditovat['editace'] || $jeMoznoEditovat['schvaleni'] || $jeMoznoEditovat['cerpani']) { ?>
                                <button type="reset" class="button" value=""><?= \Ron\ronText('form.Original')?></button>
                                <button type="submit" class="button" name="rezervacebenefituform" value="1"><?= \Ron\ronText('form.Store')?></button>
                        <?php }?>
                    <?php }?>
                <?php }?>
            </div>

        </div>
    </form>

    <br>

    <?php if ($objektBenefitu->id != "") { //Nezobrazovat pokud není zadané ID konkrétního benefitu ?>
        <div class="form middle-form form-25-75" id="example-form-2">
            <div class="form-content ">
                <div class="row form-section">
                    <?= \Ron\ronText("detail_benefitu")?>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-2 caption "><?= \Ron\ronText('typ_benefitu') ?></div>
                    <div class="col col-12 col-md-10 font-italic"><?= StringUtils::htmlTextConvert($objektBenefitu->typ) ?></div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('platnost_od') ?></div>
                    <div class="col col-12 col-md-10"><?= $objektBenefitu->platnostOd ? date('j.n.Y', $objektBenefitu->platnostOd) : "" ?></div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('platnost_do') ?></div>
                    <?php if ($objektBenefitu->platnostDo == "") { ?>
                        <div class="col col-12 col-md-2 font-weight-bold"><?= \Ron\ronText('neomezeno') ?></div>
                    <?php } else { ?>
                        <div class="col col-12 col-md-10"><?= $objektBenefitu->platnostDo ? date('j.n.Y', $objektBenefitu->platnostDo) : "" ?></div>
                    <?php } ?>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('doplatek') ?></div>
                    <div class="col col-12 col-md-3"><?= (int)$objektBenefitu->doplatekCastka ?></div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('hodnota_v_bodech') ?></div>
                    <div class="col col-12 col-md-10"><?= (int)$objektBenefitu->hodnotaVBodech ?></div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('max_na_osobu') ?></div>
                    <?php if ($objektBenefitu->neomezovatNaOsobu == 1) { ?>
                        <div class="col col-12 col-md-2 font-weight-bold"><?= \Ron\ronText('neomezeno') ?></div>
                    <?php } else { ?>
                        <div class="col col-12 col-md-10"><?= $objektBenefitu->maximalniPocetJedenZamestnanec ?></div>
                    <?php } ?>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('automaticke_schvaleni') ?></div>
                    <?php if ($objektBenefitu->automatickeSchvaleni) { $automaticke_popis = ("&nbsp;(" . \Ron\ronText('automaticke_schvaleni_popis') . ")"); } else {$automaticke_popis = "";}?>
                    <div class="col col-12 col-md-10 font-weight-bold"><?= $objektBenefitu->automatickeSchvaleni_popis ?><?= $automaticke_popis ?></div>
                </div>

                <div class="row">
                    <div class="col col-8 col-md-2 caption"><?= \Ron\ronText('detailni_popis') ?></div>
                    <div class="col col-4 col-md-10">
                        <?= StringUtils::htmlTextConvert($objektBenefitu->detailniPopis) ?>
                    </div>
                </div>

                <div><div>&nbsp;</div></div>
            </div>
        </div>

        <div>
            <?php
                if ($dokumentBenefitu != "" && $objektBenefitu->id != "") {
                    $dokumentBenefitu->render();
                }
            ?>
        </div>
    <?php }?>
<?php } ?>










