<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 11.10.2018
 */


namespace Ron\RonPortal\Benefity;

use Ron\Controls\ComboBox;
use Ron\MVC\Model;
use Ron\RonPortal\ComboBoxOsoba;
use function Ron\ronText;


$model = Model::getInstance();

$nadpis = $model->getData('nadpis');
$druhPohybu = $model->getData('druhPohybu');
$osobaSablonyBenefitu = $model->getData('osobaSablonyBenefitu');

/** @var SablonaBenefitu $objektSablonyBenefitu */
$objektSablonyBenefitu = $model->getData('objektSablonyBenefitu');

/** @var ComboBoxOsoba $comboOsobBenefitu */
$comboOsobBenefitu = $model->getData('comboOsobBenefitu');

/** @var ComboBox $comboVyberuBenefitu */
$comboVyberuBenefitu = $model->getData('comboVyberuBenefitu');

/** @var DokumentyBenefituBrowser $dokumentBenefitu */
$dokumentBenefitu = $model->getData('dokumentBenefitu');

/** @var Benefit $objektBenefitu */
$objektBenefitu = $model->getData('objektBenefitu');

$osobaSablony = $model->getData('osobaSablony');
$popisBenefitSablony = $model->getData('popisBenefitSablony');

/** @var ComboBox $comboTypCasoveSlozky */
$comboTypCasoveSlozky = $model->getData('comboTypCasoveSlozky');

$mzdyNainstalovano = $model->getData('mzdyNainstalovano');
$dochazkaNainstalovano = $model->getData('dochazkaNainstalovano');

$kalendar = $objektSablonyBenefitu->casovaJednotka;

?>

<h1><?= $nadpis ?></h1>

<form method="post" name="sablonabenefitu" action="?menuid=benefity&action=zapissablony">

    <input type="hidden" name="id" value="<?= isset($_GET['sablona']) ? $_GET['sablona'] : $objektSablonyBenefitu->id ?>">
    <input type="hidden" name="osoba" value="<?= $osobaSablonyBenefitu ?>">
    <input type="hidden" name="zdrojPoctuBenefituOld" value="<?= $objektSablonyBenefitu->zdrojPoctuBenefitu ?>">
    <input type="hidden" name="idBenefitu" value="<?= isset($_GET['benefit']) ? $_GET['benefit'] : $objektSablonyBenefitu->id ?>">
    <input type="hidden" name="hodnotaVBodechProVypocet" value="<?= $objektBenefitu->hodnotaVBodech ?>">
    <input type="hidden" name="druhPohybu" value="<?= $druhPohybu ?>">
    <input type="hidden" name="doplatekCastkaProVypocet" value="<?= $objektBenefitu->doplatekCastka ?>">
    <input type="hidden" name="maxPocetNaOsobuProVypocet" value="<?= $objektBenefitu->neomezovatNaOsobu == 1 ? "" : $objektBenefitu->maximalniPocetJedenZamestnanec ?>">

    <div class="form middle-form form-25-75" id="example-form-1">
        <div class="form-content">

            <div class="row form-section">
                <?= \Ron\ronText("Osoba") ?>
            </div>
            <div class="row">
                <div class="col col-12 col-md-3 caption required"><?= ($objektSablonyBenefitu->id != "") ? (\Ron\ronText('osoba')) : (\Ron\ronText("vyber_osoby")) ?></div>
                <div class="col col-12 col-md-9">
                    <?php
                        if ($objektSablonyBenefitu->id != ""){
                            echo $osobaSablony;
                        } else{
                            $comboOsobBenefitu->render();
                        }
                    ?>
                </div>
            </div>


            <div class="row form-section">
                <?= \Ron\ronText("benefit") ?>
            </div>
            <div class="row">
                <div class="col col-12 col-md-3 caption required"><?= ($objektSablonyBenefitu->id != "") ? (\Ron\ronText('benefit')) : (\Ron\ronText("vyber_benefitu")) ?></div>
                <div class="col col-12 col-md-9">

                    <?php
                        if ($objektSablonyBenefitu->id != ""){
                            echo $popisBenefitSablony;
                        } else{
                            $comboVyberuBenefitu->render();
                        }
                    ?>
                </div>
            </div>

            <?php if ($objektBenefitu != "") { ?>

                <div class="row" title="<?= \Ron\ronText("poradi_info") ?>">
                    <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('poradi')?></div>
                    <div class="col col-12 col-md-9">
                        <label>
                            <input class=""
                                   type="number"
                                   title="<?= \Ron\ronText('benefit_poradi_info')?>"
                                   min="1"
                                   name="poradi"
                                   value="<?= $objektSablonyBenefitu->poradi!="" ? $objektSablonyBenefitu->poradi : 1 ?>">
                        </label>
                    </div>
                </div>



                <div class="row">
                    <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('benefit_zdroj_poctu')?></div>
                    <div class="col col-12 col-md-9 ">
                        <div class="filtercontainer ">
                            <label>
                                <input class=""
                                       type="radio"
                                       id="zdrojPoctuBenefitu"
                                       name="zdrojPoctuBenefitu" <?= $objektSablonyBenefitu->zdrojPoctuBenefitu == 0 ? "checked" : "" ?>
                                       title="<?= \Ron\ronText('benefit_zadany_pocet_benefitu')?>"
                                       value="0">
                            </label>
                            <div class="text">
                                <?= \Ron\ronText('benefit_zadany_pocet_benefitu')?>
                            </div>
                        </div>

                        <?php if($mzdyNainstalovano){ ?>

                            <div class="filtercontainer min-width-200px padding-right">
                                <label>
                                    <input class=""
                                           type="radio"
                                           id="zdrojPoctuBenefitu"
                                           name="zdrojPoctuBenefitu" <?= $objektSablonyBenefitu->zdrojPoctuBenefitu == 1 ? "checked" : "" ?>
                                           title="<?= \Ron\ronText('benefit_mesicni_vysledek_mzdy')?>"
                                           value="1">
                                </label>
                                <div class="text">
                                    <?= \Ron\ronText('benefit_mesicni_vysledek_mzdy')?>
                                </div>
                            </div>

                        <?php } ?>


                        <?php if($dochazkaNainstalovano){ ?>

                            <div class="filtercontainer min-width-200px padding-right">
                                <label>
                                    <input class=""
                                           type="radio"
                                           id="zdrojPoctuBenefitu"
                                           name="zdrojPoctuBenefitu" <?= $objektSablonyBenefitu->zdrojPoctuBenefitu == 2 ? "checked" : "" ?>
                                           title="<?= \Ron\ronText('benefit_mesicni_vysledek_dochazka')?>"
                                           value="2">
                                </label>
                                <div class="text">
                                    <?= \Ron\ronText('benefit_mesicni_vysledek_dochazka')?>
                                </div>
                            </div>

                        <?php } ?>

                    </div>
                </div>

                <?php if ($dochazkaNainstalovano || $mzdyNainstalovano) { ?>
                <div class="row div-typ-casove-slozky">
                    <div class="col col-12 col-md-3 caption ">
                        <strong><?= \Ron\ronText('benefit_typ_casove_slozky')?></strong>
                    </div>

                    <div class="col col-12 col-md-9">
                        <?= $comboTypCasoveSlozky->render(); ?>
                    </div>
                </div>
                <?php } ?>

                <div class="row div-pocet-benefitu">
                    <div class="col col-12 col-md-3 caption "><strong><?= \Ron\ronText('pocet_benefitu')?></strong></div>
                    <div class="col col-12 col-md-3">
                        <label>
                            <input class=" nonempty"
                                   type="number"
                                   title="<?= \Ron\ronText('pocet_benefitu')?>" min="0"
                                   name="pocetBenefitu"
                                   value="<?= $objektSablonyBenefitu->pocetBenefitu ?>">
                        </label>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-3 caption required"><?= \Ron\ronText('pocet_bodu')?></div>
                    <div class="col col-12 col-md-3">
                        <?php
                        $variabilni = (($objektBenefitu->variabilniHodnotaVBodech == 1) ? "" : "disabled");
                         if ($objektBenefitu->variabilniHodnotaVBodech == 1) {  ?>
                             <label>
                                 <input class=" <?= $variabilni == "" ? 'nonempty' : "" ?> "
                                        type="number" <?= $variabilni ?>
                                        title="<?= \Ron\ronText('pocet_bodu')?>" min="0"
                                        name="pocetBodu"
                                        value="<?= $objektSablonyBenefitu->pocetBodu ?>">
                             </label>
                         <?php } else { ?>
                             <label>
                                 <input class=" <?= $variabilni == "" ? 'nonempty' : "" ?>"
                                        type='number'
                                        name='pocetBoduInfo' <?= $variabilni ?>
                                        title='<?= ronText('benefity_pocet_bodu') ?>'
                                        value='<?= $objektSablonyBenefitu->pocetBodu ?>'>
                             </label>
                             <input type='hidden' name='pocetBodu' value='<?= $objektSablonyBenefitu->pocetBodu ?>'>
                        <?php }?>
                    </div>
                    <div class="col col-12 col-md-6 div-typ-casove-slozky" title="<?= ronText('benefity_info_doplatek')?>">
                        <strong><?= ronText('benefity_info_doplatek')?></strong>
                    </div>
                </div>



                <div class="row">
                    <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('doplatek_benefitu')?></div>
                    <div class="col col-12 col-md-3">
                        <label>
                            <input class=""
                                   type="number"
                                   title="<?= \Ron\ronText('doplatek_benefitu')?>"
                                   min="0"
                                   name="doplatekCastka"
                                   value="<?= $objektSablonyBenefitu->doplatekCastka ?>">
                        </label>
                    </div>
                    <div class="col col-12 col-md-6 div-typ-casove-slozky info-vysledny-pocet" title="<?= ronText('benefity_info_doplatek')?>">
                        <strong><?= ronText('benefity_info_vysledny_pocet')?></strong>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-12">&nbsp;</div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('typ_doplatku')?></div>
                    <div class="filtercontainer min-width-200px padding-right">
                        <label>
                            <input class=""
                                   type="radio"
                                   name="typdoplatku" <?= $objektSablonyBenefitu->typDoplatku == 0 ? "checked" : "" ?>
                                   title="<?= \Ron\ronText('bez_doplatku')?>"
                                   value="0">
                        </label>

                        <div class="text"><?= \Ron\ronText('bez_doplatku')?></div>
                    </div>

                    <div class="filtercontainer min-width-200px padding-right">
                        <?php ?>
                        <label>
                            <input class=""
                                   type="radio"
                                   name="typdoplatku" <?= $objektSablonyBenefitu->typDoplatku == 1 ? "checked" : "" ?>
                                   title="<?= \Ron\ronText('hotovost')?>"
                                   value="1">
                        </label>

                        <div class="text"><?= \Ron\ronText('hotovost')?></div>
                    </div>

                    <div class="filtercontainer min-width-200px padding-right">
                        <label>
                            <input class=""
                                   type="radio"
                                   name="typdoplatku" <?= $objektSablonyBenefitu->typDoplatku == 2 ? "checked" : "" ?>
                                   title="<?= \Ron\ronText('benefit_srazka_ze_mzdy')?>"
                                   value="2">
                        </label>

                        <div class="text"><?= \Ron\ronText('benefit_srazka_ze_mzdy')?></div>
                    </div>

                </div>

                <div class="row">
                    <div class="col col-12 col-md-3 caption"><?= \Ron\ronText("povolit_mensi_pocet")?></div>
                    <div class="col col-12 col-md-9 filtercontainer min-width-200px padding-right">
                        <label>
                            <input class=""
                                   type="checkbox"
                                   name="typKontrolySablony"
                                   value="1"
                                   title="" <?= $objektSablonyBenefitu->typKontrolySablony == 1 ? "checked" : "" ?> >
                        </label>

                        <span> <?= \Ron\ronText("povolit_mensi_pocet_info")?></span>
                    </div>
                </div>


                <div class="form-row form-section">
                    <?= \Ron\ronText("benefit_kalendar_rezervovani")?>
                </div>

                <div class="form-row">
                    <div class="form-col form-col1 caption"><?= \Ron\ronText("obdobi")?></div>
                    <div class="filtercontainer min-width-200px padding-right">
                        <label>
                            <input class=""
                                   type="radio"
                                   name="casovaJednotka"
                                   title="<?= \Ron\ronText('den')?>"
                                   checked
                                   value="1"<?= ($kalendar==1 ? "checked" : "") ?>>
                        </label>
                        <div class="text"><?= \Ron\ronText('den')?>
                        </div>
                    </div>
                    <div class="filtercontainer min-width-200px padding-right">
                        <label>
                            <input class=""
                                   type="radio"
                                   name="casovaJednotka"
                                   title="<?= \Ron\ronText('kalendarni_tyden')?>"
                                   value="2"<?= ($kalendar==2 ? "checked" : "") ?>>
                        </label>
                        <div class="text"><?= \Ron\ronText('kalendarni_tyden')?></div>
                    </div>
                    <div class="filtercontainer min-width-200px padding-right">
                        <label>
                            <input class=""
                                   type="radio"
                                   name="casovaJednotka"
                                   title="<?= \Ron\ronText('kalendarni_mesic')?>"
                                   value="3"<?= ($kalendar==3 ? "checked" : "") ?>>
                        </label>
                        <div class="text"><?= \Ron\ronText('kalendarni_mesic')?>
                        </div>
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-col form-col1 caption"></div>
                    <div class="filtercontainer min-width-200px padding-right">
                        <label>
                            <input class=""
                                   type="radio" name="casovaJednotka"
                                   title="<?= \Ron\ronText('kalendarni_kvartal')?>"
                                   value="4" <?= ($kalendar==4 ? "checked" : "") ?>>
                        </label>
                        <div class="text"><?= \Ron\ronText('kalendarni_kvartal')?>
                        </div>
                    </div>
                    <div class="filtercontainer min-width-200px padding-right">
                        <label>
                            <input class=""
                                   type="radio" name="casovaJednotka"
                                   title="<?= \Ron\ronText('kalendarni_pulrok')?>"
                                   value="5"<?= ($kalendar==5 ? "checked" : "") ?>>
                        </label>
                        <div class="text"><?= \Ron\ronText('kalendarni_pulrok')?>
                        </div>
                    </div>
                    <div class="filtercontainer min-width-200px">
                        <label>
                            <input class=""
                                   type="radio" name="casovaJednotka"
                                   title="<?= \Ron\ronText('kalendarni_rok')?>"
                                   value="6"<?= ($kalendar==6 ? "checked" : "") ?>>
                        </label>
                        <div class="text"><?= \Ron\ronText('kalendarni_rok')?>
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('opakovani')?></div>
                    <div class="col col-12 col-md-3">
                        <label>
                            <input class=""
                                   type="number"
                                   name="pocetCasJednotek"
                                   min="1"
                                   title="<?= \Ron\ronText('pocet_cas_jednotek_info1') . "&#013;" . \Ron\ronText('pocet_cas_jednotek_info2') . "&#013;" . \Ron\ronText('pocet_cas_jednotek_info3')?> "
                                   value="<?= $objektSablonyBenefitu->pocetCasJednotek !="" ? $objektSablonyBenefitu->pocetCasJednotek : 1  ?>">
                        </label>
                    </div>
                </div>

            <?php } ?>
        </div>


        <div class="buttons">
            <input type="button" class="button" id="back_url_sablona" value="<?= \Ron\ronText('Zpet_na_seznam')?>">
            <?php if ($objektBenefitu->id != "") { //Nezobrazovat pokud není zadané ID konkrétního benefitu ?>
                <button type="submit" class="button" name="sablonabenefituform" value="1"><?= \Ron\ronText('form.Store')?></button>
            <?php }?>
        </div>

    </div>
</form>

<br />

<?php if ($objektBenefitu->id != "") { //Nezobrazovat pokud není zadané ID konkrétního benefitu ?>
    <div class="form middle-form form-25-75" id="example-form-2">
        <div class="form-content ">
            <div class="row form-section">
                <?= \Ron\ronText("detail_benefitu")?>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption "><?= \Ron\ronText('typ_benefitu') ?></div>
                <div class="col col-12 col-md-10 font-italic"><?= \Ron\StringUtils::htmlTextConvert($objektBenefitu->typ) ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('platnost_od') ?></div>
                <div class="col col-12 col-md-10"><?= $objektBenefitu->platnostOd ? date('j.n.Y', $objektBenefitu->platnostOd) : "" ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('platnost_do') ?></div>
                <?php if ($objektBenefitu->platnostDo == "") { ?>
                    <div class="col col-12 col-md-2 tucne"><?= \Ron\ronText('neomezeno') ?></div>
                <?php } else { ?>
                    <div class="col col-12 col-md-10"><?= $objektBenefitu->platnostDo ? date('j.n.Y', $objektBenefitu->platnostDo) : "" ?></div>
                <?php } ?>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('doplatek') ?></div>
                <div class="col col-12 col-md-3"><?= (int)$objektBenefitu->doplatekCastka ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('hodnota_v_bodech') ?></div>
                <div class="col col-12 col-md-10"><?= (int)$objektBenefitu->hodnotaVBodech ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('max_na_osobu') ?></div>
                <?php if ($objektBenefitu->neomezovatNaOsobu == 1) { ?>
                    <div class="col col-12 col-md-2 tucne"><?= \Ron\ronText('neomezeno') ?></div>
                <?php } else { ?>
                    <div class="col col-12 col-md-10"><?= $objektBenefitu->maximalniPocetJedenZamestnanec ?></div>
                <?php } ?>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('automaticke_schvaleni') ?></div>
                <?php if ($objektBenefitu->automatickeSchvaleni) { $automaticke_popis = ("&nbsp;(" . \Ron\ronText('automaticke_schvaleni_popis') . ")"); } else {$automaticke_popis = "";}?>
                <div class="col col-12 col-md-10 tucne"><?= $objektBenefitu->automatickeSchvaleni_popis ?><?= $automaticke_popis ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 caption"><?= \Ron\ronText('detailni_popis') ?></div>
                <div class="col col-12 col-md-10 ">
                    <?= \Ron\StringUtils::htmlTextConvert($objektBenefitu->detailniPopis) ?>
                </div>
            </div>

            <div><div>&nbsp;</div></div>
        </div>
    </div>

    <div>
        <?php
            if ($dokumentBenefitu != "" && $objektBenefitu->id != "") {
                $dokumentBenefitu->render();
            }
        ?>
    </div>
<?php }?>
