<?php
/**
 * UTF8
 * stanislav.elbl, 26.08.2015
 */

namespace Ron\RonPortal\Dochazka;

use Ron\Http\HtmlHeaders;
use Ron\MVC\BrowserController;
use Ron\RonPortal\Prava;
use Ron\RonPortal\RonPortalSettings;
use Ron\RonPortal\RonPortalUtils;
use Ron\TextManager;

require_once('ron/browsercontroller.php');
require_once('dochazka/b_eneschopenka.php');

TextManager::getInstance() ->loadStrings('dochazka.ini');
HtmlHeaders::getInstance() ->setIcon(RonPortalSettings::getValue('shortcut_icon') ?: 'images/icon_ads.png');

return new BrowserController(
    $this ->database,
    'eneschopenka',
    function() {
        $prava = Prava::vratPrava('eneschopenka_prohl');

        if (!$prava->jsouNejakePrava()) RonPortalUtils::neniPravoException();

        return new ENeschopenkaBrowser($this ->database, $prava);
    }
);
