<?php
/**
 * UTF8
 * stanislav.elbl, 27.02.2016
 */

namespace Ron\Personalistika;

use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\SQLUtils;
use Ron\Http\HtmlHeaders;
use Ron\MessageManager;
use Ron\MVC\BaseViewObject;
use Ron\MVC\HttpController;
use Ron\MVC\Model;
use Ron\MVC\Redirect;
use Ron\RonPortal\FotoOutputObject;
use RonPortal\PracovniPomer;
use RonPortal\Prava;
use RonPortal\PravaNaOsoby;
use RonPortal\RonPortalDBRecord;
use RonPortal\Controls\RonPortalFilterForm;
use RonPortal\RonPortalUtils;
use Ron\RonPortal\User;
use Ron\RonPortal\Zamestnanci\AdresaOsoby;
use Ron\RonPortal\Zamestnanci\BankovniUcetOsoby;
use Ron\RonPortal\Zamestnanci\EvidencniStav;
use Ron\RonPortal\Zamestnanci\PenzijniPripojisteniOsoby;
use Ron\RonPortal\Zamestnanci\PrukazOsoby;
use Ron\RonPortal\Zamestnanci\RodinnyPrislusnik;
use Ron\RonPortal\Zamestnanci\RodinnyStav;
use Ron\RonPortal\Zamestnanci\ZdravotniPojistovnaOsoby;
use Ron\RonPortal\Zamestnanci\ZivotniPojisteniOsoby;
use Ron\StringUtils;
use Ron\TextManager;

require_once('adsapp/ronportaldbrecord.php');
require_once('adsapp/ronportalbrowser.php');
require_once('pracovnipomery/zamestnanecpersonalni.php');
require_once('pracovnipomery/zamestnanecmzdove.php');
require_once('person/b_drivenahlasenezmeny.php');



/**
 * Class ZdravotniStavOsoby
 * @package Ron\Personalistika
 */
class ZdravotniStavOsoby
{
    public $popisStavu;
    public $drzitelPrukazuZTTP;
    public $zps;
    public $zps_tzp;
}

/**
 * Class OsobniUdajeDovednost
 * @package Ron\Personalistika
 */
class OsobniUdajeDovednost
{
    public $kod;
    public $popis;
    public $popisUrovne;
    public $bodovaHodnota;
}

/**
 * Class PracovniMistoOsoby
 * @package Ron\Personalistika
 */
class PracovniMistoOsoby
{
    public $popis;
    public $platnostOd;

    /**
     * @param Database $database
     * @param string $rc
     * @return PracovniMistoOsoby[]
     */
    public static function nactiPracovniMista($database, $rc)
    {
        $params = $database ->createParameters();

        $sql =
            'SELECT Rozdeleni.Popis, RozdeleniOsob.PlatnostOd ' .
            ' FROM RozdeleniOsob, Rozdeleni ' .
            ' WHERE Rozdeleni.KodTypuRozdeleni = RozdeleniOsob.KodTypuRozdeleni ' .
            ' AND Rozdeleni.Kod = RozdeleniOsob.Rozdeleni ' .
            ' AND Rozdeleni.KodTypuRozdeleni = -1 ' .
            ' AND RC = ' . $params ->addParameter($rc) .
            ' AND RozdeleniOsob.PlatnostOd <= ' . $params ->addParameter($database ->dateToParam(time())) .
            ' AND (RozdeleniOsob.PlatnostDo >= ' . $params ->addParameter($database ->dateToParam(time())) . ' OR RozdeleniOsob.PlatnostDo IS NULL)' .
            ' ORDER BY RozdeleniOsob.PlatnostOd DESC ';

        $result = [];

        $cursor = $database ->getSqlResult($sql, $params);
        while ($row = $cursor ->fetch()) {
            $pracovniMisto = new PracovniMistoOsoby();
            $pracovniMisto ->popis = $row[0];
            $pracovniMisto ->platnostOd = $database ->stringToTimestamp($row[1]);
            $result[] = $pracovniMisto;
        }
        $cursor ->close();

        return $result;
    }
}


/**
 * Class Osoba
 * @package Ron\Personalistika
 */
class Osoba
{
    public $rc;
    public $titul;
    public $jmeno;
    public $prijmeni;
    public $titulZa;

    public $idFotografie;

    //public $rodneJmeno;
    public $datumNarozeni;
    public $pohlavi;
    public $narodnost;
    public $rcZahranicni;

    public $uzivatelska1;
    public $uzivatelska2;
    public $uzivatelska3;
    public $uzivatelska4;
    public $uzivatelska5;
    public $uzivatelska6;
    public $uzivatelska7;
    public $uzivatelska8;
    public $uzivatelska9;
    public $uzivatelska10;
    public $uzivatelska11;
    public $uzivatelska12;
    public $uzivatelska13;
    public $uzivatelska14;
    public $uzivatelska15;
    public $uzivatelska16;
    public $uzivatelska17;
    public $uzivatelska18;
    public $uzivatelska19;
    public $uzivatelska20;

    public $mistoNarozeni;
    public $okresNarozeni;
    public $statniPrislusnost;

    public $intrawebLogin;
    public $skupinaIW;
    public $telefon;
    public $mobil;
    public $email;
    public $poznamka;

    // pracovni pomer
    public $idPP;
    public $osobniCislo;
    public $datumNastupu;
    public $datumUkonceni;
    public $zamestnanec;
    public $poradoveCisloPP;
    public $cisloPracovniSmlouvy;
    public $typPracovnihoPomeru;
    public $zkusebniDoba;
    public $zkusebniDobaDo;
    public $zkusebniDobaDoVypoctena;
    public $postaveniVZamestnani;
    public $duvodUkonceni;
    public $duvodVzniku;

    public $uzivatelskaPP1;
    public $uzivatelskaPP2;
    public $uzivatelskaPP3;
    public $uzivatelskaPP4;
    public $uzivatelskaPP5;
    public $uzivatelskaPP6;
    public $uzivatelskaPP7;
    public $uzivatelskaPP8;
    public $uzivatelskaPP9;
    public $uzivatelskaPP10;
    public $uzivatelskaPP11;
    public $uzivatelskaPP12;
    public $uzivatelskaPP13;
    public $uzivatelskaPP14;
    public $uzivatelskaPP15;
    public $uzivatelskaPP16;
    public $uzivatelskaPP17;
    public $uzivatelskaPP18;
    public $uzivatelskaPP19;
    public $uzivatelskaPP20;

    public $poznamkaPP;

    /** @var AdresaOsoby[] */
    public $adresy = [];
    /** @var bool */
    public $pravoZobrazitTrvale = true;
    /** @var bool */
    public $pravoZobrazitPrechodne = true;

    /** @var RodinnyStav */
    public $rodinnyStav = null;
    /** @var ZdravotniStavOsoby */
    public $zdravotniStav = null;
    /** @var ZdravotniPojistovnaOsoby */
    public $zdravotniPojistovna = null;
    /** @var VzdelaniOsoby[] */
    public $vzdelani = [];
    /** @var OsobniUdajeDovednost[] */
    public $dovednosti = [];
    /** @var PracovniMistoOsoby[] */
    public $pracovniMista = [];

    /** @var BankovniUcetOsoby[] $uctyOsoby  */
    public $uctyOsoby = null;

    /** @var PrukazOsoby $prukazyOsoby */
    public $prukazyOsoby = [];

    /** @var PrukazOsoby $prukazyOsoby */
    public $typyPrukazu = [];

    /** @var  PenzijniPripojisteniOsoby $penzijniPripojisteniOsoby */
    public $penzijniPripojisteniOsoby = [];

    /** @var ZivotniPojisteniOsoby $zivotniPojisteniOsoby */
    public $zivotniPojisteniOsoby = [];

    /** @var RodinnyPrislusnik $rodinniPrislusnici */
    public $rodinniPrislusnici = [];

    /** @var array $velikostPomucekOsoby */
    public $velikostPomucekOsoby = [];
    /** @var array $seznamVydanychPomucekOsoby */
    public $seznamVydanychPomucekOsoby = [];
    /** @var array $seznamNesplnenychNarokuPomucek */
    public $seznamNesplnenychNarokuPomucek = [];
    /** @var array $evidencniStavy */
    public $evidencniStavy = [];

    /**
     * @param Database $database
     * @param int $idPP
     * @throws \Exception
     */
    function nactiZakladniUdaje($database, $idPP)
    {
        $jsouMzdy = RonPortalUtils::jeNainstalovanaAplikace($database, 'MZDY');
        $jePersonalistika = RonPortalUtils::jeNainstalovanaAplikace($database, 'PERSON');

        $params = $database ->createParameters();

        $sql =
            'SELECT Osoba.RC, Osoba.Titul, Osoba.Jmeno, Osoba.Prijmeni, Osoba.TitulZa, Osoba.IdFotografie,' . // 0..5
            ' NULL AS RodneJmeno, NULL AS DatumNarozeni, NULL AS Pohlavi, NULL AS Narodnost, NULL AS RC_Zahranicni,' .  //6..10 - 11/2017 - odstraneny osobni udaje
            ' Osoba.Uzivatelska1,  Osoba.Uzivatelska2, Osoba.Uzivatelska3, Osoba.Uzivatelska4, Osoba.Uzivatelska5,' .  // 11..
            ' Osoba.Uzivatelska6,  Osoba.Uzivatelska7, Osoba.Uzivatelska8, Osoba.Uzivatelska9, Osoba.Uzivatelska10,' .
            ' Osoba.Uzivatelska11,  Osoba.Uzivatelska12, Osoba.Uzivatelska13, Osoba.Uzivatelska14, Osoba.Uzivatelska15,' .
            ' Osoba.Uzivatelska16,  Osoba.Uzivatelska17, Osoba.Uzivatelska18, Osoba.Uzivatelska19, Osoba.Uzivatelska20,' . // ..30
            ' NULL AS MistoNarozeni, NULL AS OkresNarozeni, NULL AS StatniPrislusnost,' .    // 31..33  -  11/2017 - odstraneny osobni udaje
            ' Osoba.IntrawebLogin, Osoba.SkupinaIW, Osoba.Telefon, Osoba.eMail,' .    // 34..37
            $database ->castWideMemo('Osoba.Poznamka') . ',' . // 38
            // pracovni pomer
            ' PracovniPomer.OsobniCislo, PracovniPomer.DatumNastupu, PracovniPomer.DatumUkonceni, PracovniPomer.Zamestnanec,' . // 39..42
            ' PracovniPomer.PoradoveCisloPP, PracovniPomer.CisloPracovniSmlouvy, PracovniPomer.TypPracovnihoPomeru,' .     // 43..45
            ' PracovniPomer.ZkusebniDoba, PracovniPomer.ZkusebniDobaDo,' . // 46..47
            ' PracovniPomer.Uzivatelska1,  PracovniPomer.Uzivatelska2, PracovniPomer.Uzivatelska3, PracovniPomer.Uzivatelska4, PracovniPomer.Uzivatelska5,' .  // 48..
            ' PracovniPomer.Uzivatelska6,  PracovniPomer.Uzivatelska7, PracovniPomer.Uzivatelska8, PracovniPomer.Uzivatelska9, PracovniPomer.Uzivatelska10,' .
            ' PracovniPomer.Uzivatelska11,  PracovniPomer.Uzivatelska12, PracovniPomer.Uzivatelska13, PracovniPomer.Uzivatelska14, PracovniPomer.Uzivatelska15,' .
            ' PracovniPomer.Uzivatelska16,  PracovniPomer.Uzivatelska17, PracovniPomer.Uzivatelska18, PracovniPomer.Uzivatelska19, PracovniPomer.Uzivatelska20,' . // ..67
            $database ->castWideMemo('PracovniPomer.Poznamka') . ', Osoba.Mobil,' . // 68..69
            ( ($jsouMzdy  ||  $jePersonalistika) ? ' PostaveniVZamestnani.Popis' : ' PracovniPomer.PostaveniVZamestnani')  . ', ' . // 70
            ' PracovniPomer.ZkusebniDobaDoVypoctena, DuvodUkonceniPP.Popis, DuvodVznikuPP.Popis ' . // 71..73
            // ...
            ' FROM Osoba' .
            ' INNER JOIN PracovniPomer ON Osoba.RC = PracovniPomer.RC' .
            ' LEFT OUTER JOIN DuvodUkonceniPP ON DuvodUkonceniPP.Kod = PracovniPomer.DuvodUkonceniPP ' .
            ' LEFT OUTER JOIN DuvodVznikuPP ON DuvodVznikuPP.Kod = PracovniPomer.DuvodVznikuPP ' .
            ( ($jsouMzdy  ||  $jePersonalistika)
                ? ' LEFT OUTER JOIN PostaveniVZamestnani ON PostaveniVZamestnani.Kod = PracovniPomer.PostaveniVZamestnani'
                : ''
            ) .
            ' WHERE PracovniPomer.Id = ' . $params ->addParameter((int)$idPP);

        $cursor = $database ->select($sql, $params);

        if (!$row = $cursor ->fetch()) {
            throw new \Exception(StringUtils::fromUTF8('Pozadovana osoba nebyla nalezena!'));
        }

        $this ->idPP = $idPP;
        $this ->rc = $row[0];
        $this ->titul = $row[1];
        $this ->jmeno = $row[2];
        $this ->prijmeni = $row[3];
        $this ->titulZa = $row[4];
        $this ->idFotografie = $row[5];

        //$this ->rodneJmeno = $row[6];
        $this ->datumNarozeni = $database ->stringToTimestamp($row[7]);
        $this ->pohlavi = $row[8];
        $this ->narodnost = $row[9];
        $this ->rcZahranicni = $row[10];

        for ($i = 1;  $i <= 20;  $i++) {
            $this ->{'uzivatelska'.$i} = $row[10 + $i];
        }

        $this ->mistoNarozeni = $row[31];
        $this ->okresNarozeni = $row[32];
        $this ->statniPrislusnost = $row[33];
        $this ->intrawebLogin = $row[34];
        $this ->skupinaIW = $row[35];
        $this ->telefon = $row[36];
        $this ->email = $row[37];
        $this ->poznamka = $row[38];

        // Pracovni pomer
        $this ->osobniCislo = $row[39];
        $this ->datumNastupu = $database ->stringToTimestamp($row[40]);
        $this ->datumUkonceni = $database ->stringToTimestamp($row[41]);
        $this ->zamestnanec = $row[42];
        $this ->poradoveCisloPP = $row[43];
        $this ->cisloPracovniSmlouvy = $row[44];
        $this ->typPracovnihoPomeru = $row[45];
        $this ->zkusebniDoba = $row[46];
        $this ->zkusebniDobaDo = $database ->stringToTimestamp($row[47]);
        $this ->zkusebniDobaDoVypoctena = $database ->stringToTimestamp($row[71]);

        for ($i = 1;  $i <= 20;  $i++) {
            $this ->{'uzivatelskaPP'.$i} = $row[47 + $i];
        }

        $this ->poznamkaPP = $row[68];
        $this ->mobil = $row[69];
        $this ->postaveniVZamestnani = $row[70];
        $this->duvodUkonceni = $row[72];
        $this->duvodVzniku = $row[73];
    }

    function vratTextPole($jmenoPole)
    {
        $jmenoPole = trim(strtolower($jmenoPole));

        switch ($jmenoPole) {
            case 'osoba.jmeno' : return StringUtils::htmlTextConvert($this ->jmeno);
            case 'osoba.prijmeni' : return StringUtils::htmlTextConvert($this ->prijmeni);
            case 'osoba.titul' : return StringUtils::htmlTextConvert($this ->titul);
            case 'osoba.rc' : return StringUtils::htmlTextConvert($this ->rc);
            case 'osoba.rodnejmeno' : return ''; // return StringUtils::htmlTextConvert($this ->rodneJmeno);
            case 'osoba.datumnarozeni' : return StringUtils::format('date', $this ->datumNarozeni);
            case 'osoba.poznamka' : return StringUtils::longTextToHtml($this ->poznamka, true);
            case 'osoba.pohlavi' : return $this ->pohlavi;
            case 'osoba.narodnost' : return $this ->narodnost;
            case 'osoba.mistonarozeni' : return StringUtils::htmlTextConvert($this ->mistoNarozeni);
            case 'osoba.okresnarozeni' : return StringUtils::htmlTextConvert($this ->okresNarozeni);
            case 'osoba.email' : return StringUtils::htmlTextConvert($this ->email);
            case 'osoba.intraweblogin' : return StringUtils::htmlTextConvert($this ->intrawebLogin);
            case 'osoba.skupinaiw' : return StringUtils::htmlTextConvert($this ->skupinaIW);
            case 'osoba.telefon' : return StringUtils::htmlTextConvert($this ->telefon);
            case 'osoba.mobil' : return StringUtils::htmlTextConvert($this ->mobil);
            case 'osoba.statniprislusnost' : return StringUtils::htmlTextConvert($this ->statniPrislusnost);
            case 'osoba.rczahranicni' : return StringUtils::htmlTextConvert($this ->rcZahranicni);
            case 'pracovnipomer.osobnicislo' : return StringUtils::htmlTextConvert($this ->osobniCislo);
            case 'pracovnipomer.datumnastupu' : return StringUtils::format('date', $this ->datumNastupu);
            case 'pracovnipomer.datumukonceni' : return StringUtils::format('date', $this ->datumUkonceni);
            case 'pracovnipomer.id' : return $this ->idPP;
            case 'pracovnipomer.poradovecislopp' : return $this ->poradoveCisloPP;
            case 'pracovnipomer.cislopracovnismlouvy' : return StringUtils::htmlTextConvert($this ->cisloPracovniSmlouvy);
            case 'pracovnipomer.typpracovnihopomeru' : return StringUtils::htmlTextConvert($this ->typPracovnihoPomeru);
            case 'pracovnipomer.zkusebnidoba' : return $this ->zkusebniDoba;
            case 'pracovnipomer.zkusebnidobado' : return StringUtils::format('date', $this ->zkusebniDobaDo);
            case 'pracovnipomer.zkusebnidobadovypoctena' : return StringUtils::format('date', $this ->zkusebniDobaDoVypoctena);
            case 'pracovnipomer.zamestnanec' : return $this ->zamestnanec;
            case 'pracovnipomer.poznamka' : return StringUtils::longTextToHtml($this ->poznamkaPP, true);
            case 'pracovnipomer.postavenivzamestnani' : return isset($this ->postaveniVZamestnani) ? $this ->postaveniVZamestnani : '';
            case 'pracovnipomer.duvodvznikupp' : return $this->duvodVzniku;
            case 'pracovnipomer.duvodukoncenipp' : return $this->duvodUkonceni;
        }

        if ($jmenoPole > 'osoba.uzivatelska'  &&  $jmenoPole < 'osoba.uzivatelska99') {
            $property = substr($jmenoPole, 6);
            return StringUtils::htmlTextConvert($this ->{$property});
        }

        if ($jmenoPole > 'pracovnipomer.uzivatelska'  &&  $jmenoPole < 'pracovnipomer.uzivatelska99') {
            $property = 'uzivatelskaPP' . substr($jmenoPole, 25);
            return StringUtils::htmlTextConvert($this ->{$property});
        }

        return '';
    }


    function overPravo($kodUzivatelskehoPrava)
    {
        if (Prava::existujePravo($kodUzivatelskehoPrava)) {
            return Prava::vratPrava($kodUzivatelskehoPrava) ->lzeZobrazitRC($this ->rc);
        }

        return true;
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiAdresy($database)
    {
        $this ->pravoZobrazitTrvale = $this ->overPravo('prohl_osobni_trvale');
        $this ->pravoZobrazitPrechodne = $this ->overPravo('prohl_osobni_prechodne');

        $this->adresy = ($this ->pravoZobrazitTrvale || $this ->pravoZobrazitPrechodne)
            ? AdresaOsoby::nactiAdresuOsoby($database, $this->rc, time())
            : [];
    }


    /**
     * @param $database
     * @throws \Exception
     */
    function nactiRodinnyStav($database)
    {
        if ($this->overPravo('prohl_osobni_rodinnystav')) {
            $stavArray = RodinnyStav::nactiStav($database, $this->rc, null, true); // aktualni
            $this->rodinnyStav = count($stavArray) ? $stavArray[0] : null;
        } else {
            // nema pravo na rodinny stav
            $this->rodinnyStav = false;
        }
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiRodinnePrislusniky($database){
        $this->rodinniPrislusnici = $this ->overPravo('prohl_osobni_prislusnik')
            ? RodinnyPrislusnik::nactiRodinuZamestnance($database, $this->rc)
            : false;
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiZdravotniStav($database)
    {
        if ($this ->overPravo('prohl_osobni_pojistovna')) {
            $params = $database->createParameters();
            $sql =
                'SELECT S_ZdravotniStav.Popis, DrzitelPrukazuZTTP, ZPS, ZPS_TZP ' .
                ' FROM ZdravotniStavOsoby, S_ZdravotniStav ' .
                ' WHERE ZdravotniStavOsoby.ZdravotniStav = S_ZdravotniStav.kod ' .
                ' AND RC = ' . $params->addParameter($this->rc) .
                ' AND PlatnostOd <= ' . $params->addParameter($database->dateToParam(time())) .
                ' AND (PlatnostDo >= ' . $params->addParameter($database->dateToParam(time())) . ' OR PlatnostDo IS NULL)';

            $cursor = $database->getSqlResult($sql, $params);

            if ($row = $cursor->fetch()) {
                $this->zdravotniStav = new ZdravotniStavOsoby();

                $this->zdravotniStav->popisStavu = $row[0];
                $this->zdravotniStav->drzitelPrukazuZTTP = $row[1];
                $this->zdravotniStav->zps = $row[2];
                $this->zdravotniStav->zps_tzp = $row[3];
            }
        } else {
            $this->zdravotniStav = false;
        }
    }

    /**
     * @param $database
     * @throws \Ron\DB\DBException
     */
    function nactiZdravotniPojistovnu($database)
    {
        $this ->zdravotniPojistovna = $this ->overPravo('prohl_osobni_pojistovna')
            ? ZdravotniPojistovnaOsoby::nactiZdravotniPojistovnuOsoby($database, $this ->rc, time())
            : false;
    }

    /**
     * @param $database
     * @throws \Exception
     */
    function nactiVzdelani($database)
    {
        require_once('person/vzdelani.php');
        $this ->vzdelani = $this ->overPravo('prohl_osobni_vzdelani')
            ? VzdelaniOsoby::nactiVzdelani($database, $this ->rc, 'VzdelaniOsoby')
            : false;
    }


    /**
     * @param Database $database
     * @param bool $jenNejvyssi priznak, jestli se ma nacist jen nejvyssi uroven kazde dovednosti
     * @throws \Ron\DB\DBException
     */
    function nactiDovednosti($database, $jenNejvyssi = true)
    {
        $params = $database ->createParameters();

        $sql =
            'SELECT DovednostOsoby.KodDovednosti, UrovenDovednosti.BodovaHodnota, Dovednost.Popis, UrovenDovednosti.Popis ' .
            ' FROM DovednostOsoby, Dovednost, UrovenDovednosti ' .
            ' WHERE DovednostOsoby.RC = ' . $params ->addParameter($this ->rc) .
            ' AND Dovednost.Kod = DovednostOsoby.KodDovednosti ' .
            ' AND UrovenDovednosti.KodDovednosti = DovednostOsoby.KodDovednosti ' .
            ' AND UrovenDovednosti.KodUrovne = DovednostOsoby.KodUrovne ' .
            ' ORDER BY DovednostOsoby.KodDovednosti, UrovenDovednosti.BodovaHodnota DESC ';

        $cursor = $database ->getSqlResult($sql, $params);

        $this ->dovednosti = [];

        $posledniKod = '';
        while ($row = $cursor ->fetch()) {
            if (!$jenNejvyssi  ||  ($posledniKod != $row[0])) {
                $posledniKod = $row[0];

                $dovednost = new OsobniUdajeDovednost();
                $dovednost ->kod = $row[0];
                $dovednost ->bodovaHodnota = $row[1];
                $dovednost ->popis = $row[2];
                $dovednost ->popisUrovne = $row[3];

                $this ->dovednosti[] = $dovednost;
            }
        }
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiPracovniMista($database)
    {
        $this->pracovniMista = $this ->overPravo('prohl_osobni_pracmista')
            ? PracovniMistoOsoby::nactiPracovniMista($database,  $this->rc)
            : false;
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiUcetOsoby($database){
        $this->uctyOsoby = $this ->overPravo('prohl_osobni_ucetosoby')
            ? BankovniUcetOsoby::nactiUcetOsoby($database,  $this->rc)
            : false;
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiPrukazyOsoby($database){
        $this->prukazyOsoby = $this ->overPravo('prohl_osobni_prukaz')
            ? PrukazOsoby::nactiPrukazyOsoby($database, $this->rc)
            : false;
    }

    /**
     * @param $database
     * @throws \Ron\DB\DBException
     */
    function nactiTypyPrukazu($database){
        $this->typyPrukazu = PrukazOsoby::nactiTypyPrukazu($database);
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiPenzijniPripojisteniOsoby($database){
        $this->penzijniPripojisteniOsoby = $this ->overPravo('prohl_osobni_penzijni')
            ? PenzijniPripojisteniOsoby::nactiPenzijniPripojisteniOsoby($database, $this->rc)
            : false;
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiZivotniPojisteniOsoby($database){
        $this->zivotniPojisteniOsoby = $this ->overPravo('prohl_osobni_zivotni')
            ? ZivotniPojisteniOsoby::nactiZivotniPojisteniOsoby($database, $this->rc)
            : false;
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiVelikostPracovnichPomucek($database)
    {
        if ($this ->overPravo('prohl_osobni_velikosti')) {
            $this->velikostPomucekOsoby = [];

            $params = $database->createParameters();

            $sql =
                'SELECT TypVelikosti.Popis, VelikostPPomucky.Velikost' .
                ' FROM TypVelikosti' .
                ' JOIN VelikostPPomucky ON (TypVelikosti.Kod = VelikostPPomucky.TypVelikosti)' .
                ' LEFT JOIN VelikostPPOsoby ON (VelikostPPomucky.TypVelikosti = VelikostPPOsoby.TypVelikosti AND VelikostPPomucky.Velikost = VelikostPPOsoby.Velikost)' .
                ' WHERE RCOsoby = ' . $params->addParameter($this->rc);

            $cursor = $database->getSqlResult($sql, $params);
            while ($row = $cursor->fetch()) {
                $this->velikostPomucekOsoby[] = $row;
            }
            $cursor ->close();
        } else {
            $this ->velikostPomucekOsoby = false;
        }
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function seznamVydanychPracovnichPomucek($database)
    {
        if ($this ->overPravo('prohl_osobni_pomucky')) {
            $this->seznamVydanychPomucekOsoby = [];

            $params = $database->createParameters();

            $sql =
                'SELECT PracovniPomucka.Popis, PrirazenaPracPomucka.DatumVydani, PrirazenaPracPomucka.DatumExpirace ' .
                'FROM PrirazenaPracPomucka JOIN PracovniPomucka ON (PrirazenaPracPomucka.PracovniPomucka=PracovniPomucka.Kod) ' .
                'WHERE NOT(PrirazenaPracPomucka.datumVydani IS NULL) AND (PrirazenaPracPomucka.datumVraceni IS NULL) ' .
                'AND RC = ' . $params->addParameter($this->rc) . ' ' .
                'ORDER BY PrirazenaPracPomucka.DatumExpirace';

            $cursor = $database->getSqlResult($sql, $params);

            while ($row = $cursor->fetch()) {
                $poExpiraci = "";

                if ($row[2] != "") {

                    $zbyvaDni = DateUtils::daysBetween(time(), $database->stringToTimestamp($row[2]));

                    if ($zbyvaDni > 0) {
                        $poExpiraci = "";
                        //Do expirace
                    } else {
                        //Po expiraci
                        $poExpiraci = " expirovano ";

                    }
                }

                $this->seznamVydanychPomucekOsoby[] = [
                    0 => $row[0],
                    1 => $database->stringToTimestamp($row[1]),
                    2 => $database->stringToTimestamp($row[2]),
                    3 => $poExpiraci
                ];
            }
        } else {
            $this ->seznamVydanychPomucekOsoby = false;
        }
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function seznamNesplnenychNarokuNaPracovniPomucky($database)
    {
        if ($this ->overPravo('prohl_osobni_pomucky')) {
            $params = $database->createParameters();

            $sql =
                'SELECT PracovniPomucka.popis, PrirazenaPracPomucka.DatumNaroku ' .
                'FROM (PrirazenaPracPomucka  ' .
                'LEFT JOIN PracovniPomucka ON (PracovniPomucka.kod = PrirazenaPracPomucka.pracovniPomucka) ' .
                'LEFT OUTER JOIN TypPomucky ON (TypPomucky.Kod=PracovniPomucka.TypPomucky)) ' .
                'WHERE (PrirazenaPracPomucka.RC = ' . $params->addParameter($this->rc) . ') ' .
                'AND (PrirazenaPracPomucka.datumVydani IS NULL) AND (PrirazenaPracPomucka.datumVraceni IS NULL) ' .
                'ORDER BY PrirazenaPracPomucka.DatumNaroku';

            $this->seznamNesplnenychNarokuPomucek = [];

            $cursor = $database->getSqlResult($sql, $params);
            while ($row = $cursor->fetch()) {
                $this->seznamNesplnenychNarokuPomucek[] = [
                    $row[0],
                    $database->stringToTimestamp($row[1])
                ];
            }
        } else {
            $this->seznamNesplnenychNarokuPomucek = false;
        }
    }

    function seznamEvidencnichStavu($database)
    {
        $this->evidencniStavy = $this ->overPravo('prohl_osobni_evidencni')
            ? EvidencniStav::nactiEvidencniStavy($database, $this->rc)
            : false;
    }
}


class OsobniUdajeController extends HttpController
{
    /** @var  Database */
    var $database;

    /** @var  PravaNaOsoby */
    var $pravo_nahlaseni;

    /** @var  PravaNaOsoby */
    var $pravo_schvaleni;


    /**
     * OsobniUdajeController constructor.
     * @param Database $database
     */
    public function __construct(Database $database)
    {
        $this->database = $database;
        Prava::nastavObdobiProPrava(time(),time());
        $this->pravo_nahlaseni = Prava::vratPrava('ou_zmeny_nahlaseni');
        $this->pravo_schvaleni = Prava::vratPrava('ou_zmeny_schval');

    }


    /**
     * @param $idPP
     * @return Osoba
     * @throws \Exception
     */
    function nactiOsobu($idPP)
    {
        $osoba = new Osoba();
        $osoba ->nactiZakladniUdaje($this ->database, $idPP);

        return $osoba;
    }


    /**
     * @param $idPP
     * @return FotoOutputObject
     * @throws \Exception
     */
    function downloadFoto($idPP)
    {
        require_once('adsapp/fotoutils.php');

        if (!Prava::lzeZobrazitPP( [
            Prava::vratPrava('prohlizeni'),
            Prava::vratPrava('prohl_osobni') ], $idPP )
        ) {
            RonPortalUtils::neniPravoException();
        }

        $result = new FotoOutputObject($this->database);
        $result->nactiIdFotkyPracovnihoPomeru($idPP);
        return $result;
    }


//    /**
//     * @return array
//     * @throws \Ron\DB\DBException
//     */
//    private function seznamTypuPPomucek()
//    {
//        $typyPomucek = [];
//        $params = $this->database->createParameters();
//
//        $sql = 'SELECT Kod, Popis, TypVelikosti FROM TypPomucky ORDER BY Popis';
//
//        $cursor = $this->database ->getSqlResult($sql, $params);
//        while ($row = $cursor->fetch()) {
//            $typyPomucek[] = $row;
//        }
//        $cursor->close();
//
//        return $typyPomucek;
//    }


//    /**
//     * @return array
//     * @throws \Ron\DB\DBException
//     */
//    public function velikostPomucekOsoby()
//    {
//        //Velikost pomucek osoby
//        $velikostPomucekOsoby = [];
//        $params = $this->database->createParameters();
//
//        $sql =
//            'SELECT VelikostPPomucky.TypVelikosti, VelikostPPomucky.Velikost, TypVelikosti.Popis ' .
//            'FROM TypVelikosti ' .
//            'JOIN VelikostPPomucky ON (TypVelikosti.Kod = VelikostPPomucky.TypVelikosti)' .
//            'LEFT JOIN VelikostPPOsoby ON (VelikostPPomucky.TypVelikosti = VelikostPPOsoby.TypVelikosti AND VelikostPPomucky.Velikost = VelikostPPOsoby.Velikost)' .
//            'WHERE RCOsoby = ' . $params ->addParameter(RonPortalSession::osobaRC());
//
//        MessageManager::addDebugLog($sql);
//
//        $cursor = $this->database ->getSqlResult($sql, $params);
//        while ($row = $cursor->fetch()) {
//            $velikostPomucekOsoby[] = $row;
//        }
//        $cursor->close();
//
//        return $velikostPomucekOsoby;
//    }


//    /**
//     * @return array
//     * @throws \Ron\DB\DBException
//     */
//    private function neprirazeneVelikosti()
//    {
//        $vsechnyVelikosti = $this->seznamVelikostiPomucek();
//        $prirazeneVelikost = $this->velikostPomucekOsoby();
//
//        $polePrirazenychVelikosti = [];
//        $cnt = 0;
//        foreach ($prirazeneVelikost as $item => $value){
//            $polePrirazenychVelikosti[$cnt][0] = $value[0];
//            $polePrirazenychVelikosti[$cnt][1] = $value[1];
//            $cnt++;
//        }
//
//        // pres odbc nefunguji parametry v EXISTS, a zrejme problem celkove s pod dotazy (ani count nefungoval - jako nahrada EXISTS) proto resim porovnanim poli
//        $neprirazeneVelikosti = array_map('unserialize', array_diff(array_map('serialize', $vsechnyVelikosti), array_map('serialize', $polePrirazenychVelikosti)));
//
//        return $neprirazeneVelikosti;
//    }


    /**
     * @param int $idpp
     * @return BaseViewObject
     * @throws \Exception
     * @throws \Ron\RonPortal\NeniPravoException
     */
    function detailOsobniVelikostPracovnichPomucek($idpp)
    {
        $editace = false;

        if (isset($_POST['cancel'])) {
            // uzivatel kliknul na Storno tlacitko
            return new Redirect(null, '?menuid=osobniudaje&osoba=' . $idpp);
        }

        if (isset($_POST['zapsatvelikosti'])  ||  isset($_POST['zapsatazpet'])) {
            // ulozeni hodnot - idpp nacte z postu
            $idpp = (int)$_POST['osoba'];
            $editace = true;
        }

        require_once('adsapp/ppomer.php');
        $pracovniPomer = PracovniPomer::nactiPP($this ->database, $idpp);

        Prava::nastavObdobiProPrava(time(), time());

        require_once 'person/nahlasenazmena.php';
        NahlasenaZmena::zkontrolujPravoNaZmenu('velikosti', $pracovniPomer ->rc, $editace);

        require_once 'person/f_velikostipomucek.php';
        $form = new VelikostiPomucekForm($this ->database, $pracovniPomer);
        $form ->load();

        if ($editace) {
            try {
                $form->process();
                return new Redirect(null,
                    (isset($_POST['zapsatazpet'])
                        ? '?menuid=osobniudaje&osoba=' . $idpp
                        : '?menuid=osobniudaje&action=detailvelikostpomucek&osoba=' . $idpp)
                );
            } catch (\Exception $e) {
                MessageManager::addErrorMessage($e);
            }
        }
        Model::addViewObject($form);

        $historieNahlasenychZmenBrowser = new DriveNahlaseneZmenyBrowser($this->database, $pracovniPomer->idPP, 'velikostpomucek', null,'osobniudaje');
        $historieNahlasenychZmenBrowser->showMessages = false;
        $historieNahlasenychZmenBrowser->load();

        return $historieNahlasenychZmenBrowser;
    }


//    /**
//     * Pole velikosti prac. pomucek, ktere nema osoba prirazene
//     * @return array
//     * @throws \Ron\DB\DBException
//     */
//    private function seznamVelikostiPomucek(){
//        $seznamVelikostPomucekOsoby = [];
//        $params = $this->database->createParameters();
//
//        $sql =
//            "SELECT VelikostPPomucky.TypVelikosti, VelikostPPomucky.Velikost
//              FROM VelikostPPomucky
//              ORDER BY VelikostPPomucky.Velikost";
//
//        MessageManager::addDebugLog($sql);
//
//        $cursor = $this->database ->getSqlResult($sql, $params);
//
//        while ($row = $cursor->fetch()) {
//            $seznamVelikostPomucekOsoby[] = $row;
//        }
//        $cursor->close();
//
//        return $seznamVelikostPomucekOsoby;
//    }


//    /**
//     * @param $zpet
//     * @return Redirect
//     * @throws \Exception
//     */
//    private function prirazeniVelikostiPomuckyForm($zpet)
//    {
//        $poleTypuVelikostPomucky = [];
//        $nahlaseneHodnoty = \Ron\ronText('prirazeni_velikosti') . "\n";
//
//        $idpp = (int)$_POST['osoba'];
//        require_once('adsapp/ppomer.php');
//        $pp_osoby_zmeny = PracovniPomer::nactiPP($this->database, $idpp);
//        $pp_osoby_zmeny->vyberNactenyPP($this->database, $this->pravo_nahlaseni);
//
//
//        $cnt=0;
//        foreach($_POST as $key => $value) {
//            if (strpos($key, 'novaVelikostPomucky_') === 0) {
//
//            $typPomucky = explode(";;", $value)[0];
//            $velikostPomucky = explode(";;", $value)[1];
//
//                if ($typPomucky != null && $velikostPomucky != null) {
//                    $poleTypuVelikostPomucky[$cnt][0] = $key;
//                    $poleTypuVelikostPomucky[$cnt][1] = explode("_", $key)[1];
//                    $poleTypuVelikostPomucky[$cnt][2] = explode("_", $key)[2];
//                    $poleTypuVelikostPomucky[$cnt][3] = explode(";;", $value)[0];
//                    $poleTypuVelikostPomucky[$cnt][4] = explode(";;", $value)[1];
//
//                    $nahlaseneHodnoty .= "- " . explode(";;", $value)[2] . ": " . explode(";;", $value)[1] . "; " . \Ron\ronText('velikost') . ": " . explode(";;", $value)[0] . "; " . "\n";
//                    ++$cnt;
//                }
//            }
//        }
//
//        if (count($poleTypuVelikostPomucky) > 0) {
//
//            require_once('adsapp/ronportaldbrecord.php');
//            for ($i = 0; $i < count($poleTypuVelikostPomucky); $i++) {
//                $recVelikostPPOsoby = new RonPortalDBRecord($this->database, 'VelikostPPOsoby');
//
//                $recVelikostPPOsoby->addField('RCOsoby', '', false, 15, $pp_osoby_zmeny->rc);
//                $recVelikostPPOsoby->addField('TypVelikosti', '', false, 10, $poleTypuVelikostPomucky[$i][1]);
//                $recVelikostPPOsoby->addField('Velikost', '', false, 20, $poleTypuVelikostPomucky[$i][3]);
//
//                $params = $this->database->createParameters();
//                $recVelikostPPOsoby->setWhere(
//                    'RCOsoby = ' . $params->addParameter($pp_osoby_zmeny->rc) .
//                    ' AND TypVelikosti = ' . $params->addParameter($poleTypuVelikostPomucky[$i][1]) .
//                    ' AND Velikost = ' . $params->addParameter($poleTypuVelikostPomucky[$i][3]), $params);
//
//                $recVelikostPPOsoby->loadRecord();
//
//                if (!$recVelikostPPOsoby->insertRecord()) {
//                    throw new \Exception(StringUtils::fromUTF8('Chyba pri prirazeni velikosti pomucky'));
//                }
//            }
//
//            $this->zapisNahlaseneZmeny($pp_osoby_zmeny, $nahlaseneHodnoty, \Ron\ronText('prirazeni_velikosti_pomucky_uzivatelem'));
//        }
//
//        if ($zpet == 1){
//            return new Redirect(null, '?menuid=osobniudaje&action=detailvelikostpomucek&osoba=' . $idpp);
//        }
//        return new Redirect(null, '?menuid=osobniudaje&osoba=' . $idpp);
//    }


//    /**
//     * @return Redirect
//     * @throws \Exception
//     */
//    private function zmenaVelikostiPomuckyForm()
//    {
//        $poleTypuVelikostPomucky = [];
//        $nahlaseneHodnoty = "";
//
//        $idpp = (int)$_POST['osoba'];
//        require_once('adsapp/ppomer.php');
//        $pp_osoby_zmeny = PracovniPomer::nactiPP($this->database, $idpp);
//        $pp_osoby_zmeny->vyberNactenyPP($this->database, $this->pravo_nahlaseni);
//
//        $cnt=0;
//        foreach($_POST as $key => $value) {
//            if (strpos($key, 'zmenaVelikostPomucky_') === 0) {
//
//            $typPomucky = explode(";;", $value)[0];
//            $velikostPomucky = explode(";;", $value)[1];
//
//                if ($typPomucky != null && $velikostPomucky != null) {
//                    $poleTypuVelikostPomucky[$cnt][0] = $key;
//                    $poleTypuVelikostPomucky[$cnt][1] = explode("_", $key)[1];
//                    $poleTypuVelikostPomucky[$cnt][2] = explode("_", $key)[2];
//                    $poleTypuVelikostPomucky[$cnt][3] = explode(";;", $value)[0];
//                    $poleTypuVelikostPomucky[$cnt][4] = explode(";;", $value)[1];
//                    $poleTypuVelikostPomucky[$cnt][5] = explode("_", $key)[3];
//
//                    $nahlaseneHodnoty .= \Ron\ronText('zmena_velikosti') . " - ";
//                    $nahlaseneHodnoty .= explode(";;", $value)[2] . ": " . explode(";;", $value)[1] .  "\n" .
//                        \Ron\ronText('puvodni_velikost') . ": " . explode("_", $key)[3] . "; " . "\n" .
//                        \Ron\ronText('nova_velikost') . ": " . explode(";;", $value)[0] . "; " . "\n";
//                    ++$cnt;
//                }
//            }
//        }
//
//        if (count($poleTypuVelikostPomucky) > 0) {
//            require_once('adsapp/ronportaldbrecord.php');
//            for ($i = 0; $i < count($poleTypuVelikostPomucky); $i++) {
//                $recVelikostPPOsoby = new RonPortalDBRecord($this->database, 'VelikostPPOsoby');
//
//                $typ_velikosti = $poleTypuVelikostPomucky[$i][1];
//                $velikost = $poleTypuVelikostPomucky[$i][3];
//
//                $recVelikostPPOsoby->addField('TypVelikosti', '', false, 10, $typ_velikosti);
//                $recVelikostPPOsoby->addField('Velikost', '', false, 20, $velikost);
//
//                $params = $this->database->createParameters();
//                $recVelikostPPOsoby->setWhere(
//                    'RCOsoby = ' . $params->addParameter($pp_osoby_zmeny->rc) .
//                    ' AND TypVelikosti = ' . $params->addParameter($poleTypuVelikostPomucky[$i][1]) .
//                    ' AND Velikost = ' . $params->addParameter($poleTypuVelikostPomucky[$i][5]), $params);
//
//                $recVelikostPPOsoby->loadRecord();
//
//                if (!$recVelikostPPOsoby->updateRecord()) {
//                    throw new \Exception(StringUtils::fromUTF8('Chyba pri zmene velikosti pomucky'));
//                }
//            }
//
//            $this->zapisNahlaseneZmeny($pp_osoby_zmeny, $nahlaseneHodnoty, \Ron\ronText('zmena_velikosti_pomucky_uzivatelem'));
//        }
//
//        return new Redirect(null, '?menuid=osobniudaje&action=detailvelikostpomucek&osoba=' . $idpp);
//    }


//    /**
//     * @param int $idpp
//     * @param $typVelikosti
//     * @param $popis
//     * @param $velikost
//     * @return Redirect
//     * @throws \Exception
//     */
//    public function odstranitVelikostPracovnichPomucek($idpp, $typVelikosti,$popis, $velikost)
//    {
//        require_once('adsapp/ppomer.php');
//        $pp_osoby_zmeny = PracovniPomer::nactiPP($this->database, $idpp);
//
//        require_once 'person/nahlasenazmena.php';
//        NahlasenaZmena::zkontrolujPravoNaZmenu('velikosti', $pp_osoby_zmeny ->rc, true);
//
//        $nahlaseneHodnoty = "";
//        $nahlaseneHodnoty .= \Ron\ronText('odstraneni_velikosti') . "\n" . "- ";
//        $nahlaseneHodnoty .= $popis . ": " . $typVelikosti . "; " . \Ron\ronText('velikost') . ": " . $velikost  . "; " . "\n";
//
//        $rec = new RonPortalDBRecord($this->database, 'VelikostPPOsoby');
//
//        $params = $this->database->createParameters();
//        $rec->logDescription = 'Velikost pracovnich pomucek osoby - odstraneni pomucky, Portal';
//        $rec->addField('RCOsoby', '', false);
//        $rec->addField('TypVelikosti', '', false);
//        $rec->addField('Velikost', '', false);
//
//        $rec->setWhere( 'RCOsoby  = ' . $params->addParameter($pp_osoby_zmeny->rc) .
//            ' AND TypVelikosti = ' . $params->addParameter($typVelikosti) .
//            ' AND Velikost = ' . $params->addParameter($velikost), $params);
//
//        if (!$rec->deleteRecord()) {
//            throw new \Exception(StringUtils::fromUTF8('Chyba pri odstraneni velikosti pracovni pomucky.'));
//        }
//
//        $this->zapisNahlaseneZmeny($pp_osoby_zmeny, $nahlaseneHodnoty, \Ron\ronText('odstraneni_velikosti_pomucky_uzivatelem'));
//
//        return new Redirect(null, '?menuid=osobniudaje&action=detailvelikostpomucek&osoba=' . $idpp);
//    }


    /**
     * @param PracovniPomer $pracovniPomer
     * @param $nahlaseneHodnoty
     * @param string $poznamka
     * @throws \Ron\DB\DBException
     */
    public function zapisNahlaseneZmeny($pracovniPomer, $nahlaseneHodnoty, $poznamka)
    {
        $rec = new RonPortalDBRecord($this ->database, 'NahlasenaZmena', $this);
        $rec ->addField('TypZmeny', '', false, 20, 'velikostpomucek');
        $rec ->addField('RC', '', false, 15, $pracovniPomer->rc);
        $rec ->addField('DatumCas', 'timestamp', false, 0, time());
        $rec ->addField('Hodnoty', 'memo', false, 0, $nahlaseneHodnoty);
        $rec ->addField('Nahlasil', '', false, 15, User::getRC());
        $rec ->addField('DatumCasZpracovani', 'timestamp', false, 0, time());
        $rec ->addField('Zpracoval', '', false, 15, User::getRC());
        $rec ->addField('Poznamka', 'memo', false, 0, $poznamka);

        require_once('ron/sqlutils.php');
        $id = SQLUtils::newSerialNumber($this ->database, 'NahlasenaZmena', 'Id');
        $rec ->addField('Id', 'int', false, 0, $id);

        $rec ->insertRecord();

        MessageManager::addInfoMessage( \Ron\ronText('Hlaseni_ulozeno') );
    }

    /**
     * @param string $action
     * @return BaseViewObject|\Ron\MVC\InternalRedirect|\Ron\MVC\OutputObject|Redirect|\Ron\MVC\ViewObject|string
     * @throws \Ron\DB\DBException
     * @throws \Exception
     */
    public function handleAction($action)
    {
        HtmlHeaders::getInstance()->addCss('css/nahlasenezmeny.css');
        TextManager::getInstance()->loadStrings('nahlasenezmeny.ini');
        TextManager::getInstance()->loadStrings('person.ini');
        HtmlHeaders::getInstance()->addScript('script/nahlasenezmeny.js');
        HtmlHeaders::getInstance()->addScript('script/osobni_udaje.js');

        Prava::nastavObdobiProPrava(time(), time());
        Prava::nactiPravaUzivatele($this ->database, User::getRC());

        if ( isset($_GET['foto']) ) {
            return $this ->downloadFoto((int)$_GET['foto']);
        }

        require_once('adsapp/ronportalfilter.php');
        $pravaOsobni = Prava::vratPrava('prohl_osobni');
        $prava = [$pravaOsobni, Prava::vratPrava('prohlizeni')];

        $pravaNahlasit = Prava::vratPrava('ou_zmeny_nahlaseni');

        $ou_action = isset($_GET['action']) ? $_GET['action'] : '';

        switch ($ou_action) {

            //Formular pro upraveni osobnich velikosti
            case 'detailvelikostpomucek':
                return $this-> detailOsobniVelikostPracovnichPomucek((int)$_GET['osoba']);

//            //Odeslani formulare s prirazenim novych velikosti pomucek
//            case 'prirazenivelikostipomuckyform':
//                if (!($pravaNahlasit->lzeZobrazitRC(RonPortalSession::osobaRC()))) {
//                    RonPortalUtils::neniPravoException();
//                }
//                return $this-> prirazeniVelikostiPomuckyForm($_POST['prirazenivelikostipomuckyform']);

//            //Odeslani formulare se zmenami velikosti pomucek
//            case 'zmenavelikostipomuckyform':
//                if (!($pravaNahlasit->lzeZobrazitRC(RonPortalSession::osobaRC()))) {
//                    RonPortalUtils::neniPravoException();
//                }
//                return $this->zmenaVelikostiPomuckyForm();

//            //Odstraneni velikosti pomucky
//            case 'odstranitvelikostpomucky':
//                return $this->odstranitVelikostPracovnichPomucek((int)$_GET['osoba'],$_GET['typpomucky'], $_GET['popis'], $_GET['velikost']);
        }


        $filterForm = new RonPortalFilterForm($this ->database, $action);
        $filterForm ->nastavPersonalistiku($prava);
        $filterForm ->nastavAkciGet('osobniudaje');
        $filterForm ->loadData();

        Model::addData('filterForm', $filterForm);

        $osoba = $this ->nactiOsobu($filterForm ->vybranaOsoba);

        if ($pravaOsobni ->lzeZobrazitPP($osoba ->idPP)) {
            // nacte dalsi osobni udaje
            Model::addData('zobrazitOsobni', true);
            Model::addData('nahlasitZmenu', $this->pravo_nahlaseni->lzeZobrazitRC($osoba ->rc));

            $osoba->nactiAdresy($this ->database);
            $osoba->nactiPrukazyOsoby($this->database);
            $osoba->nactiTypyPrukazu($this->database);
            $osoba->nactiRodinnyStav($this ->database);
            $osoba->nactiZdravotniStav($this ->database);
            $osoba->nactiZdravotniPojistovnu($this ->database);
            $osoba->nactiVzdelani($this ->database);
            $osoba->nactiDovednosti($this ->database, true); // jen nejvyssi uroven
            $osoba->nactiPracovniMista($this ->database);
            $osoba->nactiUcetOsoby($this ->database);
            $osoba->nactiRodinnePrislusniky($this->database);
            $osoba->seznamEvidencnichStavu($this->database);

            if (RonPortalUtils::jeNainstalovanaAplikace($this->database, 'MZDY')) {
                $osoba->nactiPenzijniPripojisteniOsoby($this->database);
                $osoba->nactiZivotniPojisteniOsoby($this->database);
            }

            $osoba ->nactiVelikostPracovnichPomucek($this ->database);
            $osoba ->seznamVydanychPracovnichPomucek($this ->database);
            $osoba ->seznamNesplnenychNarokuNaPracovniPomucky($this ->database);
        } else {
            Model::addData('zobrazitOsobni', false);
        }

        Model::addData('osoba', $osoba);

        return new BaseViewObject('person/view_osobniudaje.php');
    }
}

return new OsobniUdajeController($this ->database);
