<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 27.12.2017
 */

namespace Ron\RonPortal\Dochazka;

use Ron\Controls\DateInput;
use Ron\GuiUtils;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\RonPortal\PracovniPomer;
use Ron\StringUtils;

require_once "ron/guiutils.php";

$model = Model::getInstance();

/** @var PracovniPomer $pp */
$pp = $model->getData('pp');

$comboBox = $model->getData('comboBox');
$editace_povolena = $model->getData('editace_povolena');
$kalendare = $model->getData('kalendare');
$nadpis = $model->getData('nadpis');
$filtrObdobi = $model->getData('filtrObdobi');
$schvaleniDochazky = $model->getData('schvaleniDochazky')[0];
$obdobi_zpracovano = $model->getData('schvaleniDochazky')[1];

?>

<h1><?= $nadpis ?></h1>

<div class='form large-form'>
    <div class="form-content">

        <div class="row">
            <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('osoba_kalendare') ?></div>
            <div class="col col-12 col-md-9 "><strong><?= $pp->jmenoPrijmeniKratke ?></strong></div>
        </div>

        <div class="row">
            <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('osobni_cislo') ?></div>
            <div class="col col-12 col-md-9 "><strong><?= $pp->osobniCislo ?></strong></div>
        </div>

        <?php if ($editace_povolena) { ?>
            <div class="row form-section">
                <?= \Ron\ronText('Obdobi') ?>
            </div>

            <div class="row">
                <?php $filtrObdobi->render(); ?>
            </div>
        <?php }?>

    </div>

    <?php if (!$editace_povolena) { ?>
        <div class="form-content">
            <div class="row">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('kalendar_upozorneni') ?></div>
                <div class="col col-12 col-sm-9 "><?= \Ron\ronText('editace_neni_povolena') ?></div>
            </div>
        </div>
    <?php } ?>

    <div class="form-content">
        <div class="row form-section"><?= \Ron\ronText('kalendare_v_obdobi') ?></div>
        <div class="row form-section">
            <div class="col col-4 col-md-3 "><?= \Ron\ronText('Platnost_od')?></div>
            <div class="col col-4 col-md-3 "><?= \Ron\ronText('Platnost_do')?></div>
            <div class="col col-4 col-md-2 "><?= \Ron\ronText('kalendar')?></div>
            <div class="col col-12 col-md-4 "><?= \Ron\ronText('Popis')?></div>
        </div>

        <?php foreach ($kalendare as $i => $kalendar) {
            //Obarveni radku
            $classRadku = (($i % 2 != 0) ? "browsercolor1" : "browsercolor2") . ' padding-all';

            $titulek = '';

            if (($kalendar->platnostOd < $schvaleniDochazky && $schvaleniDochazky >= $kalendar->platnostDo && $kalendar->platnostDo != '')
                ||
                ( $kalendar->platnostOd < $schvaleniDochazky && $kalendar->platnostDo == '')
                ||
                ($kalendar->platnostOd <= $schvaleniDochazky && $schvaleniDochazky < $kalendar->platnostDo && $kalendar->platnostDo != ''))
            {
                if ($obdobi_zpracovano == 0) {
                    $titulek = \Ron\ronText('dochazka_schvalena_do') . ": " . date('j.n.Y', $schvaleniDochazky) . ".&nbsp;\n" . \Ron\ronText('prirazeni_po_schvaleni');
                } else {
                    $titulek = \Ron\ronText('obdobi_zpracovano') . ".&nbsp;\n" . \Ron\ronText('prirazeni_po_schvaleni') . ": " . date('j.n.Y', $schvaleniDochazky);
                }

                $classRadku .= ' error-back';

                //echo "<div class='col col-4 col-md-3 errortext' title='$titulek'>" . date('j.n.Y',$kalendar->platnostOd) . "</div>";
                //echo "<div class='col col-4 col-md-3 errortext' title='$titulek'>" . ($kalendar->platnostDo != "" ? date('j.n.Y',$kalendar->platnostDo) : '&nbsp;') . "</div>";
            }
            ?>


            <div class='row <?= $classRadku ?>' title="<?= $titulek ?>">

                <div class='col col-4 col-md-3'><?= date('j.n.Y',$kalendar->platnostOd) ?></div>
                <div class='col col-4 col-md-3'><?= $kalendar->platnostDo ? date('j.n.Y',$kalendar->platnostDo) : '' ?></div>

                <div class='col col-4 col-md-2'><?= StringUtils::htmlTextConvert($kalendar->kod) ?></div>
                <div class='col col-12 col-md-4'><?= StringUtils::htmlTextConvert($kalendar->popis) ?></div>
            </div>

        <?php } ?>
    </div>

    <form enctype='multipart/form-data' method="post" id="formprirazenikalendare" action="?menuid=kalendarosoby&action=upravakalendare">
        <input type="hidden" name="osoba" value="<?= $pp ->idPP ?>"/>

        <div class="form-content">
            <div class="row form-section"><?= \Ron\ronText('kalendar_osoby_prirazeni_kalendare') ?></div>

            <?php MessageManager::getInstance() ->showMessages(); ?>

            <?php if ($editace_povolena && $pp ->idPP != '') { ?>
                <div class="row">
                    <div class="col col-6 col-sm-3 caption" id="datum_od"><?= \Ron\ronText('Platnost_od') ?></div>
                    <div class="col col-6 col-sm-9"><?php DateInput::renderDateSelect('Platnost_od','', false); ?></div>
                </div>

                <div class="row">
                    <div class="col col-6 col-sm-3 caption" id="datum_do"><?= \Ron\ronText('Platnost_do') ?></div>
                    <div class="col col-6 col-sm-9"><?php DateInput::renderDateSelect('Platnost_do','', false); ?></div>
                </div>

                <div class="row">
                    <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('kalendare') ?></div>
                    <div class="col col-12 col-sm-9"><?php $comboBox->render(); ?></div>
                </div>

                <div class="row">
                    <div class="col col-8 col-sm-3 caption" id="zpracovat"><?= \Ron\ronText('zpracovat') ?></div>
                    <div class="col col-4 col-sm-9">
                        <?php GuiUtils::renderCheckbox('zpracovat', null, false, '', '', 1); ?>
                    </div>
                </div>
            <?php } ?>

            <div class='buttons'>
                <input type="button" class="submitbutton clickHref" data-ron-href='?menuid=zpracovanadochazka'" value="<?= \Ron\ronText('Zpet')?>">

                <?php if ( $editace_povolena && $pp ->idPP != '' ) { ?>
                    <input type="submit" class="submitbutton" value="<?= \Ron\ronText('form.Insert')?>" >
                <?php } ?>
            </div>
        </div>

    </form>
</div>
