/**
* (c) RON Software spol. s r.o.
* stanislav.elbl, 9.7.2015.
*/


// TODO: tinymce.Editor.uploadImages    http://www.tinymce.com/wiki.php/api4:method.tinymce.Editor.uploadImages

ronPortal.elearning = {
    /**
     * storeTimeout urcuje za jak dlouho se ulozi editovany obsah, pokud uzivatel nic neprovede
     */
    storeTimeout: 10, // 15,

    /**
     * forceStoreTimeout urcuje, za jak dlouho nejpozdeji se ulozi editovany obsah (i kdyz uzivatel dale pise)
     */
    forceStoreTimeout: 30, // 60

    urlDownload : '' // nastaveno v ronPortal.elearning.configEditace()
};


ronPortal.elearning.configEditace = function(config) {
    //for (var i = 0;  i < config.length;  i++) {
        ronPortal.elearning.urlDownload = config.urlDownload;
    //}
};



ronPortal.elearning.ObsahKurzu = function() {
    this.id = 0;
    this.poradi = 0;
    this.nazev = '';
    this.obsah = '';

    this.kodStrany = '';
    this.zobrazitHlavicku = 1;
    this.zobrazitPaticku = 1;
    //this.druhHodnoceni = undefined; // 6
    this.temaCislo = undefined;

    this.insertUserName = '';
    this.insertTimestamp = '';
    this.updateUserName = '';
    this.updateTimestamp = '';

    // doplneno dodatecne
    this.$menuItem = null;  // odkaz na polozku v seznamu stranek
};

ronPortal.elearning.PrilohaKurzu = function() {
    this.id = 0;        // id v ramci kurzu
    //this.idPrilohy = 0; // id prilohy v databazi
    this.nazev = '';
    this.type = ''; // image/document/video/audio/unknown
};

ronPortal.elearning.TestKurzu = function() {
    this.druhHodnoceni = 0;
    this.temaCislo = 0;
    this.kod = '';
    this.popis = '';
};

ronPortal.elearning.DataEditace = function() {
    this.id = 0;     // id kurzu
    this.revize = 0; // id revize kurzu

    /**
     * @type {Array.<ronPortal.elearning.ObsahKurzu>}
     */
    this.obsahKurzu = [];

    /**
     * @type {Array.<ronPortal.elearning.PrilohaKurzu>}
     */
    this.prilohy = [];

    /**
     * @type {Array.<ronPortal.elearning.TestKurzu>}
     */
    this.testy = [];
};


(function() {

    var seznamPriloh = null;

    // zajisti spravnou funkcnost drag and drop v editoru (prekryje iframe divem)
    // POZNAMKA: DnD do editoru asi nefunguje ... (09/2020)
    var onPrilohaDragStart = function () {
        $(".mce-edit-area").each(function (index, element) {
            $('<div class="iframeCover" style="zindex:99;position:absolute;width:100%;top:0px;left:0px;height:' + $(element).height() + 'px"></div>')
                .appendTo($(element));
        });
    },

    onPrilohaDragStop = function () {
        $('.iframeCover').remove();
    },


    /**
     * Prida na konec seznamu zalozku pro zadanou prilohu
     * @param {Array.<ronPortal.elearning.PrilohaKurzu>} prilohy
     * @param {int} idRevize
     * @param {int} index
     */
    zobrazPrilohu = function (prilohy, idRevize, index) {
        $("<li/>")
            .text(prilohy[index].nazev)
            .addClass("media-item")
            .data("ron-id", prilohy[index].id)
            //.data("ron-idPrilohy", priloha.idPrilohy)
            .data("ron-index", index)
            .data("ron-url", "?menuid=kurzy&%DOWNLOAD%&revize=" + idRevize + "&priloha=" + prilohy[index].id)
            .data("ron-type", prilohy[index].type)
            .appendTo("#kurz_prilohy")
            .draggable({
                start: onPrilohaDragStart,
                stop: onPrilohaDragStop,
                helper: "clone",
                zIndex: 3000
            });
    };

    $.extend(ronPortal.elearning, {
        zobrazPrilohy: function (prilohy, idRevize) {
            seznamPriloh = prilohy;

            $("#kurz_prilohy").empty();

            for (var i = 0; i < prilohy.length; i++) {
                zobrazPrilohu(prilohy, idRevize, i);
            }
        }

    });


    // Popup menu
    var odstranPrilohuZeSeznamu = function(index) {
        if (seznamPriloh) {
            seznamPriloh.splice(index, 1);
        }
    };

    var prilohaPopupMenuClick = function(e, data) {
        var akce = $(this).data("ron-akce");

        var index = $("#kurz_prilohy").children("li").index( data );

        switch (akce) {
            case "zobrazit" :
                $(data).closest(".media-list").mediaViewer( {
                    initialItem: data
                });
                break;

            case "odstranit" :
                $(data).trigger("delete-media",
                    function() {
                        odstranPrilohuZeSeznamu(index);
                        $(data).remove();
                    });
                //deletePriloha(index, function() { odstranPrilohuZeSeznamu(index); $(data).remove(); });
                break;
        }
    };

    var onPrilohaMouseUp = function($e) {
        if ($e.which == 3) {
            $("#prilohy_menu").ronPopupMenu({
                // attachToElement: $(this), nefunguje dobre, pokud je odscrollovano!
                mouseEvent: $e,
                onClick: prilohaPopupMenuClick,
                data: this // polozka seznamu, pro kterou je popupmenu zobrazeno
            });

            return false;
        }
    };

    $(function() {
        $("#kurz_prilohy")
            .on("contextmenu", function() { return false; })
            .on("mouseup", "li", onPrilohaMouseUp);
    });

})();

/**
 * @param {ronPortal.elearning.DataEditace} dataEditace
 * @param {string} initialTab
 */
ronPortal.elearning.initEditaceKurzu = function(dataEditace, initialTab) {

    /**
     * Index aktualni editovane strany
     * @type {number}
     */
    var aktualniStrana = -1;

    var editor = null;
    var saveButton = null;

    // Nastaveni velikosti jednotlivych panelu
    var $nadpis = $("#elearning_nadpis");
    var top = $nadpis.offset().top + $nadpis.outerHeight();

    $("#elearning_container")
        .css("top", top);


    /**
     * Prida na konec seznamu zalozku pro zadanou stranu
     * @param {int} index
     * @return {jQuery}    Vraci jQuery objekt pro novou polozku (li)
     */
    var pridejZalozku = function(index) {
        /** @var {ronPortal.elearning.ObsahKurzu} strana **/
        var strana = dataEditace.obsahKurzu[index];

        strana.$menuItem = $("<li/>")
            .text(strana.poradi + '. ' + strana.nazev)
            .data("ron-poradi", strana.poradi)
            .data("ron-id", strana.id)
            .data("ron-index", index)
            .appendTo("#kurz_obsah_list");

        return strana.$menuItem;
    };


    /**
     * Zobrazi zalozky pro vsechny strany
     * @param {Array.<ronPortal.elearning.ObsahKurzu>} strany
     */
    var zobrazZalozky = function(strany) {
        $("#kurz_obsah_list").empty();

        for (var i = 0;  i < strany.length;  i++) {
            pridejZalozku(i);
        }
    };


    /**
     * Vraci stranku se zadanym id
     * @param {int} id
     * @returns {ronPortal.elearning.ObsahKurzu}
     */
    var najdiStranku = function(id) {
        for (var i = 0;  i < dataEditace.obsahKurzu.length;  i++) {
            if (dataEditace.obsahKurzu[i].id == id) {
                return dataEditace.obsahKurzu[i];
            }
        }

        return null;
    };


    var pridejNovouStranku = function(strana) {
        if (!strana) return;

        dataEditace.obsahKurzu[dataEditace.obsahKurzu.length] = strana;
        var $li = pridejZalozku(dataEditace.obsahKurzu.length - 1);

        zobrazZalozku($li);
    };


    /**
     * Vytvori novou stranku kurzu a zajisti jeji zobrazeni v zalozkach
     */
    var newContent = function() {
        $.ajax( "?menuid=kurzy&action=newcontent&idrevize=" + dataEditace.revize)
            .done( function(data) {
                if (data.result == "OK") {
                    pridejNovouStranku(data.obsah);
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri vkladani nove stranky doslo k chybe!");
            });
    };


    var updateDirty = function() {
        if (saveButton) saveButton.disabled(!editor.isDirty());
    };


    /**
     * Ulozi obsah editoru do aktualni editovane strany, vcetne ulozeni na server
     * @param {int} index
     */
    var saveContent = function(index) {
        if (!editor) return;

        dataEditace.obsahKurzu[index].obsah = editor.getContent();
        var strana = dataEditace.obsahKurzu[index];

        $.ajax(
            {
                url: "?menuid=kurzy&action=savecontent",
                type: "POST",
                data: {
                    id: strana.id,
                    obsah: strana.obsah
                }
            })
            .done( function(data) {
                if (data.result == "OK") {
                    // ulozeno
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri ukladani stranky doslo k chybe!");
            });

        editor.isNotDirty = true;
        updateDirty();
    };


    // automaticke ukladani obsahu
    var forceStoreTimer = null;
    var storeTimer = null;

    // volano po uplynuti timeoutu (15 sekund) od posledni zmeny
    var onStoreTimer = function() {
        storeTimer = null;

        if (forceStoreTimer) {
            clearTimeout(forceStoreTimer);
            forceStoreTimer = null;
        }

        saveContent(aktualniStrana);
    };

    // volano po uplynuti timeoutu (60 sekund) od prvni neulozene zmeny
    var onForceStoreTimer = function() {
        forceStoreTimer = null;

        if (storeTimer) {
            clearTimeout(storeTimer);
            storeTimer = null;
        }

        saveContent(aktualniStrana);
    };

    var clearTimers = function() {
        if (storeTimer) {
            clearTimeout(storeTimer);
            storeTimer = null;
        }

        if (forceStoreTimer) {
            clearTimeout(forceStoreTimer);
            forceStoreTimer = null;
        }
    };


    /**
     * Ulozi aktualni obsah editoru do dataEditace a na server
     */
    var storeContent = function() {
        if (aktualniStrana < 0  ||  !editor  ||  !editor.isDirty()) {
            return;
        }

        if (storeTimer) clearTimeout(storeTimer);
        storeTimer = setTimeout(onStoreTimer, ronPortal.elearning.storeTimeout * 1000);

        if (!forceStoreTimer) {
            forceStoreTimer = setTimeout(onForceStoreTimer, ronPortal.elearning.forceStoreTimeout * 1000);
        }
    };


    // zobrazeni podrobnosti stranky
    var pageProperties = function(index) {
        var
            strana = dataEditace.obsahKurzu[index],
            $select = $("#test_obsahu");

        $("#kurz_page_title")
            .val(strana.nazev);

        $("#kurz_page_code")
            .val(strana.kodStrany);

        $select.empty();

        $("<option/>")
            .val("")
            .text("")
            .appendTo($select);

        for (var i = 0;  i < dataEditace.testy.length;  i++) {
            $("<option/>")
                .val(dataEditace.testy[i].temaCislo)
                .text(dataEditace.testy[i].popis)
                .appendTo($select);
        }

        $select.val(strana.temaCislo ? strana.temaCislo : "");

        $("#kurz_page_show_header").prop('checked', strana.zobrazitHlavicku);
        $("#kurz_page_show_footer").prop('checked', strana.zobrazitPaticku);
    };



    var zobrazStranu = function(index) {
        if (index < 0  ||  index >= dataEditace.obsahKurzu.length) {
            return;
        }

        clearTimers();

        if (aktualniStrana >= 0  &&  aktualniStrana < dataEditace.obsahKurzu.length) {
            if (editor.isDirty()) {
                saveContent(aktualniStrana);
            }
        }

        aktualniStrana = index;

        pageProperties(index);

        //editor.val(dataEditace.obsahKurzu[index].obsah);

        $("#kurz_editace").val(dataEditace.obsahKurzu[index].obsah);

        if (editor ) {
            editor.load(); // nacte obsah z textarea

            updateDirty();
        }
    };


//--    var tabs = ron.ronTabs( $("#elearning_tabs"), { initialPage: initialTab } );
    $("#elearning_tabs").rontabs({ initialPage: initialTab });

    // ovladani
    var tinymceSetup = function(setupEditor) {
        editor = setupEditor;

        var onChangeText = function() {
            updateDirty();
            storeContent();
        };

        setupEditor.on("change", onChangeText);
        setupEditor.on("nodeChange", onChangeText );
        setupEditor.on("keyup", onChangeText );

        var saveBtn = {
            text: '<i class="fa glyph-ok"></i>',
            tooltip: ron._('Save'),
            onAction: function () {
                clearTimers();
                saveContent(aktualniStrana);
            },
            onPostrender: function() {
                saveButton = this;
            }
        };


        setupEditor.ui.registry.addButton('ron_save', saveBtn);
    };


    // zobrazi stranky (osnovu kurzu)
    zobrazZalozky(dataEditace.obsahKurzu);
    ronPortal.elearning.zobrazPrilohy(dataEditace.prilohy, dataEditace.revize);

    /**
     * Ulozeni vlastnosti stranky
     */
    var savePageProperties = function(index) {
        if (!editor) return;

        var strana = dataEditace.obsahKurzu[index];
        strana.nazev = $("#kurz_page_title").val();
        strana.kodStrany = $("#kurz_page_code").val();

        strana.zobrazitHlavicku = $("#kurz_page_show_header").prop('checked') ? 1 : 0;
        strana.zobrazitPaticku = $("#kurz_page_show_footer").prop('checked') ? 1 : 0;
        strana.temaCislo = $("#test_obsahu").val();

        $.ajax(
            {
                url: "?menuid=kurzy&action=saveproperties",
                type: "POST",
                data: {
                    id: strana.id,
                    nazev: strana.nazev,
                    kodStrany: strana.kodStrany,
                    zobrazitHlavicku: strana.zobrazitHlavicku,
                    zobrazitPaticku: strana.zobrazitPaticku,
                    temaCislo: strana.temaCislo
                }
            })
            .done( function(data) {
                if (data.result == "OK") {
                    // ulozeno v DB
                    strana.$menuItem
                        .text(strana.poradi + '. ' + strana.nazev);
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri ukladani vlastnosti stranky doslo k chybe!");
            });
    };


    /**
     * Volano pri d&d primo do editoru (nastaveno pomoci images_upload_handler)
     * @param blobInfo
     * @param success
     * @param failure
     */
    var onUploadImage = function (blobInfo, success, failure) {
        console.log("onUploadImage", blobInfo, success, failure);
        //console.log("blob: ", blobInfo.blob());  // blob.type = "image/jpg" a podobne

        var form = new FormData();
        form.append("upload_file", blobInfo.blob());
        form.append("filename", blobInfo.filename());
        form.append("revize", dataEditace.revize);

        var successUpload = function(data) {
            if (success) success(data.location);
        };

        handleUploadForm(form, successUpload, failure);
    };


    var fileBrowserCallback = function(field_name, url, type, win) {
        console.log('fileBrowserCallback', field_name, url, type);

        if(type=="image") $("#image_upload_form").children("input").click();
    };

    $("#image_upload_form").
        on("submit", function() { console.log("submituju ..."); } );

    var onUploadImageSelected = function() {
        console.log("onUploadImageSelected");

        $("#image_upload_form").submit();
        this.value = "";
    };

    //var showLinkList = function() {
    //    //"?menuid=kurzy&action=linkslist&idrevize=" + dataEditace.revize
    //};


        //var pageContent = function() {
    //    $("#page_content_contaniner").css("display", "block");
    //};

    /**
     * Vytvori seznam preddefinovanych odkazu a zobrazi dialog nastaveni linku
     * @callback {callback}
     * @returns {*[]}
     */
    var createLinklist = function(callback) {
        var list = [
            {text: ron._("Nasledujici_strana"), value:"%NEXT_PAGE%"},
            {text: ron._("Predchozi_strana"), value:"%PREV_PAGE%"},
            {text: ron._("Prvni_strana"), value:"%FIRST_PAGE%"},
            {text: ron._("Posledni_strana"), value:"%LAST_PAGE%"}
        ];

        for (var i = 0;  i < dataEditace.obsahKurzu.length;  i++) {
            if (dataEditace.obsahKurzu[i].kodStrany) {
                list[list.length] = { text: dataEditace.obsahKurzu[i].nazev, value: "%PAGE#" + dataEditace.obsahKurzu[i].kodStrany + "%" }
            }
        }

        list[list.length] = { text: ron._('Zavrit_okno_kurzu'), value:"%CLOSE%" };
        list[list.length] = { text: ron._('Certifikat'), value:"%CERTIFIKAT%" };

        callback(list);
    };



    //ron.mce.addAssetPlugin( {
    //    items: '?menuid=prezentace&action=assets' // url pro nacteni seznamu assetu - NENI DOKONCENO A NENI PREDELANO PRO tinyMCE5
    //} );

    // inicializace editoru
    tinymce.init({
        mode: "exact",
        selector: "#kurz_editace",

        //theme: "modern",
        language: ron._('TinyMCE_Lang_Code'),

        menubar: "edit insert view format table tools",
        statusbar: true,
        resize: "both",

        content_css: 'script/ronmce.css',

        height: "100%",
        //width: "99%",

        //formats: {
        //    bold: { inline: 'span', 'classes' : 'asset bold'}
        //},

        style_formats_merge: true,
        style_formats: [
            {
                title: 'Image Left',
                selector: 'img',
                styles: {
                    'float': 'left',
                    'margin': '5px 10px'
                }
            },
            {
                title: 'Image Right',
                selector: 'img',
                styles: {
                    'float': 'right',
                    'margin': '5px 10px'
                }
            },
            {
                title: 'Image Inline',
                selector: 'img',
                styles: {
                    'float': 'none'
                }
            },
            {
                title: 'Asset',
                inline: 'span',
                classes: 'asset'
            }
        ],

        paste_data_images: true,
        image_prepend_url: ronPortal.elearning.urlDownload, // '?menuid=kurzy&%DOWNLOAD%',
        images_upload_handler: onUploadImage,
        file_browser_callback: fileBrowserCallback,
        plugins: [
            "advlist autolink lists link charmap print preview anchor",
            "searchreplace visualblocks fullscreen",
            "insertdatetime table paste", // contextmenu
            "code image imagetools media table charmap" // textcolor colorpicker asset
        ],
        //toolbar: "undo redo ron_save searchreplace | styleselect fontsizeselect | bold italic | forecolor backcolor | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image asset table charmap | fullscreen code",
        toolbar: "undo redo ron_save searchreplace | styleselect fontsizeselect | bold italic | forecolor backcolor | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image table charmap | fullscreen code",
        setup: tinymceSetup,

        link_list : createLinklist
        //link_list : "?menuid=kurzy&action=linkslist&idrevize=" + dataEditace.revize
        //showLinkList

    });


    /**
     * @param {jQuery} $li
     * @param {string} [tabId]
     */
    var zobrazZalozku = function($li, tabId) {
        $("#kurz_obsah_list")
            .children().toggleClass("selected", false);

        $li
            .toggleClass("selected", true);

        zobrazStranu( $li.data("ron-index") );

        var $tabs = $("#elearning_tabs");

        if (tabId) {
            $tabs.rontabs("selectPage", tabId);
        } else {
            // prepnout na zalozku s textem
            if (!$tabs.rontabs("getSelectedPageId") || $tabs.rontabs("getSelectedPageId") == "kurz_basic" || $tabs.rontabs("getSelectedPageId") == "kurz_testy") {
                $tabs.rontabs("selectPage", "kurz_text");
            }
        }
    };


    // osnova kurzu (seznam kapitol)
    /**
     * kliknuti mysi na osnovu - zobrazi prislusnou kapitolu
     * @param e
     */
    var osnovaClick = function(e) {
        zobrazZalozku( $(this) );
    };


    var odstranStranku = function(strana) {
        var index = $.inArray(strana, dataEditace.obsahKurzu);
        if (index < 0) {
            console.log('odstranStranku: zadana strana nebyla nalezena!');
            return;
        }

        // odstrani stranku ze seznamu
        dataEditace.obsahKurzu.splice(index, 1);
        if (aktualniStrana == index) {
            aktualniStrana = -1;
        }

        // odstrani zobrazenou zalozku
        zobrazZalozky(dataEditace.obsahKurzu);

        // zobrazi nasledujici/predchozi stranku
        if (dataEditace.obsahKurzu.length > index) {
            // zobrazi nasledujici stranu
            zobrazZalozku(dataEditace.obsahKurzu[index].$menuItem);
        } else if (!dataEditace.obsahKurzu.length) {
            // zadna strana nezustala => zobrazi podrobnosti kurzu
            $("#elearning_tabs").rontabs("selectPage", "kurz_basic");
        } else {
            // smazana byla posledni => zobrazi predchozi stranu
            zobrazZalozku(dataEditace.obsahKurzu[index - 1].$menuItem)
        }

    };


    var deletePage = function(index) {
        var strana = dataEditace.obsahKurzu[index];

        if ( !ron.confirm( ron._("Opravdu_smazat_stranku") + " " + strana.nazev + "?") ) return;

        $.ajax(
            {
                url: "?menuid=kurzy&action=deletecontent",
                type: "POST",
                data: {
                    id: strana.id
                }
            })
            .done( function(data) {
                if (data.result == "OK") {
                    // odstraneno
                    odstranStranku(strana)
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri mazani stranky doslo k chybe!");
            });
    };


    var osnovaPopupMenuClick = function(e, data) {
        var akce = $(this).data("ron-akce");

        switch (akce) {
            case "editovat" :
                zobrazZalozku( $(data), "kurz_text" );
                break;

            case "vlastnosti" :
                zobrazZalozku( $(data), "kurz_podrobnosti_stranky" );
                break;

            case "odstranit" :
                deletePage( $(data).data("ron-index") );
                break;
        }
    };


    var osnovaMouseUp = function(e) {
        //var $menu = $("#prepocet_menu");
        //ron.showPopupMenu($menu, { attachToElement: $("#tlacitkoprepocet") } );
        //
        //return false; // stop propagation

        if (e.which == 3) {
            $("#kurz_osnova_menu").ronPopupMenu({
                attachToElement : $(this),
                onClick : osnovaPopupMenuClick,
                data: this // polozka seznamu, pro kterou je popupmenu zobrazeno
            });

            return false;
        }
    };


    /**
     * Nastavi u stranek polozku poradi (stranky nepreusporadava!)
     * @param poradiStranek
     */
    var nastavPoradiStranek = function(poradiStranek) {
        if (!poradiStranek) return;

        // preusporada stranky podle dat nactenych z databaze
        for (var i = 0;  i < poradiStranek.length;  i++) {
            var stranka = najdiStranku(poradiStranek[i].id);
            if (stranka) {
                stranka.poradi = poradiStranek[i].poradi;
            }
        }
    };


    var osnovaPreusporadana = function(e, ui) {
        var indexStrany = ui.item.data("ron-index");
        var strana = dataEditace.obsahKurzu[indexStrany];
        var newIndex = ui.item.index();
        var novePoradi = dataEditace.obsahKurzu[newIndex].poradi;

        // TODO: Opravit! Nefunguje spravne, protoze se neaktualizuje ...[].poradi - nacist a preusporadat podle skutecnosti?
        $.ajax(
            {
                url: "?menuid=kurzy&action=changeorder",
                type: "POST",
                data: {
                    id: strana.id,
                    newindex: novePoradi // newIndex + 1 // (poradi je cislovane od 1)
                }
            })
            .done( function(data) {
                if (data.result == "OK") {
                    nastavPoradiStranek(data.poradiStranek);
                    // odstrani polozku z puvodni pozice
                    dataEditace.obsahKurzu.splice(indexStrany, 1);
                    // a vlozi ji na novou pozici
                    dataEditace.obsahKurzu.splice(newIndex + (newIndex > indexStrany ? 1 : 0), 0, strana);
                    // a upravi data-ron-index
                    for (var i = 0;  i < dataEditace.obsahKurzu.length;  i++) {
                        dataEditace.obsahKurzu[i].$menuItem.data("ron-index", i);
                    }
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri zmene poradi stranek doslo k chybe!");
            });

    };


    $("#kurz_new_content")
        .on("click", newContent);

    $("#kurz_obsah_list")
        .on("click", "li", osnovaClick)
        .on("mouseup", "li", osnovaMouseUp)
        .on("contextmenu", function() { return false; })
        .sortable( {
            // automaticke presouvani poradi stranek
            //axis: "y",
            //containment: "parent",
            cursor: "n-resize", // move
            axis: "y",
            distance: 5,
            forcePlaceholderSize: true,
            opacity: 1,
            placeholder: "sortable-placeholder",
            tolerance: "pointer",
            revert: false,
            stop: osnovaPreusporadana
        } );


    //var getPrilohaImageFile = function(index) {
    //    return new ron.ImageFile(
    //        "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.revize + "&priloha=" + dataEditace.prilohy[index].id,
    //        dataEditace.prilohy[index].type
    //    );
    //};


    //var deletePriloha = function(index, afterDelete) {
    //    if (!confirm( ron.translate('Opravdu_smazat_prilohu'))) {
    //        return false;
    //    }
    //
    //    $.ajax('?menuid=kurzy&action=deletepriloha&id=' + dataEditace.prilohy[index].id + '&revize=' + dataEditace.revize)
    //        .done( function(data) {
    //            if (data.result == "OK") {
    //                //console.log("Odstraneni prilohy probehlo uspesne ...");
    //                if (afterDelete) afterDelete(index);
    //            } else {
    //                ron.showError(data);
    //            }
    //        }).fail( function(jqXHR) {
    //            ron.logAjaxError(jqXHR, "Pri odstranovani prilohy doslo k chybe!");
    //        });
    //};

    //var prilohaTimer = null;
    //
    //var showImageView = function(imageIndex) {
    //    ron.imageView( {
    //        count: dataEditace.prilohy.length,
    //        actualImage: imageIndex,
    //        getImage: getPrilohaImageFile,
    //        delete: deletePriloha
    //        //this.rootElement = null;
    //    } );
    //};
    //
    //// prilohy
    //var prilohaClick = function() {
    //    if (prilohaTimer) {
    //        clearTimeout(prilohaTimer);
    //        prilohaTimer = null;
    //    }
    //
    //    var imageIndex = $("#kurz_prilohy").children("li").index( this );
    //
    //    prilohaTimer = setTimeout( function() {
    //        prilohaTimer = null;
    //        showImageView(imageIndex);
    //    }, 400 );
    //};


    /**
     * DoubleClick na priloze - vlozi dokument do textu
     */
    var prilohaDblClick = function() {
        //if (prilohaTimer) {
        //    clearTimeout(prilohaTimer);
        //    prilohaTimer = null;
        //}

        var
            $this = $(this),
            id = $this.data("ron-id");

        if (!id) {
            return;
        }

        var
            index = $("#kurz_prilohy").children("li").index( this),
            ed = tinyMCE.get("kurz_editace"),
            range = ed.selection.getRng();

        if (dataEditace.prilohy[index].type == "image") {
            var newNode = ed.getDoc().createElement("img");
            newNode.src = "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.revize + "&priloha=" + id;
        } else if (dataEditace.prilohy[index].type == "video") {
            newNode = ed.getDoc().createElement ( "video" );
            newNode.controls = "controls";
            newNode.width = 640;
            newNode.height = 480;

            var sourceNode = ed.getDoc().createElement ( "source" );
            sourceNode.src = "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.revize  + "&priloha=" + id;
            newNode.appendChild(sourceNode);
        } else {
            newNode = ed.getDoc().createElement("a");
            newNode.href = "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.revize  + "&priloha=" + id;
            newNode.textContent = ron._('Stahnout_prilohu');
            newNode.target = "_blank";
        }

        range.insertNode(newNode);
        updateDirty();
        //var ed = tinyMCE.get('txt_area_id');                // get editor instance
        //var newNode = ed.getDoc().createElement ( "img" );  // create img node
        //newNode.src="sample.jpg";                           // add src attribute
        //ed.execCommand('mceInsertContent', false, newNode.outerHTML)
    };


    /**
     *
     * @param form
     * @param {function} [success]
     * @param {function} [failure]
     */
    var handleUploadForm = function(form, success, failure) {
        $.ajax(
            {
                url: "?menuid=kurzy&action=upload",
                type: "POST",
                //enctype: 'multipart/form-data',
                data: form,
                cache: false,
                dataType: 'json',
                processData: false,
                contentType: false
            })
            .done( function(data) {
                if (data.result == "OK") {
                    //console.log("handleUploadForm", data);

                    // ulozeno, nacist prilohy do menu
                    dataEditace.prilohy = data.prilohy;
                    ronPortal.elearning.zobrazPrilohy(data.prilohy, dataEditace.revize);
                    if (success) success(data);
                    editor.isNotDirty = false;

                } else {
                    ron.showError(data);
                    if (failure) failure("Pri nahravani souboru doslo k chybe!");
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri nahravani souboru doslo k chybe!");
                if (failure) failure("Pri nahravani souboru doslo k chybe!");
            });
    };


    /**
     * Upload souboru pomoci drag&drop
     * @param files
     * @param {bool} createPages
     * @param {function} [finishedCallback] Funkce, ktera se zavola po ukonceni nahravani vsech souboru
     */
    var handleUploadFiles = function(files, createPages, finishedCallback) {
        //console.log("handleUploadFiles", files);

        /**
         * Pocitadlo dokoncenych nahravani
         */
        var counter = files.length;


        var uploadFinished = function(data) {
            counter--;
            if (!counter  &&  finishedCallback) {
                finishedCallback();
            }

            if (createPages  &&  data  &&  data.strana) {
                pridejNovouStranku(data.strana);
            }
        };

        var handleUploadFile = function(file, createPage) {
            var fileReader = new FileReader();

            fileReader.onload = ( function(e) {
                //console.log(e, file);

                var form = new FormData();
                form.append('upload_file', file);
                form.append('revize', dataEditace.revize);
                if (createPage) {
                    form.append('createPage', 1);
                }

                handleUploadForm(form, uploadFinished, uploadFinished);
            });

            fileReader.readAsBinaryString(file);
            //fileReader.readAsArrayBuffer(file);
            //fileReader.readAsDataURL(file);
        };


        for (var i = 0;  i < files.length;  i++) {
            handleUploadFile(files[i], createPages);
        }
    };


    var onPageDrop = function($e) {
        var
            dt = $e.originalEvent.dataTransfer,
            $this = $(this);

        $this.toggleClass("loading", true);

        handleUploadFiles(dt.files, true, // createPages = true
            function() {
                $this.toggleClass("loading", false);
            }
        );

        return false;
    };


    /**
     * Drop na seznamu priloh - provede upload priloh
     * @param $e
     * @returns {boolean}
     */
    var onPrilohaDrop = function($e) {
        // pozor! nefunguje v IE9 a starsim - nepodporuje file DnD
        console.log($e, $e.originalEvent.dataTransfer);
        var
            dt = $e.originalEvent.dataTransfer,
            $this = $(this);

        $this.toggleClass("loading", true);

        handleUploadFiles(dt.files, false,
            function() { $this.toggleClass("loading", false); }
        );

        return false;
    };

    var onEditorDrop = function($e) {
        // drop do editoru
        console.log("onEditorDrop ...");
    };


    var onResize = function() {
        // TODO: dodelat
        //console.log("resajzuju ...");
        //tinyMCE.activeEditor.theme.resizeTo(640, 140);
    };


    // TESTY
    var zobrazTesty = function() {
        var $tbody = $("#seznamPripojenychTestu");

        $tbody.empty();

        for (var i = 0;  i < dataEditace.testy.length;  i++) {
            $("<tr/>")
                .attr("class", (i % 2) ? "browsercolor1" : "browsercolor2")
                .append( $("<td/>").text(dataEditace.testy[i].kod) )
                .append( $("<td/>").text(dataEditace.testy[i].popis) )
                .append( $("<td/>")
                    .append( $("<a/>")
                        .attr("href", "?menuid=testy&action=show&idrevize=" + dataEditace.revize + "&druhhodnoceni=" + dataEditace.testy[i].druhHodnoceni + "&temacislo=" + dataEditace.testy[i].temaCislo)
                        .text( ron.translate('Editovat'))
                        .attr("target", "_blank")) )
                .appendTo($tbody);
        }
    };

    zobrazTesty();

    var novyTestError = function(error) {
        $("#novyTestOK").removeAttr("disabled");
        ron.showError(error);
    };


    var novyTestOK = function() {
        $("#novyTestOK").attr("disabled", "disabled");

        var kod = $("#kodNovehoTestu").val();
        var popis = $("#popisNovehoTestu").val();

        if (kod == '') {
            novyTestError( ron.translate('Neni_zadan_kod_testu') );
            return false;
        }

        if (popis == '') {
            novyTestError( ron.translate('Neni_zadan_popis_testu') );
            return false;
        }


        $.ajax(
            {
                url: "?menuid=kurzy&action=newtest",
                type: "POST",
                data: {
                    idRevize: dataEditace.revize,
                    kod: kod,
                    popis: popis
                }
            })
            .done( function(data) {
                if (data.result == "OK") {
                    $("#novyTestDialog").dialog("close");

                    dataEditace.testy = data.testy;
                    zobrazTesty();
                } else {
                    novyTestError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri vytvareni noveho testu doslo k chybe!");
                novyTestError("Pri vytvareni noveho testu doslo k chybe!");
            });
    };

    var novyTestStorno = function() {
        $("#novyTestDialog").dialog ("close");
    };


    var novyTest = function() {
        $("#novyTestOK").removeAttr("disabled"); // pri predchozim pouziti byl disabled

        $("#novyTestDialog").dialog ({
            modal : true,
            resizable: true,
            width: "auto",
            height: "auto"
        });
    };


    $("#kurz_prilohy")
        .on("dblclick", "li", prilohaDblClick);

    // testy
    $("#pripojitNovyTest").on("click", novyTest);
    $("#novyTestOK").on("click", novyTestOK);
    $("#novyTestStorno").on("click", novyTestStorno);


    $("#btn_podrobnosti_strany_OK")
        .on("click", function() {
            savePageProperties(aktualniStrana);
        });

    // upload souboru do priloh
    $("#image_upload_form_input")
        .on("change", onUploadImageSelected);

    //$.event.props.push('dataTransfer'); // dnd - presunuto do javascripts.js

    //var $prilohy = $("#elearning_prilohy");
    //ron.dndTarget($prilohy);
    //$prilohy
    $("#elearning_prilohy")
        .dndTarget()
        .on("drop", onPrilohaDrop);

    // upload souboru do seznamu kapitol
    //var $osnova = $("#elearning_osnova");
    //ron.dndTarget($osnova);
    //$osnova
    $("#elearning_osnova")
        .dndTarget()
        .on("drop", onPageDrop);
        //.on("dragover", function() { return false; });

    $("#kurz_obsah")
        .on("drop", "mce-edit-area", onEditorDrop )
        //.tabs({
        //    heightStyle: "content"  // auto bohuzel nenastavi spravne vysku - ale mozna by pomohlo zavoleni .tabs("refresh")
        //})
    ;


    $( window)
        .on("resize", onResize);

    zobrazStranu(0);
};


///**
// * Image viewer item object
// * @param {string} src
// * @param {string} [type]
// * @constructor
// */
//ron.ImageFile = function(src, type) {
//    this.src = src;
//    this.type = type ? type : "image";
//};


///**
// * Image viewer options
// * @constructor
// */
//ron.ImageViewOptions = function() {
//    this.count = -1;
//
//    /** @type {function}  Funkce, ktera vraci obrazek - ron.ImageFile nebo string (src) */
//    this.getImage = null; // function(index), return src string
//    this.delete = null;   // function(index), return bool
//
//    this.actualImage = 0;
//
//    this.thumbnailsHeight = 100;
//
//    this.rootElement = null;
//};

///**
// * @param {ron.ImageViewOptions} options
// */
//ron.imageView = function(options) {
//    var
//        actualImage = (options && options.actualImage)
//            ? options.actualImage
//            : 0,
//
//        thumbnailsHeight = (options && options.thumbnailsHeight)
//            ? options.thumbnailsHeight
//            : 100,
//
//        $rootElement = (options  &&  options.rootElement)
//            ? options.rootElement
//            : null,
//
//        $thumbPanel, // panel s thumbnaily
//
//        thumbnails = []; // seznam divu
//
//    if (!$rootElement) {
//        $rootElement =
//            $("<div/>")
//                .attr("class", "fotoViewer")
//                .appendTo( $(document.body) );
//    }
//
//    $rootElement.empty();
//
//    var $fotoContainer = $("<div/>")
//        .attr("class", "fotoViewerContainer")
//        .appendTo($rootElement);
//
//
//    var showVideo = function(src) {
//        $("<video/>")
//            .attr("width", 640)
//            .attr("height", 480)
//            //.attr("type", "video/mp4")
//            .attr("controls", "controls")
//            .append(
//            $("<source/>")
//                .attr("src", src)
//            )
//            .appendTo($fotoContainer);
//    };
//
//
//    var showImage = function(src) {
//        //$("<div/>")
//        //    .attr("class", "fotoViewerImage")
//        $("<img/>")
//            .attr("src", src)
//            //.attr("class", "fotoViewerImage")
//            .appendTo($fotoContainer);
//    };
//
//    var showLink = function(src) {
//        $("<a/>")
//            .attr("href", src)
//            .attr("target", "_blank")
//            .text(src)
//            .appendTo($fotoContainer);
//    };
//
//
//    var showFile = function(index) {
//        $fotoContainer.empty();
//
//        var
//            image = options.getImage(index),
//            type = image.type ? image.type : "image",
//            src = image.src ? image.src : image; // image muze byt objekt ron.ImageFile nebo primo string
//
//        switch (type) {
//            case "video" :
//                showVideo(src);
//                break;
//
//            case "image" :
//                showImage(src);
//                break;
//
//            default :
//                showLink(src);
//                break;
//        }
//
//        actualImage = index;
//    };
//
//
//    var selectThumbnail = function(index) {
//        if (index >= 0  &&  index < thumbnails.length) {
//            if (actualImage >= 0) {
//                thumbnails[actualImage].toggleClass("selected", false);
//            }
//
//            thumbnails[index].toggleClass("selected", true);
//
//            // nascrolluje doprostred
//            var newPos = $thumbPanel.width() / 2 - thumbnails[index].width() / 2;
//            var newScroll = ( $thumbPanel.scrollLeft() + thumbnails[index].position().left - newPos );
//            if (newScroll < 0) newScroll = 0;
//            $thumbPanel.scrollLeft( newScroll );
//        } else {
//            console.log("selectThumbnail - spatny index: ", index);
//        }
//    };
//
//
//    var onThumbnailClick = function($e) {
//        var $thumbnail = $(this); // $(this);
//
//        selectThumbnail($thumbnail.data("ron-index"));
//        //$thumbnail.siblings().toggleClass("selected", false);
//        //$thumbnail.toggleClass("selected", true);
//
//        showFile( $thumbnail.data("ron-index") );
//    };
//
//
//    var close = function() {
//        $(document.body)
//            .off("keydown", onKeyDown);
//
//        $rootElement.remove();
//    };
//
//
//    /**
//     * Callback funkce volana po uspesnem smazani prilohy
//     * @param index
//     */
//    var afterDelete = function(index) {
//        thumbnails[index]
//            .data("ron-deleted", "1")
//            .empty()
//            .append(
//                $("<i/>")
//                    .addClass("fa inline-glyph glyph-delete")
//            );
//
//    };
//
//    var onKeyDown = function($e) {
//        //console.log("jmse v keydown");
//        switch ($e.which) {
//            case 27 :
//                close();
//                break;
//
//            case 37 :
//                // doleva
//                if (actualImage > 0) {
//                    selectThumbnail(actualImage - 1);
//                    showFile(actualImage - 1);
//                }
//                break;
//
//            case 39 :
//                // doprava
//                if (actualImage < options.count - 1) {
//                    selectThumbnail(actualImage + 1);
//                    showFile(actualImage + 1);
//                }
//                break;
//
//            case 46 :
//                if (options.delete) {
//                    options.delete(actualImage, afterDelete);
//                }
//                break;
//
//            default :
//                //console.log($e.which);
//        }
//    };
//
//
//    var thumbnailsDragStart = null;
//
//    var onThumbnailsMouseDown = function($e) {
//        if ($e.which == 1) {
//            var $this = $(this);
//            thumbnailsDragStart = $e.pageX - this.offsetLeft; // + $this.scrollLeft();
//            //console.log(this, $this.parent().scrollLeft());
//            //console.log('mouseDown', $e, $e.pageX - this.offsetLeft + $(this).scrollLeft());
//            return false;
//        } else {
//            thumbnailsDragStart = null;
//        }
//    };
//
//    var onThumbnailsMouseUp = function($e) {
//        thumbnailsDragStart = null;
//    };
//
//    var onThumbnailsDrag = function($e) {
//        if (thumbnailsDragStart  &&  $e.buttons == 1) {
//            var $this = $(this);
//            var newPos = $e.pageX - this.offsetLeft; // + $this.scrollLeft();
//            $this.scrollLeft( $this.scrollLeft() + thumbnailsDragStart - newPos );
//            thumbnailsDragStart = newPos;
//            //console.log($e);
//            return false;
//        } else if (thumbnailsDragStart) {
//            thumbnailsDragStart = null;
//        }
//    };
//
//
//    $(document.body)
//        .on("keydown", onKeyDown);
//
//    $thumbPanel =
//        $("<div/>")
//            .attr("class", "fotoViewerThumbnailsPanel")
//            .appendTo($rootElement)
//            .on("mousedown", onThumbnailsMouseDown)
//            .on("mouseup", onThumbnailsMouseUp)
//            .on("mousemove", onThumbnailsDrag)
//            //.on("click", ".fotoViewerThumbnail", onThumbnailClick)
//            ;
//
//    var $thumbnails =
//        $("<div/>")
//            .attr("class", "fotoViewerThumbnails")
//            .appendTo($thumbPanel)
//            .on("click", ".fotoViewerThumbnail", onThumbnailClick)
//            //.on("mousedown", onThumbnailsMouseDown)
//            //.on("mouseup", onThumbnailsMouseUp)
//            //.on("mousemove", onThumbnailsDrag)
//            ;
//
//
//    var showThumbnails = function() {
//        for (var i = 0;  i < options.count;  i ++) {
//            var $container =
//                $("<div/>")
//                    .attr("class", "fotoViewerThumbnail" + ( (i == actualImage) ? " selected" : "" ) )
//                    .data("ron-index", i)
//                    .appendTo($thumbnails);
//
//            var imageFile = options.getImage(i);
//            var src = imageFile.src ?  imageFile.src : imageFile;
//            var type = imageFile.type ? imageFile.type : "image";
//
//            switch (type) {
//                case "image" :
//                    $("<img/>")
//                        .attr("src", src)
//                        .appendTo($container);
//                    break;
//
//                case "video" :
//                    $("<i/>")
//                        .addClass("fa fa-3x glyph-video")
//                        .appendTo($container);
//                    break;
//
//                default :
//                    $("<span/>")
//                        .text("...")
//                        .appendTo($container);
//            }
//
//            thumbnails[thumbnails.length] = $container;
//        }
//    };
//
//    showFile(actualImage);
//    showThumbnails();
//};


$(function() {
    // smazani prilohy
    var onDeletePriloha = function($e, afterDeleteCallback) {
        var
            idPrilohy = $($e.target).data("ron-id"),
            idRevize = $($e.delegateTarget).data("id-revize");

        console.log("delete-media", idPrilohy, idRevize);

        if (!confirm( ron.translate('Opravdu_smazat_prilohu'))) {
            return false;
        }

        $.ajax('?menuid=kurzy&action=deletepriloha&id=' + idPrilohy + '&revize=' + idRevize)
            .done( function(data) {
                if (data.result == "OK") {
                    //console.log("Odstraneni prilohy probehlo uspesne ...");
                    if (afterDeleteCallback) {
                        afterDeleteCallback();
                    }
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri odstranovani prilohy doslo k chybe!");
            });

        return true;
    };

    $("#kurz_prilohy")
        .on("delete-media", ".media-item", onDeletePriloha);
});

ronPortal.elearning.prezentace = function() {

    // TODO: Pouzit slidy2? http://www.w3.org/Talks/Tools/Slidy2/Overview.html

    var screenSize = ron.utils.windowSize();

    Reveal.initialize({
        width: screenSize.x * 0.9,
        height: screenSize.y * 0.9,
        margin: 0.05,

        // Display controls in the bottom right corner
        controls: true,

        // Display a presentation progress bar
        progress: true,

        // Display the page number of the current slide
        slideNumber: true,

        // Push each slide change to the browser history
        history: false,

        // Enable keyboard shortcuts for navigation
        keyboard: true,

        // Enable the slide overview mode
        overview: true,

        // Vertical centering of slides
        center: false,

        // Enables touch navigation on devices with touch input
        touch: true,

        // Loop the presentation
        loop: false,

        // Change the presentation direction to be RTL
        rtl: false,

        // Turns fragments on and off globally
        fragments: true,

        // Flags if the presentation is running in an embedded mode,
        // i.e. contained within a limited portion of the screen
        embedded: false,

        // Flags if we should show a help overlay when the questionmark
        // key is pressed
        help: true,

        // Number of milliseconds between automatically proceeding to the
        // next slide, disabled when set to 0, this value can be overwritten
        // by using a data-autoslide attribute on your slides
        autoSlide: 0,

        // Stop auto-sliding after user input
        autoSlideStoppable: true,

        // Enable slide navigation via mouse wheel
        mouseWheel: false,

        // Hides the address bar on mobile devices
        hideAddressBar: true,

        // Opens links in an iframe preview overlay
        previewLinks: false,

        // Transition style
        transition: 'default', // none/fade/slide/convex/concave/zoom

        // Transition speed
        transitionSpeed: 'default', // default/fast/slow

        // Transition style for full page slide backgrounds
        backgroundTransition: 'default', // none/fade/slide/convex/concave/zoom

        // Number of slides away from the current that are visible
        viewDistance: 3,

        // Parallax background image
        parallaxBackgroundImage: '', // e.g. "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'"
        //parallaxBackgroundImage: '?menuid=kurzy&action=download&priloha=4',

        // Parallax background size
        parallaxBackgroundSize: '', // CSS syntax, e.g. "2100px 900px"
        //parallaxBackgroundSize: '3100px 900px',

        // Amount to move parallax background (horizontal and vertical) on slide change
        // Number, e.g. 100
        parallaxBackgroundHorizontal: '',
        parallaxBackgroundVertical: ''
    });
};

