/**
* (c) RON Software spol. s r.o.
* stanislav.elbl, 15.12.2015.
*/

function prezentace(testData) {
    console.log('Inicializace prezentace ...', testData);

    var zobrazAbsolvovanoInfo = function() {
        $("#testAbsolvovanBack").css("display", "block");
        $("#testAbsolvovanInfo").css("display", "block");
    };

    var skryjAbsolvovanoInfo = function() {
        $("#testAbsolvovanBack").hide();
        $("#testAbsolvovanInfo").hide();
    };


    if (testData  && testData.casDo) {
        // odpocet zbyvajiciho casu
        var casDo = ron.utils.stringToDateTime(testData.casDo);

        var infoZobrazeno = false;

        var showRemainingTime = function() {
            var remain = Math.floor( (casDo - new Date()) / 1000 );
            if (remain < 0 ) {
                remain = 0;
                if (!infoZobrazeno) {
                    // zobrazi hlasku "test nebyl odeslan v limitu"
                    infoZobrazeno = true;
                    zobrazAbsolvovanoInfo();
                }
            }

            $("#testZbyvajiciCas").text( ron.utils.secondsToString(remain) );
        };

        var showTimeTimer = function() {
            showRemainingTime();
            setTimeout(showTimeTimer, 250);
        };

        showTimeTimer();
    }


    var loadAsset = function(callback) {
        console.log('loadAsset: ', this);
        var kod = $(this).data("ron-code");

        if (kod) {
            $.ajax("?menuid=prezentace&asset=" + kod)
                .done( function(data) {
                    if (data.result == "OK") {
                        if (data.text) callback(data.text);
                    } else {
                        console.log("Chyba pri nacitani assetu: ", data.error);
                    }
                });
        }
    };

    var onKeyPress = function($e) {
        //.on("click", "#linkNextPage", nextPage)
        //    .on("click", "#linkPrevPage", nextPage)

        if (testData  &&  testData.editace) return; // pokud je zobrazen test, tak sipky nefunguji

        var newHRef = null;

        switch ($e.which) {
            case 39 :
                // doprava
                newHRef = $("#linkNextPage").attr("href"); // click();
                break;

            case 37 :
                // doleva
                newHRef = $("#linkPrevPage").attr("href"); // click();
                break;
        }

        if (newHRef) {
            window.location.href = newHRef;
        }
    };


    var onScroll = function($e) {
        // zobrazi "plovouci" ovladaci prvky, pokud je odskrolovano
        var showFloatingControls = $("#controls").offset().top < (document.documentElement.scrollTop || document.body.scrollTop);

        $("#floatcontrolspanel").css("display", showFloatingControls ? "block" : "none");
    };

    var onResize = function() {
        // nastaveni polohy ovladacich prvku
        $("#floatcontrols").css("left", $("#controls").offset().left);
    };

    onResize();

    $("body")
        .tooltip({
            items: ".asset",
            content: loadAsset
        })
        .on("keydown", onKeyPress);

    $(window)
        .on("scroll", onScroll)
        .on("resize", onResize);

    console.log('Start prezentace ...');


    $("#testAbsolvovanBack")
        .on("click", skryjAbsolvovanoInfo);

    $("#testAbsolvovanInfo")
        .on("click", skryjAbsolvovanoInfo);


    var onCloseClick = function() {
        window.close();
    };

    $("a[href='#close']").on("click", onCloseClick);
}
