/**
 * stanislav.elbl, 14.12.2015.
 * Editace testu
 */

ronPortal.elearning.Otazka = function() {
    this.kodKriteria = '';
    this.poradi = 0;
    this.typRozsahu = '';
    this.popis = '';
    this.upresnujiciPopis = '';
    this.upresnujiciPopisProWeb = '';

    this.zpusobHodnoceni = 0;  // z tabulky ZpusobHodnoceni podle pole typRozsahu
    this.bodovaVaha = 0;
    this.povinnaOdpoved = 0;

    /**
     * @type {Array.<ronPortal.elearning.VolbaTestu>}
     */
    this.volby = [];

    this.spravnaHodnota = 0;
    this.spravnaSlovniOdpoved = '';

    this.vycetSpravnychOdpovedi = [];

    this.nova = false;      // priznak, ze se jedna o novou (jeste neulozenou) otazku

    // doplneno dodatecne
    this.$menuItem = null;  // odkaz na polozku v seznamu stranek
};


ronPortal.elearning.Test = function() {
    this.druhHodnoceni = 0;
    this.temaCislo = 0;

    this.test = 1; // 0=hodnoceni, 1=test
    /**
     * @type {Array.<ronPortal.elearning.Otazka>}
     */
    this.otazky = [];
};

ronPortal.elearning.TestEKurzu = function() {
    this.idRevize = 0;
    this.pocetPokusu = null;
    this.casovyLimit = null;
};

ronPortal.elearning.VolbaTestu = function() {
    this.hodnota = 0;
    this.popis = '';
    this.doplnujiciPopis = '';
    this.koeficient = 0.0;
    this.smazana = 0;
};

ronPortal.elearning.TypOdpovedi = function() {
    this.kod = '';
    this.popis = '';
    this.zpusobHodnoceni = 0;

    this.popisNejnizsiHodnoty = ''; // pro ZPUSOB_ODPOVEDI_STUPNICE
    this.popisNejvyssiHodnoty = '';

    this.zpusobZobrazeni = 0; // 0=pod sebou, 1=vedle sebe
    /**
     * @type {Array.<ronPortal.elearning.VolbaTestu>}
     */
    this.volby = [];
};


ronPortal.elearning.DataTestu = function() {
    /** @type {ronPortal.elearning.Test} */
    this.test = null;
    /** @type {Array.<ronPortal.elearning.TypOdpovedi>} */
    this.typyOdpovedi = null;
    /** @type {ronPortal.elearning.TestEKurzu} */
    this.testEKurzu = null;
    /** @type {Array.<ronPortal.elearning.PrilohaKurzu>} */
    this.prilohy = null;
};


/**
 * @param {ronPortal.elearning.DataTestu} dataEditace
 */
ronPortal.elearning.initEditaceTestu = function(dataEditace) {

    var
        aktualniOtazka = -1,
        /** @var {jQuery}   Nastaveni velikosti jednotlivych panelu */
        $nadpis = $("#elearning_nadpis"),
        top = $nadpis.offset().top + $nadpis.outerHeight();

    $("#elearning_container")
        .css("top", top);


    /**
     * Prida na konec seznamu zalozku pro zadanou otazku
     * @param {int} index
     * @return {jQuery}    Vraci jQuery objekt pro novou polozku (li)
     */
    var pridejZalozku = function(index) {
        var otazka = dataEditace.test.otazky[index];

        otazka.$menuItem = $("<li/>")
            .text(otazka.poradi + '. ' + otazka.kodKriteria)
            .data("ron-poradi", otazka.poradi)
            .data("ron-kod", otazka.kodKriteria)
            .data("ron-index", index)
            .appendTo("#test_obsah_list");

        return otazka.$menuItem;
    };


    /**
     * Zobrazi zalozky pro vsechny strany
     * @param {Array.<ronPortal.elearning.Otazka>} otazky
     */
    var zobrazZalozky = function(otazky) {
        $("#test_obsah_list").empty();

        for (var i = 0;  i < otazky.length;  i++) {
            pridejZalozku(i);
        }
    };


    /* * @ type {ron.RonTabs}  */
    //var tabs = ron.ronTabs( $("#elearning_tabs"), { initialTab: "test_otazka" });
    $("#elearning_tabs").rontabs({ initialTab: "test_otazka"});

    zobrazZalozky(dataEditace.test.otazky);

    ronPortal.elearning.zobrazPrilohy(dataEditace.prilohy, dataEditace.testEKurzu.idRevize);

    var nactiTypyOdpovedi = function() {
        var $select = $("#typRozsahu");
        $select.empty();

        for (var i = 0;  i < dataEditace.typyOdpovedi.length;  i++) {
            $("<option/>")
                .val(dataEditace.typyOdpovedi[i].kod)
                .text(dataEditace.typyOdpovedi[i].popis)
                .appendTo($select);
        }

    };

    nactiTypyOdpovedi();

    var vratTypOdpovedi = function(kod) {
        for (var i = 0;  i < dataEditace.typyOdpovedi.length;  i++) {
            if (dataEditace.typyOdpovedi[i].kod == kod) {
                return dataEditace.typyOdpovedi[i];
            }
        }

        return null;
    };


    /**
     *
     * @param {ronPortal.elearning.VolbaTestu[]} volby
     * @param index
     * @param {bool} readOnly
     * @param {bool} povolitViceOdpovedi
     * @param checked
     */
    var zobrazVolbu = function(volby, index, readOnly, povolitViceOdpovedi, checked) {
        if (volby[index].smazana) return;

        var $checkInput = $("<input/>")
            .attr("id", "volba_" + index); // volby[index].hodnota);

        if (povolitViceOdpovedi) {
            $checkInput
                .attr("type", "checkbox");
        } else {
            $checkInput
                .attr("type", "radio")
                .attr("name", "spravnaHodnota");
        }

        if (checked) {
            $checkInput
                .attr("checked", "checked");
        }

        var $text =
            $("<textarea/>")
                .addClass("form-input priloha-target")
                .attr("id", "textOdpovedi_" + index)
                .val(volby[index].popis);

        var $hodnota = null;
        if (!readOnly) $hodnota =
            $("<input/>")
                .addClass("form-input")
                .attr("id", "hodnotaOdpovedi_" + index)
                .val(volby[index].hodnota);

        var $koeficient = null;
        if (!readOnly) $koeficient =
            $("<input/>")
                .addClass("form-input")
                .attr("id", "koeficientOdpovedi_" + index)
                .val(volby[index].koeficient);

        if (readOnly) {
            $text.attr("disabled", "disabled");
        }

        var $row = $("<div/>")
            .addClass("row")
            .attr("id", "radekOdpovedi_" + index)
            .append(
                $("<div/>")
                    .attr("class", "col-2 caption")
                    .append( $checkInput )
            )
            .append(
                $("<div/>")
                    .addClass("col-7 padding-right")
                    .append( $text )
            )
            .appendTo( $("#vycetOdpovedi") );

        // hodnota
        var $td = $("<div/>").addClass("col-1 padding-right").appendTo($row);
        if ($hodnota) $td.append($hodnota);

        // koeficient
        $td = $("<div/>").addClass("col-1 padding-right").appendTo($row);
        if ($koeficient) $td.append($koeficient);

        $td = $("<div/>").addClass("col-1").appendTo( $row );

        if (!readOnly) {
            $("<i/>")
                .addClass("deleteRow")
                .addClass("fa inline-glyph glyph-button glyph-delete")
                .data("ron-index", index)
                .appendTo($td);
        }
    };


    /**
     * Zobrazi vycet existujicich odpovedi
     * @param {ronPortal.elearning.VolbaTestu[]} volby
     * @param {bool} readOnly
     * @param {bool} povolitViceOdpovedi
     * @param {int[]} spravneOdpovedi
     */
    var zobrazVycetOdpovedi = function(volby, readOnly, povolitViceOdpovedi, spravneOdpovedi) {
        var $tbody = $("#vycetOdpovedi");

        $tbody.empty();
        for (var i = 0;  i < volby.length;  i++ ) {
            zobrazVolbu(volby, i, readOnly, povolitViceOdpovedi, ron.inArray(volby[i].hodnota, spravneOdpovedi));
        }

        $("#vycetOdpovediHeader").css("display", "block");
        $tbody.css("display", "block");
        if (!readOnly) {
            $("#tlacitkaOdpovedi").css("display", "block");
        }
    };


    /**
     * Spusteno pri kliknuti na link "pridat_odpoved"
     */
    var pridejVolbu = function() {
        if (aktualniOtazka < 0  ||  aktualniOtazka >= dataEditace.test.otazky.length) {
            return;
        }

        var otazka = dataEditace.test.otazky[aktualniOtazka];
        if (otazka.zpusobHodnoceni != 5  &&  otazka.zpusobHodnoceni != 6) {
            // otazka nema vlastni volby => nelze pridat
            return;
        }

        var novaHodnota = 1;
        for (var i = 0;  i < otazka.volby.length;  i++) {
            if (!otazka.volby[i].smazana  &&  novaHodnota <= otazka.volby[i].hodnota) {
                novaHodnota = otazka.volby[i].hodnota + 1;
            }
        }

        //noinspection JSValidateTypes
        otazka.volby[otazka.volby.length] = {
            hodnota : novaHodnota,
            popis : '',
            doplnujiciPopis : '',
            koeficient : 0.0
        };

        zobrazVolbu(otazka.volby, otazka.volby.length - 1, false, otazka.zpusobHodnoceni == 6, false);
    };


    var odstranVolbu = function() {
        var $this = $(this);

        ron.confirm(
            ron.translate('Opravdu_smazat_volbu'),
            function() {
                var index = $this.data('ron-index');

                dataEditace.test.otazky[aktualniOtazka].volby[index].smazana = 1;
                $("#radekOdpovedi_" + index).toggleClass("deleted", true);
            }
        );

    };


    /**
     * Zobrazi vycet preddefinovanych odpovedi (tj. z tabulky RozsahHodnoceni)
     * @param {ronPortal.elearning.Otazka} otazka
     */
    var zobrazVycetPreddefinovanychOdpovedi = function(otazka) {
        var typOdpovedi = vratTypOdpovedi(otazka.typRozsahu);
        if (!typOdpovedi) return;

        zobrazVycetOdpovedi(typOdpovedi.volby, true, otazka.zpusobHodnoceni == 1, (otazka.zpusobHodnoceni == 1) ? otazka.vycetSpravnychOdpovedi : [otazka.spravnaHodnota]);
    };


    /**
     * Zobrazi editaci textove odpovedi (hodnota, vlastni text, datum)
     * @param {ronPortal.elearning.Otazka} otazka
     * @param {string} hodnota
     */
    var zobrazEditaciSpravneOdpovedi = function(otazka, hodnota) {
        console.log(otazka);
        var $tbody = $("#spravnaHodnotaBody");
        $("#spravnaHodnota").val( hodnota );

        $tbody.css("display", "block");
    };

    var zobrazEditaciMemoOdpovedi = function(otazka) {
        // neni v databazi ulozena! (nema smysl, nelze strojove porovnat)
        //var $tbody = $("#spravnaMemoHodnotaBody");
        //
        //$tbody.css("display", "table-row-group");
    };

    /**
     * Podle zpusobu hodnoceni zobrazi prislusnou editaci odpovedi (zadani spravne hodnoty, editace voleb a podobne)
     * @param {ronPortal.elearning.Otazka} otazka
     */
    var zobrazOdpoved = function(otazka) {
        $("#editace_otazky").children(".spravneOdpovedi").css("display", "none");
        //const ZPUSOB_ODPOVEDI_VYBER1_DEF = 0; // vyber z preddefinovanych hodnot
        //const ZPUSOB_ODPOVEDI_VYBER_VICE_DEF = 1;
        //const ZPUSOB_ODPOVEDI_VLASTNI = 2;
        //const ZPUSOB_ODPOVEDI_STUPNICE = 3;   // (min-max)
        //const ZPUSOB_ODPOVEDI_HODNOTA = 4;
        //const ZPUSOB_ODPOVEDI_VYBER1 = 5;     // otazka ma vlastni odpovedi
        //const ZPUSOB_ODPOVEDI_VYBER_VICE = 6;
        //const ZPUSOB_ODPOVEDI_VLASTNI_MEMO = 7;
        //const ZPUSOB_ODPOVEDI_DATUM = 8;
        switch (otazka.zpusobHodnoceni) {
            case 0 :
            case 1 :
                // otazka pouziva preddefinovane volby - napr. Ano/Ne
                zobrazVycetPreddefinovanychOdpovedi(otazka);
                break;

            case 5 :
            case 6 :
                // otazka ma zadane vlastni volby
                zobrazVycetOdpovedi(otazka.volby, false, otazka.zpusobHodnoceni == 6, (otazka.zpusobHodnoceni == 6) ? otazka.vycetSpravnychOdpovedi : [otazka.spravnaHodnota] );
                break;

            case 2 : // text
                zobrazEditaciSpravneOdpovedi(otazka, otazka.spravnaSlovniOdpoved);
                break;
            case 4 : // hodnota
                zobrazEditaciSpravneOdpovedi(otazka, otazka.spravnaHodnota);
                break;
            case 8 : // datum
                zobrazEditaciSpravneOdpovedi(otazka, "NENI IMPLEMENTOVANO!");
                break;

            case 7 : // memo
                zobrazEditaciMemoOdpovedi(otazka);
                break;
        }
    };


    var typRozsahuChange = function() {
        if (aktualniOtazka >= 0) {
            dataEditace.test.otazky[aktualniOtazka].typRozsahu = $("#typRozsahu").val();

            var typOdpovedi = vratTypOdpovedi( dataEditace.test.otazky[aktualniOtazka].typRozsahu );
            if (!typOdpovedi) return;

            dataEditace.test.otazky[aktualniOtazka].zpusobHodnoceni = typOdpovedi.zpusobHodnoceni;
            zobrazOdpoved(dataEditace.test.otazky[aktualniOtazka]);
        }
    };


    var vratVybranouOdpoved = function(volby) {
        for (var i = 0;  i < volby.length;  i++ ) {
            var $checkInput = $("#volba_" + i);
            if ($checkInput.prop("checked")) return volby[i].hodnota;
        }

        return null;
    };


    var vratVybranouPreddefinovanouOdpoved = function(otazka) {
        console.log('vratVybranouPreddefinovanouOdpoved');
        var typOdpovedi = vratTypOdpovedi(otazka.typRozsahu);
        if (!typOdpovedi) return;

        return vratVybranouOdpoved(typOdpovedi.volby);
    };


    var vratVybraneOdpovedi = function(volby) {
        var result = [];

        for (var i = 0;  i < volby.length;  i++ ) {
            var $checkInput = $("#volba_" + i);
            if ($checkInput.prop("checked")) {
                result[result.length] = volby[i].hodnota;
            }
        }

        return result;
    };

    var zapisVybraneOdpovedi = function(data, odpovedi) {
        for (var i = 0;  i < odpovedi.length;  i++ ) {
            data["vybranaVolba" + i] = odpovedi[i];
        }

        data["pocetVybranych"] = odpovedi.length;
    };

    /**
     * Do datoveho objektu pro POST zapise odpovedi - podle zpusobu hodnoceni
     * @param index
     * @param data
     */
    var zapisSpravneOdpovedi = function(index, data) {
        var otazka = dataEditace.test.otazky[index];

        switch (otazka.zpusobHodnoceni) {
            case 0 :
                otazka.spravnaHodnota = vratVybranouPreddefinovanouOdpoved(otazka);
                data["spravnaHodnota"] = otazka.spravnaHodnota;
                break;
            //case 1 :
            //    // otazka pouziva preddefinovane volby - napr. Ano/Ne
            //    zobrazVycetPreddefinovanychOdpovedi(otazka);
            //    break;
            //
            case 5 :
                otazka.spravnaHodnota = vratVybranouOdpoved(otazka.volby);
                data["spravnaHodnota"] = otazka.spravnaHodnota;
                break;

            case 6 :
                // otazka ma zadane vlastni volby, lze zaskrtnout vice
                otazka.vycetSpravnychOdpovedi = vratVybraneOdpovedi(otazka.volby);
                zapisVybraneOdpovedi(data, otazka.vycetSpravnychOdpovedi);
                break;

            case 4 : // hodnota
                otazka.spravnaHodnota = $("#spravnaHodnota").val();
                data["spravnaHodnota"] = otazka.spravnaHodnota;
                break;

            case 2 : // text
            case 8 : // datum
                otazka.spravnaSlovniOdpoved = $("#spravnaHodnota").val();
                data["spravnaHodnota"] = otazka.spravnaSlovniOdpoved;
                break;

            case 7 : // memo
                //data["spravnaMemoHodnota"] = $("#spravnaMemoHodnota").val();
                break;
        }
    };


    /**
     * @param {ronPortal.elearning.Otazka} otazka
     * @param data
     */
    var zapisOdpovedi = function(otazka, data) {
        if (otazka.zpusobHodnoceni != 5  &&  otazka.zpusobHodnoceni != 6) {
            return;
        }

        for (var i = 0;  i < otazka.volby.length;  i++ ) {
            if (otazka.volby[i].smazana) {
                data["volbaSmazana" + i] = 1;
            } else {
                // text
                otazka.volby[i].popis = $("#textOdpovedi_" + i).val();
                data["popisOdpovedi" + i] = otazka.volby[i].popis;
                // hodnota
                otazka.volby[i].hodnota = parseInt( $("#hodnotaOdpovedi_" + i).val() );
                data["hodnotaOdpovedi" + i] = otazka.volby[i].hodnota;
                // koeficient
                otazka.volby[i].koeficient = ron.utils.stringToFloat( $("#koeficientOdpovedi_" + i).val() );
                data["koeficientOdpovedi" + i] = otazka.volby[i].koeficient;
            }
        }

        data["pocetOdpovedi"] = otazka.volby.length;
    };


    /**
     * Odeslani editovane otazky
     * @param {number} index
     * @param {function} [callback]
     */
    var ulozOtazku = function(index, callback) {
        ron.showWorkingInfo( ron._('Probiha_ukladani_dat'));

        var kodKriteriaOriginal = dataEditace.test.otazky[index].kodKriteria;

        var requestData = {
            druhHodnoceni : dataEditace.test.druhHodnoceni,
            temaCislo : dataEditace.test.temaCislo,
            kodKriteriaOriginal : kodKriteriaOriginal,
            kodKriteria : $("#kodOtazky").val(),
            popis : $("#popisOtazky").val(),
            upresnujiciPopis : $("#upresnujiciPopis").val(),
            bodovaVaha : $("#bodovaVaha").val(),
            povinnaOdpoved : $("#povinnaOdpoved").prop("checked") ? 1 : 0,
            typRozsahu : $("#typRozsahu").val()
        };

        zapisOdpovedi(dataEditace.test.otazky[index], requestData);
        zapisSpravneOdpovedi(index, requestData); // nejdrive musi byt zapsany seznam odpovedi!

        $.ajax( {
            url: '?menuid=testy&action=updateotazka',
            type: "POST",
            data: requestData
        })
            .done( function(resultData) {
                if (resultData.result == "OK") {
                    var otazka = dataEditace.test.otazky[index];

                    otazka.kodKriteria = requestData.kodKriteria;
                    otazka.popis = requestData.popis;
                    otazka.upresnujiciPopis = requestData.upresnujiciPopis;
                    otazka.bodovaVaha = requestData.bodovaVaha;
                    otazka.povinnaOdpoved = requestData.povinnaOdpoved;
                    otazka.typRozsahu = requestData.typRozsahu;
                    otazka.nova = false;

                    if (otazka.$menuItem) otazka.$menuItem.text(otazka.poradi + '. ' + otazka.kodKriteria)

                    // TODO: doplnit zpusob hodnoceni!
                    ron.hideWorkingInfo();

                    if (callback) callback();
                } else {
                    ron.hideWorkingInfo();

                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
                ron.hideWorkingInfo();
                ron.logAjaxError(jqXHR, "Pri ukladani otazky doslo k chybe!");
            });
    };


    /**
     * @param {function} [callback]
     */
    var ulozAktualniOtazku = function(callback) {
        if (aktualniOtazka >= 0  &&  aktualniOtazka < dataEditace.test.otazky.length) {
            ulozOtazku(aktualniOtazka, callback);
        } else {
            if (callback) callback();
        }
    };


    /**
     *
     * @param {int} index
     * @param {string} [tabId]
     */
    var zobrazOtazku = function(index, tabId) {
        if (index < 0  ||  index >= dataEditace.test.otazky.length) {
            return;
        }

        aktualniOtazka = index;

        var otazka = dataEditace.test.otazky[index];

        var $kod = $("#kodOtazky")
            .val(otazka.kodKriteria);

        var $popis = $("#popisOtazky")
            .val(otazka.popis);

        $("#upresnujiciPopis").val(otazka.upresnujiciPopis);
        $("#bodovaVaha").val(otazka.bodovaVaha);
        $("#povinnaOdpoved").prop("checked", !!otazka.povinnaOdpoved);

        $("#typRozsahu")
            .val(otazka.typRozsahu);

        zobrazOdpoved(otazka);

        var $tabs = $("#elearning_tabs");

        if (tabId) {
            $tabs.rontabs("selectPage", tabId);
        } else {
            // prepnout na zalozku s obsahem otazky
            if (!$tabs.rontabs("getSelectedPageId")  ||  $tabs.rontabs("getSelectedPageId") != "test_otazka") {
                $tabs.rontabs("selectPage", "test_otazka");
            }
        }

        if ($tabs.rontabs("getSelectedPageId") == "test_otazka") {
            $kod.focus();
        }
        //if (editor ) {
        //    editor.load(); // nacte obsah z textarea
        //
        //    updateDirty();
        //}
    };


    /**
     * @param {jQuery} $li
     * @param {string} [tabId]
     */
    var zobrazZalozku = function($li, tabId) {
        ulozAktualniOtazku(
            // callback - volana po ulozeni
            function() {
                $("#test_obsah_list")
                    .children().toggleClass("selected", false);

                $li
                    .toggleClass("selected", true);

                zobrazOtazku( $li.data("ron-index") );
            }
        );
    };


    var otazkaCancel = function() {
        if (!ron.confirm( ron._('Opravdu_zahodit_zmeny'))) {
            return;
        }

        if (aktualniOtazka < 0  ||  aktualniOtazka >= dataEditace.test.otazky.length) {
            return;
        }

        if (dataEditace.test.otazky[aktualniOtazka].nova) {
            dataEditace.test.otazky[dataEditace.test.otazky.length - 1].$menuItem.remove();
            dataEditace.test.otazky.splice(dataEditace.test.otazky.length - 1, 1);
            zobrazOtazku(dataEditace.test.otazky.length - 1);
        } else {
            zobrazOtazku(aktualniOtazka);
        }
    };


    var seznamOtazekClick = function() {
        zobrazZalozku( $(this) );
    };


    var odstranOtazku = function(index) {
        var otazka = dataEditace.test.otazky[index].$menuItem.remove();

        // odstrani stranku ze seznamu
        dataEditace.test.otazky.splice(index, 1);
        if (aktualniOtazka == index) {
            aktualniOtazka = -1;
        }
    };

    var smazatOtazku = function($li) {
        var index = $li.data("ron-index");
        var otazka = dataEditace.test.otazky[index];

        if ( !ron.confirm( ron._('Opravdu_odstranit_otazku') + ' ' + otazka.kodKriteria + '?') ) return;

        $.ajax(
            {
                url: "?menuid=testy&action=deletequestion",
                type: "POST",
                data: {
                    druhHodnoceni : dataEditace.test.druhHodnoceni,
                    temaCislo : dataEditace.test.temaCislo,
                    kodKriteria: otazka.kodKriteria
                }
            })
            .done( function(data) {
                if (data.result == "OK") {
                    // odstraneno
                    odstranOtazku(index);
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri mazani otazky doslo k chybe!");
            });
    };


    var otazkaMenuClick = function(e, data) {
        var akce = $(this).data("ron-akce");

        switch (akce) {
            case "editovat" :
                zobrazZalozku($(data));
                break;

            case "odstranit" :
                smazatOtazku( $(data) );
                break;
        }
    };

    var seznamOtazekMouseUp = function(e) {
        if (e.which == 3) {
            $("#test_otazky_menu").ronPopupMenu({
                attachToElement : $(this),
                onClick : otazkaMenuClick,
                data: this // polozka seznamu, pro kterou je popup menu zobrazeno
            });

            return false;
        }
    };


    var novaOtazka = function() {
        var otazka = new ronPortal.elearning.Otazka();
        otazka.nova = true;
        otazka.poradi = dataEditace.test.otazky.length ? dataEditace.test.otazky[dataEditace.test.otazky.length - 1].poradi + 1 : 1;
        dataEditace.test.otazky[dataEditace.test.otazky.length] = otazka;

        var $listItem = pridejZalozku(dataEditace.test.otazky.length - 1);

        zobrazZalozku($listItem, "test_otazka");

        $.ajax("?menuid=testy&action=novykodotazky&druhhodnoceni=" + dataEditace.test.druhHodnoceni + "&temacislo=" + dataEditace.test.temaCislo)
            .done( function(resultData) {
                if (resultData.result == "OK") {
                    $("#kodOtazky").val( resultData.kodKriteria );
                }
            });


        //if (!tabs.getSelectedPageId()  ||  tabs.getSelectedPageId() != "test_otazka") {
        //    tabs.selectPage("test_otazka");
        //}

    };


    var ulozHlavickuTestu = function()
    {
        ron.showWorkingInfo( ron._('Probiha_ukladani_dat'));

        $.ajax( {
            url: '?menuid=testy&action=updatetest',
            type: "POST",
            data: {
                druhHodnoceni : dataEditace.test.druhHodnoceni,
                temaCislo : dataEditace.test.temaCislo,
                idRevize : dataEditace.testEKurzu ? dataEditace.testEKurzu.idRevize : null,
                kod: $("#kodTestu").val(),
                popis: $("#popisTestu").val(),
                poznamka: $("#poznamkaTestu").val(),
                minPocetBodu: $("#minPocetBodu").val(),
                maxPocetBodu: $("#maxPocetBodu").val(),
                //stejnaVaha: $("#stejnaVaha").prop("checked") ? 1 : 0,
                pocetPokusu : $("#pocetPokusu").val(),
                casovyLimit : $("#casovyLimit").val(),
                sirkaSloupce: $("#sirkaSloupce").val(),
                editovatPoznamku: $("#editovatPoznamku").prop("checked") ? 1 : 0,
                zobrazitOdpovediUspesne : $("#zobrazitOdpovediUspesne").val(),
                zobrazitOdpovediNeuspesne : $("#zobrazitOdpovediNeuspesne").val()
            }
        })
            .done( function(resultData) {
                ron.hideWorkingInfo();

                if (resultData.result == "OK") {

                } else {
                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
                ron.hideWorkingInfo();
                ron.logAjaxError(jqXHR, "Pri ukladani hlavicky testu doslo k chybe!");
            });

        return false;
    };


    // Hromadny import otazek
    var vlozitHromadneClick = function() {
        $("#importOtazek").dialog({
            modal : true,
            resizable: true,
            width: "auto",
            height: "auto"
        });
    };


    var zobrazNahledImportovanychOtazek = function(otazky) {
        //$("#nahledImportuOtazek").text(counter);

        var $nahled = $("#nahledImportuOtazek");
        $nahled.empty();

        for (var i = 0;  i < otazky.length;  i++) {
            console.log(otazky[i]);
            $("<div/>")
                .text(otazky[i].popis)
                .appendTo($nahled);

            var $ul = $("<ul/>")
                .appendTo($nahled);

            for (var k = 0;  k < otazky[i].volby.length;  k++) {
                $("<li/>")
                    .text(otazky[i].volby[k].popis)
                    .appendTo($ul);
            }
        }
    };

    var $request = null;
    var nahledImportuOtazek = function() {
        if ($request) {
            $request.abort();
        }

        $request = $.ajax( {
            url: '?menuid=testy&action=testimport',
            type: "POST",
            data: {
                text: $("#importOtazekText").val()
            }
        })
            .done( function(resultData) {
                $request = null;

                if (resultData.result == "OK") {
                    zobrazNahledImportovanychOtazek(resultData.otazky);
                } else {
                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
                $request = null;
                ron.logAjaxError(jqXHR, "Pri odesilani otazek doslo k chybe!");
            });
    };

    var textImportuTimer = null;

    var textImportuChange = function() {
        if (textImportuTimer) {
            clearTimeout(textImportuTimer);
        }

        textImportuTimer = setTimeout(nahledImportuOtazek, 2000);
    };



    var doplnImportovaneOtazky = function(otazky) {
        console.log('Naimportovane otazky: ', otazky);

        for (var i = 0;  i < otazky.length;  i++) {
            dataEditace.test.otazky[dataEditace.test.otazky.length] = otazky[i];
            pridejZalozku(dataEditace.test.otazky.length - 1);
        }

    };

    var provedImportOtazek = function() {
        ron.showWorkingInfo( ron.translate("Importuji_otazky") );

        $.ajax( {
            url: '?menuid=testy&action=importotazek',
            type: "POST",
            data: {
                druhHodnoceni : dataEditace.test.druhHodnoceni,
                temaCislo : dataEditace.test.temaCislo,
                text: $("#importOtazekText").val()
            }
        })
            .done( function(resultData) {
                ron.hideWorkingInfo();

                if (resultData.result == "OK") {
                    $("#importOtazek").dialog("close");
                    $("#importOtazekText").val("");
                    doplnImportovaneOtazky(resultData.otazky);
                } else {
                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
                ron.hideWorkingInfo();

                $request = null;
                ron.logAjaxError(jqXHR, "Pri odesilani otazek doslo k chybe!");
            });

    };

    $("#nahledImportuOtazek")
        .on("dblclick", function() { $("#importOtazekText").val("Ano?\nAno\nNe\nAsi\n\nJak to jde?\nJde to\nUjde to\n")} );


    $("#test_obsah_list")
        .on("click", "li", seznamOtazekClick)
        .on("mouseup", "li", seznamOtazekMouseUp)
        .on("contextmenu", function() { return false; });


    var $prilohaTargetFocus = null;

    var onInputFocus = function() {
        var $this = $(this);

        if ($this.is(".priloha-target")) {
            $prilohaTargetFocus = $this;
        } else {
            $prilohaTargetFocus = null;
        }
    };

    var prilohaDblClick = function() {
        if (!$prilohaTargetFocus  ||  !$prilohaTargetFocus.length) {
            return;
        }

        var
            text,
            $this = $(this),
            id = $this.data("ron-id"),
            index = $("#kurz_prilohy").children("li").index(this);

        if (!id) {
            return;
        }

        if (dataEditace.prilohy[index]) {
            switch (dataEditace.prilohy[index].type) {
                case "image" :
                    text = '<img src="' + "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.testEKurzu.idRevize + "&priloha=" + id + '">';
                    break;

                case "video" :
                    break;

                default :
                    text =
                        '<a target="_blank" href="' + "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.testEKurzu.idRevize + "&priloha=" + id + '">' +
                        ron._('Stahnout_prilohu') +
                        '</a>';
            }
        }

        if (text) {
            var originalText = $prilohaTargetFocus.val();
            $prilohaTargetFocus.val(
                originalText.substring(0, $prilohaTargetFocus.get(0).selectionStart) +
                text +
                originalText.substring($prilohaTargetFocus.get(0).selectionStart)
            );
        }
        //if (dataEditace.prilohy[index].type == "image") {
        //    var newNode = ed.getDoc().createElement("img");
        //    newNode.src = "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.revize + "&priloha=" + id;
        //} else if (dataEditace.prilohy[index].type == "video") {
        //    newNode = ed.getDoc().createElement ( "video" );
        //    newNode.controls = "controls";
        //    newNode.width = 640;
        //    newNode.height = 480;
        //
        //    var sourceNode = ed.getDoc().createElement ( "source" );
        //    sourceNode.src = "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.revize  + "&priloha=" + id;
        //    newNode.appendChild(sourceNode);
        //} else {
        //    newNode = ed.getDoc().createElement("a");
        //    newNode.href = "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.revize  + "&priloha=" + id;
        //    newNode.textContent = ron._('Stahnout_prilohu');
        //    newNode.target = "_blank";
        //}
        console.log(dataEditace.prilohy[index]);
    };


    $(document.body)
        .on("click", "#otazka_save", function() { ulozAktualniOtazku(null); })
        .on("click", "#otazka_cancel", otazkaCancel)
        .on("click", "#pridatOdpoved", pridejVolbu)
        .on("click", ".deleteRow", odstranVolbu)
        .on("click", "#test_new_content", novaOtazka)
        .on("change", "#typRozsahu", typRozsahuChange)
        .on("click", "#ulozitHlavickuTestu", ulozHlavickuTestu)
        .on("click", "#hromadnyImportLink", vlozitHromadneClick)
        .on("click", "#btnImportOK", provedImportOtazek)
        .on("change keyup paste", "#importOtazekText", textImportuChange)
        .on("focus", "input", onInputFocus)
        .on("focus", "textarea", onInputFocus);

    $("#kurz_prilohy")
        .on("dblclick", "li", prilohaDblClick);
};

