<?php
/**
 * UTF8
 * stanislav.elbl, 10.07.2015
 */

namespace Ron\ELearning;

use Ron\Http\App;
use Ron\Http\HtmlHeaders;
use Ron\Http\HttpResponse;
use Ron\MVC\Model;
use Ron\StringUtils;

global $appDate;
global $appVersion;
global $copyrightYear;

global $apptitle; // kompat.

$defaultQueryString = Model::getInstance()['ron@defaultQueryString'];

$editace = Model::getInstance() ->getData('editace');

?>
<!doctype html>
<html>
<head>
    <?php
    require('ron/apphead.php');
    ?>

    <script type="text/javascript" src="tinymce/tinymce.min.js"></script>

    <!--    <script type="text/javascript" src="tinymce/tinymce.min.js"></script>-->
    <link rel="stylesheet" type="text/css" href="css/elearning.css?ver=<?= $appVersion ?>">

<!--    <script type="text/javascript" src="script/ronmce.js"></script>-->

    <?php
    require('view/apphead.php');

    if ( App::getDebugMode() ) {
        HttpResponse::getInstance() ->getHeaders() ->renderDebugScript();
    }
    HtmlHeaders::getInstance() ->render();
    ?>

    <script type="text/javascript" src="?menuid=kurzy&action=translations&ver=<? $appVersion ?>"></script>

    <script type="application/javascript" src="elearning/elearning.js?ver=<?= $appVersion ?>"></script>
    <script type="application/javascript" src="elearning/testy.js?ver=<?= $appVersion ?>"></script>

</head>
<body class="<?= $editace ? 'editace' : '' ?>">
<!--<div class="pagecontent">-->
    <!-- hlavicka, aplikace, jazyk -->
    <?php
        require('view/apptitle.php');
    ?>

    <div class="topmenu">
        <div class="appselect">
            <div class="appselect-item active"><a href="?"><?= $apptitle ?: \Ron\ronText('RON_Portal') ?></a></div>
            <div class="appselect-item active"><a href="?menuid=kurzy"><?= \Ron\ronText('Kurzy') ?></a></div>
        </div>
        <ul class="langselect inline-list list-slash">
            <li><a href="?session@lang=cz&<?= $defaultQueryString ?>">cz</a></li>
            <li><a href="?session@lang=sk&<?= $defaultQueryString ?>">sk</a></li>
            <li><a href="?session@lang=eng&<?= $defaultQueryString ?>">en</a></li>
        </ul>
    </div>

    <?php
        require('view/userpanel.php');
    ?>

    <?php if(!$editace) { ?>
    <div class="container">
    <?php } ?>

    <?php
    if (Model::getInstance() ->getViewObjects()) {
        foreach (Model::getInstance() ->getViewObjects() as $viewObject) {
            $viewObject ->render();
        }
    }
    ?>

    <?php if(!$editace) { ?>
    </div>
    <?php } ?>

            <!-- paticka -->
    <div class="footer">
        <div class="copyright">
            &copy; 2003-<?= $copyrightYear ?>, <?= StringUtils::fromUTF8('Všechna práva vyhrazena') ?>, <a href="http://www.ron.cz">RON Software</a>, s.r.o.
        </div>

        <div id="nojs"><a href="script/nojs.html"><?= \Ron\ronText('Adblock_nebo_vypnuty_javascript') ?></a></div>

        <div class='version' title='<?= $appDate ?>'><a href='verze.php' target='_blank'> <?= $appVersion ?></a></div>
    </div>

<!--</div>-->
</body>
</html>
