<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 02.01.2019
 */

namespace Ron\RonPortal;

use Ron\Browser;
use Ron\BrowserField;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\SqlStatement;
use Ron\StringUtils;
use Ron\MessageManager;
use Ron\DB\SQLUtils;
use function Ron\ronText;

require_once ('adsapp/ronportalbrowser.php');



/**
 * Class FilterProhlaseniPoplatnikaDane
 * @package Ron\RonPortal
 */
class FilterProhlaseniPoplatnikaDane extends RonPortalFilterForm
{

    /**
     * FilterProhlaseniPoplatnikaDane constructor.
     * @param Database $database
     * @param $ppProSql
     * @param string $action
     * @param bool $useGet
     */
    public function __construct(Database $database, $ppProSql, $action, $useGet = false)
    {
        parent::__construct($database, $action, $useGet);
        $this->nastavOsoby(true, Prava::vratPrava('dane_prohlaseni'));
        //Na prihlasenou osobu
//        $this->osobyFiltr = "Osoba.RC = '" . User::getRC() . "'";
        $this->osobyFiltr = SQLUtils::getINCondition($database, 'PracovniPomer.ID', $ppProSql);

    }

    public function renderNovyFormular()
    {
        echo "<div class='filterrow'>";
        echo "<span class='filtercaption'>";
        echo "<a href='?menuid=dane&action=formularprohlaseni'>" . ronText("formular_prohlaseni") . "</a>";
        echo "</span>";
        echo "</div>";
    }


    function renderFilters()
    {
        parent::renderFilters();
//        $this->renderNovyFormular();
    }
}

///**
// * Class ProhlaseniField
// * @package Ron\RonPortal
// */
//class ProhlaseniPuvodniField extends BrowserField
//{
//    public $prohlaseniElektronickyIndex;
//    public $prohlaseniPortalIndex;
//    public $rokRVDIndex;
//
//    /** @var Database $database */
//    public $database;
//
//    public function __construct($database,$rokRVD, $prohlaseniElektronicky, $prohlaseniPortal)
//    {
//        parent::__construct();
//
//        $this->prohlaseniElektronickyIndex = $prohlaseniElektronicky;
//        $this->prohlaseniPortalIndex = $prohlaseniPortal;
//        $this->rokRVDIndex = $rokRVD;
//
//        $this->database = $database;
//        $this->className = 'center';
//        $this->header = ronText('formular_prohlaseni');
//    }
//
//
//    function getViewText($value, $rowNumber, $recordId, $rowData)
//    {
//        $result = "";
//
//        $prohlaseni = $rowData[$this->prohlaseniPortalIndex] ? 1 : 0;
//        $obdobi = $this->database->stringToTimestamp($rowData[$this->rokRVDIndex]);
//        if ($obdobi > 0) {
//            $result .= "<a href='?menuid=dane&action=formularprohlaseni&obdobi=$obdobi&prohlaseni=$prohlaseni' >";
//
//            $aktualniRok = date('Y', time());
//            $rokVSystemu = date("Y", $this->database->stringToTimestamp($rowData[0]));
//
//            //Pro práci s elektronickým podpisem prohlášení na portále.
//            //Schválené prohlášení provede uzamčení změn na portále a přepsání datumu prohlášení datem z portálu.
//
//            //Stavy:
//            //0 - Návrh
//            //1 - Schváleno
//            //2 - Vráceno
//            //3 - Více platných poměrů pro zdanění
//
//            //pokud bude prohlaseni schvalene ucetni (1,2), pak umoznit pouze nahled jiz ne editaci,
//            // v pripade chyby (3) se musi provest korekce mzdo. pracovnikem
//            //TODO kontrola na ProhlaseniElektronicky
//            if (($rowData[$this->prohlaseniPortalIndex] == 0 || $rowData[$this->prohlaseniPortalIndex] == 2) && ($rokVSystemu == $aktualniRok)) {
//                $result .= "<span class='bold'>" . ronText("Mzdy_vyplnit") . "</span>";
//            } else {
//
//                //Overeni zda lze vyplnit na portale jinak pouze detail
//                if ($rowData[$this->prohlaseniElektronickyIndex] == 1) {
//                    $result .= "<span>" . ronText("Mzdy_nahled") . "</span>";
//
//                } else {
//                    $telefonMzdovyPracovnik = RonPortalSettings::getValue('danekontaktnamzdoveho');
//                    $titulek = "";
//                    if ($telefonMzdovyPracovnik != "") {
//                        $titulek = ronText('Mzdy_elektronicky_podepsat_neni_povoleno_mzdovym_pracovnikem_info') .
//                            "\n" . sprintf(ronText('Mzdy_kontakt_mzdovy_pracovnik'), "\n" . $telefonMzdovyPracovnik);
//                        $titulek = "<img src='images/asset.png' title='$titulek'>";
//                    }
//                    $result .= ronText('Mzdy_elektronicky_podepsat_neni_povoleno_mzdovym_pracovnikem') . "&nbsp;&nbsp;" . $titulek;
//                }
//
//            }
//
//            $result .= "</a>";
//        }
//
//        return $result;
//    }
//}
//
//
///**
// * Class SchvaleniUcetniField
// * @package Ron\RonPortal
// */
//class SchvaleniUcetniField extends BrowserField
//{
//
//    /** @var Database $database */
//    public $database;
//
//    /**
//     * ProhlaseniField constructor.
//     * @param $database
//     */
//    public function __construct($database)
//    {
//        parent::__construct();
//
//        $this->database = $database;
//        $this->className = 'center';
//        $this->header = ronText('schvaleno_ucetni');
//    }
//
//
//    /**
//     * @param mixed $value
//     * @param int $rowNumber
//     * @param string $recordId
//     * @param array $rowData
//     * @return string
//     * @throws \Exception
//     */
//    function getViewText($value, $rowNumber, $recordId, $rowData)
//    {
//        $result = "";
//
//        if ($rowData[5] == 1){
//            $result .= "<span class='bold'>" . ronText("Str_Yes") . "</span>";
//        } else {
//            $result .= ronText("Str_No");
//        }
//
//        return $result;
//    }
//}
//
//
///**
// * Class StavProhlaseniNaPortaluField
// * @package Ron\RonPortal
// */
//class StavProhlaseniNaPortaluField extends BrowserField
//{
//
//    /** @var Database $database */
//    public $database;
//
//    /**
//     * ProhlaseniField constructor.
//     * @param $database
//     */
//    public function __construct($database)
//    {
//        parent::__construct();
//
//        $this->database = $database;
//        $this->className = 'center';
//        $this->header = ronText('Mzdy_stav_prohlaseni');
//    }
//
//
//    /**
//     * @param mixed $value
//     * @param int $rowNumber
//     * @param string $recordId
//     * @param array $rowData
//     * @return string
//     * @throws \Exception
//     */
//    function getViewText($value, $rowNumber, $recordId, $rowData)
//    {
//        $result = "";
//
//        switch ($rowData[4]){
//            case '0':
//                $result .= ronText('Mzdy_navrh');
//                break;
//
//            case '1':
//                $result .= "<span class='bold'>" . ronText('Mzdy_schvaleno') . "</span>";
//                break;
//
//            case '2':
//                $titulek = StringUtils::htmlTextConvert($rowData[8]);
//                $result .= "<span title='$titulek' class='bold'>" . ronText('Mzdy_vraceno') . "</span>";
//                break;
//
//            case '3':
//                $result .= "<span class='bold'>" . ronText('vice_pp_pro_zdaneni') . "</span>";
//                break;
//        }
//
//        return $result;
//    }
//}

//
///**
// * Class ProvestRocniVyuctovaniField
// * @package Ron\RonPortal
// */
//class ProvestRocniVyuctovaniField extends BrowserField
//{
//    /** @var Database $database */
//    public $database;
//
//    /**
//     * ProhlaseniField constructor.
//     * @param $database
//     */
//    public function __construct($database)
//    {
//        parent::__construct();
//
//        $this->database = $database;
//        $this->className = 'center';
//        $this->header = ronText('provest_rocni_vyuctovani');
//    }
//
//
//    /**
//     * @param mixed $value
//     * @param int $rowNumber
//     * @param string $recordId
//     * @param array $rowData
//     * @return string
//     * @throws \Exception
//     */
//    function getViewText($value, $rowNumber, $recordId, $rowData)
//    {
//        $result = "";
//
//        switch ($rowData[5]){
//            case '0':
//                $result .= ronText('Mzdy_navrh');
//                break;
//
//            case '1':
//                $result .= "<span class='bold'>" . ronText('Mzdy_schvaleno') . "</span>";
//                break;
//        }
//
//        return $result;
//    }
//}



/**
 * Class DatumVyplneniProhlaseniNaPortaleField
 * @package Ron\RonPortal
 */
class DatumVyplneniProhlaseniNaPortaleField extends BrowserField
{
    public $datumProhlaseni;
    public $prohlaseniElektronicky;
    public $datumProhlaseniPortal;

    /** @var Database $database */
    public $database;

    /**
     * DatumVyplneniProhlaseniNaPortaleField constructor.
     * @param $database
     * @param $indexProhlaseniElektronicky
     * @param $indexDatumProhlaseni
     * @param $indexDatumProhlaseniPortal
     */
    public function __construct($database, $indexProhlaseniElektronicky, $indexDatumProhlaseni, $indexDatumProhlaseniPortal)
    {
        parent::__construct();
        $this->datumProhlaseni = $indexDatumProhlaseni;
        $this->prohlaseniElektronicky = $indexProhlaseniElektronicky;
        $this->datumProhlaseniPortal = $indexDatumProhlaseniPortal;

        $this->database = $database;
        $this->className = 'center';
        $this->header = ronText('Prohlaseni_podepsano_dne');
    }


    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     * @throws \Exception
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = "";
        $prohlaseniKDaniCinim = (int)$rowData[3];
        $datumProhlaseni = $this->database->stringToTimestamp($rowData[$this->datumProhlaseni]);
        $datumProhlaseniPortal = $this->database->stringToTimestamp($rowData[$this->datumProhlaseniPortal]);
        $prohlaseniElektronicky = $rowData[$this->prohlaseniElektronicky];  //Zda lze vyplnit elektronicky


        /*
        "RVD.Rok,  RVD.DatumProhlaseni,  Obdobi.Popis, RVD.DatumProhlaseniPortal, " .       //0..3
            "RVD.ProhlaseniPortalStav, RVD.ProhlaseniPortal, S_AnoNe.Popis, " .     //4..6
            "RVD.ProhlaseniElektronicky, {fn_CASTWIDEMEMO(RVD.PoznamkaProZamestnance)}, " .     //7..8

            "RVD.DatumZadostiPortal, RVD.ZadostPortalStav, RVD.ProhlaseniPortal, S_AnoNe.Popis, " .       //9..12
            "RVD.ProvestRocniVyuctovani, RVD.DatumProhlaseniPortal";     //13..14
        */

        $prohlaseniKDaniCinimText = '';
//        if ($prohlaseniKDaniCinim ){
//            $prohlaseniKDaniCinimText = "(" . ronText('prohlaseni_k_dani_cinim') . ")";
//        } else {
//            $prohlaseniKDaniCinimText = "(" . ronText('prohlaseni_k_dani_necinim') . ")";
//        }


        if ($prohlaseniElektronicky == 1){
            if ($datumProhlaseniPortal != ""){
    //            $result .= date("j.n.Y", $this->database->stringToTimestamp($rowData[1]));
                $result .= "<span class='font-weight-bold'>" . StringUtils::format("date", $datumProhlaseniPortal)  . "</span>";
            } else {
                $result .= ronText('Mzdy_nepodepsano');
            }

        } else {
             if ($datumProhlaseni != ""){
    //            $result .= date("j.n.Y", $this->database->stringToTimestamp($rowData[1]));
                $result .= "<span class='font-weight-bold'>" . StringUtils::format("date", $datumProhlaseni)  . "</span>";
            } else {
                $result .= ronText('Mzdy_nepodepsano');
            }

        }


        return "<span class='align-left '>" . $result . "</span>" . "  " . "<span class='align-right '>". $prohlaseniKDaniCinimText . "</span>";
    }
}


/**
 * Class ZadostRocnihoZuctovaniField
 * @package Ron\RonPortal
 */
class ZadostRocnihoZuctovaniField extends BrowserField
{
    public $prohlaseniElektronickyIndex;
    public $prohlaseniSchvalenoIndex;


    /**
     * ZadostRocnihoZuctovaniField constructor.
     * @param $database
     * @param $prohlaseniElektronicky
     * @param $prohlaseniPortalStav
     */
    public function __construct($database, $prohlaseniElektronicky, $prohlaseniPortalStav)
    {
        parent::__construct($database);
        $this->prohlaseniElektronickyIndex = $prohlaseniElektronicky;
        $this->prohlaseniSchvalenoIndex = $prohlaseniPortalStav;

        $this->database = $database;
        $this->className .= 'center min-width-200px';
        $this->header = ronText('Mzdy_formular_zadosti');
    }

    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = "";
        $obdobi = $this->database->stringToTimestamp($rowData[0]);
        $datumProhlaseni = $this->database->stringToTimestamp($rowData[1]);
        $prohlaseniElektronicky = $rowData[$this->prohlaseniElektronickyIndex];
        $stavProhlaseni = $rowData[$this->prohlaseniSchvalenoIndex];
        $provestRocniVyuctovani = $rowData[13];

        //Pokud je po datu 15.2. a není povoleno "Možnost podepsat žádost po termínu"
        //pak editaci neumožnit

        $rokZadosti = date('Y', DateUtils::incDay(DateUtils::firstDayOfYear(time()), -1));
        $aktualniRok = date('Y', DateUtils::firstDayOfYear(time()));
        $rokVSystemu = date("Y", $this->database->stringToTimestamp($rowData[0]));

        if ($obdobi > 0) {
            $result .= "<a href='?menuid=dane&action=formularzadosti&obdobi=$obdobi' >";

            $povolitPoTerminu = (bool)(RonPortalSettings::getIntValue('zadostizuctovanidanepoterminu'));

            if ($povolitPoTerminu) {
                $lzeEditovat = true;
            } else {
                $lzeEditovat = (mktime(0, 0, 0, 2, 15, (int)date("y", time()))) > time();
            }


            //pokud bude zadost schvalena ucetni, pak umoznit pouze nahled jiz ne editaci
            if ($rowData[10] == 0 && ($rokVSystemu == $aktualniRok) && $rowData[13] == 1 && $lzeEditovat) {
                $result .= "<span class='bold'>" . ronText("Mzdy_vyplnit") . "</span>";
            } else {
                $result .= "<span>" . ronText("Mzdy_nahled") . "</span>";
            }

            $result .= "</a>";
        }


        /*
            "RVD.Rok,  RVD.DatumProhlaseni,  Obdobi.Popis, RVD.DatumProhlaseniPortal, " .       //0..3
            "RVD.ProhlaseniPortalStav, RVD.ProhlaseniPortal, S_AnoNe.Popis, " .     //4..6
            "RVD.ProhlaseniElektronicky, {fn_CASTWIDEMEMO(RVD.PoznamkaProZamestnance)}, " .     //7..8

            "RVD.DatumZadostiPortal, RVD.ZadostPortalStav, RVD.ProhlaseniPortal, S_AnoNe.Popis, " .       //9..12
            "RVD.ProvestRocniVyuctovani, RVD.DatumProhlaseniPortal";     //13..14
         */


        $zadam = "";
        if ($rokVSystemu == $aktualniRok ) {
            switch ($rowData[13]) {
                //Stav zadosti na Portale
                case '0':
                    //Nepozaduje rocni vyuctovani dane
                    $zadam .= "<span class=''>" . ronText('zadost_nezadam') . "</span>";

                    if ($rokVSystemu == $aktualniRok && $prohlaseniElektronicky == 1) {
                        $zadam .= " / ";
                        $url = "<a href='?menuid=dane&action=rocnizuctovani&obdobi=$obdobi&datumprohlaseni=$datumProhlaseni&zadamzuctovani=1'>" . ronText('zadost_zadam') . "</a>";
                        $zadam .= "<span class=''>" . $url . "</span>";
                    }
                    break;

                case '1':
                    //Pozaduje provest rocni vyuctovani
                    $zadam .= "<span class='font-weight-bold'>" . ronText('zadost_zadam') . "</span>";

                    if ($rokVSystemu == $aktualniRok && $prohlaseniElektronicky == 1) {
                        $zadam .= " / ";
                        $url = "<a href='?menuid=dane&action=rocnizuctovani&obdobi=$obdobi&datumprohlaseni=$datumProhlaseni&zadamzuctovani=0'>" . ronText('zadost_nezadam') . "</a>";
                        $zadam .= "<span class=''>" . $url . "</span>";
                    }
                    break;
            }
        }


        if ($zadam != "")
        {
            $result = "<span class='align-left'>" . $zadam . "</span>" . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;&nbsp;" . $result;
        }


        return $result;
    }
}


/**
 * Class ZmenovaCastProhlaseniField
 * @package Ron\RonPortal
 */
class ProhlaseniField extends BrowserField
{

    public $prohlaseniElektronickyIndex;
    public $prohlaseniPortalStavIndex;
    public $prohlaseniKDaniCinimAnoNeIndex;
    public $rokRVDIndex;
    public $osoba;

    /** @var Database $database */
    public $database;


    /**
     * ZmenovaCastProhlaseniField constructor.
     * @param $database
     * @param $rokRVDIndex
     * @param $prohlaseniElektronickyIndex
     * @param $prohlaseniPortalStavIndex
     * @param $prohlaseniKDaniCinimIndex
     */
    public function __construct($database, $rokRVDIndex, $prohlaseniElektronickyIndex, $prohlaseniPortalStavIndex, $prohlaseniKDaniCinimIndex)
    {
        parent::__construct();

        $this->prohlaseniElektronickyIndex = $prohlaseniElektronickyIndex;
        $this->prohlaseniPortalStavIndex = $prohlaseniPortalStavIndex;
        $this->prohlaseniKDaniCinimAnoNeIndex = $prohlaseniKDaniCinimIndex;
        $this->rokRVDIndex = $rokRVDIndex;

        $this->database = $database;
        $this->className .= 'center';
        $this->header = ronText('formular_prohlaseni');
    }


    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = "";
        $podepsat = "";
        $zmenovaCast = "";

        /** @var int 1/0 $prohlaseniPortalStav */
        $prohlaseniVyplnenoDne = $rowData[3];
        $prohlaseniPortalStav = $rowData[$this->prohlaseniPortalStavIndex];
        $prohlaseniElektronicky = $rowData[7];
        $prohlaseniKDaniCinim = (int)$rowData[5];
        $obdobi = $this->database->stringToTimestamp($rowData[$this->rokRVDIndex]);
        $aktualniRok = date('Y', time());
        $rokRVD = date("Y", $this->database->stringToTimestamp($rowData[0]));

        $idPrihlaseneOsoby = RonPortalSession::vybranaOsoba();
        $idOsobyRVD = $rowData[19];

        /*
         * "RVD.Rok,  RVD.DatumProhlaseni,  Obdobi.Popis, RVD.DatumProhlaseniPortal, " .       //0..3
            "RVD.ProhlaseniPortalStav, RVD.ProhlaseniPortal, S_AnoNe.Popis, " .     //4..6
            "RVD.ProhlaseniElektronicky, {fn_CASTWIDEMEMO(RVD.PoznamkaProZamestnance)}, " .     //7..8
            "RVD.DatumZadostiPortal, RVD.ZadostPortalStav, RVD.ProhlaseniPortal, S_AnoNe.Popis, " .       //9..12
            "RVD.ProvestRocniVyuctovani, RVD.DatumProhlaseniPortal, RVD.ProhlaseniPortalZmenaStav, " .     //13..15
            "RVD.ProhlaseniPortalRC, RVD.ProhlaseniPortalOsc, RVD.ProhlaseniPortalDatNastup, PP.ID";     //16..19
         */


        if ($obdobi > 0){
            $podepsat .= "<a href='?menuid=dane&action=formularprohlaseni&osoba=$idPrihlaseneOsoby&obdobi=$obdobi' >";

            //Pro práci s elektronickým podpisem prohlášení na portále.
            //Schválené prohlášení provede uzamčení změn na portále a přepsání datumu prohlášení datem z portálu.
            //pokud bude prohlaseni schvalene ucetni (1,2), pak umoznit pouze nahled jiz ne editaci,
            // v pripade chyby (3) se musi provest korekce mzdo. pracovnikem
            //Pokud nebude povoleno vyplneni elekrtonicky na karte zamestnance, pak umoznit pouze "Nahled"
            if (($prohlaseniPortalStav != 1) && ($rokRVD == $aktualniRok)) {

                if ($prohlaseniPortalStav == 0 && $prohlaseniVyplnenoDne != "" && $prohlaseniElektronicky == 1){

                    if ($idPrihlaseneOsoby == $idOsobyRVD) {
                        //Ma podepsano, a ve filtru ma vybrany stejny pp
                        $podepsat .= "<span class='bold'>" . ronText("Prohlaseni_podepsano") . "</span>";
                    } else {
                        //Ma sice podepsano, ale ve filtru ma vybrany jiny pp, proto se musi upravit popis odkazu
                        $podepsat .= "<span class='bold'>" . ronText("Prohlaseni_zmenit_pracovni_pomer_na_prohlaseni") . "</span>";
                    }

                } elseif ($prohlaseniVyplnenoDne == "" && $prohlaseniElektronicky == 1) {
                    $podepsat .= "<span class='bold'>" . ronText("Mzdy_podepsat_prohlaseni") . "</span>";
                } elseif ($prohlaseniPortalStav == 2 && $prohlaseniElektronicky == 1) {
                    $podepsat .= "<span class='bold'>" . ronText("prohlaseni_vraceno") . "</span>";
                } elseif ($prohlaseniPortalStav == 0  && $prohlaseniElektronicky == 0) {
                    //Je v navrhu (jeste neschvalen, ale neni povoleno vyplnit na portale)
                    $podepsat .= ronText('Mzdy_elektronicky_podepsat_neni_povoleno_mzdovym_pracovnikem');
                } else {
                    //Overeni zda lze vyplnit na portale jinak pouze detail
                    $podepsat .= "<span>" . ronText("Mzdy_nahled") . "</span>";
                }

            } else {

                $podepsat .= "<span>" . ronText("Mzdy_nahled") . "</span>";
            }

            $podepsat .= "</a>";
        }



        if ($obdobi > 0 && $aktualniRok == $rokRVD && $prohlaseniElektronicky == 1 && $prohlaseniPortalStav == 1){
            $zmenovaCast .= "<a href='?menuid=dane&action=formularprohlaseni&osoba=$idPrihlaseneOsoby&obdobi=$obdobi&zmenovacast=1' >";
            //Overeni zda lze vyplnit na portale jinak pouze detail
            if ($rowData[$this->prohlaseniElektronickyIndex] == 0 && $rokRVD != $aktualniRok)
            {
                $titulek = "";
                $telefonMzdovyPracovnik = RonPortalSettings::getValue('danekontaktnamzdoveho');

                if ($telefonMzdovyPracovnik != "")
                {
                    $titulek = ronText('Mzdy_elektronicky_podepsat_neni_povoleno_mzdovym_pracovnikem_info') .
                        "\n" . sprintf(ronText('Mzdy_kontakt_mzdovy_pracovnik'), "\n" . $telefonMzdovyPracovnik);

                    $titulek = "<img src='images/asset.png' title='$titulek'>";
                }
                $zmenovaCast .= ronText('Mzdy_elektronicky_podepsat_neni_povoleno_mzdovym_pracovnikem') . "&nbsp;&nbsp;" . $titulek;

            } else {
                $zmenovaCast .= "<span>" . ronText("Prohlaseni_zmenova_cast") . "</span>";
            }
        }

        if ($zmenovaCast != "" && ($idPrihlaseneOsoby == $idOsobyRVD)){
            $result = $podepsat . "&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;" .  $zmenovaCast;
        } else {
            $result = $podepsat;
        }


        return $result;
    }
}



/**
 * Class InformacePPProRVDField
 * @package Ron\RonPortal
 */
class InformacePPProRVDField Extends BrowserField
{
    /**
     * InformacePPProRVDField constructor.
     * @param $database
     */
    public function __construct($database)
    {
        parent::__construct($database);
        $this->className .= "font-weight-bold";
    }

    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $prohlaseniElektronicky = $rowData[7];
        $obdobi = $this->database->stringToTimestamp($rowData[0]);
        $rokRVD = date("Y", $obdobi);
        $aktualniRok = date('Y', time());

        $idPrihlaseneOsoby = RonPortalSession::vybranaOsoba();
        $idOsobyRVD = $rowData[19];

        $result = "";
        if (($rokRVD == $aktualniRok) && $prohlaseniElektronicky == 1) {
            if (($prohlaseniElektronicky == 1) && ($idPrihlaseneOsoby != $idOsobyRVD)) {
                if ($idOsobyRVD != "") {
                    $result .= ronText('Prohlaseni_uplatnujete_na_jiny_ppid');
                }
            } else {
                $result .= ronText('Prohlaseni_uplatnujete_na_tento_ppid');
            }
        }

        return $result;
    }
}

class ProhlaseniElektronickyNeboPisemneField extends BrowserField
{
    public $prohlaseniElektronicky;
    public $datumProhlaseni;


    /**
     * ProhlaseniElektronickyNeboPisemneField constructor.
     * @param Database $database
     * @param int $indexProhlaseniElektronicky
     * @param $indexDatumProhlaseni
     */
    public function __construct($database, $indexProhlaseniElektronicky, $indexDatumProhlaseni)
    {
        parent::__construct($database);

        $this->prohlaseniElektronicky = $indexProhlaseniElektronicky;
        $this->datumProhlaseni = $indexDatumProhlaseni;
        $this->className = 'center';
    }


    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = "";

        $datumProhlaseni = $this->database->stringToTimestamp($rowData[$this->datumProhlaseni]);

        if ($rowData[$this->prohlaseniElektronicky] == 1 && $datumProhlaseni != "") {
            $result .= ronText("Prohlaseni_elektronicky");
        } elseif ($rowData[$this->prohlaseniElektronicky] == 0){
            $result .= ronText("Prohlaseni_pisemne");
        } else {
            $result .= ronText("prohlaseni_k_dani_necinim");
        }

        return $result;
    }
}


/**
 * Class BrowserProhlaseniPoplatnikaDane
 * @package Ron\RonPortal
 */
class BrowserProhlaseniPoplatnikaDane extends Browser
{
    /** @var FilterProhlaseniPoplatnikaDane $filterForm */
    public $filterForm;

    /**
     * BrowserProhlaseniPoplatnikaDane constructor.
     * @param Database $database
     * @param int|int[] $ppKeZdaneni
     * @throws \Exception
     */
    public function __construct($database, $ppKeZdaneni)
    {
        parent::__construct($database);

        $this->title = ronText('prohlaseni_zadost_poplatnika_dane');
        $this->browserUrl = "?menuid=dane" ;

        $this->sqlSelectPart =
            "RVD.Rok,  RVD.DatumProhlaseni,  Obdobi.Popis, RVD.DatumProhlaseniPortal, " .       //0..3
            "RVD.ProhlaseniPortalStav, RVD.ProhlaseniPortal, S_AnoNe.Popis, " .     //4..6
            "RVD.ProhlaseniElektronicky, {fn_CASTWIDEMEMO(RVD.PoznamkaProZamestnance)}, " .     //7..8

            "RVD.DatumZadostiPortal, RVD.ZadostPortalStav, RVD.ProhlaseniPortal, S_AnoNe.Popis, " .       //9..12
            "RVD.ProvestRocniVyuctovani, RVD.DatumProhlaseniPortal, RVD.ProhlaseniPortalZmenaStav, " .     //13..15
            "RVD.ProhlaseniPortalRC, RVD.ProhlaseniPortalOsc, RVD.ProhlaseniPortalDatNastup, PP.ID";     //16..19

        $this->sqlFromPart =
            "RocniVyuctovaniDane RVD LEFT JOIN PracovniPomer PP ON (RVD.ProhlaseniPortalRC = PP.RC AND RVD.ProhlaseniPortalOsc = PP.OsobniCislo AND RVD.ProhlaseniPortalDatNastup = PP.DatumNastupu )" .
            " LEFT JOIN Obdobi ON (RVD.Rok = Obdobi.PocatekObdobi AND Obdobi.Aplikace = 'Mzdy')" .
            " LEFT JOIN S_AnoNe ON (RVD.ProhlaseniPortal = S_AnoNe.Kod)";

        $this->filterForm = new FilterProhlaseniPoplatnikaDane($database, $ppKeZdaneni,  "dane", true);
        $this->filterForm->loadData();


        $this->addField([BROWSER_FIELD_SQL_INDEX => 0, BROWSER_FIELD_SQL_NAME => "RVD.Rok",
            BROWSER_FIELD_FORMAT => "year", BROWSER_FIELD_HEADER_TEXT => 'rok', BROWSER_FIELD_ALIGN => 'center', BROWSER_FIELD_ORDERING => 1]);

        /*
        //Momentalne zakomentovano - pravdepodobne bude sjednoceno s jinym sloupcem
//        $this->addField( new StavProhlaseniNaPortaluField($this->database));

//        $this->addField([BROWSER_FIELD_SQL_INDEX => 1, BROWSER_FIELD_SQL_NAME => "RVD.DatumProhlaseni",
//            BROWSER_FIELD_FORMAT => "date", BROWSER_FIELD_HEADER_TEXT => 'datum_prohlaseni', BROWSER_FIELD_ALIGN => 'center', BROWSER_FIELD_ORDERING => 1]);

//        $this->addField([BROWSER_FIELD_SQL_INDEX => 3, BROWSER_FIELD_SQL_NAME => "RVD.DatumProhlaseniPortal",
//            BROWSER_FIELD_FORMAT => "datetime", BROWSER_FIELD_HEADER_TEXT => 'Mzdy_datum_prohlaseni_portal', BROWSER_FIELD_ALIGN => 'center', BROWSER_FIELD_ORDERING => 1]);

//        $this->addField([BROWSER_FIELD_SQL_INDEX => 6, BROWSER_FIELD_SQL_NAME => "S_AnoNe.Popis",
//            BROWSER_FIELD_HEADER_TEXT => 'prohlaseni_k_dani_cinim', BROWSER_FIELD_ALIGN => 'center', BROWSER_FIELD_ORDERING => 1]);

//        $this->addField( new ProhlaseniField($this->database, 0,7, 4));
//        $this->addField( new RocniZuctovaniZadamField($this->database));
        */

        $this->addField( new DatumVyplneniProhlaseniNaPortaleField($this->database, 7, 1, 3));

        $this->addField( new ProhlaseniElektronickyNeboPisemneField($this->database, 7, 1));


        $this->addField( new InformacePPProRVDField($this->database));

        $this->addField( new ProhlaseniField($this->database, 0, 7, 4, 5));

//        $this->addField( new ZadostRocnihoZuctovaniField($this->database, 7, 4));
    }


    function renderFilter()
    {
//        parent::renderFilter();
        /*if ($this->osoba == "") {
            MessageManager::addErrorMessage(ronText('Prohlaseni_zvolte_prosim_pracovni_pomer'));
        }*/
        $this->filterForm->render();


    }


    function renderLine($values, $className, $rowNumber, $edit = false)
    {
        parent::renderLine($values, $className, $rowNumber, $edit);

        $prohlaseniPortalStav = $values[4];
        $prohlaseniPortalZmenaStav = $values[15];
        $provestRocniVyuctovani = $values[13];
        $jeMoznoVyplnitNaPortale = $values[7];

        $rokProhlaseni = date("Y", $this->database->stringToTimestamp($values[0]));
        $aktualniRok = date("Y", time());


        //Pokud nelze vyplnit prohlaseni na portale, tak tuto informaci uzivateli uvidi v poznamce
        if ($aktualniRok == $rokProhlaseni && $jeMoznoVyplnitNaPortale == 0)
        {
            $kontakt = "";
            $telefonMzdovyPracovnik = RonPortalSettings::getValue('danekontaktnamzdoveho');
            if ($telefonMzdovyPracovnik != "") {
                $kontakt = sprintf(ronText('Mzdy_kontakt_mzdovy_pracovnik'), "\n" . $telefonMzdovyPracovnik);
            }

            echo "<tr class='$className'>";
                echo '<td></td><td colspan="' . ($this->columnCount - 1) . '">';
                    echo '<span class="browserpoznamka">' . ronText('Prohlaseni_poznamka') . ronText('Mzdy_elektronicky_podpis_zrusen') . " " . $kontakt . '</span>';
            echo '</tr>';
        }


        $rocniZuctovani = "";
        switch ($values[4])
        {
            //Stav zadosti na Portale
            case '2':
                if ($provestRocniVyuctovani == 0){
                    //Pozaduje provest rocni vyuctovani
                    $rocniZuctovani .= "<span class='bold'>" . ronText('prohlaseni_vraceno') . "</span>";
                }
                break;

            case '3':

                //TODO chyba vice_pp_pro_zdaneni jiz neplati, jelikoz doslo ke zmenam a nove lze vybrat pp. Potreba predelat az se bude resit zadost o zuctovani
                $rocniZuctovani .= "<span class=''>" . ronText('vice_pp_pro_zdaneni') . "</span>";
                break;
        }

        if ($aktualniRok == $rokProhlaseni && ($prohlaseniPortalZmenaStav == 2 || $prohlaseniPortalStav == 2))
        {
            echo "<tr class='$className'>";
                echo '<td></td><td colspan="' . ($this->columnCount - 1) . '">';
                    echo '<span class="browserpoznamka font-weight-bold">' . ronText('Prohlaseni_poznamka_mzdoveho_pracovnika') . ": " . '&nbsp;&nbsp;&nbsp;&nbsp;' . StringUtils::htmlTextConvert($values[8]) . '</span>';
                echo '<td colspan="2"></td>';
            echo '</tr>';
        }
    }



    /**
     * @return SqlStatement|string
     */
    public function getSQLFilter()
    {
        $params = $this->database->createParameters();
        $result =
            "RVD.RC = (Select RC From PracovniPomer Where ID = " . $params->addParameter($this->filterForm->vybranaOsoba) . ") " .
            " AND {fn_YEAR(RVD.Rok)} >= " . $params->addParameter(RonPortalSettings::getIntValue('dane_pocatecni_rok', 2020));

        return new SqlStatement($result, $params);
    }
}






