<?php

namespace Ron\RonPortal;

use Ron\DB\Database;
use Ron\DB\SqlStatement;
use function Ron\ronText;

require_once('adsapp/dokumentyutils.php');
require_once('adsapp/b_dokumenty.php');

class NovyDokumentProhlaseniForm extends DokumentUploadForm
{

    function __construct($database, $rok, $idPP)
    {
        parent::__construct($database, '?menuid=dane&action=dokumentupload');

        $this->typDokumentu = RonPortalSettings::getIntValue('dane_dokumenty_deti_typ');

        $this->target = null;

        $this->hiddenFields = [
            'dokumentprohlasenityp' => '',
            'rok' => $rok,
            'idosoby' => $idPP,
        ];
    }
}

class DokumentyProhlaseniBrowser extends DokumentyBrowser
{
    public $povinnyDokument;

    /**
     * DokumentyProhlaseniBrowser constructor.
     * @param Database $database
     * @param int $rok
     * @param PracovniPomer $pp
     * @param int $typDokumentu
     * @param bool $editovat
     * @param bool $povinny
     */
    function __construct($database, $rok, $pp, $typDokumentu, $editovat, $povinny)
    {
        parent::__construct($database, "?menuid=dane&action=dokumentdownload&osoba=$pp->idPP&rok=$rok", $editovat ? 1 : 0, "?menuid=dane&action=dokumentdelete&osoba=$pp->idPP&rok=$rok");

        $this->sqlFromPart = 'Dokument, TypDokumentu, DokumentyOsoby';

        $this->povinnyDokument = $povinny;

        $this->showMessages = false;

        $params = $database ->createParameters();
        $this->sqlWherePart = new SqlStatement(
            'Dokument.Id = DokumentyOsoby.Id ' .
            ' AND TypDokumentu.Kod = Dokument.Typ ' .
            " AND {fn_YEAR(DokumentyOsoby.VyuctovaniDane_Rok)} = " . $params->addParameter($rok) .
            " AND DokumentyOsoby.VyuctovaniDane_RC = " . $params->addParameter($pp->rc) .
            " AND Dokument.Typ = " . $params->addParameter($typDokumentu),
                $params);
    }

    function renderData()
    {
        $row = $this->cursor->fetch();
        if (!$row) {
            if ($this->povinnyDokument) {
                echo "<tr><td class='align-center warning font-weight-bold' colspan='" . count($this->fields) . "'>" . ronText('Prohlaseni_povinny_dokument_sekce') . "</td></tr>";
            }
        } else {
            parent::renderData();
        }
    }

}