<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 02.01.2019
 */

namespace Ron\RonPortal;

use Ron\MVC\Model;
use Ron\MessageManager;
use Ron\RonPortal\Zamestnanci\AdresaOsoby;
use Ron\StringUtils;
use function Ron\ronText;

//TODO pokud zbude cas tak zjednodusit formular, prenaset, jen nutne pro chovani formu. a nacist old hodnoty az pri zpracovani
$model = Model::getInstance();

$database = $model->getData('database');

/** @var PracovniPomer $pracovniPomer */
$pracovniPomer = $model->getData('pracovniPomer');

/** @var ProhlaseniPoplatnikaDane $hodnotyProhlaseni */
$hodnotyProhlaseni = $model->getData('hodnotyProhlaseni');
$url = $model->getData('url');
$chciPodepsatProhlaseni = $model->getData('chciPodepsatProhlaseni');
$obdobi_timestamp = $model->getData('datumObdobi_timestamp');
$chybaPP = $model->getData('chybaPP');

$comboMesicNastaleZmeny = $model->getData('comboMesicNastaleZmeny');
$comboMesicZmenyPoradiDeti = $model->getData('comboMesicZmenyPoradiDeti');
$comboProhlaseni = $model->getData('comboProhlaseni');

//Rodina poplatnika
$partnerPoplatnika = $model->getData('partnerPoplatnika');
$jinyPoplatnikJe = $partnerPoplatnika[0] != "";

$historieZmenOdpoctuNaDeti = $model->getData('historieZmenOdpoctuNaDeti');
$historieOdpoctuNaDeti = $model->getData('historieOdpoctuNaDeti');
$detiPoplatnika = $model->getData('detiPoplatnika');

$zmenaProhlaseni = $model->getData('zmenaProhlaseni');
$zmenyOdpoctuNaDite = $model->getData('zmenyOdpoctuNaDite');
$historieOdpoctu = $model->getData('historieOdpoctu');
$historieZmenOdpoctu = $model->getData('historieZmenOdpoctu');
$zmenyOdpoctu = $model->getData('zmenyOdpoctu');

/** @var AdresaOsoby $adresa */
$adresa = $model->getData('adresa');
//$comboCastZdanovacihoObdobi = $model->getData('comboCastZdanovacihoObdobi');

$povinneDokumenty = $model->getData('povinnedokumenty');


$povolenoVyplneniElektronicky = $hodnotyProhlaseni->prohlaseniElektronicky;
if ((bool)$povolenoVyplneniElektronicky)
{
    //Pokud je povoleno vyplneni na Portale elektronicky pak jeste overit stav prohlaseni
    $editovatelne = (bool)($hodnotyProhlaseni->prohlaseniPortalStav == 0 || $hodnotyProhlaseni->prohlaseniPortalStav == 2);
} else {
    //Pokud neni povoleno vyplneni na Portale, umoznit alespon nahled (MaKr)
    $editovatelne = false;
}
$disabled = $editovatelne ? "" : "disabled='disabled'";

$rok = (int)date("Y", $obdobi_timestamp);

$jednoduchyVzhled = RonPortalSettings::getIntValue('dane_zjednoduseny_vzhled');

if ($jednoduchyVzhled) {
    $classStr = 'class="dane_info_skryte"';
} else {
    $classStr = '';
}

$textProhlaseniNerezidenta = $model->getData('prohlaseni_nerezident');

?>

<?php MessageManager::getInstance() ->showMessages(); ?>

<?php if ($textProhlaseniNerezidenta != '') { ?>

    <form method="post" id="formularProhlaseni" name="formularProhlaseni" action="<?= $url ?>">
        <input type="hidden" name="obdobi" value="<?= $rok ?>">
        <input type="hidden" name="osoba" value="<?= $pracovniPomer->idPP ?>">

        <div class='form large-form'>
            <div class="form-content">

                <div class="row">
                    <h3><?= ronText('Prohlaseni_nerezident_cestne_prohlaseni'); ?></h3>
                </div>
                <div class="row">
                    <?= StringUtils::htmlTextConvert($textProhlaseniNerezidenta) ?>
                </div>
            </div>
            <div class="buttons">
                <input type="button" class="button clickHref" data-ron-href="?menuid=dane&osoba=<?= $pracovniPomer->idPP ?>" value="<?= ronText('zpet')?>">
                <button type="submit" class="button" name="souhlas" value="1"><?= ronText('potvrzuji_podpis')?></button>
                <button type="submit" class="button" name="jineprijmy" value="1"><?= ronText('mam_jine_prijmy')?></button>
            </div>
        </div>
    </form>
<?php } elseif ($chybaPP)  { ?>

    <div class="form">
        <div class="form-content">
            <?=   ronText('formular_nelze_vyplnit') ?>
        </div>

        <div class="buttons">
            <input type="button" class="button clickHref" data-ron-href="?menuid=dane" value="<?= ronText('zpet')?>">
        </div>
    </div>

<?php } else { ?>

    <?php
        if ($editovatelne) {
            $uploadForm = new NovyDokumentProhlaseniForm($database, $rok, $pracovniPomer->idPP);
            $uploadForm->render();
        }
    ?>

    <form method="post" id="formularProhlaseni" name="formularProhlaseni" action="<?= $url ?>">
        <input type="hidden" name="osoba" value="<?= $pracovniPomer->idPP ?>">
        <input type="hidden" name="prohlaseniPPID" value="<?= $hodnotyProhlaseni->prohlaseniPPID ?>">
        <input type="hidden" name="obdobi" value="<?= $rok ?>">
        <input type="hidden" name="obdobi_timestamp" id="obdobi_timestamp"  value="<?= $obdobi_timestamp ?>">
        <input type="hidden" name="datumProhlaseniPortal" value="<?= $hodnotyProhlaseni->datumProhlaseniPortal ?>">
        <input type="hidden" name="datumOdOdpocet" value="<?= $hodnotyProhlaseni->datumOdOdpocet ?>">
        <input type="hidden" name="datumVlozeniNavrhu" value="<?= $hodnotyProhlaseni->datumVlozeniNavrhu ?>">

        <input type="hidden" name="zakladniOdpocet_old" value="<?= $hodnotyProhlaseni->zakladniOdpocet ?>">
        <input type="hidden" name="naZdravotniStav_old" value="<?= $hodnotyProhlaseni->naZdravotniStav ?>">
        <input type="hidden" name="odpocetNaStudenta_old" value="<?= $hodnotyProhlaseni->odpocetNaStudenta ?>">

        <input type="hidden" name="sleva_na_zdravotni_stav1_old" value="<?= $historieOdpoctu['prohlaseni']['naZdravotniStav'] == 1 ?>">
        <input type="hidden" name="sleva_na_zdravotni_stav2_old" value="<?= $historieOdpoctu['prohlaseni']['naZdravotniStav'] == 2 ?>">

        <input type="hidden" id="prohlaseniSchvaleno" value="<?= $hodnotyProhlaseni->prohlaseniPortalStav == 1 ?>">


        <div class='form large-form prohlaseni-poplatnika'>
            <div class="form-content">

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h1>
                            <?php if ($hodnotyProhlaseni->prohlaseniPortalStav == 2) { ?>
                                <?= ronText("prohlaseni_vraceno")?>
                            <?php } elseif ($hodnotyProhlaseni->prohlaseniPortalStav == 0 ) { ?>
                                <?= ronText("Mzdy_prohlaseni")?>
                            <?php } elseif ($hodnotyProhlaseni->prohlaseniPortalStav == 1) { ?>
                                <?= ronText("Mzdy_prohlaseni") . " - " . ronText("Mzdy_schvaleno")?>
                            <?php } ?>
                        </h1>


                        <?php if ($hodnotyProhlaseni->prohlaseniPortalStav == 2) { ?>
                            <div class="errortext align-center">
                                <?= $hodnotyProhlaseni->poznamkaProZamestnance ?>
                            </div>
                        <?php } ?>

                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h3><?= ronText("poplatnik_dane")?>

                            <?= ronText("zdanovaci_obdobi")?><sup>1)</sup>&nbsp;&nbsp;
                                <?php if (false)
                                    //($editovatelne && $chciPodepsatProhlaseni > 0 )
//                                    $comboCastZdanovacihoObdobi->render();
                                ?>

                            <label>
                                <?= date("Y", $obdobi_timestamp) ?>
                                <input class="obdobi" type="hidden" name="datumobdobi" value="<?= date("Y", $obdobi_timestamp) ?>">
                            </label>
                        </h3>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <?= ronText("cinim_prohlaseni")?>

                        <?php if ($editovatelne) $comboProhlaseni->render(); ?>
                        <?php if ($hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno != "" ) { ?>
                             <input type="hidden" name="prohlasenikdanicinim" value="1">
                        <?php } ?>

                        <sup>1a)</sup>
                        <?= ronText("Prohlaseni_dle_zakona_38k")?>
                    </div>
                </div>
            </div>



            <?php if($povolenoVyplneniElektronicky && $hodnotyProhlaseni->prohlaseniPortalStav == 1 && $zmenaProhlaseni == 1) {?>
                <div class="form-content align-right">
                    <span class="" ><i class="inline-glyph fa glyph-edit" id="prechod-na-zmenovou-cast"></i></span>
                </div>
            <?php } ?>

            <div class="form-content ram">
                <div class="row">
                    <div class="col col-12 col-md-12 font-weight-bold">
                        <?= ronText("identifikace_poplatnika")?>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-4 ">
                        <?= ronText('prijmeni'). ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($pracovniPomer->prijmeni) ?></span>
                    </div>

                    <div class="col col-12 col-md-4">
                        <?= ronText('Prohlaseni_jmeno_ditete'). ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($pracovniPomer->jmeno) ?></span>
                    </div>

                    <div class="col col-12 col-md-4">
                        <?= ronText('rodne_cislo'). ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($hodnotyProhlaseni->rodneCislo) ?></span>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-12 font-weight-bold">
                        <?= ronText("adresa_trvaleho_bydliste")?>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-3">
                        <?= ronText('mesto') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($adresa->mesto) ?></span>
                    </div>

                    <div class="col col-12 col-md-3">
                        <?= ronText('ulice') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($adresa->ulice) ?></span>
                    </div>

                    <div class="col col-12 col-md-3">
                        <?= ronText('obec') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($adresa->obecPopis) ?></span>
                    </div>

                    <div class="col col-12 col-md-3">
                        <?= ronText('psc') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($adresa->psc) ?></span>
                    </div>
                </div>

                <br>

                <div class="row">
                    <div class="col col-12 col-md-4">
                        <span class="font-weight-bold"><?= ronText("nerezident_datum_narozeni")?></span>
                        <span><?= ronText('Datum_narozeni'); ?></span>
                    </div>

                    <div class="col col-12 col-md-2">
                        <?= $hodnotyProhlaseni->danovyNerezident ? StringUtils::format('date', $hodnotyProhlaseni->datumNarozeni) : '' ?>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-4">
                        <?= ronText("cislo_typ_dokladu")?>
                    </div>

                    <div class="col col-12 col-md-2">
                        <?= StringUtils::htmlTextConvert($hodnotyProhlaseni->cisloDokladuNerezidenta) ?>
                    </div>

                    <div class="col col-12 col-md-2">
                        <?= StringUtils::htmlTextConvert($hodnotyProhlaseni->typDokladuNerezidenta) ?>
                    </div>

                    <div class="col col-12 col-md-3">
                        <?= ronText("stat_nerezidenta")?>
                    </div>

                    <div class="col col-12 col-md-1">
                        <?= StringUtils::htmlTextConvert($hodnotyProhlaseni->statDokladuNerezidenta) ?>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-4">
                        <?= ronText("identifikace_ve_statu_danove_rezidence")?>
                    </div>

                    <div class="col col-12 col-md-2">
                        <?= $hodnotyProhlaseni->danovyNerezident ? StringUtils::htmlTextConvert($hodnotyProhlaseni->cisloDanoveIdentifikace) : '' ?>
                    </div>

                    <div class="col col-12 col-md-2">
                        <?= $hodnotyProhlaseni->danovyNerezident ? StringUtils::htmlTextConvert($hodnotyProhlaseni->typDanovehoIdentifikatoru_popis) : '' ?>
                    </div>

                    <div class="col col-12 col-md-3">
                        <?= ronText("stat_danoveho_rezidenta")?>
                    </div>

                    <div class="col col-12 col-md-1">
                        <?= $hodnotyProhlaseni->danovyNerezident ? StringUtils::htmlTextConvert($hodnotyProhlaseni->statDanoveRezidence) : '' ?>
                    </div>
                </div>
            </div>

            <?php if ($jednoduchyVzhled) { ?>
                <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte1"></div>
            <?php } ?>

            <div id="dane_info_skryte1" <?= $classStr ?>>
                <div class="info"><sup>1)</sup>&nbsp;<?= ronText("za_prve")?></div>
                <div class="info"><sup>1a)&nbsp;</sup><?= ronText("za_prve_a")?></div>
            </div>

            <div class="dane_info_doporuceni">
                <?php if (Prava::vratPrava('prohl_osobni')->lzeZobrazitPP($pracovniPomer->idPP, $rok, $rok)) { ?>
                    <div><a href="?menuid=osobniudaje&osoba<?= $pracovniPomer->idPP ?>"><?= ronText('Prohlaseni_info_osobni_udaje'); ?></a></div>
                <?php }
                    if ($povinneDokumenty) { ?>
                <div><?= ronText('Prohlaseni_info_dokumenty'); ?></div>
                <?php } ?>
            </div>

            <?php
                DaneController::zobrazDokumentyProhlaseni($database, $rok, $pracovniPomer, 'odecet', $editovatelne,
                    (($historieOdpoctu['prohlaseni']['naZdravotniStav'] > 0) || ($historieOdpoctu['prohlaseni']['ZTPP'] == 1) || ($historieOdpoctu['prohlaseni']['odpocetNaStudenta'] == 1)));
            ?>

            <div class="col col-12 col-md-12 center">
                <h3><?= ronText("dle_paragrafu_35ba")?><sup>2)</sup></h3>
            </div>


            <div class="form-content ram">
                <input type="hidden" name="datumOdOdpocetNavrh" value="<?= $hodnotyProhlaseni->datumOdOdpocetNavrh ?>">
                <input type="hidden" name="datumVlozeniNavrhu" value="<?= $hodnotyProhlaseni->datumVlozeniNavrhu ?>">

                <div class="row">
                    <?php if($editovatelne && $chciPodepsatProhlaseni > 0 ) {?>
                        <div class="col col-12 col-md-1 ">
                            <?= ronText('aktualni_stav')?>
                        </div>

                        <div class="col col-12 col-md-11 ">
                            <?php if ($hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno == "" ) { ?>
                                <?= ronText('pozaduji_zmenu')?>
                                    <label for="pozaduji_upravu_slev"></label><input type="checkbox" id="pozaduji_upravu_slev" name="pozaduji_upravu_slev" value="1" >
                                <?php ?>
                            <?php } else { ?>
                                <?= ronText('zmena_slevy_schvalena_mzdovym_pracovnikem')?>
                            <?php }  ?>
                        </div>
                    <?php } ?>
                </div>


                <div class="row">
                    <input type="hidden" name="zakladni_odpocet_puvodni" value="<?= $hodnotyProhlaseni->zakladniOdpocet ?>">
                    <div class="col col-12 col-md-1 ">
                        <label>
                            <select name="zakladni_odpocet_zobrazeni" disabled>
                                <option value="0" <?= $historieOdpoctu['prohlaseni']['zakladniOdpocet'] == 0 ? "selected" : "" ?> ></option>
                                <option value="1" <?= $historieOdpoctu['prohlaseni']['zakladniOdpocet'] == 1 ? "selected" : "" ?>  >X</option>
                            </select>
                        </label>
                    </div>

                    <?php if($editovatelne && $chciPodepsatProhlaseni > 0 && $hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno == "") {?>
                        <div class="col col-12 col-md-1 ">
                            <label>
                                <select class="uprava_slevy_poplatnika" name="sleva_zakladni_nova" data-old-value-selector="zakladni_odpocet_zobrazeni" <?= $disabled ?>>
                                    <option value="0" <?= $hodnotyProhlaseni->zakladniOdpocetNavrh == 0 ? "selected" : "" ?> ></option>
                                    <option value="1" <?= $hodnotyProhlaseni->zakladniOdpocetNavrh == 1 ? "selected" : "" ?>  >X</option>
                                </select>
                            </label>
                        </div>
                    <?php }?>

                    <div class="col col-12 col-md-10 font-weight-bold">
                        <?= ronText("zakladni_sleva_poplatnika")?>
                    </div>
                </div>

                <div class="row">

                    <div class="col col-12 col-md-1 ">
                        <label>
                            <select id="na_zdravotni_stav1_zobrazeni" name="na_zdravotni_stav1_zobrazeni" disabled>
                                <option value="0" <?= $historieOdpoctu['prohlaseni']['naZdravotniStav'] == 0 ? "selected" : "" ?>></option>
                                <option value="1" <?= $historieOdpoctu['prohlaseni']['naZdravotniStav'] == 1 ? "selected" : "" ?> >X</option>
                            </select>
                        </label>
                    </div>

                    <?php if($editovatelne && $chciPodepsatProhlaseni > 0 && $hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno == "") {?>
                        <div class="col col-12 col-md-1 ">
                            <label>
                                <select class="slevaNaInvaliditu uprava_slevy_poplatnika" name="sleva_na_zdravotni_stav1" data-old-value-selector="na_zdravotni_stav1_zobrazeni" <?= $disabled ?>>
                                    <option value="0" <?= $hodnotyProhlaseni->naZdravotniStavNavrh == 0 ? "selected" : "" ?>></option>
                                    <option value="1" <?= $hodnotyProhlaseni->naZdravotniStavNavrh == 1 ? "selected" : "" ?> >X</option>
                                </select>
                            </label>
                        </div>
                     <?php }?>

                    <div class="col col-12 col-md-10 info">
                        <div class="font-weight-bold float-left"><?= ronText("zakladni_sleva_na_invaliditu") ?></div>
                        <?php if ($jednoduchyVzhled) { ?>
                            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte2"></div>
                        <?php } ?>

                        <div id="dane_info_skryte2" <?= $classStr ?>>
                            <?= ronText("zakladni_sleva_na_invaliditu_info")?>
                        </div>
                    </div>
                </div>



                <div class="row">
                    <div class="col col-12 col-md-1 ">
                        <label>
                            <select id="naZdravotniStav2" name="naZdravotniStav2" disabled>
                                <option value="0" <?= $historieOdpoctu['prohlaseni']['naZdravotniStav'] == 0 ? "selected" : "" ?>></option>
                                <option value="1" <?= $historieOdpoctu['prohlaseni']['naZdravotniStav'] == 2 ? "selected" : "" ?> >X</option>
                            </select>
                        </label>
                    </div>

                    <?php if($editovatelne && $chciPodepsatProhlaseni > 0 && $hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno == "") {?>
                        <div class="col col-12 col-md-1 ">
                            <label>
                                <select class="slevaNaInvaliditu uprava_slevy_poplatnika" name="sleva_na_zdravotni_stav2"  data-old-value-selector="naZdravotniStav2" <?= $disabled ?>>
                                    <option value="0" <?= $hodnotyProhlaseni->naZdravotniStavNavrh == 0 ? "selected" : "" ?>></option>
                                    <option value="1" <?= $hodnotyProhlaseni->naZdravotniStavNavrh == 2 ? "selected" : "" ?> >X</option>
                                </select>
                            </label>
                        </div>
                     <?php }?>

                    <div class="col col-12 col-md-10 info">
                        <div class="font-weight-bold float-left"><?= ronText("rozsirenou_sleva_na_invaliditu")?></div>
                        <?php if ($jednoduchyVzhled) { ?>
                            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte3"></div>
                        <?php } ?>

                        <div id="dane_info_skryte3" <?= $classStr ?>>
                            <?= ronText("rozsirenou_sleva_na_invaliditu_info")?>
                        </div>
                    </div>
                </div>



                <div class="row">
                    <div class="col col-12 col-md-1 ">
                        <label>
                            <select id="ztpp_zobrazeni" disabled="disabled" >
                                <option value="0" <?= $historieOdpoctu['prohlaseni']['ZTPP'] == 0 ? "selected" : "" ?>></option>
                                <option value="1" <?= $historieOdpoctu['prohlaseni']['ZTPP'] == 1 ? "selected" : "" ?>>X</option>
                            </select>
                        </label>
                    </div>

                    <?php if($editovatelne && $chciPodepsatProhlaseni > 0 && $hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno == "") {?>
                        <div class="col col-12 col-md-1 ">
                            <label>
                                <select class="" id="ztpp" disabled="disabled" >
                                    <option value="0" selected></option>
                                    <option value="1" >X</option>
                                </select>
                            </label>
                        </div>
                     <?php }?>

                    <div class="col col-12 col-md-10 info">
                        <div class="font-weight-bold float-left"><?= ronText("slevu_na_ztp")?></div>
                        <?php if ($jednoduchyVzhled) { ?>
                            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte4"></div>
                        <?php } ?>

                        <div id="dane_info_skryte4" <?= $classStr ?>>
                            <?= ronText("slevu_na_ztp_info")?>
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-1 ">
                        <label>
                            <select id="odpocetNaStudenta_zobrazeni" name="odpocetNaStudenta_zobrazeni" disabled="disabled" >
                                <option value="0" <?= $historieOdpoctu['prohlaseni']['odpocetNaStudenta'] == 0 ? "selected" : "" ?> ></option>
                                <option value="1" <?= $historieOdpoctu['prohlaseni']['odpocetNaStudenta'] == 1 ? "selected" : "" ?> >X</option>
                            </select>
                        </label>
                    </div>

                    <?php if($editovatelne && $chciPodepsatProhlaseni > 0 && $hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno == "") {?>
                        <div class="col col-12 col-md-1 ">
                            <label>
                                <select class="uprava_slevy_poplatnika" name="sleva_na_studenta_nova" data-old-value-selector="odpocetNaStudenta_zobrazeni" <?= $disabled ?> >
                                    <option value="0" <?= $hodnotyProhlaseni->odpocetNaStudentaNavrh == 0 ? "selected" : "" ?> ></option>
                                    <option value="1" <?= $hodnotyProhlaseni->odpocetNaStudentaNavrh == 1 ? "selected" : "" ?> >X</option>
                                </select>
                            </label>
                        </div>
                     <?php }?>

                    <div class="col col-12 col-md-10 info">
                        <div class="font-weight-bold float-left"><?= ronText("slevu_na_studenta")?></div>
                        <?php if ($jednoduchyVzhled) { ?>
                            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte5"></div>
                        <?php } ?>

                        <div id="dane_info_skryte5" <?= $classStr ?>>
                            <?= ronText("slevu_na_studenta_info")?>
                        </div>
                    </div>
                </div>

            </div>

            <?php if ($jednoduchyVzhled) { ?>
                <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte6"></div>
            <?php } ?>

            <div id="dane_info_skryte6" <?= $classStr ?>>
                <div class="info"><sup>2)</sup><?= ronText('za_druhe')?></div>
            </div>

            <div class="col col-12 col-md-12 center">
                <h3><?= ronText("dle_paragrafu_35c")?><?= ronText("dle_paragrafu_35c_dodatecne")?><sup>5)</sup><?= ronText("dle_paragrafu_35c_zvyhodneni")?><sup>3)</sup></h3>
            </div>

            <div class="info"><?= ronText("dle_paragrafu_35_na_mnou_vyzivovane_deti")?></div>

            <div class="form-content ram">

                <div class="row">
                    <div class="col col-12 col-md-2 ">
                        <?= ronText("Prohlaseni_jmeno_ditete")?>
                    </div>

                    <div class="col col-12 col-md-2 ">
                        <?= ronText("prijmeni")?>
                    </div>

                    <div class="col col-12 col-md-1 ">
                        <?= ronText("rc")?>
                    </div>

                    <div class="col col-12 col-md-3 ">
                        <?= ronText("uplatnuji_narok")?><sup>3)</sup>
                        <?php if($editovatelne && $chciPodepsatProhlaseni > 0 ) {?>

                            <?php
                                //Pokud jsou všechny návrhy schváleny, pak neumožnit editaci
                                $umoznitEditaciPoradi = false;
                                foreach ($detiPoplatnika as $key => $val) {
                                   if ($val['stav'] == 0) {
                                       $umoznitEditaciPoradi = true;
                                       break;
                                   }
                               }
                            ?>

                            <?php if ($umoznitEditaciPoradi) { ?>
                                <div><?= ronText('aktualni_stav')?>
                                <label for="pozaduji_upravu_poradi_ditete">&nbsp;&nbsp;/&nbsp;&nbsp;<?= ronText('pozaduji_zmenu')?></label>
                                    <input type="checkbox" id="pozaduji_upravu_poradi_ditete" name="pozaduji_upravu_poradi_ditete" value="1" ></div>
                            <?php } else { ?>
                                <div><?= ronText('aktualni_stav')?>&nbsp;&nbsp;/&nbsp;&nbsp;<?= ronText('zmena_slevy_schvalena_mzdovym_pracovnikem')?></div>
                         <?php }?>

                         <?php } else { ?>
                            <div><?= ronText('aktualni_stav')?></div>
                         <?php }?>
                    </div>

                    <div class="col col-12 col-md-1 ">
                        <?= ronText("ZTP/P")?><sup>4)</sup>
                    </div>

                    <div class="col col-12 col-md-1 ">
                        <?= ronText("zletile_dite")?><sup>4)</sup>
                    </div>

                    <div class="col col-12 col-md-2 ">
                        <?= ronText("dodatecne_za_kalendarni_mesice")?><sup>5)</sup>
                    </div>

                </div>

                <hr class="oddelovac">


                <?php
                    $cnt = 0;
                    $uplatnujeOdecetNaDeti = false;
                    if (!empty($historieOdpoctuNaDeti['prohlaseni'])){
                        foreach ($historieOdpoctuNaDeti['prohlaseni'] as $dite) {
                            if ($dite['poradiDitete'] > 0) {
                                $uplatnujeOdecetNaDeti = true;
                            }
                        ?>

                    <input type="hidden" name="dite_<?= $cnt ?>" value="<?= $dite['rc_rodinnehoPrislusnika']?>">
                    <input type="hidden" name="old_datumOdNavrh_na_dite_<?= $cnt ?>" value="<?= $dite['datumOdNavrh']?>">
                    <input type="hidden" name="old_datumVlozeniNavrhu_na_dite_<?= $cnt ?>" value="<?= $dite['datumVlozeniNavrhu']?>">
                    <input type="hidden" name="poradi_ditete_old_<?=  $cnt ?>" value="<?= $dite['poradiDitete'] != "" ? $dite['poradiDitete'] : 0 ?>">

                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                            <?= $dite['jmenoDitete'] ?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= $dite['prijmeniDitete'] ?>
                        </div>

                        <div class="col col-12 col-md-1 ">
                            <?= $dite['rodneCisloRP'] ?>
                        </div>

                        <div class="col col-12 col-md-3 ">
                            <label title="<?= ronText('aktualni_stav')?>">
                                <select name="poradi_ditete_aktualni_hodnota" disabled="disabled">
                                    <option value="0" <?= $dite['poradiDitete'] === 0 ? "selected" : "" ?> >N</option>
                                    <option value="1" <?= $dite['poradiDitete'] == 1 ? "selected" : "" ?> >1</option>
                                    <option value="2" <?= $dite['poradiDitete'] == 2 ? "selected" : "" ?> >2</option>
                                    <option value="3" <?= $dite['poradiDitete'] == 3 ? "selected" : "" ?> >3</option>
                                </select>
                            </label>

                            <?php if($editovatelne && $chciPodepsatProhlaseni > 0 && $dite['datumOdNavrhSchvaleno'] == "" ) { ?>
                                <div class="odsazeni_poradi"></div>

                                <label title="<?= ronText('zruseni_nahlaseni_zmeny_poradi_info')?>">
                                    <?php if ($editovatelne){
                                        //Edit pokud: je možnost vůbec editovat prohlášení, pokud již v předchozí úpravě došlo k návrhu změny pořadí a ještě nebylo
                                        // potvrzeno mzdovým pracovníkem,
                                        // případně nebyla v daném období ještě provedena změna pořadí a uživatel chce provést a aktivuje combobox pomocí checkboxu

                                        if ($dite['poradiDitete_navrh'] !== NULL){
                                            $editovatelnePoradi = "";
                                        } else {
                                            $editovatelnePoradi = "disabled";
                                        }
                                    } else {
                                        $editovatelnePoradi = "disabled";
                                    }?>

                                    <select class="danovezvyhodneniporadiditete" name="<?= "poradi_ditete_navrh_" . $cnt ?>"  <?= $editovatelnePoradi ?> >
                                        <option value="0" <?= $dite['poradiDitete_navrh'] == 0 ? "selected" : "" ?> >N</option>
                                        <option value="1" <?= $dite['poradiDitete_navrh'] == 1 ? "selected" : "" ?> >1</option>
                                        <option value="2" <?= $dite['poradiDitete_navrh'] == 2 ? "selected" : "" ?> >2</option>
                                        <option value="3" <?= $dite['poradiDitete_navrh'] == 3 ? "selected" : "" ?> >3</option>
                                    </select>
                                </label>
                             <?php }?>
                        </div>

                        <div class="col col-12 col-md-1 ">
                            <label>
                                <input type="checkbox" <?= $dite['drzitelPrukazuZTTP'] == "1" ? 'checked' : "" ?> value="1" disabled >
                            </label>
                            <input type="hidden" name="<?= "old_dite_ztpp_" . $dite['rc_rodinnehoPrislusnika'] ?>" value="<?= $dite['drzitelPrukazuZTTP'] ?>">
                        </div>

                        <div class="col col-12 col-md-1">
                            <label>
                                <input type="checkbox" <?= $dite['zletile'] == "1" ? 'checked' : "" ?> value="1" disabled>
                            </label>
                            <input type="hidden" name="<?= "old_zletile_" . $dite['rc_rodinnehoPrislusnika'] ?>" value="<?= $dite['zletile'] ?>">
                        </div>

                        <div class="col col-12 col-md-2">
                            <label>
                                <input type="text" class="uplatnujinaditedodatecne" disabled name="<?= "old_uplatnujinaditedodatecne_" . $dite['rc_rodinnehoPrislusnika'] ?>" size="12" value="<?= ""?>">
                            </label>
                        </div>

                    </div>

                <?php $cnt++;  } } ?>
                <input type="hidden" name="pocetdetipoplatnika" value="<?= $cnt ?>">
            </div>

            <?php if ($jednoduchyVzhled) { ?>
                <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte7"></div>
            <?php } ?>

            <div id="dane_info_skryte7" <?= $classStr ?>>
                <div class="info"><sup>3)</sup>&nbsp;<?= ronText("za_treti")?></div>
                <div class="info"><sup>4)</sup>&nbsp;<?= ronText("za_ctvrte")?></div>
                <div class="info"><sup>5)</sup>&nbsp;<?= ronText("za_pate")?></div>
            </div>

            <?php
            DaneController::zobrazDokumentyProhlaseni($database, $rok, $pracovniPomer, 'deti', $editovatelne, $cnt>0 && $uplatnujeOdecetNaDeti);
            ?>

            <?php if (RonPortalSettings::getIntValue('dane_skryt_dalsiho_poplatnika') == 0) { ?>

            <div class="col col-12 col-md-12 center">
                <h3><?= ronText("Prohlaseni_dle_paragrafu_38")?></h3>
            </div>


            <div class="font-weight-bold">a)&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_za_a")?></span></div>
            <div class="font-weight-bold">b)&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_za_b")?></div>
            <div class="font-weight-bold">c)&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_za_c")?>
                <label for="vyzivujeJinyPoplatnik"></label>
                <?php if($editovatelne && $chciPodepsatProhlaseni > 0 && $hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno == "") {?>
                    <input type="hidden" id="vyzivujeJinyPoplatnikZpristupnitPolozky" value="<?= $hodnotyProhlaseni->vyzivujeJinyPoplatnik ?>">
                    <select name="vyzivujeJinyPoplatnik" id="vyzivujeJinyPoplatnik" class="" <?= $disabled ?> >
                        <option value="0"><?= ronText('Str_No') ?></option>
                        <option value="1" class="font-weight-bold" <?= $hodnotyProhlaseni->vyzivujeJinyPoplatnik == 1 ? 'selected' : '' ?> ><?= ronText('Str_Yes') ?></option>
                    </select>
                <?php } else { ?>
                    <input type="hidden" id="vyzivujeJinyPoplatnikZpristupnitPolozky" value="<?= $hodnotyProhlaseni->vyzivujeJinyPoplatnik ?>">
                    <span style="text-transform:uppercase;border: solid 1px #cccccc"><?= $hodnotyProhlaseni->vyzivujeJinyPoplatnik == 1 ? "&nbsp;" . ronText('Str_Yes') : "&nbsp;" . ronText('Str_No') . "&nbsp;" ?> </span>
                <?php } ?>
                <sup class="padding-left">6)</sup><sup>6a)</sup>

            </div>

            <br>

            <div class="form-content ram">
                <div class="row">
                    <div class="col col-12 col-md-2 center">
                        <?= ronText("Jmeno")?>
                    </div>

                    <div class="col col-12 col-md-4 center">
                        <?= ronText("Prijmeni")?>
                    </div>

                    <div class="col col-12 col-md-3 center">
                        <?= ronText("rodne_cislo")?>*
                    </div>

                    <div class="col col-12 col-md-2 center">
                        <?= ronText("Prohlaseni_dle_paragrafu_38_uplatnuje")?>
                    </div>

                    <div class="col col-12 col-md-1 center">
                        <?= ronText("Prohlaseni_dle_paragrafu_38_zamestnani")?><sup>7)</sup>
                    </div>
                </div>

                <hr class="oddelovac">

                <?php if ($editovatelne){ ?>
                    <input type="hidden" id="partnerJinyPoplatnikJmeno" value="<?= ($jinyPoplatnikJe ? $partnerPoplatnika[2] : "") ?>" >
                    <input type="hidden" id="partnerJinyPoplatnikPrijmeni" value="<?= ($jinyPoplatnikJe ? $partnerPoplatnika[3] : "") ?>" >
                    <input type="hidden" id="partnerJinyPoplatnikRC" value="<?= ($jinyPoplatnikJe ? $partnerPoplatnika[9] : "") ?>" >
                <?php } ?>

                <div class="row">
                    <div class="col col-12 col-md-2">
                        <label title="<?= ronText('')?>">
                            <input type="text"
                                   class="pole-zadosti"
                                   id="jinyPoplatnikJmenoVisible"
                                   value="<?= $hodnotyProhlaseni->jinyPoplatnikJmeno ?>"
                                   disabled="disabled" >
                            <input type="hidden" id="jinyPoplatnikJmeno" name="jinyPoplatnikJmeno" value="<?= $hodnotyProhlaseni->jinyPoplatnikJmeno ?>">
                        </label>
                    </div>

                    <div class="col col-12 col-md-4">
                        <label>
                            <input type="text"
                                   class="pole-zadosti"
                                   id="jinyPoplatnikPrijmeniVisible"
                                   value="<?= $hodnotyProhlaseni->jinyPoplatnikPrijmeni ?>"
                                   disabled="disabled" >
                            <input type="hidden" id="jinyPoplatnikPrijmeni" name="jinyPoplatnikPrijmeni" value="<?= $hodnotyProhlaseni->jinyPoplatnikPrijmeni ?>">
                        </label>
                    </div>


                    <div class="col col-12 col-md-3">
                        <label>
                            <input type="text"
                                   class="pole-zadosti ronRC"
                                   id="jinyPoplatnikRCVisible"
                                   value="<?= $hodnotyProhlaseni->jinyPoplatnikRC ?>"
                                   disabled="disabled" >
                            <input type="hidden" id="jinyPoplatnikRC" name="jinyPoplatnikRC" value="<?= $hodnotyProhlaseni->jinyPoplatnikRC ?>">
                        </label>
                    </div>

                    <div class="col col-12 col-md-2">

                        <label for="partner_zamestnan"></label>
                        <select name="jinyPoplatnikUplatnujeZv" id="jinyPoplatnikUplatnujeZv" class="pole-zadosti jiny-poplatnik prohlaseni-poplatnika-dane" <?= $disabled ?> >
                            <option value="0"><?= ronText('Str_No') ?></option>
                            <option value="1" class="font-weight-bold" <?= $hodnotyProhlaseni->jinyPoplatnikUplatnujeZv == 1 ? 'selected' : '' ?> ><?= ronText('Str_Yes') ?></option>
                        </select>

                    </div>

                    <div class="col col-12 col-md-1">
                        <select name="jinyPoplatnikZamestnani" id="jinyPoplatnikZamestnani" class="pole-zadosti jiny-poplatnik prohlaseni-poplatnika-dane" <?= $disabled ?> >
                            <option value="0"><?= ronText('Str_No') ?></option>
                            <option value="1" class="font-weight-bold" <?= $hodnotyProhlaseni->jinyPoplatnikZamestnani == 1 ? 'selected' : '' ?> ><?= ronText('Str_Yes') ?></option>
                        </select>
                    </div>

                </div>


                <hr class="oddelovac">

                <div class="row align-center">
                     <div class="col col-12 col-md-3 align-left">
                        <div><?= ronText('Prohlaseni_platce_dane_partner_adresa') ?> </div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= ronText('Prohlaseni_jinyPoplatnikObec') . '&nbsp;'  ?> </div>
                    </div>

                      <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikObec"
                               value="<?= $hodnotyProhlaseni->jinyPoplatnikObec ?>" <?= $disabled ?>>
                    </div>
                </div>


                <div class="row align-center">
                     <div class="col col-12 col-md-3">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= ronText('Prohlaseni_jinyPoplatnikUlice') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikUlice"
                               value="<?= $hodnotyProhlaseni->jinyPoplatnikUlice ?>" <?= $disabled ?>>
                    </div>
                </div>

                <div class="row align-center">
                     <div class="col col-12 col-md-3">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= ronText('Prohlaseni_jinyPoplatnikPSC') . '&nbsp;'  ?> </div>
                    </div>

                      <div class="col col-12 col-md-8">
                        <label title="<?= ronText('')?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikPSC"
                                   value="<?= $hodnotyProhlaseni->jinyPoplatnikPSC ?>" <?= $disabled ?>>
                        </label>
                    </div>
                </div>

                <hr class="oddelovac">

                <div class="row align-center">
                     <div class="col col-12 col-md-3 align-left">
                        <div><?= ronText('Prohlaseni_platce_dane_partner_zamestnavatel_nazev') ?> <sup>7)</sup></div>
                    </div>

                    <div class="col col-12 col-md-1">
                        <div></div>
                    </div>


                    <div class="col col-12 col-md-8">
                        <label title="<?= ronText('')?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikNazevPlatce"
                                   value="<?= $hodnotyProhlaseni->jinyPoplatnikNazevPlatce ?>" <?= $disabled ?>>
                        </label>
                    </div>
                </div>

                <hr class="oddelovac">

                <div class="row align-center">
                     <div class="col col-12 col-md-3 align-left">
                        <div><?= ronText('Prohlaseni_platce_dane_partner_zamestnavatel_adresa') ?> <sup>7)</sup></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= ronText('Prohlaseni_jinyPoplatnikObec') . '&nbsp;'  ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <label title="<?= ronText('')?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikObecPlatce"
                                   value="<?= $hodnotyProhlaseni->jinyPoplatnikObecPlatce ?>" <?= $disabled ?>>
                        </label>
                    </div>
                </div>

                <div class="row align-center">
                     <div class="col col-12 col-md-2">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-2 align-right">
                        <div><?= ronText('Prohlaseni_jinyPoplatnikUlice') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikUlicePlatce"
                               value="<?= $hodnotyProhlaseni->jinyPoplatnikUlicePlatce ?>" <?= $disabled ?>>
                    </div>
                </div>

                <div class="row align-center">
                     <div class="col col-12 col-md-2">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-2 align-right">
                        <div><?= ronText('Prohlaseni_jinyPoplatnikPSC') . '&nbsp;'  ?> </div>
                    </div>

                      <div class="col col-12 col-md-8">
                        <label title="<?= ronText('')?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikPSCPlatce"
                                   value="<?= $hodnotyProhlaseni->jinyPoplatnikPSCPlatce ?>" <?= $disabled ?>>
                        </label>
                    </div>
                </div>

            </div>

            <?php if ($jednoduchyVzhled) { ?>
                <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte8"></div>
            <?php } ?>

            <div id="dane_info_skryte8" <?= $classStr ?>>
                <div class="info">*<sup>)</sup>&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_doplneni_partnera")?></div>
                <div class="info"><sup>6)</sup>&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_za_6")?></div>
                <div class="info"><sup>6a)</sup>&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_za_6a")?></div>
                <div class="info"><sup>7)</sup>&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_za_7")?></div>

                <br>

                <div class="info"><?= ronText("Prohlaseni_dle_paragrafu_38_zmena")?></div>
                <br>
                <div class="info"><?= ronText("Prohlaseni_dle_paragrafu_38_nepravdive_prohlaseni")?></div>

            </div>

            <?php
                DaneController::zobrazDokumentyProhlaseni($database, $rok, $pracovniPomer, 'partner', $editovatelne);
            ?>
            <?php } ?>

            <div class="row">
                <div class="col col-12 col-md-12 center">
                    <h2><?= ronText("Mzdy_podpisova_cast")?></h2>
                </div>
            </div>

            <div class="col col-12 col-md-12 center">
                <h3><?= ronText("Mzdy_podpisova_cast_pravdivost")?></h3>
            </div>


            <div class="form-content ram">
                <div class="row">
                    <div class="col col-12 col-md-4 center">
                        <?= ronText("")?>
                    </div>

                    <div class="col col-12 col-md-4 center">
                        <?php echo sprintf(ronText("Mzdy_prokazatelne_ucinene_prohlaseni_poplatnikem"), '<sup>8)</sup>' )?>
                    </div>

                    <div class="col col-12 col-md-4 center">
                        <?php echo sprintf(ronText("Mzdy_overeni_platcem_dane"), '<sup>9)</sup>' )?>
                    </div>
                </div>


                <hr class="oddelovac">



                <div class="row align-center">
                     <div class="col col-12 col-md-4">
                        <div><?= ronText('Mzdy_na_uvedene_zdanovaci_obdobi') ?> </div>
                    </div>

                    <div class="col col-12 col-md-4">

                        <div> <?= StringUtils::htmlTextConvert($hodnotyProhlaseni->elektronickyPodpis) ?> </div>
                    </div>

                    <div class="col col-12 col-md-4">
                        <div> <?= StringUtils::htmlTextConvert($hodnotyProhlaseni->elektronickyPodpisUcetni) ?>  </div>
                    </div>
                </div>


                <div class="row align-center">
                     <div class="col col-12 col-md-4">
                        <div><?= ronText('Mzdy_dodatecne_na_uvedene_zdanovaci_obdobi') ?> </div>
                    </div>

                    <div class="col col-12 col-md-4">
                        <div><?= StringUtils::htmlTextConvert($hodnotyProhlaseni->elektronickyPodpisDodatecne) ?> </div>
                    </div>

                    <div class="col col-12 col-md-4">
                        <div><?= StringUtils::htmlTextConvert($hodnotyProhlaseni->elektronickyPodpisUcetniDodatecne) ?> </div>
                    </div>
                </div>

            </div>
            <?php if ($jednoduchyVzhled) { ?>
                <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte9"></div>
            <?php } ?>

            <div id="dane_info_skryte9" <?= $classStr ?>>
                <div class="info"><sup>8)</sup>&nbsp;<?= ronText("Mzdy_za_osme")?></div>
                <div class="info"><sup>9)</sup>&nbsp;<?= ronText("Mzdy_za_devate")?></div>
            </div>

            <?php if($povolenoVyplneniElektronicky && $hodnotyProhlaseni->prohlaseniPortalStav == 1 && $zmenaProhlaseni == 1) {?>

            </div>

            <br>

            <div class='form large-form prohlaseni-poplatnika'>

                <div class="row zmenova-cast-scroll">
                    <div class="col col-12 col-md-12 center">
                        <br>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h2><?= ronText("Prohlaseni_podpisova_cast_zmenove_casti")?></h2>
                    </div>
                </div>

                <br>

                <?php if ($hodnotyProhlaseni->prohlaseniPortalStav == 1 && $hodnotyProhlaseni->prohlaseniPortalZmenaStav == 2) { ?>
                    <div class="errortext align-center">
                        <?= $hodnotyProhlaseni->poznamkaProZamestnance ?>
                    </div>
                    <br>
                <?php } ?>

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h2><?= ronText("Prohlaseni_historie_zmen_v_prubehu_roku")?></h2>
                    </div>
                </div>

                <div class="form-content ram">

                        <div class="row">
                            <div class="col col-12 col-md-3 center">
                                <?= ronText("Prohlaseni_druh_zmeny")?>
                            </div>

                            <div class="col col-12 col-md-2 center">
                                <?= ronText("Prohlaseni_kalendarni_mesic_rozhodnuti_zmeny")?>
                            </div>

                            <div class="col col-12 col-md-3 center">
                                <?php echo sprintf(ronText("Prohlaseni_podpis_poplatnika_zmeny"), '<sup>10)</sup>' )?>
                            </div>

                            <div class="col col-12 col-md-4 center">
                                <?php echo sprintf(ronText("Mzdy_overeni_platcem_dane"), '<sup>9)</sup> <sup>10)</sup>' )?>
                            </div>
                        </div>

                        <hr class="oddelovac">

                    <?php $pocetZmen = count($historieZmenOdpoctu); $cnt = 0; foreach ($historieZmenOdpoctu as $radekOdpoctu) { ++$cnt; ?>
                        <div class="row align-center">
                             <div class="col col-12 col-md-3">
                                <div class="align-left">
                                    <?= $radekOdpoctu['zmenyTextove'] ?>
                                </div>
                            </div>

                             <div class="col col-12 col-md-2">
                                <div> <?= $radekOdpoctu['datumOd'] != "" ? date("j.n.Y", $radekOdpoctu['datumOd']) : "" ?> </div>
                            </div>

                            <div class="col col-12 col-md-3">
                                <div> <?= StringUtils::htmlTextConvert($radekOdpoctu['elektronickyPodpis']) ?> </div>
                            </div>

                            <div class="col col-12 col-md-4">
                                <div> <?= StringUtils::htmlTextConvert($radekOdpoctu['elektronickyPodpisUcetni']) ?>  </div>
                            </div>
                        </div>

                        <?php if ($pocetZmen > $cnt) { ?>
                            <br>
                        <?php } ?>

                    <?php } ?>
                </div>

                <br>

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h2><?= ronText("Prohlaseni_zmenova_cast")?></h2>
                    </div>
                </div>

                <div class="col col-12 col-md-12 center">
                    <h3><?= ronText("Prohlaseni_dle_paragrafu_38_odst_8")?></h3>
                </div>

                <div class="form-content ram">
                    <input type="hidden" name="zmenova_cast_ProhlaseniPortalZmenaStav_old" value="<?= $hodnotyProhlaseni->prohlaseniPortalZmenaStav ?>">
                    <input type="hidden" name="zmenova_cast_datumOd_old" value="<?= $zmenyOdpoctu->datumOd ?>">
                    <input type="hidden" name="zmenova_cast_pozadujiUpravuSlev_old" value="<?= $zmenyOdpoctu->datumOd != "" ? 1 : 0; ?>">
                    <input type="hidden" name="zmenova_cast_stav_zmeny_old" value="<?= $zmenyOdpoctu->stav ?>">
                    <input type="hidden" name="zmenova_cast_kalendarni_mesice_nastale_zmeny_old" value="<?= $zmenyOdpoctu->mesicZmeny ?>">
                    <input type="hidden" name="zmenova_cast_datumZmenyOdOdpocetNavrh" value="<?= $zmenyOdpoctu->datumOd ?>">
                    <input type="hidden" name="zmenova_cast_zakladniOdpocet_old" value="<?= $zmenyOdpoctu->zakladniOdpocet ?>">
                    <input type="hidden" name="zmenova_cast_odpocetNaStudenta_old" value="<?= $zmenyOdpoctu->odpocetNaStudenta ?>">
                    <input type="hidden" name="zmenova_cast_naZdravotniStav_old" value="<?= $zmenyOdpoctu->naZdravotniStav ?>">
                    <input type="hidden" name="zmenova_cast_datumVlozeniNavrhu" value="<?= $zmenyOdpoctu->datumVlozeniNavrhu ?>">

                    <div class="row">
                            <?php if( $hodnotyProhlaseni->prohlaseniPortalStav == 1) {?>
                                <div class="col col-12 col-md-2 ">
                                    <?= ronText('aktualni_stav')?>
                                </div>

                                <div class="col col-12 col-md-2 ">
                                    <?= ronText('pozaduji_zmenu')?>

                                    <?php //DatumOd, ZakladniOdpocet, OdpocetNaStudenta, NaZdravotniStav, Stav, {fn_CASTWIDEMEMO(ElektronickyPodpis)}
                                        $pozadujeZmenyVPrubehuRoku = $zmenyOdpoctu->datumOd ? "checked" : "";
                                    ?>
                                    <input type="checkbox" id="zmenova_cast_pozadujiUpravuSlev" name="zmenova_cast_pozadujiUpravuSlev" value="1" <?= $pozadujeZmenyVPrubehuRoku ?> >
                                </div>

                                <div class="col col-12 col-md-8 ">
                                    <?= ronText("Prohlaseni_mesic_zmeny") . "&nbsp;" ?>
                                    <?php $comboMesicNastaleZmeny->render(); ?>
                                </div>
                            <?php } else { ?>
                                <div><?= ronText('aktualni_stav')?></div>
                            <?php }?>
                    </div>

                    <div class="row">
                                <div class="col col-12 col-md-2 ">
                                    <label>
                                        <select id="zakladni_odpocet_zobrazeni" disabled="disabled">
                                            <option value="0"  <?= $historieOdpoctu['zmeny']['zakladniOdpocet'] == 0 ? "selected" : "" ?> ></option>
                                            <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                <option value="1" <?= $historieOdpoctu['zmeny']['zakladniOdpocet'] == 1 ? "selected" : "" ?>  >X</option>
                                            <?php }  ?>
                                        </select>
                                    </label>
                                </div>


                                <div class="col col-12 col-md-2 ">
                                    <?php if($povolenoVyplneniElektronicky && $hodnotyProhlaseni->prohlaseniPortalStav == 1) {?>
                                            <label>
                                                <select class="zmenova_cast_uprava_slevy_poplatnika" id="zmenova_cast_zakladniOdpocet" name="zmenova_cast_zakladniOdpocet" disabled>
                                                    <option value="0"  <?= $zmenyOdpoctu->zakladniOdpocet == 0 ? "selected" : "" ?> ></option>
                                                    <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                        <option value="1" <?= $zmenyOdpoctu->zakladniOdpocet == 1 ? "selected" : "" ?> >X</option>
                                                    <?php }  ?>
                                                </select>
                                            </label>
                                    <?php }?>
                                </div>

                                <div class="col col-12 col-md-8 font-weight-bold">
                                    <?= ronText("zakladni_sleva_poplatnika")?>
                                </div>
                    </div>

                    <div class="row">
                                <div class="col col-12 col-md-2 ">
                                    <label>
                                        <select id="na_zdravotni_stav1_zobrazeni" disabled="disabled">
                                            <option value="0" <?= $historieOdpoctu['zmeny']['naZdravotniStav'] == 0 ? "selected" : "" ?>></option>
                                            <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                <option value="1" <?= $historieOdpoctu['zmeny']['naZdravotniStav'] == 1 ? "selected" : "" ?> >X</option>
                                            <?php }  ?>
                                        </select>
                                    </label>
                                </div>

                                <?php if($povolenoVyplneniElektronicky && $hodnotyProhlaseni->prohlaseniPortalStav == 1 ) {?>
                                    <div class="col col-12 col-md-2 ">
                                        <label>
                                            <select class="slevaNaInvaliditu zmenova_cast_uprava_slevy_poplatnika" id="zmenova_cast_naZdravotniStavVolba1" name="zmenova_cast_naZdravotniStavVolba[]" disabled >
                                                <option value="0" <?= $zmenyOdpoctu->naZdravotniStav == 0 ? "selected" : "" ?>></option>
                                                <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                    <option value="1" <?= $zmenyOdpoctu->naZdravotniStav == 1 ? "selected" : "" ?> >X</option>
                                                <?php }  ?>
                                            </select>
                                        </label>
                                    </div>
                                 <?php }?>

                                <div class="col col-12 col-md-8 info">
                                    <div class="font-weight-bold float-left"><?= ronText("zakladni_sleva_na_invaliditu") ?></div>
                                    <?php if ($jednoduchyVzhled) { ?>
                                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte11"></div>
                                    <?php } ?>

                                    <div id="dane_info_skryte11" <?= $classStr ?>>
                                        <?= ronText("zakladni_sleva_na_invaliditu_info")?>
                                    </div>
                                </div>
                    </div>

                    <div class="row">
                                <div class="col col-12 col-md-2 ">
                                    <label>
                                        <select id="naZdravotniStav2" disabled="disabled">
                                            <option value="0" <?= $historieOdpoctu['zmeny']['naZdravotniStav'] == 0 ? "selected" : "" ?>></option>
                                            <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                <option value="1" <?= $historieOdpoctu['zmeny']['naZdravotniStav'] == 2 ? "selected" : "" ?> >X</option>
                                            <?php } ?>
                                        </select>
                                    </label>
                                </div>

                                <?php if($povolenoVyplneniElektronicky && $hodnotyProhlaseni->prohlaseniPortalStav == 1 ) {?>
                                    <div class="col col-12 col-md-2 ">
                                        <label>
                                            <select class="slevaNaInvaliditu zmenova_cast_uprava_slevy_poplatnika" id="zmenova_cast_naZdravotniStavVolba2"  name="zmenova_cast_naZdravotniStavVolba[]" disabled >
                                                <option value="0" <?= $zmenyOdpoctu->naZdravotniStav == 0 ? "selected" : "" ?>></option>
                                                <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                    <option value="2" <?= $zmenyOdpoctu->naZdravotniStav == 2 ? "selected" : "" ?> >X</option>
                                                <?php } ?>
                                            </select>
                                        </label>
                                    </div>
                                 <?php }?>

                                <div class="col col-12 col-md-8 info">
                                    <div class="font-weight-bold float-left"><?= ronText("rozsirenou_sleva_na_invaliditu")?></div>

                                    <?php if ($jednoduchyVzhled) { ?>
                                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte12"></div>
                                    <?php } ?>

                                    <div id="dane_info_skryte12" <?= $classStr ?>>
                                        <?= ronText("rozsirenou_sleva_na_invaliditu_info")?>
                                    </div>
                                </div>
                    </div>

                    <div class="row">
                                <div class="col col-12 col-md-2 ">
                                    <label>
                                        <select id="ztpp_zobrazeni" disabled="disabled" >
                                            <option value="0" <?= $historieOdpoctu['zmeny']['ztpp'] == 0 ? "selected" : "" ?>></option>
                                            <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                <option value="1" <?= $historieOdpoctu['zmeny']['ztpp'] == 1 ? "selected" : "" ?>>X</option>
                                            <?php } ?>
                                        </select>
                                    </label>
                                </div>

                                <?php if($povolenoVyplneniElektronicky  && $hodnotyProhlaseni->prohlaseniPortalStav == 1) {?>
                                    <div class="col col-12 col-md-2 ">
                                        <label>
                                            <select id="ztpp" disabled="disabled" >
                                                <option value="0" <?= $historieOdpoctu['zmeny']['ztpp'] == 0 ? "selected" : "" ?>></option>
                                            <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                <option value="1" <?= $historieOdpoctu['zmeny']['ztpp'] == 1 ? "selected" : "" ?>>X</option>
                                            <?php } ?>
                                            </select>
                                        </label>
                                    </div>
                                 <?php }?>

                                <div class="col col-12 col-md-8 info">
                                    <div class="font-weight-bold float-left"><?= ronText("slevu_na_ztp")?></div>

                                    <?php if ($jednoduchyVzhled) { ?>
                                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte13"></div>
                                    <?php } ?>

                                    <div id="dane_info_skryte13" <?= $classStr ?>>
                                        <?= ronText("slevu_na_ztp_info")?>
                                    </div>
                                </div>
                    </div>

                    <div class="row">
                                <div class="col col-12 col-md-2 ">
                                    <label>
                                        <select id="odpocetNaStudenta_zobrazeni" disabled="disabled" >
                                            <option value="0" <?= $historieOdpoctu['zmeny']['odpocetNaStudenta'] == 0 ? "selected" : "" ?> ></option>
                                            <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                <option value="1" <?= $historieOdpoctu['zmeny']['odpocetNaStudenta'] == 1 ? "selected" : "" ?> >X</option>
                                            <?php } ?>
                                        </select>
                                    </label>
                                </div>

                                <?php if($povolenoVyplneniElektronicky && $hodnotyProhlaseni->prohlaseniPortalStav == 1 ) {?>
                                    <div class="col col-12 col-md-2 ">
                                        <label>
                                            <select class="zmenova_cast_uprava_slevy_poplatnika" id="zmenova_cast_odpocetNaStudenta" name="zmenova_cast_odpocetNaStudenta" <?= $disabled ?> >
                                                <option value="0" <?= $zmenyOdpoctu->odpocetNaStudenta == 0 ? "selected" : "" ?> ></option>
                                                <?php if ($chciPodepsatProhlaseni != 2) { ?>
                                                    <option value="1" <?= $zmenyOdpoctu->odpocetNaStudenta == 1 ? "selected" : "" ?> >X</option>
                                                <?php } ?>
                                            </select>
                                        </label>
                                    </div>
                                 <?php }?>

                                <div class="col col-12 col-md-8 info">
                                    <div class="font-weight-bold float-left"><?= ronText("slevu_na_studenta")?></div>

                                    <?php if ($jednoduchyVzhled) { ?>
                                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte14"></div>
                                    <?php } ?>

                                    <div id="dane_info_skryte14" <?= $classStr ?>>
                                        <?= ronText("slevu_na_studenta_info")?>
                                    </div>
                                </div>
                    </div>
                </div>

                <?php if ($jednoduchyVzhled) { ?>
                    <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte15"></div>
                <?php } ?>

                <div id="dane_info_skryte15" <?= $classStr ?>>
                    <div class="info"><sup>10)</sup>&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_za_10")?></div>
                </div>
                <div class="info"><?= ronText("Prohlaseni_zmenova_cast_naroku_na_deti_info")?></div>


                <!-- //TODO Druh zmeny           -->


                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h2><?= ronText("Prohlaseni_historie_zmen_slev_na_deti")?></h2>
                    </div>
                </div>

                <div class="form-content ram">

                        <div class="row">
                            <div class="col col-12 col-md-2 center">
                                <?= ronText("Prohlaseni_jmeno_ditete")?>
                            </div>

                             <div class="col col-12 col-md-2 center">
                                <?= ronText("Prohlaseni_poradi_ditete")?>
                            </div>

                            <div class="col col-12 col-md-1 center">
                                <?= ronText("Prohlaseni_kalendarni_mesic_rozhodnuti_zmeny")?>
                            </div>

                            <div class="col col-12 col-md-3 center">
                                <?php echo sprintf(ronText("Prohlaseni_podpis_poplatnika_zmeny"), '<sup>10)</sup>' )?>
                            </div>

                            <div class="col col-12 col-md-4 center">
                                <?php echo sprintf(ronText("Mzdy_overeni_platcem_dane"), '<sup>9)</sup> <sup>10)</sup>' )?>
                            </div>
                        </div>

                        <hr class="oddelovac">

                    <?php $pocetZmen = count($historieZmenOdpoctuNaDeti); $cnt = 0; foreach ($historieZmenOdpoctuNaDeti as $radekOdpoctuNaDeti) { ++$cnt; ?>
                        <div class="row align-center">
                             <div class="col col-12 col-md-2">
                                <div class="font-weight-bold">
                                    <?= $radekOdpoctuNaDeti['jmenoDitete'] ."&nbsp" ?><?= $radekOdpoctuNaDeti['prijmeniDitete'] ?>
                                </div>
                            </div>

                             <div class="col col-12 col-md-2">
                                <div class="">
                                    <?= $radekOdpoctuNaDeti['poradiDitete'] ?>
                                </div>
                            </div>


                             <div class="col col-12 col-md-1">
                                <div> <?= $radekOdpoctuNaDeti['datumOd'] != "" ? date("j.n.Y", $radekOdpoctuNaDeti['datumOd']) : "" ?> </div>
                            </div>

                            <div class="col col-12 col-md-3">
                                <div> <?= StringUtils::htmlTextConvert($radekOdpoctuNaDeti['elektronickyPodpis']) ?> </div>
                            </div>

                            <div class="col col-12 col-md-4">
                                <div> <?= StringUtils::htmlTextConvert($radekOdpoctuNaDeti['elektronickyPodpisUcetni']) ?>  </div>
                            </div>
                        </div>

                        <?php if ($pocetZmen > $cnt) { ?>
                            <br>
                        <?php } ?>

                    <?php } ?>
                </div>


                <br>
                <br>


                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h2><?= ronText("Prohlaseni_zmenova_cast_poradi_deti")?></h2>
                    </div>
                </div>


                <div class="form-content ram">


                    <div class="row">
                        <div class="col col-12 col-md-2 "></div>
                        <div class="col col-12 col-md-2 ">
                            <?= ronText('pozaduji_zmenu')?>

                            <?php $pozadujeZmenyPoradiDetiVPrubehuRoku = $zmenyOdpoctuNaDite['mesicZmeny'] ? "checked" : "";
                            ?>
                            <input type="checkbox" id="zmenova_cast_pozadujiUpravuPoradiDeti" name="zmenova_cast_pozadujiUpravuPoradiDeti" value="1" <?= $pozadujeZmenyPoradiDetiVPrubehuRoku ?> >
                            <input type="hidden" name="zmenova_cast_pozadujiUpravuPoradiDeti_old" value="<?= $zmenyOdpoctuNaDite['mesicZmeny'] != "" ? 1 : 0; ?>" >
                            <input type="hidden" name="zmenova_cast_kalendarniMesic_zmenyPoradiDeti_old" value="<?= $zmenyOdpoctuNaDite['mesicZmeny'] ?>" >
                        </div>

                        <div class="col col-12 col-md-4">
                            <?= ronText("Prohlaseni_mesic_zmeny") . "&nbsp;" ?>
                            <?php $comboMesicZmenyPoradiDeti->render(); ?>
                        </div>

                        <div class="col col-12 col-md-4 center"></div>
                    </div>


                    <br>


                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                            <?= ronText("Prohlaseni_jmeno_ditete")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= ronText("rc")?>
                        </div>

                        <div class="col col-12 col-md-3 ">
                            <?= ronText("uplatnuji_narok")?><sup>11)</sup>
                        </div>


                        <div class="col col-12 col-md-3 center">
                            <?= ronText("Prohlaseni_zmena_poradi")?>
                        </div>


                        <div class="col col-12 col-md-1 center">
                            <?= ronText("ZTP/P")?><sup>4)</sup>
                        </div>

                        <div class="col col-12 col-md-1 center">
                            <?= ronText("zletile_dite")?><sup>4)</sup>
                        </div>

                    </div>

                    <hr class="oddelovac">


                    <?php
                        $cnt = 0;

                        //Zobrazi zmeny - rozdil mezi $historieOdpoctuNaDeti['zmeny'] a $historieOdpoctuNaDeti['prohlaseni'] je v datumu pred podepsanim prohlaseni a po
                        if (!empty($historieOdpoctuNaDeti['zmeny'])){
                            $hodnotyHistorieOdpoctuNaDeti = $historieOdpoctuNaDeti['zmeny'];
                        } else {
                            $hodnotyHistorieOdpoctuNaDeti = $historieOdpoctuNaDeti['prohlaseni'];
                        }

                        //Pokud by z nejakeho duvodu byla historie prazdna neprovadet foreach
                        if (!empty($hodnotyHistorieOdpoctuNaDeti)){

                            foreach ($hodnotyHistorieOdpoctuNaDeti as $dite) {
                                $puvodniPoradiDitete = $dite['poradiDitete'];
                                $navrhZmenyPoradiDitete = $zmenyOdpoctuNaDite[$dite['rc_rodinnehoPrislusnika']]['poradiDitete'];
                                $datumVlozeniNavrhuZmenyPoradiDitete = $zmenyOdpoctuNaDite[$dite['rc_rodinnehoPrislusnika']]['datumVlozeniNavrhu'];
                            ?>

                        <input type="hidden" name="zmenova_cast_DatumVlozeniNavrhuUpravyPoradiDeti[<?= $dite['rc_rodinnehoPrislusnika'] ?>]" value="<?= $datumVlozeniNavrhuZmenyPoradiDitete != "" ? $datumVlozeniNavrhuZmenyPoradiDitete : ""; ?>" >
                        <input type="hidden" name="zmenova_cast_poradiDanovehoZvyhodneniNaDeti_old[<?= $dite['rc_rodinnehoPrislusnika'] ?>]" value="<?= $puvodniPoradiDitete; ?>" >

                        <div class="row">
                            <div class="col col-12 col-md-2">
                                <?= $dite['jmenoDitete'] . "&nbsp;" ?><?= $dite['prijmeniDitete'] ?>
                            </div>

                            <div class="col col-12 col-md-2">
                                <?= $dite['rodneCisloRP'] ?>
                            </div>

                            <div class="col col-12 col-md-3 center">
                                <?= ($dite['poradiDitete'] == 0 || $dite['poradiDitete'] == "") ? "N" : $dite['poradiDitete'] ?>
                            </div>

                            <div class="col col-12 col-md-3 center">

                                <label title="<?= ronText('zruseni_nahlaseni_zmeny_poradi_info')?>">
                                    <select class="zmenova-cast-uprava-poradi-slev-na-deti zmena-poradi-combo" name="zmenova_cast_poradiDanovehoZvyhodneniNaDeti[<?= $dite['rc_rodinnehoPrislusnika'] ?>]" >
                                        <option value="" <?= $navrhZmenyPoradiDitete == '' ? "selected" : "" ?> ><?php ronText('Prohlaseni_nezvoleno')?></option>
                                        <option value="0" <?= $navrhZmenyPoradiDitete === 0 ? "selected" : "" ?> >N</option>
                                        <option value="1" <?= $navrhZmenyPoradiDitete == 1 ? "selected" : "" ?> >1</option>
                                        <option value="2" <?= $navrhZmenyPoradiDitete == 2 ? "selected" : "" ?> >2</option>
                                        <option value="3" <?= $navrhZmenyPoradiDitete == 3 ? "selected" : "" ?> >3</option>
                                    </select>
                                </label>

                            </div>



                            <div class="col col-12 col-md-1 center">
                                <label>
                                    <input type="checkbox" <?= $dite['drzitelPrukazuZTTP'] == "1" ? 'checked' : "" ?> value="1" disabled >
                                </label>
                                <input type="hidden" name="<?= "old_dite_ztpp_" . $dite['rc_rodinnehoPrislusnika'] ?>" value="<?= $dite['drzitelPrukazuZTTP'] ?>">
                            </div>

                            <div class="col col-12 col-md-1 center">
                                <label>
                                    <input type="checkbox" <?= $dite['zletile'] == "1" ? 'checked' : "" ?> value="1" disabled>
                                </label>
                                <input type="hidden" name="<?= "old_zletile_" . $dite['rc_rodinnehoPrislusnika'] ?>" value="<?= $dite['zletile'] ?>">
                            </div>

                        </div>

                    <?php $cnt++; } } ?>
                    <input type="hidden" name="pocetDetiZmenyPoradi" value="<?= $cnt ?>">
                </div>

                <?php if ($jednoduchyVzhled) { ?>
                    <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte16"></div>
                <?php } ?>

                <div id="dane_info_skryte16" <?= $classStr ?>>
                    <div class="info"><sup>11)</sup>&nbsp;<?= ronText("Prohlaseni_dle_paragrafu_38_za_11")?></div>
                </div>

            <?php } ?>

            <br>
                <?php if ($jednoduchyVzhled) { ?>
                <div class="fa inline-glyph glyph-warning dane_info" data-selector="#dane_info_skryte10"></div>
            <?php } ?>

            <div id="dane_info_skryte10" <?= $classStr ?>>
                <div class="info font-weight-bold"><?= ronText("Prohlaseni_upozorneni_zmenova_cast_tucne")?></div>
                <div class="info"><?= ronText("Prohlaseni_upozorneni_zmenova_cast")?></div>
            </div>

            <div class="buttons">
                <input type="button" class="button clickHref" data-ron-href="?menuid=dane&osoba=<?= $pracovniPomer->idPP ?>" value="<?= ronText('zpet')?>">
                <?php if ($editovatelne) { ?>
                    <?php if ($chciPodepsatProhlaseni > 0) {  ?>
                        <button type="submit" class="button" name="podepsatprohlaseni" value="1"><?= ronText('potvrzuji_pravdivost_prohlaseni')?></button>
                    <?php } else { ?>
                        <button type="submit" title="<?= ronText('Mzdy_nepodepsat_info')?>" class="button" name="nepodepsatprohlaseni" value="1"><?= ronText('potvrzuji_pravdivost_prohlaseni')?></button>
                    <?php } ?>
                <?php } ?>

                <?php if($povolenoVyplneniElektronicky && $hodnotyProhlaseni->prohlaseniPortalStav == 1 && $zmenaProhlaseni == 1) {?>
                    <button type="button" class="button" id="zmenovaCastProhlaseni" name="zmenovaCastProhlaseni" value="1"><?= ronText('Prohlaseni_zmenova_cast_ulozit')?></button>
                <?php } ?>
            </div>

        </div>
    </form>
    <br>
<?php } ?>

