<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 12.02.2019
 */
//declare(strict_types=1);
namespace Ron\RonPortal;

use Ron\Controls\ComboBox;
use Ron\Controls\Options;
use Ron\MVC\Model;
use function Ron\ronText;


$model = Model::getInstance();


$adresa = $model->getData('adresa');
$partnerPoplatnika = $model->getData('partnerPoplatnika');
$rodne_cislo_z_ou = $model->getData('rodne_cislo_z_ou');

/** @var ZadostOZuctovaniZaloh $hodnotyZadosti */
$hodnotyZadosti = $model->getData('hodnotyZadosti');
$datumObdobi = $model->getData('datumObdobiRok');
$detiPoplatnika = $model->getData('detiPoplatnika');
$chybaPP = $model->getData('chybaPP');
$aktualniRok = date("Y", time());

/** @var Options $volby_comboboxu */
$volby_comboboxu = $model->getData('volby_comboboxu');

/** @var PracovniPomer $pracovniPomer */
$pracovniPomer = $model->getData('pracovniPomer');


//Tato volba se musi povolit v nastaveni - Mzdy
$povolitPoTerminu = (bool)(RonPortalSettings::getIntValue('zadostizuctovanidanepoterminu'));

if ($povolitPoTerminu) {
    $lzeEditovat = true;
} else {
    $lzeEditovat = (mktime(0, 0, 0, 2, 15, (int)date("y", time()))) > time();
}

//Pokud neni akt.datum
$lzeEditovat = $hodnotyZadosti->zadostPortalStav == 0 ? $lzeEditovat : false;
$disabled = $hodnotyZadosti->provestRocniVyuctovani && $lzeEditovat ? "" : "disabled";

?>


<?php if ($chybaPP)  { ?>

    <div class="form">
        <div class="form-content">
            <?=   ronText('formular_nelze_vyplnit') ?>
        </div>
        <div class="buttons">
            <input type="button" class="button clickHref" data-ron-href="?menuid=dane&action=zadost" value="<?= ronText('zpet')?>">
        </div>
    </div>

<?php } else { ?>

    <form method="post" name="formularzadosti" enctype="multipart/form-data" action="?menuid=dane&action=ulozitzadost">
        <input type="hidden" name="datumobdobi" value="<?= $datumObdobi ?>">
        <input type="hidden" name="osoba" value="<?= $pracovniPomer->idPP ?>">
        <input type="hidden" name="datumProhlaseniPortal" value="<?= $hodnotyZadosti->datumProhlaseniPortal ?>">
        <input type="hidden" name="skolkovne_max" value="<?= $detiPoplatnika[0]['maxVyseSkolkovneho'] ?>">

        <div class='form large-form zadost-zuctovani'>
            <div class="form-content">

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h1> <?= ronText("zadost") . ($lzeEditovat ? " - " . ronText("zadost_nezadam") : "") ?> </h1>
                    </div>
                </div>

                 <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h3><?= ronText("zadost_za_zdanovaci_obdobi")?>
                            <label>
                                <?php //"Žádost a o roční zúčtování záloh" je za předchozí rok ?>
                                <?= date('Y', $datumObdobi); ?>
                            </label>
                        </h3>
                    </div>
                </div>


                <?php if ($hodnotyZadosti->datumProhlaseniPortal == "") { ?>
                    <div class="row">
                        <div class="col col-12 col-md-12 errorcolor ">
                            <h3>
                                <?= sprintf(ronText('zadost_poznamka_k_nevyplnenemu_prohlaseni'), date("Y", time())) ?>
                            </h3>
                        </div>
                    </div>
                <?php } ?>


                <div class="form-content ram">
                    <div class="row">
                        <div class="col col-12 col-md-12 bold">
                            <?= ronText("identifikace_poplatnika")?>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col col-12 col-md-4 ">
                            <?= ronText('prijmeni'). ": " ?><span class="bold"><?=  $pracovniPomer->prijmeni ?></span>
                        </div>

                        <div class="col col-12 col-md-4">
                            <?= ronText('jmeno'). ": " ?><span class="bold"><?=  $pracovniPomer->jmeno ?></span>
                        </div>

                        <div class="col col-12 col-md-4">
                            <?= ronText('rodne_cislo'). ": " ?><span class="bold"><?=  $rodne_cislo_z_ou ?></span>
                        </div>
                    </div>

                    <br>
                    <div class="row">
                        <div class="col col-12 col-md-12 bold">
                            <?= ronText("adresa_trvaleho_bydliste")?>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col col-12 col-md-3">
                            <?= ronText('mesto'). ": " ?><span class="bold"><?= $adresa['mesto']?></span>
                        </div>

                        <div class="col col-12 col-md-3">
                            <?= ronText('ulice'). ": " ?><span class="bold"><?= $adresa['ulice']?></span>
                        </div>

                        <div class="col col-12 col-md-3">
                            <?= ronText('obec'). ": " ?><span class="bold"><?= $adresa['obecPopis']?></span>
                        </div>

                        <div class="col col-12 col-md-3">
                            <?= ronText('psc'). ": " ?><span class="bold"><?= $adresa['psc']?></span>
                        </div>
                    </div>

                    <br>

                    <div class="row">
                        <div class="col col-12 col-md-4 bold">
                            <?= ronText("nerezident_datum_narozeni")?>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col col-12 col-md-3">
                            <?= ronText("cislo_typ_dokladu")?>
                        </div>

                        <div class="col col-12 col-md-2">
                            <?= $hodnotyZadosti->cisloDanoveIdentifikace ?>
                        </div>

                        <div class="col col-12 col-md-2">
                            <?= $hodnotyZadosti->typDanovehoIdentifikatoru_popis ?>
                        </div>

                        <div class="col col-12 col-md-2">
                            <?= ronText("stat_nerezidenta")?>
                        </div>

                        <div class="col col-12 col-md-2">
                            <?= $hodnotyZadosti->statDanoveRezidence_popis ?>
                        </div>
                    </div>
                </div>


                <div class="row">
                    <div class="col col-12 col-md-11 info">
                        <?= ronText("nejsem_povinen_podat")?>
                    </div>
                </div>

                <br>

                <div class="row">
                    <div class="col col-12 col-md-12 bold">
                        <?= ronText("zadost_uvadim_prijmy_za_obdobi")?>
                    </div>
                </div>

                <div class="form-content ram">
                    <div class="row">
                        <div class="col col-12 col-md-3 center">
                            <?= ronText("v_kalendarnich_mesicich")?>
                        </div>
                        <div class="col col-12 col-md-9 center">
                            <?= ronText("zadost_identifikace_predchozich_platcu")?>
                        </div>
                    </div>

                    <hr class="oddelovac">

                    <?php $predchoziPlatceDane = 3; for($i = 0; $i < $predchoziPlatceDane; $i++) { ?>
                        <div class="row">
                             <div class="col col-12 col-md-3">
                                <label title="<?= ronText('')?>">
                                    <input type="text" class="pole-zadosti filter-zadosti-od-do"
                                            name="predchoziplatcedanemesice_<?= $i ?>"
                                            placeholder="mm-mm" <?= $disabled ?>
                                            value="<?= $hodnotyZadosti->predchoziPrijmyKdyOdKoho[$i][0] ?>">
                                </label>
                            </div>

                            <div class="col col-12 col-md-9">
                                <label title="<?= ronText('')?>">
                                    <input type="text" class="pole-zadosti"
                                           name="predchoziplatcedaneadresa_<?= $i ?>"
                                           placeholder="<?php echo ronText('zadost_nazev_platce_dane') . ",    " .
                                              ronText('zadost_ico_platce_dane') . ",    " .
                                              ronText('adresa') . ",     "
                                              ?>" <?= $disabled ?>
                                            value="<?= $hodnotyZadosti->predchoziPrijmyKdyOdKoho[$i][1] ?>">
                                </label>
                            </div>
                        </div>

                    <?php }?>
                    <input type="hidden" name="pocetpredchozichplatcudane" value="<?= $i?>">

                </div>

                <div class="row">
                    <div class="col col-12 col-md-12  info">
                        <sup>1)</sup>
                        <?= ronText("zadost_za_prve")?>
                    </div>
                </div>

                <br>

                <div class="row">
                    <div class="col col-12 col-md-12 bold info">
                        <?= ronText("zadost_uplatnuji_narok_na")?>
                    </div>
                </div>

                <br>
                <br>

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h2><?= ronText("zadost_slevy_na_dani")?></h2>
                    </div>
                </div>

                 <div class="row">
                    <div class="col col-12 col-md-12 info">
                        <?= ronText("zadost_sleva_na_manzelku")?>
                    </div>
                </div>


                <div class="form-content ram">
                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                            <?= ronText("jmeno")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= ronText("prijmeni_partnera")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= ronText("rc")?>
                        </div>

                        <div class="col col-12 col-md-2 center">
                            <?= ronText("zadost_narok_splnen_za")?><sup>2)</sup>
                        </div>

                        <div class="col col-12 col-md-2 center">
                            <?= ronText("ZTP/P")?>
                        </div>

                        <div class="col col-12 col-md-2 center">
                            <?= ronText("zadost_narok_splnen_za_ztp")?><sup>3a)</sup>
                        </div>

                    </div>

                    <hr class="oddelovac">

                    <div class="row">
                        <?php if ($partnerPoplatnika) { ?>
                        <div class="col col-12 col-md-2 ">
                            <?php /* ClenoveRodiny.RC, ClenoveRodiny.RC_RodinnehoPrislusnika, RodinnyPrislusnik.Jmeno, RodinnyPrislusnik.Prijmeni,
                      ClenoveRodiny.RodinnyVztah, ClenoveRodiny.PartnerDatumOd, ClenoveRodiny.PartnerDatumDo, RodinnyPrislusnik.DrzitelPrukazuZTTP, S_AnoNe.popis  */?>

                            <?= $partnerPoplatnika[2] ?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= $partnerPoplatnika[3] ?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= $partnerPoplatnika[1] ?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <label>
                                <input type="text" class="pole-zadosti filter-zadosti-od-do" name="slevanapartnera" id="slevanapartnera" placeholder="mm-mm" value="<?= $hodnotyZadosti->slevaNaPartnera ?>" <?= $disabled ?>>
                            </label>
                        </div>

                        <div class="col col-12 col-md-2 center">
                            <?= $partnerPoplatnika[7] == 1 ? "X" : "" ?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <label title="<?= ronText('zadost_rozsah_mesicu_naroku')?>">
                                <input type="text"
                                       class="pole-zadosti filter-zadosti-od-do"
                                       name="slevanapartneraproztp"
                                       id="slevanapartneraproztp"
                                       placeholder="mm-mm"
                                       value="<?= $hodnotyZadosti->slevaNaPartneraZtp ?>" <?= ($partnerPoplatnika[7] == 0) ? "disabled" : $disabled ?>>
                            </label>
                        </div>

                        <?php } ?>
                    </div>
                </div>


                 <div class="row">
                    <div class="col col-12 col-md-12  info">
                        <?= ronText("zadost_rozsah_mesicu")?>
                    </div>
                </div>


                 <div class="row">
                    <div class="col col-12 col-md-12  info">
                        <sup>2)</sup>
                        <?= ronText("zadost_za_druhe")?>
                    </div>
                </div>


                 <div class="row">
                    <div class="col col-12 col-md-12  info">
                        <sup>3a)</sup>
                        <?= ronText("zadost_za_treti_a")?>
                    </div>
                </div>

                <br>
                <br>

                  <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h2><?= ronText("zadost_skolkovne")?></h2>
                    </div>
                </div>

                 <div class="row">
                    <div class="col col-12 col-md-12 info">
                        <?= ronText("zadost_sleva_na_dite")?>
                    </div>
                </div>


                <div class="form-content ram">

                    <div class="row">
                        <div class="col col-12 col-md-3 ">
                            <?= ronText("jmeno")?>
                        </div>

                        <div class="col col-12 col-md-4 ">
                            <?= ronText("prijmeni_ditete")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= ronText("rc")?>
                        </div>


                        <div class="col col-12 col-md-3 center">
                            <?= sprintf(ronText('zadost_vynalozena_castka'), $detiPoplatnika[0]['maxVyseSkolkovneho']) ?>
                        </div>
                    </div>

                    <hr class="oddelovac">

                    <?php $cnt=0; ?>
                    <?php foreach ($detiPoplatnika as $dite) { ?>
                        <?php if($dite['diteDoSestiLet']){ ?>
                            <input type="hidden" name="ditepoplatnika_<?= $cnt ?>" value="<?= $dite['rc_rodinnehoPrislusnika'] ?>">
                            <input type="hidden" name="skolkovnenaditeold_<?= $dite['rc_rodinnehoPrislusnika']?>" value="<?= $dite['skolkovne'] ?>">

                            <div class="row">
                                <div class="col col-12 col-md-3 ">
                                    <?= $dite['jmeno'] ?>
                                </div>

                                <div class="col col-12 col-md-4 ">
                                    <?= $dite['prijmeni'] ?>
                                </div>

                                <div class="col col-12 col-md-3 ">
                                    <?= $dite['rodneCisloRP'] ?>
                                </div>

                                <div class="col col-12 col-md-2 ">
                                    <label>
                                        <input type="number" class="pole-zadosti"
                                               name="skolkovnenadite_<?= $dite['rc_rodinnehoPrislusnika']?>"
                                               min="0"
                                               max="<?= $detiPoplatnika[0]['maxVyseSkolkovneho']?>"
                                               value="<?= $dite['skolkovne'] ?>" <?= $disabled ?>>
                                    </label>
                                </div>
                            </div>
                        <?php } ?>
                        <?php $cnt++; ?>
                    <?php } ?>
                    <input type="hidden" name="pocetdetipoplatnika" value="<?= $cnt ?>">
                </div>

                 <div class="row">
                    <div class="col col-12 col-md-12 info">
                        <?= ronText("zadost_prohlaseni_na_dite_uplatnuji_pouze_ja")?>
                    </div>
                </div>

                <br>
                <br>

                <div class="row">
                    <div class="col col-12 col-md-12 center">
                        <h2><?= ronText("zadost_nezdanitelne_casti")?></h2>
                    </div>
                </div>

                <div class="form-content ram">
                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                            <?= ronText("zadost_casti_zakladu_dane_uplatnuji")?><sup>4)</sup>
                        </div>

                        <div class="col col-12 col-md-8 ">
                            <?= ronText("zadost_uplatnuji_nezdanitelne_casti_zakladu")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= ronText("zadost_nezdanitelne_casti_uplatnovana_castka")?>
                        </div>
                    </div>

                    <hr class="oddelovac">

                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                             <?php ComboBox::renderComboFromArray($volby_comboboxu->data, 'zadostdaryzadam', $hodnotyZadosti->hodnotaDaru > 0 ? 1 : 0, "$disabled id='zadostdaryzadam'")?>
                        </div>

                        <div class="col col-12 col-md-8 ">
                            <?= ronText("zadost_nezdanitelne_bezuplatne")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <label>
                                <input type="number" class="pole-zadosti" name="zadostdaryvyse" min="0" value="<?= $hodnotyZadosti->hodnotaDaru ?>" <?= $disabled ?>>
                            </label>
                        </div>
                    </div>

                    <div class="mobile-only"><br></div>

                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                             <?php ComboBox::renderComboFromArray($volby_comboboxu->data, 'zadosturokyzadam', (int)!!($hodnotyZadosti->urokZeStavebSpor), "$disabled")?>
                        </div>

                        <div class="col col-12 col-md-8 ">
                            <?= ronText("zadost_nezdanitelne_uroky")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <label>
                                <input type="number" class="pole-zadosti" name="zadosturokyvyse" min="0" value="<?= $hodnotyZadosti->urokZeStavebSpor ?>" <?= $disabled ?>>
                            </label>
                        </div>
                    </div>

                    <div class="mobile-only"><br></div>

                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                             <?php ComboBox::renderComboFromArray($volby_comboboxu->data, 'zadostpenzijnizadam', (int)!!$hodnotyZadosti->penzijniPrip, "$disabled")?>
                        </div>

                        <div class="col col-12 col-md-8 ">
                            <?= ronText("zadost_nezdanitelne_penzijni")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <label>
                                <input type="number" class="pole-zadosti" name="zadostpenzijnivyse" min="0" value="<?= $hodnotyZadosti->penzijniPrip ?>" <?= $disabled ?>>
                            </label>
                        </div>
                    </div>

                    <div class="mobile-only"><br></div>

                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                             <?php ComboBox::renderComboFromArray($volby_comboboxu->data, 'zadostpojistnezadam', (int)!!$hodnotyZadosti->zivotniPojisteni, "$disabled")?>
                        </div>

                        <div class="col col-12 col-md-8 ">
                            <?= ronText("zadost_nezdanitelne_pojistne")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <label>
                                <input type="number" class="pole-zadosti" name="zadostpojistnevyse" min="0" value="<?= $hodnotyZadosti->zivotniPojisteni ?>" <?= $disabled ?>>
                            </label>
                        </div>
                    </div>

                    <div class="mobile-only"><br></div>

                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                             <?php ComboBox::renderComboFromArray($volby_comboboxu->data, 'zadostclenskezadam', (int)!!$hodnotyZadosti->clenskePrispevky, "$disabled")?>
                        </div>

                        <div class="col col-12 col-md-8 ">
                            <?= ronText("zadost_nezdanitelne_clenske")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <label>
                                <input type="number" class="pole-zadosti" name="zadostclenskevyse" min="0" value="<?= $hodnotyZadosti->clenskePrispevky ?>" <?= $disabled ?>>
                            </label>
                        </div>
                    </div>

                    <div class="mobile-only"><br></div>


                    <div class="row">
                        <div class="col col-12 col-md-2 ">
                             <?php ComboBox::renderComboFromArray($volby_comboboxu->data, 'zadostuhradazazkouskyzadam', (int)!!$hodnotyZadosti->uhradZaZkousky, "$disabled")?>
                        </div>

                        <div class="col col-12 col-md-8 ">
                            <?= ronText("zadost_nezdanitelne_uhrada")?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <label>
                                <input type="number" class="pole-zadosti" name="zadostuhradazazkouskyvyse" min="0" value="<?= $hodnotyZadosti->uhradZaZkousky ?>" <?= $disabled ?>>
                            </label>
                        </div>
                    </div>
                </div>


                 <div class="row">
                    <div class="col col-12 col-md-12 info">
                        <sup>4)</sup>
                        <?= ronText("zadost_za_ctvrte")?>
                    </div>
                </div>

                 <div class="row">
                    <div class="col col-12 col-md-12 info">
                        <sup>4a)</sup>
                        <?= ronText("zadost_za_ctvrte_a")?>
                    </div>
                </div>

                <br>

                <div class="row">
                    <div class="col col-12 col-md-12 info bold">
                        <?= ronText("zadost_prohlaseni_k_nezdanitelne_casti")?>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-12 info ">
                        <?= ronText("zadost_prohlaseni_k_nezdanitelne_casti_info")?><sup>4b)</sup>
                    </div>
                </div>

                <br>

                <div class="form-content ram">
                    <div class="row">
                        <div class="col col-12 col-md-2 center">
                            <?= ronText("jmeno")?>
                        </div>

                        <div class="col col-12 col-md-2 center">
                            <?= ronText("prijmeni")?>
                        </div>

                        <div class="col col-12 col-md-2 center">
                            <?= ronText("rc")?>
                        </div>

                        <div class="col col-12 col-md-6 center">
                            <?= ronText("zadost_adresa_trvaleho_bydliste")?>
                        </div>
                    </div>

                    <hr class="oddelovac">

                    <?php $pocetJinychOsobUplatnujicichOdpocet = 5; for($i = 0; $i < $pocetJinychOsobUplatnujicichOdpocet; $i++) { ?>
                        <div class="mobile-only"><?= ronText('zadost_osoba') ?></div>
                        <div class="row">
                            <div class="col col-12 col-md-2">
                                <label title="<?= ronText('')?>">
                                    <input type="text" class="pole-zadosti"
                                           name="jinaosobauplatnujeodpocetjmeno_<?= $i ?>"
                                           value="<?= $hodnotyZadosti->osobyUplatnujiciUver[$i][0] ?>" <?= $disabled ?>>
                                </label>
                            </div>

                            <div class="col col-12 col-md-2">
                                <label title="<?= ronText('')?>">
                                    <input type="text" class="pole-zadosti"
                                           name="jinaosobauplatnujeodpocetprijmeni_<?= $i ?>"
                                           value="<?= $hodnotyZadosti->osobyUplatnujiciUver[$i][1] ?>" <?= $disabled ?>>
                                </label>
                            </div>


                            <div class="col col-12 col-md-2">
                                <label title="<?= ronText('')?>">
                                    <input type="text" class="pole-zadosti ronRC"
                                           name="jinaosobauplatnujeodpocetrc_<?= $i ?>"
                                           value="<?= $hodnotyZadosti->osobyUplatnujiciUver[$i][2] ?>" <?= $disabled ?>>
                                </label>
                            </div>

                            <div class="col col-12 col-md-6">
                                <label title="<?= ronText('')?>">
                                    <input type="text" class="pole-zadosti"
                                           name="jinaosobauplatnujeodpocetadresa_<?= $i ?>"
                                           placeholder="<?= ronText('obec') . ": " .
                                              ronText('mesto') . ": " .
                                              ronText('ulice') . ":  " .
                                              ronText('psc') . ":" ?>"
                                           value="<?= $hodnotyZadosti->osobyUplatnujiciUver[$i][3] ?>" <?= $disabled ?>>
                                </label>
                            </div>
                        </div>

                    <?php } ?>
                    <input type="hidden" name="pocetjinychosobuplatnujicichodpocet" value="<?= $pocetJinychOsobUplatnujicichOdpocet?>">

                </div>

                <div class="row">
                    <div class="col col-12 col-md-12 info ">
                        <sup>4b)&nbsp;</sup><?= ronText("zadost_za_ctvrte_b")?>
                    </div>
                </div>

                <br>

                <div class="row">
                    <div class="col col-12 col-md-12 info ">
                        <?= ronText("zadost_predmet_bytove_potreby")?>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-12 info bold">
                        <?= ronText("zadost_misto_bytove_potreby")?>
                    </div>
                </div>

                <div class="form-content ram">
                    <div class="row">
                        <div class="col col-12 col-md-12 ">
                            <input type="hidden" id="adresabytovepotrebyuveru" value="<?= ronText('obec') . ":" .  $adresa['obecPopis'] . ", \n" .
                                ronText('mesto') . ":" . $adresa['mesto'] . ", \n" .
                                ronText('ulice') . ":" . $adresa['ulice'] . ", \n" .
                                ronText('psc') . ":" . $adresa['psc'] ?>"  >

                            <label title="<?= ronText('zadost_pouzit_aktualni_adresu')?>">
                                <textarea name="zadostbytovepotrebyuveruadresa"
                                          id="zadostbytovepotrebyuveruadresa" rows="3" cols="115"
                                          placeholder="<?php echo ronText('obec') . ":     \n" .
                                              ronText('mesto') . ":     \n" .
                                              ronText('ulice') . ":      \n" .
                                              ronText('psc') . ":    " ?>" <?= $disabled ?>><?= $hodnotyZadosti->adresaBytovePotrebyUveru ?></textarea>
                            </label>
                        </div>
                    </div>
                </div>

            </div>

            <br>

            <div class="form-content zadost-zuctovani">
                 <div class="row">
                    <div class="col col-12 col-md-12 info">
                        <?= ronText("zadost_neopravnene_vyplaceni")?>
                    </div>
                </div>
            </div>
            <div class="buttons">
                <input type="button" class="button clickHref" data-ron-href="?menuid=dane" value="<?= ronText('zpet')?>">
                <?php if ($hodnotyZadosti->provestRocniVyuctovani && $lzeEditovat) { ?>
                    <?php if ($_GET['zadost'] > 0) {  ?>
                        <button type="submit" class="button"
                                title="<?= ronText('zadost_potvrzuji_pravdivost_zadosti_info')?>"
                                name="podepsatzadost"
                                value="1"><?= ronText('zadost_potvrzuji_pravdivost_zadosti')?>
                        </button>
                    <?php } else { ?>
                        <button type="submit" class="button" name="nepodepsatzadost" value="1"><?= ronText('zadost_potvrzuji_pravdivost_zadosti')?></button>
                    <?php } ?>
                <?php } ?>
            </div>
        </div>

        <br>

    </form>

<?php } ?>
