<?php
/**
 * UTF-8
 * roman.Szablatura 21.11.2016
 */

namespace Ron\RonPortal\Napady;

use Exception;
use Ron\Controls\ComboBox;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\DB\DBUtils;
use Ron\Http\HtmlHeaders;
use Ron\MessageManager;
use Ron\MVC\InternalRedirect;
use Ron\MVC\OutputObject;
use Ron\MVC\ViewObject;
use Ron\RonPortal\DokumentOutputObject;
use Ron\MVC\BaseViewObject;
use Ron\MVC\HttpController;
use Ron\MVC\Model;
use Ron\MVC\Redirect;
use Ron\RonPortal\DokumentUploadForm;
use Ron\RonPortal\DokumentUploadOutput;
use Ron\RonPortal\DokumentyBrowser;
use Ron\RonPortal\DokumentyUtils;
use Ron\RonPortal\Prava;
use Ron\RonPortal\PravaNaOsoby;
use Ron\RonPortal\RonPortalDBRecord;
use Ron\RonPortal\RonPortalUtils;
use Ron\RonPortal\User;
use Ron\StringUtils;
use Ron\TextManager;
use function Ron\ronText;

require_once('ron/controls.php');
require_once('adsapp/dokumentyutils.php');
require_once('adsapp/b_dokumenty.php');
require_once('adsapp/ronportaldbrecord.php');
require_once ('adsapp/ronportalform.php');
require_once ('napady/napad.php');

///**
// * Class NovyDokumentNapaduForm
// * @package Ron\RonPortal\Napady
// */
//class NovyDokumentNapaduForm extends DokumentUploadForm
//{
//
//    function __construct($database, $IDNapadu)
//    {
//        parent::__construct($database, '?menuid=napady&action=dokumentupload');
//
//        //Typ dokumentu false zobrazi combo v dialogu pro vyber typu dokumentu
//        //$this->typDokumentu = true;
//
//        $this->hiddenFields = [
//            'IDNapadu' => $IDNapadu,
//        ];
//    }
//}

/**
 * Class DokumentyNapaduBrowser
 * @package Ron\RonPortal\Napady
 */
class DokumentyNapaduBrowser extends DokumentyBrowser
{

    function __construct($database, $IDNapadu)
    {
        parent::__construct($database, "?menuid=napady&action=dokumentdownload&idnapadu=$IDNapadu", 1, "?menuid=napady&action=dokumentdelete&idnapadu=$IDNapadu");

        $this->sqlFromPart =
            'Dokument, TypDokumentu, DokumentNapadu';

        $this->sqlWherePart =
            'Dokument.Id = DokumentNapadu.Id ' .
            ' AND TypDokumentu.Kod = Dokument.Typ ' .
            " AND DokumentNapadu.IDNapadu = " . (int)$IDNapadu;
    }
}


/**
 * Class SpoluautoriBrowser
 * @package Ron\RonPortal\Napady
 */
/*
class SpoluautoriBrowser extends Browser
{
    function __construct($database, $id)
    {
        parent::__construct($database);

        $this->title = ronText('spoluautori');
        $this->code = 'browserspoluautori';
        $this->tableId = 'browserspoluautori';
        $this->defaultSort = 1;
        $this->primaryField = 0;
        $this->browserUrl = '?menuid=napady&action=zaznam&record=' . $id;

        $this->sqlSelectPart =
            "IDNapadu, Spoluautor.Jmeno, Spoluautor.Prijmeni, Spoluautor.RC, " .    //0 - 3
            "(SELECT MAX(ID) FROM PracovniPomer WHERE PracovniPomer.RC = Spoluautor.RC) IDOsoby , Spoluautor.Titul  ";    //4 - 5
        $this->sqlFromPart =
            "OsobaNapadu JOIN Osoba Spoluautor ON (OsobaNapadu.RC = Spoluautor.RC) ";
        $this->sqlWherePart =
            "IDNapadu = " . (int)$id;

        $this->addField([BROWSER_FIELD_SQL_INDEX => 1, BROWSER_FIELD_SQL_NAME => 'Spoluautor.Jmeno',
            BROWSER_FIELD_HEADER_TEXT => 'jmeno', BROWSER_FIELD_ORDERING => 1]);

        $this->addField([BROWSER_FIELD_SQL_INDEX => 2, BROWSER_FIELD_SQL_NAME => 'Spoluautor.Prijmeni',
            BROWSER_FIELD_HEADER_TEXT => 'prijmeni', BROWSER_FIELD_ORDERING => 1]);

        $this->addField([BROWSER_FIELD_SQL_INDEX => 5, BROWSER_FIELD_SQL_NAME => 'Spoluautor.Titul',
            BROWSER_FIELD_HEADER_TEXT => 'Titul', BROWSER_FIELD_ORDERING => 1]);

        $this->addField(new OdebraniSpoluautoraField());
    }
}
*/

/**
 * Class OdebraniSpoluautoraField
 * @package Ron\RonPortal\Napady
 */
/*
class OdebraniSpoluautoraField extends BrowserField
{
    function __construct()
    {
        parent::__construct();
        $this->header = ronText('odebrat_spoluautora');
        $this->align = 'center';
    }

    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        if ($rowData[0]) {
            $result = '';
            $result .= '<a href="?menuid=napady&action=spoluautordelete&idnapadu=' . $rowData[0] . '&idosoby=' . $rowData[4] . '">';
            $result .= "<i class='inline-glyph glyph-button fa glyph-delete' title='" .  ronText('odebrat_spoluautora') . "'></i></a>";
            return $result;
        }
        return '';
    }
}
*/

/**
 * Class NapadController
 * @package Ron\RonPortal\Napady
 */
class NapadController extends HttpController
{
    /** @var  Database */
    private $database;

    /** @var  PravaNaOsoby */
    private $prava;

    /** @var  PravaNaOsoby */
    private $prava_admin;

    /** @var  Napad $napad */
    private $napad;

    function __construct(Database $database)
    {
        $this->database = $database;
        $this->prava = Prava::vratPrava('napady');
        $this->prava_admin = Prava::vratPrava('napady_admin');
        Prava::nastavObdobiProPrava(time(), time());
    }

    /**
     * @param $formaction
     * @param $idnapadu
     * @return Redirect|NapadForm
     * @throws Exception
     */
    function napadForm($formaction, $idnapadu)
    {
        $pilotJeUrcen = false;
        $autorMuzeEditovat = true;
        $napad = '';


        if ($formaction == 'edit' || $formaction == 'save'){
            $this->jePravoNaNapad($idnapadu);

            $napad = $this->napad;

            //Editace priority a dalsich poli, ktere jsou v kompetenci pilota pokud je pilot uveden, prihlasena osoba je urcena jako pilot nebo se jedna o administratora
            if (($this->prava_admin->lzeZobrazitRC($napad->autorRC)) || ((($napad->pilotRC != '')) && $napad->pilotRC == User::getRC())){
                $pilotJeUrcen = true;
            }

            //Pokud pilot zadal vyjadreni neumoznit autorovi (mimo admina) editaci napadu - dokud bude nejake vyjadreni pilota
            //pokud pilot nema pravo na autora, pak mize editovat pouze svou oblast napadu tedy prioritu, vyjadreni atd.
            if ( !($napad->vyjadreniPilota == '' || $this->prava_admin->jsouNejakePrava() || $this->prava->lzeZobrazitRC($napad->autorRC)) ){
                $autorMuzeEditovat = false;
            }
        }

        require_once('napady/f_napad.php');
        $form = new NapadForm($this->database, $formaction, $this->prava, $this->prava_admin, $autorMuzeEditovat, $pilotJeUrcen, $napad);

        if ($form->handleAction()){
            return $this->redirectToView($form->id);
        }
        return $form;
    }

    private function redirectToView($id)
    {
        return new Redirect(null, '?menuid=napady&action=zaznam&record=' . $id );
    }

    /**
     * @param $id
     * @param $spoluautor
     * @return Redirect
     * @throws Exception
     */
    function novySpoluautor($id, $spoluautor)
    {
        //TODO
        if ($spoluautor != '') {
//            if (!($this->prava->jsouNejakePrava() || $this->prava_admin->jsouNejakePrava())) {
//                RonPortalUtils::neniPravoException();
//            }

            $this->jePravoNaNapad($id);

            require_once('adsapp/ronportaldbrecord.php');
            $params = $this->database->createParameters();
            $osobaRC = DBUtils::getSqlValue($this->database, "SELECT RC FROM PracovniPomer WHERE ID = " . $params->addParameter($spoluautor), $params);

            $rec = new RonPortalDBRecord($this->database, 'OsobaNapadu', $this);
            $rec->addField('IDNapadu', 'int', false, 0, (int)$id);
            $rec->addField('RC', '', false, 15, $osobaRC);

            $rec->insertRecord();

            return $this->redirectToView($id);
        }
        return $this->redirectToView($id);
    }

    /**
     * @param int $idNapadu
     * @param int $idDokumentu
     * @throws Exception
     */
    private function jePravoNaDokument($idNapadu, $idDokumentu)
    {
        $this->jePravoNaNapad($idNapadu);

        $params = $this->database->createParameters();

        //Kontrola, zdali existuje u dotycneho napadu prohlizeny dokument
        $sql =
            'SELECT DokumentNapadu.ID ' .
            'FROM DokumentNapadu LEFT JOIN Napad ON (DokumentNapadu.IDNapadu = Napad.ID) ' .
            "WHERE DokumentNapadu.IDNapadu = " . $params->addParameter($idNapadu) . " AND DokumentNapadu.ID = " . $params->addParameter($idDokumentu);

        $existujeDokument = DBUtils::getSqlValue($this->database, $sql, $params);

        if ($existujeDokument == ''){
            throw new Exception(ronText('Nemate_pravo'));
        }
    }

    /**
     * @return DokumentUploadOutput
     */
    function uploadDokument()
    {
        $result = new DokumentUploadOutput();

        try {
            if (!($this->prava->jsouNejakePrava() || $this->prava_admin->jsouNejakePrava())) {
                RonPortalUtils::neniPravoException();
            }

            // Vlozi dokument do databaze
            $id = DokumentyUtils::vlozDokument($this ->database, 'soubor', $_POST['typ'], $_POST['popis'], 'Dokument');

            $idNapadu = $_POST['IDNapadu'];

            // Vlozi id dokumentu k zaznamu DokumentNapadu
            require_once('adsapp/ronportaldbrecord.php');
            $rec = new RonPortalDBRecord($this ->database, 'DokumentNapadu', $this);
            $rec->addField('ID', 'int', true, 0, $id);
            $rec->addField('IDNapadu', 'int', true, 0, (int)$idNapadu);


            $rec->insertRecord();
        } catch (Exception $e) {
            $result ->setError($e ->getMessage());
        }
        return $result;
    }

    /**
     * @param int $idNapadu
     * @param int $idDokumentu
     * @return DokumentOutputObject
     * @throws Exception
     */
    function downloadDokument($idNapadu, $idDokumentu)
    {
        $this->jePravoNaDokument($idNapadu, $idDokumentu);

        return new DokumentOutputObject($this->database,$idDokumentu);
    }


    function nactiSpoluautory($idNapadu)
    {
        $params = $this ->database ->createParameters();
        $cursor = $this ->database ->getSqlResult(
            'SELECT Spoluautor.Jmeno, Spoluautor.Prijmeni, Spoluautor.Titul, Spoluautor.RC, ' .     // 0 - 3
            ' (SELECT MAX(ID) FROM PracovniPomer WHERE PracovniPomer.RC = Spoluautor.RC) IDOsoby' . // 4
            ' FROM OsobaNapadu JOIN Osoba Spoluautor ON (OsobaNapadu.RC = Spoluautor.RC)' .
            ' WHERE OsobaNapadu.IDNapadu = ' . $params ->addParameter($idNapadu),
            $params
        );

        $result = [];

        while ($row = $cursor ->fetch()) {
            $result[] = [
                'jmeno' => $row[0],
                'prijmeni' => $row[1],
                'titul' => $row[2],
                'rc' => $row[3],
                'id' => $row[4]
            ];
        }

        $cursor ->close();

        return $result;
    }

    /**
     * @param int $idNapadu
     * @return BaseViewObject
     * @throws Exception
     */
    private function zobrazDetailNapadu($idNapadu)
    {
        if (!$idNapadu){
            throw new Exception(ronText('napad_neexistuje'));
        }

        $this->jePravoNaNapad($idNapadu);

        $detailNapadu = $this->napad;

        // dokument upload form
        $dokumentUploadForm = new DokumentUploadForm($this->database, '?menuid=napady&action=dokumentupload');
        $dokumentUploadForm ->redirectUrl = '?menuid=napady&action=zaznam&record=' . $idNapadu;
        $dokumentUploadForm ->hiddenFields = [
            'IDNapadu' => $idNapadu,
        ];


        //DokumentyNapaduBrowser
        $dokumentBrowserNapadu = new DokumentyNapaduBrowser($this->database,(int)$idNapadu);
        $dokumentBrowserNapadu->load();

        //SpoluautoriFrom
//        $spoluautoriBrowser = new SpoluautoriBrowser($this->database, $idNapadu);
//        $spoluautoriBrowser->load();

        Model::addData('spoluautori', $this ->nactiSpoluautory($idNapadu));

        //comboProSpoluautory
        $comboSpoluautori = $this->comboPridaniSpoluautora($this->database, $idNapadu);

        Model::addData('napad', $detailNapadu);
        Model::addData('pravaNapadu', $this->prava);
        Model::addData('pravaNapaduAdmin', $this->prava_admin);
        Model::addData('dokumentUploadForm', $dokumentUploadForm);
        //Model::addData('spoluautoriBrowser', $spoluautoriBrowser);
        Model::addData('dokumentBrowserNapadu', $dokumentBrowserNapadu);
        Model::addData('comboSpoluautori', $comboSpoluautori);

        return new BaseViewObject('napady/view_napad.php');
    }


    /**
     * @param Database $database
     * @param $record
     * @return ComboBox
     * @throws Exception
     */
    function comboPridaniSpoluautora($database, $record)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT ' .
            ' (SELECT MAX(ID) FROM PracovniPomer WHERE PracovniPomer.RC = Spoluautor.RC ' .
            '  AND PracovniPomer.DatumNastupu <= ' . $params->addParameter($database ->dateToParam(DateUtils::today())) .
            '  AND (PracovniPomer.DatumUkonceni >= ' . $params->addParameter($database ->dateToParam(DateUtils::today())) . ' OR PracovniPomer.DatumUkonceni IS NULL)), ' .
            " COALESCE (Spoluautor.Prijmeni, '') {fn_concat()} ' ' {fn_concat()} COALESCE (Spoluautor.Jmeno, '') {fn_concat()} COALESCE (', ' {fn_concat()}  Spoluautor.Titul,'') Spoluautor " .

            " FROM Osoba Spoluautor WHERE (NOT EXISTS (select * from OsobaNapadu where (OsobaNapadu.rc = Spoluautor.rc) and (OsobaNapadu.IDNapadu = " . $params->addParameter($record ) . ")))" .
            " AND (NOT EXISTS (select * from Napad where (Napad.Autor = Spoluautor.rc) and (Napad.ID = " . $params->addParameter($record) . ")))" .
            " AND (NOT EXISTS (select * from Napad where (Napad.Pilot = Spoluautor.rc) and (Napad.ID = " . $params->addParameter($record) . ")))" .
            ' AND EXISTS(SELECT P.RC FROM PracovniPomer P WHERE (P.RC = Spoluautor.RC) AND (P.DatumNastupu <= ' . $params->addParameter($database ->dateToParam(DateUtils::today())) . ' ) ' .
            ' AND ((P.DatumUkonceni IS NULL) OR (P.DatumUkonceni >= ' . $params->addParameter($database ->dateToParam(DateUtils::today())) . ')) AND (P.Zamestnanec > 0))' .

            ' ORDER BY Spoluautor.Prijmeni, Spoluautor.Jmeno';

        $comboSpoluautori = new ComboBox('comboSpoluautori');
        $comboSpoluautori->emptyRow = '&nbsp;';
        $comboSpoluautori ->className .= 'form-input ronselect';
        $comboSpoluautori ->htmlParams = [
            'data-columns' => 'text'
        ];
        //$comboSpoluautori->className = "minwidth";
        $comboSpoluautori->loadData($database, $sql, null, $params);

        return $comboSpoluautori;
    }

    /**
     * @param int $idNapadu
     * @param int $idDokumentu
     * @return Redirect
     * @throws Exception
     */
    private function smazPripojenyDokument($idNapadu, $idDokumentu)
    {
        $this->jePravoNaDokument($idNapadu, $idDokumentu);

        try {
            //$this->smazDokument($idDokumentu);
            $params = $this ->database ->createParameters();

            DokumentyUtils::smazDokument($this ->database, (int)$idDokumentu, $this, 'DokumentNapadu',
                'IdNapadu = ' . $params ->addParameter($idNapadu), $params);

            MessageManager::addInfoMessage(ronText('napad_odstraneni_dokumentu_ok'));
        } catch (Exception $e) {
            MessageManager::addErrorMessage($e->getMessage());
        }

        return $this->redirectToView($idNapadu);
    }

//    /**
//     * @param $id
//     * @return bool
//     * @throws DBException
//     */
//    private function smazDokument($id)
//    {
//        $rec = new RonPortalDBRecord($this->database,'DokumentNapadu', $this);
//        $rec->addField('ID', 'int', true);
//        $rec->where = 'ID = ' . (int)$id;
//
//        if ($rec->deleteRecord()) {
//            $recDokument = new RonPortalDBRecord($this->database, 'Dokument', $this);
//            $recDokument->addField('ID', 'int', true);
//            $recDokument->where = 'ID = ' . (int)$id;
//
//            return $recDokument->deleteRecord();
//        }
//        return false;
//    }

    /**
     * @param $idNapadu
     * @param $idOsoby
     * @throws DBException
     * @throws Exception
     */
    private function smazSpoluautora($idNapadu, $idOsoby)
    {
        $this->jePravoNaNapad($idNapadu);

        $params = $this->database->createParameters();
        $osobaRC = DBUtils::getSqlValue($this->database,
            'SELECT RC FROM PracovniPomer WHERE ID = ' . $params->addParameter($idOsoby),
            $params);

        $recSpoluautor = new RonPortalDBRecord($this->database, 'OsobaNapadu', $this);
        $recSpoluautor->addIntField('IDNapadu', true);
        $recSpoluautor->addStringField('RC', true);

        $params = $this ->database ->createParameters();
        $recSpoluautor->setWhere(
            'RC = ' . $params ->addParameter($osobaRC) . ' AND IDNapadu = ' . $params ->addParameter((int)$idNapadu),
            $params);

        if ($recSpoluautor ->loadRecord()) {
            $recSpoluautor->deleteRecord();
        }
    }

    private function odebratSpoluautora($idNapadu, $idOsoby)
    {
        try {
            $this->smazSpoluautora($idNapadu, $idOsoby);
            MessageManager::addInfoMessage(ronText('odebrani_spoluautora_ok'));
        } catch (Exception $e) {
            MessageManager::addErrorMessage($e->getMessage());
        }
        return $this->redirectToView($idNapadu);
    }

    /**
     * @param int $idNapadu
     * @throws Exception
     */
    function jePravoNaNapad($idNapadu)
    {
        $this->napad = Napad::nactiNapad($this->database, $idNapadu);

        //Kontrola podle data napadu
        Prava::nastavObdobiProPrava($this->napad->datum, $this->napad->datum);

        //Zobrazení nápadu podle práv nebo je-li pilot nápadu alespoň s právy "napad"
        if ( !($this->prava->lzeZobrazitRC($this->napad->autorRC) || $this->prava_admin->lzeZobrazitRC($this->napad->autorRC) || $this->napad->pilotRC == User::getRC()) ) {
            throw new Exception(ronText('Nemate_pravo'));
        }
    }


    /**
     * @param string $action
     * @return BaseViewObject|InternalRedirect|OutputObject|Redirect|ViewObject|DokumentOutputObject|DokumentUploadOutput|NapadForm|NapadyBrowser|string
     * @throws DBException
     * @throws Exception
     */
    public function handleAction($action)
    {
        if (!($this->prava->jsouNejakePrava() || $this->prava_admin->jsouNejakePrava())){
            throw new Exception(ronText('Nemate_pravo'));
        }

        TextManager::getInstance()->loadStrings('napady.ini');
        HtmlHeaders::getInstance()->setTitle(\Ron\ronText('RON_Portal') . ' - ' . \Ron\ronText('napady'));

        if (isset($_POST['record'])) $idnapadu = $_POST['record'];
        else if (isset($_GET['record'])) $idnapadu = $_GET['record'];
        else $idnapadu = '';

        if (isset($_POST['formaction'])) $formaction = $_POST['formaction'];
        else if (isset($_GET['formaction'])) $formaction = $_GET['formaction'];
        else $formaction = '';

        if ($formaction) {
            // formulář (edit, insert)
            return $this ->napadForm($formaction, $idnapadu);
        }

        switch ($_GET['action']){

            case 'zaznam':
                return $this->zobrazDetailNapadu((int)$_GET['record']);

            case 'dokumentupload':
                return $this->uploadDokument();

            case 'dokumentdownload':
                return $this->downloadDokument((int)$_GET['idnapadu'], (int)$_GET['record']);

            case 'dokumentdelete' :
                return $this->smazPripojenyDokument((int)$_GET['idnapadu'], (int)$_GET['record']);

            case 'novyspoluautor':
                return $this->novySpoluautor((int)$_POST['id_napadu'], $_POST['comboSpoluautori']);

            case 'spoluautordelete' :
                return $this->odebratSpoluautora((int)$_GET['idnapadu'], (int)$_GET['idosoby']);

            default:
                require_once('napady/b_seznamnapadu.php');
                $b = new NapadyBrowser($this->database);
                $b->load();
                return $b;
        }
    }
}
