<?php
/** roman.Szablatura 29.11.2016  */

namespace Ron\RonPortal\Napady;

use Ron\MVC\Model;
use Ron\RonPortal\DokumentUploadForm;
use Ron\RonPortal\PravaNaOsoby;
use Ron\RonPortal\RonPortalSettings;
use Ron\RonPortal\User;
use Ron\StringUtils;
use function Ron\ronText;

$model = Model::getInstance();
/** @var Napad $napad */
$napad = $model->getData('napad');

/** @var PravaNaOsoby $pravaNapadu */
$pravaNapadu = $model->getData('pravaNapadu');

/** @var PravaNaOsoby $pravaNapaduAdmin */
$pravaNapaduAdmin = $model->getData('pravaNapaduAdmin');
$dokumentBrowserNapadu = $model->getData('dokumentBrowserNapadu');
$spoluautori = $model ->getData('spoluautori');
$comboSpoluautori = $model->getData('comboSpoluautori');

//Proměnné cyklu pro vytvoření tlačítek na procházení mezi jednotlivými nápady

$polepocetnapadufiltru = '';
$polenazvunapadu = '';

//Rozsekání obou session do polí
if ($_SESSION['pocetnapadufilru']) {
    $polepocetnapadufiltru = explode(",", $_SESSION['pocetnapadufilru']);
}
if ($_SESSION['seznamnapadu']) {
    $polenazvunapadu = explode(";;", $_SESSION['seznamnapadu']);
}
//Nulování pomocného seznamu titulku, aby se vždy uložila pouze čista aktuální data, budou sloužit k přidání ukazatele na aktuální název nápadu
$_SESSION['seznamnapadusukazatelem'] = '';
$polenazvunapadusukazatelem = '';
$predchozi = '';
$dalsi = '';

$pozice = '';
$pocetnapaduvefiltru = $polepocetnapadufiltru ? count($polepocetnapadufiltru) : 0;

//Cyklus pro vytvoření tlačítek na procházení mezi jednotlivými nápady přes detail s přidáním stručného vyčtu jmen nápadů (v titulku)s ukazatelem na kterém je fokus
if ($polepocetnapadufiltru) {
    for ($i = 0; $i < count($polepocetnapadufiltru); $i++) {


        if ($polepocetnapadufiltru[$i] == $_GET['record']) {
            //Přidání ukazatele na konkrétní nápad
            $pom = $polenazvunapadusukazatelem[$i] . '&#187;&#009' . $polenazvunapadu[$i];
            $polenazvunapadusukazatelem[$i] = $pom;

            $pozice = $i + 1;

            //Dokud je předchozí
            $mene = $i - 1;
            if ($mene >= 0) {
                $predchozi = $polepocetnapadufiltru[$mene];
            }

            //Dokud je následující
            $vice = $i + 1;
            if ($vice < count($polepocetnapadufiltru)) {
                $dalsi = $polepocetnapadufiltru[$vice];
            }

        } else {
            //Přidání tabulátoru
            $pom = $polenazvunapadusukazatelem[$i] . '&#009' . $polenazvunapadu[$i];
            $polenazvunapadusukazatelem[$i] = $pom;
        }
        //O5 sestavuji a přidávám odřádkování &#010 - LF
        $_SESSION['seznamnapadusukazatelem'] .= $polenazvunapadusukazatelem[$i] . '&#010';
    }
}
?>

<h1><?= ronText('detail_napadu')?> - <?= StringUtils::htmlTextConvert($napad->nazev) ?></h1>

<div class="form middle-form">
    <div class="form-content">

        <div class="row" id="row_stav_napadu">
            <div class="col col-4 caption" id="stav_napadu_popisek"><?= ronText('stav_napadu') ?></div>
            <div class="col col-4">
                <strong><?= StringUtils::htmlTextConvert($napad->stavNapaduPopis) ?></strong>
            </div>
            <div class="col col-4 align-right">
                <?php if ($pocetnapaduvefiltru > 1) { ?>
                    <?php if ($predchozi) { ?>
                        <a href="?menuid=napady&action=zaznam&record=<?= $predchozi?>" title="<?= ronText('predchozi_napady_filtru')?>"><span class="inline-glyph glyph-button margin-all-2">&lt;</span></a>
                    <?php } ?>

                    <?php if ($pozice) { ?>
                        <span class="margin-all-2" title="<?= $_SESSION['seznamnapadusukazatelem'] ?>"><?= $pozice . '/' . $pocetnapaduvefiltru ?></span>
                    <?php } ?>

                    <?php if ($dalsi) { ?>
                        <a href="?menuid=napady&action=zaznam&record=<?= $dalsi?>" title="<?= ronText('nasledujici_napady_filtru')?>"><span class="inline-glyph glyph-button margin-all-2">&gt;</span></a>
                    <?php } else { ?>
                        <span class="inline-glyph glyph-button margin-all-2">&nbsp;</span>
                    <?php } ?>
                <?php } ?>
            </div>
        </div>

        <?php if (trim($napad->pilotPrijmeniJmeno) != ''  ||  $pravaNapaduAdmin->jsouNejakePrava())  { //Pokud se jedna o administratora nebo pilota ?>
            <div class="row" id="row_pilot_napadu">
                <div class="col col-4 caption"><?= ronText('pilot') ?></div>

                <div class="col col-8">
                <?php if (trim($napad->pilotPrijmeniJmeno) != '') { ?>
                    <strong><?= StringUtils::htmlTextConvert($napad->pilotPrijmeniJmeno) ?></strong>
                <?php } else { ?>
                    <?php if ($pravaNapaduAdmin->jsouNejakePrava()) { ?>
                    <a id="odkaz_pilot" href="?menuid=napady&formaction=edit&record=<?= $napad->id?>"><?= ronText('prirazeni_pilota')  ?></a>
                    <?php } ?>
                <?php }?>
                </div>
            </div>
        <?php } ?>

        <div class="row" id="row_autor_napadu">
            <div class="col col-4 caption"><?= ronText('autor') ?></div>

            <div class="col col-8">
                <strong><?= StringUtils::htmlTextConvert($napad->autorPrijmeniJmeno) ?></strong>
            </div>
        </div>


        <div class="form-section" id="napad_section_detaily">
            <?= ronText('detaily') ?>
        </div>


        <div class="row" id="row_oblast_napadu">
            <div class="col col-4 caption"><?= ronText('oblast_napadu') ?></div>
            <div class="col col-8">
                <?= StringUtils::htmlTextConvert($napad->oblastNapaduPopis) . ($napad->oblast ? ' (' . StringUtils::htmlTextConvert($napad->oblast) . ')' : '') ?>
            </div>
        </div>

        <div class="row" id="row_priorita_napadu">
            <div class="col col-4 caption"><?= ronText('priorita') ?></div>
            <div class="col col-8"><strong><?= StringUtils::htmlTextConvert($napad->priorita) ?></strong></div>
        </div>

        <div class="row border-bottom margin-top-2" id="row_popis_napadu">
            <div class="col col-12 col-sm-4 caption"><?= ronText('podrobny_popis') ?></div>
            <div class="col col-12 col-sm-8 poznamka"><?= StringUtils::longTextToHtml(StringUtils::htmlTextConvert($napad->podrobnyPopis)) ?></div>
        </div>

        <div class="row" id="row_vyjadreni_pilota_napadu">
            <div class="col col-12 col-sm-4 caption" id="popis_vyjadreni" ><?= ronText('vyjadreni_pilota') ?></div>
            <div class="col col-12 col-sm-8 poznamka"><?= StringUtils::longTextToHtml(StringUtils::htmlTextConvert($napad->vyjadreniPilota)) ?></div>
        </div>

        <div class="row margin-top-2" id="row_rozpocet_napadu">
            <div class="col col-4 caption"><?= ronText('rozpocet') ?></div>
            <div class="col col-8"><?= StringUtils::format('number_2', $napad->rozpocet) ?></div>
        </div>

        <div class="row" id="row_odmena_napadu">
            <div class="col col-4 caption"><?= ronText('odmena') ?></div>
            <div class="col col-8"><?= StringUtils::format('number_2', $napad->odmenaCastka) ?></div>
        </div>

        <div class="row border-bottom" id="row_obdobi_odmeny_napadu">
            <div class="col col-4 caption"><?= ronText('obdobi_vyplaceni_odmeny') ?></div>
            <div class="col col-8"><?= StringUtils::format('date', $napad->odmenaVyplacenaVObdobi) ?></div>
        </div>

        <div class="row" id="row_napad_vlozil">
            <div class="col col-4 caption"><?= ronText('zaznam_vlozil') ?></div>
            <div class="col col-8">
                <?= StringUtils::htmlTextConvert($napad->insert_UserName) ?>
                <?= $napad->insert_Timestamp ? '(' . StringUtils::format('datetime', $napad->insert_Timestamp) . ')' : '' ?>
            </div>
        </div>

        <div class="row" id="row_napad_editoval">
            <div class="col col-4 caption"><?= ronText('naposled_editoval') ?></div>
            <div class="col col-8">
                <?= StringUtils::htmlTextConvert($napad->update_UserName) ?>
                <?= $napad->update_Timestamp ? '(' . StringUtils::format('datetime', $napad->update_Timestamp) . ')' : '' ?>
            </div>
        </div>
    </div>

    <div class="buttons">
        <div class="row">
            <div class="col col-4">
                <a href="?menuid=napady"><?= ronText('zpet_na_seznam')?></a>
            </div>

            <div class="col col-8">
                <?php if ( ($napad->vyjadreniPilota == '' || $pravaNapaduAdmin->jsouNejakePrava() || $napad->pilotRC == User::getRC()) ) { ?>
                    <a href="?menuid=napady&formaction=edit&record=<?= $napad->id?>"><?= ronText('editovat')?></a>
                <?php } else { ?>
                    <?= ronText('vlozeno_vyjadreni_pilota') ?>
                <?php } ?>
            </div>
        </div>
    </div>
</div>

<div id="dokumenty_napadu">
    <?php if ($pravaNapadu->lzeZobrazitRC($napad->autorRC) || $pravaNapaduAdmin->lzeZobrazitRC($napad->autorRC)) { ?>
        <?php $dokumentBrowserNapadu->render();  ?>

        <?php if(RonPortalSettings::getIntValue('pocetdokumentuknapadu',1) > $napad->pocetDokumentu) { ?>
            <a class="show-dokument-dialog" href="#" title="<?= ronText('mozny_pocet_dokumentu') . ': ' . RonPortalSettings::getIntValue('pocetdokumentuknapadu',1) ?>"><?= ronText('novy_dokument_napadu') ?></a>
        <?php }?>
        <?php
        /** @var DokumentUploadForm $form */
        $form = $model->getData('dokumentUploadForm');
        $form ->render();
        ?>
    <?php } ?>
</div>

<?php if ($pravaNapadu->lzeZobrazitRC($napad->autorRC) || $pravaNapaduAdmin->lzeZobrazitRC($napad->autorRC)) { ?>
<div id="spoluautori_napadu" class="margin-top-2">
    <h2><?= ronText('spoluautori') ?></h2>

    <form name="novy_autor" action="?menuid=napady&action=novyspoluautor" method="post">
        <input type="hidden" name="id_napadu" value="<?= $napad->id ?>">

        <div class="form middle-form">
            <div class="form-content">
                <?php if ($spoluautori) { ?>
                    <table>
                    <?php foreach ($spoluautori as $spoluautor) { ?>
                        <tr>
                            <td><?= StringUtils::htmlTextConvert($spoluautor['titul'] ?: '') ?> <?= StringUtils::htmlTextConvert($spoluautor['prijmeni']) ?> <?= StringUtils::htmlTextConvert($spoluautor['jmeno']) ?></td>
                            <td>
                                <a href="?menuid=napady&action=spoluautordelete&idnapadu=<?= $napad ->id ?>&idosoby=<?= $spoluautor['id'] ?>">
                                    <i class="inline-glyph glyph-button fa glyph-delete" title="<?= ronText('odebrat_spoluautora') ?>"></i>
                                </a>
                            </td>
                        </tr>
                    <?php } ?>
                    </table>
                <?php } ?>
                <div>
                    <?php $comboSpoluautori->render(); ?>
                </div>
                <div>
                    <input type="submit" class="button" value="<?= ronText('vlozit_spoluautora') ?>">
                </div>
            </div>
        </div>
    </form>
</div>
<?php } ?>
