<?php

/** UTF8
 * Pavel Rudol, RON Software
 *  15.7.2015
 */

namespace Ron\Personalistika;

require_once('adsapp/b_dokumenty.php');

use Ron\RonPortal\DokumentyBrowser;
use Ron\DB\Database;

class DokumentyDovednosti extends DokumentyBrowser
{
    var $idPP;

    /**
     * @param Database $database
     * @param int    $idPP
     */
    function __construct($database, $idPP)
    {
        //parent::__construct($database, "download.php?dovednostosoby=".  $idPP . "");
        parent::__construct($database, "?menuid=dovednosti&action=download&dovednostosoby=".  $idPP);

        $this ->idPP = $idPP;
        
        $this->sqlSelectPart .= ', Dovednost.Popis, UrovenDovednosti.Popis';
        $this->sqlFromPart = 'Dokument, TypDokumentu, DokumentyOsoby, DovednostOsoby, UrovenDovednosti, Dovednost';
        $this->sqlWherePart =
            'Dokument.Id = DokumentyOsoby.Id ' .
            ' AND TypDokumentu.Kod = Dokument.Typ ' .
            " AND EXISTS(SELECT PracovniPomer.RC FROM PracovniPomer WHERE PracovniPomer.ID = " . (int)$idPP . " AND DokumentyOsoby.RC = PracovniPomer.RC)" .
            " AND DokumentyOsoby.RC = DovednostOsoby.RC " .
            " AND DokumentyOsoby.Dovednost_RC = DovednostOsoby.RC ".
            " AND DokumentyOsoby.Dovednost_Kod = DovednostOsoby.KodDovednosti ".
            " AND DokumentyOsoby.Dovednost_Uroven = DovednostOsoby.KodUrovne ".
            " AND DokumentyOsoby.Dovednost_DatumZiskani = DovednostOsoby.DatumZiskani ".
            " AND DovednostOsoby.DatumZiskani <= " . $database->dateToString(time()) .
            " AND (DovednostOsoby.PlatnostDo >= "  . $database->dateToString(time()) . " OR DovednostOsoby.PlatnostDo IS NULL) " .
            " AND UrovenDovednosti.KodDovednosti = DovednostOsoby.KodDovednosti " .
            " AND UrovenDovednosti.KodUrovne = DovednostOsoby.KodUrovne " .
            " AND Dovednost.Kod = UrovenDovednosti.KodDovednosti";
        

        
        $this ->addFields( [
                [BROWSER_FIELD_SQL_NAME => 'UrovenDovednosti.Popis', BROWSER_FIELD_SQL_INDEX => 5, BROWSER_FIELD_HEADER_TEXT => 'Dovednost',   BROWSER_FIELD_ORDERING => 1],
                [BROWSER_FIELD_SQL_NAME => 'Dovednost.Popis',     BROWSER_FIELD_SQL_INDEX => 6, BROWSER_FIELD_HEADER_TEXT => 'Dovednosti_uroven_dovednosti', BROWSER_FIELD_ORDERING => 1]
        ]);
         
        
    }

}
