<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 08.08.2019
 */

namespace Ron\Personalistika;


use Ron\BrowserField;
use Ron\DB\Database;
use Ron\DB\SqlStatement;
use Ron\RonPortal\JmenoPrijmeniBrowserField;
use Ron\RonPortal\RonPortalBrowser;
use Ron\StringUtils;

require_once 'adsapp/ronportalbrowser.php';
require_once 'person/nahlasenezmenycontroller.php';


///**
// * Class StavZmenyDriveNahlaseneZmenyField
// * @package Ron\RonPortal
// */
//class StavZmenyDriveNahlaseneZmenyField extends BrowserField
//{
//    /**
//     * StavZmenyDriveNahlaseneZmenyField constructor.
//     * @param null $database
//     * @param null $options
//     */
//    public function __construct($database = null, $options = null)
//    {
//        parent::__construct($database, $options);
//        $this->header = \Ron\ronText('stav_zmeny');
//        $this->className = 'potvrzeni_zmeny';
//    }
//
//    /**
//     * @param mixed $value
//     * @param int $rowNumber
//     * @param string $recordId
//     * @param array $rowData
//     * @return int|string
//     */
//    function getViewText($value, $rowNumber, $recordId, $rowData)
//    {
//        $result = '';
//        $result .= "<a href='?menuid=nahlasenezmeny&record={$rowData[0]}'>";
//
//        if ($rowData[3] != '') {
//            if ($rowData[14] == 1) {
//                $result .= "<strong>";
//                $result .= \Ron\ronText('zpracovano');
//                $result .= "</strong>";
//            } elseif ($rowData[14] == 2) {
//                $result .= \Ron\ronText('odmitnuto');
//            } else {
//                $result .= "<strong>";
//                $result .= \Ron\ronText('zpracovano');
//                $result .= "</strong>";
//            }
//
//        } else {
//            $result .= \Ron\ronText('nezpracovano');
//        }
//
//        $result .="</a>";
//        return $result;
//    }
//}


///**
// * Class DatumHlaseniDriveNahlaseneZmenyField
// * @package Ron\RonPortal
// */
//class DatumHlaseniDriveNahlaseneZmenyField extends BrowserField
//{
//    public $backurlZmeny = '';
//
//
//    /**
//     * DatumHlaseniDriveNahlaseneZmenyField constructor.
//     * @param null $database
//     * @param null $options
//     * @param null $backurlZmeny
//     */
//    public function __construct($database = null, $options = null, $backurlZmeny=null)
//    {
//        parent::__construct($database, $options);
//        $this->header = \Ron\ronText('datum_hlaseni');
//        $this->className = '';
//        //$this->align = 'center';
//        $this->backurlZmeny = $backurlZmeny != ''
//            ? "&backurlzmeny=$backurlZmeny"
//            : '';
//
//    }
//
//    /**
//     * @param mixed $value
//     * @param int $rowNumber
//     * @param string $recordId
//     * @param array $rowData
//     * @return string
//     */
//    function getViewText($value, $rowNumber, $recordId, $rowData)
//    {
//        return
//            "<a href='?menuid=nahlasenezmeny&record=$rowData[0]$this->backurlZmeny'>" .
//            date('j.n.Y', $this->database->stringToTimestamp($rowData[2])) .
//            "</a>";
//    }
//}

/**
 * Class EditovanaZmenaDriveNahlaseneZmenyField
 * @package Ron\RonPortal
 */
class EditovanaZmenaDriveNahlaseneZmenyField extends BrowserField
{
    public $idEditovaneZmeny;


    /**
     * EditovanaZmenaDriveNahlaseneZmenyField constructor.
     * @param $database
     * @param $idEditovaneZmeny
     */
    public function __construct($database, $idEditovaneZmeny)
    {
        parent::__construct($database);
        $this->header = \Ron\ronText('uprava_zmeny');
        $this->idEditovaneZmeny = $idEditovaneZmeny;
        $this->align = 'center';
    }

    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return int|string
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = '';

        if ($rowData[0] == $this->idEditovaneZmeny)
        {
            if ($rowData[3] != '') {
                $result .= "<div class='font-weight-bold align-center'>" . \Ron\ronText('nyni_prohlizite') . "</div>";
            } else {
                if ($rowData[14] == 0) {
                    $result .= "<div class='font-weight-bold align-center'>" . \Ron\ronText('nyni_editovano') . "</div>";
                }
            }
        }

        return $result;
    }
}

/**
 * Class PocetDokumentuDriveNahlaseneZmenyField
 * @package Ron\RonPortal
 */
class PocetDokumentuDriveNahlaseneZmenyField extends BrowserField
{
    /**
     * PocetDokumentuDriveNahlaseneZmenyField constructor.
     */
    function __construct()
    {
        parent::__construct();
        $this->align = 'center';
    }

    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        if ($rowData[15]) {
            return
                "<a href='?menuid=nahlasenezmeny&record=$rowData[0]'>" .
                '<i class="fa inline-glyph glyph-attachment" title="' . \Ron\ronText('Pocet_priloh') . ': ' . $rowData[15] . '">' .
                '</a>';
        }
        return '';
    }
}

/**
 * Class ZpracovatelDriveNahlaseneZmenyField
 * @package Ron\RonPortal
 */
class ZpracovatelDriveNahlaseneZmenyField extends BrowserField
{

    /**
     * ZpracovatelDriveNahlaseneZmenyField constructor.
     * @param $database
     */
    public function __construct($database)
    {
        parent::__construct($database);
        $this->header = \Ron\ronText('zpracoval');
        $this->align = 'center';
    }

    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = '';

        if ($rowData[8] != "") {
            $result .= StringUtils::htmlTextConvert($rowData[16]) . " " . StringUtils::htmlTextConvert($rowData[17]) . ($rowData[18]!="" ? ", " : "") . StringUtils::htmlTextConvert($rowData[18]);
        }

        return $result;
    }
}


/**
 * Class DriveNahlaseneZmenyBrowser
 * @package Ron\RonPortal
 */
class DriveNahlaseneZmenyBrowser extends RonPortalBrowser
{
    /** @var  Database $database */
    public $database;
    private $id;
    private $typZmeny;
    public $idEditovaneZmeny = "";


    /**
     * DriveNahlaseneZmenyBrowser constructor.
     * @param $database
     * @param $id
     * @param $typZmeny
     * @param null $idEditovaneZmeny
     */
    function __construct($database, $id, $typZmeny, $idEditovaneZmeny=null, $backMenuId='osobniudaje')
    {
        parent::__construct($database, null);

        $this->id = $id;
        $this->typZmeny = $typZmeny;
        $this->database = $database;
        $this->idEditovaneZmeny = $idEditovaneZmeny;

        $this->code = 'browsernahlasenezmeny';

        $this ->title = \Ron\ronText('nahlasene_zmeny');

        $this->sqlSelectPart =
            'NahlasenaZmena.ID, NahlasenaZmena.TypZmeny, NahlasenaZmena.DatumCas, NahlasenaZmena.Zpracoval,' .  //0..3
            ' {fn_CASTWIDEMEMO(NahlasenaZmena.Poznamka)}, {fn_CASTWIDEMEMO(NahlasenaZmena.Hodnoty)},' . //4..5
            ' TypNahlaseneZmeny.Popis, TypNahlaseneZmeny.Kod, NahlasenaZmena.DatumCasZpracovani,' .     //6..8
            ' OsobaZmeny.Jmeno, OsobaZmeny.Prijmeni, OsobaZmeny.Titul,' .       //9..11
            ' NahlasenaZmena.RC, PracovniPomer.ID, NahlasenaZmena.Stav,' .      //12..14
            ' (SELECT COUNT(*) FROM DokumentZmeny WHERE DokumentZmeny.IDZmeny = NahlasenaZmena.ID),' .  //15
            ' Zpracovatel.Jmeno, Zpracovatel.Prijmeni, Zpracovatel.Titul,' .    //16..18
            ' Nahlasil.Jmeno, Nahlasil.Prijmeni, Nahlasil.Titul';               //19..21

        $this->sqlFromPart =
            'NahlasenaZmena LEFT JOIN TypNahlaseneZmeny ON (NahlasenaZmena.TypZmeny = TypNahlaseneZmeny.Kod)' .
            ' LEFT JOIN Osoba OsobaZmeny ON (NahlasenaZmena.RC = OsobaZmeny.RC) ' .
            ' LEFT JOIN Osoba Zpracovatel ON (NahlasenaZmena.Zpracoval = Zpracovatel.RC)' .
            ' LEFT JOIN Osoba Nahlasil ON (NahlasenaZmena.Nahlasil = Nahlasil.RC)' .
            ' LEFT JOIN PracovniPomer ON (NahlasenaZmena.RC = PracovniPomer.RC)';

        $this->sqlOrderPart = 'NahlasenaZmena.DatumCas DESC';

        if ($idEditovaneZmeny) {
            $this->addField(new EditovanaZmenaDriveNahlaseneZmenyField($this->database, $idEditovaneZmeny));
        }

        $this ->primaryField = 0;

        if ($backMenuId != 'osobniudaje') {
            $backMenuId = null;
        }

        //$this->addField(new DatumHlaseniDriveNahlaseneZmenyField($this->database,null,$this->backurlzmeny));
        $this->addField()
            ->setSqlFieldIndex(2) ->setFormat('date')
            ->setHeaderText('datum_hlaseni')
            ->setLink('?menuid=nahlasenezmeny' . ($backMenuId ? '&back=' . $backMenuId : ''));


//        $this->addField(new StavZmenyDriveNahlaseneZmenyField($this->database));
        $this->addField(BROWSER_FIELD_TYPE_SELECT)
            ->setSqlFieldIndex(14)
            ->setHeaderText('stav_zmeny') ->setClassName('potvrzeni_zmeny')
            ->setLink('?menuid=nahlasenezmeny' . ($backMenuId ? '&back=' . $backMenuId : ''))
            ->setOptions([
                0 => \Ron\ronText('nezpracovano'),
                1 => \Ron\ronText('zpracovano'),
                2 => \Ron\ronText('odmitnuto')
            ]);


        $this ->addField(new JmenoPrijmeniBrowserField($this ->database, 9, 10, null, 11))
            ->setSqlFieldName('OsobaZmeny.Prijmeni, OsobaZmeny.Jmeno, OsobaZmeny.Titul')
            ->setHeaderText('osoba_zmeny')
            ->setOrdering(true);

        $this ->addField(new JmenoPrijmeniBrowserField($this ->database, 19, 20, null, 21))
            ->setSqlFieldName('Nahlasil.Prijmeni, Nahlasil.Jmeno, Nahlasil.Titul')
            ->setHeaderText('zmenu_nahlasil')
            ->setOrdering(true);

        $this ->addField($f = new JmenoPrijmeniBrowserField($this ->database, 16, 17, null, 18))
            ->setSqlFieldName('Zpracovatel.Prijmeni, Zpracovatel.Jmeno, Zpracovatel.Titul')
            ->setHeaderText('zpracoval')
            ->setOrdering(true);
        $f ->setIndexIfNull(3); // v tabulce neni vazba - pokud nenajde osobu podle RC, tak zobrazi primo hodnotu pole "zpracoval"

        $this->addField()
            ->setSqlFieldIndex(8) ->setSqlFieldName('NahlasenaZmena.DatumCasZpracovani')
            ->setHeaderText('datum_zpracovani') ->setFormat('date')
            ->setOrdering(true);

        $this->addField(new PocetDokumentuDriveNahlaseneZmenyField());
    }

    function setFilterForm()
    {
        return null;
    }


    function getRowAttributes($values, $className, $rowNumber)
    {
        switch ($values[14]) {
            case 1 :
                $className .= ' zpracovana-zmena';
                break;
            case 2 :
                $className .= ' odmitnuta-zmena';
                break;
            default :
                $className .= ' nezpracovana-zmena';
                break;
        }

        return parent::getRowAttributes($values, $className, $rowNumber);
    }


    /**
     * @param array $values
     * @param string $className
     * @param int $rowNumber
     * @param bool $edit
     */
    function renderLine($values, $className, $rowNumber, $edit = false)
    {
        parent::renderLine($values, $className, $rowNumber, $edit);

        if ($this->idEditovaneZmeny == $values[0]){
            echo "<tr class='font-weight-bold $className'>";
        } else {
            echo "<tr class='$className'>";
        }

        echo "<td></td>";
        $poznamka = StringUtils::htmlTextConvert($values[4]);
        echo
            "<td class='poznamka' title='$poznamka' colspan='" . ($this->columnCount - 1) . "' >" .
            $poznamka .
            '</td>';

        echo "</tr>\n";

        $this ->renderSeparator();
    }


    /**
     * @return SqlStatement|string
     */
    public function getSQLFilter()
    {
        $result = '';
        $params = $this ->database ->createParameters();
        $result .= ' PracovniPomer.ID = ' . $params->addParameter($this->id);

        if ($this->typZmeny == 'rodinnyprislusnik'){
            $result .= " AND (NahlasenaZmena.TypZmeny = " . $params->addParameter($this->typZmeny);
            $result .= " OR NahlasenaZmena.TypZmeny = " . $params->addParameter('novyclenrodiny');
            $result .= ")";

        } else {
            $result .= " AND NahlasenaZmena.TypZmeny = " . $params->addParameter($this->typZmeny);
        }

        return new SqlStatement($result, $params);
    }
}
