<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 1.9.2017
 */

namespace Ron\RonPortal;

use Ron\DB\Database;
use Ron\BrowserField;
use Ron\Browser;
use Ron\StringUtils;


/**
 * Class HodnoceniSkoleniField
 * @package Ron\RonPortal
 */
class HodnoceniSkoleniField extends BrowserField
{

    public function __construct($database, $options)
    {
        parent::__construct($database, $options);
        $this->className = 'hodnoceni_ucastniku_skoleni_formular';
        $this->header = \Ron\ronText('hodnoceni_skoleni');
        $this->align = 'center';
    }


    private function nacistUcastnikyZajezdu($cisloSkoleni)
    {
        $cnt = 0;
        $ucastnici = [];

        $sql = "SELECT PracovniPomer.ID, COALESCE (Osoba.prijmeni, '') {fn_concat()} ' ' {fn_concat()} COALESCE(Osoba.jmeno,'') '" . \Ron\ronText('jmeno') . "', " .           //0 - 1
                "GenerovaneSkoleni.RC, DruhSkoleni, DatumVznikuPovinnosti, GenerovaneSkoleni.DatumZapisu, DatumSkoleni, CisloSkoleni, Potvrzeni, " .           //2..8

                "(SELECT Count(GS.RC) FROM GenerovaneSkoleni GS INNER JOIN Osoba ON (Osoba.RC = GS.RC) WHERE (GS.CisloSkoleni = '" . $cisloSkoleni . "')), " .      //9 - vsichni
                "(SELECT Count(GS.RC) FROM GenerovaneSkoleni GS INNER JOIN Osoba ON (Osoba.RC = GS.RC) WHERE (GS.CisloSkoleni = '" . $cisloSkoleni . "') AND (GS.Potvrzeni=3)), " .      //10 - uspesni
                "(SELECT Count(GS.RC) FROM GenerovaneSkoleni GS INNER JOIN Osoba ON (Osoba.RC = GS.RC) WHERE (GS.CisloSkoleni = '" . $cisloSkoleni . "') AND (GS.Potvrzeni=4)), " .  //11 - neuspesni
                "(SELECT Count(GS.RC) FROM GenerovaneSkoleni GS INNER JOIN Osoba ON (Osoba.RC = GS.RC) WHERE (GS.CisloSkoleni = '" . $cisloSkoleni . "') AND (GS.Potvrzeni=0)), " .       //12
                $this->database->castWideMemo('GenerovaneSkoleni.Poznamka') .           //13

                "FROM GenerovaneSkoleni inner join Osoba on (Osoba.RC = GenerovaneSkoleni.RC) LEFT JOIN PracovniPomer ON (GenerovaneSkoleni.RC = PracovniPomer.RC)
                WHERE ((GenerovaneSkoleni.Potvrzeni<5) OR (GenerovaneSkoleni.Potvrzeni>6)) AND GenerovaneSkoleni.CisloSkoleni = '" . $cisloSkoleni . "' " .

                "ORDER BY Osoba.Prijmeni";

        $cursor = $this->database->getSqlResult($sql);

        while ($row = $cursor->fetch()){
            $ucastnici[$cnt] = $row;
            $cnt++;
        }
        return $ucastnici;
    }


    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = parent::getViewText($value, $rowNumber, $recordId, $rowData);

        $result .= $this->sestavFormularUcasti($rowData);

        return $result;
    }


    /** Sestaveni formulare
     * @param $rowData
     * @return string
     */
    function sestavFormularUcasti($rowData)
    {
        $formular = "";
        $cnt = 0;
        $radkyTabulky = "";

        $formular .= "<form enctype='multipart/form-data' method='post' id='hodnoceniSkoleni' name='hodnoceniSkoleni' action='?menuid=skoleni&action=skolenihodnoceni&' class='formular_hodnoceni'>";
        $formular .= '<input type="hidden" name="hodnoceniSkoleni" value="1">';
        $formular .= '<input type="hidden" name="cisloSkoleni" value="' . $rowData[0] . '">';
        $formular .= '<input type="hidden" name="druhSkoleni" value="' . $rowData[2] . '">';
        $formular .=    '<table class="inputtable tabulka_hodnoceni">';

        $ucastnici = $this->nacistUcastnikyZajezdu($rowData[0]);

        $vsichniInfo = "";
        $uspesneInfo = "";
        $neuspesneInfo = "";
        $bez_zadane_uspesnostiInfo = "";

        //Vytvoreni jednotlivych radku
        foreach ($ucastnici as $ucastnik => $row)
        {
            $vsichniInfo = $row[9];
            $uspesneInfo = $row[10];
            $neuspesneInfo = $row[11];
            $bez_zadane_uspesnostiInfo = $row[12];

            $cnt++;
            $stav = "";

            //Obarveni radku
            if ($cnt % 2 != 0) {
                $classRadku = "licheRadky radekTabulky";
            } else {
                $classRadku = "sudeRadky radekTabulky";
            }

            //uspesni
            if ($row[8] == 3) {
                //Pro procentualni informaci o uspesnych
                $stav = \Ron\ronText('uspesne');
                $classRadku .= " tucne uspesny";

            } elseif ($row[8] == 4) {
                $stav = \Ron\ronText('neuspesne');
                $classRadku .= " neuspesne";

            } elseif ($row[8] == 7) {
                $stav = \Ron\ronText('ucast_omluvena');
                $classRadku .= " neuspesne";

            } elseif ($row[8] == 8) {
                $stav = \Ron\ronText('ucast_neomluvena');
                $classRadku .= " neuspesne";

            } elseif (( (($row[8]<5) || ($row[8]>6)) ) && ( ((($row[8] <> 3) && ($row[8] <> 4) && ($row[8] <> 7) && ($row[8] <> 8)) || ($row[8] == "")) )) {
                $classRadku .= " bez_hodnoceni";
                $stav = \Ron\ronText('bez_nastavene_uspesnosti');

            }

            $radkyTabulky .= "<tr class='" . $classRadku . "'>";
            $radkyTabulky .= "<input id='" . $cnt . "_datumVznikuPovinnosti' name='" . $cnt . "_datumVznikuPovinnosti' type='hidden' value='" . $this->database ->stringToTimestamp($row[4]) . "'>";

            //Sloupec 1 ------------------------------------------------------            //Jmeno
            $radkyTabulky .=  "<td>" . StringUtils::htmlTextConvert($row[1]) . "<input id='" . $cnt . "_idUcastnika' name='" . $cnt . "_idUcastnika' type='hidden' value='" . $row[0] . "'>" . "</td>" .
                "<input id='" . $cnt . "_idUcastnikaPuvodniHodnotyHodnoceni' name='" . $cnt . "_idUcastnikaPuvodniHodnotyHodnoceni' type='hidden' value='" . $row[8]. ";;" . $row[13]. "'>";

            //Sloupec 2 ------------------------------------------------------     //aktualni stav (uspesne/neuspesne...)
            $radkyTabulky .= "<td class='center zobrazeniStavu'>$stav</td>";

            //Sloupec 3 ------------------------------------------------------     //hodnoceni (uspesne/neuspesne...)
            $jmenoComboHodnoceni = $cnt ."_hodnoceniCombo";
            $radkyTabulky .= "<td class='vpravo'>" . $this->comboHodnoceniSkoleni($jmenoComboHodnoceni, $row[8]) . "</td>";

            //Sloupec 4 ------------------------------------------------------
            $slovniHodnoceni = $cnt ."_slovniHodnoceni";
            $radkyTabulky .= "<td class=''>" . $this->textareaSlovniHodnoceni($slovniHodnoceni, $row[13], 'slovni_hodnoceni') . "</td>";

            $radkyTabulky .= '</tr>';
        }

        //Popis pripojuji az znam promenne k vypoctu
        $formular .= $this->popisTabulky($vsichniInfo, $uspesneInfo, $neuspesneInfo, $bez_zadane_uspesnostiInfo, $rowData);


        //Nadpisy sloupcu
        $nadpisy  = '<tr id="skoleniHeader" class="">';
        //Jmeno
        $nadpisy .=   '<th class="center ">' . \Ron\ronText('Jmeno') . '</th>';

        //Stav
        $nadpisy .=   '<th class="center zobrazeniStavu">' . \Ron\ronText('Stav_skoleni') . '</th>';

        //Hodnoceni
        $jmenoComboHodnoceniAll = "hodnoceniComboAll";
        $nadpisy .=   '<th colspan="" class=" vpravo ">' .
            '<div style="display: inline;float: left;padding-top: 3px">' . \Ron\ronText('hodnoceni') . "</div>" .
            "<div title='" . \Ron\ronText('volba_prepise_nepotvrzene') . "' style='display: inline'>" .
                $this->comboHodnoceniSkoleni($jmenoComboHodnoceniAll, 'combo_male') .
            '</div></th>';

        $nadpisy .=   '<th style="text-align: center;" class="slovni_hodnoceni">' . \Ron\ronText('slovni_hodnoceni') . '</th>';

        $nadpisy .= '</tr>';

        //Sestaveni formulare
        $formular .=    $nadpisy;
        $formular .=    $radkyTabulky;
        $formular .=    "</table>";
        $formular .=    "<input type='hidden' name='pocetRadku' value='" . $cnt ."'>";

        $formular .=    "<table id='tlacitkaObsluhy'>";
        $radek  =       '<tr>';
        $radek .=           '<td></td>';
        $radek .=           '<td><button type="button" id="tlacitkoStorno" class="button">' . \Ron\ronText("Zpet_na_seznam") . '</button></td>';
        $radek .=           "<td><input class='button' type='reset' value='" . \Ron\ronText('form.Original') . "' ></td>";
        $radek .=           "<td><input class='button' type='submit' value='" . \Ron\ronText('ulozit_na_seznam') . "' ></td>";
        $radek .=       "</tr>";
        $radek .=       "<tr>";
        $radek .=           '<td>&nbsp;</td>';
        $radek .=       "</tr>";
        $formular .=    $radek;
        $formular .=    '</table>';
        $formular .= '</form>';

        return $formular;
    }

    /**
     * @param $name
     * @param $hodnota
     * @param null $class
     * @return string
     */
    private function comboHodnoceniSkoleni($name, $hodnota=null, $class = null)
    {
        $result = "";

        $classComba =  $class == "" ? 'combo_velke ' : $class;
        $classComba .=  $hodnota > 0 ? 'tucne_combo' : "";

        $result .=
            "<select class='$classComba' name='$name' id='$name' >" .
                '<option value="0" ' . '>' . \Ron\ronText('nepotvrzeno') . '</option>' .
                '<option value="3" ' . ($hodnota == 3 ? 'selected="selected" ':'') . '>' . \Ron\ronText('absolvovani_uspesne') . '</option>' .
                '<option value="4" ' . ($hodnota == 4 ? 'selected="selected" ':'') . '>' . \Ron\ronText('absolvovani_neuspesne') . '</option>' .
                '<option value="7" ' . ($hodnota == 7 ? 'selected="selected" ':'') . '>' . \Ron\ronText('ucast_omluvena') . '</option>' .
                '<option value="8" ' . ($hodnota == 8 ? 'selected="selected" ':'') . '>' . \Ron\ronText('ucast_neomluvena') . '</option>' .
            '</select>';

        return $result;
    }

    private function textareaSlovniHodnoceni($name,$hodnota=NULL, $class=NULL)
    {
        $result = '';

        $result .= "<textarea name='$name' class='$class' cols='30' rows='1'>";
        $result .= $hodnota;
        $result .= "</textarea>";

        return $result;
    }


    /**
     * Vygeneruje popis tabulky
     * @param $vsichni
     * @param $uspesne
     * @param $neuspesne
     * @param $bez_zadane_uspesnosti
     * @param $rowData
     * @return string
     */
    private function popisTabulky ($vsichni, $uspesne, $neuspesne, $bez_zadane_uspesnosti, $rowData)
    {
        //radek 1 ----------
        $popisTabulky  =    '<tr>';
        $popisTabulky .=        '<td class="infoFormuKurzu" colspan="5">';
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';

        //radek 2 ----------
        $popisTabulky .=    '<tr class="">';
        $popisTabulky .=        '<td class="infoFormuKurzu" colspan="1">';
        $popisTabulky .=            \Ron\ronText('nazev') . ": ";
        $popisTabulky .=        '</td>';
        $popisTabulky .=        '<td colspan="3" class="tucne">';
        $popisTabulky .=            StringUtils::htmlTextConvert($rowData[1]);
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';

        //radek 3 ----------
        $popisTabulky .=    '<tr class="">';
        $popisTabulky .=        '<td class="infoFormuKurzu">';
        $popisTabulky .=            \Ron\ronText('termin') . ": ";
        $popisTabulky .=        '</td>';
        $popisTabulky .=        '<td  colspan="3"  class="tucne">';
        $popisTabulky .=            StringUtils::format('date', $this->database->stringToTimestamp($rowData[3])) . "&nbsp;&nbsp;-" . "&nbsp;&nbsp;" .
                                    StringUtils::format('date', $this->database->stringToTimestamp($rowData[5])) .
                                        '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' .
                                    StringUtils::format('time', $this->database->stringToTimestamp($rowData[4])) . "&nbsp;&nbsp;" . "-&nbsp;&nbsp;" .
                                    StringUtils::format('time', $this->database->stringToTimestamp($rowData[6]));
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';

        //radek 5 ----------
        $popisTabulky .=    '<tr class="">';
        $popisTabulky .=        '<td class="infoFormuKurzu" colspan="1">';
        $popisTabulky .=            \Ron\ronText('skolitel') . ": ";
        $popisTabulky .=        '</td>';
        $popisTabulky .=        '<td colspan="3">';
        $popisTabulky .=            $rowData[14];
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';


        //radek 6 ----------
        $popisTabulky .=    '<tr class="">';
        $popisTabulky .=        '<td class="infoFormuKurzu" colspan="1">';
        $popisTabulky .=            \Ron\ronText('hodnotici') . ": ";
        $popisTabulky .=        '</td>';
        $popisTabulky .=        '<td colspan="3">';
        $popisTabulky .=            $rowData[15];
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';

        //radek 7 ----------
        $popisTabulky .=    '<tr class="">';
        $popisTabulky .=        '<td class="infoFormuKurzu" colspan="1">';
        $popisTabulky .=            \Ron\ronText('skolici_firma') . ": ";
        $popisTabulky .=        '</td>';
        $popisTabulky .=        '<td colspan="3">';
        $popisTabulky .=            $rowData[21] . ($rowData[22] != "" ? (" / " . $rowData[22]): "");
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';


        //radek 8 ----------
        $popisTabulky .=    '<tr class="">';
        $popisTabulky .=        '<td class="infoFormuKurzu">';
        $popisTabulky .=            \Ron\ronText('vsichni') . " / "  . \Ron\ronText('bez_nastavene_uspesnosti') . ": ";
        $popisTabulky .=        '</td>';
        $popisTabulky .=        '<td  colspan="3" >';
        $popisTabulky .=            $vsichni;
        $popisTabulky .=        ' / ';
        $popisTabulky .=            $bez_zadane_uspesnosti;
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';

        //radek 9 ----------
        $popisTabulky .=    '<tr class="">';
        $popisTabulky .=        '<td class="infoFormuKurzu">';
        $popisTabulky .=             \Ron\ronText('uspesne') . " / " .  \Ron\ronText('neuspesne');
        $popisTabulky .=        '</td>';
        $popisTabulky .=        '<td  colspan="3" class="tucne">';
        $popisTabulky .=            $uspesne;
        $popisTabulky .=        ' / ';
        $popisTabulky .=            $neuspesne;
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';

        //radek 10 ----------
        $popisTabulky .=    '<tr class="">';
        $popisTabulky .=        '<td class="infoFormuKurzu">';
        $popisTabulky .=            \Ron\ronText('zobrazit') . ": ";
        $popisTabulky .=        '</td>';
        $popisTabulky .=        '<td colspan="4">';
        $popisTabulky .=           \Ron\ronText("vsechny") . "<input type='radio' id='filtr_pritomnych' name='filtr_pritomnych' checked value='0'>&nbsp;&nbsp;&nbsp;";
        $popisTabulky .=           \Ron\ronText("uspesne") . "<input type='radio' id='filtr_pritomnych' name='filtr_pritomnych'  value='1'>&nbsp;&nbsp;&nbsp;";
        $popisTabulky .=           \Ron\ronText("neuspesne") . "<input type='radio' id='filtr_pritomnych' name='filtr_pritomnych'  value='2'>&nbsp;&nbsp;&nbsp;";
        $popisTabulky .=           \Ron\ronText("bez_nastavene_uspesnosti") . "<input type='radio' id='filtr_pritomnych' name='filtr_pritomnych'  value='3'>";
        $popisTabulky .=        '</td>';
        $popisTabulky .=    '</tr>';

        return $popisTabulky;
    }
}


/**
 * Class HodnoceniSkoleniBrowser
 * @package Ron\RonPortal
 */
class HodnoceniSkoleniBrowser extends Browser
{
    /** @var  PravaNaOsoby $prava */
    private $prava;

    private $kodKurzu;

    public function __construct(Database $database, $kodKurzu)
    {
        parent::__construct($database);
        $this->kodKurzu = $kodKurzu;

        $this->prava = Prava::vratPrava('skoleni_prihlasit');

        $this->code = 'browserskolenihodnoceni';
        $this->tableId = 'browserskolenihodnoceni';
        $this->cssClass = "browser";
        $this->browserUrl = "?menuid=skoleni&action=skolenihodnoceni";
        $this->title = \Ron\ronText('hodnoceni_skoleni');

        //SELECT
        $this->sqlSelectPart =
            "CisloSkoleni, Popis, DruhSkoleni, DatumPocatkuSkoleni, " .     //0..3
                "CasPocatkuSkoleni, DatumUkonceniSkoleni, CasUkonceniSkoleni, " .       //4..6
                "MistoSkoleni, DelkaSkoleniDnu, DelkaSkoleniHodin, " .      //7..9
                "Kapacita, NabidkaSkoleni, StavSkoleni, " .     //10..12
                "SkoliciFirma, Skolitel, Hodnotici, " .     //13..15
                "HodnoceniUzavreno, DatumPotvrzeniUcasti, " . $database->castWideMemo('HodnoceniSkoleni') . ", " .     //16..18
                "Kredity, DlouhodobyKurz, Firma.nazev1, Firma.nazev2 ";       //19..22

        //FROM
        $this->sqlFromPart = 'Skoleni LEFT JOIN Firma ON (Skoleni.SkoliciFirma = Firma.kodFirmy)';

        //Formular se zobrazi jako radek browseru
        $this->addField(new HodnoceniSkoleniField($database, null));
    }



    function getSQLFilter()
    {
        $result= '';

        $result .= "Skoleni.CisloSkoleni = '" . $this->database->addSlashes($this->kodKurzu) . "'";

        return $result;
    }
}