<?php
/**
 * stanislav.elbl, 14.01.2016
 */

namespace Ron\Personalistika;

use Ron\BrowserField;
use Ron\Controls\ComboBox;
use Ron\DB\Database;
use Ron\DB\DBUtils;
use Ron\GuiUtils;
use Ron\Http\HtmlHeaders;
use Ron\RonPortal\RonPortalBrowser;
use Ron\RonPortal\RonPortalFilterForm;
use Ron\StringUtils;
use RonPortal\RonPortalSession;
use RonPortal\RonPortalSettings;

require_once('adsapp/ronportalbrowser.php');


/**
 * Class UchazeciFilterForm
 * @package Ron\Personalistika
 */
class UchazeciFilterForm extends RonPortalFilterForm
{
    private $volitelnyTypRozdeleni3;

    function __construct($database, $action, $typRozdeleni, $typRozdeleni2)
    {
        parent::__construct($database, $action);

        $this->f_classname = 'filtercontainer leftcaptions';

        $this->f_formaction = '?menuid=uchazeci';

        $this->nastavRozdeleni(true,-1,0,'',true);
        $this->showVcetnePodrizenychRozdeleni = false;

        if ($typRozdeleni !== 0) {
            $this->nastavRozdeleni2(true, $typRozdeleni, 0, '', true);
        }
        $this->volitelnyTypRozdeleni3 = $typRozdeleni2;
    }

    /**
     * @throws \Exception
     */
    function renderRozdeleni3()
    {
        $params = $this->database->createParameters();
        echo '<DIV class="filterrow">';
            echo '<SPAN class="filtercaption">';
                echo StringUtils::htmlTextConvert(DBUtils::getSqlValue($this->database,'SELECT Popis FROM TypRozdeleni WHERE Kod = ' . $params->addParameter($this->volitelnyTypRozdeleni3), $params));
            echo '</SPAN>';

            $sql='SELECT Kod, Popis FROM Rozdeleni WHERE KodTypuRozdeleni = ' . (int)$this->volitelnyTypRozdeleni3;

            $combo = new ComboBox('rozdeleni3');
            $combo->className = 'app_combo adsfilterforminput_popis';
            $combo->emptyRow = \Ron\ronText('_vse_');
            $combo->loadData($this->database, $sql, $_SESSION['rozdeleni3']);
            $combo->htmlParams = "data-ron-select2='rozdeleni3_kod' data-ron-autosubmit='1'";
            $combo->render();

            $combo = new ComboBox('rozdeleni3_kod');
            $combo->className = 'app_combo adsfilterforminput_kod';
            $combo->emptyRow = \Ron\ronText('_vse_');
            $combo->keyIndex = 0;
            $combo->captionIndex = 0;
            $combo->loadData($this->database, $sql, $_SESSION['rozdeleni3']);
            $combo->htmlParams = "data-ron-select2='rozdeleni3' data-ron-autosubmit='1'";
            $combo->render();

            $this->renderVcetnePodrizenych3();
        echo '</DIV>';
    }

    function renderVcetnePodrizenych3()
    {
        require_once('ron/guiutils.php');
        GuiUtils::renderCheckbox('vcetnePodrizenych3', \Ron\ronText('Rozdeleni_vcetne_podrizenych'),
            $_SESSION['vcetnePodrizenych3'], '', ($this ->f_autosubmit ? 'clickAutoSubmit' : ''));
    }


    /**
     * @throws \Exception
     */
    function renderFilters()
    {
        parent::renderFilters();

        if ($this->volitelnyTypRozdeleni3 != 0) {
            $this->renderRozdeleni3();
        }

        echo "<BR />";
    }

    function loadRozdeleni3()
    {
        if(isset($_POST['adsfilterform'])){
            $_SESSION['rozdeleni3'] = isset($_POST['rozdeleni3']) ? $_POST['rozdeleni3'] : null;
        }
    }

    function loadVcetnePodrizenych3()
    {
        if(isset($_POST['adsfilterform'])){
            $_SESSION['vcetnePodrizenych3'] = isset($_POST['vcetnePodrizenych3']);
        }
        if (!RonPortalSession::getValue('rozdeleni3'))
            $_SESSION['vcetnePodrizenych3'] = false;
    }

    function loadData()
    {
        $this->loadRozdeleni3();
        $this->loadVcetnePodrizenych3();
        parent::loadData();
    }
}

/**
 * Class RozdeleniUchazeceField
 * @package Ron\Personalistika
 */
class RozdeleniUchazeceField extends BrowserField
{
    /**
     * RozdeleniUchazeceField constructor.
     * @param Database $database
     * @throws \Exception
     */
    public function __construct($database)
    {
        parent::__construct($database);

        $params = $this->database->createParameters();
        $popis = DBUtils::getSqlValue($this->database,
            'SELECT Popis FROM TypRozdeleni' .
            ' WHERE Kod = '. $params->addParameter(RonPortalSettings::getIntValue('uchazecityprozdeleniprofiltr')), $params);

        $this->header = StringUtils::htmlTextConvert($popis);
    }

    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     * @throws \Exception
     */
    public function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $params = $this->database->createParameters();

        $sql = 'SELECT Rozdeleni.Kod, Rozdeleni.Popis ' .
            ' FROM P_Uchazec, Rozdeleni, RozdeleniUchazece ' .
            ' WHERE P_Uchazec.RC = RozdeleniUchazece.RC ' .
            ' AND RozdeleniUchazece.Rozdeleni = Rozdeleni.Kod ' .
            ' AND RozdeleniUchazece.KodTypuRozdeleni = Rozdeleni.KodTypuRozdeleni ' .
            ' AND RozdeleniUchazece.KodTypuRozdeleni = ' . $params->addParameter(RonPortalSettings::getIntValue('uchazecityprozdeleniprofiltr')) .
            ' AND P_Uchazec.RC = ' . $params->addParameter($rowData[0]) . ' '.
            ' ORDER BY Rozdeleni.Popis';

        $cursor = $this->database->getSqlResult($sql, $params);

        $result = '';

        while ($row = $cursor->fetch()) {
            if ($result) {
                $result .= ', ';
            }
            $result .= "<span title='" . $row[0]  . "'>" . $row[1] . '</span>';
        }
        return $result;
    }
}

/**
 * Class RozdeleniUchazece2Field
 * @package Ron\Personalistika
 */
class RozdeleniUchazece2Field extends BrowserField
{
    /**
     * RozdeleniUchazece2Field constructor.
     * @param $database
     * @throws \Exception
     */
    public function __construct($database)
    {
        parent::__construct($database);

        $params = $this->database->createParameters();
        $popis = DBUtils::getSqlValue($this->database,'SELECT Popis FROM TypRozdeleni WHERE Kod = '. $params->addParameter(RonPortalSettings::getIntValue('uchazecityprozdeleniprofiltr2')), $params);

        $this->header = $popis;
    }

    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     * @throws \Exception
     */
    public function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $params = $this->database->createParameters();

        $sql = 'SELECT Rozdeleni.Kod, Rozdeleni.Popis ' .
                'FROM P_Uchazec, Rozdeleni, RozdeleniUchazece ' .
                'WHERE P_Uchazec.RC = RozdeleniUchazece.RC ' .
                'AND RozdeleniUchazece.Rozdeleni = Rozdeleni.Kod ' .
                'AND RozdeleniUchazece.KodTypuRozdeleni = Rozdeleni.KodTypuRozdeleni ' .
                'AND RozdeleniUchazece.KodTypuRozdeleni = ' . $params->addParameter(RonPortalSettings::getIntValue('uchazecityprozdeleniprofiltr2')) .
                ' AND P_Uchazec.RC = ' . $params->addParameter($rowData[0]) . ' ';

        $cursor = $this->database->getSqlResult($sql, $params);

        $result = '';

        while($row = $cursor->fetch()){
            if($result){
                $result .= ', ';
            }
            $result .= "<SPAN title='" .$row[0] . "'>" . $row[1] . '</SPAN>';
        }
        return $result;
    }
}

/**
 * Class UzivatelskePoleUchazece
 * @package Ron\Personalistika
 */
class UzivatelskePoleUchazece extends BrowserField
{
    private $indexDBPole;
    private $indexUzPromenne;

    public function __construct($database, $nadpis, $indexPole, $indexUzPole)
    {
        parent::__construct($database);

        $this->indexDBPole = $indexPole;
        $this->indexUzPromenne = $indexUzPole;
        $this->header = $nadpis;
    }

    public function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        return '<div title="' . $rowData[$this->indexDBPole] . '" class="uchazeci' . $this->indexUzPromenne . '">' . $rowData[$this->indexDBPole] . '</div>';
    }
}

/**
 * Class UchazeciBrowser
 * @package Ron\Personalistika
 */
class UchazeciBrowser extends RonPortalBrowser
{
    public $typRozdeleniFiltr;
    public $typRozdeleniFiltr2;

    /**
     * UchazeciBrowser constructor.
     * @param Database $database
     * @throws \Exception
     */
    public function __construct($database)
    {
        parent::__construct($database, '');

        $this->typRozdeleniFiltr = RonPortalSettings::getIntValue('uchazecityprozdeleniprofiltr');
        $this->typRozdeleniFiltr2 = RonPortalSettings::getIntValue('uchazecityprozdeleniprofiltr2');

        $this ->sqlSelectPart =
            'RC, Jmeno, Prijmeni, Titul, TitulZa, VEvidenciOd, '.   //0 - 5
            'uzivatelska1, uzivatelska2, uzivatelska3, uzivatelska4, uzivatelska5, uzivatelska6, ' . //6 - 11
            'uzivatelska7, uzivatelska8, uzivatelska9, uzivatelska10, uzivatelska11, uzivatelska12, ' . //12 -17
            'uzivatelska13, uzivatelska14, uzivatelska15, uzivatelska16, uzivatelska17,' . //18 - 22
            'uzivatelska18, uzivatelska19, uzivatelska20, idFotografie, ' . $database->castWideMemo('ZdrojVznikuPP.Popis'); //23-27

        $this ->sqlFromPart =
            'P_Uchazec LEFT OUTER JOIN ZdrojVznikuPP ON P_Uchazec.ZdrojVzniku = ZdrojVznikuPP.Kod';

        $this ->title = \Ron\ronText('Seznam_uchazecu');

        $this ->browserUrl = '?menuid=uchazeci&';
        $this ->rowClickLink = '?menuid=uchazeci&action=zobrazuchazece';
        $this ->cssClass .= ' seznamUchazecu';

        $this->primaryField = 0;

        $this->addField( [
            BROWSER_FIELD_SQL_NAME => 'P_Uchazec.RC', BROWSER_FIELD_SQL_INDEX => 0,
            BROWSER_FIELD_HEADER_TEXT => 'ID',  BROWSER_FIELD_ORDERING => 1] );

        $this->addField( [
            BROWSER_FIELD_SQL_NAME => 'P_Uchazec.Titul', BROWSER_FIELD_SQL_INDEX => 3,
            BROWSER_FIELD_HEADER_TEXT => 'Titul'] );

        $this->addField( [
            BROWSER_FIELD_SQL_NAME => 'P_Uchazec.Jmeno', BROWSER_FIELD_SQL_INDEX => 1,
            BROWSER_FIELD_HEADER_TEXT => 'Jmeno', BROWSER_FIELD_ORDERING => 1, BROWSER_FIELD_LINK => '?menuid=uchazeci&action=zobrazuchazece'] );

        $this->addField( [
            BROWSER_FIELD_SQL_NAME => 'P_Uchazec.Prijmeni', BROWSER_FIELD_SQL_INDEX => 2,
            BROWSER_FIELD_HEADER_TEXT => 'Prijmeni',  BROWSER_FIELD_ORDERING => 1, BROWSER_FIELD_LINK => '?menuid=uchazeci&action=zobrazuchazece'] );
        $this ->defaultSort = count($this ->fields);

        $this->addField([
            BROWSER_FIELD_SQL_NAME => 'P_Uchazec.TitulZa', BROWSER_FIELD_SQL_INDEX=> 4,
            BROWSER_FIELD_HEADER_TEXT=> 'Titul_za']);

        $this->addField([
            BROWSER_FIELD_SQL_NAME => 'P_Uchazec.VEvidenciOd', BROWSER_FIELD_SQL_INDEX=> 5,
            BROWSER_FIELD_FORMAT => 'finedate',
            BROWSER_FIELD_HEADER_TEXT=> 'V_evidenci_od', BROWSER_FIELD_ORDERING => 1]);

        $this->addField( new RozdeleniUchazeceField($this->database));

        if ($this->typRozdeleniFiltr2) {
            $this->addField( new RozdeleniUchazece2Field($this->database));
        }

        $this->addField( [
            BROWSER_FIELD_SQL_NAME => 'ZdrojVznikuPP.Popis', BROWSER_FIELD_SQL_INDEX => 27,
            BROWSER_FIELD_HEADER_TEXT => 'zdrojVzniku',  BROWSER_FIELD_ORDERING => 1] );

        $css = "<style>";

        for ($i = 1; $i <= 20; $i++) {
            if (RonPortalSettings::getValue('uchazeciuzivatelska'.$i) != '') {
                $this->addField(new UzivatelskePoleUchazece($this->database,RonPortalSettings::getValue('uchazeciuzivatelska' . $i),5 + $i,$i));
//                $css .= ' .uchazeci' . $i . "{ " . "overflow:hidden; text-overflow:ellipsis; " .
//                    "max-width: " .
//                    RonPortalSettings::getIntValue('sirkauzivatelskehopole' . $i) . "px; !important;" .
//                    "} ";
            }
        }

        $css .= "</style>";

        HtmlHeaders::getInstance()->addHeader($css);
    }

    public function getSQLFilter()
    {
        $result = '1 = 1';

        if (RonPortalSession::rozdeleni(-1) != '') {
            $result .= ' AND EXISTS(SELECT * FROM UchazecNaPM ' .
                        'WHERE UchazecNaPM.RC = P_Uchazec.RC '.
                        ' AND UchazecNaPM.KodTypuRozdeleni = -1 ' .
                        " AND UchazecNaPM.KodRozdeleni = '" . $this->database->addSlashes(RonPortalSession::rozdeleni(-1)) . "')";
        }

        if (RonPortalSession::rozdeleni2($this->typRozdeleniFiltr) != '') {
            $result .= ' AND (EXISTS(SELECT * FROM RozdeleniUchazece  ' .
                        ' WHERE RozdeleniUchazece.RC = P_Uchazec.RC '.
                        ' AND RozdeleniUchazece.KodTypuRozdeleni = ' . $this->typRozdeleniFiltr .
                        " AND RozdeleniUchazece.Rozdeleni = '" . $this->database->addSlashes(RonPortalSession::rozdeleni2($this->typRozdeleniFiltr)) . "')";

            if (RonPortalSession::rozdeleni2VcetnePodrizenych($this->typRozdeleniFiltr)) {
               $result .=   'OR EXISTS(SELECT * FROM RozdeleniUchazece '.
                            'JOIN HierarchieRozdeleni H ON (H.typPodrizene = RozdeleniUchazece.KodTypuRozdeleni ' .
                            ' AND H.kodPodrizene = RozdeleniUchazece.Rozdeleni '.
                            ' AND H.typNadrazene = H.typPodrizene) '.
                            'WHERE RozdeleniUchazece.RC = P_Uchazec.RC '.
                            ' AND RozdeleniUchazece.KodTypuRozdeleni = '. $this->typRozdeleniFiltr .
                            " AND H.kodNadrazene = '" . $this->database->addSlashes(RonPortalSession::rozdeleni2($this->typRozdeleniFiltr)) . "')".
                            ')';
            }
            else {
                $result .= ')';
            }
        }

        if (RonPortalSession::getValue('rozdeleni3') != '') {
            $result .= ' AND (EXISTS(SELECT * FROM RozdeleniUchazece  ' .
                        ' WHERE RozdeleniUchazece.RC = P_Uchazec.RC ' .
                        ' AND RozdeleniUchazece.KodTypuRozdeleni = ' . $this->typRozdeleniFiltr2 .
                        " AND RozdeleniUchazece.Rozdeleni = '" . $this->database->addSlashes($_SESSION['rozdeleni3']) . "')";

            if ($_SESSION['vcetnePodrizenych3']) {
                $result .=   'OR EXISTS(SELECT * FROM RozdeleniUchazece '.
                    'JOIN HierarchieRozdeleni H ON (H.typPodrizene = RozdeleniUchazece.KodTypuRozdeleni ' .
                    ' AND H.kodPodrizene = RozdeleniUchazece.Rozdeleni '.
                    ' AND H.typNadrazene = H.typPodrizene) '.
                    'WHERE RozdeleniUchazece.RC = P_Uchazec.RC '.
                    ' AND RozdeleniUchazece.KodTypuRozdeleni = '. $this->typRozdeleniFiltr2 .
                    " AND H.kodNadrazene = '" . $this->database->addSlashes($_SESSION['rozdeleni3']) . "')".
                    ')';
            }
            else {
                $result .= ')';
            }
        }
        return $result;
    }

    public function setFilterForm()
    {
        $this->filterForm = new UchazeciFilterForm($this->database, $this->action, $this->typRozdeleniFiltr, $this->typRozdeleniFiltr2);
    }
}
