<?php
/**
 * stanislav.elbl, 20.09.2015
 * roman.szablatura 10.10.2017
 */

namespace Ron\Personalistika;

use Ron\Controls\ComboBox;
use Ron\DB\DBUtils;
use Ron\GuiUtils;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\RonPortal\DokumentUploadForm;
use Ron\RonPortal\RonPortalSettings;
use Ron\StringUtils;

require_once('ron/controls.php');

/** @var HlaseniZmenyForm $this */

/** @var Model $model */
$model = Model::getInstance();

/** @var NahlasenaZmena $nahlasenaZmena */
$nahlasenaZmena = $this ->nahlasenaZmena;

$nadpisZmeny = \Ron\ronText('Popis_typu_zmeny_' . $nahlasenaZmena ->typZmeny, '') ?: StringUtils::htmlTextConvert($nahlasenaZmena ->popisTypuZmeny);
if ($nahlasenaZmena ->id) {
    if ($nahlasenaZmena->zpracoval) {
        $nadpisZmeny =
            \Ron\ronText(($nahlasenaZmena->stavZmeny == 2) ? 'zmena_odmitnuta' : 'zmena_potvrzena')
            . ' - ' .
            $nadpisZmeny;

    } else if (!$nahlasenaZmena->stavZmeny) {
        $nadpisZmeny =
            \Ron\ronText("uprava_nahlasene_zmeny") .
            ' - ' .
            $nadpisZmeny;
    }
} else {
    $nadpisZmeny =
        \Ron\ronText($this ->detail ? "detail" : 'nahlaseni_zmeny') .
        ' - ' .
        $nadpisZmeny;
}

$back = '';
if ((isset($_GET['back']) && $_GET['back'] == 'osobniudaje') || (isset($_GET['detail'])  &&  (int)$_GET['detail'])) {
    $back = '&back=osobniudaje';
}

//Pokud se edituje
$nacteneHodnoty = $this ->nahlasenaZmena ->nacteneHodnoty;

/** @var string[] $polozkyZmeny     Konfigurace daneho typu zmeny */
$polozkyZmeny = explode(';', $this ->nahlasenaZmena ->nastaveniZmeny);

?>
<h1><?= $nadpisZmeny ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<form method="post" enctype="multipart/form-data" action="?menuid=nahlasenezmeny<?= $back ?>">
    <input type="hidden" name="sys_ulozzmenu" value="1">
<!--    <input type="hidden" name="sys_nastavenihlaseni" value="--><?//= $nastaveniZmeny ?><!--">-->
    <input type="hidden" name="sys_typzmeny" value="<?= $this ->nahlasenaZmena ->typZmeny ?>">
    <input type="hidden" name="idZmeny" value="<?= $this ->nahlasenaZmena ->id ?: '' ?>">
<!--    <input type="hidden" name="sys_ID" value="--><?//= $idpp ?><!--">-->
    <input type="hidden" name="idpp" value="<?= $this ->nahlasenaZmena ->idPPOsobyZmeny ?>">

    <div class='form large-form '>
        <div class="form-content">
            <!-- jmeno a prijmeni -->
            <div class="row form-section">
                <?= \Ron\ronText("osoba_zmeny") ?>
            </div>
            <div class="row">
                <div class="col col-12 col-sm-3 caption"></div>
                <div class="col col-12 col-sm-9">
                    <h3>
                        <?= StringUtils::htmlTextConvert($this ->nahlasenaZmena ->celeJmenoOsobyZmeny) ?>
                    </h3>
                </div>
            </div>

            <?php if ($nahlasenaZmena ->typZmeny == 'ucetosoby' && RonPortalSettings::getIntValue('zobrazit_upozorneni_uctu')) { ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption">
                        <?= \Ron\ronText('upozorneni'); ?>
                    </div>
                    <div class="col col-12 col-sm-9 errorcolor" >
                        <?= \Ron\ronText('ucet_upozorneni'); ?>
                    </div>
                </div>
            <?php } ?>

            <!-- odkaz na nahlaseni zmeny -->
            <?php if ($this ->detail && $nahlasenaZmena ->typZmeny != 'osobni') { // V pripade zmeny osobnich udaju se nezobrazi sekce nahlaseni zmeny - pouzije se primo odkaz "Upravit vlastni udaje" ?>
            <div class="row form-section">
                <?= \Ron\ronText('Nahlasit_zmenu') ?>
            </div>
            <div class="row">
                <div class="col col-12 col-sm-3 caption"></div>
                <div class="col col-12 col-sm-9">
                    <a href="?menuid=zmena&typzmeny=<?= $nahlasenaZmena ->typZmeny == "rodinnyprislusnik" ? "novyclenrodiny" : $nahlasenaZmena ->typZmeny ?>&osoba=<?= $this ->nahlasenaZmena ->idPPOsobyZmeny ?><?= $back ?>"><?= \Ron\ronText("New_record") ?></a>
                </div>
            </div>
            <?php } ?>

            <?php if (!$this ->detail) {?>
                <div class="row form-section" id="nadpisy">
                    <?php if (!$this ->detail) {?>
                        <div class="col col-6 col-sm-6">
                            <?= \Ron\ronText("udaje_zmeny") ?>
                        </div>
                    <?php } else { ?>
                        <div class="col col-6 col-sm-6 center">
                        </div>
                    <?php } ?>
                </div>

                <div id="hlaseni_zmeny_form_content">
                    <div class="row <?= $nahlasenaZmena ->typZmeny . '-info' ?>">
                        <div class="col col-0 col-sm-3 caption"></div>
                        <div class="col col-12 col-sm-9">
                            <?= \Ron\ronText('nahlasena_zmena_info_' . $nahlasenaZmena ->typZmeny, '') ?>
                        </div>
                    </div>

<!--                    <input type="hidden" name="puvodni_cislo_uctu" title="" value="--><?//= $ucetOsoby[11] != '' ?$ucetOsoby[11] : $serioveCisloUctuADatumOd[0] ?><!--">-->
<!--                    <input type="hidden" name="puvodni_Seriove_cislo_uctu" title="" value="--><?//= $ucetOsoby[12] != '' ?$ucetOsoby[12] : $serioveCisloUctuADatumOd[2] ?><!--">-->
<!--                    <input type="hidden" name="platnost_od_puvodniho_uctu" title="" value="--><?//= $ucetOsoby[10] != '' ? ($ucetOsoby[10]) : ($serioveCisloUctuADatumOd[1]) ?><!--">-->

                    <?php foreach ($polozkyZmeny as $polozkaZmeny) {
                        //list($typPolozky, $kodPolozky, $popisPolozky, $priznak) = explode(':', $polozkaZmeny);
                        $poma = explode(':', $polozkaZmeny);
                        $typPolozky = $poma[0];
                        $kodPolozky = $poma[1];
                        $popisPolozky = $poma[2];
                        $priznak = isset($poma[3]) ? $poma[3] : null;

                        $readOnlyPolozka = false;
                        if ($nahlasenaZmena ->stavZmeny) {
                            // zmena uz je zapsana
                            $readOnlyPolozka = true;
                        } else if (strtoupper($priznak) == 'RO') {
                            $readOnlyPolozka = true;
                        } else if ($nahlasenaZmena ->typZmeny == 'ucetosoby') {
                            // pri editaci uctu osoby jsou nektere polozky readonly
                            switch ($kodPolozky) {
                                case 'JmenoUctu' :
                                case 'ZahranicniPlatba' :
                                case 'IBAN' :
                                case 'KodMeny_ISO' :
                                case 'SpecifickySymbol' :
                                case 'KonstantniSymbol' :
                                case 'PlatnostDo' :
                                    $readOnlyPolozka = true;
                                    break;

                                case 'TypUctu' :
                                    // je uz nacteno, netreba dohledavat, staci zobrazit
                                    $readOnlyPolozka = true;
                                    $typPolozky = 'E';
                                    $kodPolozky = 'PopisTypuUctu';
                                    break;
                            }
                        }
                        ?>
                        <div class="row <?= $nahlasenaZmena ->typZmeny . '-' . $kodPolozky ?>">
                            <?php if (($typPolozky != 'ID') && !($typPolozky == 'soubor' && $this ->nahlasenaZmena->stavZmeny)) {
                                //Nezobrazovat ID rodinneho prislusnika jak pri vytvoreni zmeny tak ani v historii
                                ?>
                                <div class="col col-12 col-sm-3 caption <?= ($priznak == 'Pr' || $priznak == 'Po') ? ' required' : '' ?>" >
                                    <?= \Ron\ronText($popisPolozky) ?>
                                </div>
                            <?php } ?>

                            <div class="col col-12 col-sm-9">
                                <?php
                                if (!$readOnlyPolozka) {
                                    //Sekce generuje prvky formulare dle jednotlivych typu nahlasene zmeny.
                                    $povinne = '';
                                    if (($priznak == 'Pr' || $priznak == 'Po')){
                                        // Osetreni v pripade nahlasene zmeny, kdy u osobni zmeny neni uveden povinny parametr - Prijmeni (napr. zmena tel.cisla)
                                        $povinne = ' nonempty';
                                        if ($nahlasenaZmena ->typZmeny == 'osobni'  &&  $this ->nahlasenaZmena ->id) {
                                            $povinne = '';
                                        }
                                    }

                                    $errorClass = MessageManager::getInstance() ->getClass($kodPolozky);
                                    $title = StringUtils::htmlTextConvert(MessageManager::getInstance() ->getTitle($kodPolozky, \Ron\ronText($popisPolozky)));

                                    //Hodnoty v case VELKYMI pismeny!
                                    switch (strtoupper($typPolozky)) {
                                        case 'SPECIFICKYSYMBOL' :
                                        case 'E' :
                                            //Pokud se jedna o vlozeni RC pak kontrola
                                            $ronRC = $kodPolozky == 'RC_RodinnehoPrislusnika' ? 'data-ronrc-inputdatename=DatumNarozeni' : '';
                                            $ronRCClass = $kodPolozky == 'RC_RodinnehoPrislusnika' ? 'ronRC' : '';

                                            $value = isset($nacteneHodnoty[$kodPolozky]) ? StringUtils::htmlTextConvert($nacteneHodnoty[$kodPolozky]) : '';
                                            echo "<input class='form-input $povinne $ronRCClass' type='text' name='{$kodPolozky}' $ronRC title='{$popisPolozky}' value='$value'>";
                                            break;

                                        case 'D' :
                                            $value = (isset($nacteneHodnoty[$kodPolozky . '#STR'])  &&  $nacteneHodnoty[$kodPolozky . '#STR'])
                                                ? $nacteneHodnoty[$kodPolozky . '#STR']
                                                : (isset($nacteneHodnoty[$kodPolozky]) ? StringUtils::format('date', $nacteneHodnoty[$kodPolozky]) : '');
                                            echo "<input type='text'  title='{$title}' class='inputDate $povinne $errorClass' size='10' maxlength='10' name='$kodPolozky' id='$kodPolozky' value='$value'>";
                                            echo "<i class='showcalendar inline-glyph glyph-button fa glyph-calendar' data-roncalendar-inputname='$kodPolozky'></i>";
                                            break;

                                        case 'C' :
                                            GuiUtils::renderCheckbox($kodPolozky, null, ($nacteneHodnoty[$kodPolozky] == '' || $nacteneHodnoty[$kodPolozky] == 0) ? false : true, '', '', 1);
                                            break;

                                        case 'ID':
                                            echo "<input type='hidden' name='{$kodPolozky}' value='$nacteneHodnoty[$kodPolozky]'>";
                                            //ID momentalne nezobrazovat
                                            break;

                                        case 'S_RODINNYVZTAH' : //Rodinny prislusnik
                                        case 'S_ZDRAVOTNISTAV' :
                                        case 'S_RODINNYSTAV' :
                                        case 'TYPPRUKAZU' :
                                        case 'S_TYPZAMESTNANCEPROZP' :  // pojisteni
                                        case 'S_ZPUSOBUKONCENISKOLY' :  // vzdelani
                                        case 'TYPVZDELANI' :            // vzdelani
                                        case 'DOPRAVADOZAMESTNANI' :    //Bydliste
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->className = "form-input $povinne";
                                            //$comboBox->titleFieldName = $popisPolozky;
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database,
                                                "SELECT Kod, Popis FROM {$typPolozky} ORDER BY Kod",
                                                isset($nacteneHodnoty[$kodPolozky]) ? $nacteneHodnoty[$kodPolozky] : null);
                                            $comboBox->render();
                                            break;


                                        //Bydliste
                                        case 'MESTO' :
                                            $value = isset($nacteneHodnoty[$kodPolozky]) ? StringUtils::htmlTextConvert($nacteneHodnoty[$kodPolozky]) : '';
                                            echo
                                                "<input class='form-input $povinne ronselect select-mesto' name='{$kodPolozky}' title='{$popisPolozky}' value='$value' ".
                                                " data-ronselect-class='form-input' data-max-visible-rows='30' " .
                                                " data-columns='mesto;psc;obec' data-text-column='mesto' data-only-autocomplete='1' " .
                                                " data-auto-load-items='1' data-items-url='?menuid=download&seznammest=1' " .
                                                " data-value-property='mesto' type='text'/>";
//                                            echo "<input class='form-input $povinne autocomplete' data-items-url='?menuid=download&seznammest=1' data-value-property='mesto' type='text' name='{$kodPolozky}' title='{$popisPolozky}' value='$value'>";
//                                            $poleMesto = $nacteneHodnoty[$kodPolozky] == '' ? \Ron\ronText("nacitani_mest") : \Ron\ronText("nacitani_mesta");
//                                            echo "<input name='mesto2' class='selectMesto $povinne' value='$poleMesto'/>";
//                                            echo "<input type='hidden' name='$kodPolozky' value='$nacteneHodnoty[$kodPolozky]'/>";
//                                            echo "<i class='fa fa-spin glyph-spinner margin-left' id='loadingSpinnerMesto'></i>";
                                            break;

                                        case 'OBEC' :
                                            echo
                                                "<select class='ronselect form-input' name='{$kodPolozky}' " .
                                                " data-ronselect-class='form-input' data-max-visible-rows='30' " .
                                                " data-columns='popis;okresPopis' data-captions='" . \Ron\ronText('Nazev') . ';' . \Ron\ronText('Okres') . "' " .
                                                " data-value-column='kod' data-text-column='popis' " .
                                                " data-auto-load-items='1' data-items-url='?menuid=download&seznamobci=1'>";

                                            if ($nacteneHodnoty[$kodPolozky]) {
                                                $params = $this ->database->createParameters();
                                                $obec = DBUtils::getSqlValue($this ->database,
                                                    'SELECT Popis FROM Obec WHERE Kod = ' . $params->addParameter($nacteneHodnoty[$kodPolozky]),
                                                    $params);

                                                if ($obec) {
                                                    $value = StringUtils::htmlTextConvert($nacteneHodnoty[$kodPolozky]);
                                                    echo "<option value='$value' selected='selected'>" . StringUtils::htmlTextConvert($obec). '</option>';
                                                }
                                            };

                                            echo
                                                "</select>";
                                            break;

                                        case 'STAT' :
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->className = 'form-input';
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database,
                                                "SELECT Kod, Popis, 1 as preferujicesko FROM Stat WHERE Kod  = 'CZ'" .
                                                " UNION SELECT Kod, Popis, 2 as preferujicesko FROM Stat WHERE Kod <> 'CZ'" .
                                                ' ORDER BY 3, 2', isset($nacteneHodnoty[$kodPolozky]) ? $nacteneHodnoty[$kodPolozky] : ''); //CZ jako prvni radek
                                            $comboBox->render();
                                            break;


//                                        case 'S_TYPBANKOVNIHOUCTU' : // ucet
//                                            $comboBox = new ComboBox($pomarray[1]);
//                                            $comboBox->className = 'app_combo col col-12 col-sm-5';
//                                            $comboBox->dataTypeComparison = false;
//                                            $comboBox->loadData($this ->database, "SELECT Kod, Popis FROM {$pomarray[0]} WHERE Kod = 1 ORDER BY Kod DESC", $nacteneHodnoty[$i]);
//                                            $comboBox->render();
//                                            break;

                                        case 'IBAN' : // ucet
                                            echo "<input class='form-input ZahranicniPlatba' name='{$kodPolozky}' value='$nacteneHodnoty[$kodPolozky]'>";
                                            break;

                                        case 'MENA' : // ucet
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->showCode = true;
                                            $comboBox->className = 'form-input ZahranicniPlatba';
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database, "SELECT KodMeny_ISO, PopisMeny FROM {$typPolozky} ORDER BY PopisMeny", $nacteneHodnoty[$kodPolozky]);
                                            $comboBox->render();
                                            break;

                                        case 'KONSTANTNISYMBOL' : // ucet
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->showCode = true;
                                            $comboBox->className = 'form-input ronselect';
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database, "SELECT DISTINCT Kod, Popis FROM {$kodPolozky} ORDER BY Popis", $nacteneHodnoty[$kodPolozky]);
                                            $comboBox->render();
                                            break;


                                        case 'UCTARNA' :        // zdravotni pojisteni
                                        case 'ZDRAVOTNIPOJISTOVNA' : // zdravotni pojisteni
                                        case 'PENZIJNIFOND' :   // penzijni pripojisteni
                                        case 'POJISTOVNA' :     // zivotni pojisteni
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->className = 'form-input ronselect';
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database, "SELECT Kod, Popis FROM {$typPolozky} ORDER BY Popis", $nacteneHodnoty[$kodPolozky]);
                                            $comboBox->render();
                                            break;

                                        case 'BANKA' : //ucetosoby
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->showCode = true;
                                            $comboBox->className = 'form-input ronselect';
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database, "SELECT Kod, Nazev FROM {$typPolozky} ORDER BY Nazev", $nacteneHodnoty[$kodPolozky]);
                                            $comboBox->render();
                                            break;

                                        //penzijni pripojisteni - ucet zamestnance
                                        case 'BZ' :
                                        case 'BF' :
                                            $params = $this ->database->createParameters();
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->className = 'form-input';
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database,
                                                'SELECT SerioveCislo, JmenoUctu FROM BankovniUcet INNER JOIN PracovniPomer PP on BankovniUcet.RC = PP.RC' .
                                                ' WHERE PP.ID = ' . $params->addParameter($this ->nahlasenaZmena ->idPPOsobyZmeny) .
                                                ' ORDER BY JmenoUctu',
                                                $nacteneHodnoty[$kodPolozky], $params);

                                            $comboBox->render();
                                            break;

                                        //vzdelani
                                        case 'OBORVZDELANI' :
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->className = "form-input $povinne";
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database,
                                                "SELECT Kod, Popis, 1 as neurceno FROM {$typPolozky} WHERE Kod  = '0000'" . // neurcen jako prvni radek
                                                " UNION SELECT Kod, Popis, 2 as neurceno FROM {$typPolozky} WHERE Kod <> '0000'" .
                                                ' ORDER BY 3, 2',
                                                $nacteneHodnoty[$kodPolozky]);
                                            $comboBox->render();
                                            break;

                                        //vzdelani
                                        case 'SKOLA' :
                                            $comboBox = new ComboBox($kodPolozky);
                                            $comboBox->className = "form-input $povinne";
                                            $comboBox->dataTypeComparison = false;
                                            $comboBox->loadData($this ->database,
                                                "SELECT Kod, Nazev FROM {$typPolozky} ORDER BY Nazev",
                                                $nacteneHodnoty[$kodPolozky]);
                                            $comboBox->render();
                                            break;

                                        //vzdelani
                                        case 'OBORVZDELANIISPV':
                                            echo "<input type='text' class='$povinne'
                                                    name='$kodPolozky' id='$kodPolozky'
                                                    title='$popisPolozky' value='$nacteneHodnoty[$kodPolozky]'> ";
                                            //echo "&nbsp;&nbsp;&nbsp;&nbsp;";
                                            echo " <a name='$kodPolozky-vyhledej' id='$kodPolozky-vyhledej' href='' >" . \Ron\ronText('vyhledej') . "</a>";
                                            break;

                                        case 'VLASTNIPOZNAMKA':
                                            $vlastniPoznamka = StringUtils::htmlTextConvert($nacteneHodnoty[$kodPolozky]);
                                            echo "<textarea class='form-input vlastnipoznamka' rows='4' name='vlastnipoznamka'>$vlastniPoznamka</textarea>";
                                            break;

                                        case 'SOUBOR':
                                            echo "<INPUT class='form-input' type='file' name='$kodPolozky'>";
                                            break;
                                    }

                                } else {
                                    //Sekce pouze vypisuje hodnoty zmeny - zmena je jiz ulozena!
                                    switch (strtoupper($typPolozky)) {
                                        case 'E' :
                                            echo is_numeric($nacteneHodnoty[$kodPolozky])       // ? ? ?
                                                ? $nacteneHodnoty[$kodPolozky]
                                                : StringUtils::htmlTextConvert($nacteneHodnoty[$kodPolozky]);
                                            break;

                                        case 'D' :
                                            echo StringUtils::format('date', $nacteneHodnoty[$kodPolozky]);
                                            break;

                                        case 'C' :
                                            if ($nacteneHodnoty[$kodPolozky] == 1 || $nacteneHodnoty[$kodPolozky] == 'on') {
                                                echo "<input type='checkbox' disabled='disabled' checked='checked' >";
                                            } else {
                                                echo "<input type='checkbox' disabled='disabled'  >";
                                            }
                                            break;

                                        case 'ID':
                                            break;


                                        // kod (string) => popis
                                        case 'STAT' :
                                        case 'POJISTOVNA' :     // zivotni pojisteni
                                        case 'PENZIJNIFOND' :
                                        case 'ZDRAVOTNIPOJISTOVNA' :
                                        case 'UCTARNA' :        // zdravotni pojisteni
                                        case 'OBORVZDELANI' :   // vzdelani
                                            $params = $this ->database->createParameters();
                                            $value = DBUtils::getSqlValue($this ->database,
                                                "SELECT Popis FROM {$typPolozky} WHERE Kod = " . $params->addParameter($nacteneHodnoty[$kodPolozky]),
                                                $params);
                                            echo StringUtils::htmlTextConvert($value);
                                            break;

                                        // kod (int) => popis
                                        case 'TYPPRUKAZU' :
                                        case 'S_RODINNYVZTAH' :
                                        case 'S_ZDRAVOTNISTAV' :
                                        case 'S_RODINNYSTAV' :
                                        case 'S_TYPZAMESTNANCEPROZP' :
                                        case 'DOPRAVADOZAMESTNANI' :    // Adresa
                                        case 'TYPVZDELANI' :            // vzdelani
                                        case 'S_ZPUSOBUKONCENISKOLY' :  // vzdelani
                                        // case 'S_TYPBANKOVNIHOUCTU' :
                                            $params = $this ->database->createParameters();
                                            $value = DBUtils::getSqlValue($this ->database,
                                                "SELECT Popis FROM {$typPolozky} WHERE Kod = " . $params->addParameter((int)$nacteneHodnoty[$kodPolozky]),
                                                $params);
                                            echo StringUtils::htmlTextConvert($value);
                                            break;

                                        // kod (string) => nazev
                                        case 'SKOLA' :          // vzdelani
                                            $params = $this ->database->createParameters();
                                            $value = DBUtils::getSqlValue($this ->database,
                                                "SELECT Nazev FROM {$typPolozky} WHERE Kod = " . $params->addParameter($nacteneHodnoty[$kodPolozky]),
                                                $params);
                                            echo StringUtils::htmlTextConvert($value);
                                            break;



                                        case 'OBEC' :
                                            //$splitObec = explode(";", $nacteneHodnoty[$i]);       // ? ? ?
                                            $params = $this ->database->createParameters();
                                            $obec = DBUtils::getSqlValue($this ->database,
                                                'SELECT Popis FROM Obec WHERE Kod = ' . $params->addParameter($nacteneHodnoty[$kodPolozky]),
                                                $params);
                                            echo StringUtils::htmlTextConvert($obec);
                                            break;

                                        // kod => nazev (kod)
                                        case 'BANKA' :
                                            $params = $this ->database->createParameters();
                                            $sql = "SELECT Kod, Nazev FROM {$typPolozky} WHERE Kod = " . $params->addParameter($nacteneHodnoty[$kodPolozky]);
                                            $cursor = $this ->database->getSqlResult($sql, $params);
                                            $row = $cursor->fetch();
                                            $cursor ->close();
                                            echo StringUtils::htmlTextConvert($row[1]) . ' (' . StringUtils::htmlTextConvert($row[0]) . ')';
                                            break;


                                        // kod(string) => popis (kod)
                                        case 'KONSTANTNISYMBOL' : // ucet
                                            $params = $this ->database->createParameters();
                                            $sql = "SELECT Kod, Popis FROM {$typPolozky} WHERE Kod = " . $params->addParameter($nacteneHodnoty[$kodPolozky]);
                                            $cursor = $this ->database->getSqlResult($sql, $params);
                                            $row = $cursor->fetch();
                                            $cursor ->close();
                                            echo StringUtils::htmlTextConvert($row[1]) . ' (' . StringUtils::htmlTextConvert($row[0]) . ')';
                                            break;

                                        case 'BZ' :     // penzijni pripojisteni - ucet zamestnance
                                        case 'BF' :     // penzijni pripojisteni - ucet firma
                                            $params = $this ->database->createParameters();
                                            $ucet = DBUtils::getSqlValue($this ->database,
                                                'SELECT JmenoUctu FROM BankovniUcet' .
                                                ' WHERE TypUctu = 1 AND RC = ' . $params->addParameter($nahlasenaZmena ->rcOsobyZmeny) .
                                                ' AND SerioveCislo = ' . $params->addParameter((int)$nacteneHodnoty[$kodPolozky]),
                                                $params);
                                            echo StringUtils::htmlTextConvert($ucet);
                                            break;

                                        case 'SOUBOR':
                                            break;

                                        case 'VLASTNIPOZNAMKA':
                                            echo '<div  class="poznamka">' . StringUtils::longTextToHtml(StringUtils::htmlTextConvert($nacteneHodnoty[$kodPolozky])) . '</div>';
                                            break;

                                        case 'OBORVZDELANIISPV' :
                                        case 'MESTO' :
                                        case 'VARIABILNISYMBOL' : // ucet
                                        case 'IBAN' :   // ucet
                                        case 'MENA' :   // ucet
                                        case 'SPECIFICKYSYMBOL' : // ucet
                                        default :
                                            echo StringUtils::htmlTextConvert($nacteneHodnoty[$kodPolozky]);
                                            break;

                                    }
                                }?>

                            </div>
                        </div>
                    <?php } // foreach ?>

                    <div class="row">
                        <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Poznamka') ?></div>
                        <div class="col col-12 col-sm-9 poznamka">
                        <?php if (!$nahlasenaZmena ->stavZmeny) { ?>
                            <textarea class="form-input" rows="4" name="poznamka"><?= $nahlasenaZmena ->poznamka ? StringUtils::htmlTextConvert($nahlasenaZmena->poznamka) : '' ?></textarea>
                        <?php } else { ?>
                            <?= ($nahlasenaZmena  &&  $nahlasenaZmena->poznamka) ? StringUtils::htmlTextConvert($nahlasenaZmena->poznamka) : '' ?>
                        <?php }?>
                        </div>
                    </div>
                </div>
            <?php } ?>

            <?php if ($this ->nahlasenaZmena ->messages) { ?>
                <div class="hlaseni_zmeny_info">
                    <?php foreach ($this ->nahlasenaZmena ->messages as $message) { // $message muze obsahovat HTML znacky ?>
                        <div class="warningmsg"><?= $message ?></div>
                    <?php } ?>
                </div>
            <?php } ?>
        </div>


        <div class="buttons">
            <?php if ($back != '') { ?>
                <span class="button clickHref" data-ron-href="?menuid=osobniudaje&osoba=<?= $this ->nahlasenaZmena ->idPPOsobyZmeny ?>"><?= \Ron\ronText('zpet')?></span>
            <?php } else { ?>
                <span class="button clickHref" data-ron-href="?menuid=nahlasenezmeny"><?= \Ron\ronText('zpet')?></span>
            <?php } ?>

            <?php if(!$this ->nahlasenaZmena ->id) {   // Pokud se jedna o hlaseni nove zmeny  ?>
                <?php if (!$this ->detail) { ?>
                    <button type="reset" class="button" value=""><?=\Ron\ronText('form.Original') ?></button>
                    <button type="submit" class="submitbutton" value=""><?= \Ron\ronText('form.Store') ?></button>
                <?php }?>

            <?php } else { // Pokud se jedna o editaci nahlasene zmeny ?>
                <?php if (!$nahlasenaZmena->stavZmeny) {
                    //Zobrazi jen pokud neni zmena jiz zpracovana
                    ?>
                    <button type="reset" class="button" value=""><?=\Ron\ronText('form.Original') ?></button>

                    <?php if ($this ->lzeEditovat) { ?>
                        <button type="submit" class="submitbutton" name="upravit_zmenu" value=""><?= \Ron\ronText('upravit_zmenu')?></button>
                    <?php }?>

                    <div class="float-right">
                        <?php if ($this ->lzeSchvalit) { ?>
                            <button type="submit" class="submitbutton" name="potvrdit_zmenu" value=""><?= \Ron\ronText('potvrdit_zmenu')?></button>
                        <?php }?>

                        <?php if ($this ->lzeSchvalit) { ?>
                            <button type="submit" class="submitbutton" name="odmitnout_zmenu" value=""><?= \Ron\ronText('odmitnout_zmenu')?></button>
                        <?php }?>
                    </div>
                <?php }?>

            <?php } ?>
        </div>
    </div>

</form>

<?php require 'person/view_historieosobnich.php'; ?>

<?php
    //Sekce pro pripojeni dokumentu
    if($this ->dokumentBrowser  &&  $this ->nahlasenaZmena ->id  &&  $nahlasenaZmena ->typZmeny != "velikostpomucek") {?>
    <div>
        <?php $this ->dokumentBrowser->render();  ?>
        <?php if(!$this ->nahlasenaZmena->stavZmeny) { ?>
            <div class="margin-top-2">
                <a href='javascript:void(0)' onclick='showDokumentZmenyUploadDialog(<?= $nahlasenaZmena ->id ?>,<?=
                    (isset($_GET['backurlzmeny']) && $_GET['backurlzmeny'] == "osobniudaje") ? 1 : 0
                ?>);'><?= \Ron\ronText('novy_dokument_nahlasene_zmeny') ?></a>
            </div>

            <?php
                require_once 'adsapp/dokumentyutils.php';
                $novyDokumentNahlaseneZmeny = new DokumentUploadForm($this ->database, '?menuid=nahlasenezmeny&action=dokumentupload');
                $novyDokumentNahlaseneZmeny ->hiddenFields = ['IDZmeny' => $nahlasenaZmena ->id];
                $novyDokumentNahlaseneZmeny ->render();
            ?>
        <?php } ?>
    </div>
<?php } ?>

<?php $this ->historieNahlasenychZmenBrowser->render(); // seznam drive nahlasenych zmen ?>
