<?php
/**
 * stanislav.elbl, 09.06.2020
 *
 * Typy nahlasenych zmen:
 * trvale
 * prechodne
 *          D:PlatnostOd:Platnost_od:Po;E:Ulice:Ulice;Mesto:Mesto:Mesto_cast_obce;Obec:Obec:Obec;E:PSC:psc;Stat:Stat:Stat;
 *          DopravaDoZamestnani:DopravaDoZamestnani:Zpusob_dopravy:Po;E:VzdalenostDoZamestnani:Vzdalenost_do_zamestnani;
 *          D:PlatnostDo:Platnost_do;soubor:soubor:Pripojit_dokument
 * rodinnystav
 *          D:PlatnostOd:Platnost_od:Pr;S_RodinnyStav:RodinnyStav:Rodinny_stav:Po;soubor:soubor:Pripojit_dokument
 * ucetosoby
 *          E:CisloUctu:Cislo_uctu;Banka:Banka:Banka;E:VariabilniSymbol:Variabilni_symbol;D:PlatnostOd:Platnost_od;soubor:soubor:Pripojit_dokument
 *   (puvodni:)
 *          E:JmenoUctu:Jmeno_uctu;S_TypBankovnihoUctu:TypUctu:Typ_uctu;E:CisloUctu:Cislo_uctu;Banka:Banka:Banka;
 *          C:ZahranicniPlatba:Zahranicni_platba;IBAN:IBAN:IBAN;Mena:KodMeny_ISO:Kod_meny;E:SpecifickySymbol:specificky_symbol;
 *          KonstantniSymbol:KonstantniSymbol:konstantni_symbol;E:VariabilniSymbol:Variabilni_symbol;
 *          D:PlatnostOd:Platnost_od;D:PlatnostDo:Platnost_do;soubor:soubor:Pripojit_dokument
 * pojistovna
 *          ZdravotniPojistovna:KodZdravotniPojistovny:pojistovna:Pr;D:PlatnostOd:Platnost_od:Pr;D:PlatnostDo:Platnost_do;
 *          E:CisloPojistence:Cislo_pojistence:Po;Uctarna:CisloUctarny:Cislo_uctarny:Po;S_TypZamestnanceProZP:TypZamestnance:Typ_zamestnance_ZP:Po;
 *          soubor:soubor:Pripojit_dokument
 * penzijnipripojisteni
 *          PenzijniFond:PenzijniFond:Penzijni_fond:Pr;D:PlatnostOd:Platnost_od:Pr;D:PlatnostDo:Platnost_do;E:CisloSmlouvy:Cislo_smlouvy;
 *          E:PrispevekZamestnavatele:prispevek_zamestnavatele;BF:SerioveCisloUctu1:Bankovni_ucet;E:PrispevekZamestnance:prispevek_zamestnance;
 *          BZ:SerioveCisloUctu2:Bankovni_ucet;soubor:soubor:Pripojit_dokument
 * zivotnipojisteni
 *          Pojistovna:Pojistovna:pojistovna:Pr;D:PlatnostOd:Platnost_od:Pr;D:PlatnostDo:Platnost_do;E:CisloSmlouvy:Cislo_smlouvy;
 *          E:PrispevekZamestnavatele:prispevek_zamestnavatele;BF:SerioveCisloUctu1:Bankovni_ucet;E:PrispevekZamestnance:prispevek_zamestnance;
 *          BZ:SerioveCisloUctu2:Bankovni_ucet;soubor:soubor:Pripojit_dokument
 * vzdelani
 *          TypVzdelani:TypVzdelani:Typ_vzdelani:Pr;OborVzdelani:OborVzdelani:Obor_vzdelani:Pr;D:DatumUkonceni:Datum_ukonceni:Po;
 *          Skola:Skola:Skola;D:DatumOd:Datum_od;D:DatumDo:Datum_do;E:Zamereni:Zamereni;
 *          S_ZpusobUkonceniSkoly:VzdelaniUkonceno:Vzdelani_ukonceno:Po;soubor:soubor:Pripojit_dokument
 * osobni
 *          E:Titul:Titul_pred;E:TitulZa:Titul_za;E:Jmeno:Jmeno;E:Prijmeni:Prijmeni:Po;E:Email:E_mail;E:Telefon:Telefon;E:Mobil:Mobil;soubor:soubor:Pripojit_dokument
 * rodinnyprislusnik
 * novyclenrodiny
 *          E:Prijmeni:Prijmeni:Po;E:Jmeno:Jmeno:Po;E:RC_RodinnehoPrislusnika:RC_rodinneho_prislusnika:Pr;E:Titul:Titul;D:DatumNarozeni:Datum_narozeni:Po;
 *          S_RodinnyVztah:RodinnyVztah:rodinny_vztah;D:PartnerDatumOd:Registrace_od;D:PartnerDatumDo:Registrace_do;
 *          S_ZdravotniStav:ZdravotniStav:Zdravotni_stav:Po;C:DrzitelPrukazuZTTP:Drzitel_prukazu_ZTP;D:DatumPriznaniZTTP:Datum_priznani_ZTP;
 *          C:VyzivovanaOsoba:vyzivovana_osoba;C:StejnaAdresa:Stejna_adresa_jako_zamestnanec;C:KontaktniOsoba:kontaktni_osoba;
 *          E:Telefon:Telefon;E:Email:E_mail;ID:ID:ID;soubor:soubor:Pripojit_dokument
 * velikostpomucek
 *          -
 * prukaz
 *          TypPrukazu:TypPrukazu:Typ_prukazu:Po;E:CisloPrukazu:Cislo_prukazu:Po;Stat:Stat:Stat;D:PlatnostOd:Platnost_od;D:PlatnostDo:Platnost_do;vlastnipoznamka:vlastnipoznamka:Poznamka_k_prukazu
 */

namespace Ron\Personalistika;

use Ron\DateUtils;
use Ron\DB\SQLUtils;
use Ron\MessageManager;
use Ron\DB\Database;
use Ron\RonPortal\NeniPravoException;
use Ron\RonPortal\PracovniPomer;
use Ron\RonPortal\Prava;
use Ron\RonPortal\RonPortalDBRecord;
use Ron\RonPortal\RonPortalUtils;
use Ron\RonPortal\User;

/**
 * Class NahlasenaZmena
 */
class NahlasenaZmena
{
    /** @var int        Id nahlasene zmeny */
    public $id;

    /** @var string     Kod typu zmeny */
    public $typZmeny;
    /** @var string     Nataveni zmeny nactene z databaze (TypNahlaseneZmeny.Nastaveni) */
    public $nastaveniZmeny;
    /** @var int        Priznak, jestli je tato zmena povolena (TypNahlaseneZmeny.PovolitVIntrawebu) */
    public $povolitVIntrawebu;
    /** @var string     Popis typu zmeny (TypNahlaseneZmeny.Popis) */
    public $popisTypuZmeny;

    public $stavZmeny;
    public $datumCasNahlaseneZmeny;

    public $idPPOsobyZmeny;
    public $rcOsobyZmeny;
    public $celeJmenoOsobyZmeny;

    /** @var string     Text hodnot nactenych z databaze */
    public $hodnoty;

    public $datumCasZpracovani;
    public $zpracoval;
    public $celeJmenoZpracovateleZmeny;

    public $poznamka;

    /** @var string[]   Dodatecne zpravy, ktere se mohou zobrazit pod nahlasenou zmenou */
    public $messages = [];

    /** @var mixed[]    Asociativni pole hodnot zadanych uzivatelem */
    public $nacteneHodnoty = [];

    /**
     * @param Database $database
     * @param $idZmeny
     * @return NahlasenaZmena
     * @throws \Exception
     */
    public static function nactiNahlasenouZmenu($database, $idZmeny)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT NahlasenaZmena.id,NahlasenaZmena.TypZmeny,NahlasenaZmena.RC,NahlasenaZmena.DatumCas, ' .    //0..3
            $database->castWideMemo("NahlasenaZmena.Hodnoty") . ', ' .                      //4
            ' NahlasenaZmena.DatumCasZpracovani, NahlasenaZmena.Zpracoval, ' .              //5..6
            $database->castWideMemo('NahlasenaZmena.Poznamka') . ', PracovniPomer.ID, ' .   //7..8
            ' Osoba.Titul, Osoba.Jmeno, Osoba.Prijmeni, ' .                                 //9..11
            ' Zapracoval.Titul, Zapracoval.Jmeno, Zapracoval.Prijmeni, ' .                  //12..14
            $database->castWideMemo('TypNahlaseneZmeny.Nastaveni') . ', ' .                 // 15
            ' NahlasenaZmena.Stav, TypNahlaseneZmeny.PovolitVIntrawebu, TypNahlaseneZmeny.Popis ' . //16..18
            ' FROM NahlasenaZmena' .
            ' JOIN TypNahlaseneZmeny ON TypNahlaseneZmeny.Kod = NahlasenaZmena.TypZmeny' .
            ' LEFT JOIN PracovniPomer ON (NahlasenaZmena.RC = PracovniPomer.RC)' .
            ' LEFT JOIN Osoba ON (NahlasenaZmena.RC = Osoba.RC)' .
            ' LEFT JOIN Osoba Zapracoval ON (NahlasenaZmena.Zpracoval = Zapracoval.RC)' .
            ' WHERE NahlasenaZmena.ID = ' . $params->addParameter($idZmeny);

        $cursor = $database->getSqlResult($sql, $params);
        $row = $cursor->fetch();
        $cursor ->close();

        if (!$row){
            throw new \Exception(\Ron\ronText('nahlasena_zmena_neexistuje'));
        }

        $nahlasenaZmena = new NahlasenaZmena();
        $nahlasenaZmena->nactiZmenuZRadku($database, $row);
        return $nahlasenaZmena;
    }

    /**
     * @param Database $database
     * @param $row
     * @throws \Exception
     */
    private function nactiZmenuZRadku($database, $row)
    {
        $this->id = $row[0];
        $this->typZmeny = $row[1];
        $this->rcOsobyZmeny = $row[2];
        $this->datumCasNahlaseneZmeny = $database->stringToTimestamp($row[3]);
        $this->hodnoty = $row[4];
        $this->datumCasZpracovani = $database->stringToTimestamp($row[5]);
        $this->zpracoval = $row[6];
        $this->poznamka = $row[7];
        $this->idPPOsobyZmeny = (int)$row[8];
        $this->celeJmenoOsobyZmeny = ($row[9] ? $row[9] . ' ' : '') . ($row[10] ? $row[10] . ' ' : '') . ($row[11] ?: '');
        //$this->celeJmenoZpracovateleZmeny = $row[10];
        $this->celeJmenoZpracovateleZmeny = ($row[12] ? $row[12] . ' ' : '') . ($row[13] ? $row[13] . ' ' : '') . ($row[14] ?: '');
        $this->nastaveniZmeny = $row[15];
        $this->stavZmeny = (int)$row[16];
        $this->povolitVIntrawebu = (int)$row[17];
        $this->popisTypuZmeny = $row[18];

        $this->nacteneHodnoty = $this->nactiHodnoty($this ->hodnoty, $this ->nastaveniZmeny);
    }


    /**
     * Vytvori asociativni pole zadanych hodnot. Datumove polozky prevede na timestamp
     * @param string $hodnoty
     * @param string $nastaveni
     * @return array
     * @throws \Exception
     */
    private function nactiHodnoty($hodnoty, $nastaveni)
    {
        // zjisti, ktere polozky jsou datumove
        $rows = explode(';', $nastaveni);
        $datumovePolozky = [];
        foreach ($rows as $radek) {
            $pomarray = explode(':', $radek);
            if ($pomarray[0] == "D"){
                $datumovePolozky[] = strtolower(trim($pomarray[1]));
            }
        }

        $hodnotyZmeny = explode("\n", $hodnoty);
        $result = [];

        foreach ($hodnotyZmeny as $radek) {
            //list($key, $hodnotaZmeny) = explode('=', $radek, 2);
            $a_key_value = explode('=', $radek, 2);
            $key = isset($a_key_value[0]) ? $a_key_value[0] : '';
            $hodnotaZmeny = isset($a_key_value[1]) ? $a_key_value[1] : '';

            $hodnotaZmeny = str_replace('\r', "\r", str_replace('\n', "\n", $hodnotaZmeny));

            if ($key != '') {
                if (in_array(strtolower($key), $datumovePolozky)) {
                    try {
                        $value = trim($hodnotaZmeny);
                        $result[$key . '#STR'] = $value;
                        $result[$key] = $value != ''
                            ? DateUtils::dateStringToTimestamp($hodnotaZmeny)
                            : null;
                    } catch (\Exception $e) {
                        MessageManager::addErrorMessage('Chyba v polozce ' . $key . ': ' . $e ->getMessage());
                    }
                } else {
                    $result[$key] = $hodnotaZmeny;
                }
            }
        }

        return $result;
    }

    /**
     * Suffixy pro kody uzivatelsky prav pro prohlizeni jednotlivych sekci v osobnich udajich a hlaseni zmen
     * podle kodu typu zmeny. Pokud zde neni zadan, pouzije se primo kod typu zmeny (v pripadech kdy je max. 11 znaku)
     */
    const KODY_PRAV = [
        'penzijnipripojisteni' => 'penzijni',
        'rodinnyprislusnik' =>  'prislusnik',
        'zivotnipojisteni' =>   'zivotni',
        'pracovnimista' =>      'pracmista',
        'velikostpomucek' =>    'velikosti',
        'novyclenrodiny' =>     'novyclen'
        // ucetosoby, trvale, prechodne, prukaz, rodinnystav, pojistovna, vzdelani, pomucky, osobni
    ];


    /**
     * Zkontroluje, jestli ma uzivatel pravo na prohlizeni/editaci zadaneho typu zmeny
     * @param string $typZmeny  Kod typu zmeny
     * @param string $rc        RC osoby (z tabulky Osoba.RC)
     * @param bool $editace     Pokud je true, musi mit pravo na editaci.
     * @param bool $schvaleni   Pokud je true, musi mit pravo na schvaleni
     * @return bool
     * @throws \Exception
     */
    public static function jePravoNaZmenu($typZmeny, $rc, $editace, $schvaleni = false)
    {
        //prohl_osobni          + max 17 znaku
        //ou_zmeny_nahlaseni    + max 11 znaku
        //ou_zmeny_schval       + max 14 znaku

        // kody prav jsou zkracene (suffix muze mit max 11 znaku)
        $a = self::KODY_PRAV;
        $suffix = isset($a[$typZmeny]) ? $a[$typZmeny] : $typZmeny;

        if (!$editace  &&  !$schvaleni) {
            if (Prava::vratPrava('prohl_osobni', 'prohl_osobni_' . $suffix) ->lzeZobrazitRC($rc)) {
                // OK, muze prohlizet tuto zmenu
                return true;
            }

            // pokracuje dale, protoze muze zmenu zobrazit, kdyz ma na ni pravo editace nebo schvaleni
        }

        if (!$schvaleni) {
            // zkontroluje pravo na editaci
            if (Prava::vratPrava('ou_zmeny_nahlaseni', 'ou_zmeny_nahlaseni_' . $typZmeny)->lzeZobrazitRC($rc)) {
                // OK, muze nahlasit tuto zmenu => ma pravo prohlizet a editovat
                return true;
            } else if ($editace) {
                return false;
            }
        }

        if (Prava::vratPrava('ou_zmeny_schval') ->lzeZobrazitRC($rc)) {
            // muze schvalovat
            return true;
        }

        return false;
    }

    /**
     * Zkontroluje, jestli ma uzivatel pravo na prohlizeni/editaci zadaneho typu zmeny
     * @param string $typZmeny  Kod typu zmeny
     * @param string $rc        RC osoby (z tabulky Osoba.RC)
     * @param bool $editace     Pokud je true, musi mit pravo na editaci.
     * @param bool $schvaleni   Pokud je true, musi mit pravo na schvaleni.
     * @throws NeniPravoException
     * @throws \Exception
     */
    public static function zkontrolujPravoNaZmenu($typZmeny, $rc, $editace = false, $schvaleni = false)
    {
        if (!self::jePravoNaZmenu($typZmeny, $rc, $editace, $schvaleni)) {
            throw new NeniPravoException();
        }
    }

    public function zkontrolujPravo($editace = false, $schvaleni = false)
    {
        self::zkontrolujPravoNaZmenu($this ->typZmeny, $this ->rcOsobyZmeny, $editace, $schvaleni);
    }


    /**
     * Zkontroluje, jestli ma uzivatel pravo na prohlizeni/editaci zadaneho typu zmeny
     * @param Database $database
     * @param int $idZmeny      Id zapsane zmeny
     * @param bool $editace     Pokud je true, musi mit pravo na editaci.
     * @param bool $schvaleni   Pokud je true, musi mit pravo na schvaleni.
     * @throws NeniPravoException
     * @throws \Exception
     */
    public static function zkontrolujPravoNaZapsanouZmenu($database, $idZmeny, $editace = false, $schvaleni = false)
    {
        $zmena = self::nactiNahlasenouZmenu($database, $idZmeny);
        $zmena ->zkontrolujPravo($editace, $schvaleni);
    }


    /**
     * Nacte aktualni hodnoty a historii pro zadany typ zmeny. Hodnoty se zobrazi ve view_historieosobnich.php
     * @param Database $database
     * @param $rc
     * @param $typZmeny
     * @return array|bool
     * @throws \Ron\DB\DBException
     */
    public static function nactiAktualniHodnoty($database, $rc, $typZmeny)
    {
        $stavajiciHodnoty = [];
        $params = $database->createParameters();

        $sql = '';

        //Natahnuti aktualnich hodnot dle nahlasenych zmen - SELECT je sestaven pro jednoduchost presne dle konkretni nahlasene zmeny
        switch ($typZmeny) {
            case 'osobni':
                //*          E:Titul:Titul_pred;E:TitulZa:Titul_za;E:Jmeno:Jmeno;E:Prijmeni:Prijmeni:Po;E:Email:E_mail;E:Telefon:Telefon;E:Mobil:Mobil;soubor:soubor:Pripojit_dokument
                $sql .=
                    'SELECT Titul, TitulZa, Jmeno, Prijmeni, eMail, Telefon, Mobil' .
                    ' FROM Osoba WHERE RC = '. $params ->addParameter($rc);

                $cursor = $database->getSqlResult($sql, $params);
                while ($row = $cursor->fetch()) {
                    $stavajiciHodnoty[] = [
                        'Titul' => $row[0], 'TitulZa' => $row[1],
                        'Jmeno' => $row[2], 'Prijmeni' => $row[3],
                        'Email' => $row[4], 'Telefon' => $row[5], 'Mobil' => $row[6]
                    ];
                }
                $cursor ->close();

                break;

            case 'trvale':
            case 'prechodne':
                // D:PlatnostOd:Platnost_od:Po;E:Ulice:ulice;Mesto:Mesto:Mesto_cast_obce;Obec:Obec:Obec;E:PSC:psc;Stat:Stat:Stat;
                // DopravaDoZamestnani:DopravaDoZamestnani:Zpusob_dopravy:Po;E:VzdalenostDoZamestnani:Vzdalenost_do_zamestnani;
                // D:PlatnostDo:Platnost_do;soubor:soubor:Pripojit_dokument
                $sql .=
                    'SELECT AdresaOsoby.PlatnostOd, AdresaOsoby.Ulice, Mesto.Mesto, Obec.Popis, AdresaOsoby.PSC, AdresaOsoby.Stat,' . // 0..5
                    ' DopravaDoZamestnani.Popis, AdresaOsoby.VzdalenostDoZamestnani, AdresaOsoby.PlatnostDo,' . // 6..8
                    ' AdresaOsoby.Telefon1, AdresaOsoby.Telefon2, AdresaOsoby.Mobil, AdresaOsoby.E_mail' . // 9..12
                    ' FROM AdresaOsoby' .
                    ' LEFT JOIN Obec ON (AdresaOsoby.Obec = Obec.Kod)' .
                    ' LEFT JOIN Mesto ON (AdresaOsoby.PSC = Mesto.PSC AND AdresaOsoby.Mesto = Mesto.Mesto)' .
                    ' LEFT JOIN DopravaDoZamestnani ON (DopravaDoZamestnani.Kod = AdresaOsoby.ZpusobDopravy)' .
                    ' WHERE AdresaOsoby.RC = ' . $params ->addParameter($rc) .
                    ' AND AdresaOsoby.TrvaleBydliste = ' . $params ->addParameter($typZmeny == 'trvale' ? 1 : 0) .
                    ' ORDER BY PlatnostOd DESC';

                $cursor = $database ->getSqlResult($sql, $params);
                while ($row = $cursor->fetch()){
                    $stavajiciHodnoty[] = [
                        'PlatnostOd' => $database->stringToTimestamp($row[0]),
                        'Ulice' => $row[1], 'Mesto' => $row[2], 'Obec' => $row[3], 'PSC' => $row[4], 'Stat' => $row[5],
                        'DopravaDoZamestnani' => $row[6], 'VzdalenostDoZamestnani' => $row[7],
                        'PlatnostDo' => $database->stringToTimestamp($row[8]),
                        'Telefon1' => $row[9], 'Telefon2' => $row[10], 'Mobil' => $row[11], 'E_Mail' => $row[12]
                    ];
                }
                $cursor ->close();
                break;

            case 'prukaz':
                $sql .=
                    'SELECT TypPrukazu.Popis, Prukaz.CisloPrukazu, Stat.Popis, Prukaz.PlatnostOd, Prukaz.PlatnostDo, ' .
                    $database->castWideMemo('Poznamka') . ', TypPrukazu.Kod ' .
                    ' FROM Prukaz' .
                    ' LEFT JOIN TypPrukazu ON (TypPrukazu.Kod = Prukaz.TypPrukazu)' .
                    ' LEFT JOIN Stat ON (Prukaz.VydalStat = Stat.Kod)' .
                    ' WHERE Prukaz.RC = '. $params ->addParameter($rc) .
                    ' ORDER BY Prukaz.TypPrukazu';

                $cursor = $database ->getSqlResult($sql, $params);

                while ($row = $cursor->fetch()){
                    $stavajiciHodnoty[] = [
                        'TypPrukazu' => $row[0],
                        'CisloPrukazu' => $row[1],
                        'Stat' => $row[2],
                        'PlatnostOd' => $database->stringToTimestamp($row[3]),
                        'PlatnostDo' => $database->stringToTimestamp($row[4]),
                        'vlastnipoznamka' => $row[5],
                        'KodTypuPrukazu' => $row[6]
                    ];
                }
                $cursor ->close();
                break;

            case 'rodinnystav':
                // D:PlatnostOd:Platnost_od:Pr;S_RodinnyStav:RodinnyStav:Rodinny_stav:Po;soubor:soubor:Pripojit_dokument
                $sql .=
                    'SELECT PlatnostOd, S_RodinnyStav.Popis ' .
                    ' FROM RodinnyStav LEFT JOIN S_RodinnyStav ON (RodinnyStav.KodRodinnehoStavu = S_RodinnyStav.Kod)' .
                    ' WHERE RodinnyStav.RC = ' . $params ->addParameter($rc) .
                    ' ORDER BY PlatnostOd';
                $cursor = $database ->getSqlResult($sql, $params);

                while ($row = $cursor->fetch()) {
                    $stavajiciHodnoty[] = [
                        'PlatnostOd' => $database->stringToTimestamp($row[0]),
                        'RodinnyStav' => $row[1]
                    ];
                }
                $cursor ->close();
                break;

            case 'rodinnyprislusnik':
            case 'novyclenrodiny':
                $sql .=
                    'SELECT RodinnyPrislusnik.Prijmeni, RodinnyPrislusnik.Jmeno, RodinnyPrislusnik.RodneCisloRP, RodinnyPrislusnik.Titul, RodinnyPrislusnik.DatumNarozeni,' .
                    ' S_RodinnyVztah.Popis, ClenoveRodiny.PartnerDatumOd, ClenoveRodiny.PartnerDatumDo, S_ZdravotniStav.Popis, RodinnyPrislusnik.DrzitelPrukazuZTTP,' .
                    ' RodinnyPrislusnik.DatumPriznaniZTTP, ClenoveRodiny.VyzivovanaOsoba, ClenoveRodiny.StejnaAdresa, RodinnyPrislusnik.KontaktniOsoba,' .
                    ' RodinnyPrislusnik.Telefon, RodinnyPrislusnik.Email, RodinnyPrislusnik.RC_RodinnehoPrislusnika' .
                    ' FROM ClenoveRodiny' .
                    ' LEFT JOIN RodinnyPrislusnik ON (RodinnyPrislusnik.RC_RodinnehoPrislusnika = ClenoveRodiny.RC_RodinnehoPrislusnika)' .
                    ' LEFT JOIN S_ZdravotniStav ON (S_ZdravotniStav.Kod = RodinnyPrislusnik.ZdravotniStav)' .
                    ' LEFT JOIN S_RodinnyVztah ON (S_RodinnyVztah.Kod = ClenoveRodiny.RodinnyVztah)' .
                    ' WHERE ClenoveRodiny.RC = ' . $params ->addParameter($rc) .
                    ' AND (ClenoveRodiny.PartnerDatumOd IS NULL OR ClenoveRodiny.PartnerDatumOd <= ' . $params->addParameter($database->timestampToParam(time())) . ')' .
                    ' AND (ClenoveRodiny.PartnerDatumDo IS NULL OR ClenoveRodiny.PartnerDatumDo >= ' . $params->addParameter($database->timestampToParam(time())) . ')' .
                    ' ORDER BY RodinnyPrislusnik.DatumNarozeni';

                $cursor = $database ->getSqlResult($sql, $params);

                while ($row = $cursor->fetch()) {
                    $stavajiciHodnoty[] = [
                        'Prijmeni' => $row[0], 'Jmeno' => $row[1], 'RC_RodinnehoPrislusnika' => $row[2], 'Titul' => $row[3],
                        'DatumNarozeni' => $database->stringToTimestamp($row[4]),
                        'RodinnyVztah' => $row[5], 'PartnerDatumOd' => $database->stringToTimestamp($row[6]), 'PartnerDatumDo' => $database->stringToTimestamp($row[7]),
                        'ZdravotniStav' => $row[8], 'DrzitelPrukazuZTTP' => $row[9], 'DatumPriznaniZTTP' => $database->stringToTimestamp($row[10]),
                        'VyzivovanaOsoba' => $row[11], 'StejnaAdresa' => $row[12], 'KontaktniOsoba' => $row[13],
                        'Telefon' =>$row[14], 'Email' => $row[15], 'ID' => $row[16]
                    ];
                }
                $cursor ->close();
                break;

            case 'penzijnipripojisteni':
                $sql .=
                    'SELECT PenzijniFond.Popis, PlatnostOd, PlatnostDo, CisloSmlouvy, SmlouvaPenzijnihoPrip.PrispevekZamestnavatele,' .
                    '  UcetZamestnavatel.JmenoUctu, SmlouvaPenzijnihoPrip.PrispevekZamestnance, UcetZamestnanec.JmenoUctu' .
                    ' FROM SmlouvaPenzijnihoPrip LEFT JOIN PenzijniFond ON (SmlouvaPenzijnihoPrip.PenzijniFond = PenzijniFond.Kod)' .
                    ' LEFT JOIN BankovniUcet UcetZamestnavatel ON (SmlouvaPenzijnihoPrip.SerioveCisloUctu1 = UcetZamestnavatel.SerioveCislo)' .
                    ' LEFT JOIN BankovniUcet UcetZamestnanec ON (SmlouvaPenzijnihoPrip.SerioveCisloUctu2 = UcetZamestnanec.SerioveCislo)' .
                    ' WHERE SmlouvaPenzijnihoPrip.RC = ' . $params ->addParameter($rc) .
                    ' ORDER BY PlatnostOd';

                $cursor = $database ->getSqlResult($sql, $params);
                while ($row = $cursor->fetch()) {
                    $stavajiciHodnoty[] = [
                        'PenzijniFond' => $row[0],
                        'PlatnostOd' => $database->stringToTimestamp($row[1]), 'PlatnostDo' => $database->stringToTimestamp($row[2]),
                        'CisloSmlouvy' => $row[3], 'PrispevekZamestnavatele' => $row[4], 'SerioveCisloUctu1' => $row[5],
                        'PrispevekZamestnance' => $row[6], 'SerioveCisloUctu2' => $row[7]
                    ];
                }
                $cursor ->close();
                break;

            case 'zivotnipojisteni':
                $sql .=
                    'SELECT Pojistovna.Popis, PlatnostOd, PlatnostDo, CisloSmlouvy, SmlouvaZivotniPojisteni.PrispevekZamestnavatele,' .
                    '  UcetZamestnavatel.JmenoUctu, SmlouvaZivotniPojisteni.PrispevekZamestnance, UcetZamestnanec.JmenoUctu' .
                    ' FROM SmlouvaZivotniPojisteni' .
                    ' LEFT JOIN Pojistovna ON (SmlouvaZivotniPojisteni.Pojistovna = Pojistovna.Kod)' .
                    ' LEFT JOIN BankovniUcet UcetZamestnavatel ON (SmlouvaZivotniPojisteni.SerioveCisloUctu1 = UcetZamestnavatel.SerioveCislo)' .
                    ' LEFT JOIN BankovniUcet UcetZamestnanec ON (SmlouvaZivotniPojisteni.SerioveCisloUctu2 = UcetZamestnanec.SerioveCislo)' .
                    ' WHERE SmlouvaZivotniPojisteni.RC = '. $params ->addParameter($rc) .
                    ' ORDER BY PlatnostOd';

                $cursor = $database ->getSqlResult($sql, $params);
                while ($row = $cursor->fetch()) {
                    $stavajiciHodnoty[] = [
                        'Pojistovna' => $row[0],
                        'PlatnostOd' => $database->stringToTimestamp($row[1]), 'PlatnostDo' => $database->stringToTimestamp($row[2]),
                        'CisloSmlouvy' => $row[3],
                        'PrispevekZamestnavatele' => $row[4], 'SerioveCisloUctu1' => $row[5],
                        'PrispevekZamestnance' => $row[6], 'SerioveCisloUctu2' => $row[7]
                    ];
                }
                $cursor ->close();
                break;

            case 'vzdelani':
                $sql .=
                    'SELECT TypVzdelani.Popis, OborVzdelani.Popis, DatumUkonceni, Skola.Nazev, DatumOd, DatumDo, Zamereni, S_ZpusobUkonceniSkoly.Popis' .
                    ' FROM VzdelaniOsoby' .
                    ' LEFT JOIN TypVzdelani ON (TypVzdelani.Kod = VzdelaniOsoby.KodVzdelani)' .
                    ' LEFT JOIN S_ZpusobUkonceniSkoly ON (S_ZpusobUkonceniSkoly.Kod = VzdelaniOsoby.VzdelaniUkonceno)' .
                    ' LEFT JOIN OborVzdelani ON (OborVzdelani.Kod = VzdelaniOsoby.OborVzdelani)' .
                    ' LEFT JOIN Skola ON (Skola.Kod = VzdelaniOsoby.Skola)' .
                    ' WHERE VzdelaniOsoby.RC =  ' . $params ->addParameter($rc) .
                    ' ORDER BY DatumUkonceni DESC';

                $cursor = $database ->getSqlResult($sql, $params);
                while ($row = $cursor->fetch()) {
                    $stavajiciHodnoty[] = [
                        'TypVzdelani' => $row[0], 'OborVzdelani' => $row[1],
                        'DatumUkonceni' => $database->stringToTimestamp($row[2]), 'Skola' => $row[3],
                        'DatumOd' => $database->stringToTimestamp($row[4]), 'DatumDo' => $database->stringToTimestamp($row[5]),
                        'Zamereni' => $row[6], 'VzdelaniUkonceno' => $row[7]
                    ];
                }
                $cursor ->close();
                break;

            case 'ucetosoby':
                $sql .=
                    'SELECT JmenoUctu, S_TypBankovnihoUctu.Popis, CisloUctu, Banka.nazev, ZahranicniPlatba, IBAN,' .
                    '  Mena.PopisMeny, SpecifickySymbol, KonstantniSymbol.Kod, KonstantniSymbol.Popis,' .
                    '  VariabilniSymbol, VyplaceniMzdy.PlatnostOd, VyplaceniMzdy.PlatnostDo' .
                    ' FROM BankovniUcet JOIN VyplaceniMzdy ON (BankovniUcet.SerioveCislo = VyplaceniMzdy.SerioveCisloUctuVyplaty)' .
                    ' LEFT JOIN S_TypBankovnihoUctu ON (S_TypBankovnihoUctu.Kod = BankovniUcet.TypUctu)' .
                    ' LEFT JOIN Banka ON (Banka.kod = BankovniUcet.KodBanky)' .
                    ' LEFT JOIN Mena ON (Mena.KodMeny_ISO = BankovniUcet.KodMeny_ISO)' .
                    ' LEFT JOIN KonstantniSymbol ON (BankovniUcet.KonstantniSymbol = KonstantniSymbol.kod)' .
                    ' WHERE TypUctu = 1 AND BankovniUcet.RC = '. $params ->addParameter($rc) .
                    ' ORDER BY VyplaceniMzdy.PlatnostOd DESC';

                $cursor = $database ->getSqlResult($sql, $params);
                while ($row = $cursor->fetch()) {
                    $stavajiciHodnoty[] = [
                        'JmenoUctu' => $row[0], 'TypUctu' => $row[1], 'CisloUctu' => $row[2], 'Banka' => $row[3],
                        'ZahranicniPlatba' => $row[4], 'IBAN' => $row[5], 'KodMeny_ISO' => $row[6],
                        'SpecifickySymbol' => $row[7], 'KonstantniSymbol' => $row[8] . ($row[9] ? ' (' . $row[9] . ')' : ''), 'VariabilniSymbol' => $row[10],
                        'PlatnostOd' => $database->stringToTimestamp($row[11]), 'PlatnostDo' => $database->stringToTimestamp($row[12])
                    ];
                }
                $cursor ->close();
                break;

            case 'pojistovna':
                $sql .=
                    'SELECT ZdravotniPojistovna.Popis, PojisteniOsobyU_ZP.PlatnostOd, PojisteniOsobyU_ZP.PlatnostDo, PojisteniOsobyU_ZP.CisloPojistence,' .
                    ' Uctarna.Popis, S_TypZamestnanceProZP.Popis, PojisteniOsobyU_ZP.KodZdravotniPojistovny' .
                    ' FROM PojisteniOsobyU_ZP' .
                    '  LEFT JOIN ZdravotniPojistovna ON (ZdravotniPojistovna.Kod = PojisteniOsobyU_ZP.KodZdravotniPojistovny)' .
                    '  LEFT JOIN Uctarna ON (PojisteniOsobyU_ZP.CisloUctarny = Uctarna.Kod)' .
                    '  LEFT JOIN S_TypZamestnanceProZP ON (S_TypZamestnanceProZP.Kod = PojisteniOsobyU_ZP.TypZamestnance)' .
                    ' WHERE PojisteniOsobyU_ZP.RC = ' . $params ->addParameter($rc) .
                    ' ORDER BY PojisteniOsobyU_ZP.PlatnostOd DESC';
                $cursor = $database ->getSqlResult($sql, $params);
                while ($row = $cursor->fetch()){
                    $stavajiciHodnoty[] = [
                        'KodZdravotniPojistovny' => $row[0] . ' (' . $row[6] . ')',
                        'PlatnostOd' => $database->stringToTimestamp($row[1]), 'PlatnostDo' => $database->stringToTimestamp($row[2]),
                        'CisloPojistence' => $row[3], 'CisloUctarny' => $row[4], 'TypZamestnance' => $row[5],
                        'ZP_Kod' => $row[6]
                    ];
                }
                $cursor ->close();
                break;

            case 'velikostpomucek':
//                $sql =
//                    "SELECT COALESCE(TypVelikosti.Popis,'') + COALESCE(': ' + VelikostPPomucky.Velikost,'' )
//                        FROM TypVelikosti
//                        JOIN VelikostPPomucky ON (TypVelikosti.Kod = VelikostPPomucky.TypVelikosti)
//                        LEFT JOIN VelikostPPOsoby ON (VelikostPPomucky.TypVelikosti = VelikostPPOsoby.TypVelikosti AND VelikostPPomucky.Velikost = VelikostPPOsoby.Velikost)
//                        WHERE RCOsoby = " . $params ->addParameter($rc);
//
//                MessageManager::addDebugLog($sql);
//                $cursor = $database->getSqlResult($sql, $params);
//                while ($row = $cursor->fetch()) {
//                    $stavajiciHodnoty[] = $row;
//                }
//                $cursor ->close();

                break;

            default:
                MessageManager::addErrorMessage(\Ron\ronText("neznama_nahlasena_zmena"));
                MessageManager::addDebugLog("Zmena neexistuje, chyba v controlleru nahlasene zmeny.");
                return false;
        }

        return $stavajiciHodnoty;
    }


    /**
     * Zapise do databaze novy prukaz osoby
     * @param Database $database
     * @throws \Exception
     * @throws \Ron\DB\DBException
     */
    public function aktualizacePrukazuOsoby($database)
    {
        require_once 'adsapp/ronportaldbrecord.php';
        $rec = new RonPortalDBRecord($database, 'Prukaz', $this);
        $rec->addStringField('RC', true, 15, $this ->rcOsobyZmeny);
        $rec->addIntField('TypPrukazu', false, $this ->nacteneHodnoty['TypPrukazu']);
        $rec->addStringField('CisloPrukazu', false, 20, $this ->nacteneHodnoty['CisloPrukazu']);
        $rec->addStringField('VydalStat', false, 10,
            trim($this ->nacteneHodnoty['Stat']) != '' ? trim($this ->nacteneHodnoty['Stat']) : null);

        $platnostOd = $this ->nacteneHodnoty['PlatnostOd'] ?: DateUtils::today(); // jiz prevedeno na timestamp

        $rec->addDateField('PlatnostOd', false, $platnostOd);
        $rec->addDateField('PlatnostDo', false, $this ->nacteneHodnoty['PlatnostDo']);

        $rec->addField('Poznamka', 'memo', false, 0, $this ->nacteneHodnoty['vlastnipoznamka']);

        $params = $database->createParameters();
        $rec->setWhere( 'RC = ' . $params->addParameter($this ->rcOsobyZmeny) .
            ' AND TypPrukazu  = ' . $params->addParameter((int)$this ->nacteneHodnoty['TypPrukazu']) .
            ' AND CisloPrukazu  = ' . $params->addParameter($this ->nacteneHodnoty['CisloPrukazu']),
            $params);

        $rec ->updateOrInsert();
    }


    /**
     * Zapise do databaze novy rodinny vztah. Predchozi ukonci.
     * @param Database $database
     * @throws \Exception
     * @throws \Ron\DB\DBException
     */
    public function aktualizaceRodinnehoStavuOsoby($database)
    {
        $database ->beginTransaction();
        try {
            // Nejprve uzavrit predchozi rodinny stav

            require_once 'adsapp/ronportaldbrecord.php';
            $rec = new RonPortalDBRecord($database, 'RodinnyStav', $this);
            $platnostDo = DateUtils::incDay($this ->nacteneHodnoty['PlatnostOd'], -1);
            $rec->logInfoMessage = 'Ukonceni platnosti puvodniho rodinneho stavu';

            $rec->addStringField('RC', true);
            $rec->addDateField('PlatnostOd', true);
            $rec->addIntField('KodRodinnehoStavu', true);
            $rec->addDateField('PlatnostDo', false, $platnostDo);

            $params = $database->createParameters();
            $rec->setWhere(
                'RC = ' . $params->addParameter($this ->rcOsobyZmeny) .
                ' AND PlatnostDo IS NULL',
                $params);

            if ($rec ->loadRecord()) {
                $rec ->updateRecord();
            }

            // Pak vlozit novy
            $rec = new RonPortalDBRecord($database, 'RodinnyStav', $this);
            $rec->logInfoMessage = 'Vlozeni noveho rodinneho stavu';

            $rec->addStringField('RC', true, 20, $this ->rcOsobyZmeny);
            $rec->addDateField('PlatnostOd', true, $this ->nacteneHodnoty['PlatnostOd']);
            $rec->addIntField('KodRodinnehoStavu', true, $this ->nacteneHodnoty['RodinnyStav']);
            $rec->insertRecord();

            $database ->commitTransaction();
        } catch (\Exception $e) {
            $database ->rollbackTransaction();
            throw new $e;
        }
    }


    /**
     * Zapise do databaze nove vzdelani osoby.
     * @param Database $database
     * @throws \Exception
     */
    public function aktualizaceVzdelaniOsoby($database)
    {
        // TypVzdelani:TypVzdelani:Typ_vzdelani:Pr;OborVzdelani:OborVzdelani:Obor_vzdelani:Pr;D:DatumUkonceni:Datum_ukonceni:Po;
        // Skola:Skola:Skola;D:DatumOd:Datum_od;D:DatumDo:Datum_do;E:Zamereni:Zamereni;
        // S_ZpusobUkonceniSkoly:VzdelaniUkonceno:Vzdelani_ukonceno:Po;soubor:soubor:Pripojit_dokument
        if (!$this ->nacteneHodnoty['DatumUkonceni']) {
            throw new \Exception('Neni_zadano_datum_ukonceni');
        }

        if ($this ->nacteneHodnoty['DatumDo']  &&   $this ->nacteneHodnoty['DatumDo'] < $this ->nacteneHodnoty['DatumOd']) {
            throw new \Exception(\Ron\ronText('vzdelani_chyba_platnostDo_mensi_platnostiOd'));
        }

        $rec = new RonPortalDBRecord($database, 'VzdelaniOsoby', $this);
        $rec->logInfoMessage = 'Vlozeni noveho vzdelani osoby';
        $rec->addStringField('RC', false, 15, $this ->rcOsobyZmeny);
        $rec->addIntField('KodVzdelani', false, (int)$this ->nacteneHodnoty['TypVzdelani']);
        $rec->addStringField('OborVzdelani', false, 10, $this ->nacteneHodnoty['OborVzdelani']);
        $rec->addDateField('DatumUkonceni', false, $this ->nacteneHodnoty['DatumUkonceni']);

        $rec->addStringField('Skola', false, 10, $this ->nacteneHodnoty['Skola'] ?: null);
        $rec->addStringField('Zamereni', false, 40, $this ->nacteneHodnoty['Zamereni']);

        $rec->addDateField('DatumOd', false, $this ->nacteneHodnoty['DatumOd'] ?: null);
        $rec->addDateField('DatumDo', false, $this ->nacteneHodnoty['DatumDo'] ?: null);

        $rec->addIntField('VzdelaniUkonceno', false, $this ->nacteneHodnoty['VzdelaniUkonceno']);

        $params = $database->createParameters();
        $rec->setWhere( 'RC = ' . $params->addParameter($this->rcOsobyZmeny) .
            ' AND KodVzdelani  = ' . $params->addParameter((int)$this ->nacteneHodnoty['TypVzdelani']) .
            ' AND OborVzdelani  = ' . $params->addParameter($this ->nacteneHodnoty['OborVzdelani']) .
            ' AND DatumUkonceni  = ' . $params->addParameter($database->dateToParam($this ->nacteneHodnoty['DatumUkonceni'])),
            $params);

        $rec->updateOrInsert();
    }


    /**
     * Zapise do databaze novou zdravotni pojistovnu.
     * @param Database $database
     * @throws \Exception
     */
    public function aktualizacePojistovnyOsoby($database)
    {
        $database ->beginTransaction();
        try {
            $datum = $this ->nacteneHodnoty['PlatnostOd'];

            // ZdravotniPojistovna:KodZdravotniPojistovny:pojistovna:Pr;D:PlatnostOd:Platnost_od:Pr;D:PlatnostDo:Platnost_do;
            // E:CisloPojistence:Cislo_pojistence:Po;Uctarna:CisloUctarny:Cislo_uctarny:Po;S_TypZamestnanceProZP:TypZamestnance:Typ_zamestnance_ZP:Po;
            // soubor:soubor:Pripojit_dokument

            // ukonci platnost predchoziho zaznamu
            $rec = new RonPortalDBRecord($database, 'PojisteniOsobyU_ZP', $this);
            $rec->logInfoMessage = 'Aktualizace zdravotni pojistovny - ukonceni platnosti predchoziho zaznamu';
            $rec->addStringField('RC', true);
            $rec->addStringField('KodZdravotniPojistovny', true);
            $fPlatnostOd = $rec->addDateField('PlatnostOd', true);
            $rec->addDateField('PlatnostDo', false, DateUtils::incDayStart($datum, -1));
            $rec->addStringField('CisloPojistence', true);
            $rec->addStringField('CisloUctarny', true);
            $rec->addIntField('TypZamestnance', true);

            $params = $database->createParameters();
            $rec->setWhere(
                'RC = ' . $params->addParameter($this ->rcOsobyZmeny) .
                ' AND PlatnostDo IS NULL',
                $params);

            if ($rec ->loadRecord()) {
                // existuje predchozi zaznam
                if ($fPlatnostOd ->originalValue >= $datum) {
                    // platnost od musi byt u predchoziho zaznamu mensi nez zadana hodnota
                    throw new \Exception('Nelze_ukoncit_platnost_pojistovny_k_zadanemu datu');
                }

                $rec ->updateRecord();
            }

            // a vlozi novy zaznam
            $rec = new RonPortalDBRecord($database, 'PojisteniOsobyU_ZP', $this);
            $rec->logInfoMessage = 'Aktualizace zdravotni pojistovny - vlozeni noveho zaznamu';
            $rec->addStringField('RC', true, 15, $this ->rcOsobyZmeny);
            $rec->addStringField('KodZdravotniPojistovny', true, 10, $this ->nacteneHodnoty['KodZdravotniPojistovny']);
            $rec->addDateField('PlatnostOd', true, $datum);
            $rec->addDateField('PlatnostDo', true, $this ->nacteneHodnoty['PlatnostDo'] ?: null);
            $rec->addStringField('CisloPojistence', true, 15, $this ->nacteneHodnoty['CisloPojistence']);
            $rec->addStringField('CisloUctarny', true, 10, $this ->nacteneHodnoty['CisloUctarny']);
            $rec->addIntField('TypZamestnance', true, (int)$this ->nacteneHodnoty['TypZamestnance']);

            $rec ->insertRecord();

            $database ->commitTransaction();
        } catch (\Exception $e) {
            $database ->rollbackTransaction();
            throw $e;
        }
    }



    function najdiPracovniPomer($database)
    {
        // najde aktivni pracovni pomer - prednostne HPP
        require_once 'adsapp/ppomer.php';
        $pp = PracovniPomer::najdiPPOsoby($database, $this ->rcOsobyZmeny, true, time());

        if (!$pp) {
            throw new \Exception(\Ron\ronText('Nenalezen_platny_pracovni_pomer_pro_zadanou_osobu'));
        }

        return $pp;
    }


    /**
     * @param Database $database
     * @throws \Exception
     */
    public function aktualizacePenzijnihoPripojisteniOsoby($database)
    {
        // PenzijniFond:PenzijniFond:Penzijni_fond:Pr;D:PlatnostOd:Platnost_od:Pr;D:PlatnostDo:Platnost_do;E:CisloSmlouvy:Cislo_smlouvy;
        // E:PrispevekZamestnavatele:prispevek_zamestnavatele;BF:SerioveCisloUctu1:Bankovni_ucet;E:PrispevekZamestnance:prispevek_zamestnance;
        // BZ:SerioveCisloUctu2:Bankovni_ucet;soubor:soubor:Pripojit_dokument

        $pp = $this ->najdiPracovniPomer($database);

        $rec = new RonPortalDBRecord($database, 'SmlouvaPenzijnihoPrip', $this);
        $rec->logInfoMessage = 'Vlozeni noveho penzijniho pripojisteni osoby';

        $rec->addStringField('RC', true, 15, $pp->rc);
        $rec->addStringField('OsobniCislo', true, 15, $pp->osobniCislo);
        $rec->addDateField('DatumNastupu', true, $pp->datumNastupu);

        $rec->addDateField('PlatnostOd', true, $this ->nacteneHodnoty['PlatnostOd']);
        $rec->addStringField('PenzijniFond', true, 10, $this ->nacteneHodnoty['PenzijniFond']);

        $rec->addDateField('PlatnostDo', false, $this ->nacteneHodnoty['PlatnostDo'] ?: null);
        $rec->addStringField('CisloSmlouvy', false, 15, trim($this ->nacteneHodnoty['CisloSmlouvy']));

        $rec->addField('PrispevekZamestnavatele', 'float', false, 0, (float)$this ->nacteneHodnoty['PrispevekZamestnavatele'] ?: null);
        $rec->addIntField('SerioveCisloUctu1', false, (int)$this ->nacteneHodnoty['SerioveCisloUctu1'] ?: null);
        $rec->addField('PrispevekZamestnance', 'float', false, 0, (float)$this ->nacteneHodnoty['PrispevekZamestnance'] ?: null);
        $rec->addIntField('SerioveCisloUctu2', false, (int)$this ->nacteneHodnoty['SerioveCisloUctu2'] ?: null);

        $params = $database->createParameters();
        $rec->setWhere( 'RC = ' . $params->addParameter($pp->rc) .
            ' AND OsobniCislo = ' . $params->addParameter($pp->osobniCislo) .
            ' AND DatumNastupu = ' . $params->addParameter($database->dateToParam($pp->datumNastupu)) .
            ' AND PlatnostOd = ' . $params->addParameter($database->dateToParam($this ->nacteneHodnoty['PlatnostOd'])) .
            ' AND PenzijniFond = ' . $params->addParameter($this ->nacteneHodnoty['PenzijniFond']),
            $params);

        $rec ->updateOrInsert();
    }


    /**
     * Zapise do databaze nove zivotni pojisteni.
     * @param Database $database
     * @throws \Exception
     */
    public function aktualizaceZivotnihoPojisteniOsoby($database)
    {
        // zivotnipojisteni
        // Pojistovna:Pojistovna:pojistovna:Pr;D:PlatnostOd:Platnost_od:Pr;D:PlatnostDo:Platnost_do;E:CisloSmlouvy:Cislo_smlouvy;
        // E:PrispevekZamestnavatele:prispevek_zamestnavatele;BF:SerioveCisloUctu1:Bankovni_ucet;E:PrispevekZamestnance:prispevek_zamestnance;
        // BZ:SerioveCisloUctu2:Bankovni_ucet;soubor:soubor:Pripojit_dokument

        $pp = $this ->najdiPracovniPomer($database);

        $rec = new RonPortalDBRecord($database, 'SmlouvaZivotniPojisteni', $this);
        $rec->logInfoMessage = 'Vlozeni noveho zivotniho pojisteni osoby';

        $rec->addStringField('RC', true, 15, $pp->rc);
        $rec->addStringField('OsobniCislo', true, 15, $pp->osobniCislo);
        $rec->addDateField('DatumNastupu', true, $pp->datumNastupu);

        $rec->addDateField('PlatnostOd', true, $this ->nacteneHodnoty['PlatnostOd']);
        $rec->addStringField('Pojistovna', true, 10, $this ->nacteneHodnoty['Pojistovna']);

        $rec->addDateField('PlatnostDo', false, $this ->nacteneHodnoty['PlatnostDo'] ?: null);
        $rec->addStringField('CisloSmlouvy', false, 15, trim($this ->nacteneHodnoty['CisloSmlouvy']));

        $rec->addField('PrispevekZamestnavatele', 'float', false, 0, (float)$this ->nacteneHodnoty['PrispevekZamestnavatele'] ?: null);
        $rec->addIntField('SerioveCisloUctu1', false, (int)$this ->nacteneHodnoty['SerioveCisloUctu1'] ?: null);
        $rec->addField('PrispevekZamestnance', 'float', false, 0, (float)$this ->nacteneHodnoty['PrispevekZamestnance'] ?: null);
        $rec->addIntField('SerioveCisloUctu2', false, (int)$this ->nacteneHodnoty['SerioveCisloUctu2'] ?: null);

        $params = $database->createParameters();
        $rec->setWhere( 'RC = ' . $params->addParameter($pp->rc) .
            ' AND OsobniCislo = ' . $params->addParameter($pp->osobniCislo) .
            ' AND DatumNastupu = ' . $params->addParameter($database->dateToParam($pp->datumNastupu)) .
            ' AND PlatnostOd = ' . $params->addParameter($database->dateToParam($this ->nacteneHodnoty['PlatnostOd'])) .
            ' AND Pojistovna = ' . $params->addParameter($this ->nacteneHodnoty['Pojistovna']),
            $params);

        $rec ->updateOrInsert();
    }



    /**
     * Zapise do databaze novou trvalou/prechodnou adresu.
     * @param Database $database
     * @throws \Exception
     */
    public function aktualizaceAdresyOsoby($database)
    {
        // trvale/prechodne
        // D:PlatnostOd:Platnost_od:Po;E:Ulice:Ulice;Mesto:Mesto:Mesto_cast_obce;Obec:Obec:Obec;E:PSC:psc;Stat:Stat:Stat;
        // DopravaDoZamestnani:DopravaDoZamestnani:Zpusob_dopravy:Po;E:VzdalenostDoZamestnani:Vzdalenost_do_zamestnani;
        // D:PlatnostDo:Platnost_do;soubor:soubor:Pripojit_dokument
        $database ->beginTransaction();
        try {
            // ukonci platnost predchozi adresy
            $rec = new RonPortalDBRecord($database, 'AdresaOsoby', $this);
            $rec->logDescription = 'Ukonceni platnosti predchozi adresy';
            $rec->addStringField('RC', true, 15, $this ->rcOsobyZmeny);
            $rec->addIntField('TrvaleBydliste', true);
            $fPlatnostOd = $rec->addDateField('PlatnostOd', true);
            $rec->addDateField('PlatnostDo', false, DateUtils::incDayStart($this ->nacteneHodnoty['PlatnostOd'], -1));
            $rec->addStringField('Ulice', true);
            $rec->addStringField('Mesto', true);
            $rec->addStringField('Obec', true);
            $rec->addStringField('PSC', true);
            $rec->addStringField('Stat', true);
            $rec->addStringField('Telefon1', true);
            $rec->addStringField('Telefon2', true);
            $rec->addStringField('Mobil', true);
            $rec->addStringField('E_mail', true);

            $params = $database ->createParameters();
            $rec ->setWhere(
                'RC = ' . $params ->addParameter($this ->rcOsobyZmeny) .
                ' AND TrvaleBydliste = ' . $params ->addParameter($this ->typZmeny == 'trvale' ? 1 : 0) .
                ' AND PlatnostDo IS NULL',
                $params
            );

            if ($rec ->loadRecord()) {
                // zkontroluje, jestli neni platnost noveho zaznamu starsi nez platnost od existujiciho zaznamu
                if ($fPlatnostOd ->originalValue > $this ->nacteneHodnoty['PlatnostOd']) {
                    throw new \Exception(\Ron\ronText('platnost_od_mala'));
                }
                $rec ->updateRecord();
            }

            // ... a vlozi novy zaznam
            $rec = new RonPortalDBRecord($database, 'AdresaOsoby', $this);
            $rec->logDescription = 'Zapsani nove adresy';
            $rec->addStringField('RC', true, 15, $this ->rcOsobyZmeny);
            $rec->addIntField('TrvaleBydliste', true, $this ->typZmeny == 'trvale' ? 1 : 0);
            $rec->addDateField('PlatnostOd', true, $this ->nacteneHodnoty['PlatnostOd']);
            $rec->addDateField('PlatnostDo', true, $this ->nacteneHodnoty['PlatnostDo'] ?: null);
            $rec->addStringField('Ulice', true, 40, $this ->nacteneHodnoty['Ulice']);
            $rec->addStringField('Mesto', true, 40, $this ->nacteneHodnoty['Mesto']);
            $rec->addStringField('Obec', true, 10, $this ->nacteneHodnoty['Obec']);
            $rec->addStringField('PSC', true, 10, $this ->nacteneHodnoty['PSC']);
            $rec->addStringField('Stat', true, 10, $this ->nacteneHodnoty['Stat']);
            $rec->addStringField('Telefon1', true, 20, $this ->nacteneHodnoty['Telefon1']);
            $rec->addStringField('Telefon2', true, 20, $this ->nacteneHodnoty['Telefon2']);
            $rec->addStringField('Mobil', true, 20, $this ->nacteneHodnoty['Mobil']);
            $rec->addStringField('E_mail', true, 60, $this ->nacteneHodnoty['E_Mail']);
            $rec->addIntField('ZpusobDopravy', true, $this ->nacteneHodnoty['DopravaDoZamestnani']);
            $rec->addField('VzdalenostDoZamestnani', 'float', true, 0, (float)$this ->nacteneHodnoty['VzdalenostDoZamestnani']);

            $rec ->insertRecord();

            $database ->commitTransaction();
        } catch (\Exception $e) {
            $database ->rollbackTransaction();
            throw $e;
        }
    }


    /**
     * Pokusi se najit ID rodinneho prislusnika dle RC
     * @param Database $database
     * @param string $rc
     * @return mixed
     * @throws \Ron\DB\DBException
     */
    private function najdiIDRodinnehoPrislusnikaDleRC($database, $rc)
    {
        $params = $database->createParameters();
        $sql =
            'SELECT RC_RodinnehoPrislusnika FROM RodinnyPrislusnik' .
            ' WHERE RodneCisloRP = ' . $params->addParameter($rc);

        $cursor = $database->getSqlResult($sql, $params);
        $row = $cursor ->fetch();
        $cursor ->close();

        return $row ? $row[0] : null;
    }


    /**
     * Zapise do databaze rodinneho prislusnika (update nebo insert noveho.
     * @param Database $database
     * @throws \Exception
     */
    public function aktualizaceRodinnychPrislusnikuOsoby($database)
    {
        // rodinnyprislusnik/novyclenrodiny
        // E:Prijmeni:Prijmeni:Po;E:Jmeno:Jmeno:Po;E:RC_RodinnehoPrislusnika:RC_rodinneho_prislusnika:Pr;E:Titul:Titul;D:DatumNarozeni:Datum_narozeni:Po;
        // S_RodinnyVztah:RodinnyVztah:rodinny_vztah;D:PartnerDatumOd:Registrace_od;D:PartnerDatumDo:Registrace_do;
        // S_ZdravotniStav:ZdravotniStav:Zdravotni_stav:Po;C:DrzitelPrukazuZTTP:Drzitel_prukazu_ZTP;D:DatumPriznaniZTTP:Datum_priznani_ZTP;
        // C:VyzivovanaOsoba:vyzivovana_osoba;C:StejnaAdresa:Stejna_adresa_jako_zamestnanec;C:KontaktniOsoba:kontaktni_osoba;
        // E:Telefon:Telefon;E:Email:E_mail;ID:ID:ID;soubor:soubor:Pripojit_dokument

        // pri editaci musi byt zadano id (RC_RodinnehoPrislusnika) existujici osoby
        if ($this ->typZmeny == 'rodinnyprislusnik') {
            if (!$this ->nacteneHodnoty['ID']) {
                throw new \Exception('Chyba pri editaci rodinneho prislusnika - neni zadano ID osoby');
            }
        }

        $database ->beginTransaction();
        try {
            $novyZaznam = false;
            if ($this ->typZmeny == 'novyclenrodiny') {
                // zkusi najit existujiciho clena rodiny (muze byt prirazen jinemu zamestnanci)
                $idRC = $this->najdiIDRodinnehoPrislusnikaDleRC($database, $this->nacteneHodnoty['RC_RodinnehoPrislusnika']);

                if (!$idRC) {
                    // vygeneruje nove ID
                    require_once 'ron/sqlutils.php';
                    $idRC = SQLUtils::getNextRecordSerialCode($database, 'RodinnyPrislusnik', 'RC_RodinnehoPrislusnika', "ID######", 1, 999999);
                    $novyZaznam = true;
                }
            } else {
                // pri update uz musi byt zadane
                $idRC = $this ->nacteneHodnoty['ID'];
            }

            // insert/update editovane osoby v tabulce RodinnyPrislusnik
            $rec = new RonPortalDBRecord($database, 'RodinnyPrislusnik', $this);
            $rec ->logInfoMessage = $novyZaznam
                ? 'Prirazeni noveho rodinneho prislusnika'
                : 'Aktualizace rodinneho prislusnika';
            $rec->addStringField('RC_RodinnehoPrislusnika', true, 15, $idRC);  // toto je ID pole, nikoliv skutecne RC
            $rec->addStringField('Prijmeni', false, 30, trim($this ->nacteneHodnoty['Prijmeni']));
            $rec->addStringField('Jmeno', false, 30, trim($this ->nacteneHodnoty['Jmeno']));
            $rec->addStringField('RodneCisloRP', false, 15, trim($this->nacteneHodnoty['RC_RodinnehoPrislusnika']) ?: null);
            $rec->addStringField('Titul', false, 20, trim($this ->nacteneHodnoty['Titul']) ?: null);
            $rec->addIntField('ZdravotniStav', false, (int)$this ->nacteneHodnoty['ZdravotniStav']);
            $rec->addIntField('DrzitelPrukazuZTTP', false, (int)$this ->nacteneHodnoty['DrzitelPrukazuZTTP'] ? 1 : 0);
            //datum ZTP/P pouze pokud je Drzitel ZTP/P roven 1
            $rec->addDateField('DatumPriznaniZTTP', false,
                ($this ->nacteneHodnoty['DrzitelPrukazuZTTP'] && $this ->nacteneHodnoty['DatumPriznaniZTTP'])
                    ? $this ->nacteneHodnoty['DatumPriznaniZTTP']
                    : null);
            $rec->addDateField('DatumNarozeni', false, $this ->nacteneHodnoty['DatumNarozeni']);
            $rec->addIntField('KontaktniOsoba', false, (int)$this ->nacteneHodnoty['KontaktniOsoba'] ? 1 : 0);
            $rec->addStringField('Telefon', false, 60, trim($this ->nacteneHodnoty['Telefon']) ?: null);
            $rec->addStringField('Email', false, 60, trim($this ->nacteneHodnoty['']) ?: null);

            if ($novyZaznam) {
                $rec ->insertRecord();
            } else {
                $params = $database->createParameters();
                $rec->setWhere('RC_RodinnehoPrislusnika  = ' . $params->addParameter($idRC), $params);
                if (!$rec ->loadRecord()) {
                    throw new \Exception('Rodinny prislusnik se zadanym ID nebyl nalezen!');
                }
                $rec ->updateRecord();
            }

            // zapsat nebo aktualizovat noveho clena rodiny
            $rec2 = new RonPortalDBRecord($database, 'ClenoveRodiny', $this);
            $rec2->logInfoMessage = 'Vlozeni noveho clena rodiny';

            $rec2->addStringField('RC', true, 15, $this ->rcOsobyZmeny);
            $rec2->addStringField('RC_RodinnehoPrislusnika', true, 15, $idRC);

            $rec2->addIntField('RodinnyVztah', false, (int)$this->nacteneHodnoty['RodinnyVztah']);
            $rec2->addDateField('PartnerDatumOd', false, $this ->nacteneHodnoty['PartnerDatumOd']);
            $rec2->addDateField('PartnerDatumDo', false, $this ->nacteneHodnoty['PartnerDatumDo']);
            $rec2->addIntField('StejnaAdresa', false, (int)$this ->nacteneHodnoty['StejnaAdresa'] ? 1 : 0);
            $rec2->addIntField('VyzivovanaOsoba', false, (int)$this ->nacteneHodnoty['VyzivovanaOsoba'] ? 1 : 0);

            $params = $database->createParameters();
            $rec2->setWhere(
                'RC = ' . $params->addParameter($this ->rcOsobyZmeny) .
                ' AND RC_RodinnehoPrislusnika  = ' . $params->addParameter($idRC),
                $params);

            $rec2 ->updateOrInsert();

            $database ->commitTransaction();
        } catch (\Exception $e) {
            $database ->rollbackTransaction();
            throw $e;
        }
    }



    /**
     * @param Database $database
     * @throws \Exception
     */
    public function aktualizaceOsobnichUdajuOsoby($database)
    {
        // osobni
        // E:Titul:Titul_pred;E:TitulZa:Titul_za;E:Jmeno:Jmeno;E:Prijmeni:Prijmeni:Po;E:Email:E_mail;E:Telefon:Telefon;E:Mobil:Mobil;soubor:soubor:Pripojit_dokument
        $database ->beginTransaction();
        try {
//            // Nacteni stavajiciho prijmeni - pri zmene dojde k ulozeni do tabulky "PredchoziPrijmeni"
//            $params = $this->database->createParameters();
//            $sql = "SELECT Prijmeni From Osoba WHERE RC = " . $params->addParameter($pracovniPomer->rc);
//            $puvodniPrijmeni = DBUtils::getSqlValue($this->database, $sql, $params);


            $rec = new RonPortalDBRecord($database, 'Osoba', $this);
            $rec->logInfoMessage = 'Uprava osobnich udaju';
            $rec->addStringField('RC', true);

            // jmeno a prijmeni - pokud neni zadano, tak jen readonly (nelze nastavit na prazdne)
            $novePrijmeni = trim($this ->nacteneHodnoty['Prijmeni']);
            $rec->addStringField('Jmeno', trim($this ->nacteneHodnoty['Jmeno']) == '', 30, trim($this ->nacteneHodnoty['Jmeno']));
            $fPrijmeni =$rec->addStringField('Prijmeni', $novePrijmeni == '', 30, $novePrijmeni);

            $rec->addStringField('Titul', false, 20, trim($this ->nacteneHodnoty['Titul']));
            $rec->addStringField('TitulZa', false, 20, trim($this ->nacteneHodnoty['TitulZa']));

            $rec->addStringField('eMail', false, 60, trim($this ->nacteneHodnoty['Email']));
            $rec->addStringField('Telefon', false, 60, trim($this ->nacteneHodnoty['Telefon']));
            $rec->addStringField('Mobil', false, 60, trim($this ->nacteneHodnoty['Mobil']));

            $f = $rec ->addStringField('Update_UserName', false, 25, RonPortalUtils::getLogUserName());
            $f ->setUpdateLog(true);  // upravi se jen v pripade zmeny jineho pole

            $f = $rec ->addTimestampField('Update_Timestamp', false, time());
            $f ->setUpdateLog(true);  // upravi se jen v pripade zmeny jineho pole

            $params = $database->createParameters();
            $rec->setWhere('RC = ' . $params->addParameter($this ->rcOsobyZmeny), $params);

            if (!$rec ->loadRecord()) {
                throw new \Exception('Editovana osoba nebyla nalezena!');
            }

            // puvodni prijmeni si zapamatuje
            $predchoziPrijmeni = $fPrijmeni ->originalValue;

            $rec ->updateRecord();

            if ($novePrijmeni != ''  &&  $novePrijmeni != $predchoziPrijmeni) {
                $date = DateUtils::today();

                // zmena prijmeni - zaznamena predchozi
                $rec2 = new RonPortalDBRecord($database, 'PredchoziPrijmeni', $this);
                $rec2 ->logInfoMessage = 'Uprava osobnich udaju - zmena prijmeni';
                $rec2 ->addStringField('RC', true, 15, $this ->rcOsobyZmeny);
                $rec2 ->addDateField('PlatnostDo', true, $date);
                $rec2 ->addStringField('Prijmeni', true, 30, $predchoziPrijmeni);

                $params2 = $database ->createParameters();
                $rec2 ->setWhere(
                    'RC = ' . $params2 ->addParameter($this ->rcOsobyZmeny) .
                    ' AND PlatnostDo = ' . $params2 ->addParameter($database ->dateToParam($date)),
                    $params2);

                if ($rec2 ->loadRecord()) {
                    // nedela nic - posledni zadane prijmeni melo platnost az do dnesniho dne
                    // pravdepodobne se jedna o opravu
                } else {
                    $rec2 ->insertRecord();
                }
            }

            $database ->commitTransaction();
        } catch (\Exception  $e) {
            $database ->rollbackTransaction();
            throw $e;
        }
    }


    /**
     * @param Database $database
     * @throws \Exception
     */
    public function aktualizaceUctuOsoby($database)
    {
        // ucetosoby
        // E:JmenoUctu:Jmeno_uctu;S_TypBankovnihoUctu:TypUctu:Typ_uctu;E:CisloUctu:Cislo_uctu;Banka:Banka:Banka;
        // C:ZahranicniPlatba:Zahranicni_platba;IBAN:IBAN:IBAN;Mena:KodMeny_ISO:Kod_meny;E:SpecifickySymbol:specificky_symbol;
        // KonstantniSymbol:KonstantniSymbol:konstantni_symbol;E:VariabilniSymbol:Variabilni_symbol;
        // D:PlatnostOd:Platnost_od;D:PlatnostDo:Platnost_do;soubor:soubor:Pripojit_dokument

        // E:CisloUctu:Cislo_uctu;Banka:Banka:Banka;E:VariabilniSymbol:Variabilni_symbol;D:PlatnostOd:Platnost_od;soubor:soubor:Pripojit_dokument

        // najde platny pracovni pomer osoby - prednostne HPP
        $pp = $this ->najdiPracovniPomer($database);

        $platnostOd = DateUtils::firstDayOfMonth($this ->nacteneHodnoty['PlatnostOd']);
        $newPlatnostDo = DateUtils::incDayStart($platnostOd, -1);

        // TODO: doplnit kontrolu, ze je datum az od pristiho mesice? Nebo staci ve formulari?
//        if ($platnostOd < time()) {
//            throw new \Exception(\Ron\ronText('ucet_upozorneni'));
//        }

        $database ->beginTransaction();
        try {
            // vytvori a naplni novy bankovni ucet
            $recUcet = new RonPortalDBRecord($database, 'BankovniUcet', $this);
            $fSerioveCislo = $recUcet->addIntField('SerioveCislo', true);
            $recUcet->addStringField('JmenoUctu', false, 40, sprintf(\Ron\ronText('nazev_uctu_vyplaty'), $pp ->prijmeni . ' ' . $pp ->jmeno . ($pp ->titul ? ', ' . $pp ->titul : '')));
            $recUcet->addStringField('CisloUctu', false, 20, $this ->nacteneHodnoty['CisloUctu']);
            $recUcet->addStringField('KodBanky', false, 10, $this ->nacteneHodnoty['Banka']);
            $recUcet->addIntField('TypUctu', false, 1); //ucet zamestnance
            $recUcet->addStringField('RC', false, 15, $pp->rc);

            $recUcet->addStringField('SpecifickySymbol', true, 20); // pouzije se hodnota z predchoziho uctu
            $recUcet->addStringField('KonstantniSymbol', true, 10); //  -//-
            $recUcet->addStringField('VariabilniSymbol', false, 20, $this ->nacteneHodnoty['VariabilniSymbol']);

            $recUcet->addStringField('Insert_UserName', false, 25, RonPortalUtils::getLogUserName());
            $recUcet->addTimestampField('Insert_Timestamp', false, time());

            // nacte posledni zaznam prirazeni bankovniho uctu (VyplaceniMzdy)
            $params = $database ->createParameters();
            $sql =
                'SELECT MAX(PlatnostOd) FROM VyplaceniMzdy' .
                ' WHERE RC = ' . $params ->addParameter($pp ->rc) .
                ' AND OsobniCislo = ' . $params ->addParameter($pp ->osobniCislo) .
                ' AND DatumNastupu = ' . $params ->addParameter($database ->dateToParam($pp ->datumNastupu));
            $cursor = $database ->getSqlResult($sql, $params);
            $row = $cursor ->fetch();
            $cursor ->close();

            if ($row  &&  isset($row[0])) {
                $oldPlatnostOd = $database ->stringToTimestamp($row[0]);
                if ($oldPlatnostOd >= $platnostOd) {
                    // Uz je zadan nejaky budouci ucet => pripadna aktualizace by byla slozita. Napriklad by se musela aktualizovat platnostDo dalsiho predchazejiciho uctu
                    throw new \Exception(\Ron\ronText('Platnost_od_uctu_musi_byt_vetsi_nez_platnost_predchoziho_uctu'));
                }

                // nasel predchozi prirazeny ucet - zkontroluje jeho platnost a ukonci jej
                $recVyplaceni = new RonPortalDBRecord($database, 'VyplaceniMzdy', $this);
                $recVyplaceni->logInfoMessage = 'Ukonceni platnosti stareho uctu zamestnance: ' . $pp ->jmeno . ' ' . $pp ->prijmeni;
                $recVyplaceni->addStringField('RC', true);
                $recVyplaceni->addStringField('OsobniCislo', true);
                $recVyplaceni->addDateField('DatumNastupu', true);
                $fUcetVyplaceni = $recVyplaceni->addIntField('SerioveCisloUctuVyplaty', true);
                $recVyplaceni->addDateField('PlatnostOd', true);
                $fPlatnostDo = $recVyplaceni->addDateField('PlatnostDo', false, $newPlatnostDo);

                $params = $database->createParameters();
                $recVyplaceni->setWhere(
                    'RC = ' . $params->addParameter($pp->rc) .
                    ' AND OsobniCislo = ' . $params->addParameter($pp->osobniCislo) .
                    ' AND DatumNastupu = ' . $params->addParameter($database->dateToParam($pp->datumNastupu)) .
                    ' AND PlatnostOd = ' . $params->addParameter($database->dateToParam($oldPlatnostOd)),
                    $params
                );

                if (!$recVyplaceni->loadRecord()) {
                    // nenasel zaznam - nemelo by nastat
                    throw new \Exception('Chyba pri aktualizaci predchoziho zaznamu VyplaceniMzdy - zaznam nebyl nalezen!');
                }

                if (!$fPlatnostDo ->originalValue  ||  $fPlatnostDo ->originalValue > $newPlatnostDo) {
                    // predchozi prirazeni uctu ma platnostDo vyssi nez pozadovana hodnota, nebo ho nema zadane => aktualizuje
                    $recVyplaceni ->updateRecord();
                }

                if (isset($fUcetVyplaceni ->originalValue)) {
                    // posledni zaznam vyplaceni mzdy ma prirazen ucet => nacte ho
                    // a pouzije z nej nektere hodnoty (konstantni symbol, specificky symbol)

                    $params = $database->createParameters();
                    $recUcet->setWhere(
                        'SerioveCislo = ' . $params->addParameter((int)$fUcetVyplaceni->originalValue),
                        $params
                    );

                    if (!$recUcet->loadRecord()) {
                        // nemelo by nastat
                        // throw new \Exception('Chyba pri nacitani predchoziho bankovniho uctu - zaznam nebyl nalezen!');
                        // da se ignorovat, stejne se vklada novy
                    }
                }
            }

            // vlozi novy ucet do databaze
            $fSerioveCislo ->setNewValue(SQLUtils::newSerialNumber($database, 'BankovniUcet', 'SerioveCislo'));
            $recUcet ->insertRecord();

            // a nastavi vyplaceni mzdy na novy ucet
            $recVyplaceni = new RonPortalDBRecord($database, 'VyplaceniMzdy', $this);
            $recVyplaceni->logInfoMessage = 'Prirazeni noveho uctu zamestnanci: ' . $pp ->jmeno . ' ' . $pp ->prijmeni;
            $recVyplaceni->addStringField('RC', true, 15, $pp ->rc);
            $recVyplaceni->addStringField('OsobniCislo', true, 15, $pp ->osobniCislo);
            $recVyplaceni->addDateField('DatumNastupu', true, $pp ->datumNastupu);
            $recVyplaceni->addDateField('PlatnostOd', true, $platnostOd);
            $recVyplaceni->addIntField('ZpusobPlatbyVyplaty', true, 1);
            $recVyplaceni->addIntField('SerioveCisloUctuVyplaty', true, $fSerioveCislo ->value);
            $recVyplaceni->insertRecord();

            $database ->commitTransaction();
        } catch (\Exception $e) {
            $database ->rollbackTransaction();
            throw $e;
        }
    }



    /**
     * @param $database
     * @throws \Exception
     */
    public function zapisZmeny($database)
    {
        // aktualizuje udaje v databazi
        switch ($this ->typZmeny) {
            case 'prukaz' :
                $this->aktualizacePrukazuOsoby($database);
                break;

            case 'rodinnystav' :
                $this->aktualizaceRodinnehoStavuOsoby($database);
                break;

            case 'vzdelani' :
                $this ->aktualizaceVzdelaniOsoby($database);
                break;

            case 'pojistovna' :
                $this ->aktualizacePojistovnyOsoby($database);
                break;

            case 'penzijnipripojisteni' :
                $this ->aktualizacePenzijnihoPripojisteniOsoby($database);
                break;

            case 'zivotnipojisteni' :
                $this ->aktualizaceZivotnihoPojisteniOsoby($database);
                break;

            case 'trvale' :
            case 'prechodne' :
                $this ->aktualizaceAdresyOsoby($database);
                break;

            case 'rodinnyprislusnik' :
            case 'novyclenrodiny' :
                $this ->aktualizaceRodinnychPrislusnikuOsoby($database);
                break;

            case 'osobni' :
                $this ->aktualizaceOsobnichUdajuOsoby($database);
                break;

            case 'ucetosoby' :
                $this ->aktualizaceUctuOsoby($database);
                break;

            default :
                throw new \Exception("ZAPIS TETO ZMENY NENI IMPLEMENTOVAN!");
        }
    }
}

