<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 15.08.2019
 */

namespace Ron\RonPortal\Notifikace;


use Ron\DB\Database;
use Ron\MVC\BaseViewObject;
use Ron\MVC\InternalRedirect;
use Ron\MVC\Model;
use Ron\MVC\JsonOutputObject;
use Ron\MVC\OutputObject;
use Ron\MVC\JsonController;
use Ron\MVC\Redirect;
use Ron\MVC\ViewObject;
use Ron\RonPortal\Prava;
use Ron\RonPortal\PravaNaOsoby;
use Ron\RonPortal\RonPortalUtils;
use Ron\TextManager;


/**
 * Class Notifikace
 * @package Ron\RonPortal\Notifikace
 */
class Notifikace extends JsonController
{

    /** @var PravaNaOsoby $pravo_notifikace */
    public $pravo_notifikace;

    /** @var Database $database */
    public $database;


    /**
     * Notifikace constructor.
     * @param Database $database
     */
    public function __construct($database)
    {
        $this->database = $database;
        $this->pravo_notifikace = Prava::vratPrava('notifikace');


    }


    /**
     * @param $record
     * @return BaseViewObject
     * @throws \Exception
     */
    public function detailNotifikace($record)
    {
        //TODO implementovat view


        require_once 'person/notifikace.php';
        $hodnotaNotifikace = NotifikaceObjekt::nactiHodnotyNotifikace($this->database, $record);
        Model::addData('hodnotaNotifikace', $hodnotaNotifikace);

        //TODO implementovat tridu nacitajici data notifikace

        return new BaseViewObject('person/view_notifikace.php');
    }


    /**
     * @param $record
     */
    public function notifikacePrectenaOdkazem($record)
    {

        //TODO implementace zápisu přečtení přes odkaz v browseru

        //TODO nejdříve dojde z zápisu přečtení a následně pak ke zobrazení detailu v příslušné agendě

        //TODO zápis přečtení

        //TODO redirect na agendu

    }



    public function mojeNotifikace($output)
    {
        //TODO doplnit dashboard

    }


    /**
     * @param string $action
     * @param JsonOutputObject $output
     */
    function handleJsonAction($action, $output)
    {
        switch ($_GET['action']){
            case 'mojenotifikace':
                $this->mojeNotifikace($output);
                break;
        }
    }


    /**
     * @param string $action
     * @return InternalRedirect|OutputObject|Redirect|ViewObject|string
     * @throws \Exception
     */
    public function handleAction($action)
    {
        //TODO doplnit právo
        if (true){
            RonPortalUtils::neniPravoException();
        }


        TextManager::getInstance() ->loadStrings('notifikace.ini');


        //TODO doplnit zobrazení detailu (view)



        if ($_GET['action'] == 'mojenotifikace'){
            //json action
            return parent::handleAction($action);
        }


        switch ($_GET['action']){

            case 'detailnotifikace':
                return $this->detailNotifikace($_GET['record']);


            case 'notifikaceprectena':
                return $this->notifikacePrectenaOdkazem($_GET['record']);


            default:
                require_once 'person/b_notifikace.php';
                $b = new NotifikaceBrowser($this->database);
                $b->load();
                return $b;
        }
    }
}

