<?php
/** Roman.Szablatura RON Software 18.6.2018 */

namespace Ron\RonPortal;


use Ron\DB\Database;
use Ron\MessageManager;


/**
 * Class PlanovaneSkoleniObjekt
 * @package Ron\RonPortal
 */
class PlanovaneSkoleniObjekt
{

    public $cisloSkoleni;
    public $popis;
    public $druhSkoleni;
    public $datumPocatkuSkoleni;
    public $casPocatkuSkoleni;
    public $datumUkonceniSkoleni;
    public $casUkonceniSkoleni;
    public $mistoSkoleni;
    public $delkaSkoleniDnu;
    public $delkaSkoleniHodin;
    public $pocetOsob;
    public $konkretniUcastnici;
    //Skolici firma
    public $firma;
    public $skolitel;
    public $cenaZaSkoleni;
    public $zakladDPH1;
    public $zakladDPH2;
    public $zakladDPH3;
    public $dph1;
    public $dph2;
    public $dph3;
    public $dan1;
    public $dan2;
    public $dan3;
    public $uzivatelska1;
    public $uzivatelska2;
    public $uzivatelska3;
    public $uzivatelska4;
    public $uzivatelska5;
    public $uzivatelska6;
    public $uzivatelska7;
    public $uzivatelska8;
    public $uzivatelska9;
    public $uzivatelska10;
    public $stav;
    public $poznamka;
    public $stavPopis;



    /**
     * @param Database $database
     * @param $cisloSkoleni
     * @return PlanovaneSkoleniObjekt
     * @throws \Exception
     */
    public static function nactiPlanovaneSkoleni($database, $cisloSkoleni)
    {
        $params = $database->createParameters();

        $sql =
            "SELECT 
                PS.CisloSkoleni, PS.Popis, PS.DruhSkoleni, PS.DatumPocatkuSkoleni, PS.CasPocatkuSkoleni, 
                
                PS.DatumUkonceniSkoleni, PS.CasUkonceniSkoleni, PS.MistoSkoleni, PS.DelkaSkoleniDnu, PS.DelkaSkoleniHodin, 
                
                PS.PocetOsob, PS.KonkretniUcastnici, PS.SkoliciFirma, PS.Skolitel, PS.CenaZaSkoleni, 
                
                PS.ZakladDPH1, PS.ZakladDPH2, PS.ZakladDPH3, PS.DPH1, PS.DPH2, PS.DPH3, PS.Dan1, PS.Dan2, PS.Dan3, 
                
                PS.uzivatelska1, PS.uzivatelska2, PS.uzivatelska3, PS.uzivatelska4, PS.uzivatelska5, PS.uzivatelska6, 
                
                PS.uzivatelska7, PS.uzivatelska8, PS.uzivatelska9, PS.uzivatelska10, PS.Stav, " . $database->castWideMemo('PS.Poznamka') . ", 
                
                S_StavPlanovanehoSkoleni.Popis AS StavPopis
                
                FROM PlanovaneSkoleni AS PS INNER JOIN S_StavPlanovanehoSkoleni ON PS.Stav = S_StavPlanovanehoSkoleni.Kod " .

            "WHERE PS.CisloSkoleni = " . $params->addParameter($cisloSkoleni);

        MessageManager::addDebugLog($sql);

        $cursor = $database->getSqlResult($sql, $params);

        if (!$row = $cursor->fetch()){
            throw new \Exception(\Ron\ronText('planovane_skoleni_neexistuje'));
        }

        $planovaneSkoleni = new PlanovaneSkoleniObjekt();
        $planovaneSkoleni->cisloSkoleni = $cisloSkoleni;
        $planovaneSkoleni->nactiPlanovaneSkoleniZRadku($database, $row);
        $cursor->close();
        return $planovaneSkoleni;
    }

    /**
     * @param Database $database
     * @param $row
     */
    public function nactiPlanovaneSkoleniZRadku($database, $row)
    {
        $this->cisloSkoleni = $row[0];
        $this->popis = $row[1];
        $this->druhSkoleni = $row[2];
        $this->datumPocatkuSkoleni = $database->stringToTimestamp($row[3]);
        $this->casPocatkuSkoleni = $database->stringToTimestamp($row[4]);
        $this->datumUkonceniSkoleni = $database->stringToTimestamp($row[5]);
        $this->casUkonceniSkoleni = $database->stringToTimestamp($row[6]);
        $this->mistoSkoleni = $row[7];
        $this->delkaSkoleniDnu = $row[8];
        $this->delkaSkoleniHodin = $row[9];
        $this->pocetOsob = $row[10];
        $this->konkretniUcastnici = $row[11];
        $this->firma = $row[12];
        $this->skolitel = $row[13];
        $this->cenaZaSkoleni = $row[14];
        $this->zakladDPH1 = $row[15];
        $this->zakladDPH2 = $row[16];
        $this->zakladDPH3 = $row[17];
        $this->dph1 = $row[18];
        $this->dph2 = $row[19];
        $this->dph3 = $row[20];
        $this->dan1 = $row[21];
        $this->dan2 = $row[22];
        $this->dan3 = $row[23];
        $this->uzivatelska1 = $row[24];
        $this->uzivatelska2 = $row[25];
        $this->uzivatelska3 = $row[26];
        $this->uzivatelska4 = $row[27];
        $this->uzivatelska5 = $row[28];
        $this->uzivatelska6 = $row[29];
        $this->uzivatelska7 = $row[30];
        $this->uzivatelska8 = $row[31];
        $this->uzivatelska9 = $row[32];
        $this->uzivatelska10 = $row[33];
        $this->stav = $row[34];
        $this->poznamka = $row[35];
        $this->stavPopis = $row[36];
    }
}