<?php
/**
 * Created by PhpStorm.
 * User: Roman.Szablatura
 * Date: 26.01.2016
 * Time: 13:15
 */
namespace Ron\Personalistika;

use Ron\DB\Database;
use Ron\MessageManager;

class UchazecDokumenty
{
    public $idDokumentu;
    public $nazevDokumentu;
    public $popisDokumentu;
    public $datumVlozeniDokumentu;



    /**
     * @param Database $database
     * @param $row
     */
    private function nactiUchazecovyDokumentyZRadku($database, $row)
    {
        $this->idDokumentu = $row[0];
        $this->nazevDokumentu = $row[1];
        $this->popisDokumentu = $row[2];
        $this->datumVlozeniDokumentu = $database->stringToTimestamp($row[3]);
    }

    /**
     * @param Database $database
     * @param $rc
     * @return UchazecDokumenty[]
     * @throws \Exception
     */
    public static function nactiDokumentyUchazece($database, $rc)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT Dokument.id, Dokument.jmenoSouboru, Dokument.popis, Dokument.datum ' .
            ' FROM P_Uchazec, DokumentUchazece, Dokument ' .
            ' WHERE P_Uchazec.RC = DokumentUchazece.IDUchazece ' .
            ' AND DokumentUchazece.ID = Dokument.id ' .
            ' AND RC = ' . $params->addParameter($rc) . ' ' .
            ' ORDER BY Dokument.id DESC, Dokument.datum  DESC';

        MessageManager::addDebugLog($sql);

        $cursor = $database ->getSqlResult($sql,$params);

        $seznamDokumentu = [];
        while($row = $cursor->fetch())
        {
            $uchazecDokumenty = new UchazecDokumenty();
            $uchazecDokumenty ->nactiUchazecovyDokumentyZRadku($database, $row);
            $seznamDokumentu[] = $uchazecDokumenty;
        }
        return $seznamDokumentu;
    }
}

