<?php
/**
 * Created by PhpStorm.
 * User: Roman.Szablatura
 * Date: 27.01.2016
 * Time: 14:51
 */
namespace Ron\Personalistika;

use Ron\DB\Database;
use Ron\MessageManager;

class UchazecDovednosti
{
    public $datumZiskani;
    public $popisDovednosti;
    public $urovenDovednosti;

    /**
     * @param Database $database
     * @param $row
     */
    private function nactiUchazecDovednostiZRadku($database, $row)
    {
        $this->datumZiskani = $database->stringToTimestamp($row[0]);
        $this->popisDovednosti = $row[1];
        $this->urovenDovednosti = $row[2];
    }

    /**
     * @param Database $database
     * @param $rc
     * @return UchazecDovednosti[]
     * @throws \Exception
     */
    public static function nactiDovednostiUchazece($database, $rc)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT DovednostUchazece.DatumZiskani, Dovednost.Popis, UrovenDovednosti.Popis ' .
            ' FROM P_Uchazec,DovednostUchazece, UrovenDovednosti,Dovednost,TypDovednosti ' .
            ' WHERE DovednostUchazece.KodDovednosti = UrovenDovednosti.KodDovednosti ' .
            ' AND DovednostUchazece.KodUrovne = UrovenDovednosti.KodUrovne ' .
            ' AND UrovenDovednosti.KodDovednosti = Dovednost.Kod ' .
            ' AND Dovednost.TypDovednosti = TypDovednosti.Kod ' .
            ' AND P_Uchazec.RC = DovednostUchazece.RCUchazece' .
            ' AND P_Uchazec.RC = ' . $params->addParameter($rc) . ' '.
            ' ORDER BY DovednostUchazece.DatumZiskani DESC';


        MessageManager::addDebugLog($sql);

        $cursor = $database->getSqlResult($sql, $params);

        $seznamDovednosti = [];
        while ($row = $cursor->fetch()) {
            $uchazecDovednosti = new UchazecDovednosti();
            $uchazecDovednosti->nactiUchazecDovednostiZRadku($database, $row);
            $seznamDovednosti[] = $uchazecDovednosti;
        }
        return $seznamDovednosti;
    }
}