<?php
/**
 * Created by PhpStorm.
 * User: Roman.Szablatura
 * Date: 27.01.2016
 * Time: 14:51
 */
namespace Ron\Personalistika;

use Ron\DB\Database;
use Ron\DB\DBUtils;
use Ron\MessageManager;

class UchazecKomunikace
{
    public $idKomunikace;
    public $datumACasKomunikace;
    public $personalistaRC;
    public $personalistaJmeno;
    public $personalistaPrijmeni;
    public $druhSdeleni;
    public $obsahSdeleni;
    public $odpoved;


    /**
     * @param Database $database
     * @param $row
     */
    private function nactiKomunikaciUchazeceZRadku($database, $row)
    {
        $this->datumACasKomunikace = $database->stringToTimestamp($row[0]);
        $this->personalistaJmeno = $row[1];
        $this->personalistaPrijmeni = $row[2];
        $this->druhSdeleni = $row[3];
        $this->obsahSdeleni = $row[4];
        $this->odpoved = $row[5];
        $this->idKomunikace = $row[6];
        $this->personalistaRC = $row[7];
    }

    /**
     * @param Database $database
     * @param $rc
     * @param UchazeciKomunikace []
     * @return array
     */
    public static function nactiKomunikaciUchazece($database, $rc)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT Komunikace.DatumCas, P_Osoba.Jmeno, P_Osoba.Prijmeni, Komunikace.DruhSdeleni, ' .
            ' Komunikace.ObsahSdeleni, Komunikace.OdpovedUchazece, IDKomunikace, P_Osoba.RC ' .
            ' FROM Komunikace, P_Osoba ' .
            ' WHERE P_Osoba.RC = Komunikace.RCOsoby ' .
            ' AND RCUchazece = ' . $params->addParameter($rc) . ' '.
            ' ORDER BY Komunikace.DatumCas DESC';


        MessageManager::addDebugLog($sql);

        $cursor = $database->getSqlResult($sql, $params);

        $seznamKomunikace = [];
        while ($row = $cursor->fetch()) {
            $uchazecKomunikace = new UchazecKomunikace();
            $uchazecKomunikace->nactiKomunikaciUchazeceZRadku($database, $row);
            $seznamKomunikace[] = $uchazecKomunikace;
        }
        return $seznamKomunikace;
    }

    public static function vratRCUchazecePodleID($database, $idKomunikace)
    {
        //TODO: udelat

        return DBUtils::getSqlValue($database, 'SELECT RCUchazece FROM Komunikace WHERE IDKomunikace = ' . (int)$idKomunikace );
    }

    public static function vratRCPersonalistyPodleID($database, $idKomunikace)
    {
        return DBUtils::getSqlValue($database, 'SELECT RCOsoby FROM Komunikace WHERE IDKomunikace = ' . (int)$idKomunikace );
    }
}