<?php
/**
 * Created by PhpStorm.
 * User: Roman.Szablatura
 * Date: 27.01.2016
 * Time: 14:51
 */
namespace Ron\Personalistika;

use Ron\DB\Database;
use Ron\MessageManager;

class UchazecRozdeleni
{
    public $kodRozdeleni;
    public $popisRozdeleni;
    public $typRozdeleni;

    /**
     * @param $row
     */
    private function nactiRozdeleniUchazeceZRadku($row)
    {
        $this->kodRozdeleni = $row[0];
        $this->popisRozdeleni = $row[1];
        $this->typRozdeleni = $row[2];
    }

    /**
     * @param Database $database
     * @param $rc
     * @return UchazecRozdeleni[]
     * @throws \Exception
     */
    public static function nactiRozdeleniUchazece($database, $rc)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT Rozdeleni.Kod, Rozdeleni.Popis, TypRozdeleni.Popis ' .
            ' FROM P_Uchazec, Rozdeleni, RozdeleniUchazece, TypRozdeleni ' .
            ' WHERE P_Uchazec.RC = RozdeleniUchazece.RC ' .
            ' AND RozdeleniUchazece.Rozdeleni = Rozdeleni.Kod ' .
            ' AND RozdeleniUchazece.KodTypuRozdeleni = Rozdeleni.KodTypuRozdeleni ' .
            ' AND Rozdeleni.KodTypuRozdeleni = TypRozdeleni.Kod ' .
            ' AND TypRozdeleni.VyberoveRizeni = 1' .
            ' AND P_Uchazec.RC = ' . $params->addParameter($rc) . ' '.
            'ORDER BY TypRozdeleni.Kod';


        MessageManager::addDebugLog($sql);

        $cursor = $database->getSqlResult($sql, $params);

        $seznamRozdeleni = [];
        while ($row = $cursor->fetch()) {
            $uchazecRozdeleni = new UchazecRozdeleni();
            $uchazecRozdeleni->nactiRozdeleniUchazeceZRadku($row);
            $seznamRozdeleni[] = $uchazecRozdeleni;
        }
        return $seznamRozdeleni;
    }
}