<?php
/**
 * UTF8
 * stanislav.elbl, 01.11.2015
 * szablatura.roman 10.10.2016
 */

namespace Ron\Personalistika;

use Exception;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\MessageManager;
use Ron\RonPortal\RonPortalDBRecord;
use Ron\RonPortal\RonPortalUtils;
use Ron\RonPortal\User;
use Ron\StringUtils;
use function Ron\ronText;


class Ukol
{
    var $kodSerial;
    /** @var array Pole definovane dovednosti */
    var $poleDefDovUkolu = [];
    /** @var array Pole získané dovednosti */
    var $poleZiskDovUkolu = [];
    var $prideleniDovednostiProvedeno;
    var $vypisDefinovanychDovednosti;
    var $vypisUkolemDosazenychDovednosti;

    var $popis;
    var $typUkolu;
    var $zkracenyPopis;
    var $dovednostZaUkolJe;

    var $podrobnosti;
    var $stavUkolu;


    var $kategorie;
    var $popisVazbyNaOsobu;

    var $RC_Osoby;
    var $osoba_Jmeno;

    var $vazanaOsobaJmeno;
    var $vazanaOsobaPrijmeni;

    var $hodnotitel;
    var $datumZadani;
    var $RC_KdoZadal;
    var $kdoZadal_Jmeno;

    var $termin;
    var $datumSplneni;
    var $poznamkaKeSplneni;
    var $jeVTerminu;

    var $prekazka;
    var $datumZapisuPrekazky;
    var $poznamkaKPrekazce;
    var $datumOdstraneniPrekazky;

    // hodnoceni
    var $RC_Hodnotitele_Def;
    var $kdoHodnotil_Jmeno;
    var $pocetBodu_Maximalni;
    var $pocetBodu_Dosazeny;
    var $procenta_Dosazenych;
    var $popisHodnoceni;
    var $hodnoceno;
    var $datumHodnoceni;
    var $podrobnaPoznamkaKHodnoceni;
    var $urovenHodnoceni;

    // schvaleni
    var $schvalovatel1_Def;
    var $schvalovatel2_Def;

    var $schvalil_1_uroven;
    var $Schvaleno1;
    var $CasSchvaleni1;

    var $schvalil_2_uroven;
    var $Schvaleno2;
    var $CasSchvaleni2;

    var $RC_schvalovatele1_Def;
    var $Schvaleno1_Uzivatel;
    var $RC_schvalovatele2_Def;
    var $Schvaleno2_Uzivatel;

    var $navrzenaOdmena;
    var $skutecnaOdmena;


    /**
     * nacte zadany ukol. pokud je opakovany, tak nacte take prvni nesplneny termin a pokud takovy neni, tak posledni splneny termin
     * @param Database $database
     * @param int $kodSerial
     * @throws Exception
     */
    function load($database, $kodSerial)
    {
        $kodSerial = (int)$kodSerial;

        $sql =
            'SELECT UkolOsoby.RC_Osoby, Resitel.Jmeno, Resitel.Prijmeni, Resitel.Titul, ' . // 0 - 3
            '  UkolOsoby.RC_KdoZadal, Zadavatel.Jmeno, Zadavatel.Prijmeni, Zadavatel.Titul, ' . // 4 - 7
            '  UkolOsoby.DatumZadani, UkolOsoby.ZkracenyPopis, ' . $database ->castWideMemo('UkolOsoby.PodrobnyPopis') . ', ' . // 8 - 10
            '  UkolOsoby.KodKategorieUkolu, ' . // 11
            // splneni
            '  UkolOsoby.DatumSplneni_Narizene, UkolOsoby.DatumSplneni_Skutecne, ' . $database ->castWideMemo('UkolOsoby.PoznamkaKeSplneni') . ', ' . // 12 - 14
            // prekazka
            '  UkolOsoby.Prekazka, UkolOsoby.DatumZapisuPrekazky, ' . $database ->castWideMemo('UkolOsoby.PoznamkaKPrekazce') . ', UkolOsoby.DatumOdstraneniPrekazky, ' . // 15 - 18
            // hodnoceni
            '  UkolOsoby.PocetBodu_Maximalni, UkolOsoby.PocetBodu_Dosazeny, ' . $database ->castWideMemo('UkolOsoby.PodrobnyPopisHodnoceni') . ',' .// 19 - 21
            '  UkolOsoby.ZkracenyPopis, ' .     //22
            // schvaleni
            '  UkolOsoby.RC_Schvalovatele1_Def, UkolOsoby.RC_Schvalovatele2_Def, UkolOsoby.RC_Schvalovatele1, UkolOsoby.Schvaleno1, ' .     //23 - 26
            '  UkolOsoby.Schvaleno1_Uzivatel, UkolOsoby.CasSchvaleni1, UkolOsoby.RC_Schvalovatele2, UkolOsoby.Schvaleno2, ' .       //27 - 30
            '  UkolOsoby.Schvaleno2_Uzivatel, UkolOsoby.CasSchvaleni2, ' .  //31 - 32
            '  KategorieUkolu.popis, KategorieUkolu.VazbaNaOsobu, KategorieUkolu.PopisVazbyNaOsobu, ' .      //33 - 35
            '  VazanaOsoba.Jmeno, VazanaOsoba.Prijmeni, UkolOsoby.RC_KdoHodnotil, ' .      //36 - 38
            "  COALESCE(Hodnotitel.Titul {fn_concat()} ' ', '') {fn_concat()} COALESCE(Hodnotitel.Jmeno {fn_concat()} ' ', '') {fn_concat()} COALESCE(Hodnotitel.Prijmeni, ''),  " .      //39
            "  COALESCE(Schvalovatel_1_Def.Titul {fn_concat()} ' ', '') {fn_concat()} COALESCE(Schvalovatel_1_Def.Jmeno {fn_concat()} ' ', '') {fn_concat()} COALESCE(Schvalovatel_1_Def.Prijmeni, ''),  " .      //40
            "  COALESCE(Schvalovatel_2_Def.Titul {fn_concat()} ' ', '') {fn_concat()} COALESCE(Schvalovatel_2_Def.Jmeno {fn_concat()} ' ', '') {fn_concat()} COALESCE(Schvalovatel_2_Def.Prijmeni, ''),   " .      //41
            '  UkolOsoby.StavUkolu, ' .   //42
            "  COALESCE(Schvalil1_uroven.Titul {fn_concat()} ' ', '') {fn_concat()} COALESCE(Schvalil1_uroven.Jmeno {fn_concat()} ' ', '') {fn_concat()} COALESCE(Schvalil1_uroven.Prijmeni, ''),   " .      //43
            "  COALESCE(Schvalil2_uroven.Titul {fn_concat()} ' ', '') {fn_concat()} COALESCE(Schvalil2_uroven.Jmeno {fn_concat()} ' ', '') {fn_concat()} COALESCE(Schvalil2_uroven.Prijmeni, ''),   " .      //44
            "  COALESCE(KdoHodnotil.Titul {fn_concat()} ' ', '') {fn_concat()} COALESCE(KdoHodnotil.Jmeno {fn_concat()} ' ', '') {fn_concat()} COALESCE(KdoHodnotil.Prijmeni, ''),   " .      //45
            '  UkolOsoby.Hodnoceno, UkolOsoby.PodrobnyPopisHodnoceni, UkolOsoby.RC_Hodnotitele_Def, UkolOsoby.CasHodnoceni, ' .      //46 - 49
            '  DovednostUkolu.KodUkolu, DovednostUkolu.KodDovednosti, DovednostUkolu.KodUrovne, KategorieUkolu.UrovenHodnoceni, ' .      //50 - 53
            '  DosazenaDovednostUkolu.KodUkolu, DovednostZaUkolJe.RC, UkolOsoby.NarvzenaOdmena, UkolOsoby.SkutecnaOdmena ' .      //54 - 57

            'FROM UkolOsoby ' .
            'JOIN Osoba Resitel ON (Resitel.RC = UkolOsoby.RC_Osoby) ' .
            ' LEFT JOIN Osoba Zadavatel ON (Zadavatel.RC = UkolOsoby.RC_KdoZadal) ' .
            '  LEFT JOIN KategorieUkolu ON (KategorieUkolu.Kod = UkolOsoby.KodKategorieUkolu) ' .
            '   LEFT JOIN Osoba VazanaOsoba ON (UkolOsoby.RC_OsobaUkolu = VazanaOsoba.RC) ' .
            '    LEFT JOIN Osoba Hodnotitel ON (UkolOsoby.RC_Hodnotitele_Def = Hodnotitel.RC) ' .
            '     LEFT JOIN Osoba Schvalovatel_1_Def ON (UkolOsoby.RC_Schvalovatele1_Def = Schvalovatel_1_Def.RC) ' .
            '      LEFT JOIN Osoba Schvalovatel_2_Def ON (UkolOsoby.RC_Schvalovatele2_Def = Schvalovatel_2_Def.RC) ' .
            '       LEFT JOIN Osoba Schvalil1_uroven ON (UkolOsoby.RC_Schvalovatele1 = Schvalil1_uroven.RC) ' .
            '        LEFT JOIN Osoba Schvalil2_uroven ON (UkolOsoby.RC_Schvalovatele2 = Schvalil2_uroven.RC) ' .
            '         LEFT JOIN Osoba KdoHodnotil ON (UkolOsoby.RC_KdoHodnotil = KdoHodnotil.RC) ' .
            '          LEFT JOIN DovednostUkolu ON (UkolOsoby.kodSerial = DovednostUkolu.KodUkolu) ' .
            '           LEFT JOIN DosazenaDovednostUkolu ON (UkolOsoby.kodSerial = DosazenaDovednostUkolu.KodUkolu) ' .
            '            LEFT JOIN DovednostOsoby DovednostZaUkolJe ON (UkolOsoby.kodSerial = DovednostZaUkolJe.IDUkolu) ' .

            'WHERE UkolOsoby.KodSerial = ' . $kodSerial;

        MessageManager::addDebugLog($sql);

        $cursor = $database ->getSqlResult($sql);

        if (!$row = $cursor ->fetch()) {
            throw new Exception('Chyba: Zadany zaznam neexistuje!');
        }

        $cursor ->close();

        $this->nacteniDefinovaneDovednosti($database, $kodSerial);
        $this->nacteniUkolemDosazenychDovednosti($database, $kodSerial);

        $this->kodSerial = $kodSerial;
        $this->popis = $row[9];
        $this->podrobnosti = $row[10];
        $this->kategorie = $row[11];
        $this->RC_Osoby = $row[0];
        $this->osoba_Jmeno = $row[1] . ' ' . $row[2];
        if ($row[3]) $this->osoba_Jmeno = $row[3] . ' ' . $this->osoba_Jmeno;
        $this->RC_KdoZadal = $row[4];
        $this->kdoZadal_Jmeno = $row[5] . ' ' . $row[6];
        if ($row[7]) $this->kdoZadal_Jmeno = $row[7] . ' ' . $this->kdoZadal_Jmeno;

        $this->datumZadani = $database ->stringToTimestamp($row[8]);
        $this->termin = $database ->stringToTimestamp($row[12]);
        $this->datumSplneni = $database ->stringToTimestamp($row[13]);
        $this->poznamkaKeSplneni = $row[14];

        $this->prekazka = $row[15] ? 1 : 0;
        $this->datumZapisuPrekazky = $database ->stringToTimestamp($row[16]);
        $this->poznamkaKPrekazce = $row[17];
        $this->datumOdstraneniPrekazky = $database ->stringToTimestamp($row[18]);
        $this->zkracenyPopis = $row[22];
        $this->RC_schvalovatele1_Def = $row[23];
        $this->RC_schvalovatele2_Def = $row[24];
        $this->Schvaleno1 = $row[26];
        $this->Schvaleno1_Uzivatel = $row[27];
        $this->CasSchvaleni1 = $database->stringToTimestamp($row[28]);
        $this->Schvaleno2 = $row[30];
        $this->Schvaleno2_Uzivatel = $row[31];
        $this->CasSchvaleni2 = $database->stringToTimestamp($row[32]);
        $this->typUkolu = $row[33];
        $this->popisVazbyNaOsobu = $row[35];
        $this->vazanaOsobaJmeno = $row[36];
        $this->vazanaOsobaPrijmeni = $row[37];
        $this->hodnotitel = $row[39];
        $this->schvalovatel1_Def = $row[40];
        $this->schvalovatel2_Def = $row[41];
        $this->stavUkolu = $row[42];
        $this->schvalil_1_uroven = $row[43];
        $this->schvalil_2_uroven = $row[44];
        $this->kdoHodnotil_Jmeno = $row[45];
        $this->hodnoceno = $row[46];
        $this->podrobnaPoznamkaKHodnoceni = $row[47];
        $this->RC_Hodnotitele_Def = $row[48];
        $this->datumHodnoceni = $database ->stringToTimestamp($row[49]);
        $this->urovenHodnoceni = $row[53];

        //Info zda v tabulce DovednostOsoby již existuje zápis o dovednosti z konkrétního úkolu - pokud ano,
        //nelze takovému úkolu zrušit splnění nebo přidání nějaké dovednosti nebo upravit vázanou osobu
        $this->dovednostZaUkolJe = ($row[0] == $row[55]) ? 1 : 0;

        $this->vypisDefinovanychDovednosti = $this->nacteniAVypisDovednostiUkolu('definovane');
        $this->vypisUkolemDosazenychDovednosti = $this->nacteniAVypisDovednostiUkolu('dosazene');
        $this->jeVTerminu = $this->zjisteniRozdiluSplneniOprotiTerminu($this->termin,$this->datumSplneni);
        // hodnoceni
//        $this->f_RC_KdoHodnotil;
//        $this->f_KdoHodnotil_Jmeno;
        $this->pocetBodu_Maximalni = $row[19];
        $this->pocetBodu_Dosazeny = $row[20];
        $this->procenta_Dosazenych = ($row[19] != 0 && $row[20] != 0) ? (($row[20]/$row[19])*100) : "";
        $this->navrzenaOdmena = $row[56];
        $this->skutecnaOdmena = $row[57];
//        $this->f_PopisHodnoceni;
    }


    /**
     * @param Database $database
     * @param bool $editovatDatum  Urcuje, jestli muze uzivatel editovat datum (pokud ne, tak je zobrazen jen checkbox)
     * @throws Exception
     */
    function ulozZmenenyZaznam($database, $editovatDatum)
    {
        require_once('adsapp/ronportaldbrecord.php');
        $rec = new RonPortalDBRecord($database, 'UkolOsoby');

        //Pole, která se pouze přečtou proto readOnly parametr true
        $rec ->addField('kodSerial', 'int', true);
        $rec ->addField('RC_Osoby', '', true);
        $rec ->addField('DatumZadani', 'timestamp', true);
        $rec ->addField('ZkracenyPopis', '', true);


        // prekazka
        $prekazkanew = $_POST['Prekazka'] ? 1 : 0;
        $rec ->addField('Prekazka', 'int', false, 0, $prekazkanew);
        $fZapisPrekazky = $rec ->addField('DatumZapisuPrekazky', 'timestamp', true);
        $fOdstraneniPrekazky = $rec ->addField('DatumOdstraneniPrekazky', 'timestamp', true);

        if ($this->prekazka != $prekazkanew) {
            // změnilo se zaškrtavátko "prekazka"
            if ($prekazkanew) {
                $fZapisPrekazky ->setNewValue( time() );
            } else {
                $fOdstraneniPrekazky ->setNewValue( time() );
            }
        }
        if ($_POST['PoznamkaKPrekazce'] != '') {
            $rec->addField('PoznamkaKPrekazce', '', false, 0, $_POST['PoznamkaKPrekazce']);
        }

        // splneni
        $datum = $this->datumSplneni; // vychozi hodnota - stejná jako puvodni
        if ($editovatDatum) {
            // možnost editovat datum splneni
            if ($_POST['datumsplneni']) {
                $datum = DateUtils::dateStringToTimestamp($_POST['datumsplneni']);
            } else {
                $datum = null;
            }
        } else {
            // jen zaškrtavátko "splněno" a poznamka ke splneni
            $splnenoold = false;

            if ($this->datumSplneni) {
                $splnenoold = true;
            }
            $splnenonew = false;
            if ($_POST['splneno']) {
                $splnenonew = true;
            }
            if ($splnenoold != $splnenonew) {
                $datum = $splnenonew ? time() : null;
            }
        }

        if ($this->hodnoceno == 0) {
            $rec->addField('DatumSplneni_Skutecne', 'timestamp', false, 0, $datum);
            $rec->addField('PoznamkaKeSplneni', '', false, 0, $_POST['PoznamkaKeSplneni']);
            $rec->addField('StavUkolu', 'int', false, 0, $_POST['splneno'] ? 1 : 0);
        }

        //Pozn. V případě, že již byla na základě splnění úkolu vygenerovaná dovednost, nelze vrátit
        //splnění úkolu, stejně tak jako změnit datum splnění, nebo osobu, která je s úkolem svázaná a
        //případně také změnit definici dovednosti dosažených splněním úkolu (viz Rozšíření agendy úkolů (2.6.2016) Radek Urbančík)
        if ($this->stavUkolu == 1){
            //Uložení označených dovedností
            $this->zapisUkolemDosazeneDovednosti($database);
        }

        //Hodnoceni - pokud dojde ke změně checkboxu uloží se čas (jmeno hodnotitele je porovnáváno s hodnotitelem, který je definován)
        if ($this->RC_Hodnotitele_Def == User::getRC()) {
            $rec ->addField('Hodnoceno', 'int', false, 0, $_POST['Hodnoceno'] ? 1 : 0 );
            $rec ->addField('RC_KdoHodnotil', '', false, 0, User::getRC());
            $rec ->addField('PodrobnyPopisHodnoceni', '', false, 0, $_POST['podrobnaPoznamkaKHodnoceni']);
            $rec ->addField('CasHodnoceni', 'timestamp', false, 0, time())->updateLog = true;
        }

        //Schválení 1.úrovně - pokud je schválená druhá úroveň, není možné upravovat první (řeší se ve view - ukol_formular)
        if ($this->RC_schvalovatele1_Def == User::getRC()) {
            $rec ->addField('Schvaleno1', 'int', false, 0, $_POST['schvaleni1'] ? 1 : 0 );
            $rec ->addField('RC_Schvalovatele1', '', false, 0, User::getRC());
            $rec ->addField('CasSchvaleni1', 'timestamp', false, 0, time())->updateLog = true;
        }

        //Schválení 2.úrovně
        if ( $this->RC_schvalovatele2_Def == User::getRC()) {
            $rec ->addField('Schvaleno2', 'int', false, 0, $_POST['schvaleni2'] ? 1 : 0 );
            $rec ->addField('RC_Schvalovatele2', '', false, 0, User::getRC());
            $rec ->addField('CasSchvaleni2', 'timestamp', false, 0, time())->updateLog = true;
        }

        $rec ->addField('Update_TimeStamp', 'timestamp', false, 0, time()) ->updateLog = true;
        $rec ->addField('Update_UserName', '', false, 25, RonPortalUtils::getLogUserName()) ->updateLog = true;

        $rec ->where = 'KodSerial = ' . (int)$this ->kodSerial;
        if (!$rec ->loadRecord()) {
            throw new Exception(StringUtils::fromUTF8('Chyba při aktualizaci úkolu - původní záznam nebyl nalezen!'));
        }

        //Jelikož záznam vytváří pouze aplikace, RonPortal provádí pouze Update
        $rec ->updateRecord();

        /*
        $zapsat = false;

        $sql =
            'UPDATE UkolOsoby SET UPDATE_TimeStamp = ' . $database ->timestampToString(time()) . ', ' .
            "Update_UserName = '" . $database ->addSlashes(\Ron\RonPortal\getLogUserName(true)) . "'";

        $logmessage = '';

        // Prekazka
        if ($this->poznamkaKPrekazce != $_POST['PoznamkaKPrekazce']) {
            $sql .= ", PoznamkaKPrekazce = '" . $database ->addSlashes($_POST['PoznamkaKPrekazce']) . "' ";

            $logmessage .=
                'PoznamkaKPrekazce: ' . $_POST['PoznamkaKPrekazce'] . "\n" .
                '            <old>: ' . $this->poznamkaKPrekazce . "\n";

            $zapsat = true;
        }

        // Prekazka, DatumZapisuPrekazky, DatumOdstraneniPrekazky
        if ($this->prekazka != $prekazkanew) {
            // zmenilo se zaskrtavatko "prekazka"
            $sql .= ', Prekazka = ' . (int)$prekazkanew;
            $logmessage .=
                'Prekazka = ' . $prekazkanew . ' <old: ' . $this->prekazka . ">\n";

            $cas = time();
            if ($prekazkanew) {
                $sql .= ', DatumZapisuPrekazky = ' . $database ->timestampToString($cas);
                $oldval = $this->datumZapisuPrekazky ? date('j.n.Y G:i', $this->datumZapisuPrekazky) : 'null';
                $logmessage .=
                    'DatumZapisuPrekazky = ' . date('j.n.Y G:i', $cas) . ' <old: ' . $oldval . ">\n";
            } else {
                $sql .= ', DatumOdstraneniPrekazky = ' . $database ->timestampToString($cas);
                $oldval = $this->datumOdstraneniPrekazky ? date('j.n.Y G:i', $this->datumOdstraneniPrekazky) : 'null';
                $logmessage .=
                    'DatumOdstraneniPrekazky = ' . date('j.n.Y G:i', $cas) . ' <old: ' . $oldval . ">\n";
            }

            $zapsat = true;
        }


        // Poznamka ke splneni
        if ($this->poznamkaKeSplneni != $_POST['PoznamkaKeSplneni']) {
            $sql .= ", PoznamkaKeSplneni = '" . $database ->addSlashes($_POST['PoznamkaKeSplneni']) . "' ";

            $logmessage .=
                'PoznamkaKeSplneni: ' . $_POST['PoznamkaKeSplneni'] . "\n" .
                '            <old>: ' . $this->poznamkaKeSplneni . "\n";

            $zapsat = true;
        }

        // Splneni
        $datum = $this->datumSplneni; // vychozi hodnota - stejna jako puvodni

        if ($editovatDatum) {
            // moznost editovat datum splneni
            if ($_POST['datumsplneni']) {
                $datum = datestringtotimestamp($_POST['datumsplneni']);
                if (!$datum) {
                    global $STR_SpatnaHodnota;

                    throw new \Exception($STR_SpatnaHodnota . ' (' . $_POST['datumsplneni'] . ')');
                }
            } else $datum = null; // prazdne
        } else {
            // jen zaskrtavatko "splneno" a poznamka ke splneni
            $splnenoold = false;
            if ($this->datumSplneni) $splnenoold = true;

            $splnenonew = false;
            if ($_POST['splneno']) $splnenonew = true;

            if ($splnenoold != $splnenonew) {
                if ($splnenonew) $datum = time();
                else $datum = null;
            }
        }

        if ($datum != $this->datumSplneni) {
            // doslo ke zmene datumu / zaksrtavatka
            if ($datum) {
                $sql .= ', DatumSplneni_Skutecne = ' . $database ->timestampToString($datum);
                $oldval = $this->datumSplneni ? date('j.n.Y', $this->datumSplneni) : 'null';
                $logmessage .= 'DatumSplneni_Skutecne: ' . date('j.n.Y', $datum) . ' <old: ' . $oldval . ">\n";
            } else {
                $sql .= ', DatumSplneni_Skutecne = NULL ';
                $logmessage .= 'DatumSplneni_Skutecne: NULL <old: ' . date('j.n.Y', $this->datumSplneni) . ">\n";
            }

            $zapsat = true;
        }

        if ($zapsat) {
            $sql .= ' WHERE KodSerial = ' . (int)$this->kodSerial;

            if ( !$database ->sql($sql) ) {
                throw new DBException($database, $sql, 'Chyba při ukládání záznamu');
            }

            $logmessage =
                "\n" .
                'RC_Osoby: ' . $this->RC_Osoby . "\n" .
                $logmessage;

            \AddRecordToDBLog($database, 'UkolOsoby', 'UPDATE', 'Úkoly', $sql . "\n" . $logmessage);
        }
        */
    }

    /** Výpočet rozdílu termínu oproti splnění případně oproti aktuálnímu datu a vypsání této informace v title u termínu ve view.
     * @param $termin
     * @param $splneno
     * @return string
     */
    public function zjisteniRozdiluSplneniOprotiTerminu($termin, $splneno)
    {
        $result = '';
        if (!is_null($splneno)){
            $vypocet = DateUtils::daysBetween($splneno, $termin);

            if($vypocet >= 0){
                $result .= 'title="'. ronText('Splneno_v_terminu') .'"';
            } else {
                $vypocet = DateUtils::daysBetween($termin, $splneno);
                $result .= 'title="' . sprintf(ronText('Splneno_po_terminu'), $vypocet) . '"';
            }
        } else {
            $vypocet = DateUtils::daysBetween($termin,time() );
            if ($vypocet < 0){
                $result .= 'title="' . sprintf(ronText('Zbyva'),$vypocet * (-1) ) . '"';
            }else {
                $result .= 'title="' . sprintf(ronText('Skluz_splneni'), $vypocet) . '"';
            }
        }
        return $result;
    }

    /**
     * Zápis definovaných dovednosti úkolu do tabulky 'DosazenaDovednostUkolu' - úkolem dosažené dovednosti
     * @param $database
     * @throws Exception
     */
    private function zapisUkolemDosazeneDovednosti($database)
    {
        for ($i = 0; $i< count($this->poleDefDovUkolu); $i++) {
            $recDosazenaDovednost = new RonPortalDBRecord($database, 'DosazenaDovednostUkolu');
            $pomPromenna = "poleDefDovUkolu_" . $i;
            $postPromenna = isset($_POST[$pomPromenna]);

            if ($this->poleDefDovUkolu[$i][4] == 0 && $postPromenna == 1) {
                //Pro zápis označených Definovaných dovednosti úkolu do tabulky DosazenaDovednostUkolu
                $recDosazenaDovednost->addField('KodUkolu', 'int', false, 0, $this->kodSerial);
                $recDosazenaDovednost->addField('KodDovednosti', '', false, 40, $this->poleDefDovUkolu[$i][2]);
                $recDosazenaDovednost->addField('KodUrovne', 'int', false, 0, (int)$this->poleDefDovUkolu[$i][3]);

                if (!$recDosazenaDovednost->insertRecord()) {
                    throw new Exception(StringUtils::fromUTF8('Chyba při vkládání nové dovednosti!Pravděpodobně je již uložena.'));
                }
            }
        }
    }

    /**
     * @param Database $database
     * @param $kodSerial
     * Načtení definovaných dovedností
     * @throws DBException
     */
    public function nacteniDefinovaneDovednosti($database, $kodSerial)
    {
        $params = $database->createParameters();
        $sql =
            'SELECT Dovednost.Popis, UrovenDovednosti.Popis, DovednostUkolu.KodDovednosti,UrovenDovednosti.KodUrovne ' .             //0 - 3
            'FROM UkolOsoby LEFT JOIN DovednostUkolu ON (UkolOsoby.kodSerial = DovednostUkolu.KodUkolu) ' .
            ' LEFT JOIN UrovenDovednosti ON (DovednostUkolu.KodUrovne = UrovenDovednosti.KodUrovne AND DovednostUkolu.KodDovednosti = UrovenDovednosti.KodDovednosti) ' .
            '  LEFT JOIN Dovednost ON (UrovenDovednosti.KodDovednosti = Dovednost.Kod) ' .
            'WHERE kodSerial = ' . $params->addParameter($kodSerial);

        $cursor = $database->getSqlResult($sql,$params);

        $cnt = 0;

        while ($row = $cursor->fetch()){
            //Definované dovednosti ukládám do pole pro další využití při zápisu do databáze
            $this->poleDefDovUkolu[$cnt] = $row;
            //Čtvrtý sloupec nese informaci o shodnosti téhož řádku v obou tabulkách, implicitně nastaven na nulu
            $this->poleDefDovUkolu[$cnt][4] = 0;
            $cnt++;
        }

        $cursor ->close();
    }

    /**
     * @param Database $database
     * @param $kodSerial
     * Načtení úkolem dosažených dovedností
     * @throws DBException
     */
    public function nacteniUkolemDosazenychDovednosti($database, $kodSerial)
    {
        $params = $database->createParameters();
        $sql =
            'SELECT Dovednost.Popis, UrovenDovednosti.Popis, DosazenaDovednostUkolu.KodDovednosti, UrovenDovednosti.KodUrovne ' .      //0 - 3
            'FROM UkolOsoby Left JOIN DosazenaDovednostUkolu ON (UkolOsoby.kodSerial = DosazenaDovednostUkolu.KodUkolu) ' .
            ' LEFT JOIN UrovenDovednosti ON ( DosazenaDovednostUkolu.KodDovednosti= UrovenDovednosti.KodDovednosti AND DosazenaDovednostUkolu.KodUrovne = UrovenDovednosti.KodUrovne) ' .
            '  LEFT JOIN Dovednost ON (UrovenDovednosti.KodDovednosti = Dovednost.Kod) ' .
            'WHERE kodSerial = ' . $params->addParameter($kodSerial);

        $cursor = $database->getSqlResult($sql,$params);

        $this->poleZiskDovUkolu = [];
        while ($row = $cursor->fetch()) {
            $this->poleZiskDovUkolu[] = $row;
        }

        $cursor ->close();
    }

    /** Přijímá string 'definovane' nebo 'dosazene' pro výpis Definovaných nebo Úkolem získaných dovedností
     * @param $pozadovanyVypis
     * @return bool|string
     */
    public function nacteniAVypisDovednostiUkolu($pozadovanyVypis)
    {
        $result = '';
        //Výpis - DovednostUkolu.KodDovednosti
        $slKodDovednosti = 2;
        //Výpis - UrovenDovednosti.KodUrovne
        $slKodUrovne = 3;

        //Nastavení příznaku. Zpracovává se vždy, kdy je definovaná alespoň jedna dovednost - určí, který řádek se nenachází
        // v obou tabulkách a označí hodnotou '1' v jeho 4 sloupci (pro použití ve view a při ukládání do DB).
        if (!empty($this->poleDefDovUkolu[0][0])) {
            for ($i = 0; $i < count($this->poleDefDovUkolu); $i++) {
                for ($j = 0; $j < count($this->poleZiskDovUkolu); $j++) {
                    //Porovnání tabulek řádek po řádku Definovaných dovednosti a Úkolem dosažených dovedností
                    if ($this->poleDefDovUkolu[$i][$slKodDovednosti] == $this->poleZiskDovUkolu[$j][$slKodDovednosti] && $this->poleDefDovUkolu[$i][$slKodUrovne] == $this->poleZiskDovUkolu[$j][$slKodUrovne]) {
                        //Čtvrtý sloupec nese informaci o shodnosti - hodnota 1 se bude zobrazovat u checkboxu jako checked="checked"
                        $this->poleDefDovUkolu[$i][4] = 1;
                    }
                }
            }
        }

        //Výpis Definovaných dovednosti s jednoduchým připojením checkboxu a přidáním vlastnosti checked="checked" dle podmínky(pro použití ve view)
        if ($pozadovanyVypis == 'definovane' && !empty($this->poleDefDovUkolu[0][0])) {
            for ($i = 0; $i < count($this->poleDefDovUkolu); $i++) {
                if ($this->poleDefDovUkolu[$i][4] == 1) {
                    //Popis dovednosti, úrovně dovednosti a vypsání checkboxu označeného
                    $result .= '<tr><td class="inputformcaption">' . $this->poleDefDovUkolu[$i][0] . '</td>
                    <td colspan="2">' . $this->poleDefDovUkolu[$i][1] . '</td>
                    <td>' . '<input title="' . ronText('Dovednost_vlozena') . '" type="checkbox" name="' . 'poleDefDovUkolu_' . $i . '" checked="checked" disabled="disabled">' . '</td></tr>';
                } else {
                    //Zpřístupnit volbu ve view pouze je-li úkol splněn a nedošlo již k přidělení dovednosti za úkol pomocí přepočtu agenta
                    if ($this->dovednostZaUkolJe != 1 && $this->stavUkolu == 1 && (User::getRC() == $this->RC_Osoby || User::getRC() == $this->RC_Hodnotitele_Def || User::getRC() == $this->RC_schvalovatele1_Def || User::getRC() == $this->RC_schvalovatele2_Def)) {
                        //Popis dovednosti, úrovně dovednosti a checkbox
                        $result .= '<tr><td class="inputformcaption">' . $this->poleDefDovUkolu[$i][0] . '</td>
                            <td colspan="2">' . $this->poleDefDovUkolu[$i][1] . '</td>
                            <td>' . '<input title="' . ronText('Dovednost_priradit') . '" type="checkbox" name="' . 'poleDefDovUkolu_' . $i . '" >' . '</td></tr>';
                    } else {
                        $result .= '<tr><td class="inputformcaption">' . $this->poleDefDovUkolu[$i][0] . '</td>
                            <td colspan="2">' . $this->poleDefDovUkolu[$i][1] . '</td>
                            <td>' . '<input title="" type="checkbox" name="' . 'poleDefDovUkolu_' . $i . '" disabled="disabled" >' . '</td></tr>';
                    }
                }
            }
            return $result;
        }

        //Výpis Dosažených dovednosti, pokud požaduji pouze čistý výpis pak se v metodě zpracuje Nastavení příznaku a zavolá tento cyklus
        if ($pozadovanyVypis == 'dosazene') {
            //Pro view - výpis Definovaných dovedností úkolu
            for ($i = 0; $i < count($this->poleZiskDovUkolu); $i++) {
                $result .= '<tr><td class="inputformcaption">' . $this->poleZiskDovUkolu[$i][0] . '</td><td>' . $this->poleZiskDovUkolu[$i][1] . '</td></tr>';
            }
            return $result;
        }
        return false;
    }
}
