<?php
/**
 * stanislav.elbl, 11.06.2020 - presunuto z hlasenizmeny_view.php
 * Zobrazeni aktualnich hodnot a historie osobnich udaju v hlaseni zmen
 */

namespace Ron\Personalistika;

use Ron\StringUtils;

/** @var HlaseniZmenyForm $this */
/** @var string[] $polozkyZmeny     Konfigurace daneho typu zmeny */
/** @var mixed[] $aktualniHodnoty */
$aktualniHodnoty = $this ->aktualniHodnoty;

$back = '';
if ((isset($_GET['back']) && $_GET['back'] == 'osobniudaje') || (isset($_GET['detail']) && (int)$_GET['detail'])) {
    $back = '&back=osobniudaje';
}
?>

<div class='form large-form'>

    <div class="form-content">
        <div class="form-section margin-bottom-2" id="nadpisy">
            <?= \Ron\ronText("aktualni_udaje") ?>
        </div>

        <?php
        foreach ($aktualniHodnoty as $index => $zaznam) {
            //Sekce vypisuje hodnoty aktualniho stavu/historii
            $i=0; ?>

            <div id='sekce_historie_<?= $index + 1 ?>' class="sekce-historie-osobnich margin-bottom-2 <?= ($index < count($aktualniHodnoty) - 1) ? 'border-bottom' : '' ?>">

                <?php foreach ($polozkyZmeny as $polozkaZmeny) {
                    //$pomarray = explode(':', $polozkaZmeny);
                    list($typPole, $kodPole, $nadpisPole) = explode(':', $polozkaZmeny);

                    ?>

                    <div  class="row">
                        <?php if ($typPole != 'ID' && $typPole != 'soubor') { ?>
                            <div class="col col-5 col-sm-3 caption ">
                                <?= \Ron\ronText($nadpisPole) ?>
                            </div>
                        <?php } ?>

                        <div class="col col-7 col-sm-9" data-typ-polozky="<?= $typPole ?>">
                            <?php
                            switch (strtoupper($typPole)) {
                                case 'E' :
                                    echo StringUtils::htmlTextConvert($zaznam[$kodPole]);
                                    break;

                                case 'D' :
                                    $datum = $zaznam[$kodPole]; // finta, aby nezobrazoval 31.12.1899 - bohuzel je to v aplikaci i s casem
                                    echo ($datum  < 31359600 || $datum > 31445999) ? StringUtils::format("date", $datum) : '';
                                    break;

                                case 'C' :
                                    echo '<input type="checkbox" disabled="disabled"' . ($zaznam[$kodPole] ? " checked='checked'" : '') . '>';
                                    break;

                                case 'ID':
                                case 'SOUBOR':
                                    break;

                                case 'VLASTNIPOZNAMKA' :
                                    if ($zaznam[$kodPole]) {
                                        $text = StringUtils::htmlTextConvert($zaznam[$kodPole]);
                                        echo '<div class="autoExpand" title="' . $text . '">' . StringUtils::longTextToHtml($text) . '</div>';
                                    }
                                    break;

                                // rodinny prislusnik
                                case 'S_RODINNYVZTAH' :
                                case 'S_ZDRAVOTNISTAV' :
                                // stav
                                case 'S_RODINNYSTAV' :
                                // prukazy
                                case 'TYPPRUKAZU' :
                                // ucet
                                case 'S_TYPBANKOVNIHOUCTU' :
                                case 'BANKA' :
                                case 'IBAN' :
                                case 'MENA' :
                                case 'KONSTANTNISYMBOL' :
                                // adresa
                                case 'MESTO' :
                                case 'OBEC' :
                                case 'STAT' :
                                case 'DOPRAVADOZAMESTNANI' :
                                // zdravotni, penzijko a zivotko
                                case 'S_TYPZAMESTNANCEPROZP' :
                                case 'UCTARNA' :
                                case 'ZDRAVOTNIPOJISTOVNA' :
                                case 'PENZIJNIFOND' :
                                case 'BF' :
                                case 'BZ' :
                                case 'POJISTOVNA' :
                                // vzdelani
                                case 'TYPVZDELANI' :
                                case 'OBORVZDELANI' :
                                case 'SKOLA' :
                                case 'S_ZPUSOBUKONCENISKOLY' :
                                case 'OBORVZDELANIISPV' :
                                default:
                                    echo StringUtils::htmlTextConvert($zaznam[$kodPole]);
                                    break;

                            }
                            $i++;
                            ?>
                        </div>
                    </div>
                <?php  } ?>

                <?php if ($this ->nahlasenaZmena ->typZmeny == 'rodinnyprislusnik' || $this ->nahlasenaZmena ->typZmeny == 'novyclenrodiny') { ?>
                    <div class="row">
                        <div class="col col-12 col-sm-3 caption"></div>
                        <div class="col col-12 col-sm-5 font-weight-bold">
                            <a href="?menuid=zmena&typzmeny=rodinnyprislusnik&editace=rodina&osoba=<?= $this ->nahlasenaZmena ->idPPOsobyZmeny ?>&idrodinnehoprislusnika=<?= $zaznam['ID'] ?><?= $back ?>" title=""><?= \Ron\ronText('upravit_udaje_osoby') ?></a>
                        </div>
                    </div>
                <?php } ?>


                <?php if ($this ->nahlasenaZmena ->typZmeny == 'osobni') { ?>
                    <div class="row">
                        <div class="col col-12 col-sm-3 caption"></div>
                        <div class="col col-12 col-sm-5">
                            <a href="?menuid=zmena&typzmeny=osobni&editace=osobnich&osoba=<?= $this ->nahlasenaZmena ->idPPOsobyZmeny ?><?= $back ?>" title=""><?= \Ron\ronText('upravit_vlastni_udaje') ?></a>
                        </div>
                    </div>
                <?php } ?>


                <?php if ($this ->nahlasenaZmena ->typZmeny == 'prukaz') { ?>
                    <div class="row">
                        <div class="col col-12 col-sm-3 caption"></div>
                        <div class="col col-12 col-sm-5">
                            <a href="?menuid=zmena&typzmeny=prukaz&editace=prukazy&cisloprukazu=<?= $zaznam['CisloPrukazu'] ?>&typprukazu=<?= $zaznam['KodTypuPrukazu'] ?>&osoba=<?= $this ->nahlasenaZmena ->idPPOsobyZmeny ?><?= $back ?>" title=""><?= \Ron\ronText('upravit_prukaz') ?></a>
                        </div>
                    </div>
                <?php } ?>

                <?php //TODO doplnit primou editaci adresy  ?>

            </div>
        <?php } ?>

    </div>
</div>

