<?php
/**
 * stanislav.elbl, 16.11.2015
 * Hlavicka hodnoceni (hodnotitele, obdobi, ...)
 */

namespace Ron\Personalistika;

use Ron\Http\App;
use Ron\MessageManager;
use Ron\RonPortal\RonPortalSettings;
use Ron\StringUtils;
use function Ron\ronText;

global $STR_H_0; // kompat.
global $STR_H_1;
global $STR_H_2;
global $STR_H_3;
global $STR_H_4;
global $STR_H_5;

/** @var $this Hodnoceni */

if (isset($_POST['backaction'])  &&  $_POST['backaction']) $back = StringUtils::secureString($_POST['backaction']);
else if (isset($_GET['backaction'])  &&  $_GET['backaction']) $back = StringUtils::secureString($_GET['backaction']);
else $back = 'hodnoceni';

?>
<h1><?= ronText('Hodnoceni_osoby') ?></h1>

<?php MessageManager::getInstance() ->showMessages() ?>

<div class="form form-30-70 middle-form hlavickahodnoceni">
    <div class="form-content">
        <?php if ($this->fHodnocenyPrijmeni || $this->fHodnocenyJmeno) { ?>
            <div class="row">
                <div class="form-col form-col1"><?= ronText('Hodnoceny') ?></div>
                <div class="form-col form-col2 required"><?= StringUtils::htmlTextConvert($this->fHodnocenyJmeno .' ' . $this->fHodnocenyPrijmeni) ?></div>
            </div>
        <?php } ?>
        <?php if ($this->fPocatekObdobi || $this->fKonecObdobi) { ?>
            <div class="row">
                <div class="form-col form-col1"><?= ronText('Hodnocene_obdobi') ?></div>
                <div class="form-col form-col2"><?= StringUtils::format('date', $this->fPocatekObdobi) ?> - <?= StringUtils::format('date', $this->fKonecObdobi) ?></div>
            </div>
        <?php } ?>

        <div class="row">
            <div class="form-col form-col1"><?= ronText('Stav_hodnoceni') ?></div>
            <div class="form-col form-col2">
                <?php
                switch ($this->fStav) {
                    case 0 :
                        echo $STR_H_0 ?: ronText('Stav_hodnoceni_0');
                        break;
                    case 1 :
                        echo $STR_H_1 ?: ronText('Stav_hodnoceni_1');
                        break;
                    case 2 :
                        echo $STR_H_2 ?: ronText('Stav_hodnoceni_2');
                        break;
                    case 3 :
                        echo $STR_H_3 ?: ronText('Stav_hodnoceni_3');
                        break;
                    case 4 :
                        echo $STR_H_4 ?: ronText('Stav_hodnoceni_4');
                        break;
                    case 5 :
                        echo $STR_H_5 ?: ronText('Stav_hodnoceni_5');
                        break;
                }

                if (App::getDebugMode()) echo ' (DEBUG> stav = ' . $this->fStav . ')';
                ?>
            </div>
        </div>

        <?php if ($this->fHodnotici || $this->fHodnoticiPrijmeni || $this->fHodnoticiJmeno) { ?>
            <div class="row">
                <div class="form-col form-col1"><?= ronText('Hodnotil') ?></div>
                <div class="form-col form-col2">
                    <?= StringUtils::htmlTextConvert($this->fHodnoticiJmeno . ' ' . $this->fHodnoticiPrijmeni) ?>
                    <?php if ($this->fHodnotici) echo ' ('. StringUtils::htmlTextConvert($this->fHodnotici) . ')'; ?>
                </div>
            </div>
        <?php } ?>

        <?php if ($this->fDatumHodnoceni) { ?>
            <div class="row">
                <div class="form-col form-col1"><?= ronText('Datum_hodnoceni') ?></div>
                <div class="form-col form-col2"><?= StringUtils::format('datetime', $this->fDatumHodnoceni) ?></div>
            </div>
        <?php } ?>

        <!-- seznam hodnotitelu -->
        <div class="row">
            <div class="form-col">
                <?= ronText('Hodnotili') ?>:
                <?php $prvni = true; foreach ($this ->hodnotitele as $hodnotitel) { ?>
                    <?= $prvni ? '' : ', ' ?>

                    <?php if ($hodnotitel ->id == $this ->fId) { ?>
                        <span class="aktualnihodnoceni">
                    <?php } else { ?>
                        <a href="?menuid=hodnoceni&record=<?= $hodnotitel ->id ?>">
                    <?php } ?>

                    <?php if ($hodnotitel ->hodnotici) { ?>
                        <?= StringUtils::htmlTextConvert($hodnotitel ->hodnotici) ?>
                    <?php } else { ?>
                        <?= ronText('Ceka_na_hodnoceni') ?> (<?= $hodnotitel ->urovenPredavani ?>)
                    <?php } ?>

                    <?php if ($hodnotitel ->id != $this ->fId) { ?>
                        </a>
                    <?php } else { ?>
                        </span>
                    <?php } ?>

                    <?php if ($hodnotitel ->hodnotici  &&  RonPortalSettings::getIntValue(RonPortalSettings::ZOBRAZIT_VYSLEDKY_HODNOCENI)) { ?>
                        <span class="hodnocenivysledek">

                        <?php if (RonPortalSettings::getIntValue(RonPortalSettings::ZOBRAZIT_VYSLEDKY_HODNOCENI) & 1) { // znamka nebo oboji ?>
                            <?= StringUtils::format('number_2', $hodnotitel ->znamka) ?>
                        <?php } ?>
                        <?= ( RonPortalSettings::getIntValue(RonPortalSettings::ZOBRAZIT_VYSLEDKY_HODNOCENI) == 3) ? '/' : '' ?>
                        <?php if ( RonPortalSettings::getIntValue(RonPortalSettings::ZOBRAZIT_VYSLEDKY_HODNOCENI) & 2 ) { // koeficient nebo oboji ?>
                            <?= StringUtils::format('number_2', $hodnotitel ->koeficient) ?>
                        <?php } ?>

                        </span>
                    <?php } ?>

                <?php
                    $prvni = false;
                }
                ?>

            </div>
        </div>

        <div class="row">
            <div class="form-col form-col1"><?= ronText('Detail_vysledku') ?></div>
            <div class="form-col form-col2"><?= StringUtils::htmlTextConvert($this->detailVysledku) ?></div>
        </div>

    </div>
    <div class="buttons">
        <a href="?menuid=<?= $back ?>"><?= ronText('Zpet_na_seznam_hodnoceni') ?></a>
    </div>
</div>


