<?php
/**
 * stanislav.elbl, 16.11.2015, pavel.rudol, 8.11.2017
 * Hlavicka hodnoceni (obdobi, ...)
 */

namespace Ron\Personalistika;

use Ron\Http\App;
use Ron\MessageManager;
use Ron\StringUtils;
use function Ron\ronText;

global $STR_H_0; // kompat.
global $STR_H_1;
global $STR_H_2;
global $STR_H_3;
global $STR_H_4;
global $STR_H_5;

/** @var $this HodnoceniSkoleni */

if ($_POST['backaction']) $back = StringUtils::secureString($_POST['backaction']);
else if ($_GET['backaction']) $back = StringUtils::secureString($_GET['backaction']);
else $back = 'skoleni';

$nadpis = '';

switch ($this->typGenerovaniHodnoceni) {
    case 1 : //ucastnik dle typu rozdeleni
    case 2 : //ucastnik zvolenou osobou
        $nadpis = ronText('Skoleni_Hodnoceni_Ucastnika');
        break;
    case 3 : //skoleni ucastnikem
        $nadpis = ronText('Skoleni_Hodnoceni');
        break;
}
?>

<h1><?= $nadpis ?></h1>

<?php MessageManager::getInstance() ->showMessages() ?>

<table class='infotable hlavickahodnoceni'>
    <tbody>

    <tr>
        <td><?= ronText('Skoleni') ?></td>
        <td><strong><?= StringUtils::htmlTextConvert($this->nazevSkoleni) ?></strong></td>
    </tr>
    <tr>
        <td><?= ronText('Skoleni_DatumZacatku'); ?></td>
        <td><?= StringUtils::format('datetime', $this->zacatekSkoleni) ?></td>
    </tr>
    <tr>
        <td><?= ronText('Skoleni_DatumUkonceni'); ?></td>
        <td><?= StringUtils::format('datetime', $this->konecSkoleni) ?></td>
    </tr>

    <?php if ($this->fHodnocenyPrijmeni || $this->fHodnocenyJmeno) { ?>
        <tr>
            <td><?= $this->typGenerovaniHodnoceni == 3 ? ronText('hodnotici') : ronText('Hodnoceny') ?></td>
            <td><strong><?= StringUtils::htmlTextConvert($this->fHodnocenyJmeno .' ' . $this->fHodnocenyPrijmeni) ?></strong></td>
        </tr>
    <?php } ?>

    <?php if ($this->fPocatekObdobi || $this->fKonecObdobi) { ?>
        <tr>
            <td><?= ronText('Hodnocene_obdobi') ?></td>
            <td><?= StringUtils::format('date', $this->fPocatekObdobi) ?> - <?= StringUtils::format('date', $this->fKonecObdobi) ?></td>
        </tr>
    <?php } ?>

    <tr>
        <td><?= ronText('Stav_hodnoceni') ?></td>
        <td>
            <?php
            switch ($this->fStav) {
                case 0 :
                    echo $STR_H_0 ?: ronText('Stav_hodnoceni_0');
                    break;
                case 1 :
                    echo $STR_H_1 ?: ronText('Stav_hodnoceni_1');
                    break;
                case 2 :
                    echo $STR_H_2 ?: ronText('Stav_hodnoceni_2');
                    break;
                case 3 :
                    echo $STR_H_3 ?: ronText('Stav_hodnoceni_3');
                    break;
                case 4 :
                    echo $STR_H_4 ?: ronText('Stav_hodnoceni_4');
                    break;
                case 5 :
                    echo $STR_H_5 ?: ronText('Stav_hodnoceni_5');
                    break;
            }

            if (App::getDebugMode()) echo ' (DEBUG> stav = ' . $this->fStav . ')';
            ?>
        </td>
    </tr>

    <?php if ($this->fHodnotici || $this->fHodnoticiPrijmeni || $this->fHodnoticiJmeno) { ?>
        <tr>
            <td><?= ronText('Hodnotil') ?></td>
            <td>
                <?= StringUtils::htmlTextConvert($this->fHodnoticiJmeno . ' ' . $this->fHodnoticiPrijmeni) ?>
                <?php if ($this->fHodnotici) echo ' ('. StringUtils::htmlTextConvert($this->fHodnotici) . ')'; ?>
            </td>
        </tr>
    <?php } ?>

    <?php if ($this->fDatumHodnoceni) { ?>
        <tr>
            <td><?= ronText('Datum_hodnoceni') ?></td>
            <td><?= StringUtils::format('datetime', $this->fDatumHodnoceni) ?></td>
        </tr>
    <?php } ?>

    </tbody>
</table>

<div class="text_link">
    <a href="?menuid=<?= $back ?>"><?= ronText('Zpet_na_seznam_hodnoceni') ?></a>
</div>

