<?php
/** Roman.Szablatura 26.01.2016 */

namespace Ron\Personalistika;

use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\RonPortal\PravaNaOsoby;
use Ron\RonPortal\RonPortalSettings;
use Ron\RonPortal\User;
use Ron\StringUtils;

/* @var Uchazec $uchazec */
$uchazec = Model::getInstance()->getData('uchazec');

/* @var PravaNaOsoby $pravaKomunikace */
$pravaKomunikace = Model::getInstance()->getData('pravaKomunikace');
?>

<h1><?= \Ron\ronText('Uchazec') ?></h1>
<a href="?menuid=uchazeci&"><?= \Ron\ronText('Zpet_na_seznam') ?></a>


<?php MessageManager::getInstance() ->showMessages() ?>

<table class='infotable minwidth'>
    <tbody>
        <tr id="hlavickauchazece_signatura">
            <td colspan="3">
                <?= StringUtils::htmlTextConvert($uchazec ->titul) ?>
                <strong><?= StringUtils::htmlTextConvert($uchazec ->jmeno)?></strong>
                <strong><?= StringUtils::htmlTextConvert($uchazec ->prijmeni) ?></strong>
                <?= StringUtils::htmlTextConvert($uchazec ->titulza) ?>
            </td>
            <td>
                <!--
                    <div id="detailuchazece_foto_full" >
                        <img src="?menuid=uchazeci&action=downloadfoto&record=<?= $uchazec->rc ?>" alt="foto_uchazec" >
                    </div>
                -->
                <div id="<?= $uchazec->idFotografie ? 'detailuchazece_foto' : 'detailuchazece_noFoto'?>">
                    <?php if ($uchazec->idFotografie) { ?>
                        <img src="?menuid=uchazeci&action=downloadfoto&record=<?= $uchazec->rc ?>" alt="foto_uchazec" >
                    <?php }  ?>
                </div>
            </td>
        </tr>
    </tbody>


    <tbody id="detaily">
        <tr id="hlavickauchazece_detaily" class="inputtablesection">
            <td colspan="4"><strong><?= \Ron\ronText('Detaily') ?></strong></td>
        </tr>

        <tr >
            <td class="formtablecaption"><?= \Ron\ronText('Email')?></td>
            <td colspan="3">
                <a href="mailto:<?= StringUtils::htmlTextConvert($uchazec->email) ?>?subject=<?= \Ron\ronText('Zprava_od_personalisty')?>&body=<?= \Ron\ronText('Vazeny_uchazeci')?>,%0A%08%0A%0A%08%0A<?= \Ron\ronText('S_pozdravem')?>,"><?= StringUtils::htmlTextConvert($uchazec->email) ?></a>
            </td>
        </tr>

        <tr>
            <td class="formtablecaption"><?= \Ron\ronText('Mobil')?></td>
            <td colspan="3"><?= StringUtils::htmlTextConvert($uchazec->mobil) ?></td>
        </tr>

        <tr>
            <td class="formtablecaption"><?= \Ron\ronText('Telefon1')?></td>
            <td colspan="3"><?= StringUtils::htmlTextConvert($uchazec->telefon1) ?></td>
        </tr>

        <tr>
            <td class="formtablecaption"><?= \Ron\ronText('Telefon2')?></td>
            <td colspan="3"><?= StringUtils::htmlTextConvert($uchazec->telefon2) ?></td>
        </tr>

        <tr>
            <td class="formtablecaption"><?= \Ron\ronText('Poznamka')?></td>
            <td colspan="3"><?= StringUtils::htmlTextConvert($uchazec->poznamka) ?></td>
        </tr>
        <tr>
            <td class="formtablecaption"><?= \Ron\ronText('zdrojVzniku')?></td>
            <td colspan="3"><?= StringUtils::htmlTextConvert($uchazec->zdrojVzniku/* ? $uchazec->zdrojVzniku : ''*/) ?></td>
        </tr>

        <?php for ($i = 1; $i <= 10; $i++) {
            if (RonPortalSettings::getValue('uchazeciuzivatelska'.$i) !== '') { ?>
                <tr>
                    <td class="formtablecaption"><?= RonPortalSettings::getValue('uchazeciuzivatelska'.$i)  ?></td>
                    <td><?= StringUtils::htmlTextConvert($uchazec->uzivatelskaPole[$i]) ?></td>
                    <td class="formtablecaption"><?= RonPortalSettings::getValue('uchazeciuzivatelska'.($i+10))  ?></td>
                    <td><?= StringUtils::htmlTextConvert($uchazec->uzivatelskaPole[$i+10]) ?></td>
                </tr>
        <?php }} ?>
    </tbody>


    <?php if(!empty($uchazec->rozdeleni)) {?>
    <tbody id="rozdeleni">
        <tr id="detailuchazece_rozdeleni" class="inputtablesection">
            <td colspan="4"><strong><?= \Ron\ronText('Rozdeleni') ?></strong></td>
        </tr>
        <?php $typRozdeleni = '' ?>
        <?php foreach ($uchazec->rozdeleni as $rozdeleniUchazece) { ?>
            <tr>
                <td class="formtablecaption">
                    <?= ($typRozdeleni !== $rozdeleniUchazece->typRozdeleni) ?  StringUtils::htmlTextConvert($rozdeleniUchazece->typRozdeleni) : '' ?></td>
                    <td colspan="3"><?= StringUtils::htmlTextConvert($rozdeleniUchazece->kodRozdeleni) ?>
                    <?= ' - ' . StringUtils::htmlTextConvert($rozdeleniUchazece->popisRozdeleni) ?></td>
                <?php $typRozdeleni = $rozdeleniUchazece->typRozdeleni;  ?>
            </tr>
        <?php }?>
    <?php }?>
    </tbody>


    <tbody id="vzdelani">
        <tr id="hlavickauchazece_vzdelani" class="inputtablesection">
            <td colspan="4"><strong><?= \Ron\ronText('Vzdelani') ?></strong></td>
        </tr>
        <?php foreach ($uchazec->vzdelani as $vzdelaniUchazece) { ?>
            <tr>
                <td class="formtablecaption"><?= StringUtils::format('year',$vzdelaniUchazece->skolaOd)?>
                <?= ' - ', StringUtils::format('year',$vzdelaniUchazece->skolaDo)?></td>
                <td colspan="3"><?= StringUtils::htmlTextConvert($vzdelaniUchazece->popisUrovneVzdelani) ?></td>
            </tr>

            <tr>
                <td class="formtablecaption"></td>
                <td colspan="3"><?= StringUtils::htmlTextConvert($vzdelaniUchazece->oborVzdelani)  ?></td>
            </tr>

            <tr>
                <td class="formtablecaption"></td>
                <td colspan="3"><?= StringUtils::htmlTextConvert($vzdelaniUchazece->nazevSkoly) ?></td>
            </tr>
        <?php } ?>
    </tbody>



    <?php   if(!empty($uchazec->dovednosti)) { ?>
    <tbody id="dovednosti">
            <tr id="hlavickauchazece_schopnosti" class="inputtablesection">
                <td colspan="4"><strong><?= \Ron\ronText('Schopnosti') ?></strong></td>
            </tr>

            <?php foreach ($uchazec->dovednosti as $dovednostiUchazece) { ?>
                <tr>
                    <td class="formtablecaption"><?= StringUtils::format('year',$dovednostiUchazece->datumZiskani)?>
                    <td colspan="3"><?= StringUtils::htmlTextConvert($dovednostiUchazece->popisDovednosti) ?>
                    <?= ' - ', StringUtils::htmlTextConvert($dovednostiUchazece->urovenDovednosti)  ?></td>
                </tr>
            <?php } ?>
    <?php } ?>
    </tbody>


    <?php   if(!empty($uchazec->dokumenty)) { ?>
    <tbody id="dokumenty">
            <tr id="hlavickauchazece_dokumenty" class="inputtablesection">
                <td colspan="4"><strong><?= \Ron\ronText('Dokumenty') ?></strong></td>
            </tr>

            <?php foreach ($uchazec->dokumenty as $dokumentyUchazece) { ?>
                <tr>
                    <td class="formtablecaption"><?= StringUtils::format('year',$dokumentyUchazece->datumVlozeniDokumentu)?></td>
                    <td colspan="3"><?= StringUtils::htmlTextConvert($dokumentyUchazece->popisDokumentu) ?></td>
                </tr>

                <tr>
                    <td class="formtablecaption"></td>
                    <td colspan="3"><a href="?menuid=uchazeci&action=download&record=<?= $uchazec->rc ?>&dokument=<?= $dokumentyUchazece->idDokumentu ?>">
                            <?= StringUtils::htmlTextConvert($dokumentyUchazece->nazevDokumentu) ?></a></td>
                </tr>
            <?php } ?>
    <?php } ?>
    </tbody>

    <tbody id="komunikace">
        <tr id="hlavickauchazece_komunikace" class="inputtablesection">
            <td colspan="4"><strong><?= \Ron\ronText('Komunikace') ?></strong></td>
        </tr>

        <?php foreach ($uchazec->komunikace as $komunikaceUchazece) { ?>
            <tr>
                <td class="formtablecaption"><strong><?= StringUtils::format('finedatetime',$komunikaceUchazece->datumACasKomunikace)?></strong></td>
                <td><strong><?= StringUtils::htmlTextConvert($komunikaceUchazece->personalistaJmeno) ?>
                        <?= StringUtils::htmlTextConvert($komunikaceUchazece->personalistaPrijmeni) ?></strong>
                </td>
                <td colspan="2" class="align-right">
                    <?php if ($pravaKomunikace->jsouNejakePrava() && ($komunikaceUchazece->personalistaRC == User::getRC())){?>
                        <a href="?menuid=uchazeci&action=komunikace&formaction=edit&record=<?= $komunikaceUchazece->idKomunikace ?>"><?= \Ron\ronText('Editace_komunikace_s_uchazecem')?></a>
                    <?php } ?>
                </td>
            </tr>
            <tr>
                <td class="formtablecaption"><?= \Ron\ronText('Druh_a_obsah_sdeleni')?></td>
                <td colspan="3"><?= $komunikaceUchazece->druhSdeleni ? StringUtils::htmlTextConvert($komunikaceUchazece->druhSdeleni) . ' - '  : '' ?>
                    <?= StringUtils::htmlTextConvert($komunikaceUchazece->obsahSdeleni) ?>
                </td>
            </tr>

            <tr>
                <td class="formtablecaption"><?= \Ron\ronText('Odpoved_uchazece')?></td>
                <td colspan="3"><?= StringUtils::htmlTextConvert($komunikaceUchazece->odpoved) ?></td>
            </tr>
            <tr>
                <td colspan="4"><p></p></td>
            </tr>
        <?php } ?>
        <tr>
            <td></td>
            <td colspan="3" >
                <?php if ($pravaKomunikace->jsouNejakePrava()) {?>
                    <a href="?menuid=uchazeci&action=komunikace&formaction=new&uchazec=<?= StringUtils::htmlTextConvert($uchazec->rc) ?>"><?= \Ron\ronText('Zaznamenat_komunikaci_s_uchazecem')?></a>
                <?php } ?>
            </td>
        </tr>
    </tbody>

</table>

    <table>
        <tr >
            <td><a href="?menuid=uchazeci&"><?= \Ron\ronText('Zpet_na_seznam') ?></a></td>
        </tr>
    </table>

<script>
    personalistika.zobrazFoto($('#detailuchazece_foto').find('img'));
</script>
