<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 15.6.2018
 */


namespace Ron\RonPortal;

use Ron\Controls\ComboBox;
use Ron\MessageManager;
use Ron\MVC\Model;
use function Ron\ronText;

$model = Model::getInstance();

/** @var PracovniPomer $pp */
$pp = $model->getData('pp');

$nadpis = $model->getData('nadpis');
/** @var PlanovaneSkoleniObjekt $nactenyPost */
$nactenyPost = $model->getData('nactenyPost');
$nakladovePolozky = $model->getData('nakladovePolozky');
$comboTypuSkoleni = $model->getData('comboTypuSkoleni');
$comboStavuSkoleni = $model->getData('comboStavuSkoleni');
$comboNakladuSkoleni = $model->getData('comboNakladuSkoleni');
$comboFirmaSkoleni = $model->getData('comboFirmaSkoleni');
/** @var PlanovaneSkoleniObjekt $detailPlanovanehoSkoleni */
$detailPlanovanehoSkoleni = $model->getData('detailPlanovanehoSkoleni');

if ($nactenyPost != "") {
    $hodnoty = $nactenyPost;
} else {
    $hodnoty = $detailPlanovanehoSkoleni;
}

MessageManager::getInstance()->showMessages();
?>



<h1><?= $nadpis ?></h1>

<form enctype="multipart/form-data" name="zadaniNovehoPlanu" method="post" action="?menuid=skoleni&action=zapisskoleni">
    <input type="hidden" name="osoba" value="<?= $pp->idPP ?>">
    <input type="hidden" name="cisloSkoleni" value="<?= $hodnoty ? $hodnoty->cisloSkoleni : '' ?>">

    <div class='form large-form maxwidth'>

        <div class="form-content">

            <div class="row form-section">
                <div class="col col-12 col-sm-3"><?= ronText("zakladni_udaje") ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><strong><?= ronText("kod") ?></strong></div>
                <div class="col col-12 col-sm-10">
                    <input type="text"
                           class="planovani_input nonempty"
                           name="cisloSkoleni" <?= ($hodnoty->cisloSkoleni != "" ? "disabled" : "") ?>
                           title="<?= ronText("kod") ?>"
                           value="<?= $hodnoty->cisloSkoleni ?>">
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><strong><?= ronText("popis") ?></strong></div>
                <div class="col col-12 col-sm-10">
                    <input type="text"
                           class="adsfilterforminput_full nonempty"
                           name="popis"
                           title="Popis"
                           value="<?= \Ron\StringUtils::htmlTextConvert($hodnoty->popis) ?>">
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><strong><?= ronText("typ_skoleni") ?></strong></div>
                <div class="col col-12 col-sm-10" >
                    <?php
                    /** @var ComboBox $comboTypuSkoleni  */
                    $comboTypuSkoleni->render();
                    ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><strong><?= ronText("stav_skoleni") ?></strong></div>
                <div class="col col-12 col-sm-10">
                    <?php
                    /** @var ComboBox $comboTypuSkoleni  */
                    $comboStavuSkoleni->render();
                    ?>
                </div>
            </div>


            <div><div>&nbsp;</div></div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><strong><?= ronText("realizace_od") ?></strong></div>
                <div class="col col-12 col-sm-10" title="Realizace od">
                    <?php
                    $datumPocatkuSkoleni = $hodnoty->datumPocatkuSkoleni != "" ? date("j.n.Y", $hodnoty->datumPocatkuSkoleni) : "";
                    echo "<input type='text' class='inputDate nonempty' size='10' maxlength='10' name='datumPocatkuSkoleni' title='" . ronText("realizace_od") . "' value='$datumPocatkuSkoleni'>";
                    echo "<img src='images/16_calendar.png' class='showcalendar' data-roncalendar-inputname='datumPocatkuSkoleni' />";
                    ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><?= ronText("cas_realizace_od") ?></div>
                <div class="col col-12 col-sm-2">
                    <input type="text"
                           class="planovani_input"
                           min="0"
                           placeholder="hh:mm"
                           name="casPocatkuSkoleni"
                           title="<?= ronText("cas_realizace_od") ?>"
                           value="<?= $hodnoty->casPocatkuSkoleni != "" ? date("G:i", $hodnoty->casPocatkuSkoleni) : "" ?>">
                </div>

                <div class="col col-12 col-sm-2 caption"><?= ronText("cas_realizace_do") ?></div>
                <div class="col col-12 col-sm-2">
                    <input type="text" class="planovani_input"
                           min="0"
                           placeholder="hh:mm"
                           name="casUkonceniSkoleni"
                           title="<?= ronText("cas_realizace_do") ?>"
                           value="<?= $hodnoty->casUkonceniSkoleni != "" ? date("G:i", $hodnoty->casUkonceniSkoleni) : "" ?>">
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><?= ronText("realizace_do") ?></div>
                <div class="col col-12 col-sm-10" title="Realizace do">
                    <?php
                    $datumUkonceniSkoleni = $hodnoty->datumUkonceniSkoleni != "" ? date("j.n.Y", $hodnoty->datumUkonceniSkoleni) : "";
                    echo "<input type='text' class='inputDate' size='10' maxlength='10' name='datumUkonceniSkoleni' title='' value='$datumUkonceniSkoleni'>";
                    echo "<img src='images/16_calendar.png' class='showcalendar' data-roncalendar-inputname='datumUkonceniSkoleni' />";
                    ?>
                </div>
            </div>


            <div class="row"><div>&nbsp;</div></div>


            <div class="row">
                <div class="col col-12 col-sm-2 caption"><?= ronText("delka_skoleni_dnu") ?></div>
                <div class="col col-12 col-sm-10">
                    <input type="number"
                           class="planovani_input"
                           min="0"
                           name="delkaSkoleniDnu"
                           title=""
                           value="<?= $hodnoty->delkaSkoleniDnu ?>">
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><?= ronText("delka_skoleni_hodin") ?></div>
                <div class="col col-12 col-sm-10">
                    <input type="number"
                           class="planovani_input"
                           min="0"
                           name="delkaSkoleniHodin"
                           title="" value="<?= $hodnoty->delkaSkoleniHodin ?>">
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><strong><?= ronText("pocet_ucastniku") ?></strong></div>
                <div class="col col-12 col-sm-10">
                    <input type="number"
                           class="planovani_input nonempty"
                           min="0"
                           name="pocetOsob"
                           title="<?= ronText('pocet_ucastniku') ?>"
                           value="<?= ($hodnoty->pocetOsob == null ? 1 : $hodnoty->pocetOsob) ?>">
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><?= ronText("poznamka") ?></div>
                <div class="col col-12 col-sm-10">
                    <textarea name="poznamka"
                              class="adsfilterforminput_full"
                              title="<?= ronText("poznamka") ?>"
                    ><?= ($hodnoty->poznamka != "" ? $hodnoty->poznamka : "") ?></textarea>
                </div>
            </div>

            <div class="row"><div>&nbsp;</div></div>


            <div class="row form-section">
                <div class="col col-12 col-sm-3"><?= ronText("realizuje_firma") ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-2 caption"><?= ronText("realizuje_firma") ?></div>
                <div class="col col-12 col-sm-10" title="<?= ronText('typ_skoleni')?>">
                    <?php
                    /** @var ComboBox $comboTypuSkoleni  */
                    //                        $comboFirmaSkoleni->render();
                    $poleFirma = $hodnoty->firma == "" ? ronText("nacitani_firem") : ronText("nacitani_firem");
                    ?>
                    <input name='firma2' class='adsfilterforminput_full selectFirmy' value='<?= $poleFirma ?>'/>
                    <input type='hidden' name='firma' value='<?= $hodnoty->firma ?>'/>
                    <i class="fa fa-spin glyph-spinner margin-left" id='loadingSpinnerFirma'></i>

                </div>
            </div>
        </div>

        <div class="row"><div>&nbsp;</div></div>

        <div class="buttons">
            <input type="button" class="submitbutton" id="back_url_planovani_skoleni" value="<?= ronText('Zpet')?>">
            <input type="reset" class="submitbutton" value="<?= ronText('form.Original')?>">
            <button type="submit" class="submitbutton" name="upravaplanovanehoskoleni" value="1"><?= ronText('form.Store')?></button>
        </div>

    </div>
</form>

<form enctype="multipart/form-data" name="pripojeniNakladuPlanovanehoSkoleni" method="post" action="?menuid=skoleni&action=detailplanovanehoskolenikurzu&record=<?= $hodnoty->cisloSkoleni?>">
    <input type="hidden" name="osoba" value="<?= $pp->idPP ?>">
    <input type="hidden" name="cisloSkoleni" value="<?= $hodnoty->cisloSkoleni ?>">
    <input type="hidden" name="stav" value="<?= $hodnoty->stav ?>">

    <div class='form large-form maxwidth'>

        <div class="form-content">

            <div class="row form-section">
                <div><?= ronText("cena_planovaneho") ?></div>
            </div>

            <?php if ($hodnoty->cisloSkoleni == "") { ?>
                <div class="row">
                    <div class="col col-12 col-sm-2 caption"><strong><?= ronText("informace") ?></strong></div>
                    <div class="col col-12 col-sm-10">
                        <strong><?= ronText("cena_po_planovani") ?></strong>
                    </div>
                </div>
            <?php } ?>


            <?php if ($hodnoty->cisloSkoleni != "") { ?>

                <?php if (!empty($nakladovePolozky)) { ?>
                    <div class="row">
                        <div class="col col-12 col-sm-2 caption"><strong><?= ronText('typ_polozky') ?></strong></div>
                        <div class="col col-12 col-sm-2 pole_nakladu_popisek" ><?= ronText('cena_bez_dph') ?></div>
                        <div class="col col-12 col-sm-2 pole_nakladu_popisek" ><?= ronText('sazba_dph') ?></div>
                        <div class="col col-12 col-sm-2 pole_nakladu_popisek" ><?= ronText('dph') ?></div>
                        <div class="col col-12 col-sm-2 pole_nakladu_popisek" ><?= ronText('cena_s_dph') ?></div>
                    </div>
                <?php } ?>

                <?php $cnt = 0; foreach ($nakladovePolozky as $polozka) { ?>

                    <div class="row">
                        <div class="col col-12 col-sm-2 caption"><strong><?= $polozka['popis'] ?></strong></div>

                        <div class="col col-12 col-sm-2" >
                            <input type="number" name="<?= "polozka" . $cnt ?>_cenaBezDPH" class="pole_cena" size="5" min="0" data-ron-sazba="<?= $polozka['sazbaDPH'] ?>" data-ron-polozka="<?= $polozka['typPolozky'] ?>" title="Cena bez DPH" value="<?= $polozka['cenaBezDPH'] ?>">
                            <input type="hidden" name="<?= "polozka" . $cnt ?>_sazbaDPH" value="<?= $polozka['sazbaDPH'] ?>">
                            <input type="hidden" name="<?= "polozka" . $cnt ?>_nakladovaPolozka" value="<?= $polozka['typPolozky'] ?>">
                            <input type="hidden" name="<?= "polozka" . $cnt ?>_cenaSDPH" value="<?= $polozka['cenaSDPH'] ?>">
                        </div>

                        <div class="col col-12 col-sm-2 pole_nakladu" >
                            <input type="text" class="pole_dph" name="<?= "polozka" . $cnt ?>_sazbaDPH" id="sazbaDPH_<?= $cnt . "_" . $polozka['typPolozky'] ?>" data-ron-polozka="<?= $polozka['typPolozky'] ?>" title="Sazba" disabled value="<?= $polozka['sazbaDPH'] ?>">
                        </div>

                        <div class="col col-12 col-sm-2 pole_nakladu" >
                            <input type="text" class="pole_dph" name="<?= "polozka" . $cnt ?>_DPH" id="<?= $cnt . "_" . $polozka['typPolozky'] ?>_DPH" data-ron-polozka="<?= $polozka['typPolozky'] ?>" title="DPH" disabled value="<?= number_format($polozka['DPH'], 2) ?>">
                        </div>

                        <div class="col col-12 col-sm-2 pole_nakladu" >
                            <input type="text" class="pole_dph" name="<?= "polozka" . $cnt ?>_cenaSDPH" id="<?= $cnt . "_" . $polozka['typPolozky'] ?>_cenaSDPH" data-ron-polozka="<?= $polozka['typPolozky'] ?>" title="Cena s DPH" disabled value="<?= number_format($polozka['cenaSDPH'], 2) ?>">
                        </div>


                    </div>

                    <?php $cnt++; } $cnt--; ?>
                <input type="hidden" name="pocet_polozek" value="<?= $cnt ?>">

                <div><div>&nbsp;</div></div>

                <div class="buttons">
                    <div class="col col-12 col-sm-10 pole_nakladu" ></div>
                    <div class="col col-12 col-sm-2 pole_nakladu" >
                        <button type="submit" class="submitbutton" name="nakladyplanovanehoskoleni" value="1" ><?= ronText('form.Store')?></button>
                    </div>
                </div>

                <div class="row form-section">
                    <div><?= ronText("cena_planovaneho") ?></div>
                </div>

                <?php if (!empty($comboNakladuSkoleni)) { ?>
                    <div><div>&nbsp;</div></div>

                    <div class="row">
                        <div class="col col-12 col-sm-2 caption"><?= ronText("pripojit_naklady_planovaneho") ?></div>
                        <div class="col col-12 col-sm-8">
                            <select class="adsfilterforminput_full" title="<?= ronText('')?>" name="pridatTypPolozky" >
                                <?php foreach ($comboNakladuSkoleni as $polozkaNakladu => $item) {  ?>
                                    <option value="<?= $item['kod'] ?>;;<?= $item['sazbaDPH'] ?>" ><?=$item['popis']?></option>
                                <?php } ?>
                            </select>
                        </div>
                    </div>

                    <div class="buttons">
                        <div class="col col-12 col-sm-2">
                            <button type="submit" class="submitbutton" name="novenakladyplanovanehoskoleni" value="1"><?= ronText('form.Store')?></button>
                        </div>

                    </div>
                <?php } ?>
            <?php } ?>

        </div>

    </div>
</form>
