<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 13.05.2019
 */

namespace Ron\RonPortal;


use Ron\Controls\ComboBox;
use Ron\MVC\Model;
use Ron\MessageManager;

$model = Model::getInstance();

/** @var ComboBox $combo_typ_skoleni */
$combo_typ_skoleni = $model->getData('combo_typ_skoleni');

/** @var ComboBox $combo_kurz */
$combo_kurz = $model->getData('combo_kurz');

/** @var ComboBoxZamestnanec $comboOsoby */
$comboOsoby = $model->getData('comboOsoby');

$kurz = $model->getData('kurz');
$naplnenostKurzu = $model->getData('naplnenostKurzu');

MessageManager::getInstance()->showMessages();

?>



<form enctype="multipart/form-data"  method="post" name="formularvyslaninaskoleni" action="?menuid=skoleni">

    <input type="hidden" name="typ_navrhu" value="1">
    <input type="hidden" name="volnych_mist" value="<?= $naplnenostKurzu[2] ?>">

    <div class='form large-form'>
        <div class="form-content">

            <div class="row">
                <div class="col col-12 col-md-3 caption required"><?= \Ron\ronText('Skoleni_typ_navrhu') ?></div>
                <div class="col col-12 col-md-9 required">
                    <?= \RON\ronText('skoleni_typ_navrhu_potvrzeno') ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-3 caption required"><?= \Ron\ronText('skoleni_osoba_na_skoleni') ?></div>
                <div class="col col-12 col-md-9 ">
                    <?= $comboOsoby->render();?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-3 caption required"><?= \Ron\ronText('Skoleni_typ_skoleni') ?></div>
                <div class="col col-12 col-md-9 ">
                    <?= $combo_typ_skoleni->render() ?>
                </div>
            </div>

            <?php if(!empty($combo_kurz->data)) { ?>
                <div class="row">
                    <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('Skoleni_kurz') ?></div>
                    <div class="col col-12 col-md-9">
                        <?= $combo_kurz->render() ?>
                    </div>
                </div>
            <?php } ?>


            <?php if($kurz != '' || !empty($combo_kurz->data)) { ?>
                <div class="row">
                    <div class="col col-12 col-md-3 caption "><?= \Ron\ronText('Skoleni_kapacita') ?></div>
                    <div class="col col-12 col-md-9 required">
                        <?= $naplnenostKurzu[0] ?>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-3 caption "><?= \Ron\ronText('Skoleni_prihlasenych_kurz') ?></div>
                    <div class="col col-12 col-md-9 required">
                        <?= $naplnenostKurzu[1] ?>
                    </div>
                </div>
            <?php } ?>


            <?php if($naplnenostKurzu  &&  $naplnenostKurzu[0] == $naplnenostKurzu[1] && !empty($naplnenostKurzu[0])) { ?>
                <div class="row">
                    <div class="col col-12 col-md-3 caption"><?= \Ron\ronText('') ?></div>
                    <div class="col col-12 col-md-9 app_input_error">
                        <?= \RON\ronText('Skoleni_kurz_vycerpan')?>
                    </div>
                </div>
            <?php } ?>



            <?php if($naplnenostKurzu[2] != 0 || $_GET['kurz'] == '') { ?>

                <div class="row">
                    <div class="col col-12 col-md-3 caption required"><?= \Ron\ronText('Skoleni_pozadovane_datum_skoleni') ?></div>
                    <div class="col col-12 col-md-9">
                        <label>
                            <?php
                                echo "<input type='text' class='inputDate nonempty' size='10' maxlength='10' name='pozadovanedatumskoleni' title='" . \Ron\ronText('Skoleni_pozadovane_datum_skoleni') . "' value=''>";
                                echo "<i class='showcalendar inline-glyph glyph-button fa glyph-calendar' data-roncalendar-inputname='pozadovanedatumskoleni'></i>";
                            ?>
                        </label>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-12 col-md-3 caption "><?= \Ron\ronText('Skoleni_popis_skoleni') ?></div>
                    <div class="col col-12 col-md-9 ">
                        <label>
                            <input class="app_input" name="popis_skoleni" value="">
                        </label>
                    </div>
                </div>

                <?php if(isset($_GET['druhskoleni'])  && $_GET['druhskoleni'] != '') { ?>
                    <?php if(RonPortalSettings::getIntValue('skoleni_typ_dokumentu') != '') { ?>
                         <div class="row">
                            <div class="col col-12 col-md-3 caption "><?= \Ron\ronText('Skoleni_dokument_vyslani_na_skoleni') ?></div>
                            <div class="col col-12 col-md-9 ">
                                <label>
                                    <input class="app_input" type="file" name="dokument">
                                </label>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col col-12 col-md-3 caption "><?= \Ron\ronText('Skoleni_popis_dokument_vyslani_na_skoleni') ?></div>
                            <div class="col col-12 col-md-9 ">
                                <label>
                                    <input class="app_input" name="dokument_popis" value="">
                                </label>
                            </div>
                        </div>
                    <?php } else { ?>
                        <div class="row">
                                <div class="col col-12 col-md-3 caption "><strong><?= \Ron\ronText('Skoleni_informace') ?></strong></div>
                                <div class="col col-12 col-md-9 "><strong>
                                    <?= \Ron\ronText('Skoleni_nastaveni_dokumentu') ?></strong>
                                </div>
                            </div>
                    <?php } ?>
                <?php } ?>

                <div class="row">
                    <div class="col col-12 col-md-3 caption "><?= \Ron\ronText('Poznamka') ?></div>
                    <div class="col col-12 col-md-9 ">
                        <label>
                            <textarea class="form-input" name="poznamka_skoleni" rows="2" cols="50"></textarea>
                        </label>
                    </div>
                </div>

            <?php } ?>

        </div>


        <div class="buttons">
            <input type="button" class="button clickHref" data-ron-href="?menuid=skoleni" value="<?= \Ron\ronText('Zpet_na_seznam')?>">
            <?php if(($naplnenostKurzu[0] > $naplnenostKurzu[1] && $naplnenostKurzu[0] != null) || ($naplnenostKurzu[0] == null)) { ?>
                <input type="submit" class="button" name="zaznamenatvyslaninaskoleni" value="<?= \Ron\ronText('form.Store')?>">
            <?php }?>
        </div>

    </div>


</form>

