<?php

/** UTF8
 * Pavel Rudol, RON Software
 *  30.6.2015
 */
namespace Ron\Personalistika;

use Ron\StringUtils;
use function Ron\ronText;
use RonPortal\RonPortalSession;

/* @var $this SeznamDovednostiOsob */

?>

<a class="no-print" href="?menuid=maticedovednosti&action=ziskane&format=csv"><?= ronText('Dovednosti_csv') ?></a>

<table class='browser rowOver oddEvenRows' id='maticeDovednosti' data-ron-pritomnost-url="?menuid=dovednosti&action=pritomnost" data-ron-hledatpp='false'>
    <thead>
        <?php if ($this->zobrazitPritomnost) { ?>
            <th class="dovednosti_pritomnost pritomnost">
                <?= ronText('Dovednosti_pritomnost') ?>
            </th>
        <?php } ?>
        <?php if ($this->zobrazitFoto) { ?>
            <th class="dovednosti_foto">
                <?= ronText('Foto') ?>
            </th>
        <?php } ?>
        <th class="dovednosti_zamestnanec">
            <?= ronText('Zamestnanec') ?>
        </th>
        <th class="dovednosti_osobnicislo">
            <?= ronText('Osobni_cislo') ?>
        </th>
        <?php if ($this->zobrazitTypPP) { ?>
            <th class="dovednosti_typ_pp">
                <?= ronText('Dovednosti_typ_PP') ?>
            </th>
        <?php } ?>
        <?php if ($this->zobrazitPracovniMisto) { ?>
        <th class="dovednosti_pracovni_mista">
            <?= StringUtils::htmlTextConvert($this->typRozdeleniPracMisto->popis) ?>
        </th>
        <?php } ?>
        <?php if ($this->zobrazitRozdeleni) { ?>
        <th class="dovednosti_rozdeleni">
            <?= StringUtils::htmlTextConvert($this->typRozdeleniFiltr->popis) ?>
        </th>
        <?php } ?>
        <?php if ($this->zobrazitKalendar) { ?>
        <th class="dovednosti_kalendar">
            <?= ronText('Kalendar') ?>
        </th>
        <?php } ?>
        <th class="dovednosti_stav">
            <?= ronText('Dovednosti_stav') ?>
        </th>
        <?php
            foreach($this->seznamDovednosti as $dovednost)
            {
                echo '<th><div class="dovednost" title="' . StringUtils::htmlTextConvert($dovednost->popis) . '" ' .
                        (strlen($dovednost->popis) > 90 ? 'style="width: 70px; margin-top: 10px; margin-bottom: -170px;"' : '') . '>' .

                    wordwrap(StringUtils::htmlTextConvert($dovednost->popis), 30, '<br/>', true);

                echo    '</div></th>';

                //zobrazit platnost
                if (RonPortalSession::getValue('zobrazit_expiraci')) {
                    echo '<th><div class="dovednost" >' . ronText('Platnost_do') . '</div></th>';
                }
            }
        ?>
    </thead>
    <tbody>
        <?php
            /* @var $osoba OsobaSDovednosti */
            foreach($this->osoby as $osoba)
            {
                $rowData = '';

                if ($this->zobrazitPritomnost) $rowData = "data-ron-idpp='$osoba->idOsoby'";

                echo "<tr $rowData>";

                if ($this->zobrazitPritomnost) {
                    echo '<td class="pritomnost" nowrap="nowrap">' .
                        '<div class="pritomnost_info" title="' . ronText('Dovednosti_pritomnost_nenacteno') . '">&nbsp;</div></td>';
                }

                if ($this->zobrazitFoto) {
                    echo '<td class="dovednosti_foto">';

                    if ($osoba->idFotografie) {
                        if ($this->zobrazitFoto == 1) {
                            echo '<span class="ronInfoFoto" id="dovednosti_foto_' . $osoba->idOsoby . '"
                                data-foto-url="?menuid=dovednosti&action=foto&osoba=' . $osoba->idOsoby . '"
                                data-foto-alt="' . StringUtils::htmlTextConvert($osoba->prijmeni) . '">
                             <img src="images/16_info.png" alt="foto" />    
                           </span>';
                        }

                        if ($this->zobrazitFoto == 2) {
                            echo '<div class="dovednosti_browser_foto ronFoto"><img alt="foto osoby" src="?menuid=dovednosti&action=foto&osoba=' . $osoba->idOsoby . '"></div>';
                        }
                    }

                    echo '</td>';
                }

                echo '<td class="dovednosti_zamestnanec">';
                
                //pokud ma uzivatel pravo zobrazit osobni udaje zamestnance, zobrazi se proklik na osobni udaje, jinak jen jmeno bez odkazu
                if ($osoba->lzeZobrazitOsobniUdaje) {
                    echo "<a href='?menuid=osobniudaje&osoba=" . $osoba->idOsoby . "'>";
                }
                echo StringUtils::htmlTextConvert($osoba->prijmeni) . ' ' . StringUtils::htmlTextConvert($osoba->jmeno);
                if ($osoba->lzeZobrazitOsobniUdaje) {
                    echo "</a>";
                }
                
                echo '</td>';
                echo '<td class="dovednosti_osobnicislo">' . StringUtils::htmlTextConvert($osoba->osobniCislo) . '</td>';

                if ($this->zobrazitTypPP == 1) {
                    echo '<td class="dovednosti_typ_pp">' . StringUtils::htmlTextConvert($osoba->typPP) . '</td>';
                }

                if ($this->zobrazitPracovniMisto) {
                    //vypise seznam kodu pracovnich mist osoby s popisem po najeti
                    echo '<td class="dovednosti_pracovni_mista">';
                    $seznamPM = '';
                    $seznamPopisuPM = '';
                    foreach ($osoba->pracovniMista as $pracovniMisto) {
                        if ($seznamPM) {
                            $seznamPM .= ', ';
                        }
                        if ($seznamPopisuPM) {
                            $seznamPopisuPM .= ', ';
                        }
                        $seznamPopisuPM .= StringUtils::htmlTextConvert($pracovniMisto->popis);
                        $seznamPM .= '<div title="' . StringUtils::htmlTextConvert($pracovniMisto->popis) . '">' . StringUtils::htmlTextConvert($pracovniMisto->kod) . '</div>';
                    }
                    if ($this->zobrazitPracovniMisto == 1) {
                        echo $seznamPM;
                    } elseif ($this->zobrazitPracovniMisto == 2) {
                        echo $seznamPopisuPM;
                    }
                    echo '</td>';
                }

                if ($this->zobrazitRozdeleni) {
                    //vypise seznam kodu rozdeleni osoby s popisem po najeti
                    echo '<td class="dovednosti_rozdeleni">';
                    $seznamRozdeleni = '';
                    $seznamPopisuRozdeleni = '';
                    foreach ($osoba->prirazenaRozdeleniOsoby as $rozdeleni) {
                        if ($seznamRozdeleni) {
                            $seznamRozdeleni .= ', ';
                        }
                        if ($seznamPopisuRozdeleni) {
                            $seznamPopisuRozdeleni .= ', ';
                        }
                        $seznamPopisuRozdeleni .= StringUtils::htmlTextConvert($rozdeleni->popis);
                        $seznamRozdeleni .= '<div style="display:inline;" title="' . StringUtils::htmlTextConvert($rozdeleni->popis) . '">' . StringUtils::htmlTextConvert($rozdeleni->kod) . '</div>';
                    }
                    if ($this->zobrazitRozdeleni == 1) {
                        echo $seznamRozdeleni;
                    } elseif ($this->zobrazitRozdeleni == 2) {
                        echo $seznamPopisuRozdeleni;
                    }
                    echo '</td>';
                }

                if ($this->zobrazitKalendar) {
                    echo '<td class="dovednosti_kalendar">';

                    if ($this->zobrazitKalendar == 1) {
                        echo '<div title="' . StringUtils::htmlTextConvert($osoba->popisKalendare) . '">' . $osoba->kodKalendare . '</div>';
                    } elseif ($this->zobrazitKalendar == 2) {
                        echo StringUtils::htmlTextConvert($osoba->popisKalendare);
                    }

                    echo '</td>';
                }
                
                echo '<td class="dovednosti_stav">';
                if ($this->zobrazitPocetDosazenychDovednosti)
                    echo count($osoba->ziskaneDovednosti) . '/';
                echo $osoba->pocetZiskanychDovednosti;
                echo '</td>';

                /** @var DovednostOsoby $dovednost */
                foreach($this->seznamDovednosti as $dovednost)
                {
                    echo '<td><div class="' . ($osoba->urovenZiskaneDovednosti($dovednost->kod, true) > 0 ? 'dovednosti_dovednost_osoby ' : '') .
                                            'ziskana_'.$osoba->urovenZiskaneDovednosti($dovednost->kod) . ($osoba->urovenZiskaneDovednosti($dovednost->kod, true) > 4 ? ' ziskana_4' : '');
                        if (isset($osoba->ziskaneDovednosti[$dovednost->kod])  &&  is_array($osoba->ziskaneDovednosti[$dovednost->kod]->specifikaceUrovne)) {
                            foreach ($osoba->ziskaneDovednosti[$dovednost->kod]->specifikaceUrovne as $kodUrovne => $urovenDovednosti) {
                                echo $urovenDovednosti == 1 ? " samokontrola_$kodUrovne" : '';
                            }
                        }
                    echo '" title="' . ($this->zobrazeniUrovneDovednosti == 0
                            ? (isset($osoba->ziskaneDovednosti[$dovednost->kod]->uroven) && $dovednost ->htmlPopisUrovni[$osoba->ziskaneDovednosti[$dovednost->kod]->uroven] ?: '')
                            : ($osoba->urovenZiskaneDovednosti($dovednost->kod) ?: '')) . '">';
                    
                    if ($osoba->lzeEditovat || $osoba->lzeZobrazit)
                    {
                        if ($osoba->lzeEditovat) {
                            $dovednostAction = 'novadovednost';
                        } else {
                            $dovednostAction = 'dovednostiosoby';
                        }
                        
                        echo '<a href="?menuid=maticedovednosti&amp;action=' . $dovednostAction . '&amp;idosoby=' . $osoba->idOsoby . '&amp;dovednost=' . $dovednost->kod . '">';
                    }
                    echo ($this->zobrazeniUrovneDovednosti == 0 ? $osoba->urovenZiskaneDovednosti($dovednost->kod) : $dovednost ->htmlPopisUrovni[$osoba->ziskaneDovednosti[$dovednost->kod]->uroven]);
                    if ($osoba->lzeEditovat || $osoba->lzeZobrazit)
                    {
                        echo '</a>'; 
                    }
                    
                    echo '</div></td>';

                    //zobrazit platnost do
                    if (RonPortalSession::getValue('zobrazit_expiraci')) {
                        echo '<td>';
                        if ($osoba->ziskaneDovednosti[$dovednost->kod]->platnostDo > 0) {
                            echo '<div title="' . StringUtils::format('date', $osoba->ziskaneDovednosti[$dovednost->kod]->platnostDo) . '">'
                                . date('n/y', $osoba->ziskaneDovednosti[$dovednost->kod]->platnostDo) . '</div>';
                        }
                        echo '</td>';
                    }
                }
                
                echo '</tr>';
            }
        ?>
    </tbody>
</table>

<?= ronText('Dovednosti_prehled_doplnujici_info') ?>

<!--<div id="dovednosti_reporty">

</div>-->