<?php
/**
 * UTF-8
 * Created by PhpStorm.
 * User: pavel.rudol
 * Date: 18.3.2016
 * Time: 14:01
 */

namespace Ron\RonPortal\PokladniKniha;

use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\RonPortal\PravaNaOsoby;
use Ron\RonPortal\RonPortalSettings;
use Ron\StringUtils;
use function Ron\ronText;

$model = Model::getInstance();

/** @var PokladniKniha $pokladniKnihaZaznam */
$pokladniKnihaZaznam = $model->getData('pokladnikniha');

/** @var DokumentyPokladniKnihyBrowser $dokumentyBrowser */
$dokumentyBrowser = $model->getData('dokumentyBrowser');

/** @var bool $vraceni */
$vraceni = $model->getData('vraceni');

/** @var SeznamPolozekPokladniKnihy $seznamPolozekPoklK */
$seznamPolozekPoklK = $model->getData('seznamPolozekPoklK');

$typPolozky = $seznamPolozekPoklK->vratTypPolozky($pokladniKnihaZaznam->typPolozkyKod);
?>

<h1><?= ronText('pokladni_kniha_zaznam' . ($seznamPolozekPoklK->cislo != 1 ? "_$seznamPolozekPoklK->cislo" : '')) ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<table class='infotable minwidth' id='hlavickapokladniknihy'>
    <tr id="hlavickapoklk_osoba">
        <td></td>
        <td><strong><?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->vratJmenoPrijmeni()) ?></strong>, <?= ronText('Osobni_cislo') . ' ' . StringUtils::htmlTextConvert($pokladniKnihaZaznam->osobniCislo) ?></td>
    </tr>
    <tr id="hlavickapoklk_datum">
        <td><?= ronText('datum_pohybu') ?></td>
        <td><?= StringUtils::format('date',$pokladniKnihaZaznam->datumPohybu) ?></td>
    </tr>
    <tr id="hlavickapoklk_typpohybu">
        <td><?= ronText('typ_polozky') ?></td>
        <td><?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->typPolozky) ?></td>
    </tr>
    <tr id="hlavickapoklk_popis">
        <td><?= ronText('popis' . ($seznamPolozekPoklK->cislo != 1 ? "_$seznamPolozekPoklK->cislo" : '')) ?></td>
        <td><?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->popis) ?></td>
    </tr>
    <?php if ($typPolozky->lzeZobrazitCastkuBezDPH()) { ?>
    <tr id="hlavickapoklk_castka_bez_dph">
        <td><?= ronText('castkaBezDPH') ?></td>
        <td><?= StringUtils::format('number2',$pokladniKnihaZaznam->castkaBezDPH) ?>  <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->mena) ?></td>
    </tr>
    <?php } ?>
    <?php if ($typPolozky->lzeZobrazitCastkuDPH()) { ?>
    <tr id="hlavickapoklk_castka_dph">
        <td><?= ronText('castkaDPH') ?></td>
        <td><?= StringUtils::format('number2',$pokladniKnihaZaznam->castkaDPH) ?>  <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->mena) ?></td>
    </tr>
    <?php } ?>
    <tr id="hlavickapoklk_castka">
        <td><?= ronText('castka') ?></td>
        <td><strong><?= StringUtils::format('number2',$pokladniKnihaZaznam->castka) ?></strong>  <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->mena) ?></td>
    </tr>
    <tr id="hlavickapoklk_poznamka">
        <td><?= ronText('poznamka' . ($seznamPolozekPoklK->cislo != 1 ? "_$seznamPolozekPoklK->cislo" : '')) ?></td>
        <td><?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->poznamka) ?></td>
    </tr>

    <tr>
        <td><br /></td>
    </tr>

    <tr id="hlavickapoklk_schvaleni" class="inputtablesection">
        <td colspan="2">
            <?= ronText('PoklK_schvaleni') ?>
        </td>
    </tr>

    <?php

        if (!$pokladniKnihaZaznam ->jeZaznamSchvalen(2) && $pokladniKnihaZaznam ->schvaleni[1]) $urovenvraceni = 1; // 1. je schvalena, dalsi ne => uzivatel na urovni 2 muze vratit
        else if (!$pokladniKnihaZaznam ->jeZaznamSchvalen(3) && $pokladniKnihaZaznam ->schvaleni[2]) $urovenvraceni = 2; // 2. je schvalena, dalsi ne => uzivatel na urovni 3 muze vratit
        else $urovenvraceni = 0;

        $posloupnostZapnuta = RonPortalSettings::getIntValue('poklk_posloupnost_schvalovani');
    
        for ($uroven = 1; $uroven <= 3; $uroven++) { ?>
        <tr class="schvaleni_poklk_<?= $uroven ?>">
            <td class='formtablecaption'><span class='textschvaleni<?= $uroven ?>'><?= ronText('PoklK_schvaleni_uroven'.$uroven . ($seznamPolozekPoklK->cislo != 1 ? "_$seznamPolozekPoklK->cislo" : '')) ?></span></td>
            <td>

            <?php

            $lzeVratit = false;

            if ($uroven > 1) {
                $lzeVratit = $uroven == 2 ? $urovenvraceni == 1 : ($uroven == 3 ? $urovenvraceni == 2 : false);
            }

            /** @var PravaNaOsoby $pravaSchvalit */
            $pravaSchvalit = $model->getData('pravaSchvalit'.$uroven);

            if ($pokladniKnihaZaznam->schvaleni[$uroven]) { ?>
                <span class="textschvaleni<?= $uroven ?>"><?= StringUtils::format('date',$pokladniKnihaZaznam->schvaleni[$uroven]) . ' ' .
                    StringUtils::htmlTextConvert($pokladniKnihaZaznam->schvalil[$uroven])  ?>
                </span>

                <?php if (!$pravaSchvalit ->priznak) {
                    // nelze zrusit datum schvaleni pokud je jiz obdobi (podle datumPohybu) uzavreno

                    if (($uroven == 3 || !$pokladniKnihaZaznam->jeZaznamSchvalen($uroven + 1)) && // pokud je vyssi uroven schvaleni, tak nesmi zrusit tuto
                    $pravaSchvalit->lzeZobrazitPP($pokladniKnihaZaznam->idPP, $pokladniKnihaZaznam->datumPohybu, $pokladniKnihaZaznam->datumPohybu)
                    ) {
                        ?>
                    &nbsp;&nbsp;&nbsp;<A href='?menuid=pokladnikniha&action=zrusschvaleni<?= $uroven?>&record=<?= $pokladniKnihaZaznam->vratID() ?>'>
                        <?= ronText('PoklK_zrusschvaleni_uroven'.$uroven) ?></A>
                <?php }
                }
            }
            else {
                if ( (!$posloupnostZapnuta || $lzeVratit  ||  $uroven == 1)  && $pravaSchvalit->lzeZobrazitPP($pokladniKnihaZaznam->idPP, $pokladniKnihaZaznam->datumPohybu, $pokladniKnihaZaznam->datumPohybu)) {

                ?>

                <A href='?menuid=pokladnikniha&action=schval<?= $uroven ?>&record=<?= $pokladniKnihaZaznam->vratID() ?>'><?= ronText('PoklK_provedschvaleni_uroven'.$uroven) ?></A>

                <?php
                    if (RonPortalSettings::getIntValue('poklk_pouzivat_vraceni') && $lzeVratit) {
                    // mezera
                    ?>
                        <span style="display:inline-block; width:50px;"></span>

                        <A href='?menuid=pokladnikniha&action=vrat&record=<?= $pokladniKnihaZaznam->vratID() ?>' class="vraceni_pokladni_knihy_link">
                            <?= ronText('PoklK_vratschvaleni_uroven'.$uroven) ?>
                        </A>
                    <?php
                    }
                }
            }
            ?>

            </td>
        </tr>
    <?php } ?>
    

    <?php if ($pokladniKnihaZaznam->lzeEditovat(false)) { ?>
        <tr id="hlavickapoklk_editace">
            <td></td>
            <td><a href="?menuid=pokladnikniha&formaction=edit&record=<?= $pokladniKnihaZaznam->vratID() ?>"><?= ronText('Edit') ?></a> </td>
        </tr>
    <?php } ?>

    <?php if (RonPortalSettings::getIntValue('poklk_pouzivat_vraceni') && $urovenvraceni) { // pouziva se vraceni - div pro zapsani poznamky k vraceni
        $value = '';
        if (isset($_POST['poznamkakvraceni'])) $value = $_POST['poznamkakvraceni'];
        ?>
        <tr>
            <td colspan="2">
                <div id="vracenipokladniknihy" <?php if (!$vraceni) echo 'style="display:none"'; /* zobrazi se az po kliknuti na "vratit" */ ?> >
                    <form method="post" name="vracenipoklkform" action="?menuid=pokladnikniha&action=vrat&record=<?= $pokladniKnihaZaznam ->vratID() ?>">
                        <input type="hidden" name="urovenvraceni" value="<?= $urovenvraceni ?>" />

                        <label>
                            <strong><?= ronText('PoklK_poznamka_k_vraceni') ?></strong><br/>
                            <textarea name="poznamkakvraceni" rows="8" style="width:100%"><?= StringUtils::htmlTextConvert($value) ?></textarea><br/>
                        </label>
                        <input type="submit" class="submitbutton" value="OK">

                    </form>
                </div>
            </td>
        </tr>
    <?php } ?>

    <tr id="hlavickapoklk_historie">
        <td></td>
        <td>
            <div id="historie_poklk" class="autoExpand xhistorie_poklk_1">

                <?= StringUtils::longTextToHtml(trim($pokladniKnihaZaznam ->historieSchvalovani)) ?>
            </div>
        </td>
    </tr>

</table>

<br />

<?php
    $dokumentyBrowser->render();
?>

<br />

<?php if ($pokladniKnihaZaznam->lzeEditovat(false)) { ?>
    <div>
        <a href='#' onclick='showDokumentPokladniKnihyDialog(<?= $pokladniKnihaZaznam->vratID() ?>);'><?= ronText('PoklK_novy_dokument') ?></a>
        <?php
        $form = $model->getData('dokumentForm');
        $form ->render();
        ?>
    </div>
<?php } ?>

<br />

<a href="?menuid=pokladnikniha&browser=<?= $seznamPolozekPoklK->cislo ?>"><?= ronText('Zpet_na_seznam') ?></a>

