<?php
/**
 * Created by PhpStorm.
 * User: pavel.rudol
 * Date: 11.8.2016
 * Time: 8:32
 */

namespace Ron\RonPortal\Zamestnanci;

use Ron\Controls\ComboBox;
use Ron\GuiUtils;
use Ron\RonPortal\NastaveniUzivatele;
use Ron\RonPortal\Prava;
use Ron\RonPortal\RonPortalFilterForm;
use Ron\TextManager;

require_once('ron/guiutils.php');
require_once('adsapp/ronportalfilter.php');

/**
 * Filtr pro browsery PP, osob
 * Filtruje rozdeleni, platnost PP, typ Zamestnance, aktivni/neaktivni/vsechny osoby/PP
 */
class SeznamZamestnancuFilterForm extends RonPortalFilterForm
{

    public function __construct($database, $action)
    {
        parent::__construct($database, $action);

        TextManager::getInstance()->loadStrings('zamestnanci.ini');

        $this->f_classname = 'filtercontainer leftcaptions';

        $this->nastavRozdeleni(true);
        $this->nastavRozdeleni2(true);
        $this->f_pravarozdeleni = Prava::vratPrava('zamest_prohl');

        $this->nastavDatumOdDo((isset($_SESSION['stavPP']) && ($_SESSION['stavPP'] !== 'vsichni')), TRUE);
    }

    /**
     * @throws \Exception
     */
    private function renderTypZamestnance()
    {
        echo '<DIV class="filterrow">';

        // checkbox "Jen typ osoby"
        echo '<SPAN class="filtercaption">';
        GuiUtils::renderCheckbox('jenTypZamestnance',
            \Ron\ronText('Jen_typ_zamestnance') . '&nbsp;&nbsp;', $_SESSION['jenTypZamestnance'],
            'onClick="submit()"');

        echo '</SPAN>';

        // combobox pro vyber
        $sql =
            'SELECT Kod, Popis FROM S_TypOsoby ';

        $sql .=
            ' ORDER BY Popis';

        // vyber typu osoby/zamestnance podle popisu
        $combo = new ComboBox('typZamestnance');
        $combo->className = 'app_combo adsfilterforminput_full';
        $combo->htmlParams = 'onChange="if (jenTypZamestnance.checked) submit();"';
        $combo->emptyRow = ' ';
        $combo->loadData($this->database, $sql, $_SESSION['typZamestnance']);
        $combo->render();

        echo "</DIV>\n";
    }


    /**
     *
     */
    private function renderFiltrStav()
    {
        echo '<DIV class="filterrow">';

        echo '<SPAN class="filtercaption">';

        echo "<input type='radio' name='stavPP' value='vsichni' " . (($_SESSION['stavPP'] == 'vsichni' or !isset($_SESSION['stavPP'])) ? 'checked' : '') .
            " onClick='submit();'>" . \Ron\ronText('Vsichni') . "&nbsp;";
        echo "<input type='radio' name='stavPP' value='aktivni' " . ($_SESSION['stavPP'] == 'aktivni' ? 'checked' : '') . " onClick='submit();'>" . \Ron\ronText('Aktivni') . "&nbsp;";
        echo "<input type='radio' name='stavPP' value='neaktivni' " . ($_SESSION['stavPP'] == 'neaktivni' ? 'checked' : '') . " onClick='submit();'>" . \Ron\ronText('Neaktivni');

        echo '</SPAN>';

        echo "</DIV>\n";

    }

    private function renderTypSeznamu()
    {
        echo '<DIV class="filterrow">';

        echo '<SPAN class="filtercaption">';
        echo '</SPAN>';

        echo "<input type='radio' name='typBrowseru' value='seznampp' " . (($_SESSION['Ron.Zamestnanci.Browser'] == 'seznampp' or !isset($_SESSION['Ron.Zamestnanci.Browser'])) ? 'checked' : '') .
            " onClick='window.location= &quot;?menuid=&quot;+this.value;'>" . \Ron\ronText('Prehled_PP') . "&nbsp;";
        echo "<input type='radio' name='typBrowseru' value='seznamosob' " . ($_SESSION['Ron.Zamestnanci.Browser'] == 'seznamosob' ? 'checked' : '') .
            " onClick='window.location= &quot;?menuid=&quot;+this.value;'>" . \Ron\ronText('Seznam_osob') . "&nbsp;";

        echo "</DIV>\n";

        echo "<br />";
    }

    private function renderNew()
    {
        echo "<BR />";

        echo "<A href='?menuid=zamestnanec&action=insert'>" . \Ron\ronText('novy_zamestnanec') . "</A>";
    }

    private function loadTypZamestnance()
    {
        if (isset($_POST['adsfilterform'])) {
            $_SESSION['jenTypZamestnance'] = isset($_POST['jenTypZamestnance']);
            $_SESSION['typZamestnance'] = $_POST['typZamestnance'];

            NastaveniUzivatele::setUserSettingsItem($this->database, 'zamestnanci_jen_typ_zamestnance', $_SESSION['jenTypZamestnance'], false);
            NastaveniUzivatele::setUserSettingsItem($this->database, 'zamestnanci_typ_zamestnance', $_SESSION['typZamestnance'], '');
        }
        else {
            $_SESSION['jenTypZamestnance'] = NastaveniUzivatele::getUserSettingsItem($this->database, 'zamestnanci_jen_typ_zamestnance', false);
            $_SESSION['typZamestnance'] = NastaveniUzivatele::getUserSettingsItem($this->database, 'zamestnanci_typ_zamestnance', '');
        }
    }

    private function loadFiltrStav()
    {
        if (isset($_POST['adsfilterform'])) {
            $_SESSION['stavPP'] = $_POST['stavPP'];

            NastaveniUzivatele::setUserSettingsItem($this->database, 'zamestnanci_stav_pp', $_SESSION['stavPP'], 'vsichni');
        }
        else {
            $_SESSION['stavPP'] = NastaveniUzivatele::getUserSettingsItem($this->database, 'zamestnanci_stav_pp', 'vsichni');
        }
        $this->showDatumOdDo = (isset($_SESSION['stavPP']) && ($_SESSION['stavPP'] !== 'vsichni'));
    }

    function loadData()
    {
        $this->loadFiltrStav();

        $this->loadTypZamestnance();

        parent::loadData();
    }

    /**
     * @throws \Exception
     */
    function renderFilters()
    {
//        $this->renderTypSeznamu();

        $this->renderFiltrStav();

        parent::renderFilters(); // rozdeleni

        $this->renderTypZamestnance();

        //TODO: odstranit po dokonceni formulare
        global $enable_seznamPP;
        if ($enable_seznamPP)
        $this->renderNew();
    }
}