<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\DB;

use Ron\RonException;

class DBException extends RonException
{
    var $sql;
    var $dbMessage;

    /**
     * @param Database $database
     * @param string   $message
     * @param string $sql
     * @param string $dbMessage
     * @param \Exception $previous
     */
    public function __construct($database, $sql, $message = null, $previous = null, $dbMessage = null)
    {
        $this ->sql = $sql;
        $this ->dbMessage = isset($dbMessage) ? $dbMessage : ($database ? $database ->lastErrorText() : null);

        parent::__construct(
            ($message ? $message : 'Chyba v SQL dotazu!') . " \n" . $this ->dbMessage,
            null,
            $this ->sql,
            0, $previous);

    }
}
