<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron;

class Message
{
    const INFO = 1;
    const ERROR = 2;
    const DEBUG = 3;
    const LOG = 4; // vypisuje se do logu
    const WARNING = 5;
    const SUCCESS = 6;

    /** @var int  INFO/ERROR/DEBUG/LOG/WARNING */
    var $type;

    var $text;
    var $fieldName;
    var $id;

    /** @var bool Priznak, ze text obsahuje HTML a nema se konvertovat */
    var $isHtml;

    /** @var string  Dodatecny popis chyby */
    var $description;


    function __construct($text, $type = Message::INFO, $fieldName = null, $id = null, $description = null)
    {
        $this ->text = $text;
        $this ->type = $type;
        $this ->fieldName = $fieldName;
        $this ->id = $id;
        $this ->description = $description;
    }


    function false() {
        return false;
    }


    function storeToArray()
    {
        return [
            'type' => $this ->type,
            'text' => $this ->text,
            'fieldName' => $this ->fieldName,
            'id' => $this ->id,
            'description' => $this ->description
        ];
    }


    function loadFromAray($array)
    {
        $this ->type = (int)$array['type'];
        $this ->text = $array['text'];
        $this ->fieldName = $array['fieldName'];
        $this ->id = $array['id'];
        $this ->description = $array['description'];
    }
}
