<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;


/**
 * Blokovy View object - obaluje vnorene ViewObjecty a muze je vlozit i do nejakeho HTML elementu (defaultne div)
 * Class BlockViewObject
 * @package Ron\MVC
 */
class BlockViewObject implements ViewObject
{
    /** @var string Obalujici html element (pokud neni zadan, tak se nic negeneruje) */
    public $wrappingElement = 'div';

    public $wrappingElementParams = '';


    /** @var ViewObject[] */
    private $childViewObjects = [];


    /**
     * @param ViewObject $viewObject
     */
    public function addViewObject($viewObject)
    {
        $this ->childViewObjects[] = $viewObject;
    }


    public function renderHeader()
    {
        if ($this ->wrappingElement) {
            echo "<{$this ->wrappingElement} {$this ->wrappingElementParams}>";
        }
    }


    public function renderFooter()
    {
        if ($this ->wrappingElement) {
            echo "</{$this ->wrappingElement}>";
        }
    }


    public function renderChildren()
    {
        foreach ($this ->childViewObjects as $child) {
            $child ->render();
        }
    }

    public function render()
    {
        $this ->renderHeader();
        $this ->renderChildren();
        $this ->renderFooter();
    }

}
