<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;

use Ron\Http\App;
use Ron\RonException;

abstract class JsonController extends HttpController
{

    /**
     * @param string $action
     * @param JsonOutputObject $output
     */
    abstract function handleJsonAction($action, $output);

    public function handleAction($action)
    {
        $result = new JsonOutputObject();

        try {
            if (!App::getDebugMode()) {
                ini_set('display_errors', 0);
            };

            $this ->handleJsonAction($action, $result);
        } catch (RonException $e) {
            $result ->addError($e ->getMessage(), $e ->getFieldName(), $e ->getErrorDescription());
        } catch (\Exception $e) {
            $result ->addError($e ->getMessage());
        }

        return $result;
    }
}

