<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;

/**
 * Zajistuje zobrazeni textu (div)
 * Class TextViewObject
 * @package Ron\MVC
 */
class TextViewObject implements ViewObject
{
    const ERROR_CLASS = 'errortext';

    private $text;
    private $className;
    /** @var string     Urcuje, do jakeho elementu se obsah obali (muze byt i prazdny) */
    public $wrapElement;

    public function __construct($text, $className = '', $wrapElement = 'div')
    {
        $this ->text = $text;
        $this ->className = $className;
        $this ->wrapElement = $wrapElement;
    }

    /**
     *
     */
    public function render()
    {
        echo
            ($this ->wrapElement
                ? '<' . $this ->wrapElement . ($this ->className ? ' class="' . $this ->className . '"' : '') . '>'
                : '') .
            $this ->text .
            ($this ->wrapElement
                ? '</' . $this ->wrapElement . '>'
                : '');
    }
}
