<?php
/**
 * stanislav.elbl, 25.02.2021
 */

namespace RonPortal\Controller;
use Ron\DB\Database;
use Ron\Http\HtmlHeaders;
use Ron\MVC\Controller;
use Ron\MVC\Model;
use Ron\MVC\OutputObject;
use Ron\MVC\TranslationsOutputObject;
use Ron\MVC\ViewObject;
use Ron\TextManager;


//require_once('ron/guiutils.php');
//require_once('ron/stringutils.php');
//require_once('ron/apputils.php');
//require_once('ron/dateutils.php');
//require_once('adsapp/nastaveni.php');
//require_once('adsapp/prava.php');
//require_once('adsapp/sessionvars.php');
//require_once('adsapp/obdobi.php');
//require_once('adsapp/rozdeleni.php');
//require_once('adsapp/ppomer.php');
//require_once('adsapp/usersettings.php');
//
//require_once('appconstants.php'); // verze a podobne


/**
 * Class UserPageView
 * @package Ron\RonPortal
 */
class UserPageView implements ViewObject
{
    var $f_dbconnection; // pro kompatibilitu
    var $f_menuid;

    /**
     * @param Database $database
     * @param $menuid
     */
    function __construct($database, $menuid)
    {
        $this ->f_dbconnection = $database;
        $this ->f_menuid = $menuid;
    }


    /**
     */
    public function render()
    {
        if ( isset($_GET['menuid']) && $_GET['menuid'] ) {
            $_SESSION['appaction'] = $_GET['menuid'];
        }

        require_once('adsapp/useractions.php');
        \useraction($this ->f_dbconnection, $this ->f_menuid);
    }

}


class UserPageController implements Controller
{
    /** @var  Database */
    var $database;

    /**
     * @param Database $database
     */
    public function __construct($database)
    {
        $this ->database = $database;
    }


    /**
     * @param string $action
     * @return string|OutputObject
     */
    public function handleAction($action)
    {
        TextManager::getInstance() ->loadStrings('dochazka.ini');

        if ($action == 'jsstrings') {
            require_once('ron/utils.php');
            return new TranslationsOutputObject();
        }

        Model::setData('defaultQueryString', $_SERVER['QUERY_STRING']);

        HtmlHeaders::getInstance() ->addScript('', '?menuid=jsstrings&ver=' . HtmlHeaders::getInstance() ->versionId);

        $app = new UserPageView($this ->database, $action);

        Model::addViewObject($app);

        return 'view/appview.php';
    }

}
