<?php
/**
 * stanislav.elbl, 28.02.2021
 */

namespace RonPortal\Dochazka;

use Ron\DB\Database;
use Ron\Http\App;
use Ron\MVC\BaseViewObject;
use Ron\MVC\Model;
use RonPortal\Obdobi;
use RonPortal\RonPortalSession;
use RonPortal\RonPortalXMLEvents;
use RonPortal\XML\RonPortalXMLForm;

class SchvaleniView extends BaseViewObject
{
    var $xmlEventsText = '';
    var $showDialog;

    var $redirectUrl = null;

    /**
     * SchvaleniView constructor.
     * @param Database $database
     * @param bool $showDialog
     */
    public function __construct($database, $showDialog = false)
    {
        parent::__construct('view/schvalenidochazky.php');

        $this ->showDialog = $showDialog;

        $obdobi = new Obdobi();
        $obdobi ->nactiObdobi($database, 'ADS', RonPortalSession::obdobi());

        Model::setData('obdobi', $obdobi);
        Model::setData('datumzpracovanidochazky', DochazkaUtils::datumCasZpracovaniDochazky($database));

        // nacte pripadne xml formulare
        $this ->xmlEventsText = RonPortalXMLForm::xmlEvents($database, RonPortalXMLEvents::SCHVALOVANI_SHOW, '', '', true); // returnContent = true
    }


    public function render()
    {
        parent::render();

        echo $this ->xmlEventsText;

        if ($this ->showDialog) {
            $obdobistr = date('j.n.Y', RonPortalSession::obdobi());
            $idpp = RonPortalSession::vybranaOsoba();
            echo
                "<script type='text/javascript'>" .
                ( App::getDebugMode() ? "console.log('Zobrazuji schvaleni pro idpp $idpp, obdobi $obdobistr');" : '') .
                "ronPortal.dochazka.zobrazSchvaleniDochazky($idpp, '$obdobistr', " . ($this ->redirectUrl ? "'{$this ->redirectUrl}'" : 'null') . ");" .
                "</script>";

        }
    }
}
