<?php
/**
 * stanislav.elbl, 16.03.2021
 */

namespace RonPortal\Dochazka;

use Ron\Controls\LinksList;
use Ron\TextManager;
use RonPortal\Controls\RonPortalFilterForm;
use RonPortal\Prava;
use RonPortal\RonPortalSession;
use RonPortal\RonPortalSettings;

class SchvalovaniFilterForm extends RonPortalFilterForm
{
    function __construct($database)
    {
        parent::__construct($database, 'schvalovani', true);

        $this ->nastavObdobi(true, 'ADS', false);  // jenotevrene = false
        $this ->nastavRozdeleni(true);

        $this ->f_pravarozdeleni = Prava::vratPrava('prohlizeni');

        if ( RonPortalSettings::getIntValue(RonPortalSettings::ROZDELENI2_TYP) ) {
            $this ->nastavRozdeleni2(true);
        }
    }


    function loadData()
    {
        parent::loadData();

        if (isset($_GET['urovenschvaleni'])) {
            $actualvalue = (int)$_GET['urovenschvaleni'];
            $_SESSION['filtr_urovenschvaleni'] = $actualvalue;
        }
    }


    function renderFilterStav()
    {
        echo '<div class="filterrow" id="filter_urovenschvaleni">';
        echo '<span class="filtercaption"></span>';

//        if (isset($_GET['urovenschvaleni'])) {
//            $actualvalue = (int)$_GET['urovenschvaleni'];
//            $_SESSION['filtr_urovenschvaleni'] = $actualvalue;
//        } else {
//            $actualvalue = (int)$_SESSION['filtr_urovenschvaleni'];
//        }


//        global $STR_Neschvaleno1; // jen pro kompatibilitu starych prekladu
//        global $STR_Neschvaleno2;
//        global $STR_Neschvaleno3;

        LinksList::renderLinks([
            0 => TextManager::_('Vsechno'),
            1 => TextManager::_('Neschvaleno1'),
            2 => TextManager::_('Neschvaleno2'),
            3 => TextManager::_('Neschvaleno3')
        ],
            (int)RonPortalSession::getValue('filtr_urovenschvaleni'), '?menuid=schvalovani&urovenschvaleni=', '', false);

        echo "</div>\n";
    }


    function renderFilters()
    {
        parent::renderFilters();

        // vsechno / nezpracovano / nezkontrolovano / neschvaleno
        $this->renderFilterStav();
    }
}
