<?php
/**
 * stanislav.elbl, 22.02.2021
 */

namespace RonPortal\Dokumenty;

use Ron\MVC\OutputObject;
use Ron\StringUtils;

/**
 * Zajistuje funkcnost uploadu dokumentu pro view dokument_novy.php
 * Class DokumentUploadOutput
 */
class DokumentUploadOutput implements OutputObject
{
    var $result = 'OK';
    var $errorText = null;


    public function setError($errorText)
    {
        $this ->result = 'error';
        $this ->errorText = $errorText;
    }


    public function output()
    {
        $jsonResult = [
            'result' => $this ->result
        ];

        if ($this ->errorText) {
            $jsonResult['errors'] = [ ['errorText' => StringUtils::jsonText($this ->errorText)] ];
        }

        echo
            '<html>' .
            '<body>' .
            '<script type="text/javascript">' .
            'var result = ' . json_encode($jsonResult) . '; ' .
            ' window.parent.window.vlozitDokumentResult(result);' .
            '</script>' .
            '</body>' .
            '</html>';
    }
}
