<?php
/**
 * stanislav.elbl, 28.02.2021
 */

namespace RonPortal\Editace;

use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\SqlStatement;
use RonPortal\Dokumenty\DokumentyBrowser;
use RonPortal\PracovniPomer;

class DokumentyDochazkyBrowser extends DokumentyBrowser
{
    /**
     * @param \Ron\DB\Database $database
     * @param PracovniPomer $pp
     * @param int  $obdobi
     * @param bool $lzeEditovat
     */
    function __construct($database, $pp, $obdobi, $lzeEditovat)
    {
        parent::__construct($database,
            '?menuid=editace&action=download&idpp=' . $pp ->idPP . '&obdobi=' . DateUtils::dateToUrlString($obdobi),
            $lzeEditovat ? 2 : 0); // 2 = mazani pres form

        $this ->title = '';
        $this ->showMessages = false;

        $this->sqlFromPart = 'Dokument, TypDokumentu, DokumentDochazky';

        $params = $database ->createParameters();
        $this->sqlWherePart = new SqlStatement(
            'Dokument.Id = DokumentDochazky.Id ' .
            ' AND TypDokumentu.Kod = Dokument.Typ ' .
            ' AND DokumentDochazky.RC = ' . $params->addParameter($pp ->rc) .
            ' AND DokumentDochazky.OsobniCislo = ' . $params->addParameter($pp ->osobniCislo) .
            ' AND DokumentDochazky.DatumNastupu = ' . $params ->addParameter($database ->dateToParam($pp ->datumNastupu)) .
            ' AND DokumentDochazky.PocatekObdobi = ' . $params ->addParameter($database ->dateToParam($obdobi)) .
            " AND DokumentDochazky.Aplikace = 'ADS'",
            $params);

        $this->sqlSelectPart .= ', DokumentDochazky.Den';

        $this ->datumField ->sqlFieldIndex = 5;
    }


    /**
     * @param Database $database
     * @param PracovniPomer $pp
     * @param int  $obdobi
     * @param bool $lzeEditovat
     */
    static function zobrazDokumentyDochazky($database, $pp, $obdobi, $lzeEditovat)
    {
        echo "<a name='dokumenty'></a>\n";

        // Seznam dokumentu
        $b = new DokumentyDochazkyBrowser($database, $pp, $obdobi, $lzeEditovat);
        $b ->load();
        $b ->render();
    }

}
