<?php
/**
 * Roman.Szablatura, 18.3.2016
 */

namespace RonPortal\Personalistika;
use Ron\Controls\BrowserField;
use Ron\Controls\ComboBox;
use Ron\Controls\LinksList;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\DB\SqlStatement;
use Ron\GuiUtils;
use Ron\HttpUtils;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\OsobniCisloBrowserField;
use RonPortal\Controls\RonPortalBrowser;
use RonPortal\Controls\RonPortalFilterForm;
use RonPortal\Prava;
use RonPortal\PravaNaOsoby;
use RonPortal\RonPortalSession;
use RonPortal\RonPortalSettings;
use RonPortal\RozdeleniUtils;


/**
 * Class LekarskeProhlidkyFilterForm
 * @package RonPortal\Personalistika
 */
class LekarskeProhlidkyFilterForm extends RonPortalFilterForm
{
    /**
     * LekarskeProhlidkyFilterForm constructor.
     * @param Database $database
     * @param PravaNaOsoby $pravaProhlizet
     * @param PravaNaOsoby $pravaAbsolvovat
     * @param PravaNaOsoby $pravaZapis
     */
    function __construct($database, $pravaProhlizet, $pravaAbsolvovat, $pravaZapis)
    {
        parent::__construct($database, 'lekarskeprohlidky');

        //$this->f_formaction = '?menuid=lekarskeprohlidky';
        $this->f_classname = 'filtercontainer leftcaptions';

        $this->nastavRozdeleni(true);
        $this->nastavRozdeleni2(true);

        $this->setUseGet(true, 'lekarskeprohlidky');

        $this->nastavOsoby(true, [$pravaProhlizet, $pravaAbsolvovat, $pravaZapis], time(), time());
        $this->povolitVsechyOsoby = 1;
    }


    /**
     * @throws DBException
     */
    function renderTypProhlidky()
    {
        echo '<div class="filterrow" id="filterrow_typprohlidky">';
            echo '<span class="filtercaption">';
            GuiUtils::renderCheckbox('jentypprohlidky', TextManager::_('typ_prohlidky'),
                RonPortalSession::getValue('jenTypProhlidky'), ['id' => 'filterform_jentypprohlidky'], 'clickAutoSubmit', 1);
            echo '</span>';

            $sql = 'SELECT S_TypLekarskeProhlidky.Kod, S_TypLekarskeProhlidky.Popis FROM S_TypLekarskeProhlidky ';

            $combo = new ComboBox('typprohlidky');
            $combo->className = 'adsfilterforminput_full';
            $combo->dataTypeComparison = false;
            $combo->htmlParams = [ //'onChange="if (jenTypProhlidky.checked)submit();"';
                'data-ron-autosubmit' => '1',
                'data-ron-autosubmit-check' => '#filterform_jentypprohlidky'
            ];
            $combo->loadData($this->database, $sql, RonPortalSession::getValue('typProhlidky'));
            $combo->render();
        echo "</div>";
    }

    /**
     * @throws DBException
     */
    function renderProhlidka()
    {
        echo '<div class="filterrow" id="filterrow_prohlidka">';
        {
            echo '<span class="filtercaption">';
            GuiUtils::renderCheckbox('jenvyberprohlidka', TextManager::_('prohlidka'),
                RonPortalSession::getValue('jenVyberProhlidka'), ['id' => 'filterform_jenprohlidka'], 'clickAutoSubmit', 1);
            echo '</span>';

            $sql = 'SELECT LekarskaProhlidka.Kod, LekarskaProhlidka.Popis FROM LekarskaProhlidka ';

            $combo = new ComboBox('vyberprohlidka');
            $combo->className = 'adsfilterforminput_full';
            $combo->dataTypeComparison = false;
            $combo->htmlParams = [   //'onChange="if (jenVyberProhlidka.checked)submit();"';
                'data-ron-autosubmit' => '1',
                'data-ron-autosubmit-check' => '#filterform_jenprohlidka'
            ];

            $combo->loadData($this->database, $sql, RonPortalSession::getValue('vyberProhlidka'));
            $combo->render();
        }
        echo "</div>";
    }

    /**
     * @throws DBException
     */
    function renderVysledekProhlidky()
    {
        echo '<DIV class="filterrow" id="filterrow_vysledekprohlidky">';
        {
            echo '<SPAN class="filtercaption">';
            GuiUtils::renderCheckbox('jenvysledekprohlidky', TextManager::_('vysledek'),
                RonPortalSession::getValue('jenVysledekProhlidky'), ['id' => 'filterform_jenvysledekprohlidky'], 'clickAutoSubmit', 1);
            echo '</SPAN>';

            $sql = 'SELECT S_VyhodnoceniProhlidky.Kod, S_VyhodnoceniProhlidky.Popis FROM S_VyhodnoceniProhlidky ';

            $combo = new ComboBox('vysledekprohlidky');
            $combo->className = 'adsfilterforminput_full';
            $combo->dataTypeComparison = false;
            $combo->htmlParams = [ // 'onChange="if (jenVysledekProhlidky.checked)submit();"';
                'data-ron-autosubmit' => '1',
                'data-ron-autosubmit-check' => '#filterform_jenvysledekprohlidky'
            ];
            $combo->loadData($this->database, $sql, RonPortalSession::getValue('vysledekProhlidky'));
            $combo->render();
        }
        echo "</DIV>";
    }

    function renderPovinna()
    {
        echo '<DIV class="filterrow">';
        echo '<span class="filtercaption">' . TextManager::_('zobraz_zdravotnicke_prohlidky') . '</span>';

        $data = array(
            0 => TextManager::_('Vse'),
            1 => TextManager::_('absolvovana'),
            2 => TextManager::_('neabsolvovana')
        );

        LinksList::renderLinks($data,
            RonPortalSession::getValue('vseAbsolvovanaNeabsolvovana') ?: 0,
            $this ->f_formaction .  '&van=', '', false);

        echo '</DIV>';
    }

    function renderZadatLekarskouProhlidku()
    {
        echo '<DIV class="filterrow">';
        echo '<SPAN class="filtercaption">';
        echo '<a href="?menuid=lekarskeprohlidky&formaction=new">';
        echo TextManager::_('zadat_zdravotni_prohlidku');
        echo '</a>';
        echo '</SPAN>';
        echo "</DIV>";
    }


    /**
     * @throws DBException
     * @throws \Exception
     */
    function renderFilters()
    {
        if ($this->f_showrozdeleni) $this->renderRozdeleni();
        if ($this->f_showrozdeleni2) {
            $this->renderRozdeleni2();
        }

        if ($this->f_showosoba) $this->renderOsoby();
        if ($this->f_link) $this->renderLink();
        $this->renderTypProhlidky();
        $this->renderProhlidka();
        $this->renderVysledekProhlidky();
        $this->renderPovinna();

//        if(Prava::vratPrava('lekarske_edit')->lzeZobrazitRC($this->vybranaOsobaRC, time(), time())){
//            $this->renderZadatLekarskouProhlidku();
//        }
        if (Prava::vratPrava('lekarske_edit')->jsouNejakePrava()) {
            $this->renderZadatLekarskouProhlidku();
        }
    }

    private function loadTypProhlidky()
    {
        if (isset($_GET['typprohlidky'])){
            RonPortalSession::setValue('jenTypProhlidky', isset($_GET['jentypprohlidky']) ? (int)$_GET['jentypprohlidky'] : 0);
            RonPortalSession::setValue('typProhlidky', $_GET['typprohlidky']);
        }
    }

    private function loadProhlidka()
    {
        if (isset($_GET['vyberprohlidka'])){
            RonPortalSession::setValue('jenVyberProhlidka', isset($_GET['jenvyberprohlidka']) ? (int)$_GET['jenvyberprohlidka'] : 0);
            RonPortalSession::setValue('vyberProhlidka', $_GET['vyberprohlidka']);
        }
    }

    private function loadVysledekProhlidky()
    {
        if (isset($_GET['vysledekprohlidky'])){
            RonPortalSession::setValue('jenVysledekProhlidky', isset($_GET['jenvysledekprohlidky']) ? (int)$_GET['jenvysledekprohlidky'] : 0);
            RonPortalSession::setValue('vysledekProhlidky', $_GET['vysledekprohlidky']);
        }
    }

    private function loadUrovenProhlidky()
    {
        if(isset($_GET['van'])){
            RonPortalSession::setValue('vseAbsolvovanaNeabsolvovana', $_GET['van']);
        }
    }

    private function loadVcetnePodrizenych2()
    {
        if(isset($_POST['adsfilterform'])){
            RonPortalSession::setValue('vcetnePodrizenych2', isset($_POST['vcetnePodrizenych2'])  &&  $_POST['vcetnePodrizenych2']);
        }
    }


    function loadData()
    {
        parent::loadData();
        $this->loadUrovenProhlidky();
        $this->loadTypProhlidky();
        $this->loadProhlidka();
        $this->loadVysledekProhlidky();
        $this->loadVcetnePodrizenych2();
    }
}

/**
 * Class DatumAbsolvovaniProhlidkyField
 * @package RonPortal\Personalistika
 */
class DatumAbsolvovaniProhlidkyField extends BrowserField
{

    private $prava;

    /**
     * DatumAbsolvovaniProhlidkyField constructor.
     * @param null|Database $database
     * @param PravaNaOsoby $prava
     * @internal param array|null $options
     */
    public function __construct($database, $prava)
    {
        parent::__construct($database);

        $this
            ->setHeaderText('datum_absolvovani')
            ->setAlign('center') ->setOrdering(1)
            ->setCode('col-datum-absolvovani')
            ->setSortSQL('GenerovaneLekProhlidky.DatumAbsolvovani')
            ->setSortSQLDesc('GenerovaneLekProhlidky.DatumAbsolvovani DESC');

        $this->prava = $prava;
    }

    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     * @throws \Exception
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = '';
        $idosoby = $rowData[LekarskeProhlidkyBrowser::ID_PP_INDEX];

        //Pokud je prohlidka absolvovana pak nezobrazit odkaz ale pouze "absolvovano"

        if ($rowData[LekarskeProhlidkyBrowser::VYSLEDEK_PROHLIDKY_INDEX] != null || $rowData[LekarskeProhlidkyBrowser::VYSLEDEK_PROHLIDKY_INDEX] != "") {
            if ($rowData[LekarskeProhlidkyBrowser::DATUM_ABSOLVOVANI_INDEX] != '') {
                $result .= StringUtils::format('date', $this->database->stringToTimestamp($rowData[LekarskeProhlidkyBrowser::DATUM_ABSOLVOVANI_INDEX]));
            } else {
                $result .= "<span title='" . TextManager::_('lekarska_prohlidka_absolvovano_info') . "'>" . TextManager::_('lekarska_prohlidka_absolvovano') . "</span>";
            }

        } else {

            if ($rowData[LekarskeProhlidkyBrowser::DATUM_ABSOLVOVANI_INDEX] == '' && $this->prava->lzeZobrazitRC($rowData[LekarskeProhlidkyBrowser::ID_OSOBY_INDEX])) {
                $result .= '<a href="?menuid=lekarskeprohlidky&formaction=edit&osoba=' . $idosoby .
                    '&kod=' . HttpUtils::urlEncode($rowData[LekarskeProhlidkyBrowser::KOD_PROHLIDKY_INDEX]) . '&absolvovat=1' .
                    '&vznik=' . $this->database->stringToTimestamp($rowData[LekarskeProhlidkyBrowser::DATUM_POVINNOSTI_INDEX]) . '">';
                $result .= TextManager::_('absolvovat');
                $result .= '</a>';
            }
        }
        return  $result;
    }
}

/**
 * Class DetailProhlidkyField
 * @package RonPortal\Personalistika
 */
class DetailProhlidkyField extends BrowserField
{
    private $prava;

    /**
     * DetailProhlidkyField constructor.
     * @param null|Database $database
     * @param PravaNaOsoby $prava
     * @internal param array|null $options
     */
    public function __construct($database, $prava)
    {
        parent::__construct($database);
        $this->header = TextManager::_('detail');
        $this->align = "center";
        $this ->code = "col-detail";

        $this->prava = $prava;
    }

    /**
     * @param mixed $value
     * @param int $rowNumber
     * @param string $recordId
     * @param array $rowData
     * @return string
     * @throws \Exception
     */
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $lzeEditovat = $this->prava->lzeZobrazitRC($rowData[LekarskeProhlidkyBrowser::ID_OSOBY_INDEX]);

        return
            '<a href="?menuid=lekarskeprohlidky&' . ($lzeEditovat ? 'formaction=edit' : 'action=detail') .
            '&osoba=' . $rowData[LekarskeProhlidkyBrowser::ID_PP_INDEX] .
            '&kod=' . HttpUtils::urlEncode($rowData[LekarskeProhlidkyBrowser::KOD_PROHLIDKY_INDEX]) .
            '&vznik=' . $this->database->stringToTimestamp($rowData[LekarskeProhlidkyBrowser::DATUM_POVINNOSTI_INDEX]) .
            '"' .
            (RonPortalSettings::getIntValue('otevreni_detailu') ? ' target="_blank"' : '') .
            '>' .
            TextManager::_('detail') .
            '</a>';
    }
}


/**
 * Class LekarskeProhlidkyBrowser
 * @package RonPortal\Personalistika
 */
class LekarskeProhlidkyBrowser extends RonPortalBrowser
{
    const DATUM_POVINNOSTI_INDEX = 0;
    const DATUM_ABSOLVOVANI_INDEX = 1;
    const KOD_PROHLIDKY_INDEX = 2;
    const ID_PP_INDEX = 14;
    const ID_OSOBY_INDEX = 18;
    const VYSLEDEK_PROHLIDKY_INDEX = 19;

    /** @var PravaNaOsoby  */
    var $pravaProhlizet;
    /** @var PravaNaOsoby  */
    var $pravaZapis;
    /** @var PravaNaOsoby  */
    var $pravaAbsolvovat;

    /** @var  LekarskeProhlidkyFilterForm */
    //var $filterForm;

    /**
     * LekarskeProhlidkyBrowser constructor.
     * @param Database $database
     * @throws \Exception
     */
    function __construct($database)
    {
        parent::__construct($database, 'lekarskeprohlidky');

        $this->pravaProhlizet = Prava::vratPrava('lekarske_prohl');
        $this->pravaZapis = Prava::vratPrava('lekarske_edit');
        $this->pravaAbsolvovat = Prava::vratPrava('lekarske_absolv');

        $this->title = TextManager::_('zdravotni_prohlidky');
        $this->code = 'browserlekarskeprohlidky';
        $this->tableId = 'browserlekarskeprohlidky';

        $this->sqlSelectPart =
            'GenerovaneLekProhlidky.DatumVznikuPovinnosti, GenerovaneLekProhlidky.DatumAbsolvovani, GenerovaneLekProhlidky.KodLekarskeProhlidky, ' .    //0 - 2
            'LekarskaProhlidka.Popis, S_DuvodProhlidky.Popis, GenerovaneLekProhlidky.Generovana, {fn_CASTWIDEMEMO(GenerovaneLekProhlidky.VysledekProhlidky)}, ' . //3 - 6
            'GenerovaneLekProhlidky.OsetrujiciLekar, {fn_CASTWIDEMEMO(GenerovaneLekProhlidky.Poznamka)}, Osoba.Jmeno, Osoba.Prijmeni, S_VyhodnoceniProhlidky.Popis, '   .    //7 - 11
            "S_DuvodProhlidky.Popis, COALESCE(OsetrujiciLekar.JmenoLekare,'') {fn_concat()} ' ' {fn_concat()} COALESCE(OsetrujiciLekar.Prijmeni,''), " .    //12 - 13
            '(SELECT MAX(ID) FROM PracovniPomer WHERE PracovniPomer.RC = Osoba.RC ), ' .  //14
            '{fn_CASTWIDEMEMO(GenerovaneLekProhlidky.DoplnujiciTextPozvanky)}, GenerovaneLekProhlidky.CasProhlidkyRezervovany, DatumProhlidkyRezervovany, Osoba.RC, GenerovaneLekProhlidky.Vysledek '; //15 - 19

        $this->sqlFromPart =
            'Osoba JOIN GenerovaneLekProhlidky ON (GenerovaneLekProhlidky.RC = Osoba.RC)' .
            ' LEFT OUTER JOIN OsetrujiciLekar ON (GenerovaneLekProhlidky.OsetrujiciLekar = OsetrujiciLekar.Kod)' .
            ' LEFT OUTER JOIN  LekarskaProhlidka ON (GenerovaneLekProhlidky.KodLekarskeProhlidky = LekarskaProhlidka.Kod)' .
            ' LEFT OUTER JOIN  S_DuvodProhlidky ON (GenerovaneLekProhlidky.DuvodProhlidky = S_DuvodProhlidky.Kod )' .
            ' LEFT OUTER JOIN  S_TypLekarskeProhlidky ON  (LekarskaProhlidka.TypProhlidky = S_TypLekarskeProhlidky.Kod )' .
            ' LEFT OUTER JOIN  S_VyhodnoceniProhlidky ON  (GenerovaneLekProhlidky.Vysledek = S_VyhodnoceniProhlidky.Kod )';

        $this->browserUrl = '?menuid=lekarskeprohlidky&';

        $this ->filterForm = new LekarskeProhlidkyFilterForm($this ->database, $this->pravaProhlizet, $this->pravaAbsolvovat, $this->pravaZapis);
        $this ->filterForm ->loadData();

        $this->addField(BrowserField::FIELD_TYPE_LINE)
            ->setCode('col-line');

        $this->addField()
            ->setSqlFieldName('GenerovaneLekProhlidky.DatumVznikuPovinnosti', 0)
            ->setCode('col-datum-vzniku')
            ->setHeaderText('datum_povinnosti') ->setFormat('date') ->setAlign('center') ->setOrdering(1);

        //Urci podle ktereho fieldu se bude defaultne radit
        $this->defaultSort = count($this->fields);

        if (RonPortalSettings::getIntValue('lekprohl_rezervovany')) {
            $this->addField()
                ->setSqlFieldName('GenerovaneLekProhlidky.CasProhlidkyRezervovany', 16)
                ->setCode('col-cas-rezervace')
                ->setHeaderText('rezervovany_cas') ->setFormat('time') ->setAlign('center') ->setOrdering(1);

            $this->addField()
                ->setSqlFieldName('GenerovaneLekProhlidky.DatumProhlidkyRezervovany', 17)
                ->setCode('col-datum-rezervace')
                ->setHeaderText('rezervovany_datum') ->setFormat('date') ->setAlign('center') ->setOrdering(1);
        }

        //Zobrazeni odkazu Absolvovani nebo pouze datumu
        $this->addField(new DatumAbsolvovaniProhlidkyField($this->database, $this->pravaAbsolvovat));

        //filtr na Vse/Absolvovana/Povinne
        if (isset($_GET['van']) && ($_GET['van'] == 0 || $_GET['van'] == 1)) {
            $this->addField()
                ->setSqlFieldName('S_VyhodnoceniProhlidky.Popis', 11)
                ->setCode('col-vysledek')
                ->setHeaderText('vysledek') ->setAlign('center') ->setOrdering(1);
        }

        $this->addField(new DetailProhlidkyField($this->database, $this->pravaZapis));

        $this->addField()
            ->setSqlFieldName('GenerovaneLekProhlidky.KodLekarskeProhlidky', 2)
            ->setCode('col-kod')
            ->setHeaderText('kod_zdravotni_prohlidky') ->setAlign('center') ->setOrdering(1);

        $this->addField()
            ->setSqlFieldName('LekarskaProhlidka.Popis', 3)
            ->setCode('col-popis')
            ->setHeaderText('popis_zdravotni_prohlidky') ->setOrdering(1);

        $this->addField()
            ->setSqlFieldName('S_DuvodProhlidky.Popis', 4)
            ->setCode('col-duvod')
            ->setHeaderText('duvod_zdravotni_prohlidky') ->setOrdering(1);

        $this->addField()
            ->setSqlFieldName('GenerovaneLekProhlidky.Generovana', 5)
            ->setCode('col-generovana') ->setFormat('anone')
            ->setHeaderText('generovana_zdravotni_prohlidka') ->setAlign('center') ->setOrdering(1);

        $this->addField()
            ->setSqlFieldName("OsetrujiciLekar.JmenoLekare + ' ' + OsetrujiciLekar.Prijmeni", 13)
            ->setCode('col-lekar')
            ->setHeaderText('osetrujici_lekar') ->setOrdering(1);

        $this->addField()
            ->setSqlFieldName('Osoba.Prijmeni', 10)
            ->setCode('col-prijmeni') ->setVisible($this ->filterForm ->vsechnyOsoby)
            ->setHeaderText('Prijmeni') ->setOrdering('ordering');

        $this->addField()
            ->setSqlFieldName('Osoba.Jmeno', 9)
            ->setCode('col-jmeno') ->setVisible($this ->filterForm ->vsechnyOsoby)
            ->setHeaderText('Jmeno') ->setOrdering(1);

        $this->addField(new  OsobniCisloBrowserField($this->database, self::ID_OSOBY_INDEX))
            ->setCode('col-osobni-cislo')
            ->setVisible($this ->filterForm ->vsechnyOsoby)
            ->setAlign('center');
    }


    function setFilterForm()
    {
        // parent::setFilterForm(); - nevolat
    }
    
    function renderLine($values, $className, $rowNumber, $edit = false)
    {
        parent::renderLine($values, $className, $rowNumber, $edit);

        //Doplnujici poznamka
        if(RonPortalSettings::getIntValue('lekprohl_doplnujici_text')) {
            $hodnotaSloupce = 15;
            if ($values[$hodnotaSloupce]) {
                echo "<tr class='$className'>";
                echo '<td></td><td colspan="' . ($this->columnCount - 1) . '">';
                echo '<span class="poznamka doplnujiciText">' . TextManager::_('doplnujici_text') .  ': ' .StringUtils::htmlTextConvert($values[$hodnotaSloupce]) . '</span>';
                //echo '<td colspan="2"></td></tr>';
            }
        }

        //poznamka
        if(RonPortalSettings::getIntValue('lekprohl_poznamka')) {
            $hodnotaSloupce = 8;
            if ($values[$hodnotaSloupce]) {
                echo "<tr class='$className'>";
                echo '<td></td><td colspan="' . ($this->columnCount - 1) . '">';
                echo '<span class="poznamka poznamkaLekarskeProhlidky">' . TextManager::_('Poznamka') . ': ' . StringUtils::htmlTextConvert($values[$hodnotaSloupce]) . '</span>';
                //echo '<td colspan="2"></td></tr>';
            }
        }

        //vysledek prohlidky
        if(RonPortalSettings::getIntValue('lekprohl_vysledek_prohlidky')) {
            $hodnotaSloupce = 6;
            if ($values[$hodnotaSloupce]) {
                echo "<tr class='$className'>";
                echo '<td></td><td colspan="' . ($this->columnCount - 1) . '">';
                echo '<span class="poznamka vysledekProhlidky">' . TextManager::_('vysledek_prohlidky') . ': ' . StringUtils::htmlTextConvert($values[$hodnotaSloupce]) . '</span>';
                //echo '<td colspan="2"></td></tr>';
            }
        }
    }


    public function getSQLFilter()
    {
        $params = $this->database->createParameters();

        $datum = DateUtils::today();

        //Overeni prav
        $result =
            "EXISTS(SELECT PP.RC FROM PracovniPomer PP " .
            "WHERE (PP.RC = Osoba.RC) " .
            ' AND ((' . $this->pravaProhlizet->sqlFiltr('PP', $datum, $datum, $params) . ')' .
            '       OR (' . $this->pravaZapis->sqlFiltr('PP', $datum, $datum, $params) . ')' .
            '       OR (' . $this->pravaAbsolvovat->sqlFiltr('PP', $datum, $datum, $params) . ')' .
            '     )' .
            " AND (PP.DatumNastupu <= " . $params->addParameter($this->database->dateToParam($datum)) . ")" .
            " AND ((PP.DatumUkonceni >= " . $params->addParameter($this->database->dateToParam($datum)) . ") OR (PP.DatumUkonceni IS NULL))";

        if (!$this->filterForm->vsechnyOsoby) {
            $result .= " AND PP.RC = " . $params->addParameter($this->filterForm->vybranaOsobaRC);
        } else {
            if ($this->filterForm->kodRozdeleni != '') {
                $result .= ' AND ' . RozdeleniUtils::sqlFilterRozdeleniPP($this->database, 'PP',
                        $this->filterForm->f_typrozdeleni, $this->filterForm->kodRozdeleni,
                        $datum, $datum,
                        $this->filterForm->vcetnePodrizenychRozdeleni, $params);
            }
            if ($this->filterForm->kodRozdeleni2 != '') {
                $result .= ' AND ' . RozdeleniUtils::sqlFilterRozdeleniPP($this->database, 'PP',
                        $this->filterForm->f_typrozdeleni2, $this->filterForm->kodRozdeleni2,
                        $datum, $datum,
                        $this->filterForm->vcetnePodrizenychRozdeleni2, $params);
            }
        }

        $result .=
            ')';

        if (RonPortalSession::getValue('jenTypProhlidky')) {
            $result .= " AND S_TypLekarskeProhlidky.Kod = " . $params->addParameter(RonPortalSession::getValue('typProhlidky'));
        }

        if (RonPortalSession::getValue('jenVyberProhlidka')) {
            $result .= " AND LekarskaProhlidka.Kod = " . $params->addParameter(RonPortalSession::getValue('vyberProhlidka'));
        }

        if (RonPortalSession::getValue('jenVysledekProhlidky')) {
            $result .= " AND S_VyhodnoceniProhlidky.Kod = " . $params->addParameter(RonPortalSession::getValue('vysledekProhlidky'));
        }

        /* 0 => ('Vse'), 1 => ('absolvovana'), 2 => ('neabsolvovana')*/
        if (!RonPortalSession::getValue('vseAbsolvovanaNeabsolvovana')) {
            $result .= ' AND (GenerovaneLekProhlidky.DatumAbsolvovani IS NOT NULL ';
            $result .= ' OR GenerovaneLekProhlidky.DatumAbsolvovani IS NULL) ';
        }
        elseif (RonPortalSession::getValue('vseAbsolvovanaNeabsolvovana') == 1) {
            $result .= ' AND GenerovaneLekProhlidky.DatumAbsolvovani IS NOT NULL ';
        }
        elseif (RonPortalSession::getValue('vseAbsolvovanaNeabsolvovana') == 2) {
            $result .= ' AND GenerovaneLekProhlidky.DatumAbsolvovani IS NULL ';
        }

        return new SqlStatement($result, $params);
    }
}