<?php
/**
 * Roman.Szablatura 24.2.2016
 */

namespace RonPortal\Pomucky;

use Ron\Controls\ComboBox;
use Ron\Controls\FormField;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\DBRecord;
use Ron\DB\DBUtils;
use Ron\DB\SqlStatement;
use Ron\DB\SQLUtils;
use Ron\StringUtils;
use RonPortal\Controls\OsobaFormField;
use RonPortal\Controls\RonPortalForm;
use RonPortal\PracovniPomer;
use RonPortal\Prava;
use RonPortal\RonPortalSession;
use RonPortal\RonPortalUtils;


/**
 * Class OsobaPracovnichPomucekField
 */
class OsobaPracovnichPomucekField extends OsobaFormField
{
    /**
     * @param string $prava
     * @param int $datumPlatnostiPP
     * @param PracovniPomer $pp
     */
    public function __construct($prava, $datumPlatnostiPP, $pp)
    {
        parent::__construct($prava, $datumPlatnostiPP, false);

        $this->pracovniPomer = $pp;
    }

    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
    {
        if ($insert) {
            parent::showFieldContent($database, $value, $canEdit, $insert, $rowData);
        }
        elseif ($this->pracovniPomer) {
            echo '<input type="hidden" name="' . $this->fieldName . '" value="' . $this->pracovniPomer->idPP . '" />';
            //echo StringUtils::htmlTextConvert($this->pracovniPomer->jmenoPrijmeniKratke) . "\n";
            echo $this->pracovniPomer->jmenoPrijmeniKratke;
        }
    }
}


///**
// * Class VybratOsobuField
// */
//class VybratOsobuField extends FormField
//{
//    /** @var PravaNaOsoby */
//    var $prava;
//
//    /**
//     * VybratPracPomuckuField constructor.
//     * @param null $prava
//     * @param bool $edit
//     */
//    function __construct($prava, $edit)
//    {
//        parent::__construct();
//
//        $this->prava = $prava;
//        $this->editable = $edit;
//        $this->required = true;
//        $this->caption = \Ron\ronText('Osoba');
//    }
//
//    /**
//     * @param \Ron\DB\Database $database
//     * @param mixed $value
//     * @param bool $canedit
//     * @param bool $insert
//     * @param array $rowData
//     * @throws \Ron\DB\DBException
//     */
//    function showFieldContent($database, $value, $canedit, $insert, $rowData)
//    {
//        if($canedit){
//            $comboOsoba = new ComboBoxZamestnanec('osoba'); // jmeno promenne
//            $comboOsoba ->className = 'app_combo adsfilterforminput_full';
//
//            $comboOsoba->loadDataPP($database,
//                time(), time(), $this->prava,
//                false, RonPortalSession::vybranaOsoba()); // $emptyrow = false, $selectedvalue, vcetneexternich
//            $comboOsoba->render();
//        }else{
//            $sql =
//                "SELECT COALESCE(Osoba.Prijmeni,'') + ' ' + COALESCE(Osoba.Jmeno,'') + COALESCE(', ' + Osoba.Titul,''), PracovniPomer.OsobniCislo, PracovniPomer.DatumNastupu, " . //0 - 2
//                "(SELECT COUNT(*) FROM PracovniPomer WHERE PracovniPomer.RC = Osoba.RC AND PracovniPomer.DatumNastupu <= " . $database->timestampToString(time()) .
//                "  AND (PracovniPomer.DatumUkonceni >= " . $database->timestampToString(time()) . " OR PracovniPomer.DatumUkonceni IS NULL))" . //3
//                "FROM Osoba JOIN PracovniPomer ON (Osoba.RC = PracovniPomer.RC) WHERE PracovniPomer.ID = " . (int)$_GET['osoba'];
//
//            $cursor = $database->getSqlResult($sql);
//
//            $row = $cursor->fetch();
//
//            $osoba = $row[0];
//
//            if ($row[3] > 1) {
//                $osoba .= ' - ' . \Ron\ronText('Osobni_cislo'). ' ' . $row[1] . ', ' . \Ron\ronText('Datum_nastupu') . ' ' . StringUtils::format('date',$database->stringToTimestamp($row[2]));
//            }
//            echo  $osoba;
//        }
//        /* $this->addField([ FORM_FIELD_TYPE => FORM_FIELD_TYPE_TEXT, FORM_FIELD_NAME => 'uzivatel',
//            FORM_FIELD_SQL_INDEX => 4, FORM_FIELD_CAPTION_TEXT =>  \Ron\ronText('Jmeno_a_prijmeni'), FORM_FIELD_TEXT => S_GetOsobaJmenoPrijmeni() ,FORM_FIELD_EDIT => 0 ]);*/
//    }
//}

/**
 * Class VybratPracPomuckuField
 */
class VybratPracPomuckuField extends FormField
{
    /**
     * VybratPracPomuckuField constructor.
     */
    function __construct()
    {
        parent::__construct(FormField::FIELD_TYPE_SELECT);
    }

    /**
     * @param \Ron\DB\Database $database
     * @param mixed $value
     * @param bool $canEdit
     * @param bool $insert
     * @param array $rowData
     * @throws \Ron\DB\DBException
     */
    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
    {
        if ($canEdit) {
//            $sql =
//                "SELECT PP.Kod,  +'" . \Ron\ronText('Typ') . ": ' + PP.TypPomucky + ' - " . \Ron\ronText('Popis') . ": ' + PP.Popis " .  //0 - 2
//                "FROM PracovniPomucka PP " .
//                "WHERE NOT EXISTS (SELECT * FROM PrirazenaPracPomucka WHERE PrirazenaPracPomucka.PracovniPomucka = PP.Kod " .
//                " AND PrirazenaPracPomucka.DatumVydani <= " . $database->timestampToString(DateUtils::startOfTheDay(time())) .
//                " AND (PrirazenaPracPomucka.DatumVraceni >= " . $database->timestampToString(DateUtils::startOfTheDay(time())) .
//                "   OR PrirazenaPracPomucka.DatumVraceni is null)) " .
//                " AND PP.Stav = 1 " .
//                " ORDER BY PP.TypPomucky, PP.Popis";

//            "SELECT PracovniPomucka.Kod, PracovniPomucka.Popis + ' " . \Ron\ronText('Typ') . ": ' + PracovniPomucka.TypPomucky" .   //0 - 2
//            ' FROM PracovniPomucka, TypPomucky ' .
//            ' WHERE (PracovniPomucka.TypPomucky = TypPomucky.Kod) ' .
//            " AND ((PracovniPomucka.kod = '') " .
//            " OR ((PracovniPomucka.Stav=1 OR PracovniPomucka.Stav=2 OR (PracovniPomucka.Stav=3 AND PracovniPomucka.VyrazenoDoData IS NOT NULL AND PracovniPomucka.VyrazenoDoData < " . $database->timestampToString(DateUtils::startOfTheDay(time())) . ")) " .
//            //" AND ((TypPomucky.Sledovany=0) OR ((TypPomucky.Sledovany=1) " .
//            ' AND NOT EXISTS(select * from PrirazenaPracPomucka' .
//            "   WHERE PracovniPomucka=PracovniPomucka.Kod and ((DatumVraceni IS NULL) OR (DatumVraceni > " . $database->timestampToString(DateUtils::startOfTheDay(time())) . "))) )) )" .
//            ')' .
//            ' ORDER BY PracovniPomucka.Kod';
//
            echo '<div class="row">';
            echo '<div class="col col-9">';
            $sql =
                //"SELECT PracovniPomucka.Kod,  +'" . \Ron\ronText('Typ') . ": ' + PracovniPomucka.TypPomucky + ' - " . \Ron\ronText('Popis') . ": ' + PracovniPomucka.Popis " .  //0 - 2
                "SELECT PracovniPomucka.Kod, PracovniPomucka.Popis {fn_concat()} ' " . \Ron\ronText('Typ') . ": ' {fn_concat()} PracovniPomucka.TypPomucky" .   //0 - 2
                ' FROM PracovniPomucka, TypPomucky ' .
                ' WHERE (PracovniPomucka.TypPomucky = TypPomucky.Kod) ' .
                ' AND ' .
                '  (PracovniPomucka.Stav=1 OR PracovniPomucka.Stav=2' .
                "   OR (PracovniPomucka.Stav=3 AND PracovniPomucka.VyrazenoDoData IS NOT NULL AND PracovniPomucka.VyrazenoDoData < " . $database->dateToString(time()) . ')' .
                ' )' .
                " AND ((TypPomucky.Sledovany=0) OR ((TypPomucky.Sledovany=1) " .
                " AND NOT exists(select * from PrirazenaPracPomucka where PracovniPomucka=PracovniPomucka.Kod and ((DatumVraceni IS NULL) OR (DatumVraceni > " . $database->dateToString(time()) .
                ')))))';

            $combo = new ComboBox($this ->fieldName);
            $combo->emptyRow = ' ';

            //$combo->alwaysShowSelected = isset($value) && $value != '';
            $combo->className .= ' form-input';
            $combo->loadData($database, $sql . ' ORDER BY PracovniPomucka.Popis', $value);
            $combo->showCode = 1;
            $combo->htmlParams = ['data-ron-select2' => $this ->fieldName . '_kod', 'id' => 'kod_pracovni_pomucky'];
            $combo->render();
            echo '</div>';

            echo '<div class="col col-3">';
            $combo = new ComboBox($this ->fieldName . '_kod');
            $combo->emptyRow = ' ';

            //$combo->alwaysShowSelected = isset($value) && $value != '';
            $combo->className .= ' form-input';
            $combo->keyIndex = 0;
            $combo->captionIndex = 0;
            $combo->loadData($database, $sql . ' ORDER BY PracovniPomucka.Kod', $value);
            $combo->htmlParams = ['data-ron-select2' => $this ->fieldName];
            $combo->render();

            echo '</div>'; // col
            echo '</div>'; // row
        } else {
            $params = $database ->createParameters();
            $popisPomucky = DBUtils::getSqlValue($database,
                'SELECT PracovniPomucka.Popis' .
                ' FROM PracovniPomucka' .
                ' WHERE PracovniPomucka.Kod = ' . $params ->addParameter($value),
                $params);

            echo
                StringUtils::htmlTextConvert($popisPomucky) .
                '<input type="hidden" name="' . $this->fieldName . '" value="' . StringUtils::htmlTextConvert($value) . '"/>';
        }
    }
}


class DetailPracovniPomuckyField extends FormField
{
    /** @var Database */
    var $database;

    /**
     * DetailPracovniPomuckyField constructor.
     * @param $database
     */
    public function __construct($database)
    {
        parent::__construct(FormField::FIELD_TYPE_TEXT);
        $this->database = $database;
    }


    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
    {
        $value = isset($_POST['PracovniPomucka'])
            ? $_POST['PracovniPomucka']
            : ($rowData  ?  $rowData[4] : null);

        /** @noinspection PhpUnusedLocalVariableInspection */
        $pracovniPomucka = ($value)
            ? PracovniPomucka::nactiPomucku($this ->database, $value)
            : null;

        require 'ronportal/pomucky/view_detail_pomucky.php';
    }
}



/**
 * Class DoporucenaVelikostPomuckyField
 */
class DoporucenaVelikostPomuckyField extends FormField
{
    function __construct()
    {
        parent::__construct(FormField::FIELD_TYPE_TEXT);
        $this->caption = \Ron\ronText('doporucena_velikost');
    }


    /**
     * @param \Ron\DB\Database $database
     * @param mixed $value
     * @param bool $canEdit
     * @param bool $insert
     * @param array $rowData
     * @throws \Ron\DB\DBException
     */
    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
    {
        //parent::showFieldContent($database, $value, $canEdit, $insert, $rowData);
        $idpp = null;
        $rc = null;

        if (isset($_POST['osoba'])) {
            $idpp = $_POST['osoba'] != '' ? (int)$_POST['osoba'] : null;
        } else if ($rowData) {
            $rc = $rowData[7];
        } else {
            $idpp = RonPortalSession::vybranaOsoba();
        }

        $pomucka = isset($_POST['PracovniPomucka'])
            ? $_POST['PracovniPomucka']
            : ($rowData  ?  $rowData[4] : null);

        $doporucenaVelikost = PracovniPomucka::nactiDoporucenouVelikostPomucky($database, $pomucka, $idpp, $rc);

        echo '<span id="doporucenaVelikost">' . StringUtils::htmlTextConvert($doporucenaVelikost) . '</span>';
    }
}

/**
 * Class VydanaVelikostPomuckyField
 */
class VydanaVelikostPomuckyField extends FormField
{
    function __construct()
    {
        parent::__construct(FormField::FIELD_TYPE_SELECT);
        $this->showEmptyValue = true;
    }

    /**
     * @param \Ron\DB\Database $database
     * @param mixed $value
     * @param bool $canEdit
     * @param bool $insert
     * @param array $rowData
     * @throws \Ron\DB\DBException
     */
    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
    {
        if (isset($_POST['PracovniPomucka'])) {
            $pomucka = $_POST['PracovniPomucka'];
        } else if (isset($rowData[4])) {
            $pomucka = $rowData[4];
        } else {
            $pomucka = '';
        }

        $params = $database ->createParameters();
        $this ->setSelectSql(new SqlStatement(
            'SELECT VelikostPPomucky.Velikost, VelikostPPomucky.Velikost' .
            ' FROM VelikostPPomucky, PracovniPomucka, TypPomucky' .
            ' WHERE VelikostPPomucky.TypVelikosti = TypPomucky.TypVelikosti' .
            ' AND PracovniPomucka.TypPomucky = TypPomucky.Kod' .
            ' AND PracovniPomucka.Kod = ' . $params ->addParameter($pomucka),
            $params
        ));


        parent::showFieldContent($database, $value, $canEdit, $insert, $rowData);

//        $sql =
//            "SELECT VelikostPPomucky.TypVelikosti+'~'+VelikostPPomucky.Velikost, VelikostPPomucky.Velikost " .
//            'FROM PracovniPomucka LEFT JOIN TypPomucky ON (PracovniPomucka.TypPomucky = TypPomucky.Kod) LEFT JOIN ' .
//            'TypVelikosti ON (TypPomucky.TypVelikosti = TypVelikosti.Kod) LEFT JOIN VelikostPPomucky ON (TypVelikosti.Kod = VelikostPPomucky.TypVelikosti) ' .
//            "WHERE PracovniPomucka.Kod = '" . (isset($_POST['pomucka']) ? $_POST['pomucka'] : $_GET['pomucka']) . "'";
//
//        $cursor = $database->getSqlResult($sql);
//        $row = $cursor->fetch();
//
//        if($row[0] != '') {
//            $combo = new ComboBox('velikost');
//            $combo->alwaysShowSelected = isset($value) && $value != '';
//            $combo->className .= 'app_combo adsfilterforminput_kod';
//            $combo->loadData($database, $sql, isset($_POST['doporucenaVelikostPomucky']) ? $_POST['doporucenaVelikostPomucky'] : 0);
////        $combo->showCode = 1;
//            $combo->render();
//        }
    }
}


//class DoporucenaExpiraceFormField extends FormField
//{
//    /**
//     * DoporucenaExpiraceFormField constructor.
//     * @param $options
//     */
//    function __construct($options)
//    {
//        parent::__construct($options);
//        $this->caption = "<DIV title='" . \Ron\ronText('doporucena_expirace_pomucky') . "'>" . \Ron\ronText('expirace_pomucky');
//    }
//
//    /**
//     * @param \Ron\DB\Database $database
//     * @param mixed $value
//     * @param bool $canEdit
//     * @param bool $insert
//     * @param array $rowData
//     * @throws \Ron\DB\DBException
//     */
//    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
//    {
//        parent::showFieldContent($database, $value, $canEdit, $insert, $rowData);
//
//        $sql =
//            'SELECT ExpiraceRok *12 + ExpiraceMesic ' .
//
//            'FROM Osoba LEFT JOIN PracovniPomer ON (Osoba.RC = PracovniPomer.RC) LEFT JOIN ' .
//            'RozdeleniOsob ON (PracovniPomer.RC = RozdeleniOsob.RC and PracovniPomer.datumNastupu = RozdeleniOsob.datumNastupu ' .
//            'AND PracovniPomer.osobniCislo = RozdeleniOsob.osobniCislo) LEFT JOIN ' .
//            'Rozdeleni ON (Rozdeleni.Kod = RozdeleniOsob.Rozdeleni AND Rozdeleni.KodTypuRozdeleni = RozdeleniOsob.KodTypuRozdeleni) ' .
//            'LEFT JOIN PomuckyNaPracMiste ON (PomuckyNaPracMiste.KodTypuRozdeleni = Rozdeleni.KodTypuRozdeleni AND PomuckyNaPracMiste.KodRozdeleni = Rozdeleni.Kod)' .
//
//            'WHERE  RozdeleniOsob.DatumNastupu <= ' . $database->timestampToString(time()) . ' ' .
//            'AND (PracovniPomer.DatumUkonceni >= ' . $database->timestampToString(time()). ' ' .
//            'OR PracovniPomer.DatumUkonceni IS NULL) AND RozdeleniOsob.PlatnostOd <= ' . $database->timestampToString(time()) . ' ' .
//            'AND (RozdeleniOsob.PlatnostDo >= ' . $database->timestampToString(time()) . ' OR RozdeleniOsob.PlatnostDo IS NULL) ' . ' ' .
//            "AND PracovniPomer.ID = " . $_GET['osoba'] . " AND PracovniPomucka = '" . $_GET['pomucka'] . "'";
//
//        $cursor = $database->getSqlResult($sql);
//
//        $row = $cursor->fetch();
//
//        if($row[0] == 0){
//            echo \Ron\ronText('neuvedeno');
//        } else {
//            echo $row[0];
//        }
//    }
//}

/**
 * Class VydejPracovniPomuckyForm
 */
class VydejPracovniPomuckyForm extends RonPortalForm
{
    const TYP_POHYBU_VRACENI = 0;
    const TYP_POHYBU_VYDANI_PRIRAZENE = 1;
    const TYP_POHYBU_VYDANI_NOVE = 2;

    /** @var PracovniPomer */
    protected $pracovniPomer;

    /** @var string     Editovany zaznam - kod pomucky */
    protected $pomucka = null;
    /** @var int        Editovany zaznam - datum naroku */
    protected $datumNaroku = null;
    /** @var int        Editovany zaznam - poradi */
    protected $poradi = null;

    protected $typPohybu;

    /**
     * EditaceDatumuVraceniPomuckyForm constructor.
     * @param \Ron\DB\Database $database
     * @param PracovniPomer $pp
     * @param string $kodPomucky
     * @param int $datumnaroku
     * @param int $poradi
     * @throws \Ron\DB\DBException
     * @throws \Exception
     */
    function __construct($database, $pp, $kodPomucky, $datumnaroku, $poradi)
    {
        parent::__construct($database);

        $this ->pracovniPomer = $pp;

        $this ->pomucka = isset($_POST['PracovniPomucka'])
            ? $_POST['PracovniPomucka']
            : (isset($_GET['pomucka']) ? $_GET['pomucka'] : null);

        $this ->datumNaroku = isset($_POST['datumnaroku'])
            ? $_POST['datumnaroku']
            : (isset($_GET['datumnaroku']) ? $_GET['datumnaroku'] : null);

        $this ->poradi = isset($_POST['poradi'])
            ? $_POST['poradi']
            : (isset($_GET['poradi']) ? $_GET['poradi'] : null);

        $this->htmlAction = '?menuid=pracovnipomucky&action=pomuckyform';
        $this->stornoAction = '?menuid=pracovnipomucky';

        $this->cssClass .= ' pracovnipomuckyform';

        $this ->typPohybu = isset($_POST['vydanipomucky'])
            ? (int)$_POST['vydanipomucky']
            : (int)$_GET['vydanipomucky'];

        $individualni = isset($_POST['individualni'])
            ? (int)$_POST['individualni']
            : (isset($_GET['individualni']) ? (int)$_GET['individualni'] : 0);

        switch ($this ->typPohybu) {
            case self::TYP_POHYBU_VYDANI_NOVE :
                $this ->title = \Ron\ronText('vydej_pomucky_zamestnanci');
                break;

            case self::TYP_POHYBU_VRACENI :
                $this->title = \Ron\ronText('formular_vraceni_pomucky');
                break;

            default :
                $this->title = \Ron\ronText('formular_vydani_pomucky');
        }

        $this->sqlTableName = 'PrirazenaPracPomucka';
        $this->sqlSelectPart =
            'PrirazenaPracPomucka.DatumVydani, PrirazenaPracPomucka.DatumVraceni, ' .   // 0 - 1
             $database->castWideMemo('PrirazenaPracPomucka.Poznamka') . ' as Poznamka, PrirazenaPracPomucka.DatumExpirace, '. // 2 - 3
            'PrirazenaPracPomucka.PracovniPomucka, Individualni, OpakovanyNarok, ' .    //4 - 6
            'PrirazenaPracPomucka.RC'; // 7

//        if (isset($_GET['osoba'])) {
//            $pracovniPomer = new PracovniPomer();
//            $pracovniPomer->nactiPPPodleId($database,$_GET['osoba']);
//            $pracovniPomer->vyberNactenyPP($database,Prava::vratPrava('pomucky_vydej'));
//        }
        if ($pp) {
            $pp ->vyberNactenyPP($database, Prava::vratPrava('pomucky_vydej')); // ? musi to tu byt?
        }

        $osobaField = new OsobaPracovnichPomucekField('pomucky_vydej', DateUtils::now(), $pp);
        $osobaField
            ->setCaption('Osoba')
            ->setOtherHtmlParams([
                'id' => 'osoba',
                'class' => 'form-input'
            ]);
        $this->addField($osobaField);

        $this->addField(new VybratPracPomuckuField())
            ->setFieldName('PracovniPomucka') ->setSqlFieldIndex(4)
            ->setCaption('pracovni_pomucka')
            ->setReadOnly(true);

        $this->addField(new DetailPracovniPomuckyField($this ->database))
            ->setCode('field-detail');

        if($individualni) {
            $this->addField(new DoporucenaVelikostPomuckyField());
            $this->addField(new VydanaVelikostPomuckyField())
                ->setFieldName('VelikostPP') ->setCaption('vydana_velikost')
                ->setFieldId('VelikostPP');
        }

        //Zobrazeni poli s daty a memo
        $this->addField(FormField::FIELD_TYPE_TEXT);
            //->[ FORM_FIELD_TYPE => FORM_FIELD_TYPE_TEXT, FORM_FIELD_CAPTION_TEXT => '&nbsp;']);

        if($individualni) {
            $this->addField(FormField::FIELD_TYPE_CHECK)
                ->setSqlFieldIndex(6) ->setFieldName('OpakovanyNarok')
                ->setCaption('opakovany');
        }

        $this->addField(FormField::FIELD_TYPE_DATE)
            ->setFieldName('DatumVydani') ->setSqlFieldIndex(0) ->setCaption('datum_vydani')
            ->setCode('field-datum-vydani')
            ->setReadOnly(!$this ->typPohybu) ->setUseDefaultValueToEditNull((bool)$this ->typPohybu)
            ->setDefaultValue(StringUtils::format('date', DateUtils::today()));
//        [ FORM_FIELD_TYPE => FORM_FIELD_TYPE_DATE, FORM_FIELD_SQL_NAME => 'DatumVydani',
//            FORM_FIELD_NAME => 'DatumVydani', FORM_FIELD_SQL_INDEX => 0, FORM_FIELD_CAPTION_TEXT => 'datum_vydani',
//            FORM_FIELD_EDIT => (int)$this ->typPohybu, 'useDefaultValueToEditNull' => !!$this ->typPohybu, //  $typPohybu!= 2 ? $typPohybu : $typPohybu,
//            FORM_FIELD_DEFAULT_VALUE => StringUtils::format('date', DateUtils::startOfTheDay(time()))]);

        $this->addField(FormField::FIELD_TYPE_DATE)
            ->setFieldName('DatumVraceni') ->setSqlFieldIndex(1) ->setCaption('datum_vraceni')
            ->setCode('field-datum-vraceni')
            ->setReadOnly((bool)$this ->typPohybu) ->setUseDefaultValueToEditNull($this ->typPohybu == 0)
            ->setDefaultValue($this ->typPohybu == 0 ? StringUtils::format('date', DateUtils::today()) : null);
//        [ FORM_FIELD_TYPE => FORM_FIELD_TYPE_DATE, FORM_FIELD_SQL_NAME => 'DatumVraceni',
//            FORM_FIELD_NAME => 'DatumVraceni', FORM_FIELD_SQL_INDEX => 1, FORM_FIELD_CAPTION_TEXT => 'datum_vraceni', FORM_FIELD_EDIT => !$this ->typPohybu,
//            'useDefaultValueToEditNull' => $this ->typPohybu == 0, FORM_FIELD_DEFAULT_VALUE => $this ->typPohybu == 0 ? StringUtils::format('date', DateUtils::startOfTheDay(time())) : null]);

        $this->addField(FormField::FIELD_TYPE_MEMO)
            ->setFieldName('Poznamka') ->setSqlFieldIndex(2) ->setCaption('Poznamka')
            ->setCode('field-poznamka');
//var_dump($this);
//        [ FORM_FIELD_TYPE => FORM_FIELD_TYPE_MEMO, FORM_FIELD_NAME => 'Poznamka', FORM_FIELD_CAPTION_TEXT => 'text_cinnosti',
//            FORM_FIELD_EDIT => 1, FORM_FIELD_SQL_INDEX => 2, FORM_FIELD_SQL_NAME => 'Poznamka']);
    }

    /**
     * @return string
     * @throws \Ron\DB\DBException
     */
    function getWhereCondition()
    {
//        if (isset($_POST['osoba'])) $osoba = $_POST['osoba'];
//        else if (isset($_GET['osoba'])) $osoba = $_GET['osoba'];
//        else $osoba = '';

//        if (isset($_POST['pomucka'])) $pomucka = $_POST['pomucka'];
//        else if (isset($_GET['pomucka'])) $pomucka = $_GET['pomucka'];
//        else $pomucka = null;
//
//        if (isset($_POST['datumnaroku'])) $datumnaroku = $_POST['datumnaroku'];
//        else if(isset($_GET['datumnaroku'])) $datumnaroku = $_GET['datumnaroku'];
//        else $datumnaroku = null;
//
//        if (isset($_POST['poradi'])) $poradi = $_POST['poradi'];
//        else if(isset($_GET['poradi'])) $poradi = $_GET['poradi'];
//        else $poradi = null;

        //$osobaRC = DBUtils::getSqlValue($this->database,"SELECT RC FROM PracovniPomer WHERE ID = '" . $this->database->addSlashes($osoba) . "'");
        if ($this ->pracovniPomer  &&  $this ->pomucka && $this ->datumNaroku && $this ->poradi) {
            $params = $this ->database ->createParameters();
            return new SqlStatement(
                'RC = ' . $params ->addParameter($this ->pracovniPomer ->rc) .
                ' AND PracovniPomucka = ' . $params ->addParameter($this ->pomucka) .
                ' AND DatumNaroku = ' .  $params ->addParameter($this->database->timestampToParam($this ->datumNaroku)) .
                ' AND Poradi = ' .  $params ->addParameter((int)$this ->poradi),
                $params);
        }

        return '';
    }

    public function renderCommonFields()
    {
        parent::renderCommonFields();

//        if(isset($_POST['pomucka'])) $pomucka = $_POST['pomucka'];
//        else if (isset($_GET['pomucka'])) $pomucka = $_GET['pomucka'];
//        else $pomucka = '';

//        if (isset($_POST['datumnaroku'])) $datumnaroku = $_POST['datumnaroku'];
//        else if(isset($_GET['datumnaroku'])) $datumnaroku = $_GET['datumnaroku'];
//        else $datumnaroku = '';
//
//        if (isset($_POST['poradi'])) $poradi = (int)$_POST['poradi'];
//        else if(isset($_GET['poradi'])) $poradi = (int)$_GET['poradi'];
//        else $poradi = '';

//        if (isset($_POST['vydanipomucky'])) $vydanipomucky = $_POST['vydanipomucky'];
//        else if(isset($_GET['vydanipomucky'])) $vydanipomucky = $_GET['vydanipomucky'];
//        else $vydanipomucky = '';

//        if (isset($_POST['editexpirace'])) $editexpirace = (int)$_POST['editexpirace'];
//        else if(isset($_GET['editexpirace'])) $editexpirace = (int)$_GET['editexpirace'];
//        else $editexpirace = '';

        if (isset($_POST['individualni'])) {
            $individualni = (int)$_POST['individualni'];
        }
        else if(isset($_GET['individualni'])) {
            $individualni = (int)$_GET['individualni'];
        }
        else {
            $individualni = 0;
        }

        //echo '<input type="hidden" name="osoba" value="' . ($this ->pracovniPomer ? $this ->pracovniPomer ->idPP : '') . '" />';
        //echo '<input type="hidden" name="pomucka" value="' . StringUtils::htmlTextConvert($pomucka) . '" />';
        echo '<input type="hidden" name="datumnaroku" value="' . ($this ->datumNaroku ?: '') . '" />';
        echo '<input type="hidden" name="poradi" value="' . ($this ->poradi ?: '') . '" />';
        echo '<input type="hidden" name="vydanipomucky" value="' . $this ->typPohybu . '" />';
        //echo '<input type="hidden" name="typpohybu" value="' . StringUtils::htmlTextConvert($vydanipomucky) . '" />';  // ?? co to je toto?
//        echo '<input type="hidden" name="editexpirace" value="' . $editexpirace . '" />';
        echo '<input type="hidden" name="individualni" value="' . $individualni . '" />';

        echo '';
    }


    /*/**
     * @return bool
     * @throws \Ron\DB\DBException
     * @throws \Exception

    function editRecord()
    {
        if (!$this->checkRequiredFields(true)) {return false;}

        /** @var DBRecord $rec
        $rec = $this->createDBRecord();

        foreach ($this->fields as $i => $field) {
            $rec_field = $field->createDBRecordField($this ->database, $this->sqlTableName, false); // $insert = false
            if ($rec_field) {
                $rec->addDBRecordField($rec_field);
            }
        }

        $rec->where = $this->getWhereCondition();

        if (!$rec->loadRecord()) {throw new \Exception('Chyba pri editaci zaznamu - puvodni zaznam nebyl nalezen!');}

        if (!$this->beforeUpdateRecord($rec)) {return false;}

        if (!$rec->updateRecord()) {return false;}

        return $this->afterUpdateRecord($rec);
    }*/


    function createDBRecordFields($rec, $insert)
    {
        if (isset($_POST['VelikostPP'])  &&  $_POST['VelikostPP'] != '') {
            // jeste nacte typ velikosti k zadane pomucce
            $params = $this ->database ->createParameters();
            $typVelikostiPomucky = DBUtils::getSqlValue($this ->database,
                'SELECT TypPomucky.TypVelikosti' .
                ' FROM PracovniPomucka, TypPomucky' .
                ' WHERE PracovniPomucka.Kod = ' . $params ->addParameter($_POST['PracovniPomucka']) .
                ' AND TypPomucky.Kod = PracovniPomucka.TypPomucky',
                $params);
        } else {
            $typVelikostiPomucky = null;
        }

        $rec->addStringField('RC', true, 15, $this->pracovniPomer->rc);      // $pracPomer->rc
        $rec->addStringField('OsobniCislo', true, 15, $this->pracovniPomer->osobniCislo);   // $pracPomer->osobniCislo
        $rec->addDateField('DatumNastupu', true, $this ->pracovniPomer->datumNastupu);  // $pracPomer->datumNastupu

        //$result->addStringField('PracovniPomucka', true, 10,  $_POST['PracovniPomucka']);
        $rec->addField('DatumNaroku', 'date', true, 0, time());
        $rec->addField('Poradi', 'int', true, 0);
        $rec->addField('Individualni', 'int', true, 0, (int)$_POST['individualni']);
        $rec->addField('TypVelikostiPP', '', true, 10, $typVelikostiPomucky);
        //$result->addField('VelikostPP', '', true, 20, $velikostPomucky[1]);

        parent::createDBRecordFields($rec, $insert);

        $rec->addStringField('Insert_UserName', true, 25, RonPortalUtils::getLogUserName());
        $rec->addTimestampField('Insert_Timestamp', true, time());

        $rec->addStringField('Update_UserName', false, 25, RonPortalUtils::getLogUserName())
            ->setUpdateLog(true)
            ->setNoInsert(true);
        $rec->addTimestampField('Update_Timestamp', false, time())
            ->setUpdateLog(true)
            ->setNoInsert(true);
    }


    /**
     * @param DBRecord $rec
     * @throws \Ron\DB\DBException
     */
    function setDBRecord($rec)
    {
        parent::setDBRecord($rec);
        $rec->setWhere($this->getWhereCondition());
    }


    /**
     * @param DBRecord $rec
     * @return bool
     * @throws \Exception
     * @throws \Ron\DB\DBException
     */
    function beforeInsertRecord($rec)
    {
//        if (isset($_POST['osoba'])) $osoba = $_POST['osoba'];
//        else $osoba = '';

        $pp = PracovniPomer::nactiPP($this ->database, (int)$_POST['osoba']);

        $pomucka = $_POST['PracovniPomucka'];

        $zadaneDatumVydani = $rec['DatumVydani'];
        $params = $this ->database ->createParameters();
        $jizVydaneVDatu = $this->database->stringToTimestamp(
            DBUtils::getSqlValue($this->database,
                'SELECT max (DatumVydani)' .
                ' FROM PrirazenaPracPomucka LEFT JOIN PracovniPomucka' .
                ' ON (PrirazenaPracPomucka.PracovniPomucka = PracovniPomucka.Kod)' .
                ' LEFT JOIN TypPomucky ON (PracovniPomucka.TypPomucky = TypPomucky.Kod)' .
                ' WHERE TypPomucky.Sledovany = 1 AND PrirazenaPracPomucka.PracovniPomucka = '. $params ->addParameter($pomucka),
            $params)
        );

        if($zadaneDatumVydani <  $jizVydaneVDatu){
            throw new \Exception(\Ron\ronText('datum_obsazeno'));
        }

        $datumnaroku = DateUtils::startOfTheDay(time());

        //umozni prirazeni stejne pomucky jedne osobe ve stejny aktualni den vlozenim noveho cisla poradi
        $params = $this ->database ->createParameters();

        $rec['Poradi'] = SQLUtils::newSerialNumber($this->database, 'PrirazenaPracPomucka', 'Poradi',
            'RC = ' . $params ->addParameter($pp ->rc) .
            ' AND PracovniPomucka = ' . $params ->addParameter($pomucka) .
            ' AND DatumNaroku = ' . $params ->addParameter($this->database->dateToParam($datumnaroku)),
            $params);

        return true;
    }

    /**
     * @param DBRecord $rec
     * @return bool
     * @throws \Exception
     */
    function beforeUpdateRecord($rec)
    {
        if($_POST['vydanipomucky'] == 0) {
            if ($rec['DatumVraceni'] == '') {
                throw new \Exception(\Ron\ronText('form.Missing_value') . ' ' . \Ron\ronText('datum_vraceni') . '!');
            }

            if($rec['DatumVraceni'] < $rec['DatumVydani']){
                throw new \Exception(\Ron\ronText('spatne_datum_vraceni'));
            }
        }

        return parent::beforeUpdateRecord($rec);
    }
}
