<?php
/**
 * stanislav.elbl, 16.02.2021
 */

namespace RonPortal;


class SamlUtils
{

    public static function samlLogin()
    {
        global $simplesaml_sp;
        global $simplesaml_path;
        global $simplesaml_name_attribute;

        require_once(($simplesaml_path ?: '../simplesamlphp') . '/lib/_autoload.php');
        $as = new \SimpleSAML\Auth\Simple($simplesaml_sp);

        if (!$as->isAuthenticated()) {
            $as->requireAuth();
        }

        $attributes = $as->getAttributes();
        \SimpleSAML\Session::getSessionFromRequest()->cleanup();


        $nameAttribute = isset($simplesaml_name_attribute)
            ? $simplesaml_name_attribute
            : 'sAMAccountName';

        if (!isset($attributes[$nameAttribute][0])) {
            global $enabledebugmode;
            if ($enabledebugmode && isset($_GET['debug']) && (int)$_GET['debug']) {
                var_dump($attributes);
            }

            throw new \Exception(\Ron\ronText('Bad_password'));
        }
        return $attributes[$nameAttribute][0];
    }


    public static function samlLogout()
    {
        global $simplesaml_sp;
        global $simplesaml_path;

        require_once ( ($simplesaml_path ?: '../simplesamlphp') .  '/lib/_autoload.php');
        $as = new \SimpleSAML\Auth\Simple($simplesaml_sp);
//var_dump($as);
        if ($as ->isAuthenticated()) {
            //self::clearSession();
            $as ->logout();
            //$as ->logout('https://www.ron.cz');
            //$url = $as ->getLogoutURL('/');
//var_dump($url);
//die("Jsme tadyk");
//                self::clearSession();
//                return new Redirect($url);
        }

        \SimpleSAML\Session::getSessionFromRequest()->cleanup();
    }
}
