<?php
/**
 * stanislav.elbl, 26.05.2021 0:01
 */

namespace RonPortal\Skoleni;

use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\MessageManager;

class SkoleniUtils
{
    /** Vraci true, pokud pro zadanou osobu a druh skoleni existuje vygenerovany navrh bez zadaneho absolvovani.
     * @param Database $database
     * @param string $osobaRC
     * @param string $druhSkoleni
     * @return bool
     * @throws DBException
     */
    public static function existujeNavrhTypuSkoleni($database, $osobaRC, $druhSkoleni)
    {
        $params = $database->createParameters();
        $sql =
            'SELECT COUNT(RC) FROM GenerovaneSkoleni LEFT JOIN Skoleni' .
            '  ON (Skoleni.CisloSkoleni = GenerovaneSkoleni.CisloSkoleni)' .
            ' WHERE GenerovaneSkoleni.RC = ' . $params->addParameter($osobaRC) .
            '  AND GenerovaneSkoleni.DruhSkoleni = ' . $params->addParameter($druhSkoleni) .
            '  AND (GenerovaneSkoleni.Potvrzeni IN (0,5,6)' .
            '    OR (GenerovaneSkoleni.Potvrzeni = 1 AND (Skoleni.StavSkoleni IS NULL OR Skoleni.StavSkoleni <> 2)))';

        MessageManager::addDebugMessage($sql);

        $cursor = $database->getSqlResult($sql, $params);
        $row = $cursor ->fetch();
        $cursor ->close();

        return $row  &&  $row[0] > 0;
    }

}
