<?php
/**
 * stanislav.elbl, 21.02.2021
 */

namespace RonPortal;

use Ron\DB\Database;
use Ron\DB\DBException;

class TypRozdeleni
{
    /** @var int */
    var $kod;
    /** @var string */
    var $popis;

    /**
     * @param Database $database
     * @param int $typRozdeleni
     * @return bool
     * @throws DBException
     */
    function load($database, $typRozdeleni)
    {
        $params = $database ->createParameters();
        $sql = 'SELECT Kod, Popis FROM TypRozdeleni WHERE Kod = ' . $params ->addParameter((int)$typRozdeleni);
        $cursor = $database ->getSqlResult($sql, $params);
        $row = $cursor ->fetch();
        $cursor ->close();

        if (!$row) return false;

        $this->kod = (int)$row[0];
        $this->popis = $row[1];

//        $this ->f_kod = $this ->kod;  // 12/2017 - pouze pro kompatibilitu pripadneho uzivatelskeho kodu
//        $this ->f_popis = $this ->popis;

        return true;
    }


    /**
     * @param Database $database
     * @param int $kodTypuRozdeleni
     * @return TypRozdeleni
     * @throws \Exception
     */
    public static function getTypRozdeleni($database, $kodTypuRozdeleni)
    {
        $typRozdeleni = new TypRozdeleni();
        if (!$typRozdeleni ->load($database, $kodTypuRozdeleni)) {
            throw new \Exception('Chyba - zadany typ rozdeleni neexistuje!');
        }

        return $typRozdeleni;
    }
}
