<?php
/**
 * stanislav.elbl, 22.06.2021 13:30
 */

namespace RonPortal\XML\Classes;

use Ron\MessageManager;
use Ron\RonPortal\XML\XmlFormException;
use Ron\StringUtils;
use RonPortal\XML\XMLFormElementCommand;

class XMLElementMessage extends XMLFormElementCommand
{
    var $fieldName;
    var $text;


    function loadXML($xmlReader)
    {
        parent::loadXML($xmlReader);

        $this ->fieldName = $this ->getAttributeValue('fieldname');
        $this ->text = $this ->getAttributeValue('text');

        if (!isset($this ->text)) {
            $this ->text = $this ->getTextContent(true);
        } else {
            $this ->text = StringUtils::fromUTF8($this ->text);
        }
    }


    function doCommand()
    {
        $fieldName = $this ->nahradPromenne($this ->fieldName);
        $text = $this ->nahradPromenne($this ->text);

        switch ($this ->elementName) {
            case 'exception' :
                throw new XmlFormException($text, $fieldName);

            case 'error' :
            case 'errormsg' :
            case 'errormessage' :
                $this ->xmlForm ->addErrorMsg( $text, $fieldName );
                break;

            case 'infomsg' :
            case 'infomessage' :
                MessageManager::addInfoMessage($text);
                break;

            case 'warning' :
                MessageManager::addWarning($text, $fieldName);
                break;

            case 'debugmsg' :
            case 'debugmessage' :
                $this ->xmlForm ->addDebugMessage($text);
                break;

            case 'debuglog' :
                $this ->xmlForm ->addDebugMessage($text, true);
                break;
        }
    }
}
