/**
 * UTF8
 * Roman.Szablatura RON Software 07.01.2019 */

var dane = {};

(function () {

    var formulareProhlaseniVolbaDodatecne = function(){
        var prohlasenikdanicinim = $("[name='prohlasenikdanicinim']");
        var obdobi_timestamp = $("#obdobi_timestamp");
        var osoba = $("[name='osoba']");

        prohlasenikdanicinim.on('change', function () {
            window.location.href = '?menuid=dane&action=formularprohlaseni&prohlaseni=' + $(this).val() + "&osoba=" + $(osoba).val() + "&obdobi=" + $(obdobi_timestamp).val();
        })
    };

    var formulareProhlaseniCastZdanovacihoObdobi = function(){
        var prohlasenikdanicinim = $("[name='prohlasenikdanicinim']");
        var castzdanovacihoobdobi = $("[name='castzdanovacihoobdobi']");
        var danovezvyhodneniporadiditete = $(".danovezvyhodneniporadiditete");
        var uplatnujinaditedodatecne = $(".uplatnujinaditedodatecne");

        //pokud je zvoleno "dodatecne cinim" pak musi byt cast "zdanovaci obdobi" nepristupna
        if(prohlasenikdanicinim.val() === '2'){
            $(castzdanovacihoobdobi).hide();
        }

        if(prohlasenikdanicinim.val() === '1'){
            $(uplatnujinaditedodatecne).hide();
        }

        if(prohlasenikdanicinim.val() < 1 ){
            $(danovezvyhodneniporadiditete).hide();
        } else {
            $(danovezvyhodneniporadiditete).show();
        }
    };


    var kontrolaPoradiDuplicityDitete = function () {
        //Kontrola duplicity poradi (1 a 2) ty mohou byt pouze 1x

        $("form").submit(function (e) {
            if(!otestujPoradi(".danovezvyhodneniporadiditete")){
                e.preventDefault();
            }

            if(!otestujPoradi(".zmenova-cast-uprava-poradi-slev-na-deti")){
                e.preventDefault();
            }
        });
    };


    var otestujPoradi = function (trida) {
        if(debugMode){console.log(trida);}
        var navrat = 1;
        var jedna = 0;
        var dve = 0;
        var pocetDeti = 0;
        $(trida).each(function ()
        {
            $(this).removeClass("app_input_error");

            if($(this).val() == 1){
                pocetDeti += 1;
                jedna += 1;

                if(jedna > 1){
                    navrat = 0;
                    $(this).addClass("app_input_error");
                } else {
                    $(this).removeClass("app_input_error");
                }
            }

            if($(this).val() == 2){
                pocetDeti += 1;
                dve += 1;

                if(dve > 1){
                    navrat = 0;
                    $(this).addClass("app_input_error");
                } else {
                    $(this).removeClass("app_input_error");
                }
            }
        });

        console.log(pocetDeti);

        if((jedna == 1 && dve == 0 && pocetDeti > 1) || (jedna == 0 && dve == 1 && pocetDeti > 1)){
            $(trida).each(function ()
            {
                $(this).addClass("app_input_error");
                ron.showError(ron.translate('Prohlaseni_poradi_ditete_vynechano_info'));
            });
        } else {
             $(trida).each(function ()
            {
                $(this).removeClass("app_input_error");
            });
        }

        if(navrat === 0){
            ron.showError(ron.translate('poradi_ditete_info'));
        }

        return navrat;
    };



     var otestujSlevuNaInvaliditu = function () {
        $(".slevaNaInvaliditu").change(function ()
        {
            $(".slevaNaInvaliditu").not(this).val('0');
        });
    };


    var zmenaPoradiDitete = function(){
        var danovezvyhodneniporadiditete = $('.danovezvyhodneniporadiditete');

        var pozadavekUpravyPoradi = $('#pozaduji_upravu_poradi_ditete');

        if($(pozadavekUpravyPoradi).is(':checked') === true){
            danovezvyhodneniporadiditete.each(function () {
                $(this).prop('disabled', false);
            })
        } else {
            danovezvyhodneniporadiditete.each(function () {
                $(this).prop('disabled', true);
            })
        }

        pozadavekUpravyPoradi.on('change', function () {
            if($(pozadavekUpravyPoradi).is(':checked') === true){
                danovezvyhodneniporadiditete.each(function () {
                    $(this).prop('disabled', false);
                })
            } else {
                danovezvyhodneniporadiditete.each(function () {
                    $(this).prop('disabled', true);
                })
            }
        });
    };


    /**
     * Pokud je zvolena sleva na zdravotni stav, pak je mozno zvolit pouze bud zakladni slevu na invaliditu nebo rozsirenou, nikoliv oboje najednou
     */
    var pozadavekNaZmenuSlevy = function(){
        var comboZmenySlev = $('.uprava_slevy_poplatnika');

        var pozadavekUpravySlev = $('#pozaduji_upravu_slev');

        if($(pozadavekUpravySlev).is(':checked') === true){
            comboZmenySlev.each(function () {
                $(this).prop('disabled', false);
            })
        } else {
            comboZmenySlev.each(function () {
                $(this).prop('disabled', true);
            })
        }


        pozadavekUpravySlev.on('change', function () {
            if($(pozadavekUpravySlev).is(':checked') === true){
                comboZmenySlev.each(function () {
                    $(this).prop('disabled', false);
                })
            } else {
                comboZmenySlev.each(function () {
                    $(this).prop('disabled', true);
                    $(this).removeClass("app_input_error");
                })
            }
        });
    };


     var kontrolaVyplneniSlev = function () {
        //Kontrola vyplnění slev - pokud uživatel zvolí požadavek na změnu a žádnou nenastaví, bude upozorněn

        $("form").submit(function (e) {
            var pozadujiUpravuSlev = $('#pozaduji_upravu_slev');


            if($(pozadujiUpravuSlev).is(':checked') === true) {
                var slevyPoplatnika = $('.uprava_slevy_poplatnika'),
                    zmenaSlev = false,
                    oldValueSelector = '';

                slevyPoplatnika.each(function () {
                    oldValueSelector = $(this).data('old-value-selector');
                    $(this).removeClass("app_input_error");
                    if ($(this).val() !== $('[name="' + oldValueSelector + '"]').val()) {
                        zmenaSlev = true;
                    } else {
                        $(this).addClass("app_input_error");
                    }
                });

                if (!zmenaSlev){
                    ron.showError(ron.translate('pozadavek_zmeny_slev_bez_nastavene_hodnoty'));
                    e.preventDefault();
                }
                else {
                    slevyPoplatnika.each(function () {
                        $(this).removeClass("app_input_error");
                    });
                }
            }
        });
    };


     var kontrolaVyplneniUdajuJinehoPoplatnika = function () {
        //Kontrola vyplnění povinnych poli

        $("form").submit(function (e) {
            var vyzivujeJinyPoplatnik = $('#vyzivujeJinyPoplatnik');
            var jinyPoplatnikZamestnani = $('#jinyPoplatnikZamestnani');

            if($(vyzivujeJinyPoplatnik).find(":selected").val() == 1) {
                var cssAdresaPoplatnika = $('.adresa-poplatnika');
                var adresaNastavena = true;

                cssAdresaPoplatnika.each(function () {
                    $(this).removeClass("app_input_error");

                    if ($(this).val() == "") {
                        adresaNastavena = false;
                        $(this).addClass("app_input_error");
                    }
                });

                if(adresaNastavena){
                    cssAdresaPoplatnika.each(function () {
                        $(this).removeClass("app_input_error");
                    });
                }

                if (!adresaNastavena) {
                    ron.showError(ron.translate('Mzdy_prohlaseni_vyplnte_adresu_poplatnika'));
                    e.preventDefault();
                }
            }

            if($(jinyPoplatnikZamestnani).find(":selected").val() == 1 && $(vyzivujeJinyPoplatnik).find(":selected").val() == 1) {
                var zamestnavatelUdaje = $('.zamestnavatel-udaje');
                var zamestnavatelUdajeNastaveny = true;

                zamestnavatelUdaje.each(function () {
                    $(this).removeClass("app_input_error");

                    if ($(this).val() == "") {
                        zamestnavatelUdajeNastaveny = false;
                        $(this).addClass("app_input_error");
                    }
                });

                if(zamestnavatelUdajeNastaveny){
                    zamestnavatelUdaje.each(function () {
                        $(this).removeClass("app_input_error");
                    });
                }

                if (!zamestnavatelUdajeNastaveny) {
                    ron.showError(ron.translate('Mzdy_prohlaseni_vyplnte_adresu_poplatnika'));
                    e.preventDefault();
                }
            }
        });
    };


     var pouzitAktualniAdresu = function(){
         var adresa = $("#adresabytovepotrebyuveru");
         var poleSAdresou = $("#zadostbytovepotrebyuveruadresa");

         $(poleSAdresou).on('dblclick', function () {
             $(this).val($(adresa).val());
             $(this).html($(adresa).val());
         })
     };


     var prevenceOdeslaniFormularePomociEnter = function(){
        $("form").keydown(function(event){
            if(event.keyCode == 13) {
              event.preventDefault();
              return false;
            }
        });
     };


      var prevenceOdeslaniFormularePokudJeNastavenaChyba = function(){
        $("form").submit(function (e) {
            var prvekSChybou = $(".app_input_error:first");

            if($(prvekSChybou).length  > 0)
            {
                if($(prvekSChybou).val() != "")
                {
                    var body = $("html, body");
                    body.stop().animate({scrollTop: $(prvekSChybou).offset().top - 50}, 900);
                    setTimeout(function () {
                        alert(ron.translate('zadost_na_formulari_jsou_chyby'));
                    }, 1000);

                    e.preventDefault();
                }
            }
        });
     };


     var kontrolaPoliDatumuOdDo = function()
     {
        var chyba = false;
        $(".filter-zadosti-od-do").blur(function ()
        {
            if($(this).val() != "") {
                //vypocitat a overit spravnost od - do
                var mesic = $(this).val().split("-");
                var mesicOd = parseInt(mesic[0]);
                var mesicDo = parseInt(mesic[1]);
                var overeniDatumu = new RegExp("^(0?[1-9]|1[012])$");
                var jeCislo = $.isNumeric(mesicDo);

                if ( (mesicDo > mesicOd) && jeCislo && ((overeniDatumu.test((mesicOd).toString())) && (overeniDatumu.test((mesicDo).toString()))) ) {
                    $(this).removeClass("app_input_error");
                    $(this).val(mesicOd + "-" + mesicDo);
                    chyba = false;
                } else {
                    $(this).addClass("app_input_error");
                    chyba = true;
                }
            } else {
                $(this).removeClass("app_input_error");
                    chyba = false;
            }
        });

        if(chyba){
            ron.showError(ron.translate(''));
        }

        return chyba;
     };



     var kontrolaSlevyNaPartnera = function ()
     {
        var slevanapartneraproztp = $('#slevanapartneraproztp');
        var slevanapartnera = $('#slevanapartnera');

        $(slevanapartneraproztp).keypress(function(e) {
            if($(slevanapartnera).val() === ""){
                e.preventDefault();
            }
        });

        //Pokud je vyplnen "nárok na ZTP" pak musí být vyplnen "nárok na"
        $(slevanapartnera).blur(function () {
            if($(slevanapartnera).val() === ""){
                $(slevanapartneraproztp).val("");
            }

            kontrolaSlevyNaPartneraZtp();
        });

        $(slevanapartneraproztp).blur(function () {
            kontrolaSlevyNaPartneraZtp();
        });
     };



     var kontrolaSlevyNaPartneraZtp = function(){
        var slevanapartneraproztp = $('#slevanapartneraproztp');
        var slevanapartnera = $('#slevanapartnera');

        var testOk = true;
        var mesicZTP = $(slevanapartneraproztp).val().split("-");
        var mesicZTPOd = parseInt(mesicZTP[0]);
        var mesicZTPDo = parseInt(mesicZTP[1]);

        var mesicNaroku = $(slevanapartnera).val().split("-");
        var mesicNarokuOd = parseInt(mesicNaroku[0]);
        var mesicNarokuDo = parseInt(mesicNaroku[1]);


        if($(slevanapartnera).val() !== ""){
            if($(slevanapartneraproztp).val() !== "") {
                if (!((mesicNarokuOd <= mesicZTPOd) && (mesicZTPDo <= mesicNarokuDo))) {
                    testOk = false;
                    ron.showError(ron.translate('zadost_rozsah_mesicu_naroku'));
                }
            }
        }


        if(testOk){
            $(slevanapartneraproztp).removeClass("app_input_error");
        } else {
            $(slevanapartneraproztp).addClass("app_input_error");
        }
     };



    dane.vyzivujeJinyPoplatnik = function(){
        var vyzivujeJinyPoplatnikZpristupnitPolozky = $('#vyzivujeJinyPoplatnikZpristupnitPolozky').val();
        var vyzivujeJinyPoplatnik = $('#vyzivujeJinyPoplatnik');
        var jinyPoplatnikUplatnujeZv = $('#jinyPoplatnikUplatnujeZv');
        var jinyPoplatnikZamestnani = $('#jinyPoplatnikZamestnani');
        var jinyPoplatnik = $('.jiny-poplatnik');

        var vyzivujeJinyPoplatnikJe = $(vyzivujeJinyPoplatnik).find(":selected").val() == 0;

        //TODO predelat na ajax

        $(jinyPoplatnikUplatnujeZv).prop('disabled', (vyzivujeJinyPoplatnikJe));
        $(jinyPoplatnikZamestnani).prop('disabled', (vyzivujeJinyPoplatnikJe));
        $(jinyPoplatnik).prop('disabled', (vyzivujeJinyPoplatnikZpristupnitPolozky));

        vyzivujeJinyPoplatnik.on('change', function () {

            if ($(vyzivujeJinyPoplatnik).find(":selected").val() == 1) {
                $(jinyPoplatnikUplatnujeZv).prop('disabled', false);
                $(jinyPoplatnikZamestnani).prop('disabled', false);
                $(jinyPoplatnik).prop('disabled', false);

                $('#jinyPoplatnikJmeno').val($('#partnerJinyPoplatnikJmeno').val());
                 $('#jinyPoplatnikPrijmeni').val($('#partnerJinyPoplatnikPrijmeni').val());
                 $('#jinyPoplatnikRC').val($('#partnerJinyPoplatnikRC').val());
                 $('#jinyPoplatnikJmenoVisible').val($('#partnerJinyPoplatnikJmeno').val());
                 $('#jinyPoplatnikPrijmeniVisible').val($('#partnerJinyPoplatnikPrijmeni').val());
                 $('#jinyPoplatnikRCVisible').val($('#partnerJinyPoplatnikRC').val());
            } else {
                $(jinyPoplatnikUplatnujeZv).prop('disabled', true);
                $(jinyPoplatnikZamestnani).prop('disabled', true);
                $(jinyPoplatnik).prop('disabled', true);
                $(".jiny-poplatnik").removeClass("app_input_error");

                $('#jinyPoplatnikZamestnani').val("0").change();
                $('#jinyPoplatnikUplatnujeZv').val("0").change();

                $('#jinyPoplatnikJmeno').val("");
                $('#jinyPoplatnikPrijmeni').val("");
                $('#jinyPoplatnikRC').val("");
                $('#jinyPoplatnikJmenoVisible').val("");
                $('#jinyPoplatnikPrijmeniVisible').val("");
                $('#jinyPoplatnikRCVisible').val("");

            }
        })
    };

     var jinyPoplatnikZamestnani = function(){
        var jinyPoplatnikZamestnani = $('#jinyPoplatnikZamestnani');
        var jinyPoplatnikZamestnavatel = $('.jiny-poplatnik-zamestnavatel');

        var jinyPoplatnikZamestnaniJe = $(jinyPoplatnikZamestnani).find(":selected").val() == 0;

        $(jinyPoplatnikZamestnavatel).prop('disabled', (jinyPoplatnikZamestnaniJe));

        jinyPoplatnikZamestnani.on('change', function () {

            if ($(jinyPoplatnikZamestnani).find(":selected").val() == 1) {
                $(jinyPoplatnikZamestnavatel).prop('disabled', false);
            } else {
                $(jinyPoplatnikZamestnavatel).prop('disabled', true);
                $(jinyPoplatnikZamestnavatel).removeClass("app_input_error");
            }
        })
    };


     var prohlaseniKDaniCinim = function(){
        var prohlaseniKDaniCinimCombo = $('#prohlasenikdanicinim');
        var jinyPoplatnik = $('.jiny-poplatnik');

        if ($(prohlaseniKDaniCinimCombo).find(":selected").val() == 0) {
            var prohlaseniKDaniCinimComboJe = $(prohlaseniKDaniCinimCombo).find(":selected").val() == 0;
            $(jinyPoplatnik).prop('disabled', prohlaseniKDaniCinimComboJe);
        }
     };


     dane.zmenovaCastSlevNaDani = function(){
         var check_zmenova_cast_pozaduji_upravu_slev = $("#zmenova_cast_pozadujiUpravuSlev");
         var zmenova_cast_slevy_poplatnika = $(".zmenova_cast_uprava_slevy_poplatnika");

         check_zmenova_cast_pozaduji_upravu_slev.on('click', function () {
            var checkbox = $(this).is(':checked');
            dane.prednastaviHodnotSlevyNaDani(checkbox);

            $(zmenova_cast_slevy_poplatnika).each(function () {
                $(this).prop('disabled', !checkbox);
            })
         })
     };


     dane.zmenovaCastUpravyPoradiSlevNaDeti = function(){
         var check_zmenova_cast_pozadujiUpravuPoradiDeti = $("#zmenova_cast_pozadujiUpravuPoradiDeti");
         var zmenova_cast_slevy_poplatnika = $(".zmenova-cast-uprava-poradi-slev-na-deti");

         check_zmenova_cast_pozadujiUpravuPoradiDeti.on('click', function () {
            var checkbox = $(this).is(':checked');
            // dane.prednastaviHodnotSlevyNaDani(checkbox);

            $(zmenova_cast_slevy_poplatnika).each(function () {
                $(this).prop('disabled', !checkbox);
            })
         })
     };


    dane.prednastaviHodnotSlevyNaDani = function(x){
        var zakladniSlevaPoplatnika = $('#zakladni_odpocet_zobrazeni').find(":selected").val();
        var zakladniSlevaNaInvaliditu = $('#na_zdravotni_stav1_zobrazeni').find(":selected").val();
        var rozsirenaSlevaNaInvaliditu = $('#naZdravotniStav2').find(":selected").val();
        var slevaZttp = $('#ztpp_zobrazeni').find(":selected").val();
        var slevaNaStudenta = $('#odpocetNaStudenta_zobrazeni').find(":selected").val();

        if(x === true){
            //Prednastavi volby dle aktualnich hodnot
            $('#zmenova_cast_zakladniOdpocet option:eq('+zakladniSlevaPoplatnika+')').prop('selected', x);
            $('#zmenova_cast_naZdravotniStavVolba1 option:eq('+zakladniSlevaNaInvaliditu+')').prop('selected', x);
            $('#zmenova_cast_naZdravotniStavVolba2 option:eq('+rozsirenaSlevaNaInvaliditu+')').prop('selected', x);
            $('#ztpp_zobrazeni option:eq('+slevaZttp+')').prop('selected', x);
            $('#zmenova_cast_odpocetNaStudenta option:eq('+slevaNaStudenta+')').prop('selected', x);
        } else {
            $('#zmenova_cast_zakladniOdpocet option:eq(0)').prop('selected', true);
            $('#zmenova_cast_naZdravotniStavVolba1 option:eq(0)').prop('selected', true);
            $('#zmenova_cast_naZdravotniStavVolba2 option:eq(0)').prop('selected', true);
            $('#ztpp_zobrazeni option:eq(0)').prop('selected', true);
            $('#zmenova_cast_odpocetNaStudenta option:eq(0)').prop('selected', true);
        }
     };


    dane.odeslatZmenovouCast = function(){
        var buttonZmenovaCast = $("#zmenovaCastProhlaseni");
        buttonZmenovaCast.on('click', function () {
            $("form#formularProhlaseni").submit();
        })
    };


    dane.naskrolovaniNaZmenovouCast = function(){
        //Nascrolovani na zmenovou cast
        $('#prechod-na-zmenovou-cast').click(function () {
            $([document.documentElement, document.body]).animate({
                scrollTop: $(".zmenova-cast-scroll").offset().top }, 1000);
             // $([document.documentElement, document.body]).scrollTop($(".zmenova-cast-scroll").offset().top);
        });
    };




    dane.inicializace = function(){
        //Kontrola zda je checkbox "Požaduji změnu" zvolen pokud ne, vybrane prvky - disabled
        var pozadujiZmenu = $("#zmenova_cast_pozadujiUpravuSlev").is(':checked');
        $(".zmenova_cast_uprava_slevy_poplatnika").each(function () {  $(this).prop('disabled', !pozadujiZmenu);  });

        var pozadujiZmenuPoradiSlevNaDeti = $("#zmenova_cast_pozadujiUpravuPoradiDeti").is(':checked');
        $(".zmenova-cast-uprava-poradi-slev-na-deti").each(function () {  $(this).prop('disabled', !pozadujiZmenuPoradiSlevNaDeti);  });


        //Pokud je prohlaseni schvaleno disablovat vybrane prvky formulare
        if($('#prohlaseniSchvaleno').val() != ""){
            $(".prohlaseni-poplatnika-dane").prop('disabled', ($('#prohlaseniSchvaleno').val() == '1'));
        }


        var check_zmenova_cast_pozaduji_upravu_slev = $("#zmenova_cast_pozadujiUpravuSlev");
        var check_pozadavekUpravyPoradiSlevNaDeti = $('#zmenova_cast_pozadujiUpravuPoradiDeti');

        if($(check_zmenova_cast_pozaduji_upravu_slev).is(':checked') === true || $(check_pozadavekUpravyPoradiSlevNaDeti).is(':checked') === true ){
            $("#zmenovaCastProhlaseni").show();
        }
    };


    dane.showDoplnujiciInfo = function () {
        ron.showMessage(
            {
                title: ron._("Info"),
                content: $($(this).data('selector')).html()
            });
    };
    dane.doplnujiciInfo = function () {
        var text;
        $('.dane_info').each(function () {
            text = $($(this).data('selector')).text().toString();
            text = text.replace(/\n\s+/g, '\n');
            text.trim();
            $(this).prop('title', text);
        });
    };


    $(function () {
        //Dane - Prohlaseni
        formulareProhlaseniVolbaDodatecne();
        formulareProhlaseniCastZdanovacihoObdobi();
        kontrolaPoradiDuplicityDitete();
        zmenaPoradiDitete();
        otestujSlevuNaInvaliditu();
        pozadavekNaZmenuSlevy();
        kontrolaVyplneniSlev();
        kontrolaVyplneniUdajuJinehoPoplatnika();
        dane.vyzivujeJinyPoplatnik();
        jinyPoplatnikZamestnani();
        prohlaseniKDaniCinim();
        dane.inicializace();
        dane.zmenovaCastSlevNaDani();
        dane.zmenovaCastUpravyPoradiSlevNaDeti();
        dane.naskrolovaniNaZmenovouCast();
        dane.odeslatZmenovouCast();


        //Dane - Zadost
        pouzitAktualniAdresu();
        prevenceOdeslaniFormularePomociEnter();
        kontrolaPoliDatumuOdDo();
        kontrolaSlevyNaPartnera();
        prevenceOdeslaniFormularePokudJeNastavenaChyba();

        $(document.body)
            .on('click', '.dane_info', dane.showDoplnujiciInfo);
        dane.doplnujiciInfo();
    })
})();