


var personalistika = { };
personalistika.UrovenDovednosti = function() {
    this.kod = 0;
    this.popis = '';
};

personalistika.zobrazUrovneDovednosti = function(kodDovednosti) {
    var vynulujSelect = function(select) {
        $(select).find('option').remove();
    };
    var zobrazData = function(data) {
        var select = $('#urovneDovednosti').find('select[name="urovenDovednosti"]');

        if (!data  ||  !data.urovne)
        {
            vynulujSelect(select);
            return;
        }

        vynulujSelect(select);

        $.each(data.urovne, function(key, value) {
            $(select)
                .append($('<option>', {value : value.kod})
                    .text(value.popis));
        });

    };



    var url = "?menuid=dovednosti&action=loaddata&dovednost=" + kodDovednosti;

    $.ajax(url)
        .done( function(data) {
            if (debugMode) console.log("Nacteny urovne dovednosti: " + kodDovednosti + ". ", data);

            if (data.result == "error") {
                vynulujSelect($('#urovneDovednosti').find('select[name="urovenDovednosti"]'));
                ron.showError(data);
            } else {
                zobrazData(data);
            }

        }).fail( function(jqXHR) {
        vynulujSelect($('#urovneDovednosti').find('select[name="urovenDovednosti"]'));
        ron.showAjaxError(jqXHR, "Pri nacitani urovni dovednosti doslo k chybe!");
    });
};

personalistika.skoleni = {
    odhlaseni : function () {
        var url;
        var cisloSkoleni;

        var dialogTerminy = function (event) {
            url = '?menuid=skoleni&action=odhlaseni';
            cisloSkoleni = $(this).data('skoleni-kod');

            if ($(this).data('prihlaseny-terminy') === 1) {
                event.preventDefault();
                dialogSmazatTerminy();
            } else if ($(this).data('ponechat-navrh') === 0) {
                event.preventDefault();
                dialogSmazatSkoleni();
            }
        };

        var dialogSmazatTerminy = function () {
            $("#btnTerminySmazat")
                .off('click')
                .on("click", function () {
                    $("#dialogSkoleniTerminy").dialog('close');
                    dialogSmazatSkoleni();
                });

            $("#btnTerminyNechat")
                .off('click')
                .on("click", function () {
                    $("#dialogSkoleniTerminy").dialog('close');
                    return false;
                });
            $("#dialogSkoleniTerminy")
                .dialog({
                    modal: true,
                    resizable: false,
                    width: "400",
                    height: "160",
                    closeOnEscape: false
                });

        };

        var dialogSmazatSkoleni = function () {
            $("#btnPonechatNavrh")
                .off('click')
                .on("click", ponechatNavrh);

            $("#btnSmazatNavrh")
                .off('click')
                .on("click", smazatSkoleni);
            $("#dialogSkoleniNavrh")
                .dialog({
                    modal: true,
                    resizable: false,
                    width: "auto",
                    height: "auto",
                    closeOnEscape: false
                });

        };

        var smazatSkoleni = function () {
            $(this).off('click');
            $("#btnPonechatNavrh").off('click');
            window.location.href = url + '&navrh=smazat&cisloskoleni=' + cisloSkoleni;
        };

        var ponechatNavrh = function () {
            $(this).off('click');
            $("#btnSmazatNavrh").off('click');
            window.location.href = url + '&navrh=zrusit&cisloskoleni=' + cisloSkoleni;
        };

        var vysledekOdhlaseniJSON = function (data) {
            $('#skoleniNavrh').text(data.text);
            $('#btnPonechatNavrh, #btnSmazatNavrh').hide();
            $('#btnNavrhZavrit').show().on('click', function () {
                $("#dialogSkoleniNavrh").dialog('close');
            });
        };

        dialogTerminy();
    },
    vyhledaniKurzuStejneUmisteni : function () {
        var $this = $(this),
            urlVyhledat = $this.data('skoleni-vyhledat'),
            urlProvest = $this.data('skoleni-provest');

        var dialogVyhledatKurzy = function () {
            $("#btnVyhledatUmisteni")
                .off('click')
                .on("click", vyhledatKurzy);

            $("#btnPrihlasitKurz")
                .off('click')
                .on("click", prihlasitKurz);

            $("#btnUmisteniZavrit")
                .off('click')
                .on("click", zavritDialog);
            $("#dialogSkoleniVyhledatUmisteni")
                .dialog({
                    modal: true,
                    resizable: false,
                    width: "auto",
                    height: "auto",
                    closeOnEscape: false
                });
        };

        var vyhledatKurzy = function () {
            $(this).off('click');
            $("#btnPrihlasitKurz").off('click');
            $("#btnUmisteniZavrit").off('click');
            window.location.href = urlVyhledat;
        };
        var prihlasitKurz = function () {
            $(this).off('click');
            $("#btnVyhledatUmisteni").off('click');
            $("#btnUmisteniZavrit").off('click');
            window.location.href = urlProvest;
        };
        var zavritDialog = function () {
            $(this).off('click');
            $("#btnVyhledatUmisteni").off('click');
            $("#btnPrihlasitKurz").off('click');
            $("#dialogSkoleniVyhledatUmisteni").dialog('close');
        };

        dialogVyhledatKurzy();
    }
};

personalistika.dovednosti = {

    zpracujDialogTPM : function () {
        var editovatTPM = function() {

            $("#dovednosti_tpm_buttonsrow").hide();

            this.form.submit();
            return true;
        };

        var stornoTPM = function() {
            $("#dovednosti_tpm").dialog("close");
        };


        $("#dovednosti_tpm")
            .off("click")
            .on("click", "#dovednosti_tpm_vlozit_Btn", editovatTPM)
            .on("click", "#dovednosti_tpm_storno_Btn", stornoTPM)
            .dialog( {
                position: { my: "center", at: "center", of: 'form:has(select[name=urovenDovednosti])', within: 'form:has(select[name=urovenDovednosti])' },
                modal : true,
                resizable: false,
                width: "auto",
                height: "auto"
            });
    },

    zobrazVlozeniTPM : function () {
        $('#dovednosti_tpm_platnost_do').hide();
        $('#dovednosti_tpm_poznamka').show();
        $('#dovednosti_tpm_kod').show();
        $('#dovednosti_tpm_platnost_od').show();

        personalistika.dovednosti.zpracujDialogTPM();
    },

    zobrazUkonceniTPM : function () {
        $('#dovednosti_tpm_platnost_do').show();
        $('#dovednosti_tpm_poznamka').hide();
        $('#dovednosti_tpm_kod').hide();
        $('#dovednosti_tpm_platnost_od').hide();

        var $this = $(this);

        $('#tpm_kod').prop('value',$this.data('tpm-kod'));
        $('#tpm_platnost_od').prop('value',$this.data('tpm-platnost-od'));

        personalistika.dovednosti.zpracujDialogTPM();
    }
};


function showDokumentDovednostiDialog(idPP) {

    var dokumentDovednostiResult = function(result) {
        processDokumentResult(result, '?menuid=maticedovednosti&action=novadovednost&idosoby=' + idPP);
    };

    ronPortal.showDokumentDialog(dokumentDovednostiResult);
    return false;
}

function showDokumentLekarskeProhlidkyDialog(idOsoby, kodZP, datumVzniku) {

    var dokumentLekarskeProhlidkyResult = function(result) {
        processDokumentResult(result, '?menuid=lekarskeprohlidky&action=detail&osoba=' + idOsoby + '&kod=' + kodZP + '&vznik=' + datumVzniku);
    };

    ronPortal.showDokumentDialog(dokumentLekarskeProhlidkyResult);
}

function showDokumentOsobyDialog(idPP) {
    var dokumentOsobyResult = function(result) {
        processDokumentResult(result, '?menuid=dokumenty&osoba=' + idPP);
    };

    ronPortal.showDokumentDialog(dokumentOsobyResult);
    return false;
}



$( function() {
    $('#dovednosti_nove_tpm').on('click', personalistika.dovednosti.zobrazVlozeniTPM);
    $('#tpm').on('click', 'a.ukonceniTPM', personalistika.dovednosti.zobrazUkonceniTPM);
    $('.prihlaseniSkoleniBrowser')
        .on('click', 'a[data-prihlaseny-terminy]', personalistika.skoleni.odhlaseni)
        .on('click', '.skoleniVyhledatUmisteni', personalistika.skoleni.vyhledaniKurzuStejneUmisteni);
});

$(function() {

    var
        showRow = function(rowSelector, dataSelector, value) {
            if (value == '') {
                $(rowSelector).addClass('d-none');
            } else {
                $(dataSelector).text(value);
                $(rowSelector).removeClass('d-none');
            }
        },

        zobrazData = function(detailData, doporucenaVelikost) {
            $("#detail_pomucky_nazev").text(detailData.popis + " (" + detailData.kod + ")");
            $("#detail_pomucky_typ").text(detailData.typ);

            showRow("#detail_pomucky_row_inventarni_cislo", "#detail_pomucky_inventarni_cislo", detailData.inventarniCislo);
            showRow("#detail_pomucky_row_vyrobni_cislo", "#detail_pomucky_vyrobni_cislo", detailData.vyrobniCislo);
            showRow("#detail_pomucky_row_znacka", "#detail_pomucky_znacka", detailData.znacka);
            showRow("#detail_pomucky_row_konec_zaruky", "#detail_pomucky_konec_zaruky", detailData.konecZaruky);


            for (var i = 1;  i <= 5;  i++) {
                if (detailData["nadpisUzivatelske" + i]) {
                    $("#detail_pomucky_uzivatelska" + i + "_nadpis")
                        .text(detailData["nadpisUzivatelske" + i]);

                    $("#detail_pomucky_uzivatelska" + i)
                        .text(detailData["uzivatelske" + i]);

                    $("#detail_pomucky_row_uzivatelska" + i).removeClass('d-none');
                } else {
                    $("#detail_pomucky_row_uzivatelska" + i).addClass('d-none');
                }
            }
            $("#doporucenaVelikost").text(doporucenaVelikost);

            var $velikostPP = $("#VelikostPP");
            $velikostPP.empty();
            $velikostPP.append( $("<option/>").attr('value', '').text('') );

            console.log(detailData.velikosti.length, detailData.velikosti);
            if (detailData.velikosti && detailData.velikosti.length) {
                for (i = 0;  i < detailData.velikosti.length;  i++) {
                    $velikostPP.append(
                        $("<option/>")
                            .attr('value', detailData.velikosti[i])
                            .text(detailData.velikosti[i])
                    );
                }
            }
        },

        loadData = function(kod) {
            var idpp = $('#osoba').val();

            $.ajax("?menuid=pracovnipomucky&action=detaildata&kod=" + encodeURIComponent(kod) + (idpp ? '&idpp=' + idpp : ''))
                .done(function(data) {
                    $("#detail_pracovni_pomucky")
                        .removeClass("loading");

                    zobrazData(data.detail, data.doporucenaVelikost);
                })
                .fail(function(jqXHR) {
                    ron.showAjaxError(jqXHR, "Pri nacitani delky smeny doslo k chybe!");
                    $("#detail_pracovni_pomucky")
                        .removeClass("loading")
                });
        },

        onDetailClick = function() {
            $("#detail_pracovni_pomucky")
                .addClass("loading")
                .dialog({
                    modal: true,
                    minHeight: 0,
                    minWidth: 600
                });

            loadData($(this).data('kod'));

            return false;
        },

        onVyberPomuckyChange = function() {
            var newVal = $(this).val();

            if (newVal) {
                $("#detail_pracovni_pomucky")
                    .addClass("loading");

                loadData(newVal);
            }
        },

        onVyberOsobyChange = function() {
            if (!$(this).val()) {
                return;
            }

            var kodPomucky = $("#kod_pracovni_pomucky").val();
            if (kodPomucky) {
                loadData(kodPomucky);
            }
        };


    $("body")
        .on("click", ".pracovni-pomucky-detail-link", onDetailClick)
        .on("change", "#kod_pracovni_pomucky", onVyberPomuckyChange)
        .on("change", "#osoba", onVyberOsobyChange);
});
