
ron.createCalendarButton = function(element) {
    var $element = $(element);
};



ron.PopupCalendarOptions = function() {
    this.submitForm = false;
    this.minDate = undefined;
    this.maxDate = undefined;
    this.nextDateInput = undefined;
    this.prevDateInput = undefined;
};
ron.popupCalendar = function(input, options) {

    var
        parent = $(document.body), // predelat na input.parent?
        textElement = $(input);

    if (!textElement.length) {
        return;
    }

    if (textElement.attr("disabled")) {
        return;
    }
    var
        submitForm = textElement.data("roncalendar-submit"),    // jestli ma provest submit
        minDateText = textElement.data("roncalendar-mindate"),  // rozsah datumu
        maxDateText = textElement.data("roncalendar-maxdate"),
        textElementTo = null,
        textElementFrom = null;

    if (options  &&  options.nextDateInput) {
        textElementTo = $("[name=" + options.nextDateInput + "]");
    } else if (options  &&  options.prevDateInput) {
        textElementFrom = $("[name=" + options.prevDateInput + "]");
    } else if (textElement.data("roncalendar-next")) {
        textElementTo = $("[name=" + textElement.data("roncalendar-next") + "]");
    } else if (textElement.data("roncalendar-prev")) {
        textElementFrom = $("[name=" + textElement.data("roncalendar-prev") + "]");
    }

    if (textElementTo   &&  !textElementTo.length) textElementTo = null;
    if (textElementFrom &&  !textElementFrom.length) textElementFrom = null;
    if (options) {
        if (options.submitForm != undefined) submitForm = options.submitForm;
        if (options.minDate != undefined) minDateText = options.minDate;
        if (options.maxDate != undefined) maxDateText = options.maxDate;
    }


    var
        minDate = minDateText ? ron.utils.stringToDate(minDateText) : null,
        maxDate = maxDateText ? ron.utils.stringToDate(maxDateText) : null;
    var
        month = null,
        date = null,
        dateTo = null,
        calendarDiv = null,
        headerDiv = null,
        cells = [],
        dates = [];
    var onCellClick = function(cell) {
        var newDate = getDateForCell(cell);
        if (!newDate) return false;

        if (minDate && newDate < minDate) return false;
        if (maxDate && newDate > maxDate) return false;

        var text = newDate.getDate() + '.' + (newDate.getMonth() + 1) + '.' + newDate.getFullYear();

        var changed = textElement.val() != text;
        textElement.val(text);

        if (textElementTo) {
            if (dateTo && dateTo < newDate) {
                if (textElementTo.val() != text) {
                    textElementTo.val(text);
                    textElementTo
                        .trigger("change")
                        .trigger("blur");
                }
            }
        } else if (textElementFrom) {
            if (date  &&  date > newDate) {
                if (textElementFrom.val() != text) {
                    textElementFrom.val(text);
                    textElementFrom
                        .trigger("change")
                        .trigger("blur");
                }

            }
        }

        if (changed) {
            $(textElement)
                .trigger("change")
                .trigger("blur");
        }

        if (submitForm) textElement[0].form.submit();
        return true;
    };


    var showMonth = function (showDate) {
        var pomDate = new Date(showDate);
        pomDate.setDate(1); // nastavi 1. den v mesici

        month = new Date(pomDate); // zapamatuje si zacatek aktualniho mesice

        var cnt = pomDate.getDay();
        if (!cnt) cnt = 7;
        pomDate.setDate(pomDate.getDate() - cnt + 1);

        var today = new Date();

        for (var i = 0; i < cells.length; i++) {
            cells[i].html(pomDate.getDate());
            dates[i] = new Date(pomDate);

            var className = '';
            if (dateTo) {
                if (pomDate >= date  &&  pomDate <= dateTo) className = 'calendarselected';
            }
            else {
                if (pomDate <= date && pomDate >= date) className = 'calendarselected'; // == nefunguje!
            }

            if (pomDate.getDate() == today.getDate() && pomDate.getMonth() == today.getMonth() && pomDate.getYear() == today.getYear()) className += ' calendartoday';

            if ( (minDate  &&  pomDate < minDate) || (maxDate  &&  pomDate > maxDate) ) className += ' calendardisabled';

            cells[i].attr("class", className);
            cells[i].data("calendarIndex", i);
            pomDate = ron.utils.incDayStart(pomDate, 1);
        }

        headerDiv.html( (month.getMonth() + 1) + '/' + month.getFullYear() );
    };



    var setDate = function (value) {
        date = new Date(value);

        showMonth(value);
    };


    var setDateText = function (text) {
        var date = ron.utils.stringToDate(text);
        if (date) setDate(date);
    };


    var setDateRange = function (from, to) {
        date = new Date(from);
        dateTo = new Date(to);

        if (textElementTo) showMonth(date);
        else showMonth(dateTo)
    };


    var setDateRangeText = function (textfrom, textto) {
        var datefrom = ron.utils.stringToDate(textfrom);
        var dateto = ron.utils.stringToDate(textto);

        if (datefrom && minDate && datefrom < minDate) datefrom = minDate;
        if (datefrom && maxDate && datefrom > maxDate) datefrom = maxDate;

        if (dateto && minDate && dateto < minDate) dateto = minDate;
        if (dateto && maxDate && dateto > maxDate) dateto = maxDate;

        if (datefrom && dateto) setDateRange(datefrom, dateto);
        else if (datefrom) setDate(datefrom);
    };
    var getDateForCell = function (cell) {
        var index = parseInt($(cell).data("calendarIndex"));
        return dates[index];
    };




    var hide = function () {
        calendarDiv.remove();
        calendarDiv = null;
    };


    var show = function () {
        calendarDiv = $("<div/>")
            .attr(
            {
                "class": "popup",
                tabindex: "1"  // aby fungovalo onblur a onkeypress!
            });

        calendarDiv
            .on("click", function () { return false; })
            ;

        calendarDiv.appendTo(parent);
        var topdiv = $("<div/>")
            .attr("class", "calendarheader")
            .css("width", "100%");

        calendarDiv.append(topdiv);


        $("<span/>")
            .attr("class", "calendarbutton")
            .css("float", "left")
            .html("&nbsp;<&nbsp;")
            .appendTo(topdiv)
            .on("click", function () {
                if (minDate) {
                    if (month <= minDate) return false;
                }

                showMonth(ron.utils.incMonth(month, -1));
                return false;
            });

        $("<span/>")
            .attr("class", "calendarbutton")
            .css("float", "right")
            .html("&nbsp;>&nbsp;")
            .appendTo(topdiv)
            .on("click", function () {
                var newmonth = ron.utils.incMonth(month, 1);
                if (maxDate) if (newmonth > maxDate) return false;

                showMonth(newmonth);
            });


        headerDiv = $("<span/>")
            .html("&nbsp;")
            .appendTo(topdiv);
        var table = $("<table/>")
            .attr("class", "calendartable")
            .appendTo(calendarDiv);
        var headerrow = $("<tr/>")
            .appendTo(table)
            .addClass("border-bottom border-dark");

        for (var den = 0; den < 7; den++) {
            var header = $("<th/>");
            switch (den) {
                case 6 :
                    header.html( ron._('Day_short_0') );
                    break;
                default :
                    header.html( ron._('Day_short_' + (den + 1)) );
            }

            headerrow.append(header);
        }
        for (var tyden = 0; tyden < 6; tyden++) {
            var row = $("<tr/>")
                .appendTo(table);

            for (den = 0; den < 7; den++) {
                var cell = $("<td/>")
                    .appendTo(row);

                cell.on("click", function () {
                    if (onCellClick(this)) hide(); // TODO: opravit
                });

                cells[cells.length] = cell;
            }
        }

        var pomDate = new Date();
        if (minDate && pomDate < minDate) setDate(minDate);
        else if (maxDate && pomDate > maxDate) setDate(maxDate);
        else setDate(pomDate);

        var pos = textElement.offset();
        var inputHeight = textElement.get(0).offsetHeight; // height() vraci jen vnitrni velikost

        var viewRect = ron.utils.windowViewRect();
        if (pos.top + inputHeight + calendarDiv.outerHeight() + 4 >= viewRect.y2) {
            pos.top -= calendarDiv.outerHeight();
        } else {
            pos.top += inputHeight;
        }

        calendarDiv
            .css("left", pos.left + "px")
            .css("top", pos.top + "px");

        calendarDiv
            .css("display", "block")
            .focus();

        calendarDiv.ronPopup({ closeAction: "remove" });
    };
    show();

    if (textElementTo) setDateRangeText(textElement.val(), textElementTo.val());
    else if (textElementFrom) setDateRangeText(textElementFrom.val(), textElement.val());
    else setDateText(textElement.val());
};
function ShowCalendar(inputname, submitForm, min, max) {
    console.log('Funkce ShowCalendar je deprecated! Pouzivejte ron.popupCalendar()');

    ron.popupCalendar("[name=" + inputname + "]", {
        submitForm : submitForm,
        minDate: min,
        maxDate: max
    });
}



$( function() {
    var showCalendar = function(event) {
        var inputSelector = $(this).data("roncalendar-input");

        if (!inputSelector) {
            var inputName = $(this).data("roncalendar-inputname");
            if (!inputName) return;

            inputSelector = "input[name='" + inputName + "']";
        }

        var $input = $(inputSelector);
        if (!$input.length) return;

        ron.popupCalendar($input[0]);
        return false; // nepropagovat udalost
    };


    $(document)
        .on("click", ".showcalendar", showCalendar);
});