

ronPortal.rozdeleniOsoby = function() {
    var filtr = "";         // aktualni filtr - uppercase - pro funkci filterFunction
    var nactenyFiltr = "";  // pro jaky filtr jsou data nactena (muze byt podretezcem filtr)
    var nactenoVse = false; // priznak, jestli je nacten i seznam neprirazenych rozdeleni
    var afterLoadData = function (responseData) {

        nactenyFiltr = responseData.data.filter;
        nactenoVse = responseData.data.nactenoVse;

        $("#InfoPocetRozdeleni").html(
            (responseData.data.count != undefined)
                ? ron.translate("Celkovy_pocet_zaznamu") + ": <strong>" + responseData.data.count + "</strong>"
                : "");
    };
    var $shiftForm = null;

    var loadShiftFormData = function (param) {
        $("#InfoPocetRozdeleni").html(ron._("Probiha_vyhledavani"));
        $shiftForm.shiftform("loadData", param);
    };

    var fitPattern = function (item, pattern) {
        if (pattern == '') return true;

        if (item.popis) {
            var pomstr = item.popis.toUpperCase();
            if (pomstr.indexOf(pattern) >= 0) return true;
        }

        if (item.kod) {
            pomstr = item.kod.toUpperCase();
            return pomstr.indexOf(pattern) >= 0;
        }
        return false;
    };
    var filterFunction = function (index, item) {
        return fitPattern(item, filtr);
    };


    var loadData = function (novyFiltr) {
        var dataNactena = false;

        var newFiltr = novyFiltr.toUpperCase();

        if (nactenoVse) {
            var loadedfiltr = nactenyFiltr.toUpperCase();
            dataNactena = (loadedfiltr != '') && newFiltr.indexOf(loadedfiltr) >= 0; // pokud je jiz nacteny filtr podretezcem noveho, tak neni potreba data nacitat znovu
        }

        filtr = newFiltr;

        if (dataNactena) {
            $shiftForm.shiftform("showData", filterFunction);
        } else {
            loadShiftFormData("filter=" + novyFiltr)
        }
    };


    var filtrujRozdeleniOsoby = function (event) // onkeyup
    {
        var zadanyFiltr = $("#filtrrozdeleni").val();

        if (event.which == 13 && zadanyFiltr.length >= 3) {
            loadShiftFormData("force=1");
        }

        if (zadanyFiltr == filtr) {
            return;
        }

        $("#vyhledatRozdeleni").prop("disabled", zadanyFiltr.length < 3);

        setTimeout( // timeout kvuli lepsi odezve
            function () {
                loadData(zadanyFiltr);
            }, 100
        );
    };
    var filtrRozdeleniOsobyKeyPress = function (event) // onkeypress
    {
        if (event.which == 13) return false; // zahodi enter - aby se nezavrelo okno
        return true;
    };


    var closeDialog = function() {
        $("#rozdeleniosobydialog").dialog("close");
    };


    var dblClickItem = null; // pouzije se jako parametr callBack funkce volane pri zavreni okna

    var onRightDblClick = function() {
        var index = $(this).data("rontable-index");
        dblClickItem = $shiftForm.shiftform("instance").options.data.rightItems[index].kod;
        closeDialog();
    };



    var onLeftDblClick = function() {
        var index = $(this).data("rontable-index");
        dblClickItem = $shiftForm.shiftform("instance").options.data.leftItems[index].kod;
        $shiftForm.shiftform("moveRight", [index], function() {
            closeDialog();
            return false; // aby zbytecne nerefreshoval obsah shiftformu
        });
    };
    return function (url, idpp, closeCallback) {
        url = url + "&idpp=" + idpp;

        var onClose = function() {
            if (closeCallback) closeCallback(dblClickItem);
        };

        if (!$shiftForm) {
            var $left = $("#NeprirazeneRozdeleni");
            var $right = $("#PrirazeneRozdeleni");
            $shiftForm = $("#rozdeleniosobydialog").shiftform({
                $leftTable: $left,
                $rightTable: $right,
                leftColumns: ["kod", "popis"],
                rightColumns: ["kod", "popis"],
                afterLoadData: afterLoadData,
                url: url
            });


            $left
                .on("dblclick", "tr", onLeftDblClick);

            $right
                .on("dblclick", "tr", onRightDblClick);

            $("#filtrrozdeleni")
                .on("keyup", filtrujRozdeleniOsoby)
                .on("keypress", filtrRozdeleniOsobyKeyPress);

            $("#zrusRozdeleniOsoby")
                .on("click", function () {
                    $shiftForm.shiftform("moveLeft");
                    return false;
                });

            $("#priradRozdeleniOsoby")
                .on("click", function () {
                    $shiftForm.shiftform("moveRight");
                    return false;
                });

            $("#vyhledatRozdeleni")
                .on("click", function () {
                    loadShiftFormData("filter=" + filtr + "&force=1");
                });

            $("#RozdeleniOK")
                .on("click", function() {
                    closeDialog();
                });
        }


        $("#rozdeleniosobydialog").dialog({
            modal: true,
            resizable: false,
            width: "auto",
            height: "auto",
            close: onClose
        });

        setTimeout(function () { // timeout kvuli lepsi odezve
            loadShiftFormData(null);
        }, 100);

        $("#filtrrozdeleni")
            .val("")
            .focus();
    };
}();
ronPortal.aktualizujRozdeleniOsoby = function(url, idpp, $selectKod, $selectPopis, newValue, callback) {

    var createRozdeleniSelectItems = function($select, items, pouzeKod) {
        var value = newValue ? newValue : $select.val();
        var newValueFound = false;

        $select.empty();
        $("<option/>")
            .attr("value", "")
            .appendTo($select);

        if (!value) newValueFound = true;

        for (var i = 0; i < items.length; i++) {
            if ($select) {
                $("<option/>")
                    .attr("value", items[i].kod)
                    .text(pouzeKod ? items[i].kod : items[i].popis)
                    .attr("class", items[i].cssClass ? items[i].cssClass : '')
                    .attr("title", pouzeKod ? items[i].popis : items[i].kod)
                    .appendTo($select);
            }

            if (items[i].kod == value) newValueFound = true;
        }

        if ( !newValueFound ) {
            $("<option/>")
                .attr("value", value)
                .text(value)
                .appendTo($select);
        }

        $select.val(value);
    };


    var ajaxUrl = url + "&shiftformaction=loaddata&jenvlastni=1&idpp=" + idpp;

    $.ajax( ajaxUrl )
        .done( function(responseData) {
            var i;

            if ( !responseData ) return;

            if ( responseData.result == 'OK' ) {
                for (i = 0;  i < $selectPopis.length;  i++) {
                    createRozdeleniSelectItems($selectPopis[i], responseData.data.rightItems, false); // i popis
                }
                responseData.data.rightItems.sort( function(item1, item2) {
                    return item1.kod.localeCompare(item2.kod);
                } );

                for (i = 0;  i < $selectKod.length;  i++) {
                    createRozdeleniSelectItems($selectKod[i], responseData.data.rightItems, true); // jen kod
                }

                if (callback) callback(newValue);
            }
            else {
                ron.showError(responseData);
            }

        }).fail( function(jqXHR) {
            ron.showAjaxError(jqXHR, "Chyba p�i na��t�n� seznamu rozd�len�!");
        });
};
ronPortal.rozdeleniOsoby_DVHromadne = function(idpp) {
    var url = '?menuid=editace&action=rozdeleniosoby';

    var aktualizujSelect = function(newValue) {
        ronPortal.aktualizujRozdeleniOsoby(url, idpp, [$("#vyberRozdeleni")], [$("#vyberRozdeleniPopis")], newValue);
    };

    ronPortal.rozdeleniOsoby(url, idpp, aktualizujSelect);
};
ronPortal.rozdeleniOsoby_DVDenni = function(idpp) {
    var url = '?menuid=editace&action=rozdeleniosoby';

    var aktualizujSelecty = function(newValue) {
        console.log(newValue);
        var $kody = [];
        var $popisy = [];

        var cnt = parseInt($("#DenniVysledekR_COUNT").val());
        for (var i = 0;  i < cnt;  i++) {
            $kody[$kody.length] = $("#DenniVysledekR" + i + "_kod1");
            $popisy[$popisy.length] = $("#DenniVysledekR" + i + "_kod");
        }

        var nastavNovouHodnotu = function() {
            if (newValue) {
                if ($("#DenniVysledekR" + (cnt - 1) + "_novyradek").val()) {
                    $kody[cnt-1].val(newValue);
                    $popisy[cnt-1].val(newValue);
                }
            }
        };

        ronPortal.aktualizujRozdeleniOsoby(url, idpp, $kody, $popisy, null, nastavNovouHodnotu);

    };

    ronPortal.rozdeleniOsoby(url, idpp, aktualizujSelecty);
};
