<?php
/**
 * UTF8
 * stanislav.elbl, 14.10.2014
 * kompaktni needitovatelne zobrazeni radku sluzebnich cest
 */

namespace Ron\RonPortal;


use Ron\DateUtils;
use Ron\DB\Database;
use Ron\StringUtils;

class KompaktniRadekSluzebniCesty
{
    var $f_datumcas_od;
    var $f_datumcas_do;

    var $f_popis;

    var $f_snidane;
    var $f_obedy;
    var $f_vecere;

    function KompaktniRadekSluzebniCesty() {
        $this ->f_popis = '';
        $this ->f_snidane = 0;
        $this ->f_obedy = 0;
        $this ->f_vecere = 0;
    }


    function getDatumStr() {
        if ( DateUtils::startOfTheDay($this ->f_datumcas_od) == DateUtils::startOfTheDay($this ->f_datumcas_do) ) {
            return date('j.n.Y G:i', $this ->f_datumcas_od) . ' - ' . date('G:i', $this ->f_datumcas_do);
        }
        else {
            return date('j.n.Y G:i', $this ->f_datumcas_od) . ' - ' . date('j.n.Y G:i', $this ->f_datumcas_do);
        }
    }


    /**
     * @param Database $database
     * @param SluzebniCesta $sluzebniCesta
     * @returns KompaktniRadekSluzebniCesty[]
     */
    public static function nactiKompaktniRadkySC($database, $sluzebniCesta)
    {
        $sql =
            'SELECT RadekSluzebniCesty.Stav, RadekSluzebniCesty.DatumCasOd, RadekSluzebniCesty.Popis, '. // 0..2
            ' RadekSluzebniCesty.Stat, RadekSluzebniCesty.Misto, '. // 3,4
            ' RadekSluzebniCesty.PocetPJidel_S, RadekSluzebniCesty.PocetPJidel_O, RadekSluzebniCesty.PocetPJidel_V, '. // 5..7
            ' MistoSluzebniCesty.Popis '. // 8
            '  FROM RadekSluzebniCesty LEFT OUTER JOIN MistoSluzebniCesty '.
            '    ON MistoSluzebniCesty.Kod = RadekSluzebniCesty.Misto '.
            ' WHERE RadekSluzebniCesty.SluzebniCesta_ID = '.(int)$sluzebniCesta ->id.
            ' ORDER BY RadekSluzebniCesty.DatumCasOd';

        $cursor = $database ->getSqlResult($sql);
        $result = [];

        /** @var $radek KompaktniRadekSluzebniCesty */
        $radek = null;
        $poslednistat = $sluzebniCesta ->f_stat;
        $poslednipopis = '';

        while ($row = $cursor ->fetch()) {
            if ( !$radek ) {
                $radek = new KompaktniRadekSluzebniCesty();
                $radek ->f_datumcas_od = $database ->stringToTimestamp($row[1]);
                $radek ->f_datumcas_do = $radek ->f_datumcas_od;
                $prvniradeksc = true;
                $poslednipopis = '';
            }
            else {
                $radek ->f_datumcas_do = $database ->stringToTimestamp($row[1]);
                $prvniradeksc = false;
            }

            // misto - jen pokud je ruzne od prednastaveneho mista
            if ( $row[4]  &&  $row[4] != RonPortalSettings::getValue(SluzebniCesta::SETTINGS_ZACATEK) ) {
                $radek ->f_popis .= ($radek ->f_popis ? ', ' : '') . StringUtils::htmlTextConvert($row[8]);
            }

            if ($row[2]  &&  $row[2] != $poslednipopis) {
                $radek ->f_popis .= ($radek ->f_popis ? ', ' : '') . StringUtils::htmlTextConvert($row[2]);
                $poslednipopis = $row[2];
            }

            // zmena statu => prida zkratku statu
            if ($row[3] != $poslednistat) {
                $radek ->f_popis .= ' (<strong>' . StringUtils::htmlTextConvert($row[3]) . '</strong>)';
                $poslednistat = $row[3];
            }

            $radek ->f_snidane += (int)$row[5];
            $radek ->f_obedy += (int)$row[6];
            $radek ->f_vecere += (int)$row[7];

            if ( $row[0] == 2  ||  (!$prvniradeksc  &&  $row[4]  &&  $row[4] == $sluzebniCesta ->mistoZacatku) ) {
                // konec
                $result [] = $radek;
                $radek = null;
            }
        }

        if ($radek) $result[] = $radek;

        return $result;
    }

}
