<?php
/**
 * UTF8
 * stanislav.elbl, 24.07.2015
 */

namespace Ron\RonPortal;

require_once('ron/controls.php');

use Ron\Controls\ComboBox;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;

/** @var SluzebniCestaFormular $this */

/** @var SluzebniCesta $sluzebniCesta */
$sluzebniCesta = Model::getInstance() ->getData('sluzebniCesta');

/** @var \Ron\DB\Database $database */
$database = Model::getInstance() ->getData('database');

/** @var string $formAction */
$formAction = Model::getInstance() ->getData('formAction');

$copyrecordid = null;
if (isset($_POST['copyrecordid'])) $copyrecordid = $_POST['copyrecordid'];
else if ($formAction == 'copy' && $_GET['record']) $copyrecordid = $_GET['record'];

?>
<!--suppress HtmlUnknownTarget -->
<h1><?= \Ron\ronText('Sluzebni_cesta') ?></h1>

<?= \Ron\ronText('SC_Form_info') ?>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div id="sluzebni_cesta_formular"
     data-sazba-kapesneho-podle-statu="<?= RonPortalSettings::getIntValue('sazbakapesnehopodlestatu') ?>"
     data-menit-sazbu-kapesneho="<?= RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_MENIT_SAZBU_KAPESNEHO) ?>"
     data-nacitat-adresu-rozdeleni="<?= RonPortalSettings::getIntValue('rozdelenisc_adresadocile') ?>"
     data-id-pp="<?= isset($sluzebniCesta ->f_PP ->idPP) ? $sluzebniCesta ->f_PP ->idPP : '' ?>"
     data-id-sc="<?= ($sluzebniCesta  &&  $sluzebniCesta ->id) ? $sluzebniCesta ->id : '' ?>" >
<form enctype="multipart/form-data" name="sluzebnicestaform" method="post" action="?menuid=sluzebnicesty&record=<?= $sluzebniCesta ->id ?>">
    <input type="hidden" name="Id" value="<?= $sluzebniCesta ->id ?>" />
    <input type="hidden" name="formaction" value="<?= $formAction /* save/insert */?>" />
    <input type="hidden" name="record" value="<?= $sluzebniCesta ->id ?>" />

    <?php if ($copyrecordid) { ?>
        <input type="hidden" name="copyrecordid" value="<?= $copyrecordid ?>" />
    <?php } ?>



    <div class="form large-form form-sm">
        <div class="form-content sluzebnicestaformular<?= $sluzebniCesta ->zahranicni ? ' zahranicniSC' : '' ?><?= $sluzebniCesta ->pozadovanaZaloha ? ' pozadovanazalohaSC' : '' ?>" id="sluzebnicestatable">
            <!-- zahranicni -->
            <div class="row" id="hlavickasc_zahranicni">
                <div class="col col-12 align-right">
                    <label>
                        <?= \Ron\ronText('Zahranicni') ?>
                        <input type="checkbox" id="scZahranicni" name="Zahranicni" <?php if ($sluzebniCesta ->zahranicni) echo 'checked="checked"'; ?> />
                    </label>
                </div>
            </div>

            <!-- osoba -->
            <div class="row" id="hlavickasc_osoba">
                <div class="col-12 col-sm-3 caption required"><?= \Ron\ronText('Osoba') ?></div>
                <div class="col-12 col-sm-9">
                    <?php $this ->comboBoxOsoba -> render(); ?>
                </div>
            </div>

            <!-- stat -->
            <?php
            if (!RonPortalSettings::getValue(SluzebniCesta::SETTINGS_STAT)  &&  !RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI_PRO_STAT)) { ?>
                <div class= "row" id="hlavickasc_stat">
                    <div class="col-12 col-sm-3 caption required"><?= \Ron\ronText('Stat') ?></div>
                    <div class="col-12 col-sm-9">
                        <?php
                        // v nastaveni intrawebu neni zadan stat - musi ho zadat uzivatel
                        ComboBox::renderComboBox('Stat', $this ->statySC, $sluzebniCesta ->f_stat, ['className' => 'form-control', 'htmlParams' => 'id="vychoziStatSC"']);
                        ?>
                    </div>
                </div>
            <?php } ?>

            <!-- zacatek -->
            <?php if (!RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ZACATEK_NEMENIT)) { ?>
                <div class="row" id="hlavickasc_zacatek">
                    <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Misto_zacatku') ?></div>
                    <div class="col-12 col-sm-9"><?php
                        ComboBox::renderComboBox('MistoZacatku', $this ->pocatkySC, $sluzebniCesta ->mistoZacatku, ['className' => 'form-control']);
                        ?>
                    </div>
                </div>
            <?php } ?>

            <div class="row" id="hlavickasc_popiszacatku">
                <div class="col-12 col-sm-3 caption"><?= RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ZACATEK_NEMENIT) ? \Ron\ronText('Misto_zacatku') : \Ron\ronText('Popis_mista_zacatku') ?></div>
                <div class="col-12 col-sm-9">
                    <input class="form-control" name="PopisMistaZacatku" maxlength="160" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->popisZacatku) ?>" type="text">
                </div>
            </div>

            <!-- cil -->
            <div class="row" id="hlavickasc_cil">
                <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Cil_sc') ?></div>
                <div class="col-12 col-sm-9"><?php
                    ComboBox::renderComboBox('Cil', $this ->cileSC, $sluzebniCesta ->cil, ['className' => 'form-control']);
                    ?>
                </div>
            </div>

            <div class="row" id="hlavickasc_popiscile">
                <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Popis_cile') ?></div>
                <div class="col-12 col-sm-9">
                    <input class="form-control" name="PopisCile" maxlength="160" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->popisCile) ?>" type="text">
                </div>
            </div>

            <!-- pres -->
            <div class="row" id="hlavickasc_pres">
                <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Pres') ?></div>
                <div class="col-12 col-sm-9">
                    <input class="form-control" name="Pres" maxlength="160" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->pres) ?>" type="text">
                </div>
            </div>

            <!-- cilovy stat -->
            <div class="row" id="hlavickasc_cilovystat">
                <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Cilovy_stat') ?></div>
                <div class="col-12 col-sm-9">
                    <?php
                    ComboBox::renderComboBox('CilovyStat', $this ->statySC, $sluzebniCesta ->cilovyStat, ['className' => 'form-control', 'htmlParams' => 'id="CilovyStat"']);
                    ?>
                </div>
            </div>

            <!-- rozdeleni 1 -->
            <?php if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI)) { ?>
                <div id="hlavickasc_rozdeleni">
                    <div class="row">
                        <div class="col-12 col-sm-3 caption<?= RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ROZDELENI_POVINNE) ? ' required' : '' ?>">
                            <?= \Ron\ronText('Rozdeleni_sc') ?: StringUtils::htmlTextConvert($this ->typRozdeleni ->popis); ?>
                        </div>
                        <div class="col-12 col-sm-6">
                            <?php $this ->comboBoxesRozdeleni ->combo1 ->render(); ?>
                        </div>
                        <div class="d-xs-none col-3">
                            <?php $this ->comboBoxesRozdeleni ->combo2 ->render(); ?>
                        </div>
                    </div>
                    <?php if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ROZDELENI_POVOLIT_VYBER) ) { ?>
                        <div class="row">
                            <div class="d-xs-none col-3 caption"></div>
                            <div class="col-12 col-sm-9">
                                <span id="vybratRozdeleniSC" class="js"><?= \Ron\ronText('Vybrat_rozdeleni') ?></span>
                            </div>
                        </div>
                    <?php } ?>
                </div>
            <?php } ?>

            <div class="row" id="hlavickasc_ucel">
                <div class="col-12 col-sm-3 caption<?= (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_POVINNY_UCEL)) ? ' required' : ''  ?>"><?= \Ron\ronText('Ucel_sc') ?></div>
                <div class="col-12 col-sm-9">
                    <?php
                    ComboBox::renderComboBox('Ucel', $this ->ucelySC, $sluzebniCesta ->ucel, ['className' => 'form-control']);
                    ?>
                </div>
            </div>

            <!-- casy -->
            <div class="row" id="hlavickasc_casod">
                <div class="col-12 col-sm-3 caption required"><?= \Ron\ronText('Zacatek') ?></div>
                <div class="col-12 col-sm-9">
                    <input class="inputDate _col1" data-roncalendar-next="DatumCasDo" type="text" id="DatumSCOd" name="DatumCasOd" maxlength="10" size="10" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->datumOdStr) ?>"  />
                    <i class="showcalendar glyph-button inline-glyph fa glyph-calendar" data-roncalendar-inputname="DatumCasOd"></i>
                    <?php if ( !RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_CASY_AUTOMATICKY) ) { ?>
                        <input class="inputTime" type="text" name="DatumCasOd_time" maxlength="8" size="8" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->casOdStr) ?>"  />
                    <?php } ?>
                </div>
            </div>

            <div class="row" id="hlavickasc_casdo">
                <div class="col-12 col-sm-3 caption required"><?= \Ron\ronText('Konec') ?></div>
                <div class="col-12 col-sm-9">
                    <input class="inputDate _col1" type="text" data-roncalendar-prev="DatumCasOd" name="DatumCasDo" maxlength="10" size="10" value="<?= StringUtils::htmlTextConvert($sluzebniCesta -> datumDoStr) ?>" />
                    <i class="showcalendar glyph-button inline-glyph fa glyph-calendar" data-roncalendar-inputname="DatumCasDo"></i>
                    <?php if ( !RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_CASY_AUTOMATICKY) ) { ?>
                        <input class="inputTime" type="text" name="DatumCasDo_time" maxlength="8" size="8" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->casDoStr) ?>" />
                    <?php } ?>
                </div>
            </div>

            <!-- datum kurzu -->
            <?php if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ZADAVAT_DATUM_KURZU, 1) ) { ?>
                <div class="row" id="hlavickasc_datumkurzu">
                    <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Datum_kurzu') ?></div>
                    <div class="col-12 col-sm-9">
                        <input type="text" name="DatumKurzu" maxlength="10" size="10" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->datumKurzuStr) ?>">
                        <i class="showcalendar glyph-button inline-glyph fa glyph-calendar" data-roncalendar-inputname="DatumKurzu"></i>
                    </div>
                </div>
                <div class="row" id="hlavickasc_datumkurzuinfo">
                    <div class="col-12 col-sm-3 caption"></div>
                    <div class="col-12 col-sm-9"><span class="forminfotext"><?= \Ron\ronText('Datum_kurzu_info') ?></span></div>
                </div>
            <?php } ?>

            <?php if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_MENIT_SAZBU_KAPESNEHO)) { ?>
                <div class="row" id="hlavickasc_sazbakapesneho">
                    <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Sazba_kapesneho') ?></div>
                    <div class="col-12 col-sm-3">
                        <input type="text" class="form-control" name="SazbaKapesneho" id="SazbaKapesneho" maxlength="5" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->sazbaKapesnehoStr) ?>">
                    </div>
                </div>
            <?php } ?>

            <!-- dopravni prostredek a vozidlo -->
            <div class="row" id="hlavickasc_dopravniprostredek">
                <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Dopravni_prostredek') ?></div>
                <div class="col-12 col-sm-3">
                    <?php
                    ComboBox::renderComboBox('DopravniProstredek', $this ->dopravniProstredky, $sluzebniCesta ->dopravniProstredek, ['className' => 'form-control']);
                    ?>
                </div>

                <?php
                    $comboVozidlo = new ComboBox('RegistracniZnacka');
                    //$comboVozidlo ->captionIndex = 0;
                    $comboVozidlo ->emptyRow = ' ';
                    $comboVozidlo ->className = 'form-control ' . MessageManager::getClass('RegistracniZnacka');

                    // nacte soukroma vozidla osoby a sluzebni vozidla
                    if (isset($sluzebniCesta->f_PP)) {
                        $params = $database->createParameters();
                        $comboVozidlo->loadData($database,
                            'SELECT Vozidlo.RegistracniZnacka, ' .
                            ' Vozidlo.RegistracniZnacka ' . $database->concatenateOperator . " ' ' " . $database->concatenateOperator . ' Vozidlo.Popis, ' .
                            ' Vozidlo.Soukrome, VozidloOsoby.RC' .
                            ' FROM Osoba JOIN Vozidlo ON 1 = 1 LEFT OUTER JOIN VozidloOsoby' . // v ON podmince nezvlada parametry, proto pripojuji tabulku Osoba a podminka je ve where
                            '   ON VozidloOsoby.RegistracniZnacka = Vozidlo.RegistracniZnacka' .
                            '  AND VozidloOsoby.RC = Osoba.RC' .
                            ' WHERE Osoba.RC = ' . $params->addParameter($sluzebniCesta->f_PP->rc) .
                            ' AND (Vozidlo.Soukrome = 0  OR  VozidloOsoby.RC IS NOT NULL)',
                            $sluzebniCesta->registracniZnacka, $params);
                    }

                    //if (count($comboVozidlo->data)) { ?>
                    <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Vozidlo') ?></div>
                    <div class="col-12 col-sm-3"><?php
                        ComboBox::renderComboBox('RegistracniZnacka', $this ->vozidla, $sluzebniCesta ->registracniZnacka,
                            [
                                'className' => 'form-control' . MessageManager::getClass('RegistracniZnacka'),
                                'htmlParams' => ['id' => 'RegistracniZnacka']
                            ]);
                        //$comboVozidlo ->render();
                        ?></div>
                <?php //} ?>
            </div>

            <?php if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_PRENASET_DO_DOCHAZKY, 1) == 1) { /* prenaseni do dochazky - nastaveno "podle volby uzivatele" */ ?>
                <div class="row" id="hlavickasc_prenosdodochazky">
                    <div class="col-12 col-sm-3 caption"><?= \Ron\ronText('Prenos_do_dochazky') ?></div>
                    <div class="col-12 col-sm-3">
                        <?php
                        $selectedValue = $sluzebniCesta ->prenasetDoDochazky ? $sluzebniCesta ->typPrenosuDoDochazky : -1;

                        ComboBox::renderComboFromArray(
                            [-1 => \Ron\ronText('Neprenaset_do_dochazky'), 0 => \Ron\ronText('Prenaset_po_smenach'), 1 => \Ron\ronText('Prenaset_podle_rozpisu')],
                            'TypPrenosuDoDochazky', $selectedValue, ['class' => 'form-input'], false
                        );
                        ?>
                    </div>
                </div>
            <?php } ?>

            <?php if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_CASY_PODLE_RADKU) == -1) { /* casy podle radku - nastaveno "podle volby uzivatele" */ ?>
                <div class="row" id="hlavickasc_casypodleradku">
                    <div class="col-8 col-sm-3 caption"><?= \Ron\ronText('Casy_podle_radku') ?></div>
                    <div class="col-4 col-sm-9 align-xs-right">
                        <input type="checkbox" id="sc_pocatekKonecPodleRadku" name="PocatekKonecPodleRadku" <?= $sluzebniCesta ->pocatekKonecPodleRadku ? 'checked="checked"' : '' ?>  />
                    </div>
                    <div class="col-3 caption"></div>
                    <div class="col-12 col-sm-9">
                        <span class="forminfotext"><?= \Ron\ronText('Casy_podle_radku_info') ?></span>
                    </div>
                </div>
            <?php } ?>

            <div class="row" id="hlavickasc_popis">
                <div class="col-12 col-sm-3 caption<?= RonPortalSettings::getIntValue('povinnypopisslcesty') ? ' required' : '' ?>"><?= \Ron\ronText('Popis_sc') ?></div>
                <div class="col-12 col-sm-9">
                    <input class="form-input" name="Popis" maxlength="160" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->popis) ?>" />
                </div>
            </div>

            <!-- rozdeleni 2 -->
            <?php if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2)) { ?>
                <div class="row" id="<?= (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2) != RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z)) ? 'hlavickasc_rozdeleni2tuzemska' : 'hlavickasc_rozdeleni2' ?>">
                    <div class="col-12 col-sm-3 caption"> <?php
                        $textRozdeleni = \Ron\ronText('Rozdeleni_sc_2');
                        if ($textRozdeleni) {
                            echo $textRozdeleni;
                        } else {
                            $typrozdeleni = new TypRozdeleni();
                            $typrozdeleni ->load($database, RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2));
                            echo StringUtils::htmlTextConvert($typrozdeleni ->popis);
                        }
                        ?>
                    </div>
                    <div class="col-12 col-sm-6">
                        <?php
                        $this ->showVyberRozdeleni('Rozdeleni2', 'rozdelenisc2',
                            RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2),
                            RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ROZDELENI2_POUZE_VLASTNI),
                            $sluzebniCesta ->kodTypuRozdeleni2 == RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2) ? $sluzebniCesta ->rozdeleni2 : null,
                            false, false); // povinne = false, kod = false
                        ?>
                    </div>
                    <div class="d-xs-none col-3">
                        <?php
                        $this ->showVyberRozdeleni('Rozdeleni2', 'rozdelenisc2',
                            RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2),
                            RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ROZDELENI2_POUZE_VLASTNI),
                            $sluzebniCesta ->kodTypuRozdeleni2 == RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2) ? $sluzebniCesta ->rozdeleni2 : null,
                            false, true); // povinne = false, kod = true
                        ?>
                    </div>
                </div>

                <?php if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z)  &&  RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2) != RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z)) { ?>
                    <div class="row" id="hlavickasc_rozdeleni2zahranicni">
                        <div class="col-12 col-sm-3 caption"> <?php
                            $textRozdeleni = \Ron\ronText('Rozdeleni_sc_2_zahranicni');
                            if ($textRozdeleni) {
                                echo $textRozdeleni;
                            } else {
                                $typrozdeleni = new TypRozdeleni();
                                $typrozdeleni ->load($database, (int)RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z));
                                echo StringUtils::htmlTextConvert($typrozdeleni ->popis);
                            }
                            ?>
                        </div>
                        <div class="col-12 col-sm-6">
                            <?php
                            $this ->showVyberRozdeleni('Rozdeleni2Z', 'rozdelenisc2Z',
                                RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z),
                                RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ROZDELENI2_POUZE_VLASTNI),
                                $sluzebniCesta ->kodTypuRozdeleni2 == RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z) ? $sluzebniCesta ->rozdeleni2 : null,
                                false, false); // povinne = false
                            ?>
                        </div>
                        <div class="d-xs-none col-3">
                            <?php
                            $this ->showVyberRozdeleni('Rozdeleni2Z', 'rozdelenisc2Z',
                                RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z),
                                RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ROZDELENI2_POUZE_VLASTNI),
                                $sluzebniCesta ->kodTypuRozdeleni2 == RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z) ? $sluzebniCesta ->rozdeleni2 : null,
                                false, true); // povinne = false
                            ?>
                        </div>
                    </div>
                <?php } ?>
            <?php } ?>

            <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA1)) { ?>
                <div class="row" id="hlavickasc_uzivatelska1">
                    <div class="col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA1) ?></div>
                    <div class="col-12 col-sm-9">
                        <input class="form-input" name="Uzivatelska1" maxlength="100" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska1) ?>" />
                    </div>
                </div>
            <?php } ?>

            <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA2)) { ?>
                <div class="row" id="hlavickasc_uzivatelska2">
                    <div class="col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA2) ?></div>
                    <div class="col-12 col-sm-9">
                        <input class="form-input" name="Uzivatelska2" maxlength="100" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska2) ?>" />
                    </div>
                </div>
            <?php } ?>

            <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA3)) { ?>
                <div class="row" id="hlavickasc_uzivatelska3">
                    <div class="col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA3) ?></div>
                    <div class="col-12 col-sm-9">
                        <input class="form-input" name="Uzivatelska3" maxlength="100" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska3) ?>" />
                    </div>
                </div>
            <?php } ?>

            <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA4)) { ?>
                <div class="row" id="hlavickasc_uzivatelska4">
                    <div class="col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA4) ?></div>
                    <div class="col-12 col-sm-9">
                        <input class="form-input" name="Uzivatelska4" maxlength="100" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska4) ?>" />
                    </div>
                </div>
            <?php } ?>

            <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA5)) { ?>
                <div class="row" id="hlavickasc_uzivatelska5">
                    <div class="col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA5) ?></div>
                    <div class="col-12 col-sm-9">
                        <input class="form-input" name="Uzivatelska5" maxlength="100" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska5) ?>" />
                    </div>
                </div>
            <?php } ?>

            <!-- ucetni zalezitosti -->
            <div class="row d-none" id="hlavickasc_urcenestravne">
                <div class="col-6 col-sm-3 caption"><?= \Ron\ronText('Maximalni_denni_stravne') ?></div>
                <div class="col-6 col-sm-3" id="maximalniDenniStravne"><?= StringUtils::format('number_2', $sluzebniCesta ->urceneDenniStravne) . ' ' . $sluzebniCesta ->urceneDenniStravneMena ?></div>
                <div class="col-6 col-sm-3 caption">
                    <?= \Ron\ronText('Urcene_kapesne') ?>
                </div>
                <div class="col-3 col-sm-2">
                    <input class="form-input" name="UrceneKapesne" value="<?= StringUtils::format('number_2', $sluzebniCesta ->urceneKapesne) ?>" />
                </div>
                <div class="col-3 col-sm-1">
                    <?php $this ->comboBoxMena('UrceneKapesneMena', $sluzebniCesta ->urceneKapesneMena); ?>
                </div>
            </div>

            <div class="row" id="hlavickasc_zpusobvyuctovani">
                <div class="col-6 col-sm-9 col-md-3 caption"><?= \Ron\ronText('Zpusob_vyuctovani_sc') ?></div>
                <div class="col-6 col-sm-3">
                    <?php ComboBox::renderComboBox('VyplatitHotove', $this ->zpusobyUctovani, $sluzebniCesta ->vyplatitHotove, ['className' => 'form-input']); ?>
                </div>

                <div class="col-6 col-sm-9 col-md-3 caption"><?= \Ron\ronText('Mena_pro_vyplaceni_sc') ?></div>
                <div class="col-6 col-sm-3">
                    <?php $this ->comboBoxMena('MenaProVyplaceni', $sluzebniCesta ->menaProVyplaceni); ?>
                </div>

            </div>

            <!-- zaloha -->
            <div id="hlavickasc_zaloha">
                <div class="row form-section" id="hlavickasc_pozadovanazaloha">
                    <div class="col-8 col-sm-3 caption"><label for="sc_pozadovanazaloha"><?= \Ron\ronText('Pozadovana_zaloha') ?></label></div>
                    <div class="col-4 col-sm-9 align-xs-right">
                        <input type="checkbox" id="sc_pozadovanazaloha" name="PozadovanaZaloha" <?= $sluzebniCesta ->pozadovanaZaloha ? 'checked="checked"' : '' ?>
                               class="toggleClass" data-selector="#sluzebnicestatable" data-check-class="pozadovanazalohaSC" />
                    </div>
                </div>

                <div class="row" id="hlavickasc_zalohacastka">
                    <div class="col-12 col-sm-9 col-md-3 caption"><?= \Ron\ronText('Zaloha_v_hotovosti') ?></div>
                    <div class="col-6 mobile-only"></div>
                    <div class="col-3 col-sm-2">
                        <input class="form-input" name="PozadovanaZalohaHotovost" value="<?= StringUtils::format('number_2', $sluzebniCesta ->pozadovanaZalohaHotovost) ?>" />
                    </div>
                    <div class="col-3 col-sm-1">
                        <?php $this ->comboBoxMena('PozadovanaZalohaHotMena', $sluzebniCesta ->pozadovanaZalohaHotovostMena); ?>
                    </div>
                </div>

                <div class="row" id="hlavickasc_zalohacastka">
                    <div class="col-12 col-sm-9 col-md-3 caption"><?= \Ron\ronText('Zaloha_na_ucet') ?></div>
                    <div class="col-6 mobile-only"></div>
                    <div class="col-3 col-sm-2">
                        <input class="form-input" name="PozadovanaZalohaUcet" value="<?= StringUtils::format('number_2', $sluzebniCesta ->pozadovanaZalohaUcet) ?>" />
                    </div>
                    <div class="col-3 col-sm-1">
                        <?php $this ->comboBoxMena('PozadovanaZalohaUcetMena', $sluzebniCesta ->pozadovanaZalohaUcetMena); ?>
                    </div>
                </div>

                <div class="row" id="hlavickasc_zalohaucet">
                    <div class="col-6 col-sm-9 col-md-3 caption"><?= \Ron\ronText('Cislo_uctu') ?></div>
                    <div class="col-6 col-sm-3">
                        <input class="form-input" name="CisloUctuProZalohu" maxlength="30" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->cisloUctuProZalohu) ?>">
                    </div>

                    <div class="col-6 col-sm-9 col-md-3 caption"><?= \Ron\ronText('Vedeny_v_mene') ?></div>
                    <div class="col-6 col-sm-3">
                        <?php $this ->comboBoxMena('MenaUctuProZalohu', $sluzebniCesta ->menaUctuProZalohu); ?>
                    </div>
                </div>

                <div class="row" id="hlavickasc_zalohaiban">
                    <div class="col-6 col-sm-9 col-md-3 caption"><?= \Ron\ronText('IBAN') ?></div>
                    <div class="col-6 col-sm-3">
                        <input class="form-input" name="PozadovanaZalohaIBAN" maxlength="40" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->pozadovanaZalohaIBAN) ?>">
                    </div>

                    <div class="col-6 col-sm-9 col-md-3 caption"><?= \Ron\ronText('SWIFT') ?></div>
                    <div class="col-6 col-sm-3">
                        <input class="form-input" name="PozadovanaZalohaSWIFT" maxlength="40" value="<?= StringUtils::htmlTextConvert($sluzebniCesta ->pozadovanaZalohaSWIFT) ?>">
                    </div>
                </div>
            </div>

            <!-- predpokladane naklady -->
            <?php if ($sluzebniCesta ->predpokladaneNaklady  &&  sizeof($sluzebniCesta ->predpokladaneNaklady) > 0) { ?>
                <div id="hlavickasc_predpokladanenaklady">
                    <div id="hlavickasc_predpokladanenakladycaption" class="row">
                        <div class="col-12 form-section"><?= \Ron\ronText('Predpokladane_naklady') ?></div>
                    </div>
                    <div class="row d-xs-none">
                        <div class="col-3"></div>
                        <div class="col-3"><?= \Ron\ronText('NSC_Pocet_dnu') ?></div>
                        <div class="col-3"><?= \Ron\ronText('Castka') ?></div>
                        <div class="col-3"><?= \Ron\ronText('Mena') ?></div>
                    </div>
                    <?php foreach($sluzebniCesta ->predpokladaneNaklady as $index => $predpokladanyvydaj) { ?>
                        <div class="row">
                            <div class="col-12 col-sm-3 caption" id="hlavickasc_predpokladanyvydaj_<?= $predpokladanyvydaj ->typ ?>">
                                <?= $predpokladanyvydaj ->popisTypu ?>
                                <input type="hidden" name="PV_Typ_<?= $index ?>" value="<?= StringUtils::htmlTextConvert($predpokladanyvydaj ->typ) ?>" />
                            </div>
                            <div class="mobile-only col-4"><?= \Ron\ronText('NSC_Pocet_dnu') ?></div>
                            <div class="mobile-only col-4"><?= \Ron\ronText('Castka') ?></div>
                            <div class="mobile-only col-4"><?= \Ron\ronText('Mena') ?></div>
                            <div class="col-4 col-sm-3">
                                <input type="text" class="form-input inputInt" name="PV_PocetDnu_<?= $predpokladanyvydaj ->typ ?>" value="<?= $predpokladanyvydaj ->pocetDnu ?>" />
                            </div>
                            <div class="col-4 col-sm-3">
                                <input type="text" class="form-input inputFloat" name="PV_Castka_<?= $predpokladanyvydaj ->typ ?>" value="<?= $predpokladanyvydaj ->castka ? number_format(StringUtils::stringToFloat($predpokladanyvydaj ->castka), 2, ',', ' ') : '' ?>" />
                            </div>
                            <div class="col-4 col-sm-3">
                                <?php $this ->comboBoxMena('PV_Mena_' . $predpokladanyvydaj ->typ, $predpokladanyvydaj ->kodMeny); ?>
                            </div>
                        </div>
                    <?php } ?>
                </div>
            <?php } ?>

            <!-- poznamka -->
            <div class="row" id="hlavickasc_poznamkacaption">
                <div class="col-12 form-section"><?= \Ron\ronText('Poznamka_sc') ?></div>
            </div>
            <div class="row" id="hlavickasc_poznamka">
                <div class="col-3 d-xs-none"></div>
                <div class="col-12 col-sm-9">
                    <textarea name="Poznamka" class="form-input" cols="60" rows="8"><?= StringUtils::htmlTextConvert($sluzebniCesta ->poznamka) ?></textarea>
                </div>
            </div>

            <!-- nastaveni kopie -->
            <?php if ($formAction == 'copy' || isset($_POST['copyrecordid'])) { ?>
                <div class="row form-gap" id="hlavickasc_kopirovatradky">
                    <div class="col-10 mobile-only caption"><label for="kopirovatradky"><?= \Ron\ronText('Kopirovat_radky_sc') ?></label></div>
                    <div class="col-3 d-xs-none"></div>
                    <div class="col-2 col-sm-9 align-xs-right">
                        <input type="checkbox" id="kopirovatradky" name="kopirovatradky" checked="checked" />
                        <label class="d-xs-none" for="kopirovatradky"><?= \Ron\ronText('Kopirovat_radky_sc') ?></label>
                    </div>
                </div>

                <div class="row" id="hlavickasc_kopirovatuctovani">
                    <div class="col-10 mobile-only caption"><label for="kopirovatuctovani"><?= \Ron\ronText('Kopirovat_uctovani_sc') ?></label></div>
                    <div class="col-3 d-xs-none"></div>
                    <div class="col-2 col-sm-9 align-xs-right">
                        <input type="checkbox" id="kopirovatuctovani" name="kopirovatuctovani"/>
                        <label class="d-xs-none" for="kopirovatuctovani"><?= \Ron\ronText('Kopirovat_uctovani_sc') ?></label>
                    </div>
                </div>
            <?php } ?>
        </div>

        <div id="hlavickasc_tlacitka" class="buttons">
            <input type="submit" class="submitbutton" value="<?= \Ron\ronText('form.Store') ?>" />
            <input type="reset" class="button" value="<?= \Ron\ronText('form.Original') ?>" />
            <input id="scFormularCancel" type="button" class="button clickHref" value="<?= \Ron\ronText('Cancel') ?>"
                   data-ron-href="<?= $sluzebniCesta ->id
                       ? "?menuid=sluzebnicesty&action=zobrazslcestu&record={$sluzebniCesta ->id}"
                       : "?menuid=sluzebnicesty" ?>" />
        </div>
    </div>

    <div></div>

</form>
</div>

<?php
if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI)  &&  RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ROZDELENI_POVOLIT_VYBER) ) {
    /** @noinspection PhpUnusedLocalVariableInspection */
    $typrozdeleni = $this->typRozdeleni; // pro pouziti ve view/rozdeleniosoby.php
    require_once('view/rozdeleniosoby.php');
    ?>
<?php } ?>
