<?php
/**
 * UTF8
 * stanislav.elbl, 4.10.2014
 */

namespace Ron\RonPortal;

use Ron\GuiUtils;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;

/** @var $this SluzebniCestaView */

/** @var $sluzebniCesta SluzebniCesta */
$sluzebniCesta = $this ->sluzebniCesta;

/** @var $vraceni bool */
$vraceni = Model::getInstance() ->getData('vraceni');

$zacatekStr = RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ZACATEK_NEMENIT) ? '' : StringUtils::htmlTextConvert($sluzebniCesta ->mistoZacatkuPopis);
if ($zacatekStr && $sluzebniCesta ->popisZacatku) $zacatekStr = '<span class="kod-mista-sc">' . $zacatekStr . ' - ' . '</span>';
$zacatekStr .= StringUtils::htmlTextConvert($sluzebniCesta ->popisZacatku);

$cilStr = StringUtils::htmlTextConvert($sluzebniCesta ->cilPopis);
if ($cilStr && $sluzebniCesta ->popisCile) $cilStr = '<span class="kod-mista-sc">' . $cilStr . ' - ' . '</span>';
$cilStr .= StringUtils::htmlTextConvert($sluzebniCesta ->popisCile);

// zauctovani
$prava_z = Prava::vratPrava('slcesty_zauct');
$lzezauctovat = $sluzebniCesta ->f_PP ->lzeZobrazitPP($prava_z, $sluzebniCesta ->datumCasOd, $sluzebniCesta ->datumCasDo);

// schvaleno nadrizenym
//$pravaNadrizeny = Prava::vratPrava('slcesty_nadriz');
//$jeNadrizeny = $sluzebniCesta ->f_PP ->lzeZobrazitPP($pravaNadrizeny, $sluzebniCesta ->datumCasOd, $sluzebniCesta ->datumCasDo);

//$pravaNadrizeny2 = Prava::vratPrava('slcesty_nadriz2');
//$jeNadrizeny2 = $sluzebniCesta ->f_PP ->lzeZobrazitPP($pravaNadrizeny2, $sluzebniCesta ->datumCasOd, $sluzebniCesta ->datumCasDo);

$pravaSpolucestujici = Prava::vratPrava('slcesty_spolu');

require_once 'sluzebnicesty/sc_utils.php';
$muzeSchvalovatZamestnancem = SluzebniCestyUtils::lzeSchvalitZamestnancem($sluzebniCesta ->f_PP ->rc,
    $sluzebniCesta ->f_PP ->idPP, $sluzebniCesta ->datumCasOd, $sluzebniCesta ->datumCasDo);

?>
<h1><?= \Ron\ronText('Sluzebni_cesta') ?> <span id='cisloSC'><?= $sluzebniCesta ->id ?></span></h1>

<?= \Ron\ronText('SC_View_info') ?>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div class="form middle-form<?php if ($sluzebniCesta ->zahranicni) echo ' zahranicniSC'; ?>" id="hlavickasluzebnicesty">
    <div class="form-content sluzebnicestaformular<?= $sluzebniCesta ->zahranicni ? ' zahranicniSC' : '' ?><?= $sluzebniCesta ->pozadovanaZaloha ? ' pozadovanazalohaSC' : '' ?>" id="sluzebnicestatable">
        <!-- zahranicni -->
        <?php if ($sluzebniCesta ->zahranicni) {?>
        <div class="row" id="hlavickasc_zahranicni">
            <div class="col col-12 align-right"><?= \Ron\ronText('Zahranicni') ?></div>
        </div>
        <?php } ?>

        <div class="row" id="hlavickasc_osoba">
            <div class="col col-3 d-xs-none"></div>
            <div class="col col-12 col-sm-9">
                <strong><?= $sluzebniCesta ->f_PP ->jmenoPrijmeni ?></strong>, <?= \Ron\ronText('Osobni_cislo') . ' ' . StringUtils::htmlTextConvert($sluzebniCesta ->f_PP ->osobniCislo) ?>
            </div>
        </div>

        <?php if (!$this ->vychoziStatOsoby ||  ($sluzebniCesta ->f_stat != $this ->vychoziStatOsoby) ) { ?>
            <div class="row" id="hlavickasc_stat">
                <div class="col col-3 d-xs-none"></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($this ->nazevStatu) ?></div>
            </div>
        <?php } ?>

        <div class="row" id="hlavickasc_datum">
            <div class="col col-3 d-xs-none caption"><?= \Ron\ronText('Date') ?></div>
            <div class="col col-12 col-sm-9"><?= date('j.n.Y G:i', $sluzebniCesta ->datumCasOd) . ' - ' . date('j.n.Y G:i', $sluzebniCesta ->datumCasDo) ?></div>
        </div>

        <?php if ($zacatekStr) { ?>
            <div class="row" id="hlavickasc_zacatek">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Misto_zacatku') ?></div>
                <div class="col col-12 col-sm-9"><?= $zacatekStr ?></div>
            </div>
        <?php } ?>


        <?php if ($cilStr) { ?>
            <div class="row"  id="hlavickasc_cil">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Cil_sc') ?></div>
                <div class="col col-12 col-sm-9"><?= $cilStr ?></div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->pres) { ?>
            <div class="row" id="hlavickasc_pres">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Pres') ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->pres) ?></div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->cilovyStat) { ?>
            <div class="row" id="hlavickasc_cilovystat">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Cilovy_stat') ?></div>
                <div class="col col-12 col-sm-9"><?= $sluzebniCesta ->cilovyStatPopis ?></div>
            </div>

        <?php } ?>

        <?php if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI)  &&  $sluzebniCesta ->rozdeleni) {
            $rozdeleni_text = \Ron\ronText('Rozdeleni_sc');
            if (!$rozdeleni_text  &&  $this ->typRozdeleni) {
                $rozdeleni_text = $this ->typRozdeleni ->popis;
            }
            ?>
            <div class="row" id="hlavickasc_rozdeleni">
                <div class="col col-12 col-sm-3 caption"><?= StringUtils::htmlTextConvert($rozdeleni_text) ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($this ->rozdeleni ->kod . ' - ' . $this ->rozdeleni ->popis) ?></div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->ucelPopis) { ?>
            <div class="row" id="hlavickasc_ucel">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Ucel_sc') ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->ucelPopis) ?></div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->dopravniProstredek) { ?>
            <div class="row" id="hlavickasc_dopravniprostredek">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Dopravni_prostredek') ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->dopravniProstredek) ?></div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->registracniZnacka) { ?>
            <div class="row" id="hlavickasc_vozidlo">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Vozidlo') ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->registracniZnacka) ?> - <?= StringUtils::htmlTextConvert($sluzebniCesta ->popisVozidla) ?></div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->popis) { ?>
            <div class="row" id="hlavickasc_popis">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Popis_sc') ?></div>
                <div class="col col-12 col-sm-9"><strong><?= StringUtils::htmlTextConvert($sluzebniCesta ->popis) ?></strong></div>
            </div>
        <?php } ?>

        <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA1)  &&  $sluzebniCesta ->uzivatelska1) { ?>
            <div class="row" id="hlavickasc_uzivatelska1">
                <div class="col col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA1) ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska1) ?></div>
            </div>
        <?php } ?>

        <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA2)  &&  $sluzebniCesta ->uzivatelska2) { ?>
            <div class="row" id="hlavickasc_uzivatelska2">
                <div class="col col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA2) ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska2) ?></div>
            </div>
        <?php } ?>

        <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA3)  &&  $sluzebniCesta ->uzivatelska3) { ?>
            <div class="row" id="hlavickasc_uzivatelska3">
                <div class="col col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA3) ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska3) ?></div>
            </div>
        <?php } ?>

        <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA4)  &&  $sluzebniCesta ->uzivatelska4) { ?>
            <div class="row" id="hlavickasc_uzivatelska4">
                <div class="col col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA4) ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska4) ?></div>
            </div>
        <?php } ?>

        <?php if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA5)  &&  $sluzebniCesta ->uzivatelska5) { ?>
            <div class="row" id="hlavickasc_uzivatelska5">
                <div class="col col-12 col-sm-3 caption"><?= RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA5) ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($sluzebniCesta ->uzivatelska5) ?></div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->poznamka) { ?>
            <div class="row" id="hlavickasc_poznamka">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Poznamka_sc') ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::longTextToHtml($sluzebniCesta ->poznamka, true) ?></div>
            </div>
        <?php } ?>

        <div class="row form-gap"></div>

        <div class="row" id="hlavickasc_zpusobvyuctovani">
            <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Zpusob_vyuctovani_sc') ?></div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($sluzebniCesta ->vyplatitHotoveStr . ($sluzebniCesta ->menaProVyplaceni ? ', ' . $sluzebniCesta ->menaProVyplaceni : '')) ?>
            </div>
        </div>

        <?php if ($sluzebniCesta ->urceneDenniStravne) { ?>
            <div class="row" id="hlavickasc_dennistravne">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Maximalni_denni_stravne') ?></div>
                <div class="col col-12 col-sm-9">
                    <?= StringUtils::format('number2', $sluzebniCesta ->urceneDenniStravne) . ' ' . $sluzebniCesta ->urceneDenniStravneMena ?>
                </div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->urceneKapesne) { ?>
            <div class="row">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Urcene_kapesne') ?></div>
                <div class="col col-12 col-sm-9">
                    <?= StringUtils::format('number2', $sluzebniCesta ->urceneKapesne) . ' ' . $sluzebniCesta ->urceneKapesneMena ?>
                </div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->pozadovanaZaloha) { ?>
            <div class="row">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Pozadovana_zaloha') ?></div>
                <div class="col col-12 col-sm-9">
                    <?php
                    if ($sluzebniCesta ->pozadovanaZalohaHotovost) echo \Ron\ronText('hotove') . ' ' . StringUtils::format('number2', $sluzebniCesta ->pozadovanaZalohaHotovost) . ' ' . $sluzebniCesta ->pozadovanaZalohaHotovostMena;
                    if ($sluzebniCesta ->pozadovanaZalohaHotovost  &&  $sluzebniCesta ->pozadovanaZalohaUcet) echo ', ';
                    $ucetstr = $sluzebniCesta ->cisloUctuProZalohu ? $sluzebniCesta ->cisloUctuProZalohu : ' ';
                    if ($sluzebniCesta ->pozadovanaZalohaIBAN) {
                        $ucetstr .= ($ucetstr ? ', ' : '') . \Ron\ronText('IBAN_pozadovane_zalohy') . ' ' . $sluzebniCesta ->pozadovanaZalohaIBAN;
                    }
                    if ($sluzebniCesta ->pozadovanaZalohaSWIFT) {
                        $ucetstr .= ($ucetstr ? ', ' : '') . \Ron\ronText('SWIFT_pozadovane_zalohy') . ' ' . $sluzebniCesta ->pozadovanaZalohaSWIFT;
                    }
                    $ucetstr = $ucetstr ? ' (' . $ucetstr  . ') ' : '';
                    if ($sluzebniCesta ->pozadovanaZalohaUcet) echo \Ron\ronText('na_ucet') . ' ' . StringUtils::format('number2', $sluzebniCesta ->pozadovanaZalohaUcet) . ' ' . $sluzebniCesta ->pozadovanaZalohaUcetMena . $ucetstr;
                    ?>
                </div>
            </div>
        <?php } ?>

        <div class="row" id="hlavickasc_vyuctovani">
            <div class="col col-8 col-sm-3 caption"><?= \Ron\ronText('Sluzebni_cesta_celkem') ?></div>
            <div class="col col-4 col-sm-9 align-xs-right"><strong><?=
                    isset($sluzebniCesta ->vyuctovani)
                        ? StringUtils::format('number2', $sluzebniCesta ->vyuctovani) . ' ' . StringUtils::htmlTextConvert($sluzebniCesta ->menaVyuctovani)
                        : '<span class="errorcolor">' . \Ron\ronText('Neni_vyuctovano') . '</span>'
                    ?></strong></div>
        </div>

        <?php if ($sluzebniCesta ->datumKurzu) { ?>
            <div class="row" id="hlavickasc_datumkurzu">
                <div class="col col-8 col-sm-3 caption"><?= \Ron\ronText('Datum_kurzu') ?></div>
                <div class="col col-4 col-sm-9 align-xs-right"><?= date('j.n.Y', $sluzebniCesta ->datumKurzu) ?></div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->sazbaKapesneho) { ?>
            <div class="row" id="hlavickasc_sazbakapesneho">
                <div class="col col-9 col-sm-3 caption"><?= \Ron\ronText('Sazba_kapesneho') ?></div>
                <div class="col col-3 col-sm-9 align-xs-right"><?= StringUtils::htmlTextConvert($sluzebniCesta ->sazbaKapesneho) ?> %</div>
            </div>
        <?php } ?>

        <?php if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_PRENASET_DO_DOCHAZKY, 1) == 1) /*podle volby uzivatele*/ { ?>
            <div class="row" id="hlavickasc_prenosdodochazky">
                <div class="col col-12 col-sm-3 caption"><?= \Ron\ronText('Prenos_do_dochazky') ?></div>
                <div class="col col-12 col-sm-9"><?php
                    if ($sluzebniCesta ->prenasetDoDochazky) {
                        switch ($sluzebniCesta ->typPrenosuDoDochazky) {
                            case 0 :
                                echo \Ron\ronText('Prenaset_po_smenach');
                                break;
                            case 1 :
                                echo \Ron\ronText('Prenaset_podle_rozpisu');
                                break;
                        }
                    } else {
                        echo \Ron\ronText('Neprenaset_do_dochazky');
                    }
                    ?></div>
            </div>
        <?php } ?>

        <?php if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_CASY_PODLE_RADKU) == -1  ||  (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_CASY_PODLE_RADKU) != $sluzebniCesta ->pocatekKonecPodleRadku)) { ?>
            <div class="row" id="hlavickasc_casypodleradku">
                <div class="col col-9 col-sm-3 caption"><?= \Ron\ronText('Casy_podle_radku') ?></div>
                <div class="col col-3 col-sm-9 align-xs-right"><?= \Ron\ronText($sluzebniCesta ->pocatekKonecPodleRadku ? 'Str_Yes' : 'Str_No') ?></div>
            </div>
        <?php } ?>

        <?php if ( $this ->rozdeleni2 ) {
            // rozdeleni 2 pro tuzemske SC
            $rozdeleni_text = \Ron\ronText('Rozdeleni_sc_2');
            if (!$rozdeleni_text  &&  $this ->typRozdeleni) {
                $rozdeleni_text = $this ->typRozdeleni2 ->popis;
            }
            ?>
            <div class="row" id="hlavickasc_rozdeleni2">
                <div class="col col-12 col-sm-3 caption"><?= StringUtils::htmlTextConvert($rozdeleni_text) ?></div>
                <div class="col col-12 col-sm-9"><?= StringUtils::htmlTextConvert($this ->rozdeleni2 ->kod . ' - ' . $this ->rozdeleni2 ->popis) ?></div>
            </div>
        <?php } ?>

        <!-- zauctovani -->
        <?php if ($sluzebniCesta ->zauctovanoStr || $lzezauctovat) { ?>
            <div class="row" id="hlavickasc_zauctovani">
                <div class="col col-sm-3 dis-xs d-xs-none"></div>
                <div class="col col-12 col-sm-9"><?php

                    if ($sluzebniCesta ->zauctovanoStr) echo StringUtils::htmlTextConvert($sluzebniCesta ->zauctovanoStr);

                    // zrusit zauctovani // zauctovat
                    if ($lzezauctovat) {
                        if ($sluzebniCesta ->zauctovano) echo " - <A href='?menuid=sluzebnicesty&action=zrusitzauctovani&record={$sluzebniCesta ->id}'>" . \Ron\ronText('Zruzit_zauctovani_sc') . '</A>';
                        else echo "<A href='?menuid=sluzebnicesty&action=zauctovat&record={$sluzebniCesta ->id}'>". \Ron\ronText('Zauctovat_sc') .'</A>';
                    }
                    ?>

                </div>
            </div>
        <?php } ?>

        <div class="row form-gap"></div>

        <?php if ( ($sluzebniCesta->spolucestujici  &&  count($sluzebniCesta->spolucestujici))  ||  $pravaSpolucestujici ->jsouNejakePrava() ) { ?>
            <div id="hlavickasc_spolucestujici">

                <div class="row" id="hlavickasc_spolucestujicicaption">
                    <div class="col col-12 form-section">
                        <?= \Ron\ronText('Spolucestujici') ?>
                    </div>
                </div>

                <?php if ($sluzebniCesta->spolucestujici  &&  count($sluzebniCesta->spolucestujici)) { ?>
                    <div id="hlavickasc_seznamspolucestujicich">
                        <?php foreach ($sluzebniCesta->spolucestujici as $spolucestujici) { ?>
                            <div class="row">
                                <div class="col col-3 d-xs-none"></div>
                                <div class="col col-12 col-sm-3">
                                    <?= $spolucestujici ->jmenoPrijmeni ?>
                                </div>
                                    <?php if ($pravaSpolucestujici ->lzeZobrazitPP($spolucestujici ->idPP)) { ?>
                                        <div class="col col-3 col-sm-2">
                                        <a href="?menuid=sluzebnicesty&action=odstranspolucestujiciho&record=<?= $sluzebniCesta ->id ?>&idpp=<?= $spolucestujici ->idPP ?>"
                                           class="confirmQuestion odstranitSpolucestujiciho"
                                           data-ron-confirm-id="Opravdu_odstranit_spolucestujiciho"><?= \Ron\ronText('Odstranit_spolucestujiciho') ?></a>
                                        </div>

                                        <div class="col col-9 col-sm-4 align-right">
                                        <?php if ($pravaSpolucestujici ->priznak) { // muze vytvorit kopii ?>
                                            <a href="?menuid=sluzebnicesty&action=kopieprospolucestujiciho&record=<?= $sluzebniCesta ->id ?>&idpp=<?= $spolucestujici ->idPP ?>"
                                               class="kopieProSpolucestujiciho"
                                               title="<?= StringUtils::htmlTextConvert(\Ron\ronText('Vytvorit_kopii_pro_spolucestujiciho_info')) ?>"
                                               data-ron-idpp="<?= $spolucestujici ->idPP ?>"
                                               data-ron-idsc="<?= $sluzebniCesta ->id ?>"
                                               data-ron-confirm-id="Opravdu_vytvorit_kopii_pro_spolucestujiciho"
                                               data-ron-working-info="<?= StringUtils::htmlTextConvert(\Ron\ronText('Probiha_zpracovani_dat')) ?>" ><?= \Ron\ronText('Vytvorit_kopii_pro_spolucestujiciho') ?>
                                            </a>
                                        <?php } ?>
                                        </div>
                                    <?php } ?>
                            </div>
                        <?php } ?>
                    </div>
                <?php } ?>

                <?php if ($pravaSpolucestujici ->jsouNejakePrava()) { ?>
                    <div class="row" id="hlavickasc_pridanispolucestujicich">
                        <div class="col col-3 d-xs-none"></div>
                        <div class="col col-12 col-sm-9">
                            <div><a href="#" id="hlavickasc_pridatspolucestujiciho"><?= \Ron\ronText('Pridat_spolucestujiciho') ?></a></div>
                            <div id="vyber_spolucestujiciho" style="display: none; position: relative">
                                <input id="jmenoSpolucestujiho" size="40">
                                <input id="osobniCisloSpolucestujiciho" size="10" maxlength="10">
                                <input type="hidden" id="idScSpolucestujiciho" value="<?= $sluzebniCesta ->id ?>">

                                <div>
                                    <input id="spolucestujiciOK" class="submitbutton" type="button" value="<?= \Ron\ronText('OK') ?>">
                                    <input id="spolucestujiciCancel" class="button" type="button" value="<?= \Ron\ronText("Cancel") ?>">
                                </div>

                                <div class="waitmessage" id="nacitani_spolucestujicich"><?= \Ron\ronText("Probiha_nacitani") ?></div>
                            </div>
                        </div>
                    </div>
                <?php } ?>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->predpokladaneNaklady  &&  sizeof($sluzebniCesta ->predpokladaneNaklady) > 0) { ?>
            <div id="hlavickasc_predpokladanenaklady">
                <div class="row" id="hlavickasc_predpokladanenakladycaption">
                    <div class="col col-12 form-section">
                        <?= \Ron\ronText('Predpokladane_naklady') ?>
                    </div>
                </div>

                <?php foreach($sluzebniCesta ->predpokladaneNaklady as $predpokladanyvydaj) { ?>
                    <div class="row">
                        <div class="col col-6 col-sm-3 caption"><?= $predpokladanyvydaj ->popisTypu ?></div>
                        <div class="col col-6 col-sm-9">
                            <?php
                            if ($predpokladanyvydaj ->pocetDnu) echo $predpokladanyvydaj ->pocetDnu . ' ' . \Ron\ronText('NSC_dnu');
                            if ($predpokladanyvydaj ->pocetDnu  &&  $predpokladanyvydaj ->castkaStr) echo ', ';
                            if ($predpokladanyvydaj ->castkaStr) echo $predpokladanyvydaj ->castkaStr . ' ' . $predpokladanyvydaj ->kodMeny;
                            ?>
                        </div>
                    </div>
                <?php } ?>
            </div>
        <?php } ?>

        <div class="row" id="hlavickasc_schvaleni">
            <div class="col col-12 form-section">
                <?= \Ron\ronText('Schvaleni_sc') ?>
            </div>
        </div>

        <?php if ( !RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_NESCHVALOVAT_ZAMESTNANCEM) && ($muzeSchvalovatZamestnancem || $sluzebniCesta ->schvalenoZamestnancem)) { ?>
            <div class='row schvaleni_sc_zam' id="hlavickasc_schvalenizam">
                <div class='col col-6 col-sm-3 caption'><?= \Ron\ronText('Zamestnanec') ?></div>
                <div class="col col-6 col-sm-9">
                    <?php
                    if ($sluzebniCesta ->schvalenoZamestnancem) {
                        // je schvaleno zamestnancem
                        echo date('j.n.Y', $sluzebniCesta ->sz_datumcas) . ' ' . StringUtils::htmlTextConvert($sluzebniCesta ->sz_uzivatel);
                        $zrusitText = \Ron\ronText('Zrusit_schvaleni_sc_zam');
                        if ($muzeSchvalovatZamestnancem) echo "&nbsp;&nbsp;&nbsp;<A href='?menuid=sluzebnicesty&action=zrusschvalenizam&record={$sluzebniCesta ->id}'>$zrusitText</A>";
                    } else {
                        // neni schvaleno zamestnancem
                        $schvalitText = \Ron\ronText('Schvalit_sc_zam');
                        echo "<A href='?menuid=sluzebnicesty&action=schvalslcestuzam&record={$sluzebniCesta ->id}'>$schvalitText</A>";
                    }
                    ?>
                </div>
            </div>
        <?php } ?>

        <?php  // povoleni nadrizeneho
        $this ->zobrazPovoleniNadrizeneho(1, $sluzebniCesta ->schvalenoNadrizenym, $sluzebniCesta ->sn_uzivatel, $sluzebniCesta ->sn_datumcas);
        $this ->zobrazPovoleniNadrizeneho(2, $sluzebniCesta ->schvalenoNadrizenym2, $sluzebniCesta ->sn2_uzivatel, $sluzebniCesta ->sn2_datumcas);
        $this ->zobrazPovoleniNadrizeneho(3, $sluzebniCesta ->schvalenoNadrizenym3, $sluzebniCesta ->sn3_uzivatel, $sluzebniCesta ->sn3_datumcas);
        $this ->zobrazPovoleniNadrizeneho(4, $sluzebniCesta ->schvalenoNadrizenym4, $sluzebniCesta ->sn4_uzivatel, $sluzebniCesta ->sn4_datumcas);
        ?>

        <?php  // schvaleni
        if (!$sluzebniCesta ->jeSchvalena(2) && $sluzebniCesta ->schvaleni1) $urovenvraceni = 1; // 1. je schvalena, dalsi ne => uzivatel na urovni 2 muze vratit
        else if (!$sluzebniCesta ->jeSchvalena(3) && $sluzebniCesta ->schvaleni2) $urovenvraceni = 2; // 2. je schvalena, dalsi ne => uzivatel na urovni 3 muze vratit
        else if (!$sluzebniCesta ->jeSchvalena(4) && $sluzebniCesta ->schvaleni3) $urovenvraceni = 3; // 3. je schvalena, dalsi ne => uzivatel na urovni 4 muze vratit
        else $urovenvraceni = 0;

        $this ->zobrazSchvaleni($sluzebniCesta ->schvaleni1, $sluzebniCesta ->schvalil1, 1, false, $sluzebniCesta ->datumVraceni1); // datum, schvalil, uroven, lzeVratit, datumVraceni
        $this ->zobrazSchvaleni($sluzebniCesta ->schvaleni2, $sluzebniCesta ->schvalil2, 2, $urovenvraceni == 1, $sluzebniCesta ->datumVraceni2);
        $this ->zobrazSchvaleni($sluzebniCesta ->schvaleni3, $sluzebniCesta ->schvalil3, 3, $urovenvraceni == 2, $sluzebniCesta ->datumVraceni3);

        if ($sluzebniCesta ->jeSchvalena(4)  ||  Prava::vratPrava('slcesty_schval4') ->lzeZobrazitPP($sluzebniCesta ->f_PP ->idPP)) {
            // uroven 4 jen kdyz ma prava nebo je schvalena
            $this->zobrazSchvaleni($sluzebniCesta->schvaleni4, $sluzebniCesta->schvalil4, 4, $urovenvraceni == 3, null);
        }
        ?>

        <?php if (RonPortalSettings::getIntValue(SluzebniCestyController::SETTINGS_POUZIVAT_VRACENI) && $urovenvraceni) { // pouziva se vraceni absence - div pro zapsani poznamky k vraceni
            $value = '';
            if (isset($_POST['poznamkakvraceni'])) $value = $_POST['poznamkakvraceni'];
            ?>
            <div class="row">
                <div class="col col-12">
                    <div id="vracenisluzebnicesty" <?php if (!$vraceni) echo 'style="display:none"'; /* zobrazi se az po kliknuti na "vratit" */ ?> >
                        <form method="post" name="vracenisluzebnicestyform" action="?menuid=sluzebnicesty&action=vratslcestu&record=<?= $sluzebniCesta ->id ?>">
                            <input type="hidden" name="urovenvraceni" value="<?= $urovenvraceni ?>" />

                            <label>
                                <strong><?= \Ron\ronText('Poznamka_k_vraceni') ?></strong><br/>
                                <textarea name="poznamkakvraceni" rows="8" style="width:100%"><?= StringUtils::htmlTextConvert($value) ?></textarea><br/>
                            </label>
                            <input type="submit" class="submitbutton" value="OK">

                        </form>
                    </div>
                </div>
            </div>
        <?php } ?>

        <?php if ($sluzebniCesta ->lzeEditovat  &&  $sluzebniCesta ->lzeEditovatHlavicku) { /* jeste neni nastaveno schvaleni, prava OK, obdobi OK - lze upravit */ ?>
            <div class="row form-gap"></div>
            <!-- link upravit -->
            <div class="row">
                <div class="col col-3"></div>
                <div class="col col-9 align-xs-right"><a href='?menuid=sluzebnicesty&formaction=edit&record=<?= $sluzebniCesta ->id ?>'><?= \Ron\ronText('Upravit') ?></a></div>
            </div>
        <?php } ?>

        <div class="row" id="hlavickasc_historie">
            <div class="col col-3 d-xs-none"></div>
            <div class="col col-12 col-sm-9">
                <div id="historie_sc" class="autoExpand poznamka font-normal">
                    <?= StringUtils::longTextToHtml(trim($sluzebniCesta ->historieSchvalovani)) ?>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col col-12 align-right">
                <a target="_blank" href="?menuid=sluzebnicesty&action=ical&timestamp=<?= time() ?>&idslcesty=<?= $sluzebniCesta ->id; ?>"><?= \Ron\ronText('Stahnout_do_kalendare') ?></a>
            </div>
        </div>
    </div>
</div>


<?php require_once('ron/guiutils.php'); GuiUtils::scrollPageScript(); ?>
