<?php
/** stanislav.elbl, 23.10.2014 */

namespace RonPortal\Dochazka;

use Ron\DateUtils;
use Ron\MessageManager;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\RonPortalSettings;

global $STR_ZpracovanoDo;   // kompat
global $STR_ZkontrolovanoDo;// kompat
global $STR_SchvalenoDo;    // kompat

/** @var $connection resource */
/** @var $this HromadneSchvaleniFormular */

$datumpredplneni = $this -> datumZpracovaniDochazky;
if ( $datumpredplneni < $this -> obdobi -> zacatek ) $datumpredplneni = 0;
else if ( $datumpredplneni > $this -> obdobi -> konec ) $datumpredplneni = $this -> obdobi -> konec;

?>
<h1><?= TextManager::_('Schvalovani') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<form name="schvalovaniform" id="hromadneschvalenidochazky" method="post" action="?menuid=schvalovani">
    <input type="hidden" name="schvaleniaction" value="hromadneschvaleni" />
    <input type="hidden" name="obdobi" value="<?= DateUtils::dateToUrlString($this -> obdobi -> zacatek) ?>" />
    <input type="hidden" name="rozdeleni" value="<?= StringUtils::htmlTextConvert($this -> kodRozdeleni) ?>" />
    <input type="hidden" name="rozdeleni2" value="<?= StringUtils::htmlTextConvert($this -> kodRozdeleni2) ?>" />

    <div class='form form-30-70' id="hromadneschvalenitable">
        <div class="form-content">
            <div class="form-row" id="hromadneschvaleni_obdobi">
                <div class="form-col form-col1 caption"><?= TextManager::_('Obdobi') ?></div>
                <div class="form-col form-col2 font-weight-bold"><?= StringUtils::htmlTextConvert($this -> obdobi -> popis) ?></div>
            </div>

            <?php if ($this -> kodRozdeleni) { ?>
                <div class="form-row" id="hromadneschvaleni_rozdeleni">
                    <div class="form-col form-col1 caption"><?= RonPortalSettings::getValue(RonPortalSettings::ROZDELENI_NADPIS) ?></div>
                    <div class="form-col form-col2 font-weight-bold">
                        <?= $this ->rozdeleni ? StringUtils::htmlTextConvert($this ->rozdeleni ->popis . ' (' . $this ->rozdeleni ->kod . ')') : '' ?>
                    </div>
                </div>
            <?php } ?>

            <?php if ($this -> kodRozdeleni2) { ?>
                <div class="form-row" id="hromadneschvaleni_rozdeleni2">
                    <div class="form-col form-col1 caption"><?= RonPortalSettings::getValue(RonPortalSettings::ROZDELENI2_NADPIS) ?></div>
                    <div class="form-col form-col2 font-weight-bold">
                        <?= $this ->rozdeleni2 ? StringUtils::htmlTextConvert($this ->rozdeleni2 ->popis . ' (' . $this ->rozdeleni2 ->kod . ')') : '' ?>
                    </div>
                </div>
            <?php } ?>

            <div class="form-row" id="hromadneschvaleni_zpracovani">
                <div class="form-col form-col1"></div>
                <div class="form-col form-col2"><?= TextManager::_('Datum_posledniho_zpracovani') ?> <?= date('j.n.Y', $this -> datumZpracovaniDochazky) ?></div>
            </div>

            <div class="form-gap"></div>

        <?php

            // Zpracovano do
            $this -> vlozPolickoSDatem($STR_ZpracovanoDo ?: TextManager::_('Dochazka_schvaleni_1_do'), 'textschvaleni1', 'zpracovanodo',
                $this -> zpracovanoDo, $this -> zpracoval,
                $this -> editovatZpracovano, $datumpredplneni);

            // Zkontrolovano do
            $this -> vlozPolickoSDatem($STR_ZkontrolovanoDo ?: TextManager::_('Dochazka_schvaleni_2_do'), 'formtablecaption textschvaleni2', 'zkontrolovanodo',
                $this -> zkontrolovanoDo, $this -> zkontroloval,
                $this -> editovatZkontrolovano, $datumpredplneni);

            // Schvaleno do
            $this -> vlozPolickoSDatem($STR_SchvalenoDo ?: TextManager::_('Dochazka_schvaleni_3_do'), 'formtablecaption textschvaleni3', 'schvalenodo',
                $this -> schvalenoDo, $this -> schvalil,
                $this -> editovatSchvaleno, $datumpredplneni);

            // Poznamka
            $checkedstr = ( isset($_POST['poznamka_check'])  &&  $_POST['poznamka_check'] ) ? "checked='checked'" : '';
        ?>

            <div class="form-row" id="hromadneschvaleni_poznamka">
                <div class="form-col form-col1 caption">
                    <label>
                        <?= TextManager::_('Poznamka') ?>
                        <input type="checkbox" id="hromadneschvaleni_poznamkacheck" name="poznamka_check" <?= $checkedstr ?> />
                    </label>
                </div>
                <div class="form-col form-col2">
                    <textarea name="poznamka" class="form-input" cols="80" rows="5" id="hromadneschvaleni_poznamkaedit"><?= StringUtils::htmlTextConvert(isset($_POST['poznamka']) ? $_POST['poznamka'] : $this -> poznamka) ?></textarea>
                </div>
            </div>
        </div>

        <div class="buttons">
            <div class="form-row" id="hromadneschvaleni_buttons">
                <div class="form-col form-col1"></div>
                <div class="form-col form-col2">
                    <input type="submit" class="submitbutton" value="<?= TextManager::_('Provest') ?>"/>
                </div>
            </div>
            <div class="form-row">
                <div class="form-col form-col1-2">
                    <a href="?menuid=schvalovani"><?= TextManager::_('Zpet') ?></a>
                </div>
            </div>
        </div>
    </div>
</form>

<script>$(function() { ronPortal.dochazka.hromadneSchvaleniForm(); });</script>
