<?php

/** UTF8
 * Pavel Rudol, RON Software
 *  12.2.2015
 */


namespace Ron\RonPortal;


use Ron\DateUtils;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use function Ron\ronText;


/* @var $terminal Terminal */
$terminal = Model::getInstance()->getData('terminal');
/* @var $prava PravaNaOsoby */
$prava = Model::getInstance()->getData('prava');


if (isset($_SESSION['terminalUspesnyTest']) && $_SESSION['terminalUspesnyTest']) {
    echo '<strong>'. ronText('UspesnyTestTerminalu').'</strong>';
    $_SESSION['terminalUspesnyTest'] = false;
}

MessageManager::getInstance()->showMessages();
MessageManager::getInstance()->clear();
?>

<h1><?= ronText('terminal_detail') ?></h1>
    

<table class='infotable minwidth' id='hlavickaterminalu'>
<tbody>
    <tr id="hlavickaterminalu_popis">
        <td class="inputformcaption"><?= ronText('terminal') ?></td>
        <td>
            <strong><?= StringUtils::htmlTextConvert($terminal ->kod) ?></strong> - <?= StringUtils::htmlTextConvert($terminal ->popis) ?>
        </td>
    </tr>
    
    <tr id="hlavickaterminalu_urceni">
        <td class="inputformcaption"><?= ronText('terminal_urceni') ?></td>
        <td>
            <strong><?= StringUtils::htmlTextConvert($terminal ->urceni) ?></strong>
        </td>
    </tr>
    
    <?php if ($terminal->umisteni) { ?>
    <tr id="hlavickaterminalu_umisteni">
        <td class="inputformcaption"><?= ronText('umisteni') ?></td>
        <td>
            <?= StringUtils::htmlTextConvert($terminal ->umisteni) ?>
        </td>
    </tr>
    <?php } ?>
    
    <?php if ($terminal->typrozdeleni) { ?>
    <tr id="hlavickaterminalu_rozdeleni">
        <td class="inputformcaption"><?= $terminal->typrozdeleni ?></td>
        <td>
            <?= StringUtils::htmlTextConvert($terminal ->rozdeleni) ?>
        </td>
    </tr>
    <?php } ?>
    
    <?php if ($terminal->poznamka) { ?>
    <tr id="hlavickaterminalu_poznamka">
        <td class="inputformcaption"><?= ronText('poznamka') ?></td>
        <td>
            <?= StringUtils::longTextToHtml(StringUtils::htmlTextConvert($terminal ->poznamka)) ?>
        </td>
    </tr>
    <?php } ?>
    
    <tr>
        <td></td>
        <td>&nbsp;</td>
    </tr>
    
    <?php if ($terminal->driver) { ?>
    <tr id="hlavickaterminalu_driver">
        <td class="inputformcaption"><?= ronText('driver') ?></td>
        <td>
            <?= StringUtils::htmlTextConvert($terminal ->driver) ?>
        </td>
    </tr>
    <?php } ?>
    
    <?php if ($terminal->typterminalu) { ?>
    <tr id="hlavickaterminalu_typterminalu">
        <td class="inputformcaption"><?= ronText('typ_terminalu') ?></td>
        <td>
            <?= StringUtils::htmlTextConvert($terminal ->typterminalu) ?>
        </td>
    </tr>
    <?php } ?>
    
    <?php if ($terminal->typkomunikacepopis) { ?>
    <tr id="hlavickaterminalu_typkomunikace">
        <td class="inputformcaption"><?= ronText('terminal_typ_komunikace') ?></td>
        <td>
            <?php 
            echo '<strong>' . StringUtils::htmlTextConvert($terminal ->typkomunikacepopis) . '</strong>';
            
            if ($terminal->hostitel && ($terminal->typkomunikacekod == 1))
            {
               echo ', ' . StringUtils::htmlTextConvert($terminal ->hostitel);
            }
            
            if ($terminal->port && ($terminal->typkomunikacekod == 1)) 
            {
                echo ' : ' . StringUtils::htmlTextConvert($terminal ->port);
            }
            
            if ($terminal->comport && (($terminal->typkomunikacekod == 2) || ($terminal->typkomunikacekod == 3))) 
            {
                echo ', ' . StringUtils::htmlTextConvert($terminal ->comport);
            }
            
            if ($terminal->parita && ($terminal->typkomunikacekod == 3)) 
            {
                echo ', ' . ronText('terminal_parita') . ': ' . StringUtils::htmlTextConvert($terminal ->parita);
            }
            
            if ($terminal->baudrate && ($terminal->typkomunikacekod == 3)) 
            {
                echo ', ' . ronText('terminal_baud_rate') . ': ' . StringUtils::htmlTextConvert($terminal ->baudrate);
            }
            
            ?>
        </td>
    </tr>
    <?php } ?>
    
    <tr>
        <td></td>
        <td>&nbsp;</td>
    </tr>
    
    <?php if ($terminal->stav) {  ?>
    <tr id="hlavickaterminalu_casnacteni">
        <td class="inputformcaption"><?= ronText('terminal_posledni_nacteni') ?></td>
        <td>
            <?php if ($terminal ->casuspesnehonacteni) echo DateUtils::fineDateString($terminal ->casuspesnehonacteni, true); ?>
        </td>
    </tr>
    
    <tr id="hlavickaterminalu_casnastaveni">
        <td class="inputformcaption"><?= ronText('terminal_posledni_nastaveni') ?></td>
        <td>
            <?php if ($terminal->casuspesnehonastaveni) echo DateUtils::fineDateString($terminal ->casuspesnehonastaveni, true); ?>
            <input type="hidden" id="hlavickaterminalu_casnastaveni_timestamp" value="<?= $terminal->casuspesnehonastaveni ?>" />
        </td>
    </tr>
    
    <tr id="hlavickaterminalu_casspojeni">
        <td class="inputformcaption"><?= ronText('terminal_posledni_spojeni') ?></td>
        <td>
            <?php if ($terminal->casuspesnehospojeni) echo DateUtils::fineDateString($terminal ->casuspesnehospojeni, true); ?>
        </td>
    </tr>
    
    <tr>
        <td></td>
        <td>&nbsp;</td>
    </tr>
        
    <tr id="hlavickaterminalu_pocetnacteni">
        <td class="inputformcaption"><?= ronText('terminal_pocet_nacteni') ?></td>
        <?php $class=''; if ($terminal->pocetneuspesnychnacteni > 0) {$class=' class="terminal_neuspesnanacteni"';} ?>
        <td<?= $class ?>>
            <?= StringUtils::format('number_1',$terminal ->pocetneuspesnychnacteni) ?>
        </td>
    </tr>
   
    <tr id="hlavickaterminalu_pocetnastaveni">        
        <td class="inputformcaption"><?= ronText('terminal_pocet_nastaveni') ?></td>
        <?php $class=''; if ($terminal->pocetneuspesnychnastaveni > 0) {$class=' class="terminal_neuspesnenastaveni"';} ?>
        <td<?= $class ?>>
            <?= StringUtils::format('number_1',$terminal ->pocetneuspesnychnastaveni) ?>
        </td>
        <input type="hidden" id="hlavickaterminalu_pocetnastaveni_int" value="<?= $terminal->pocetneuspesnychnastaveni ?>" />
    </tr>
    
    <tr id="hlavickaterminalu_pocetspojeni">
        <td class="inputformcaption"><?= ronText('terminal_pocet_spojeni') ?></td>
        <?php $class=''; if ($terminal->pocetneuspesnychspojeni > 0) {$class=' class="terminal_neuspesnaspojeni"';} ?>
        <td<?= $class ?>>
            <?= StringUtils::format('number_1',$terminal ->pocetneuspesnychspojeni) ?>
        </td>
    </tr>    
    
    <tr>
        <td></td>
        <td>&nbsp;</td>
    </tr>
    
    <?php if ($terminal->verzefirmware) { ?>
    <tr id="hlavickaterminalu_firmware">
        <td class="inputformcaption"><?= ronText('terminal_firmware') ?></td>
        <td>
            <?= StringUtils::htmlTextConvert($terminal ->verzefirmware) ?>
        </td>
    </tr>
    <?php } ?>
    
    <?php if ($terminal->seriovecislo) { ?>
    <tr id="hlavickaterminalu_seriovecislo">
        <td class="inputformcaption"><?= ronText('terminal_seriove_cislo') ?></td>
        <td>
            <?= StringUtils::htmlTextConvert($terminal ->seriovecislo) ?>
        </td>
    </tr>
    <?php } ?>
    
    <?php if ($terminal->macadresa) { ?>
    <tr id="hlavickaterminalu_macadresa">
        <td class="inputformcaption"><?= ronText('terminal_MAC') ?></td>
        <td>
            <?= StringUtils::htmlTextConvert($terminal ->macadresa) ?>
        </td>
    </tr>
    <?php }
        }
    ?>
    
</tbody>
</table>

<?php if ($terminal->kodAplikace) { ?>
<br/>
<div class="normaltext">
    <form name="detailterminaluform" id="detailterminaluform" method="post" action="?menuid=terminaly&record=<?= $terminal->kod ?>" >
        <input type="hidden" name="terminal_kod" value="<?= $terminal->kod ?>" />        
        <input class='submitbutton' name='test' type='submit' value='<?= ronText('terminal_provest_test') ?>' />
        <?php if ($prava->priznak) { ?>
            <input class='submitbutton' name='nastaveni' type='submit' value='<?= ronText('terminal_provest_generovani') ?>' />
        <?php } ?>
    </form>
</div>
<?php } ?>

<div id="terminal_generovani_dialog" style="display:none; text-align:center;" title="<?= ronText('terminal') . ': ' . $terminal->kod ?>">
    <span id="terminal_generovani_info"><?= ronText('Generovani') ?> </span><br/>
    <span id="dots"></span>
    <input type="hidden" id="zmenaStavu" value="0" />
    <DIV class="buttons align-center">
        <input type="button" id="btnZavritDialog" class="button" style="display: none;" value="<?= ronText('Zavrit') ?>" />
    </DIV>    
</div>

<script type="text/javascript">terminaly.nastavGenerovani(<?= RonPortalSettings::getIntValue('terminal_max_interval',15).','.
            RonPortalSettings::getIntValue('terminal_delka_intervalu',5) ?>);</script>

<BR>
<DIV class='normaltext'>
    <A href='?menuid=terminaly'><?= ronText('Zpet_na_seznam') ?></A>
</DIV>