<?php
/**
 * UTF8
 * stanislav.elbl, 23.11.2014
 * roman.szablatura, 14.10.2016 */

namespace Ron\Personalistika;

use Ron\Controls\DateInput;
use Ron\DateUtils;
use Ron\MVC\Model;
use Ron\RonPortal\Prava;
use Ron\RonPortal\PravaNaOsoby;
use Ron\RonPortal\RonPortalSettings;
use Ron\StringUtils;
use Ron\RonPortal\User;

/** @var Ukol $ukol */
$ukol = Model::getInstance() ->getData('ukol');
/** @var PravaNaOsoby $prava */
$prava = Prava::vratPrava('ukoly');



require_once('ron/controls.php');

//!Kvůli množství dílčích úprav je již formulář nepřehledný, pokud bude čas, pokusím se přepracovat

?>
<h1><?= \Ron\ronText('Ukol') ?></h1>
<form enctype="multipart/form-data" method="post" name="ukolform" action="?menuid=ukoly&">
    <input type="hidden" name="kodserial" value="<?= $ukol->kodSerial ?>" />

    <table class="inputtable">

        <tr><td></td></tr>
        <tr>
            <td class="inputformcaption"><strong><?= \Ron\ronText('StavUkolu')?></strong></td>
            <td style="font-size: 105%">
                <strong>
                    <?= ($ukol->stavUkolu == 0) ? \Ron\ronText('UkolProbiha') : ($ukol->stavUkolu == 1 ? \Ron\ronText('UkolSplnen') : \Ron\ronText('UkolZrusen'))?>
                </strong>
            </td>
        </tr>

        <tr><td></td></tr>
        <tr><td></td></tr>

<?php if(false) //<!------  Sekce Definice úkolu  -------> ?>
        <tr class="inputtablesection">
            <td  colspan="4"><strong><?= \Ron\ronText('Definice_ukolu') ?></strong></td>
        </tr>

        <!-- Zadáno osobě -->
        <tr>
            <td class="inputformcaption"><strong><?= \Ron\ronText('Resitel') ?></strong></td><td><strong><?= StringUtils::htmlTextConvert($ukol->osoba_Jmeno) ?></strong></td>
        </tr>

        <!-- typ, popis úkolu a podrobnosti -->
        <tr>
            <td class="inputformcaption"><?= \Ron\ronText('Typ_ukolu') ?></td><td colspan="3"><?= StringUtils::htmlTextConvert($ukol->typUkolu) ?></td>
        </tr>

        <tr>
            <td class="inputformcaption"><?= \Ron\ronText('zkraceny_popis') ?></td><td colspan="3"><i><?= StringUtils::htmlTextConvert($ukol->zkracenyPopis) ?></i></td>
        </tr>

        <tr>
            <td class="inputformcaption"><?= \Ron\ronText('Detailni_popis') ?></td><td colspan="3"><i><?= StringUtils::longTextToHtml($ukol->podrobnosti, true) ?></i></td>
        </tr>

        <tr><td></td></tr>

        <tr>
            <td class="inputformcaption"><strong><?= \Ron\ronText('Zadavatel') ?></strong></td><td colspan="3"><strong><?= StringUtils::htmlTextConvert($ukol->kdoZadal_Jmeno) ?></strong></td>
        </tr>

        <tr><td></td></tr>
        <tr><td></td></tr>

        <tr>
            <td class="inputformcaption"><?= \Ron\ronText('Datum_zadani') ?></td><td><?= date('j.n.Y', $ukol->datumZadani) ?></td>
        </tr>

        <!-- termín -->

        <tr>
            <td class="inputformcaption"><?= \Ron\ronText('Termin_ukolu') ?></td>
            <td>
                <div <?= $ukol->jeVTerminu?> <?php if (DateUtils::endOfTheDay($ukol->termin) < $ukol->datumSplneni || $ukol->stavUkolu == 0) {
                    echo 'class="po_terminu"';
                } ?>>
                    <?= date('j.n.Y', $ukol->termin) ?>
                </div>
            </td>
        </tr>

        <tr>
            <td class="inputformcaption"><strong><?= \Ron\ronText('Datum_splneni') ?></strong></td>
            <td <?= $ukol->jeVTerminu?> ><strong><?php if ($ukol->stavUkolu == 1) echo date('j.n.Y', $ukol->datumSplneni)?></strong></td>
        </tr>

        <?php if(RonPortalSettings::getIntValue('zobrazit_body') == 1){ ?>
            <tr><td></td></tr>

            <tr>
                <td class="inputformcaption"><?= \Ron\ronText('max_body') ?> /<strong><?= \Ron\ronText('dosazene_body') ?></strong></td>
                <td title="<?php echo StringUtils::format('number0', $ukol->procenta_Dosazenych) ?>%"><?php echo $ukol->pocetBodu_Maximalni ?> <?php if($ukol->pocetBodu_Maximalni !="") echo "/"?> <strong><?php echo $ukol->pocetBodu_Dosazeny ?></strong></td>
            </tr>

        <?php } ?>

        <?php if(RonPortalSettings::getIntValue('zobrazit_odmenu') == 1){ ?>
            <tr><td></td></tr>

            <tr>
                <td class="inputformcaption"><?= \Ron\ronText('Navrzena') ?> /<strong><?= \Ron\ronText('skutecna_odmena') ?></strong></td>
                <td><?php echo StringUtils::format('number0', $ukol->navrzenaOdmena) ?> <?php if($ukol->navrzenaOdmena !="") echo "/"?> <strong><?php echo StringUtils::format('number0', $ukol->skutecnaOdmena) ?></strong></td>
            </tr>

        <?php } ?>
        <tr><td></td></tr>

        <tr>
            <td class="inputformcaption"><?= \Ron\ronText('Dnesni_datum') ?></td>
            <td><?= date('j.n.Y', time())?></td>
        </tr>

        <tr><td></td></tr>
        <tr><td></td></tr>

        <!-- vazana osoba -->
        <tr>
            <td class="inputformcaption">
                <strong><?= StringUtils::htmlTextConvert($ukol->popisVazbyNaOsobu)?></strong>
            </td>
            <td colspan="3">
                <strong><?= StringUtils::htmlTextConvert($ukol->vazanaOsobaJmeno) ?>  <?= StringUtils::htmlTextConvert($ukol->vazanaOsobaPrijmeni)?></strong>
            </td>
        </tr>

        <!-- Hodnotitel -->
        <tr>
            <td class="inputformcaption">
                <strong><?= \Ron\ronText('Hodnotitel')?></strong></td>
            <td colspan="3"><strong><?= StringUtils::htmlTextConvert($ukol->hodnotitel) ?></strong></td>
        </tr>

        <!-- Schvalovatel 1.-->
        <?php  if(!empty($ukol->schvalovatel1_Def)) { ?>
            <tr>
                <td class="inputformcaption"><strong><?= \Ron\ronText('Schvalovatel_1')?></strong></td><td colspan="3"><strong><?= StringUtils::htmlTextConvert($ukol->schvalovatel1_Def) ?></strong></td>
            </tr>
        <?php } ?>

        <!-- Schvalovatel 2.-->
        <?php  if(!empty($ukol->schvalovatel2_Def)) { ?>
            <tr>
                <td class="inputformcaption" ><strong><?= \Ron\ronText('Schvalovatel_2')?></strong></td><td colspan="3"><strong><?= StringUtils::htmlTextConvert($ukol->schvalovatel2_Def) ?></strong></td>
            </tr>
        <?php } ?>

        <tr><td></td></tr>
        <tr><td></td></tr>

<?php  //<!------ Sekce Vyhodnoceni úkolu  ---------> ?>
        <tr class="inputtablesection">
            <td  colspan="4"><strong><?= \Ron\ronText('Vyhodnoceni_ukolu') ?></strong></td>
        </tr>

        <?php if ($ukol->RC_Osoby == User::getRC()) { //Možnost editace?>
            <?php  // prekazka   --?>
            <tr>
                <td class="inputformcaption"><?= \Ron\ronText('Prekazka_ukolu') ?></td>
                <td colspan="3">
                    <input title="Překážka" class="app_check" type="checkbox" name="Prekazka" <?php if ($ukol->prekazka) echo 'checked="checked"'; ?><?php if($ukol->stavUkolu == 1) echo 'disabled="disabled"'?> />
                    <?php if ($ukol->datumZapisuPrekazky) { ?>
                        &nbsp;&nbsp;&nbsp; (<?= DateUtils::fineDateString($ukol->datumZapisuPrekazky, true) ?>)
                    <?php } ?>
                    <?php if ($ukol->datumOdstraneniPrekazky) { ?>
                        - <?= \Ron\ronText('Prekazka_odstranena') ?> <?= DateUtils::fineDateString($ukol->datumOdstraneniPrekazky, true) ?>
                    <?php } ?>
                </td>
            </tr>

        <?php  //------- Text area  Poznamka_k_prekazce--?>
            <tr>
                <td class="inputformcaption"><?= \Ron\ronText('Poznamka_k_prekazce')?></td>
                <td colspan="4"><textarea title="Poznámka k překážce" rows="4" cols="50" name="PoznamkaKPrekazce"<?php if($ukol->stavUkolu == 1) echo 'disabled="disabled"'?> ><?= StringUtils::htmlTextConvert($ukol->poznamkaKPrekazce) ?></textarea></td>
            </tr>

        <?php  //------- splneni    -- ?>
            <?php if ($prava->f_priznak) { // moznost zadat datum splneni ?>
                <tr>
                    <td><?= \Ron\ronText('Datum_splneni') ?></td>
                    <td><?php
                        $val = $ukol->datumSplneni ? date('j.n.Y', $ukol->datumSplneni) : '';
                        DateInput::renderDateSelect('datumsplneni', $val, false);?>
                    </td>
                </tr>
            <?php } else { // jen zaskrtavatko ?>
                <tr>
                    <td class="inputformcaption"><?= \Ron\ronText('Splneno') ?></td>
                    <td>
                        <input title="<?= $ukol->dovednostZaUkolJe ? \Ron\ronText('uzamknuto_prirazenim_dovednosti') : '' ?>" class="app_check" type="checkbox" name="splneno" <?php if ($ukol->stavUkolu == 1) echo 'checked="checked"'; ?> <?php if ($ukol->hodnoceno == 1 || $ukol->RC_Osoby != User::getRC() || $ukol->dovednostZaUkolJe == 1) echo 'disabled="disabled"'; ?> />
                        <?php if ($ukol->datumSplneni) echo '&nbsp;&nbsp;&nbsp; ' . date('j.n.Y', $ukol->datumSplneni) ; ?>
                        <?php if ($ukol->hodnoceno == 1 || $ukol->RC_Osoby != User::getRC() || $ukol->dovednostZaUkolJe == 1) { ?>
                            <input type="hidden" name="splneno" value="<?= $ukol->stavUkolu?>">
                        <?php } ?>
                    </td>
                </tr>

                <!-- Text area    -->
                <tr><td class="inputformcaption"><?= \Ron\ronText('Poznamka_ke_splneni') ?></td>
                    <td colspan="3"><textarea title="Poznamka ke splnění" rows="4" cols="50"  name="PoznamkaKeSplneni" <?php if ($ukol->hodnoceno == 1 || $ukol->Schvaleno1 == 1 || $ukol->Schvaleno2 == 1 || $ukol->dovednostZaUkolJe == 1) echo 'disabled="disabled"'; ?>><?= StringUtils::htmlTextConvert($ukol->poznamkaKeSplneni) ?> </textarea></td></tr>
                    <?php if ($ukol->hodnoceno == 1 || $ukol->Schvaleno1 == 1 || $ukol->Schvaleno2 == 1 || $ukol->dovednostZaUkolJe == 1) { ?>
                    <input type="hidden" name="PoznamkaKeSplneni" value="<?= StringUtils::htmlTextConvert($ukol->poznamkaKeSplneni)?>">
                    <?php } ?>
            <?php } ?>
        <?php } ?>

        <?php if (($ukol->RC_Osoby != User::getRC())) { //Pouze pro textovy vypis - bez možnosti editace?>
            <!-- Překážka úkolu-->
            <tr>
                <td class="inputformcaption"><?= \Ron\ronText('Prekazka_ukolu') ?></td>
                <td colspan="3">
                    <input title="Překážka" class="app_check" type="checkbox" name="Prekazka" <?php if ($ukol->prekazka) echo 'checked="checked"'; ?><?php if($ukol->stavUkolu == 1  || $ukol->RC_Osoby != User::getRC()) echo 'disabled="disabled"'?> />

                    <?php if ($ukol->datumZapisuPrekazky) { ?>
                        &nbsp;&nbsp;&nbsp; (<?= DateUtils::fineDateString($ukol->datumZapisuPrekazky, true) ?>)
                    <?php } ?>

                    <?php if ($ukol->datumOdstraneniPrekazky) { ?>
                        - <?= \Ron\ronText('Prekazka_odstranena') ?> <?= DateUtils::fineDateString($ukol->datumOdstraneniPrekazky, true) ?>
                    <?php } ?>

                    <?php if ($ukol->stavUkolu == 1 || $ukol->RC_Osoby != User::getRC()) { ?>
                    <input type="hidden" name="Prekazka" value="<?= $ukol->prekazka?>">
                    <?php } ?>
                </td>
            </tr>

            <tr>
                <td class="inputformcaption"><?= \Ron\ronText('Poznamka_k_prekazce')?></td>
                <td colspan="4"><textarea title="Poznámka k překážce" rows="4" cols="50" name="PoznamkaKPrekazce"<?php if($ukol->stavUkolu == 1 || $ukol->RC_Osoby != User::getRC() || $ukol->dovednostZaUkolJe == 1) echo 'disabled="disabled"'?> ><?= StringUtils::htmlTextConvert($ukol->poznamkaKPrekazce) ?></textarea></td>
            </tr>

            <?php //---------------Splněno ?>
            <tr><td class="inputformcaption"><strong><?= \Ron\ronText('Splneno')?></strong></td>
                <td><input title="" type="checkbox" name="splneno" <?php if ($ukol->stavUkolu == 1) echo 'checked="checked"'; ?>
                        <?php if ($ukol->hodnoceno == 1 || $ukol->RC_Osoby != User::getRC()) { ?>
                            disabled="disabled">
                        <?php } ?>
                        <?php if ($ukol->hodnoceno == 1|| $ukol->RC_Osoby != User::getRC()) { ?>
                            <input type="hidden" name="splneno" value="<?= $ukol->stavUkolu?>">
                        <?php } ?>
                </td>
            </tr>

            <tr>
                <td class="inputformcaption"><?= \Ron\ronText('Poznamka_ke_splneni')?></td>
                <td colspan="4"><textarea title="Poznámka ke splnění" rows="4" cols="50" name="PoznamkaKeSplneni"
                        <?php if($ukol->stavUkolu == 1 || $ukol->RC_Osoby != User::getRC()) echo 'disabled="disabled"'?> ><?= StringUtils::htmlTextConvert($ukol->poznamkaKeSplneni) ?></textarea></td>
            </tr>

        <?php } ?>
<?php //---------------Hodnoceni ?>
        <tr>
            <td class="inputformcaption"><strong><?= \Ron\ronText('Hodnoceno')?></td>
            <?php if(($ukol->RC_Hodnotitele_Def == User::getRC()) && $ukol->stavUkolu == 1 && $ukol->Schvaleno1 == 0) { ?>
            <td><input title="" type="checkbox" name="Hodnoceno" <?php if($ukol->hodnoceno == 1) echo 'checked="checked"'; ?>>&nbsp;&nbsp;&nbsp;&nbsp;<?= $ukol->datumHodnoceni ? (date('j.n.Y',$ukol->datumHodnoceni)) : '' ?></strong></td>

            <?php } else { ?>
            <td><input title="" type="checkbox" name="Hodnoceno" disabled="disabled" <?php if($ukol->hodnoceno == 1) echo 'checked="checked"'; ?>>&nbsp;&nbsp;&nbsp;&nbsp;<?= $ukol->datumHodnoceni ? (date('j.n.Y',$ukol->datumHodnoceni)) : '' ?></strong></td>
                <input type="hidden" name="Hodnoceno" value="<?= $ukol->hodnoceno ?>">
            <?php }?>

            <td class="inputformcaption"><strong><?= \Ron\ronText('Hodnotil')?></strong></td><td><strong><?= StringUtils::htmlTextConvert($ukol->kdoHodnotil_Jmeno)?></strong></td>
        </tr>

        <tr>
            <td class="inputformcaption"><?= \Ron\ronText('Poznamka_k_hodnoceni')?></td><td colspan="3" width="10">
                <?php if (($ukol->RC_Hodnotitele_Def == User::getRC()) && $ukol->stavUkolu == 1 && $ukol->Schvaleno1 == 0) { ?>
                <textarea title="" name="podrobnaPoznamkaKHodnoceni" rows="4" cols="50"
                          wrap="hard" ><?= $ukol->podrobnaPoznamkaKHodnoceni?></textarea>
                <?php } else {?>
                <textarea title="" name="podrobnaPoznamkaKHodnoceni" rows="4" cols="50"
                          wrap="hard" disabled="disabled"><?= $ukol->podrobnaPoznamkaKHodnoceni?></textarea>
                <input type="hidden" name="podrobnaPoznamkaKHodnoceni" value="<?= StringUtils::htmlTextConvert($ukol->podrobnaPoznamkaKHodnoceni)?>">
                <?php } ?>
            </td>
        </tr>

        <tr><td></td></tr>

        <tr>
        </tr>

<?php //------------Schvalování ?>
   <?php if (false) //Zobrazí se, pokud bude nastaveno zobrazení úrovní v nastaveni RONPortálu   ?>
        <tr><td></td></tr>
        <tr><td></td></tr>
        <tr><?php if(RonPortalSettings::getIntValue('urovne_schvalovani') != 0){ ?>
            <td class="inputformcaption"><strong><?= \Ron\ronText('Schvalil_1_uroven')?></strong></td>
            <td><strong><?= StringUtils::htmlTextConvert($ukol->schvalil_1_uroven)?></strong></td>
                <?php if(RonPortalSettings::getIntValue('urovne_schvalovani') == 2){ ?>
                    <td class="inputformcaption"><strong><?= \Ron\ronText('Schvalil_2_uroven')?></strong></td>
                    <td><strong><?= StringUtils::htmlTextConvert($ukol->schvalil_2_uroven)?></strong></td>
                <?php }?>
            <?php }?>
        </tr>

        <tr><?php if(RonPortalSettings::getIntValue('urovne_schvalovani') != 0){ ?>

            <td class="inputformcaption"><strong><?= \Ron\ronText('Schvaleno_na_1_urovni')?></strong></td>
            <td><input title="" type="checkbox" name="schvaleni1"<?php if($ukol->Schvaleno1 == 1) echo 'checked="checked"'; ?>
                <?php if (($ukol->RC_schvalovatele1_Def != User::getRC()) || ($ukol->Schvaleno2 == 1) || $ukol->hodnoceno == 0) echo 'disabled="disabled"'; ?>>
                <?php if (($ukol->RC_schvalovatele1_Def != User::getRC()) || ($ukol->Schvaleno2 == 1) || $ukol->hodnoceno == 0) { ?>
                <input type="hidden" name="schvaleni1" value="<?= $ukol->Schvaleno1?>">
                <?php } ?>
            </td>

            <?php if(RonPortalSettings::getIntValue('urovne_schvalovani') == 2){ ?>
                <td class="inputformcaption"><strong><?= \Ron\ronText('Schvaleno_na_2_urovni')?></strong></td>
                <td><input title="" type="checkbox" name="schvaleni2"<?php if($ukol->Schvaleno2 == 1) echo 'checked="checked"'; ?>
                <?php if (($ukol->RC_schvalovatele2_Def != User::getRC()) || ($ukol->Schvaleno1 != 1) || ($ukol->Schvaleno1 != 1)) echo 'disabled="disabled"'; ?>>
                </td>
            <?php }?>
            <?php }?>
        </tr>

        <tr><?php if(RonPortalSettings::getIntValue('urovne_schvalovani') != 0){ ?>
            <td class="inputformcaption"><?= \Ron\ronText('Cas_schvaleni_1_urovne')?></td>
            <td><?= ($ukol->CasSchvaleni1) ? date('j.n.Y', $ukol->CasSchvaleni1) : '' ?></td>
                <?php if(RonPortalSettings::getIntValue('urovne_schvalovani') == 2){ ?>
                    <td class="inputformcaption"><?= \Ron\ronText('Cas_schvaleni_2_urovne')?></td>
                    <td><?= ($ukol->CasSchvaleni2) ? date('j.n.Y', $ukol->CasSchvaleni2) : '' ?></td>
                <?php }?>
            <?php }?>
        </tr>


        <tr><td></td></tr>
        <tr><td></td></tr>
        <tr><td></td></tr>

        <?php if(!empty($ukol->poleDefDovUkolu[0][0])) {  ?>
            <?php //<!-------- Sekce Definované dovednosti úkolu --------> ?>
                <tr class="inputtablesection">
                    <td  colspan="4"><strong><?= \Ron\ronText('Definovane_dovednosti_ukolu') ?></strong></td>
                </tr>

                <tr>
                    <td class="inputformcaption"><strong><?= \Ron\ronText('Dovednosti_popis') ?></strong></td>
                    <td><strong><?= \Ron\ronText('Dovednosti_popis_urovne') ?></strong></td>
                    <td></td><td><strong><?= \Ron\ronText('ziska')?></strong></td>
                </tr>

                <?= $ukol->vypisDefinovanychDovednosti ?>


                <tr><td></td></tr>
                <tr><td></td></tr>

            <?php //<!-------- Sekce Úkolem dosažené dovednosti úkolu --------> ?>
                <tr class="inputtablesection">
                    <td  colspan="4"><strong><?= \Ron\ronText('Ukolem_dosazene_dovednosti') ?></strong></td>
                </tr>

                <tr>
                    <td class="inputformcaption"><strong><?= \Ron\ronText('Dovednosti_popis') ?></strong></td>
                    <td><strong><?= \Ron\ronText('Dovednosti_popis_urovne') ?></strong></td>
                </tr>

                <?= $ukol->vypisUkolemDosazenychDovednosti ?>
        <?php }?>

        <tr><td></td></tr>
        <tr><td></td></tr>
        <tr><td></td></tr>
        <tr><td></td></tr>


        <tr class="inputtablesection">
            <td  colspan="4">&nbsp;</strong></td>
        </tr>

        <tr><td></td></tr>
        <tr><td></td></tr>
        <tr><td></td></tr>
        <tr><td></td></tr>

         <!-- OK   -->
        <tr>
            <td></td>
            <td><input type="button" class="submitbutton" onclick="window.location.href='?menuid=ukoly';" value="<?= \Ron\ronText('Zpet')?>"></td>
            <?php if(User::getRC() == $ukol->RC_Osoby || User::getRC() == $ukol->RC_Hodnotitele_Def || User::getRC() == $ukol->RC_schvalovatele1_Def || User::getRC() == $ukol->RC_schvalovatele2_Def) { ?>
                <?php if (RonPortalSettings::getIntValue('typ_tlacitka')) { ?>
                    <td colspan="2"><input type="submit" class="submitbutton" value="<?= \Ron\ronText('Ulozeni')?>"></td>
                <?php } else { ?>
                    <td colspan="2"><input type="submit" class="submitbutton" value="OK"></td>
                <?php }?>
            <?php }?>
        </tr>

    </table>
</form>

<br/><br/>
<div class='normaltext'>
<!--    <a href=?menuid=ukoly>--><?//= \Ron\ronText('Zpet_na_seznam') ?><!--</a>-->
</div>
